CREATE OR REPLACE PROCEDURE RECALC_FATCORR_PROD_REC
( P_PRATOINI     IN VARCHAR2,
  P_PRATOFIN     IN VARCHAR2,
  P_CDFILAUXPRAT IN VARCHAR2, -- FILIAL PARA CARREGAR PRATO LOCAL
  P_CDFILIAIS    IN VARCHAR2, -- X: NO CONSIDERAR RECEITA LOCAL; T: CONSIDERA; CDFILIAL_
  P_SERVICOS     IN VARCHAR2, -- X: NO CONSIDERAR RECEITA POR SERVIO; T: CONSIDERA; CDFILIAL||CDSERVFILI_
  P_NRORG        IN VARCHAR2
) IS
  V_QTBLOQUEADA   VARCHAR2(1);
  V_NOVO_QTBRUTA  FLOAT;
  V_QTD           FLOAT;
  V_NOVO_QTLIQ    FLOAT;
  V_NOVA_QTREQ    FLOAT;
  V_NOVO_CALCNUTR FLOAT;
  V_FATOR         FLOAT;
  
BEGIN
  --VERIFICAR QUAL QUANTIDADE EST ATIVA
  BEGIN
    SELECT IDQTLIQUBRUT 
      INTO V_QTBLOQUEADA
      FROM PARAMPLANEJA 
     WHERE CDFILIAL = P_CDFILAUXPRAT 
       AND NRORG = P_NRORG;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN BEGIN
      V_QTBLOQUEADA := 'L';
    END;
  END;     
  
  DBMS_OUTPUT.PUT_LINE('QUANTIDADE BLOQUEADA ' || V_QTBLOQUEADA);
  
  -- BUSCA AS RECEITAS DOS PRATOS SELECIONADOS
  FOR C_REC IN
    (SELECT RECEITA.CDFILIAL, RECEITA.CDSERVFILI, RECEITA.CDPRATO, RECEITA.CDFILAUXPRAT, RECEITA.CDPRODUTO, 
            DECODE(RECEITA.SGUNIDADE, NULL, PRODUTO.SGUNIDADE, RECEITA.SGUNIDADE) AS SGUNIDADE, 
            ROUND(PRODUTO.VRPEFATOCORR, 3) FATOCORR, NVL(CONVPRODUTO.VRFATOCONVES, '1') AS VRFATOCONVES, 
            RECEITA.QTLIQ, RECEITA.QTBRUTA, RECEITA.QTREQ, RECEITA.QTUNI, RECEITA.GANHOCOC, RECEITA.PERDALIMP, 
            RECEITA.APROVNUTR, RECEITA.CALCNUTR, NVL(RECEITA.QTFIXEM, 'N') AS QTFIXEM, RECEITA.NRORG
       FROM (SELECT '' AS CDFILIAL, '' AS CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODPRAT AS QTLIQ, 
                    VRPEFATCOCPR AS GANHOCOC, VRPEFATCORPR AS PERDALIMP, QTUNIDESTPR AS QTUNI, QTBRUTAPR AS QTREQ, 
                    VRPEFATNUTPR AS APROVNUTR, QTCALCNUTRPR AS CALCNUTR, QTBRUTAPRUNR AS QTBRUTA, IDQTDEFIXPR AS QTFIXEM, NRORG
               FROM RECEPADR
              WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = P_CDFILAUXPRAT)
                AND (CDPRATO BETWEEN P_PRATOINI AND P_PRATOFIN)
                AND (NRORG = P_NRORG)
              UNION ALL
             SELECT CDFILIAL, '' AS CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODRECLOC AS QTLIQ, 
                    VRPEFATCOCLO AS GANHOCOC, VRPEFATCORLO AS PERDALIMP, QTUNIDESTLO AS QTUNI, QTBRUTALO AS QTREQ, 
                    VRPEFATNUTLO AS APROVNUTR, QTCALCNUTRLO AS CALCNUTR, QTBRUTALOUNR AS QTBRUTA, IDQTDEFIXLO AS QTFIXEM, NRORG
               FROM RECEFILI
              WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = P_CDFILAUXPRAT)
                AND (CDPRATO BETWEEN P_PRATOINI AND P_PRATOFIN)
                AND (NRORG = P_NRORG)
                AND (INSTR(P_CDFILIAIS, CDFILIAL) > 0 OR P_CDFILIAIS = 'T')
              UNION ALL
             SELECT CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODRECSER AS QTLIQ, 
                    VRPEFATCOCSE AS GANHOCOC, VRPEFATCORSE AS PERDALIMP, QTUNIDESTSE AS QTUNI, QTBRUTASE AS QTREQ, 
                    VRPEFATNUTSE AS APROVNUTR, QTCALCNUTRSE AS CALCNUTR, QTBRUTASEUNR AS QTBRUTA, IDQTDEFIXSE AS QTFIXEM, NRORG
               FROM RECESERV
              WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = P_CDFILAUXPRAT)
                AND (CDPRATO BETWEEN P_PRATOINI AND P_PRATOFIN)
                AND (NRORG = P_NRORG)
                AND (INSTR(P_CDFILIAIS, CDFILIAL) > 0 OR P_CDFILIAIS = 'T')
                AND (INSTR(P_SERVICOS, CDFILIAL||CDSERVFILI) > 0 OR P_SERVICOS = 'T')
            ) RECEITA
      INNER JOIN PRODUTO ON PRODUTO.CDPRODUTO = RECEITA.CDPRODUTO AND PRODUTO.NRORG = RECEITA.NRORG AND VRPEFATOCORR > 0
       LEFT JOIN CONVPRODUTO ON CONVPRODUTO.NRORG = PRODUTO.NRORG AND CONVPRODUTO.CDPRODUTO = RECEITA.CDPRODUTO AND CONVPRODUTO.SGUNIDADE = RECEITA.SGUNIDADE
      ORDER BY RECEITA.CDPRATO, RECEITA.CDFILAUXPRAT, RECEITA.CDFILIAL, RECEITA.CDSERVFILI, RECEITA.CDPRODUTO
    )LOOP
      -- CALCULA A QUANTIDADE DE ACORDO COM O PARAMETRO
      IF (V_QTBLOQUEADA = 'L') THEN
        V_NOVO_QTBRUTA := C_REC.QTBRUTA;
        
        V_QTD := C_REC.QTBRUTA - ((C_REC.QTBRUTA * C_REC.FATOCORR) / 100);
        V_NOVO_QTLIQ := ROUND(V_QTD + ((V_QTD * C_REC.GANHOCOC) / 100), 5);
        
        V_NOVA_QTREQ := V_NOVO_QTBRUTA * C_REC.VRFATOCONVES;
        
        V_NOVO_CALCNUTR := (V_NOVO_QTLIQ * C_REC.VRFATOCONVES) * C_REC.APROVNUTR / 100;
      ELSE 
        V_NOVO_QTLIQ := C_REC.QTLIQ;
        
        V_QTD := (C_REC.QTLIQ / (C_REC.GANHOCOC + 100)) * 100;
        V_NOVO_QTBRUTA := ROUND((V_QTD / (100 - C_REC.FATOCORR)) * 100, 5);
        
        IF (C_REC.FATOCORR > 0) THEN
          V_FATOR := C_REC.VRFATOCONVES;
          V_NOVO_CALCNUTR := (V_NOVO_QTLIQ * C_REC.APROVNUTR / 100) * V_FATOR;
        ELSE 
          V_FATOR := C_REC.QTREQ / C_REC.QTBRUTA;        
          V_NOVO_CALCNUTR := (V_NOVO_QTLIQ * C_REC.APROVNUTR / 100);
        END IF;
        
        V_NOVA_QTREQ := V_NOVO_QTBRUTA * V_FATOR;
      END IF;
      
      IF (C_REC.CDSERVFILI IS NOT NULL) THEN
        UPDATE RECESERV
           SET VRPEFATCORSE = C_REC.FATOCORR,
               QTPRODRECSER = V_NOVO_QTLIQ,
               QTBRUTASEUNR = V_NOVO_QTBRUTA,
               QTCALCNUTRSE = V_NOVO_CALCNUTR,
               QTBRUTASE = V_NOVA_QTREQ,
               QTUNIDESTSE = V_NOVA_QTREQ
         WHERE CDPRODUTO = C_REC.CDPRODUTO
           AND CDFILIAL = C_REC.CDFILIAL
           AND CDSERVFILI = C_REC.CDSERVFILI
           AND CDPRATO = C_REC.CDPRATO
           AND CDFILAUXPRAT = C_REC.CDFILAUXPRAT
           AND NRORG = C_REC.NRORG;
           
        DBMS_OUTPUT.PUT_LINE('ATUALIZA RECEITA POR SERVICO (PRATO: ' || C_REC.CDPRATO || ' - FILIAL: ' || C_REC.CDFILIAL || ' - SERVICO: ' || C_REC.CDSERVFILI || ' - PRODUTO: ' || C_REC.CDPRODUTO ||')');
      ELSIF (C_REC.CDFILIAL IS NOT NULL) THEN 
        UPDATE RECEFILI
           SET VRPEFATCORLO = C_REC.FATOCORR,
               QTPRODRECLOC = V_NOVO_QTLIQ,
               QTBRUTALOUNR = V_NOVO_QTBRUTA,
               QTCALCNUTRLO = V_NOVO_CALCNUTR,
               QTBRUTALO = V_NOVA_QTREQ,
               QTUNIDESTLO = V_NOVA_QTREQ
         WHERE CDPRODUTO = C_REC.CDPRODUTO
           AND CDFILIAL = C_REC.CDFILIAL
           AND CDPRATO = C_REC.CDPRATO
           AND CDFILAUXPRAT = C_REC.CDFILAUXPRAT
           AND NRORG = C_REC.NRORG;
           
        DBMS_OUTPUT.PUT_LINE('ATUALIZA RECEITA LOCAL (PRATO: ' || C_REC.CDPRATO || ' - FILIAL: ' || C_REC.CDFILIAL || ' - PRODUTO: ' || C_REC.CDPRODUTO || ')');
      ELSE 
        UPDATE RECEPADR
           SET VRPEFATCORPR = C_REC.FATOCORR,
               QTPRODPRAT = V_NOVO_QTLIQ,
               QTBRUTAPRUNR = V_NOVO_QTBRUTA,
               QTCALCNUTRPR = V_NOVO_CALCNUTR,
               QTBRUTAPR = V_NOVA_QTREQ,
               QTUNIDESTPR = V_NOVA_QTREQ
         WHERE CDPRODUTO = C_REC.CDPRODUTO
           AND CDPRATO = C_REC.CDPRATO
           AND CDFILAUXPRAT = C_REC.CDFILAUXPRAT
           AND NRORG = C_REC.NRORG;
           
        DBMS_OUTPUT.PUT_LINE('ATUALIZA RECEITA PADRO (PRATO: ' || C_REC.CDPRATO || ' - PRODUTO: ' || C_REC.CDPRODUTO || ')');
      END IF;
      
      V_NOVO_QTLIQ := 0;
      V_QTD := 0;
      V_NOVO_QTBRUTA := 0;
      V_FATOR := 0;
      V_NOVA_QTREQ := 0;
      V_NOVO_CALCNUTR := 0;
    END LOOP; 
    
    COMMIT;
    DBMS_OUTPUT.PUT_LINE('----------- FIM -----------');    
END;
/