var Ger01100_Transportadora_Controller = function (ScreenService, General, templateManager, restEngine, localStorageEngine, Endereco, Ger01100_Transportadora_Service) {

	this.newTransportadora = function(widget){
		General.newRow(widget);
		this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro(widget.name);
	};
	
	this.setFieldsAddress = function (widgetName, fieldName) {
		//field = General.getFieldValue(fieldName,widgetName);
		//field = field.toString();
		//return field;
		return General.getFieldValue(fieldName, widgetName);
		//return templateManager.container.getWidget(widgetName).currentRow[fieldName] || '';
	};

	this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRTRAN');
		if (widget.currentRow.NMPAIS) {
			estado.readOnly = false;
			municipio.readOnly = true;
			bairro.readOnly = true;
			if (widget.currentRow.NMESTADO) {
				municipio.readOnly = false;
				bairro.readOnly = true;
				if (widget.currentRow.NMMUNICIPIO) {
					bairro.readOnly = false;
				} else {
					bairro.readOnly = true;
				}
			} else {
				municipio.readOnly = true;
				bairro.readOnly = true;
			}
		} else {
			estado.readOnly = true;
			municipio.readOnly = true;
			bairro.readOnly = true;
		}
	};

	this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRTRAN');
		switch (nomeCampoAtual) {
		case 'Pais':
			estado.value('');
			municipio.value('');
			bairro.value('');
			break;
		case 'Estado':
			municipio.value('');
			bairro.value('');
			break;
		case 'Municipio':
			bairro.value('');
			break;
		default:
			break;
		}
	};

	this.recarregarCampo = function (nomeWidget, nomeCampo) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.getField(nomeCampo).reload();
	};

	this.recarregarWidget = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.reload();
	};

	this.validarCepEnd = function (args) {

		var widget = args.owner.owner.widget;
		var CEP = widget.currentRow.NRCEPTRAN;
		if (CEP) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				if (endereco) {
					widget.currentRow.NRCEPTRAN = CEP;
					widget.currentRow.ENDERECOPARCEIRO = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
					widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
					widget.currentRow.NMBAIRTRAN = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
					widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
					widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
					widget.currentRow.DSENDETRAN = ((endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '') + " " + widget.currentRow.ENDERECOPARCEIRO;
					//widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';
					this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridTransportadora');
				}
				if (response.dataset.ERRO){ 
					ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
				}
			}.bind(this), function(error){
				ScreenService.showMessage("Ouve um erro ao tentar localizar este CEP. Insira um CEP Valido.", "warning");	
			});
		}
	};

	/* **************************************************
	 * Procedimento que checa o input de inscrição,
	 * validando-o e colocando o tipo de inscrição na
	 * currentRow de acordo.
	 *
	 * Nota: Esse método pressupõe que o input de
	 * inscrição possui as propriedades valueField e
	 * descriptionField, apesar de ser do template
	 * text-edit. Ele também supõe que o valueField
	 * e o descriptionField estarão na currentRow.
	 *
	 * @param Field field
	 */
	this.checkNumeroDeInscricao = function (field) {
		var validatedInscricao = Ger01100_Transportadora_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
		var widget = field.widget;

		if (validatedInscricao.valid) {
			//if input is valid, builds unformatted data to save
			switch (validatedInscricao.tipo.cod) {
			case 'O': //Código genérico
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
				break;
			case 'I': //Inscrição genérica
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
				break;
			default: //CPF && CNPJ
				validatedInscricao.rawValue = validatedInscricao.parameter;
			}

			//sets data in the currentRow
			widget.currentRow.IDTPIJURTRAN = validatedInscricao.tipo.cod;
			widget.currentRow[field.valueField] = validatedInscricao.rawValue;
			widget.currentRow[field.descriptionField] = validatedInscricao.value;
		} else {
			//if message exists, throws warning popup
			if (validatedInscricao.error.msg)
				ScreenService.showMessage(validatedInscricao.error.msg, "warning");

			//cleans data
			widget.currentRow[field.valueField] = null;
			widget.currentRow[field.descriptionField] = null;
		}
	};

	this.verificaVeiculo = function (args) {
		var widget = templateManager.container.getWidget('gridTransportadora');
		var veiculo = widget.getField('DSTIPOVEIC');
		var inscricao = widget.getField('NRINSJURTRAN').value();
		veiculo.dataSourceFilter[0].value = inscricao.replace(/[^0-9]/g, '');
		widget.getField('DSTIPOVEIC').reload().then(function (Success) {
			if (veiculo.dataSource.data.length === 0) {
				ScreenService.showMessage('Veículo não cadastrado para a transportadora.');
				//ScreenService.closePopup();
			}
		}, function (callback) {});
	};

	this.salvarTransportadora = function (args) {
		var widget = templateManager.container.getWidget('gridTransportadora');
		if (widget.isValid()) {

			widget.currentRow.CDTIPTRANS = widget.currentRow.CDTIPTRANS ? widget.currentRow.CDTIPTRANS : null;
			widget.currentRow.CDVEICPADRAO = widget.currentRow.CDVEICPADRAO ? widget.currentRow.CDVEICPADRAO : null;
			if (!widget.currentRow.CDLOGRADOURO) {
				widget.currentRow.CDLOGRADOURO = null;
			}
			Ger01100_Transportadora_Service.removerMacaras(widget.currentRow);
			Ger01100_Transportadora_Service.salvarTransportadora(widget.currentRow).then(function (Success) {
				widget.dataSource.name = 'ped_expedicao#/crud/transport_completa';
				if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
				}
			}, function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
				widget.dataSource.name = 'ped_expedicao#/crud/transport_completa';

			});
		}
	};
	
	this.verficaParceiro = function (args) {
		var widget = args.owner.owner.widget;
		if (widget.currentRow.NRINSJURTRAN) {
			widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURTRAN.replace(/[^0-9]/g, '');
			Ger01100_Transportadora_Service.buscarParceiro(widget.currentRow).then(function (response) {
					var parceiro = response.dataset.parcnegocio;
					if (parceiro.length !== 0) {
						ScreenService.confirmMessage('Já existe um parceiro para este número de inscrição. Deseja carregar dados do parceiro?', 'question', function (success) {
							widget.currentRow.NMRAZSOCTRAN = parceiro[0].NMPRINCIPALPARC;
							widget.currentRow.NMFANTTRAN = parceiro[0].NMSECUNDARIPARC;
							widget.currentRow.NRPARCNEGOCIO = parceiro[0].NRPARCNEGOCIO;
						});
					}
				},
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
	};

	this.addMask = function (widget) {
		var data = widget.dataSource.data;
		data.forEach(function (element, index, data) {
			if (element.NRINSJURTRAN.length == 14)
				element.NRINSJURTRAN = element.NRINSJURTRAN.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
			if (element.NRINSJURTRAN.length == 11)
				element.NRINSJURTRAN = element.NRINSJURTRAN.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
		});
		widget.redraw();
	};

};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01100_Transportadora_Controller', Ger01100_Transportadora_Controller);
});