// FILE: ./assets/js/utilities/PedGeral_Utility.js
var PedGeral_Utility = function(General, templateManager, ZhFilterPreferences, ZHPromise) {
    
    this.openFilter = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
          //  this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.openFilterFilial = function(widget) {
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        });
    };
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('ped#/crud/filial', 'FilterData', filter);
    };

    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                if(filterBforeApply.lastActiveWidget.name == 'zhFilterPreferencesSelectConditions'){
                    filterWidget = filterBforeApply.lastActiveWidget;
                    return filterWidget.currentRow[fieldName];
                }
                else{
                    var f = container.getWidget(widgetName);
                    if(f) {
                         filterWidget = container.getWidget(widgetName).appliedFilter;
                    }
                }
                    
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];
                    
                return valueField || null;
            }
            
               else return null;
        }
        else return null;
    };
    
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('PedGeral_Utility', PedGeral_Utility);
});

// FILE: ./assets/js/repositories/Ger41200_GrupoClientes_Repository.js
var Ger41200_GrupoClientes_Repository = function(restEngine) {
    this.newAlvaraNR = function(){
        return restEngine.post('ped#/novoAlvara', {
           "requestType": "FilterData",
           "filter": []
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger41200_GrupoClientes_Repository', Ger41200_GrupoClientes_Repository);
});

// FILE: ./assets/js/repositories/Ger96600_AlvarasLicenciamento_Repository.js
var Ger96600_AlvarasLicenciamento_Repository = function(restEngine) {
    this.newAlvaraNR = function(){
        return restEngine.post('ped#/novoAlvara', {
           "requestType": "FilterData",
           "filter": []
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger96600_AlvarasLicenciamento_Repository', Ger96600_AlvarasLicenciamento_Repository);
});

// FILE: ./assets/js/repositories/Ped00000_dashboardPedidos_Repository.js
var Ped00000_dashboardPedidos_Repository = function(restEngine) {
    
    this.buscaVendas = function(filter) {
        return restEngine.post('ped#/crud/pedido_cliente', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped00000_dashboardPedidos_Repository', Ped00000_dashboardPedidos_Repository);
});

// FILE: ./assets/js/repositories/Ped07000_agendaVendedorRegiao_Repository.js
var Ped07000_agendaVendedorRegiao_Repository = function(restEngine) {
    
    this.buscaCalendarColor = function(row){
        return restEngine.post('ped#/agendaVendedorRegiao/buscaCalendarColor', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveCliente = function(row){
        return restEngine.post('ped#/agendaVendedorRegiao/saveCliente', {
            "requestType": "Row",
            "row": row
        });
    };

	this.searchRegiao = function() {
        return restEngine.post('ped#/crud/regiaoped', {
            "requestType": "FilterData",
            "filter": ""
        });
    };
    
    this.searchPrevData = function() {
        return restEngine.post('ped#/crud/agendavendedor_regiaoped_cliente', {
            "requestType": "FilterData",
            "filter": ""
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped07000_agendaVendedorRegiao_Repository', Ped07000_agendaVendedorRegiao_Repository);
});

// FILE: ./assets/js/repositories/Ped07700_ParametrizacaoClientesPedidos_Repository.js
var Ped07700_ParametrizacaoClientesPedidos_Repository = function(restEngine) {
    
    this.exportarPrecosCliente = function(row){
        return restEngine.post('ped#/parametrizacaoClientes/exportarPrecos', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.searchTabela = function(filter) {
        return restEngine.post('ped#/precobasecli_precobase', {
            "requestType": "FilterData",
            "filter": filter
        });
	};
	
	this.salvaDadosProduto = function(row){
	    return restEngine.post('ped#/parametrizacaoClientes/salvaDadosProduto', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.deletaDadosProduto = function(row){
	    return restEngine.post('ped#/parametrizacaoClientes/deletaDadosProduto', {
            "requestType": "Row",
            "row": row
        });
	};
	this.cadastramentoAutomaticoCliente = function(dataset){
	    return restEngine.post('ped#/cadastramento_automatico/save', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped07700_ParametrizacaoClientesPedidos_Repository', Ped07700_ParametrizacaoClientesPedidos_Repository);
});

// FILE: ./assets/js/repositories/ger00700_Cliente_Repositories.js
var Ger00700_Cliente_Repositories = function(localStorageEngine, restEngine) {
    self = this;

    self.removePrazoPagamento = function (data) {
        return restEngine.post('ped#/crud/prazopgtclie/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.inserePrazoPagamento = function (data) {
        return restEngine.post('ped#/crud/prazopgtclie/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereParceiro = function(data){
        return restEngine.post('ped#/crud/parcnegocio/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereEnderecoParceiro = function(data){
        return restEngine.post('ped#/crud/enderecoparc/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.getParcNegocio = function (inscricao) {
        return restEngine.post('ped#/crud/parcnegocio',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRINSCRICAOPARC",
                        "operator": "=",
                        "value": inscricao
                    }
                ]
            }
        );
    };

    self.getEnderecoParcNegocio = function (parceiro, tipoEndereco) {
        return restEngine.post('ped#/crud/enderecoparc',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceiro
                    },
                    {
                        "name": "CDTIPOENDERECO",
                        "operator": "=",
                        "value": tipoEndereco
                    }
                ]
            }
        );
    };

    self.getParceria = function(parceria, tipoparceiro){
        return restEngine.post('ped#/crud/parceria',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceria
                    },
                    {
                        "name": "CDTIPOPARCEIRO",
                        "operator": "=",
                        "value": tipoparceiro
                    }
                ]
            }
        );
    };

    self.insereParceria = function(parceria){
        return restEngine.post('ped#/crud/parceria/save',
            {
                "requestType": "DataSet",
                "dataset": parceria
            }
        );
    };

    self.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

    //getBancoPref
    self.getBancoPref = function (cliente, organizacao) {
        return restEngine.post('ped#/crud/bancopref',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": cliente
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": organizacao
                    },
                    {
                        "name": "IDPRIORBPREF",
                        "operator": "=",
                        "value": "S"
                    }
                ]
            }
        );
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger00700_Cliente_Repositories', Ger00700_Cliente_Repositories);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped00100_lancamentoPedido_Repository.js
function Ped00100_lancamentoPedido_Repository (restEngine, localStorageEngine) {

    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  DESKTOP
    
    this.montaConfigTransmissao = function(row) {
        var filter = [
            {
                "name": "ROW",
                "operator": "=",
                "value": row
            }
        ];
        return localStorageEngine.download("df#/config_transmissao", filter);
    };
    
    this.getNewCode = function(filial) {
        return restEngine.post('ped#/novoCodigo', {
            "requestType": "Row",
            "row": filial
        });
    };

    this.updateOrder = function(row) {
        return restEngine.post('ped#/pedido_completa/updateOrder', {
            "requestType": "DataSet",
            "dataset": row
        });
    };
    this.calcImpostoItem = function(dataset) {
        return restEngine.post('ped#/calcula_imposto', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };

    this.findModpgtoPrazo = function(filter) {
        return restEngine.post('ped#/crud/modpgto_prazomodpgto', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.retornaParamPedido = function() {
        return restEngine.post('ped#/crud/parampedido', {
            "requestType": "FilterData"
        });
    };

    this.retornaPrecobase = function() {
        return restEngine.post('ped#/crud/precobase', {
            "requestType": "FilterData"
        });
    };

    this.retornaPrecobasecli = function() {
        return restEngine.post('ped#/precobasecli_precobase', {
            "requestType": "FilterData"
        });
    };

    this.retornaPendenciaFin = function() {
        return restEngine.post('ped#/crud/contareceber_boletreceber_notafiscal', {
            "requestType": "FilterData"
        });
    };
    
    this.checkLogin = function(filter) {
        return restEngine.post('ped#/aprovacao/checkLogin', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };

    this.savePedido = function(data) {
        return restEngine.post('ped#/pedido_completa/save', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.deletePrazo = function(data) {
        return restEngine.post('ped#/pedido_completa/delete', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.salvarEncargo = function(data) {
        return restEngine.post("ped_pedidos#/encargo_lancamento/save", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  MOBILE
    this.enviarPedido = function(data) {
        return restEngine.post('ped#/enviarPedido', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.findClienteVendedor = function(filter) {
        return restEngine.post('ped#/crud/cliente_completa', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.findProduto = function(filter) {
        return restEngine.post('ped#/crud/produto_itemprebase_promoprbase', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.filtraVendedor = function(filter) {
        return restEngine.post('ped#/crud/vendedor', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.findQTprod = function() {
        return restEngine.post('ped#/crud/reservaped_sum_qttotalestoq', {
            "requestType": "FilterData"
        });
    };
    this.findModpgtoPrazoMod = function() {
        return restEngine.post('ped#/crud/modpgto_prazomodpgto', {
            "requestType": "FilterData"
        });
    };
    this.findModpgto = function() {
        return restEngine.post('ped#/crud/modpgto', {
            "requestType": "FilterData"
        });
    };
    this.findParameters = function(filter) {
        return restEngine.post('ped#/crud/parampedido', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.findParamPedido = function(filter) {
        return restEngine.post('ped#/crud/ped_parampedido', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.findTpdesc = function() {
        return restEngine.post('ped#/crud/tipodesc', {
            "requestType": "FilterData"
        });
    };
    this.findTpOperac = function(filter) {
        return restEngine.post('ped#/crud/tipooperac', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.retornaDadosUnidade = function(filter) {
        return restEngine.post('ped#/crud/filial_empresa_endefili', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.filtraFilioper = function(filter) {
        return restEngine.post('ped#/crud/filioper', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.enviarEmail = function(data) {
        return restEngine.post('ped#/enviarEmail', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.deletePedido = function(row) {
        return restEngine.post('ped#/deletePedido', {
            "requestType": "DataSet",
            "dataset": row
        });
    };
    
    this.validaQtdeDispEstoque = function(data) {
        return restEngine.post('ped#/validaQtdeDispEstoque', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.salvarDuplicPed = function(data) {
        return restEngine.post('ped#/salvarDuplicPed', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped00100_lancamentoPedido_Repository', Ped00100_lancamentoPedido_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped00200_confirmacaoPedido_Repository.js
function Ped00200_confirmacaoPedido_Repository (restEngine) {

    this.saveJust = function(row) {
        return restEngine.post('ped_pedidos#/confirmacaoPedido/saveJust', {
            "requestType": "Row",
            "row": row
        });
    };
    
       
    this.saveItem = function(data) {
        return restEngine.post('ped#/itempedido_produto_fatorpreco/save', {
            "requestType": "DataSet",
            "dataset": data
        });
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped00200_confirmacaoPedido_Repository', Ped00200_confirmacaoPedido_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped00300_aprovacao_Repository.js
function Ped00300_aprovacao_Repository (localStorageEngine, restEngine) {

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.checkLogin = function(filter) {
        return restEngine.post('ped#/aprovacao/checkLogin', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };

    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped00300_aprovacao_Repository', Ped00300_aprovacao_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped00301_posicaoFinanceiraCliente_Repository.js
function Ped00301_posicaoFinanceiraCliente_Repository (localStorageEngine, restEngine) {

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.getPosicaoFinanceira = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnPosicao', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getContasAbertas = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnContasAbertas', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getTipoRecAbertas = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnTipoRecAbertas', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getContasFechadas = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnContasFechadas', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getTipoRecFechadas = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnTipoRecFechadas', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getEndereco = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnEndereco', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getHistorico = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnHistorico', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.getHistContas = function(filter) {
        return restEngine.post('ped#/posicaoFinanceira/returnHistContas', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };
    
    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped00301_posicaoFinanceiraCliente_Repository', Ped00301_posicaoFinanceiraCliente_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped01100_dadosPedido_Repository.js
function Ped01100_dadosPedido_Repository (restEngine) {

   this.geraRelatorio = function(row){
        return restEngine.post('ped_pedidos#/ped01100_relatorio',
            {
                "requestType":"Row",
                "row": row
            }
        );
   };
   
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped01100_dadosPedido_Repository', Ped01100_dadosPedido_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped02300PrecoBaseRepositories.js
var Ped02300PrecoBaseRepositories = function(restEngine) {

    this.newCode = function(row) {
        return restEngine.post('ped_pedidos#/newCode', {
            "requestType": "Row",
            "row": row
        });    
    };
    
    this.setPromoPrBase = function(row) {
        return restEngine.post('ped#/crud/promoprbase/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.setItemPrecoBase = function(newItemPrecoBase) {
        return restEngine.post('ped#/crud/itemprebase/save', {
            "requestType": "Row",
            "row": newItemPrecoBase
        });
    };

    this.removeItemPrecoBase = function(row) {
        return restEngine.post('ped#/crud/itemprebase/remove', {
            "requestType": "Row",
            "row": row
        });
    };

    this.removePrecoBase = function(row) {
        return restEngine.post('ped#/crud/precobase/remove', {
            "requestType": "Row",
            "row": row
        });
    };

    this.exportaItem = function(row){
        return restEngine.post('ped_pedidos#/exportarItem', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveFatorPreco = function(row){
        return restEngine.post('ped_pedidos#/saveFatorPreco', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02300PrecoBaseRepositories', Ped02300PrecoBaseRepositories);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped02600_parametrosPedidos_Repository.js
var  Ped02600_parametrosPedidos_Repository = function(restEngine){
    
    this.saveParamPed = function(row) {
        return restEngine.post('ped_pedidos#/saveParaPed', {
            "requestType": "Row",
            "row": row
        });
    }; 
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02600_parametrosPedidos_Repository', Ped02600_parametrosPedidos_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped03500_tabelaMetaComissao_Repository.js
function Ped03500_tabelaMetaComissao_Repository(restEngine) {

    this.verificaValorInicial = function(VRINICVENDA,CDFILIAL, CDPRODUTO, CDCOMISSAO) {
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": CDFILIAL
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": CDPRODUTO
            },
            {
                "name": "CDCOMISSAO",
                "operator": "=",
                "value": CDCOMISSAO
            },
            {
                "name": "VRINICVENDA",
                "operator": "<=",
                "value": VRINICVENDA
            },
            {
                "name": "VRFINAVENDA",
                "operator": ">=",
                "value": VRINICVENDA
            }

        ];
        return restEngine.post('ped#/crud/itcomissao', {
            "requestType": "FilterData",
            "filter": filtro
        });
    };

     this.verificaValorFinal = function(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO) {
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": CDFILIAL
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": CDPRODUTO
            },
            {
                "name": "CDCOMISSAO",
                "operator": "=",
                "value": CDCOMISSAO
            },
            {
                "name": "VRFINAVENDA",
                "operator": "BETWEEN",
                "value": VALORES
            }
        ];
        return restEngine.post('ped#/crud/itcomissao', {
            "requestType": "FilterData",
            "filter": filtro
        });
    };

    this.verificaValores = function(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO) {
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": CDFILIAL
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": CDPRODUTO
            },
            {
                "name": "CDCOMISSAO",
                "operator": "=",
                "value": CDCOMISSAO
            },
            {
                "name": "VRINICVENDA",
                "operator": "BETWEEN",
                "value": VALORES
            }
        ];
        return restEngine.post('ped#/crud/itcomissao', {
            "requestType": "FilterData",
            "filter": filtro
        });
    };
    this.getNrSeq = function(row){
        return restEngine.post('ped_pedidos#/MetaVendaGetNrSeq', {
            "requestType": "Row",
            "row": row
        });
    };
    this.cadastroAutomaticoItem = function(row) {
        return restEngine.post('ped_pedidos#/itcomissao_cadastroautomatico', {
            "requestType": "Row",
            "row": row
        });
    };
    this.cadastroAutomaticoProduto = function(row){
         return restEngine.post('ped_pedidos#/prodmetavend_cadastroautomatico', {
            "requestType": "Row",
            "row": row
        });
    };

    this.delete = function(dataSource, row) {
        if(dataSource === 'ped_pedidos#/metavenda') {
            return restEngine.post('ped_pedidos#/metavenda', {
                "requestType": "Row",
                "row": row
            });
        }
        else if(dataSource === 'ped_pedidos#/comissao') {
             return restEngine.post('ped_pedidos#/comissao', {
                "requestType": "Row",
                "row": row
            });
        }
    };


}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped03500_tabelaMetaComissao_Repository', Ped03500_tabelaMetaComissao_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped04400_previsao_de_vendas_Repository.js
var Ped04400_previsao_de_vendas_Repository = function(restEngine, localStorageEngine) {

    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped04400_previsao_de_vendas_Repository', Ped04400_previsao_de_vendas_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped04900_recalculo_comissao_vendedor_Repository.js
function Ped04900_recalculo_comissao_vendedor_Repository(restEngine, localStorageEngine) {
    
    this.recalculoComissaoVendedor = function(row){
        return restEngine.post('ped#/recalculoComissaoVendedor', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped04900_recalculo_comissao_vendedor_Repository', Ped04900_recalculo_comissao_vendedor_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped05000_metaVendaComissao_Repository.js
function Ped05000_metaVendaComissao_Repository(restEngine) {

    this.getNrSeq = function(row){
        return restEngine.post('ped_pedidos#/MetaVendaGetNrSeq', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.cadastroAutomaticoVendedor = function(row){
        return restEngine.post('ped_pedidos#/metavendedor_cadastroautomatico', {
            "requestType": "Row",
            "row": row
        });
    }; 

}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05000_metaVendaComissao_Repository', Ped05000_metaVendaComissao_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped05001_equipeVendedorMeta_Repository.js
function Ped05001_equipeVendedorMeta_Repository(restEngine) {
    this.getNrSeq = function(row){
        return restEngine.post('ped_pedidos#/equipeVendGetNrSeq', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.searchEquipe = function() {
        return restEngine.post('ped#/crud/equipe', {
            "requestType": "FilterData",
            "filter": ""
        });
    };
    
    this.searchMembros = function() {
        return restEngine.post('ped#/crud/equipevendedor', {
            "requestType": "FilterData",
            "filter": ""
        });
    };
    
    this.exportarMembros = function(row){
        return restEngine.post('ped_pedidos#/equipeExportMembros', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.importarMembros = function(row){
        return restEngine.post('ped_pedidos#/equipeImportMembros', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05001_equipeVendedorMeta_Repository', Ped05001_equipeVendedorMeta_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped05300_recalculo_preco_pedido_Repository.js
function Ped05300_recalculo_preco_pedido_Repository(restEngine, localStorageEngine) {
    
   
    this.buscaPedRecalc = function(row){
        return restEngine.post('ped#/buscaPedRecalc', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.recalcVrPedido = function(row){
        return restEngine.post('ped#/recalcVrPedido', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped05300_recalculo_preco_pedido_Repository', Ped05300_recalculo_preco_pedido_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped05700_importacao_Solicitacao_Compras_Repository.js
function Ped05700_importacao_Solicitacao_Compras_Repository(restEngine) {

    
    this.importarSolicitacoes = function(rows){
        return restEngine.post('ped_pedidos#/importasolicitacaocompra_importarsolicitacoes', {
            "requestType": "DataSet",
            "dataset": rows
        });
    }; 
    

}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05700_importacao_Solicitacao_Compras_Repository', Ped05700_importacao_Solicitacao_Compras_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped07001_ControleVisitasVendedor_Repository.js
function Ped07001_ControleVisitasVendedor_Repository(restEngine) {

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP & MOBILE


    this.getAgeVenRealizado = function(filter) {
        return restEngine.post('ped_pedidos#/agevenrealizado_agendavendedor_regiaoped', {
            "requestType": "FilterData",
            "filter": filter
        });

    };

    this.findPedidos = function(filter) {
        return restEngine.post('ped_pedidos#/pedido_filial_modpgto', {
            "requestType": "FilterData",
            "filter": filter
        });

    };

    this.enviarDadosControleVisita = function(data) {
         return restEngine.post('ped_pedidos#/enviarDadosControleVisita', {
            "requestType": "DataSet",
            "dataset": data
        });
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped07001_ControleVisitasVendedor_Repository', Ped07001_ControleVisitasVendedor_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped08000_tabela_desconto_Repository.js
var Ped08000_tabela_desconto_Repository = function(restEngine) {
    
    this.getNewNRTABDESC = function() {
        return restEngine.post('ped_pedidos#/getNewNRTABDESC', {
            "requestType": "FilterData",
            "filter": null
        });
    };
    
    this.getNewNRITTABDESC = function(filter) {
        return restEngine.post('ped_pedidos#/getNewNRITTABDESC', {
            "requestType": "DataSet",
            "filter": filter
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped08000_tabela_desconto_Repository', Ped08000_tabela_desconto_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped14000_parametrosWebservice_Repository.js
function Ped14000_parametrosWebservice_Repository (restEngine, localStorageEngine) {
    this.addweb = function(){};
    
    this.salvaDadosCliePedWeb = function(data){
   
	    return restEngine.post('ped#/crud/cliepedweb/save', {
	        "requestType": "DataSet",
            "dataset": data
        });
    };
        
    this.salvaDadosProdPedWeb = function(data){
   
	    return restEngine.post('ped#/crud/prodpedweb/save', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.salvaDadosClieWebSync = function(row){
	    return restEngine.post('ped#/crud/cliewebsync/save', {
	        "requestType": "DataSet",
            "dataset": row
        });
    };
    
    this.salvaDadosProdWebSync = function(row){
	    return restEngine.post('ped#/crud/prodwebsync/save', {
            "requestType": "DataSet",
            "dataset": row
        });
    };
    this.salvarCadastroAutomaticoProduto = function(row){
        return restEngine.post('ped#/cadastroAuto_Produto/save', {
            "requestType": "Row",
            "row": row
        });
    };
    this.salvarCadastroAutomaticoCliente = function(row){
        return restEngine.post('ped#/cadastroAuto_Cliente/save', {
            "requestType": "Row",
            "row": row
        });
    };
    this.salvaDadosModPedWeb = function(data){
   
	    return restEngine.post('ped#/crud/modpedweb/save', {
	        "requestType": "DataSet",
            "dataset": data
        });
    };
    this.salvarCadastroAutomaticoModalidade = function(row){
        return restEngine.post('ped#/cadastroAuto_Modalidade/save', {
            "requestType": "Row",
            "row": row
        });
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped14000_parametrosWebservice_Repository', Ped14000_parametrosWebservice_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped22000_relacionamento_produtos_importacao_Repository.js
function Ped22000_relacionamento_produtos_importacao_Repository (restEngine, localStorageEngine) {
    this.addweb = function(){};
    
    this.salvaDadosRelProdImp = function(data){
   
	    return restEngine.post('ped#/crud/relacprodimpsc/save', {
	        "requestType": "DataSet",
            "dataset": data
        });
    };
    
    
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped22000_relacionamento_produtos_importacao_Repository', Ped22000_relacionamento_produtos_importacao_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/Ped29000_manutencaoReserva_Repository.js
function Ped29000_manutencaoReserva_Repository (restEngine, localStorageEngine) {
    this.addweb = function(){};

    this.salvarManutencaoReserva = function(dataReserva){
	    return restEngine.post('ped_pedidos#/manutencao_reserva/save', {
	        "requestType": "DataSet",
            "dataset": dataReserva
        });
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped29000_manutencaoReserva_Repository', Ped29000_manutencaoReserva_Repository);
});

// FILE: ./assets/modules/pedidos/assets/js/repositories/ped05800_itens_composicao_preco_Repository.js
function ped05800_itens_composicao_preco_Repository(restEngine) {


    

}

Configuration(function(ContextRegister){
    ContextRegister.register('ped05800_itens_composicao_preco_Repository', ped05800_itens_composicao_preco_Repository);
});

// FILE: ./assets/modules/expedicao/assets/js/repositories/Exp00200_lancamentoExpedicaoPedido_Repository.js
var Exp00200_lancamentoExpedicaoPedido_Repository = function(localStorageEngine, restEngine) {
    
    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
    
    this.retornaEmpresa = function(cdempresa) {
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }
        ];
        return localStorageEngine.download("ped#/crud/empresa", filter);
    };  

    this.expedirPedido = function(data) {
        return restEngine.post('ped_expedicao#/expedir_pedido', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.getEstoqueData = function(row) {
        return restEngine.post('ped#/getEstoqueItemData', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Exp00200_lancamentoExpedicaoPedido_Repository', Exp00200_lancamentoExpedicaoPedido_Repository);
});

// FILE: ./assets/modules/expedicao/assets/js/repositories/Exp01100_parametrosDeExpedicao_Repositories.js
function Exp01100_parametrosDeExpedicao_Repositories(restEngine){

    
    this.deleteLogExpedicao = function(filial) {
        return restEngine.post('ped_expedicao#/deleteLogExpedicao', {
            "requestType": "Row",
            "row": filial
        });
    };
    
    this.insertLogExpedicao = function(objLog) {
        return restEngine.post('ped#/crud/autgrupop/save', {
            "requestType": "Row",
            "row": objLog
        });
    };
    
    this.getMaxNrautgrupop = function(cdgrupoper, idautgrupop, nrorg) {
        var filter = [
            {
                "name": "CDGRUPOPER",
                "operator": "=",
                "value": cdgrupoper
            },
            {
                "name": "IDAUTGRUPOP",
                "operator": "=",
                "value": idautgrupop
            },{
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        return restEngine.post('ped#/crud/autgrupop', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp01100_parametrosDeExpedicao_Repositories', Exp01100_parametrosDeExpedicao_Repositories);
});

// FILE: ./assets/modules/expedicao/assets/js/repositories/Exp0800_comissaoVendedorPeriodo_Repository.js
function Exp0800_comissaoVendedorPeriodo_Repository(restEngine) {
    
    this.apurarComissao = function(row) {
        return restEngine.post('ped#/apurarComissao', {
            "requestType": "Row",
            "row": row
        });
  
    };
    
    
    this.saveNota = function(row) {
        return restEngine.post('ped#/saveNotaForaPeriodo', {
            "requestType": "Row",
            "row": row
        });
  
    };
    
    this.saveConta = function(row) {
        return restEngine.post('ped#/saveContaForaPeriodo', {
            "requestType": "Row",
            "row": row
        });
  
    };
    
    this.verificaMapasAnteriores = function(mapa) {
       var filter = [
            {
                "name": "CDFILICOMIS",
                "operator": "=",
                "value": mapa.CDFILIAL
            },
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": mapa.VENDEDOR
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": mapa.NRORG
            },
            {
                "name": "IDBLOQMAPACOMIS",
                "operator": "=",
                "value": "N"
            },
            {
                "name": "DTINIPERIODO",
                "operator": "<",
                "value": mapa.INICIAL
            }
            
        ];
       return restEngine.post('ped#/crud/mapacomperiodo', {
            "requestType": "FilterData",
            "filter": filter
       });
   };
   
    this.verificaAlertaMapas = function(mapa) {
        return restEngine.post('ped#/verificaAlertaMapas', {
            "requestType": "Row",
            "row": mapa
        });

   };
   
    this.gerarContaPagar = function(row) {
        return restEngine.post('ped#/gerarContaPagar', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveComissaoProduto = function(row) {
        return restEngine.post('ped#/saveComissaoProduto', {
            "requestType": "Row",
            "row": row
        });
    };
   
    this.verificaContaPagar = function(row) {
 
        var filter = [
            {
                "name": "CDFILICOMIS",
                "operator": "=",
                "value": row.CDFILICOMIS
            },
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": row.CDVENDEDOR
            },
            {
                "name": "NRMAPACOMIS",
                "operator": "=",
                "value": row.NRMAPACOMIS
            }
        ];
        return restEngine.post('ped#/crud/mapacompag', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.excluirMapa = function(row) {
        return restEngine.post('ped#/excluirMapa', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.recalculoComissao = function(dataset){
        return restEngine.post('ped#/recalculoComissao',{
            "requestType": "DataSet",  
            "dataset": dataset
        });  
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp0800_comissaoVendedorPeriodo_Repository', Exp0800_comissaoVendedorPeriodo_Repository);
});

// FILE: ./assets/modules/expedicao/assets/js/repositories/Ger01100_Transportadora_Repository.js
var Ger01100_Transportadora_Repository = function (restEngine) {
	this.saveTransportadora = function (row) {
		return restEngine.post('ped_expedicao#/crud/transport_completa/save', {
			"requestType": "Row",
			"row": row
		});
	};

	this.findParceiro = function (row) {
		var filtro = [
			{
				"name": "NRINSCRICAOPARC",
				"operator": "=",
				"value": row.INSCRICAO
            }
        ];
		return restEngine.post('ped_expedicao#/findParceiro', {
			"requestType": "FilterData",
			"filter": filtro
		});
	};
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01100_Transportadora_Repository', Ger01100_Transportadora_Repository);
});

// FILE: ./assets/modules/expedicao/assets/js/repositories/exp02100_rota_entrega_Repository.js
var exp02100_rota_entrega_Repository = function (restEngine) {

    this.deleteRota = function(row) {
        return restEngine.post('ped_expedicao#/deleteRotaTrans', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('exp02100_rota_entrega_Repository', exp02100_rota_entrega_Repository);
});

// FILE: ./assets/js/services/Ger02400_CalendarioDeDiasNaoUteis_Service.js
var Ger02400_CalendarioDeDiasNaoUteis_Service = function (ScreenService, templateManager, restEngine, localStorageEngine) {

    this.findCalendario = function(filter, calendarioOption){
        switch(calendarioOption){
            case 'filial' :
                filter[2].name = "DTFERIFILI";
                return this.findFilial(filter);
            case 'compras' : 
                filter[2].name = "DTFERICOMP";
                return this.findCompras(filter);
            case 'bancario':
                filter[2].name = "DTFERIBANC";
                return this.findBancario(filter);
            case 'cardapio':
                filter[2].name = "DTFERICARD";
               return this.findCardapio(filter);
        }
    };
    
    this.CalcCalendCompra = function(data){
        return restEngine.post("/calendario/CalcCalendCompra", {
            "requestType": "DataSet",
            "dataset": data
        },
        undefined, 
        "POST",
        undefined,
        undefined,
        300000
        );
    }; 
    
    this.verificaDia = function(data){
        return restEngine.post("/calendario/verificaDia", {
            "requestType": "DataSet",
            "dataset": data
        },
        undefined, 
        "POST",
        undefined,
        undefined,
        300000
        );
    };

    this.saveCalendario = function(data,calendarioOption){
        return restEngine.post("/calendario/save", {
            "requestType": "DataSet",
            "dataset": data
        },
        undefined, 
        "POST",
        undefined,
        undefined,
        300000
        );
    };
    
	this.findFilial = function (filter){

        return restEngine.post("ped#/crud/ferifili", {
            "requestType": "FilterData",
            "filter": filter
        });
	};


    this.findCompras = function (filter){

        return restEngine.post("ped#/crud/fericomp", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.findBancario = function (filter){

        return restEngine.post("ped#/crud/feribanc", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.findCardapio = function (filter){

        return restEngine.post("ped#/crud/fericard", {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.excluirDia = function (data){

        return restEngine.post("/calendario/remove", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.deleteCardapio = function (row){

        return restEngine.post("/calendario/removeCardapio", {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
	
	this.getDTPROCE = function(CDFILIAL){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": CDFILIAL
            }
        ];
        return localStorageEngine.download("ped#/crud/paramfilial", filter);
	};

};

Configuration(function(ContextRegister, eventEngine) {
	ContextRegister.register('Ger02400_CalendarioDeDiasNaoUteis_Service', Ger02400_CalendarioDeDiasNaoUteis_Service);
});

// FILE: ./assets/js/services/Ger41200_GrupoClientes_Service.js
var Ger41200_GrupoClientes_Service = function(Ger41200_GrupoClientes_Repository) {
    
    this.newAlvaraNR = function(){
        return Ger41200_GrupoClientes_Repository.newAlvaraNR();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger41200_GrupoClientes_Service', Ger41200_GrupoClientes_Service);
});

// FILE: ./assets/js/services/Ger96600_AlvarasLicenciamento_Service.js
var Ger96600_AlvarasLicenciamento_Service = function(Ger96600_AlvarasLicenciamento_Repository) {
    
    this.newAlvaraNR = function(){
        return Ger96600_AlvarasLicenciamento_Repository.newAlvaraNR();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger96600_AlvarasLicenciamento_Service', Ger96600_AlvarasLicenciamento_Service);
});

// FILE: ./assets/js/services/Ped00000_dashboardPedidos_Service.js
var Ped00000_dashboardPedidos_Service = function(Ped00000_dashboardPedidos_Repository, localStorageEngine) {
    
    this.buscaVendas = function(filter) {
        return Ped00000_dashboardPedidos_Repository.buscaVendas(filter);
    };
    
    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };
    
    this.getData = function(name) {
        return localStorageEngine.getDataSource(name);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped00000_dashboardPedidos_Service', Ped00000_dashboardPedidos_Service);
});

// FILE: ./assets/js/services/Ped07000_agendaVendedorRegiao_Service.js
var Ped07000_agendaVendedorRegiao_Service = function(Ped07000_agendaVendedorRegiao_Repository) {
    
    this.saveCliente = function(row) {
        return Ped07000_agendaVendedorRegiao_Repository.saveCliente(row);
    };
    
    this.searchRegiao = function() {
        return Ped07000_agendaVendedorRegiao_Repository.searchRegiao();
    };
    
    this.searchPrevData = function() {
        return Ped07000_agendaVendedorRegiao_Repository.searchPrevData();
    };
    
    this.buscaCalendarColor = function(row) {
        return Ped07000_agendaVendedorRegiao_Repository.buscaCalendarColor(row);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped07000_agendaVendedorRegiao_Service', Ped07000_agendaVendedorRegiao_Service);
});

// FILE: ./assets/js/services/Ped07700_ParametrizacaoClientesPedidos_Service.js
var Ped07700_ParametrizacaoClientesPedidos_Service = function(Ped07700_ParametrizacaoClientesPedidos_Repository) {
    

    this.exportPrecosCliente = function(row) {
        return Ped07700_ParametrizacaoClientesPedidos_Repository.exportarPrecosCliente(row);
    };
    
    this.searchTabela = function(filter) {
        return Ped07700_ParametrizacaoClientesPedidos_Repository.searchTabela(filter);
    };
    
    this.salvaDadosProduto = function(row){
        return Ped07700_ParametrizacaoClientesPedidos_Repository.salvaDadosProduto(row);
    };
    
    this.deletaDadosProduto = function(row){
        return Ped07700_ParametrizacaoClientesPedidos_Repository.deletaDadosProduto(row);
    };
    
    this.cadastramentoAutomaticoCliente = function(dataSet){
        
        return Ped07700_ParametrizacaoClientesPedidos_Repository.cadastramentoAutomaticoCliente(dataSet);
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped07700_ParametrizacaoClientesPedidos_Service', Ped07700_ParametrizacaoClientesPedidos_Service);
});

// FILE: ./assets/js/services/ger00700_Cliente_Service.js
var Ger00700_Cliente_Service = function(localStorageEngine, ZHPromise, templateManager, ScreenService,Ger00700_Cliente_Repositories) {

    self = this;

    self.removePrazoPagamento = function(data) {
        return Ger00700_Cliente_Repositories.removePrazoPagamento(data);
    };

    self.inserePrazoPagamento = function(data){
        return Ger00700_Cliente_Repositories.inserePrazoPagamento(data);
    };

    self.insereParceiro = function(data){
        return Ger00700_Cliente_Repositories.insereParceiro(data);
    };

    self.insereEnderecoParceiro = function(endereco){
        return Ger00700_Cliente_Repositories.insereEnderecoParceiro(endereco);
    };

    self.getParcNegocio = function(inscricao){
        return Ger00700_Cliente_Repositories.getParcNegocio(inscricao);
    };

    self.getEnderecoParcNegocio = function(parceiro, tipoEndereco){
        return Ger00700_Cliente_Repositories.getEnderecoParcNegocio(parceiro, tipoEndereco);
    };

    self.validaDiasPrazo = function(dataSet){
        var dias = [];
        dataSet.forEach(function(row){
            dias.push(row.NRDIASPGTOCL);
        });
        for(var i in dias){
            if(dias.indexOf(dias[i])!==dias.lastIndexOf(dias[i]) && dias[i]!==undefined && Number.isNaN(dias[i]))
                return false;
        }
        return true;
    };

    self.getParceria = function(parceria, tipoparceiro){
        return Ger00700_Cliente_Repositories.getParceria(parceria, tipoparceiro);
    };

    self.insereParceria = function(parceria){
        return Ger00700_Cliente_Repositories.insereParceria(parceria);
    };

    self.validaPercentual = function(dataSet){
        var percent = 0.0;
        dataSet.forEach(function(row){
            percent +=parseFloat(row.VRPERCPGTOCL);
        });
        return percent ===100;
    };

    self.getBancoPref = function(cliente, organizacao){
        return Ger00700_Cliente_Repositories.getBancoPref(cliente, organizacao);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ger00700_Cliente_Service", Ger00700_Cliente_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped00100_lancamentoPedido_Service.js
// FILE: ./assets/js/services/Ped00100_lancamentoPedido_Service.js
var  Ped00100_lancamentoPedido_Service = function(Ped00100_lancamentoPedido_Repository, localStorageEngine){

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.getNewCode = function(params) {
        var filial = { "filial": params};
        return Ped00100_lancamentoPedido_Repository.getNewCode(filial);
    };

    this.updateOrder = function(row) {
        return Ped00100_lancamentoPedido_Repository.updateOrder(row);
    };
    this.calcImpostoItem = function(dataset){
      return Ped00100_lancamentoPedido_Repository.calcImpostoItem(dataset);  
    };
    
     this.deletePrazo = function(data) {
        return Ped00100_lancamentoPedido_Repository.deletePrazo(data);
    };

    this.findModpgtoPrazo = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findModpgtoPrazo(filter);
    };

    this.retornaParamPedido = function() {
        return Ped00100_lancamentoPedido_Repository.retornaParamPedido();
    };

    this.retornaPrecobase = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPrecobase();
    };

    this.retornaPrecobasecli = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPrecobasecli();
    };

    this.retornaPendenciaFin = function() {
        return Ped00100_lancamentoPedido_Repository.retornaPendenciaFin();
    };

    this.checkLogin = function(filter) {
        return Ped00100_lancamentoPedido_Repository.checkLogin(filter);
    };

    this.savePedido = function(data) {
        return Ped00100_lancamentoPedido_Repository.savePedido(data);
    };

    var getDataSourceConfigTransmissao = function() {
        return localStorageEngine.getDataSource("df#/config_transmissao").then(function(transmissao){
            return transmissao[0].config;
        });
    };
    
    this.statusServico = function(notasfiscais){
        return getDataSourceConfigTransmissao().then(function(config){
            return Ped00100_lancamentoPedido_Repository.statusServico(notasfiscais, config);
        });
    };

    this.montaConfigTransmissao = function(pedido){
        
         var row = {
            'CDEMPRESA': pedido.CDEMPRESA,
            'CDINSCESTA': pedido.CDINSCESTA,
            'CDFILIAL': pedido.CDFILIAL,
            'NRORG': pedido.NRORG
        };
        
        return Ped00100_lancamentoPedido_Repository.montaConfigTransmissao(row);
    };


    
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP & MOBILE

    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };
    this.setData = function(name, dataSource) {
        return localStorageEngine.setDataSource(name, dataSource);
    };
    this.getData = function(name) {
        return localStorageEngine.getDataSource(name);
    };
    this.getLocalVar = function(name) {
        return localStorageEngine.getLocalVar(name);
    };


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - MOBILE
    this.enviarPedido = function(data) {
        return Ped00100_lancamentoPedido_Repository.enviarPedido(data);
    };
    this.filtraVendedor = function(filter) {
        return Ped00100_lancamentoPedido_Repository.filtraVendedor(filter);
    };
    this.retornaDadosUnidade = function(filter) {
        return Ped00100_lancamentoPedido_Repository.retornaDadosUnidade(filter);
    };
    this.filtraFilioper = function(filter) {
        return Ped00100_lancamentoPedido_Repository.filtraFilioper(filter);
    };
    this.findClienteVendedor = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findClienteVendedor(filter);
    };
    this.findQTprod = function() {
        return Ped00100_lancamentoPedido_Repository.findQTprod();
    };
    this.findModpgto = function() {
        return Ped00100_lancamentoPedido_Repository.findModpgto();
    };
    this.findModpgtoPrazoMod = function() {
        return Ped00100_lancamentoPedido_Repository.findModpgtoPrazoMod();
    };
    this.findParameters = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findParameters(filter);
    };
    
    this.findParamPedido = function(filter) {
      return Ped00100_lancamentoPedido_Repository.findParamPedido(filter);  
    };
    
    this.findTpdesc = function() {
        return Ped00100_lancamentoPedido_Repository.findTpdesc();
    };
    this.findTpOperac = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findTpOperac(filter);
    };
    this.findProduto = function(filter) {
        return Ped00100_lancamentoPedido_Repository.findProduto(filter);
    };

    this.saveItem = function(data) {
        return Ped00100_lancamentoPedido_Repository.saveItem(data);
    };

    this.savePrazo = function(data) {
        return Ped00100_lancamentoPedido_Repository.savePrazo(data);
    };

    this.enviarEmail = function(/*emails, */data) {
        return Ped00100_lancamentoPedido_Repository.enviarEmail(/*emails, */data);
    };
    
    this.deletePedido = function(row) {
        return Ped00100_lancamentoPedido_Repository.deletePedido(row);
    };
    
    this.validaQtdeDispEstoque = function(data) {
        return Ped00100_lancamentoPedido_Repository.validaQtdeDispEstoque(data);
    };
    
    this.salvarDuplicPed = function(data) {
        return Ped00100_lancamentoPedido_Repository.salvarDuplicPed(data);
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00100_lancamentoPedido_Service', Ped00100_lancamentoPedido_Service);
});


// FILE: ./assets/modules/pedidos/assets/js/services/Ped00200_confirmacaoPedido_Service.js
var  Ped00200_confirmacaoPedido_Service = function(Ped00200_confirmacaoPedido_Repository, localStorageEngine){

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    
    this.savePedido = function(data) {
        return Ped00200_confirmacaoPedido_Repository.savePedido(data);
    };

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP & MOBILE
    
    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };
    this.setData = function(name, dataSource) {
        return localStorageEngine.setDataSource(name, dataSource);
    };
    this.getData = function(name) {
        return localStorageEngine.getDataSource(name);
    };
    this.getLocalVar = function(name) {
        return localStorageEngine.getLocalVar(name);
    };

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - MOBILE

    this.saveItem = function(data) {
        return Ped00200_confirmacaoPedido_Repository.saveItem(data);
    };
    
    this.saveJust = function(row) {
      return   Ped00200_confirmacaoPedido_Repository.saveJust(row);
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00200_confirmacaoPedido_Service', Ped00200_confirmacaoPedido_Service);
});


// FILE: ./assets/modules/pedidos/assets/js/services/Ped00300_aprovacao_Service.js
var  Ped00300_aprovacao_Service = function(Ped00300_aprovacao_Repository, localStorageEngine){

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.checkLogin = function(filter) {
        return Ped00300_aprovacao_Repository.checkLogin(filter);
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00300_aprovacao_Service', Ped00300_aprovacao_Service);
});


// FILE: ./assets/modules/pedidos/assets/js/services/Ped00301_posicaoFinanceiraCliente_Service.js
var  Ped00301_posicaoFinanceiraCliente_Service = function(Ped00301_posicaoFinanceiraCliente_Repository, localStorageEngine){

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP
    this.getPosicaoFinanceira = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getPosicaoFinanceira(filter);
    };
    
    this.getContasAbertas = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getContasAbertas(filter);
    };
    
    this.getTipoRecAbertas = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getTipoRecAbertas(filter);
    };
    
    this.getContasFechadas = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getContasFechadas(filter);
    };
    
    this.getTipoRecFechadas = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getTipoRecFechadas(filter);
    };
    
    this.getEndereco = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getEndereco(filter);
    };
    
    this.getHistorico = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getHistorico(filter);
    };
    
    this.getHistContas = function(filter) {
        return Ped00301_posicaoFinanceiraCliente_Repository.getHistContas(filter);
    };
    
    this.getFilialLogada = function(){
        return Ped00301_posicaoFinanceiraCliente_Repository.retornaUnidadeLogada();
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00301_posicaoFinanceiraCliente_Service', Ped00301_posicaoFinanceiraCliente_Service);
});


// FILE: ./assets/modules/pedidos/assets/js/services/Ped01100_dadosPedido_Service.js
var  Ped01100_dadosPedido_Service = function(Ped01100_dadosPedido_Repository, localStorageEngine){
    this.geraRelatorio = function(row) {
		return Ped01100_dadosPedido_Repository.geraRelatorio(row);
	};
   
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped01100_dadosPedido_Service', Ped01100_dadosPedido_Service);
});


// FILE: ./assets/modules/pedidos/assets/js/services/Ped02300PrecoBaseServices.js
var Ped02300PrecoBaseServices = function(localStorageEngine, Ped02300PrecoBaseRepositories) {
    
    this.newCode = function(row){
        return Ped02300PrecoBaseRepositories.newCode(row);
    };
    
    this.setPromoPrBase = function(row){
        return Ped02300PrecoBaseRepositories.setPromoPrBase(row);
    };
    
    this.setItemPrecoBase = function(newItemPrecoBase){
        newItemPrecoBase.DTHRATZIPB = moment().format('DD/MM/YYYY');
        return Ped02300PrecoBaseRepositories.setItemPrecoBase(newItemPrecoBase);
    };
    
    this.removeItemPrecoBase = function(row){
        return Ped02300PrecoBaseRepositories.removeItemPrecoBase(row);
    };
    
    this.removePrecoBase = function(row){
        return Ped02300PrecoBaseRepositories.removePrecoBase(row);
    };
    
    this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
	};
	
    this.saveFatorPreco = function(row) {
        return Ped02300PrecoBaseRepositories.saveFatorPreco(row);
    }; 
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ped02300PrecoBaseServices", Ped02300PrecoBaseServices);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped02600_parametrosPedidos_Service.js
var  Ped02600_parametrosPedidos_Service = function(Ped02600_parametrosPedidos_Repository){
    
    this.saveRowParamPed = function(row) {
        return Ped02600_parametrosPedidos_Repository.saveParamPed(row);
    };  
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02600_parametrosPedidos_Service', Ped02600_parametrosPedidos_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped03500_tabelaMetaComissao_Service.js
function Ped03500_tabelaMetaComissao_Service(Ped03500_tabelaMetaComissao_Repository) {
    
    this.verificaValorInicial = function(VRINICVENDA, CDFILIAL, CDPRODUTO, CDCOMISSAO) {
        return Ped03500_tabelaMetaComissao_Repository.verificaValorInicial(VRINICVENDA, CDFILIAL, CDPRODUTO, CDCOMISSAO); 
    };  
    
    this.verificaValorFinal = function(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO) {
        return Ped03500_tabelaMetaComissao_Repository.verificaValorFinal(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO); 
    };
    this.verificaValores = function(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO){
        return Ped03500_tabelaMetaComissao_Repository.verificaValores(VALORES, CDFILIAL, CDPRODUTO, CDCOMISSAO); 
    };
    this.getNrSeq = function(row){
        return Ped03500_tabelaMetaComissao_Repository.getNrSeq(row);
    };
    this.cadastroAutomaticoItem = function(row) {
        
        return Ped03500_tabelaMetaComissao_Repository.cadastroAutomaticoItem(row); 
    };
    
    this.cadastroAutomaticoProduto = function(row){
        return Ped03500_tabelaMetaComissao_Repository.cadastroAutomaticoProduto(row);
    };
    
    this.delete = function(dataSource, row) {
        return Ped03500_tabelaMetaComissao_Repository.delete(dataSource, row);
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped03500_tabelaMetaComissao_Service', Ped03500_tabelaMetaComissao_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped04400_previsao_de_vendas_Service.js
var Ped04400_previsao_de_vendas_Service = function(localStorageEngine, Ped04400_previsao_de_vendas_Repository) {
    
    this.getFilialLogada = function(){
        return Ped04400_previsao_de_vendas_Repository.retornaUnidadeLogada();
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ped04400_previsao_de_vendas_Service", Ped04400_previsao_de_vendas_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped04900_recalculo_comissao_vendedor_Service.js
var Ped04900_recalculo_comissao_vendedor_Service = function(Ped04900_recalculo_comissao_vendedor_Repository, localStorageEngine){
    
    this.recalculoComissaoVendedor = function(row){
        return Ped04900_recalculo_comissao_vendedor_Repository.recalculoComissaoVendedor(row);
    };
    
};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped04900_recalculo_comissao_vendedor_Service', Ped04900_recalculo_comissao_vendedor_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped05000_metaVendaComissao_Service.js
function Ped05000_metaVendaComissao_Service(Ped05000_metaVendaComissao_Repository) {
    
    this.getNrSeq = function(row){
        return Ped05000_metaVendaComissao_Repository.getNrSeq(row);
    };
    
    this.cadastroAutomaticoVendedor = function(row){
        return Ped05000_metaVendaComissao_Repository.cadastroAutomaticoVendedor(row);
    }; 
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05000_metaVendaComissao_Service', Ped05000_metaVendaComissao_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped05001_equipeVendedorMeta_Service.js
function Ped05001_equipeVendedorMeta_Service(Ped05001_equipeVendedorMeta_Repository) {
    this.getNrSeq = function(row){
        return Ped05001_equipeVendedorMeta_Repository.getNrSeq(row);
    };
    
    this.searchEquipe = function() {
        return Ped05001_equipeVendedorMeta_Repository.searchEquipe();
    };
    
    this.searchMembros = function() {
        return Ped05001_equipeVendedorMeta_Repository.searchMembros();
    };
    
    this.exportarMembros = function(row){
        return Ped05001_equipeVendedorMeta_Repository.exportarMembros(row);
    };
    
    this.exportarMembros = function(row){
        return Ped05001_equipeVendedorMeta_Repository.exportarMembros(row);
    };
    
    this.importarMembros = function(row){
        return Ped05001_equipeVendedorMeta_Repository.importarMembros(row);
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05001_equipeVendedorMeta_Service', Ped05001_equipeVendedorMeta_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped05300_recalculo_preco_pedido_Service.js
var Ped05300_recalculo_preco_pedido_Service = function(Ped05300_recalculo_preco_pedido_Repository, localStorageEngine){
    
    this.buscaPedRecalc = function(row){
        return Ped05300_recalculo_preco_pedido_Repository.buscaPedRecalc(row);
    };
    
    this.recalcVrPedido = function(row){
        return Ped05300_recalculo_preco_pedido_Repository.recalcVrPedido(row);
    };
    
    
};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped05300_recalculo_preco_pedido_Service', Ped05300_recalculo_preco_pedido_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped05700_importacao_Solicitacao_Compras_Service.js
function Ped05700_importacao_Solicitacao_Compras_Service(Ped05700_importacao_Solicitacao_Compras_Repository) {
    
    this.importarSolicitacoes = function(rows){
        return Ped05700_importacao_Solicitacao_Compras_Repository.importarSolicitacoes(rows);
    }; 
    
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05700_importacao_Solicitacao_Compras_Service', Ped05700_importacao_Solicitacao_Compras_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped07001_ControleVisitasVendedor_Service.js
function Ped07001_ControleVisitasVendedor_Service(localStorageEngine, Ped07001_ControleVisitasVendedor_Repository) {

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP & MOBILE


    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };
    this.setData = function(name, data) {
        return localStorageEngine.setDataSource(name, data);
    };
    this.getData = function(name) {
        return localStorageEngine.getDataSource(name);
    };
    this.getLocalVar = function(name) {
        return localStorageEngine.getLocalVar(name);
    };

    this.getAgeVenRealizado = function(filter) {
        return Ped07001_ControleVisitasVendedor_Repository.getAgeVenRealizado(filter);
    };

    this.findPedidos = function(filter) {
        return Ped07001_ControleVisitasVendedor_Repository.findPedidos(filter);
    };

    this.enviarDadosControleVisita = function(data) {
        return Ped07001_ControleVisitasVendedor_Repository.enviarDadosControleVisita(data);
    };



}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped07001_ControleVisitasVendedor_Service', Ped07001_ControleVisitasVendedor_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped08000_tabela_desconto_Services.js
var Ped08000_tabela_desconto_Services = function(localStorageEngine, Ped08000_tabela_desconto_Repository) {
    
    this.getNewNRTABDESC = function(){
        return Ped08000_tabela_desconto_Repository.getNewNRTABDESC();
    };
    
    this.getNewNRITTABDESC = function(filter){
        return Ped08000_tabela_desconto_Repository.getNewNRITTABDESC(filter);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ped08000_tabela_desconto_Services", Ped08000_tabela_desconto_Services);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped14000_parametrosWebservice_Service.js
var Ped14000_parametrosWebservice_Service = function(Ped14000_parametrosWebservice_Repository, localStorageEngine){
    this.addweb = function(){};
    
    this.salvaDadosProdPedWeb = function(data){
        return Ped14000_parametrosWebservice_Repository.salvaDadosProdPedWeb(data);
    };
    this.salvaDadosProdWebSync = function(row){
        return Ped14000_parametrosWebservice_Repository.salvaDadosProdWebSync(row);
    };    
    
    this.salvaDadosCliePedWeb = function(data){
        return Ped14000_parametrosWebservice_Repository.salvaDadosCliePedWeb(data);
    };
    this.salvaDadosClieWebSync = function(row){
        return Ped14000_parametrosWebservice_Repository.salvaDadosClieWebSync(row);
    };
    this.salvarCadastroAutomaticoCliente = function(row){
        return Ped14000_parametrosWebservice_Repository.salvarCadastroAutomaticoCliente(row);
    }; 
    this.salvarCadastroAutomaticoProduto = function(row){
        return Ped14000_parametrosWebservice_Repository.salvarCadastroAutomaticoProduto(row);
    };
    this.salvaDadosModPedWeb = function(data){
        return Ped14000_parametrosWebservice_Repository.salvaDadosModPedWeb(data);
    };
    this.salvarCadastroAutomaticoModalidade = function(row){
        return Ped14000_parametrosWebservice_Repository.salvarCadastroAutomaticoModalidade(row);
    };
};


Configuration(function(ContextRegister){
    ContextRegister.register('Ped14000_parametrosWebservice_Service', Ped14000_parametrosWebservice_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped22000_relacionamento_produtos_importacao_Service.js
var Ped22000_relacionamento_produtos_importacao_Service = function(Ped22000_relacionamento_produtos_importacao_Repository, localStorageEngine){
    this.addweb = function(){};
    
    this.salvaDadosRelProdImp = function(data){
        return Ped22000_relacionamento_produtos_importacao_Repository.salvaDadosRelProdImp(data);
    };
    
    
};


Configuration(function(ContextRegister){
    ContextRegister.register('Ped22000_relacionamento_produtos_importacao_Service', Ped22000_relacionamento_produtos_importacao_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/Ped29000_manutencaoReserva_Service.js
var Ped29000_manutencaoReserva_Service = function(Ped29000_manutencaoReserva_Repository, localStorageEngine){
    
    this.salvarManutencaoReserva = function(dataReserva){
        return Ped29000_manutencaoReserva_Repository.salvarManutencaoReserva(dataReserva);
    };
    
};


Configuration(function(ContextRegister){
    ContextRegister.register('Ped29000_manutencaoReserva_Service', Ped29000_manutencaoReserva_Service);
});

// FILE: ./assets/modules/pedidos/assets/js/services/ped05800_itens_composicao_preco_Service.js
var ped05800_itens_composicao_preco_Service = function(ped05800_itens_composicao_preco_Repository, localStorageEngine){
    

    
};
Configuration(function(ContextRegister){
    ContextRegister.register('ped05800_itens_composicao_preco_Service', ped05800_itens_composicao_preco_Service);
});

// FILE: ./assets/modules/expedicao/assets/js/services/Exp00200_lancamentoExpedicaoPedido_Service.js
var Exp00200_lancamentoExpedicaoPedido_Service = function(Exp00200_lancamentoExpedicaoPedido_Repository, localStorageEngine, ScreenService, templateManager, ZHPromise, MessageService) {

    this.getFilialLogada = function(){
        return Exp00200_lancamentoExpedicaoPedido_Repository.retornaUnidadeLogada();
    };

    this.retornaEmpresa = function(cdempresa){
        return Exp00200_lancamentoExpedicaoPedido_Repository.retornaEmpresa(cdempresa);
    };

    this.expedirPedido = function(row){
        var operador = getLocalVar('CDOPERADOR');
        for(var i=0; i <row[0].length; i++){
            row[0][i].CDOPERADOR = operador;
        }
        return Exp00200_lancamentoExpedicaoPedido_Repository.expedirPedido(row);
    };

    this.getEstoqueData = function(row){
        return Exp00200_lancamentoExpedicaoPedido_Repository.getEstoqueData(row);
    };

    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };

    this.setData = function(name, dataSource) {
        return localStorageEngine.setDataSource(name, dataSource);
    };

    this.getData = function(dataSourceName, filter) {
        filter = filter || [];
        return localStorageEngine.getDataSource(dataSourceName, null, filter, null, 999999999);
    };

    this.expedir = function(args){
        var serie = '';
        var empresa = '';
        var tipooper = '';
        var widget = args.owner.widget;
        var checkedRows = args.owner.widget.dataSource.getCheckedRows();
        if (checkedRows.length > 0){
            // widget.appliedFilter.forEach(function(filter){
            // if(widget.appliedFilter.FILTER_ROW.CDTIPOOPER !== ''){
                tipooper = widget.appliedFilter.FILTER_ROW.CDTIPOOPER;
            // }
            // });
            empresa = widget.CDEMPRESA;
            serie   = widget.CDSERIE;
            
            for (var i = 0; i < checkedRows.length; i++ ) {
                checkedRows[i].CDEMPRESA = empresa;
                checkedRows[i].CDSERIE = serie;
                if (widget.getField('NMTIPOOPER').requiredParam) {
                    checkedRows[i].CDTIPOOPER = tipooper;
                }
            }
            
            this.getData('ped_expedicao#/lotes_expedicao').then(function(localdata){
                var data = [checkedRows, localdata];
                this.expedirPedido(data).then(function(callback){
                        //ScreenService.showMessage('Pedido(s) expedido(s) com sucesso.');
                    widget.unSelectAll();
                    widget.reload();
                    var widgetRetornoExp = templateManager.container.getWidget('popUpRetornoExpedicao');
                    
                    callback.dataset.data.forEach(function(item){
                        item.DSERRO = ScreenService.i18n(item.DSERRO);
                        if(item.PRODUTO){
                            item.DSERRO = item.PRODUTO + item.DSERRO;    
                        }
                    });
                    
                    setTimeout(function(){
                        ZHPromise.all(ScreenService.openPopup(widgetRetornoExp)).then(function(){
                            widgetRetornoExp.dataSource.data = callback.dataset.data;
                            widget.reload();
                        });
                    }, 1000);                    
                }.bind(this)).catch(function(callback){
                    //ScreenService.showMessage(callback.data.error);
                    if(callback.data.error.indexOf("erro_lote") > -1){
                        var itemSemLote = "ITEM_NAO_POSSUI_LOTE";
                        var parametros = callback.data.error.split("/");
                        MessageService.showMessageByCode(itemSemLote,{"NMPRODUTO":parametros[1], "NRPEDIDO":parametros[2], "NMRAZSOCCLIE":parametros[3]});                    
                    }else{
                        ScreenService.showMessage(callback.data.error);
                    }
                    ScreenService.closePopup(widget).then(function(){
                        ScreenService.closePopup();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(callback){
                ScreenService.showMessage(callback.data.error);
            }.bind(this));
            
        } else {
            ScreenService.showMessage('Selecione algum pedido.');
        }
    };


};

Configuration(function(ContextRegister) {
    ContextRegister.register("Exp00200_lancamentoExpedicaoPedido_Service", Exp00200_lancamentoExpedicaoPedido_Service);
});

// FILE: ./assets/modules/expedicao/assets/js/services/Exp01100_parametrosDeExpedicao_Service.js
function Exp01100_parametrosDeExpedicao_Service (Exp01100_parametrosDeExpedicao_Repositories, General){

    this.deleteLogExpedicao = function(filial) {
        return Exp01100_parametrosDeExpedicao_Repositories.deleteLogExpedicao(filial);
    };
    
    this.findLogExpedicao = function(cdfilial, idautgrupop) {
        return Exp01100_parametrosDeExpedicao_Repositories.findLogExpedicao(cdfilial, idautgrupop);
    };
    
    this.insertLogExpedicao = function(objLog) {
        return Exp01100_parametrosDeExpedicao_Repositories.insertLogExpedicao(objLog);
    };
    
    this.getMaxNrautgrupop = function(cdgrupoper, idautgrupop, nrorg){
        return Exp01100_parametrosDeExpedicao_Repositories.getMaxNrautgrupop(cdgrupoper, idautgrupop, nrorg);
    };
    
    this.verificaIsNew = function(cdfilial) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            }  
        ];
        return General.callRestEngine('ped_expedicao#/crud/parexpedicao_tipooperac', 'FilterData', filter);
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp01100_parametrosDeExpedicao_Service', Exp01100_parametrosDeExpedicao_Service);
});

// FILE: ./assets/modules/expedicao/assets/js/services/Exp0800_comissaoVendedorPeriodo_Service.js
function Exp0800_comissaoVendedorPeriodo_Service(Exp0800_comissaoVendedorPeriodo_Repository) {
    
    this.apurarComissao = function(row) {
      return Exp0800_comissaoVendedorPeriodo_Repository.apurarComissao(row);  
    };
    
    this.saveNota = function(row) {
        return Exp0800_comissaoVendedorPeriodo_Repository.saveNota(row);  
    };
    
    this.saveConta = function(row) {
        return Exp0800_comissaoVendedorPeriodo_Repository.saveConta(row);  
    };
    
    this.verificaMapasAnteriores = function(mapa) {
        mapa.INICIAL = mapa.INICIAL.split(" ")[0];
        return Exp0800_comissaoVendedorPeriodo_Repository.verificaMapasAnteriores(mapa);
    };
    this.verificaAlertaMapas = function(mapa) {
        return Exp0800_comissaoVendedorPeriodo_Repository.verificaAlertaMapas(mapa);
    };
    this.gerarContaPagar = function(row) {
        return Exp0800_comissaoVendedorPeriodo_Repository.gerarContaPagar(row);
    };
    this.saveComissaoProduto = function(row) {
        return Exp0800_comissaoVendedorPeriodo_Repository.saveComissaoProduto(row);
    };
    
    this.verificaContaPagar = function(row) {
        return Exp0800_comissaoVendedorPeriodo_Repository.verificaContaPagar(row);
    };
    
    this.excluirMapa = function(row){
         return Exp0800_comissaoVendedorPeriodo_Repository.excluirMapa(row);
    };
    
    this.recalculoComissao = function(dataSet){
        return Exp0800_comissaoVendedorPeriodo_Repository.recalculoComissao(dataSet);
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp0800_comissaoVendedorPeriodo_Service', Exp0800_comissaoVendedorPeriodo_Service);
});

// FILE: ./assets/modules/expedicao/assets/js/services/Ger01100_Transportadora_Service.js
var Ger01100_Transportadora_Service = function (General,Ger01100_Transportadora_Repository, ScreenService) {

    this.validateNumeroDeInscricao = function(inputValue) {
        var inscricao = General.inscricaoFormat(inputValue);
        if(!inscricao.valid) {
            //build appropriated error messages
            inscricao.error = {};
            var var_invalido =  ScreenService.i18n(" inválido!");
            var var_invalida =  ScreenService.i18n(" inválida!");
            switch(inscricao.tipo.cod) {
                case 'J':
                    inscricao.error.msg = "CNPJ \"" + inscricao.value + "\"" + var_invalido ;
                    break;
                case 'F':
                    inscricao.error.msg = "CPF \"" + inscricao.value + "\"" + var_invalido;
                    break;
                case null:
                    break;
                case 'I':
                /* falls through */
                default:
                    inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\"" + var_invalida;
            }
        }
        return inscricao;
    };

    this.salvarTransportadora = function(row){
        return Ger01100_Transportadora_Repository.saveTransportadora(row);
    };
    this.buscarParceiro = function(row){
        return Ger01100_Transportadora_Repository.findParceiro(row);

    };
    this.removerMacaras= function(row){
        if(row.NRINSJURTRAN){
            row.NRINSJURTRAN =row.NRINSJURTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRTELETRAN){
            row.NRTELETRAN =row.NRTELETRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRFAXTRAN){
            row.NRFAXTRAN =row.NRFAXTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRTELEXTRAN){
            row.NRTELEXTRAN =row.NRTELEXTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRCEPTRAN){
           row.NRCEPTRAN =row.NRCEPTRAN.replace(/[^0-9]/g,'');
        }
    };


};

Configuration(function(ContextRegister){
    ContextRegister.register('Ger01100_Transportadora_Service', Ger01100_Transportadora_Service);
});

// FILE: ./assets/modules/expedicao/assets/js/services/exp02100_rota_entregaService.js
var exp02100_rota_entregaService = function(localStorageEngine, exp02100_rota_entrega_Repository){

	this.retornaFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
	};
	
	this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
	};
	
	this.deletarRota = function(row){
        return exp02100_rota_entrega_Repository.deleteRota(row);
    };
    
};

 Configuration(function (ContextRegister){
    ContextRegister.register('exp02100_rota_entregaService', exp02100_rota_entregaService);
});

// FILE: ./assets/js/controllers/Ger02400_CalendarioDeDiasNaoUteis_Controller.js
function Ger02400_CalendarioDeDiasNaoUteis_Controller(ScreenService, General, ZHPromise, Ger02400_CalendarioDeDiasNaoUteis_Service, templateManager, MessageService) {

    var tabCal;
    var DTPROCE;
    var NRORG;
    var CDFILIAL;
    var TABS = {
        "filial": {
            DTFERI: "DTFERIFILI",
            DSFERI: "DSFERIFILI",
            TABFERI: "ferifili",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTULTATUFEFI"
        },
        'compras': {
            DTFERI: "DTFERICOMP",
            DSFERI: "DSFERICOMP",
            TABFERI: "fericomp",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTULTATUFECO"
        },
        'bancario': {
            DTFERI: "DTFERIBANC",
            DSFERI: "DSFERIBANC",
            TABFERI: "feribanc",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTINCLUSAO"
        },
        'cardapio': {
            DTFERI: "DTFERICARD",
            DSFERI: "DSFERICARD",
            TABFERI: "fericard",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTINCLUSAO"
        }
    };

    this.filialCalendario = function(widget){
        if(widget.currentRow.NMFILIAL == ""){
            widget.getField('CALENDAR_TYPE').readOnly = true;
            widget.getField('CALENDAR_TYPE').value("");
            widget.getField('CALENDAR_TYPE').reload();
            widget.widgets[0].isVisible = false;
            widget.widgets[0].deactivate();
            widget.widgets[0].actions.forEach(function(element){
                element.isVisible = false;
            });
            widget.widgets[0].reload();
        } else {
            CDFILIAL = widget.currentRow.CDFILIAL;
            Ger02400_CalendarioDeDiasNaoUteis_Service.getDTPROCE(CDFILIAL).then(function(callback){
                if(callback[0].DTPROCESSA){    
                    DTPROCE = callback[0].DTPROCESSA.substring(0,10);
                    widget.getField('CALENDAR_TYPE').readOnly = false;
                    widget.currentRow.CALENDAR_TYPE = "";
                } else {
                    //ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial '+widget.currentRow.NMFILIAL+'.');
                    
                    var var_parametrizacao_nao_encontrada = "PARAM_NAO_ENCONTRADA";
                    MessageService.showMessageByCode(var_parametrizacao_nao_encontrada,{"NMFILIAL" : widget.currentRow.NMFILIAL });
                }
            });
        }
    };
    
    this.tipoCalendario = function(args){
        var widget = args.owner.field.widget;
        if(widget.currentRow.CALENDAR_TYPE == null){
            widget.widgets[0].isVisible = false;
            widget.widgets[0].deactivate();
            widget.widgets[0].actions.forEach(function(element){
                element.isVisible = false;
            });
            widget.widgets[0].reload();
        } else {
            widget.widgets[0].isVisible = true;
            widget.widgets[0].activate();
            widget.widgets[0].actions.forEach(function(element){
                element.isVisible = true;
            });
            this.selecionaCalendario(args);
            widget.widgets[0].reload();
        }
    };

    this.selecionaCalendario = function(args) {
        if(args.owner.field.widget.currentRow.CALENDAR_TYPE != null){
            NRORG = getLocalVar('NRORG');
            tabCal = args.owner.field.widget.currentRow.CALENDAR_TYPE;
            this.carregaCalendario(args.owner.field.widget);
        }
    };

    this.carregaCalendario = function(widget) {
        var calendarWidget = templateManager.container.getWidget('calendario');
        calendarWidget.selectedDates = [];
        var data = [];
        var year;
        if(typeof calendarWidget.getYear == "function"){
            year = calendarWidget.getYear();
        } else {
            year = moment().format("YYYY");
        }
        var dateInit = moment(year, 'YYYY').startOf('year').format('DD/MM/YYYY');
        var dateFinal = moment(year, 'YYYY').endOf('year').format('DD/MM/YYYY');
        var filter = [{
            "name": "NRORG",
            "operator": "=",
            "value": NRORG
        }, {
            "name": "CDFILIAL",
            "operator": "=",
            "value": CDFILIAL
        }, {
            "name": "",
            "operator": "BETWEEN",
            "value": [dateInit, dateFinal]
        }];
        Ger02400_CalendarioDeDiasNaoUteis_Service.findCalendario(filter, tabCal).then(function(callback) {
            var dias;
            dias = callback.dataset[TABS[tabCal].TABFERI];
            dias.forEach(function(dataset) {
                var dateFormat = moment(dataset[TABS[tabCal].DTFERI].slice(0, 10), "DD/MM/YYYY");
                var DTINC = TABS[tabCal].DTINC;
                var DTULTA = TABS[tabCal].DTULTA;
                data.push({
                    TITLE: dataset[TABS[tabCal].DSFERI],
                    DATE: dateFormat.format("YYYY-MM-DD"),
                    DTINC: dataset[TABS[tabCal].DTINC],
                    DTULTA: dataset[TABS[tabCal].DTULTA],
                    NRORGINCLUSAO: dataset.NRORGINCLUSAO,
                    CDOPERINCLUSAO: dataset.CDOPERINCLUSAO,
                    NRORGULTATU: dataset.NRORGULTATU,
                    IDATIVO: dataset.IDATIVO
                });
            });
            calendarWidget.dataSource.data = data;
            var j = 0;
            data.forEach(function(element){
                 calendarWidget.selectedDates[j] = element.DATE;
                 j++;
            });
            calendarWidget.reload();
            
            if (widget.mode != "view") {
                calendarWidget.reload().then(function() {
                    calendarWidget.activate();
                });
            }
        });
    };

    this.editar = function(widget) {
        widget.edit();
        widget.template = widget.formTemplate = widget.templateToForm;
    };

    this.deleteCardapio = function(row) {
        return Ger02400_CalendarioDeDiasNaoUteis_Service.deleteCardapio(row);
    };

    this.excluirDia = function(widget) {
        var rows = widget.currentRow;
        var calendar = [
            {
                "CALENDAR" : templateManager.container.getWidget('calendario').parent.currentRow.CALENDAR_TYPE
            }
        ];
        var info = [{
            "CDFILIAL": CDFILIAL,
            "NRORG": NRORG,
            "tipo" : "Varias Datas"
        }];
        if((rows.length < 367) || (rows.DATA)){
            if(rows.DATA){
               rows.DATA = rows.DATA.replace(/-/g,'/');
               info[0].tipo = "Data Unica";
            }
            var data = [rows, calendar, TABS, info];
            Ger02400_CalendarioDeDiasNaoUteis_Service.excluirDia(data).then(function() {
                this.carregaCalendario(widget);
                widget.reload();
                ScreenService.closeSwipe();
                ScreenService.showMessage('Deletado com sucesso');
            }.bind(this), function(error){
                ScreenService.showMessage('Erro ao deletar');
            });
        } else {
            ScreenService.showMessage('Só é permitido operações no intervalo de um ano.');
        }
    };

    this.excluirDiaTodos = function(widget) {
        var tabelas = ['filial', 'compras', 'bancario', 'cardapio'];
        var rows = widget.currentRow;
        var info = [{
            "CDFILIAL": CDFILIAL,
            "NRORG": NRORG,
            "tipo" : "Varias Datas"
        }];
        if((rows.length < 367) || (rows.DATA)){
            if(rows.DATA){
               rows.DATA = rows.DATA.replace(/-/g,'/');
               info[0].tipo = "Data Unica";
            }
            var data = [rows, tabelas, TABS, info];
            Ger02400_CalendarioDeDiasNaoUteis_Service.excluirDia(data).then(function() {
                this.carregaCalendario(widget);
                widget.reload();
                ScreenService.closeSwipe();
                ScreenService.showMessage('Deletado com sucesso');
            }.bind(this), function(error){
                ScreenService.showMessage('Erro ao deletar');
            });
        } else {
            ScreenService.showMessage('Só é permitido operações no intervalo de no máximo um ano.');
        }
    };

    this.excluirDiaNaoUtil = function(widget) {
        var calendar;
        if (Array.isArray(widget.currentRow)) {
            calendar = widget.parent.container.getWidget('cadastroAuto').currentRow.calendario;
        } else {
            calendar = tabCal;
        }
        var actions1 = [{
            label: ScreenService.i18n("Sim"),
            code: function() {
                this.excluirDiaTodos(widget);
            }.bind(this)
        }, {
            label: ScreenService.i18n("Somente filial"),
            code: function() {
                this.excluirDia(widget);
            }.bind(this)
        }, {
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }];
        var actions2 = [{
            label: ScreenService.i18n("Sim"),
            code: function() {
                this.excluirDia(widget, calendar);
            }.bind(this)
        }, {
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }];
        switch (calendar) {

            case "filial":
                ScreenService.showCustomDialog("Deseja excluir o dia não útil, de compras, bancário e cardápio, da filial?", null, "question", actions1);
                break;
            case "compras":
                ScreenService.showCustomDialog("Deseja excluir o dia não útil de compras?", null, "question", actions2);
                break;
            case "bancario":
                ScreenService.showCustomDialog("Deseja excluir o dia não útil de bancário?", null, "question", actions2);
                break;
            case "cardapio":
                ScreenService.showCustomDialog("Deseja excluir o dia não útil de cardápio?", null, "question", actions2);
                break;
        }
        
        this.voltar(widget);
    };

    this.cancelar = function(widget) {
        if (widget.currentRow.__is_new) {
            ScreenService.closeSwipe();
            widget.container.getWidget('calendario').activate();
            this.carregaCalendario(widget);
        } else {
            widget.view();
            widget.template = widget.formTemplate = widget.templateToView;
            widget.activate();
        }
    };
    
    this.voltar = function(widget) {
        ScreenService.closeSwipe();
        widget.container.getWidget('calendario').activate();
        this.carregaCalendario(widget);
    };

    this.openAutoOperation = function(widget) {
        ScreenService.closePopup();
        var tabbedAutoOperationWidget = widget.widgets[0];
        var autoOperationWidget = widget.widgets[0].widgets[0];
        autoOperationWidget.template = autoOperationWidget.formTemplate = autoOperationWidget.templateToForm;
        ScreenService.openSwipe(tabbedAutoOperationWidget);
        autoOperationWidget.newRow();
    };
    
    this.confirmOperation = function(widget) {
        if (widget.isValid()) {
            var row = widget.currentRow;
            var weekdays = [];
            weekdays.push(row.segunda, row.terca, row.quarta, row.quinta, row.sexta, row.sabado, row.domingo);
            var count = 0;
            for (var i in weekdays) {
                if (weekdays[i] == 'N')
                    count++;
            }
            if (count == 7) {
                ScreenService.showMessage("Dia(s) deve(m) ser informado(s) para realizar a operação.");
            } else if(widget.currentRow.intervalo.end > moment(widget.currentRow.intervalo.start).add(1,"year").format("YYYY-MM-DD")){
                ScreenService.showMessage("A operação só pode ser feita em um intervalo de no máximo um ano.");
            } else {
                row.weekdays = weekdays;
                if (widget.currentRow.operacao == 1) {
                    if(count == 0){
                        ScreenService.confirmMessage(ScreenService.i18n('Deseja inserir todos os dias da semana como dias não úteis no intervalo selecionado?'), 'question', function (success){
                            this.autoOperation(widget, 1);        
                        }.bind(this));
                    } else {
                        this.autoOperation(widget, 1);
                    }
                } else if (widget.currentRow.operacao == 2) {
                    this.autoOperation(widget, 2);
                }
            }
        }
    };

    this.verificaDia = function(widget) {
        var data = [];
        if (Array.isArray(widget.currentRow)) {
            var verificaPromises = [];
            var days = widget.currentRow;
            if(days.length < 367){
                for (var day in days) {
                    data = [{
                        "DTDIA": moment(days[day], 'YYYY/MM/DD').format('DD/MM/YYYY'),
                        "DTPROCE": DTPROCE,
                        "TABCAL": "filial",
                        "CDFILIAL": CDFILIAL,
                        "NRORG": NRORG
                    }];
                    verificaPromises.push(data);
                }
                return ZHPromise.all(Ger02400_CalendarioDeDiasNaoUteis_Service.verificaDia(verificaPromises)).then(function(callback) {
                    var daysToSave = [];
                    var response = [];
                    for (var key in callback.dataset.filial) {
                        if (!Array.isArray(callback.dataset.filial[key].newDataSet)) {
                            if (!callback.dataset.filial[key].newDataSet.ERRORMSG) {
                                response.push({
                                    "CDFILCENTPME": callback.dataset.filial[key].newDataSet.CDFILCENTPME,
                                    "CDFILIAL": callback.dataset.filial[key].newDataSet.CDFILIAL,
                                    "DTPROCE": callback.dataset.filial[key].newDataSet.DTPROCE,
                                    "DTCARDAPIO": callback.dataset.filial[key].newDataSet.DTCARDAPIO,
                                    "MSG": callback.dataset.filial[key].newDataSet.MSG,
                                    "TYPE": callback.dataset.filial[key].newDataSet.TYPE
                                });
                            }
                        }
                        if (!callback.dataset.filial[key].newDataSet.ERRORMSG) {
                            daysToSave.push(days[key]);
                        }
                    }
                    if (response.length) {
                        return ScreenService.confirmMessage("Existem cardapios cadastrados no período. Deseja Excluí-los?").then(function() {
                            for (var key in response) {
                                this.deleteCardapio(response[key]);
                            }
                            return daysToSave;
                        }.bind(this), function() {
                            return false;
                        });
                    } else {
                        return daysToSave;
                    }
                }.bind(this));
            } else {
                ScreenService.showMessage('Só é permitido operações no intervalo de no máximo um ano.');
                var daysToSave = [];
                return daysToSave;
            }
        } else {
            if (tabCal == "filial") {
                data = [{
                    "DTDIA": moment(widget.currentRow).format('DD/MM/YYYY'),
                    "DTPROCE": DTPROCE,
                    "TABCAL": tabCal,
                    "CDFILIAL": CDFILIAL,
                    "NRORG": NRORG
                }];
                Ger02400_CalendarioDeDiasNaoUteis_Service.verificaDia(data).then(function(callback) {
                    var response = callback.dataset.filial.newDataSet;
                    if (response.ERRORMSG) {
                        ScreenService.showMessage(response.ERRORMSG);
                    } else if (response.TYPE == 'industrial') {
                        ScreenService.confirmMessage(response.MSG).then(function() {
                            this.deleteCardapio(response).then(function() {
                                this.detalhes(widget);
                            }.bind(this));
                        }.bind(this));
                    } else if (response.TYPE == 'merenda') {
                        ScreenService.confirmMessage(response.MSG).then(function() {
                            if (response.CDFILIAL == response.CDFILCENTPME) {
                                ScreenService.confirmMessage("Atenção! A filial selecionada é centralizadora. A confirmação desta operação irá excluir todos os cardápios(Merenda) das filiais agregadas. Confirma exclusão?").then(function() {
                                    this.deleteCardapio(response);
                                }.bind(this));
                            } else {
                                this.deleteCardapio(response);
                            }
                        }.bind(this));
                    } else {
                        this.detalhes(widget);
                    }
                }.bind(this));
            } else {
                data = [{
                    "DTDIA": moment(widget.currentRow).format('DD/MM/YYYY'),
                    "DTPROCE": DTPROCE,
                    "TABCAL": tabCal,
                    "CDFILIAL": CDFILIAL,
                    "NRORG": NRORG
                }];
                Ger02400_CalendarioDeDiasNaoUteis_Service.verificaDia(data).then(function() {
                    this.detalhes(widget);
                }.bind(this));
            }
        }
    };

    this.salvar = function(widget, cadAuto, table) {
        var promises;
        if (cadAuto) {
            var dias = widget.currentRow;
            var data;
            var row;
            if (table == "filial") {
                data = [];
                for (var diaF in dias) {
                    row = {};
                    row.__is_new = true;
                    row.CALENDAR = table;
                    row.NRORG = NRORG;
                    row.CDFILIAL = CDFILIAL;
                    row.TABS = TABS;
                    row[TABS[table].DTFERI] = moment(dias[diaF], 'YYYY/MM/DD').format('DD/MM/YYYY');
                    row[TABS[table].DSFERI] = null;
                    data.push(row);
                }
                Ger02400_CalendarioDeDiasNaoUteis_Service.saveCalendario(data, table);
            } else if (Array.isArray(table)) {
                promises = [];
                for (var i in table) {
                    data = [];
                    for (var diaT in dias) {
                        row = {};
                        row.__is_new = true;
                        row.CALENDAR = table[i];
                        row.CDFILIAL = CDFILIAL;
                        row.NRORG = NRORG;
                        row.TABS = TABS;
                        row[TABS[table[i]].DTFERI] = moment(dias[diaT], 'YYYY/MM/DD').format('DD/MM/YYYY');
                        row[TABS[table[i]].DSFERI] = null;
                        data.push(row);
                    }
                    promises.push(Ger02400_CalendarioDeDiasNaoUteis_Service.saveCalendario(data, table[i]));
                }
                return ZHPromise.all(promises);
            } else {
                promises = [];
                data = [];
                for (var dia in dias) {
                    row = {};
                    row.__is_new = true;
                    row.CALENDAR = table;
                    row.CDFILIAL = CDFILIAL;
                    row.NRORG = NRORG;
                    row.TABS = TABS;
                    row[TABS[table].DTFERI] = moment(dias[dia], 'YYYY/MM/DD').format('DD/MM/YYYY');
                    row[TABS[table].DSFERI] = null;
                    data.push(row);
                }
             promises.push(Ger02400_CalendarioDeDiasNaoUteis_Service.saveCalendario(data, table));
             return ZHPromise.all(promises);
            }
        } else {
            promises = [];
            var dataset = [];
            var datas = widget.container.getWidget('calendario').dataSource.data;
            if (tabCal == "filial") {
                for (table in TABS) {
                    dataset = [];
                    widget.currentRow.CALENDAR = table;
                    for (var dt in datas) {
                        if (datas[dt].DATE == widget.currentRow.DATA) {
                            widget.currentRow[TABS[table].DTINC] = datas[dt].DTINC;
                            widget.currentRow[TABS[table].DTULTA] = datas[dt].DTULTA;
                            widget.currentRow.NRORGINCLUSAO = datas[dt].NRORGINCLUSAO;
                            widget.currentRow.CDOPERINCLUSAO = datas[dt].CDOPERINCLUSAO;
                            widget.currentRow.NRORGULTATU = datas[dt].NRORGULTATU;
                            widget.currentRow.IDATIVO = datas[dt].IDATIVO;
                        }
                    }
                    widget.currentRow.__is_new = widget.currentRow.__is_new ? true : false;
                    widget.currentRow.CDFILIAL = CDFILIAL;
                    widget.currentRow.NRORG = NRORG;
                    widget.currentRow.TABS = TABS;
                    widget.currentRow[TABS[table].DTFERI] = moment(widget.currentRow.DATA, 'YYYY-MM-DD').format('DD/MM/YYYY');
                    widget.currentRow[TABS[table].DSFERI] = widget.currentRow.DESC;
                    dataset.push(angular.copy(widget.currentRow));
                    promises.push(Ger02400_CalendarioDeDiasNaoUteis_Service.saveCalendario(dataset, table));
                }
            } else {
                dataset = [];
                for (var dta in datas) {
                    if (datas[dta].DATE == widget.currentRow.DATA) {
                        widget.currentRow[TABS[tabCal].DTINC] = datas[dta].DTINC;
                        widget.currentRow[TABS[tabCal].DTULTA] = datas[dta].DTULTA;
                        widget.currentRow.NRORGINCLUSAO = datas[dta].NRORGINCLUSAO;
                        widget.currentRow.CDOPERINCLUSAO = datas[dta].CDOPERINCLUSAO;
                        widget.currentRow.NRORGULTATU = datas[dta].NRORGULTATU;
                        widget.currentRow.IDATIVO = datas[dta].IDATIVO;
                    }
                }
                widget.currentRow.CALENDAR = tabCal;
                widget.currentRow.__is_new = widget.currentRow.__is_new ? true : false;
                widget.currentRow.CDFILIAL = CDFILIAL;
                widget.currentRow.NRORG = NRORG;
                widget.currentRow.TABS = TABS;
                widget.currentRow[TABS[tabCal].DTFERI] = moment(widget.currentRow.DATA, 'YYYY-MM-DD').format('DD/MM/YYYY');
                widget.currentRow[TABS[tabCal].DSFERI] = widget.currentRow.DESC;
                dataset.push(angular.copy(widget.currentRow));
                promises.push(Ger02400_CalendarioDeDiasNaoUteis_Service.saveCalendario(dataset, tabCal));
            }
        }
        if(promises){    
            ZHPromise.all(promises).finally(function() {
            this.carregaCalendario(widget);
            ScreenService.closeSwipe();
            widget.container.getWidget('calendario').activate();
        }.bind(this));
        }
    };

    this.autoOperation = function(widget, operation) {
        var diaWidget = widget.parent.parent.container.getWidget('dia');
        var calendarWidget = widget.parent.parent;
        var diaInicial = moment(widget.currentRow.intervalo.start, 'YYYY-MM-DD');
        var diaFinal = moment(widget.currentRow.intervalo.end, 'YYYY-MM-DD');
        var dias = [];
        var diasOperacao = [];
        var weekday;
        while (diaInicial <= diaFinal) {
            weekday = diaInicial.format('d');
            if (widget.currentRow.weekdays.indexOf(weekday) >= 0) {
                dias.push(diaInicial.format('YYYY/MM/DD'));
            }
            diaInicial.add(1, 'day');
        }
        if (operation == 1) {
            calendarWidget.currentRow = dias;
            if (widget.currentRow.calendario == "filial") {
                var diasFilial;
                this.verificaDia(calendarWidget).then(function(diasFilial) {
                    if (diasFilial) {
                        calendarWidget.currentRow = diasFilial;
                        this.salvar(calendarWidget, true, "filial");
                        calendarWidget.currentRow = dias;
                        this.salvar(calendarWidget, true, ["compras", "bancario", "cardapio"]).finally(function() {
                            this.carregaCalendario(widget);
                            ScreenService.closeSwipe();
                            calendarWidget.activate();
                        }.bind(this));
                    } else {
                        ScreenService.closeSwipe();
                        calendarWidget.activate();
                    }
                }.bind(this));
            } else {
                this.salvar(calendarWidget, true, widget.currentRow.calendario).finally(function() {
                    ScreenService.closeSwipe();
                    widget.container.getWidget('calendario').activate();
                    this.carregaCalendario(widget);
                }.bind(this));
            }
        } else if (operation == 2) {
            diaWidget.currentRow = dias;
            this.excluirDiaNaoUtil(diaWidget);
        }
    };

    this.cancelOperation = function(widget) {
        ScreenService.closeSwipe();
        widget.container.getWidget('calendario').activate();
    };

    this.detalhes = function(widget) {
        var diaWidget = widget.container.getWidget('dia');
        var tabbedDiaWidget = widget.container.getWidget('tabbedDia');
        var diaAtual;
        var dias = widget.dataSource.data;
        for (var dia in dias) {
            if (dias[dia].DATE == widget.currentRow) {
                diaAtual = dias[dia];
            }
        }
        
        if (diaAtual) {
            diaWidget.currentRow = {
                DESC: diaAtual.TITLE,
                DATA: diaAtual.DATE
            };
            diaWidget.label ="Dia "+moment(widget.currentRow).format('DD/MM/YYYY');
            diaWidget.reload();
            diaWidget.view();
            diaWidget.template = diaWidget.formTemplate = diaWidget.templateToView;
            ScreenService.openSwipe(tabbedDiaWidget);
            diaWidget.activate();
        } else {
            diaWidget.label ="Dia "+moment(widget.currentRow).format('DD/MM/YYYY');
            diaWidget.reload();
            diaWidget.newRow();
            diaWidget.currentRow.DATA = moment(widget.currentRow).format('YYYY-MM-DD');
            diaWidget.template = diaWidget.formTemplate = diaWidget.templateToForm;
            ScreenService.openSwipe(tabbedDiaWidget);
            diaWidget.activate();
        }
    };
    
    this.calcCalendCompra = function(widget) {
        ScreenService.closePopup();
        var tabbedCalcCalendCompraWidget = widget.widgets[1];
        var autoCalWidget = widget.widgets[1].widgets[0];
        autoCalWidget.template = autoCalWidget.formTemplate = autoCalWidget.templateToForm;
        ScreenService.openSwipe(tabbedCalcCalendCompraWidget);
        autoCalWidget.newRow();
    };
    
    this.exportarCalend = function(widget) {
        ScreenService.closePopup();
        var tabbedExportarCalendWidget = widget.widgets[2];
        var exportarCalendWidget = widget.widgets[2].widgets[0];
        exportarCalendWidget.template = exportarCalendWidget.formTemplate = exportarCalendWidget.templateToForm;
        ScreenService.openSwipe(tabbedExportarCalendWidget);
        exportarCalendWidget.newRow();
    };
    
    this.confirmCalc = function(widget){
        var row = widget.currentRow;
        if(row.CDPERIENTR == ""){
            row.CDPERIENTR = [];
            row.NMPERIENTR = [];
            row.IDDIANUTIL = [];
            row.IDTIPODIA = [];
            widget.getField('CDPERIENTR').dataSource.data.forEach(function(element){
                row.CDPERIENTR.push(element.CDPERIENTR);
                row.NMPERIENTR.push(element.NMPERIENTR);
                row.IDDIANUTIL.push(element.IDDIANUTIL);
                row.IDTIPODIA.push(element.IDTIPODIA);
            });
        }
        
        var NRMESES = 0;
        var num_mes = [];
        widget.fields.forEach(function(element){
            if(element.template == "field/checkbox.html"){
                if(element.checked == true){
                    num_mes.push(element.valueToTrue);
                    NRMESES++;
                }
            }
        });
        var ano = widget.parent.parent.getYear();
        var dtInicial = "01/01/"+ano.toString();
        var info = [CDFILIAL, NRORG, DTPROCE, dtInicial ];
        var meses =[];
        if(NRMESES == 12){
            meses.push(NRMESES);
        } else {
            meses = [NRMESES, num_mes];
            
        }
        var data = [row,meses,info];
        
        Ger02400_CalendarioDeDiasNaoUteis_Service.CalcCalendCompra(data).then(function(success){
            ScreenService.closeSwipe();
            widget.container.getWidget('calendario').activate();
            this.carregaCalendario(widget);
            ScreenService.showMessage("Calendário de Compras calculado com sucesso");
        }.bind(this), function(error){
            ScreenService.showMessage(error);
        });
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger02400_CalendarioDeDiasNaoUteis_Controller', Ger02400_CalendarioDeDiasNaoUteis_Controller);
});

// FILE: ./assets/js/controllers/Ger23100_PosicaoFinanceiraCliente_Controller.js
function Ger23100_PosicaoFinanceiraCliente_Controller(General, ScreenService, templateManager) {

	this.fixMinDate = function (widget) {
		var widgetAtiva = templateManager.container.getActiveWidget().name;
		if (widgetAtiva == 'abertas' || widgetAtiva == "baixadas") {
			widget.getField('DTFINAL').minDate = widget.getField('DTINICIAL').value();
		}
		if (widgetAtiva == "filial") {
			widget.getField('DTFIM').minDate = widget.getField('DTINI').value();
		}
	};

	this.filtroCliente = function () {
		var widgetAtiva = templateManager.container.getActiveWidget().name;
		this.filtroPosicaoFinanceira();
		if (widgetAtiva == 'abertas' || widgetAtiva == 'baixadas') {
			this.filtroAbertas();
			this.filtroBaixadas();
		}
		if (widgetAtiva == 'enderecoCliente') {
			this.filtroEnderecoCliente();
		}
		if (widgetAtiva == 'filial') {
			this.filtroFilial();
		}
	};

	this.filtroPosicaoFinanceira = function () {
		var posicaoFinanceira = templateManager.container.getWidget('posicaoFinanceira');
		var cliente = posicaoFinanceira.getParent().currentRow.CDCLIENTE;
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }
        ];

		General.callRestEngine("ped#/crud/contareceber_notafiscal", "FilterData", filtro).then(function (sucesso) {
			var widget = templateManager.container.getWidget('posicaoFinanceira');
			widget.dataSource.data = sucesso.dataset.contareceber_notafiscal;

			this.setForms(widget);
		}.bind(this));
	};

	this.filtroAbertas = function () {
		var widgetAbertas = templateManager.container.getWidget('contas');
		var cliente = widgetAbertas.getParent().currentRow.CDCLIENTE;
		var dtinicial = widgetAbertas.getField('DTINICIAL').value();
		var dtfinal = widgetAbertas.getField('DTFINAL').value();
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }, {
				"name": "P_DTINICIAL",
				"operator": "=",
				"value": dtinicial
            }, {
				"name": "P_DTFINAL",
				"operator": "=",
				"value": dtfinal
            }, {
				"name": "P_TODOS",
				"operator": "=",
				"value": ''
            }
        ];

		General.callRestEngine("ped#/crud/notafiscal_contareceber_boletreceber", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('abertas').dataSource.data = sucesso.dataset.notafiscal_contareceber_boletreceber;
		});

	};

	this.filtroTipoRecebimento = function () {
		var widgetTipoRecebimento = templateManager.container.getWidget('tipoRecebimento');
		var filial = widgetTipoRecebimento.getParent().currentRow.CDFILIAL;
		var vratuarec = widgetTipoRecebimento.getParent().currentRow.VRATUAREC;
		var nrlambolrec = widgetTipoRecebimento.getParent().currentRow.NRLANBOLREC;
		var filtro = [
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            }, {
				"name": "P_VRATUAREC",
				"operator": "=",
				"value": vratuarec
            }, {
				"name": "P_NRLANBOLREC",
				"operator": "=",
				"value": nrlambolrec
            }
        ];

		General.callRestEngine("ped#/crud/tprecboleto_tiporece_boletreceber", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('tipoRecebimento').dataSource.data = sucesso.dataset.tprecboleto_tiporece_boletreceber;
		});

	};

	this.filtroBaixadas = function () {
		var widgetBaixadas = templateManager.container.getWidget('contas');
		var cliente = widgetBaixadas.getParent().currentRow.CDCLIENTE;
		var dtinicial = widgetBaixadas.getField('DTINICIAL').value();
		var dtfinal = widgetBaixadas.getField('DTFINAL').value();
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }, {
				"name": "P_DTINICIAL",
				"operator": "=",
				"value": dtinicial
            }, {
				"name": "P_DTFINAL",
				"operator": "=",
				"value": dtfinal
            }, {
				"name": "P_TODOS",
				"operator": "=",
				"value": ''
            }
        ];

		General.callRestEngine("ped#/crud/notafiscal_boletreceber_baixarecebida", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('baixadas').dataSource.data = sucesso.dataset.notafiscal_boletreceber_baixarecebida;
		});

	};

	this.filtroTipoRecebimentoBaixadas = function () {
		var widgetTipoRecebimentoBaixadas = templateManager.container.getWidget('tipoRecebimentoBaixadas');
		var filial = widgetTipoRecebimentoBaixadas.getParent().currentRow.CDFILIAL;
		var vratuarec = widgetTipoRecebimentoBaixadas.getParent().currentRow.VRATUAREC;
		var nrlambolrec = widgetTipoRecebimentoBaixadas.getParent().currentRow.NRLANBOLREC;
		var filtro = [
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            }, {
				"name": "P_VRATUAREC",
				"operator": "=",
				"value": vratuarec
            }, {
				"name": "P_NRLANBOLREC",
				"operator": "=",
				"value": nrlambolrec
            }
        ];

		General.callRestEngine("ped#/crud/tprecboleto_tiporece_tipobaixarec", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('tipoRecebimentoBaixadas').dataSource.data = sucesso.dataset.tprecboleto_tiporece_tipobaixarec;
		});

	};

	this.setForms = function (widget) {
		widget.currentRow = widget.dataSource.data[0];
	};

	this.filtroEnderecoCliente = function () {
		var widgetEnderecoCliente = templateManager.container.getWidget('tabbedEnderecoCliente');
		var cliente = widgetEnderecoCliente.getParent().currentRow.CDCLIENTE;
		var idtpendeclie = widgetEnderecoCliente.getField('IDTPENDECLIE').value();
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }, {
				"name": "P_IDTPENDECLIE",
				"operator": "=",
				"value": idtpendeclie
            }
        ];

		General.callRestEngine("ped#/crud/endeclie_pais_municipio", "FilterData", filtro).then(function (sucesso) {
			var widget = templateManager.container.getWidget('enderecoCliente');
			widget.dataSource.data = sucesso.dataset.endeclie_pais_municipio;

			this.setForms(widget);
		}.bind(this));

	};

	this.filtroFilial = function () {
		var widgetHistorico = templateManager.container.getWidget('tabbedHistorico');
		var widgetFilial = templateManager.container.getWidget('filial');
		var cliente = widgetHistorico.getParent().currentRow.CDCLIENTE;
		var dtinicial = widgetHistorico.getField('DTINI').value();
		var dtfinal = widgetHistorico.getField('DTFIM').value();
		var filial = widgetFilial.getParent().currentRow.CDFILIAL;
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }, {
				"name": "P_DTINI",
				"operator": "=",
				"value": dtinicial
            }, {
				"name": "P_DTFIM",
				"operator": "=",
				"value": dtfinal
            }, {
				"name": "P_TDATA",
				"operator": "=",
				"value": ''
            }, {
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            }
        ];

		General.callRestEngine("ped#/crud/pedido_vendedor_tipooperac", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('filial').dataSource.data = sucesso.dataset.pedido_vendedor_tipooperac;
		});

	};

	this.filtroContasFilial = function () {
		var widgetHistorico = templateManager.container.getWidget('tabbedHistorico');
		var widgetFilial = templateManager.container.getWidget('filial');
		var cliente = widgetHistorico.getParent().currentRow.CDCLIENTE;
		var dtinicial = widgetHistorico.getField('DTINI').value();
		var dtfinal = widgetHistorico.getField('DTFIM').value();
		var filial = widgetFilial.getParent().currentRow.CDFILIAL;
		var filtro = [
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": cliente
            }, {
				"name": "P_DTINI",
				"operator": "=",
				"value": dtinicial
            }, {
				"name": "P_DTFIM",
				"operator": "=",
				"value": dtfinal
            }, {
				"name": "P_TDATA",
				"operator": "=",
				"value": ''
            }, {
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            }
        ];

		General.callRestEngine("ped#/crud/pedido_notafiscal_contareceber", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('contasFilial').dataSource.data = sucesso.dataset.pedido_notafiscal_contareceber;
		});
	};

	this.filtroInfItensPedidos = function () {
		var widgetFilial = templateManager.container.getWidget('filial');
		var widgetInfItensPedidos = templateManager.container.getWidget('infItensPedidos');
		var nrpedido = widgetInfItensPedidos.getParent().currentRow.NRPEDIDO;
		var filial = widgetFilial.getParent().currentRow.CDFILIAL;
		var filtro = [
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            },
			{
				"name": "P_NRPEDIDO",
				"operator": "=",
				"value": nrpedido
            }
        ];

		General.callRestEngine("ped#/crud/itempedido_cliente_produto", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('infItensPedidos').dataSource.data = sucesso.dataset.itempedido_cliente_produto;
		});

	};

	this.filtroItensPedidos = function () {
		var widgetFilial = templateManager.container.getWidget('filial');
		var widgetInfItensPedidos = templateManager.container.getWidget('infItensPedidos');
		var nrpedido = widgetInfItensPedidos.getParent().currentRow.NRPEDIDO;
		var filial = widgetFilial.getParent().currentRow.CDFILIAL;
		var filtro = [
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": filial
            },
			{
				"name": "P_NRPEDIDO",
				"operator": "=",
				"value": nrpedido
            }
        ];

		General.callRestEngine("ped#/crud/itemproduto_notafiscal_produto", "FilterData", filtro).then(function (sucesso) {
			templateManager.container.getWidget('itensPedidos').dataSource.data = sucesso.dataset.itemproduto_notafiscal_produto;
		});

	};

	this.voltarAbertas = function () {
		ScreenService.goBack();
		var widgetAbertas = templateManager.container.getWidget('abertas');
		widgetAbertas.reload();
	};

	this.voltarBaixadas = function () {
		ScreenService.goBack();
		var widgetBaixadas = templateManager.container.getWidget('baixadas');
		widgetBaixadas.reload();
	};

	this.voltarFilial = function () {
		ScreenService.goBack();
		var widgetFilial = templateManager.container.getWidget('filial');
		widgetFilial.reload();
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger23100_PosicaoFinanceiraCliente_Controller', Ger23100_PosicaoFinanceiraCliente_Controller);
});

// FILE: ./assets/js/controllers/Ger41200_GrupoClientes_Controller.js
function Ger41200_GrupoClientes_Controller(templateManager, ScreenService, General, Ger41200_GrupoClientes_Service) {

}

Configuration(function(ContextRegister){
    ContextRegister.register('Ger41200_GrupoClientes_Controller', Ger41200_GrupoClientes_Controller);
});

// FILE: ./assets/js/controllers/Ger96600_AlvarasLicenciamento_Controller.js
function Ger96600_AlvarasLicenciamento_Controller(templateManager, ScreenService, General, Ger96600_AlvarasLicenciamento_Service) {

    this.newRow = function(widget){
        
        widget.newRow();
        Ger96600_AlvarasLicenciamento_Service.newAlvaraNR().then(function(novoAlvara){
            var newCode = novoAlvara.dataset.newAlvaraNr[0].NOVOCODIGO;
            widget.currentRow.NRALVARA = newCode;
        });
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ger96600_AlvarasLicenciamento_Controller', Ger96600_AlvarasLicenciamento_Controller);
});

// FILE: ./assets/js/controllers/Ped00000_dasboardPedidos_Controller.js
function Ped00000_dasboardPedidos_Controller(templateManager, ScreenService, General, Ped00000_dashboardPedidos_Service, Ped00100_lancamentoPedido_Service, ZHPromise, localStorageEngine) {
    
    var Today = new Date();
    var cdVendedor;
    
    var minDate;
    var maxDate;
    
    this.operador               = [];
    this.filialLogada           = [];
    this.email                  = [];
    this.dadosFilial            = [];
    this.nrorg                  = [];
    this.parametros             = [];
    this.valida                 = true;
    
    var mensagens = [];
    mensagens.operadorNaoVinculado = "Operador não vinculado com um vendedor.";
    mensagens.operadorVinculadoVen = "Operador vinculado.";
    mensagens.campoVazioFiltro = "É necessário preencher todos os campos do filtro.";

    this.BackConfig = function(){
        templateManager.container.getWidget('SettingsPopUp').isVisible = false;
        ScreenService.closePopup();
        
    };
    
    this.changeCharts = function(widget){
        
        if(!widget.currentRow){
            widget.currentRow = widget;
        }
        
        if(widget.currentRow.SitPedSelect === "P"){
            if(templateManager.container.getWidget('pedChart').isVisible === true){
                templateManager.container.getWidget('pedChart').chartSeries["0"].serieType = "pie";
            }
        } else if(widget.currentRow.SitPedSelect === "D"){
            if(templateManager.container.getWidget('pedChart').isVisible === true){
                templateManager.container.getWidget('pedChart').chartSeries["0"].serieType = "donut";
            }
        }
        
        if(widget.currentRow.EvoVenSelect === "B"){
            if(templateManager.container.getWidget('vendEvoChart').isVisible === true){
                templateManager.container.getWidget('vendEvoChart').chartSeries["0"].serieType = "bar";
            }
        } else if(widget.currentRow.EvoVenSelect === "L"){
            if(templateManager.container.getWidget('vendEvoChart').isVisible === true){
                templateManager.container.getWidget('vendEvoChart').chartSeries["0"].serieType = "line";
            }
                
        }
        
        if(widget.currentRow.ConVenSelect === "B"){
            if(templateManager.container.getWidget('ConcluVen').isVisible === true){
                templateManager.container.getWidget('ConcluVen').chartSeries["0"].serieType = "bar";
            }
        } else if(widget.currentRow.ConVenSelect === "L"){
            if(templateManager.container.getWidget('ConcluVen').isVisible === true){
                templateManager.container.getWidget('ConcluVen').chartSeries["0"].serieType = "line";
            }
        }

    };
    
    this.changeShortcut = function(selector1, selector2) {
        var x = document.querySelector(selector1);
        if(x){
            x.style.transform = 'translate(-110px , -110px)';
            x.childNodes[0].style.transform = 'scale(4)';
        
            var y = x.parentElement.innerHTML;
            y = y.replace('width="40px" height="40px"', 'width="120px" height="130px"');
            x.parentElement.innerHTML = y;
        }
        
        var z = document.querySelector(selector2);
        if(z){
            z.style.transform = 'translate(40%, 40%) scale(1.8)';
        }
        
    };
    
    this.Configuration = function(widget){
        
        if(templateManager.container.getWidget('SettingsPopUp').currentRow){
            
            templateManager.container.getWidget('SettingsPopUp').currentRow.Info = "Selecione os gráficos que deseja exibir.";
        
            if(templateManager.container.getWidget('ultVendWidget').isVisible === true){
                templateManager.container.getWidget('SettingsPopUp').currentRow.UltVen = "S";
            } else if(templateManager.container.getWidget('ultVendWidget').isVisible === false){
                templateManager.container.getWidget('SettingsPopUp').currentRow.UltVen = "N";
            } 
            if(templateManager.container.getWidget('pedChart').isVisible === true){
                templateManager.container.getWidget('SettingsPopUp').currentRow.SitPedCheck = "S";
            } else if(templateManager.container.getWidget('pedChart').isVisible === false){
                templateManager.container.getWidget('SettingsPopUp').currentRow.SitPedCheck = "N";
            }
            if(templateManager.container.getWidget('vendEvoChart').isVisible === true){
                templateManager.container.getWidget('SettingsPopUp').currentRow.EvoVenCheck = "S";
            } else if(templateManager.container.getWidget('vendEvoChart').isVisible === false){
                templateManager.container.getWidget('SettingsPopUp').currentRow.EvoVenCheck = "N";
            }
            if(templateManager.container.getWidget('CONTAS_A_RECEBER').isVisible === true){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ContRecCheck = "S";
            } else if(templateManager.container.getWidget('CONTAS_A_RECEBER').isVisible === false){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ContRecCheck = "N";
            }
            if(templateManager.container.getWidget('ConcluVen').isVisible === true){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ConVenCheck = "S";
            } else if(templateManager.container.getWidget('ConcluVen').isVisible === false){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ConVenCheck = "N";
            }
            
            if(templateManager.container.getWidget('pedChart').chartSeries["0"].serieType === "pie"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.SitPedSelect = "P";
            } else if(templateManager.container.getWidget('pedChart').chartSeries["0"].serieType === "donut"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.SitPedSelect = "D";
            } 
            if(templateManager.container.getWidget('vendEvoChart').chartSeries["0"].serieType === "bar"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.EvoVenSelect = "B";
            } else if(templateManager.container.getWidget('vendEvoChart').chartSeries["0"].serieType === "line"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.EvoVenSelect = "L";
            }
            if(templateManager.container.getWidget('ConcluVen').chartSeries["0"].serieType === "bar"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ConVenSelect = "B";
            } else if(templateManager.container.getWidget('ConcluVen').chartSeries["0"].serieType === "line"){
                templateManager.container.getWidget('SettingsPopUp').currentRow.ConVenSelect = "L";
            }
            
            templateManager.container.getWidget('SettingsPopUp').reload();
            
            this.render();
            ScreenService.openPopup(templateManager.container.getWidget('SettingsPopUp'));
               
        }
    };
    
	this.dataSourceConfig = function(){
	   
	   var filter=[
	       {
	            "name": "CDVENDEDOR",
                "operator": "=",
                "value": cdVendedor
	       }
	   ];
	   
	   templateManager.container.getWidget('SettingsPopUp').dataSourceFilter = filter;
	   templateManager.container.getWidget('SettingsPopUp').reload();
	   
	   var widget = templateManager.container.getWidget('SettingsPopUp').dataSource.data[0];
	   
        /*this.changeCharts(widget);
        this.verifyWidgets(widget);*/
	   
	};
    
    this.initiateButtons = function() {
            this.changeShortcut('#masonry-item-26869167325980149931039 > div > span.zh-icon.zh-icon-money-alert.zh-icon-no-border.zh-icon-color-white > svg',
            '#masonry-item-26869167325980149931039 > div > span.shortcut-label.ng-binding');
            this.changeShortcut('#masonry-item-26869167334172459611040 > div > span.zh-icon.zh-icon-money-sign.zh-icon-no-border.zh-icon-color-white > svg',
            '#masonry-item-26869167334172459611040 > div > span.shortcut-label.ng-binding');
            this.changeShortcut('#masonry-item-26869167310466517451041 > div > span.zh-icon.zh-icon-contacts.zh-icon-no-border.zh-icon-color-white > svg',
            '#masonry-item-26869167310466517451041 > div > span.shortcut-label.ng-binding');
            this.changeShortcut('#masonry-item-26869167329643881421042 > div > span.zh-icon.zh-icon-calendar.zh-icon-no-border.zh-icon-color-white > svg',
            '#masonry-item-26869167329643881421042 > div > span.shortcut-label.ng-binding');
    };
    
    this.initiateCharts = function() {
        
        var vendEvoChart = templateManager.container.getWidget("vendEvoChart");
        var currentMonth = Today.getFullYear() + "/" + this.placeZero(Today.getMonth()+1);
        var previousYear = Today.getFullYear()-1 + "/" + this.placeZero(Today.getMonth()+1);
        vendEvoChart.dataSourceFilter = [
            {
                "name": "DTHRLANPED",
    			"operator": "<=",
    			"value": currentMonth
            }, 
            {
                "name": "DTHRLANPED",
    			"operator": ">=",
    			"value": previousYear
            }, 
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": cdVendedor
            }
        ];
        
        currentMonth = this.placeZero(Today.getDate()) + "/" + this.placeZero(Today.getMonth()+1) + "/" + Today.getFullYear();
        previousYear = this.placeZero(Today.getDate()) + "/" + this.placeZero(Today.getMonth()+1) + "/" + (Today.getFullYear()-1);
        
        var pieWidget = templateManager.container.getWidget('pedChart');
        pieWidget.dataSourceFilter = [
            {
                "name": "DTMAX",
    			"operator": "<=",
    			"value": currentMonth
            }, 
            {
                "name": "DTMIN",
    			"operator": ">=",
    			"value": previousYear
            }, 
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": cdVendedor
            }
        ];
        pieWidget.label = "Situação dos Pedidos: " + previousYear + " - " + currentMonth;
        pieWidget.reload();
        
        vendEvoChart.label = "Evolução de Vendas: " + previousYear.substring(3,10) + " - " + currentMonth.substring(3,10);
        vendEvoChart.reload();
        
        minDate = previousYear;
        maxDate = currentMonth;
        
        this.verificaSitPedido();
    
        templateManager.container.getWidget("CONTAS_A_RECEBER").reload();
        
        var monthConcluVen = [];
        for(var i = 0; i < 13; i++){
            monthConcluVen[i] = moment().subtract(1, 'year').add(i,'month').format('MM/YYYY');
        }
        
        var filial = this.dadosFilial[2].CDFILIAL;
        var widgetConcluVen = templateManager.container.getWidget('ConcluVen');
        widgetConcluVen.labelInfo = monthConcluVen[0] + " - " + monthConcluVen[monthConcluVen.length - 1];
        widgetConcluVen.dataSourceFilter =[
            {
                "name": "P_CDFILIAL",
                "operator": "IN",
                "value": filial
            },
            {
                "name": "DATA",
    			"operator": "IN",
    			"value": monthConcluVen
            }
        ];
        widgetConcluVen.reload();
        
    };
    
    this.placeZero = function(number) {
        if(number < 10) {
            return "0" + number;
        } else {
            return number;
        }
    };
    
    this.render = function(){
        
        templateManager.container.getWidget('widgetPrincipal').reload();
        templateManager.container.getWidget('ultVendWidget').reload();
        templateManager.container.getWidget('pedChart').reload();
        templateManager.container.getWidget('vendEvoChart').reload();
        templateManager.container.getWidget('CONTAS_A_RECEBER').reload();
        templateManager.container.getWidget('ConcluVen').reload();
        templateManager.container.getWidget('SettingsPopUp').reload();
        
        setTimeout(function(){
            $('body > span > section > section > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section').scope().grid.render();
        },150);
        
    };
		
	this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
	};
    
    this.SaveConfig = function(widget){
        if(widget.currentRow){
            
            this.verifyWidgets(widget);
            this.changeCharts(widget);
            widget.currentRow.CDVENDEDOR = cdVendedor;
        
            Ped00000_dashboardPedidos_Service.saveData("ped#/info_tela", widget.currentRow);
        
            ScreenService.closePopup();
            this.initiateButtons();
    
        }
    };
    
    this.setVendedor = function() {
        if(cdVendedor) {
            
            var dates = [];
            var vendWidget = templateManager.container.getWidget('ultVendWidget');
            
            var filter = [
                {
                    "name": "DTMAX",
            		"operator": "<=",
            		"value": Today.getDate() + "/" + ((Today.getMonth())+1) + "/" + Today.getFullYear()
                }, 
                {
                    "name": "DTMIN",
            		"operator": ">=",
            		"value": Today.getDate() + "/" + ((Today.getMonth())+1) + "/" + ((Today.getFullYear())-1)
                }, 
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": cdVendedor
                }
            ];
            
            vendWidget.dataSourceFilter = filter;
            vendWidget.reload();
            
            Ped00000_dashboardPedidos_Service.buscaVendas(filter).then(function(success){
                
                if(success.dataset.pedido_cliente.length == 1) {
                    vendWidget.highlight = success.dataset.pedido_cliente[0].DTPEDIDO.substr(0,10);
                } else {
                    for(var i=0; i<success.dataset.pedido_cliente.length; i++) {
                        dates.push(success.dataset.pedido_cliente[i].DTPEDIDO);
                    }
                    
                    if(dates.length>=8) {
                        if(dates[0].substr(0,10) == dates[7].substr(0,10)){
                            vendWidget.highlight = dates[0].substr(0,10);
                        } else {
                            vendWidget.highlight = dates[0].substr(0,10) + " até " + dates[7].substr(0,10);
                        }
                    } else {
                        vendWidget.highlight = dates[0].substr(0,10) + " até " + dates[dates.length - 1].substr(0,10);
                    }
                }
            }.bind(this));
            
            this.initiateCharts();
            this.initiateButtons();
    
        }
    };
    
	this.verificaSitPedido = function(){
        
        if(templateManager.container){
            var contasWidget = templateManager.container.getWidget('CONTAS_A_RECEBER');
        
            if(contasWidget){
            
                var tamanho = contasWidget.dataSource.data.length;
                
                for(var i = 0; i < tamanho; i++){
                
                    if (contasWidget.dataSource.data[i].IDSTATUSPAG === "A") {
                        contasWidget.dataSource.data[i].DSSTATUSPAG = "Vencido";
                    } else if (contasWidget.dataSource.data[i].IDSTATUSPAG === "B") {
                        contasWidget.dataSource.data[i].DSSTATUSPAG = "Baixado";
                    } else if (contasWidget.dataSource.data[i].IDSTATUSPAG === "D") {
                        contasWidget.dataSource.data[i].DSSTATUSPAG = "A vencer";
                    }
                }
            }
        }
    };	
	
    this.verifyOperator = function (container, args) {
       
            if (this.valida) {
                // args.e.preventDefault();
                this.retornaOperadorLogado().then(function (callback) {
                    this.operador = callback[0].CDOPERADOR;
                   
                    this.email = callback[0].DSEMAILOPER;
                    var filter = [
                        {
                            "name": "CDOPERADOR",
                            "operator": "=",
                            "value": this.operador
                        }
                    ];
                    return Ped00100_lancamentoPedido_Service.filtraVendedor(filter);
                }.bind(this)).then(function(callback){
                    if(callback.dataset.vendedor.length && callback.dataset.vendedor.length <= 1){
                        this.vendedor = callback.dataset.vendedor[0];
                        cdVendedor = this.vendedor.CDVENDEDOR;
                        return Ped00100_lancamentoPedido_Service.getLocalVar('CDFILIAL');
                    } else if(!callback.dataset.vendedor.length){
                        ScreenService.showCustomDialog(mensagens.operadorNaoVinculado, 'exclamation', 'exclamation', [{
                            label: ScreenService.i18n("OK"),
                            code: function(){openWindow('product#dashboard');}
                        }]);
                        return ZHPromise.defer().reject(1);
                    } else {
                        ScreenService.showCustomDialog(mensagens.operadorVinculadoVen, 'exclamation', 'exclamation', [{
                            label: ScreenService.i18n("OK"),
                            code: function(){openWindow('product#dashboard');}
                        }]);
                        return ZHPromise.defer().reject(2);
                    }
                }.bind(this)).then(function(callback){
                    this.filialLogada = callback;
                    var filter = [
                        {
                            "name": "CDOPERADOR",
                            "operator": "=",
                            "value": this.operador
                        }
                    ];
                    return Ped00100_lancamentoPedido_Service.filtraFilioper(filter);
                }.bind(this)).then(function(callback){
                    this.dadosFilial = callback.dataset.filioper;
                    var filial = [];
                    if (this.dadosFilial.length > 1) {
                        for (var i = 0; i < this.dadosFilial.length; i++) {
                            filial.push(this.dadosFilial[i].CDFILIAL);
                        }
                    } else {
                        filial = this.dadosFilial[0].CDFILIAL;
                    }
                    var filter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "IN",
                            "value": filial
                        }
                    ];
                    var filterP = [
                        {
                            "name": "CDFILIAL",
                            "operator": "IN",
                            "value": filial
                        }
                    ];
                    var promises = [];
                    promises.push(Ped00100_lancamentoPedido_Service.retornaDadosUnidade(filter));
                    promises.push(Ped00100_lancamentoPedido_Service.findParameters(filterP));
                    return ZHPromise.all(promises);
                }.bind(this)).then(function(callback){
                    if(this.dadosFilial.length > 0){
                        openWindow('ped#ped00000_dashboard_pedidos');
                        this.dadosFilial = callback[0].dataset.filial_empresa_endefili;
                        this.parametros = callback[1].dataset.parampedido;
                        this.valida = false;
                        this.verifyChartsOperator();
                    } else {
                        ScreenService.showCustomDialog('Operador não Vinculado a uma Filial', 'exclamation', 'exclamation', [{
                            label: ScreenService.i18n("OK"),
                            code: function(){openWindow('product#dashboard');}
                        }]);
                    }
                }.bind(this));
            } else {
                this.valida = true;
            }
    };
    
    this.verifyWidgets = function(widget){ 
        
        if(!widget.currentRow){
            widget.currentRow = widget;
        }
        
        var verificaIsVislible = [1,1,1,1,1,1,1,1,1,0];
        
        if(widget.currentRow.UltVen === "N"){
            templateManager.container.getWidget('ultVendWidget').isVisible = false;
            verificaIsVislible[4] = 0;
            templateManager.container.getWidget('ultVendWidget').reload();
        } else if(widget.currentRow.UltVen === "S"){
            templateManager.container.getWidget('ultVendWidget').isVisible = true;
            verificaIsVislible[4] = 1;
            templateManager.container.getWidget('ultVendWidget').reload();
        }
        
        if(widget.currentRow.SitPedCheck === "N"){
            templateManager.container.getWidget('pedChart').isVisible = false;
            verificaIsVislible[5] = 0;
            templateManager.container.getWidget('pedChart').reload();
        } else if(widget.currentRow.SitPedCheck === "S"){
            templateManager.container.getWidget('pedChart').isVisible = true;
            verificaIsVislible[5] = 1;
            templateManager.container.getWidget('pedChart').reload();
        }
        
        if(widget.currentRow.EvoVenCheck === "N"){
            templateManager.container.getWidget('vendEvoChart').isVisible = false;
            verificaIsVislible[7] = 0;
            templateManager.container.getWidget('vendEvoChart').reload();
        } else if(widget.currentRow.EvoVenCheck === "S"){
            templateManager.container.getWidget('vendEvoChart').isVisible = true;
            verificaIsVislible[7] = 1;
            templateManager.container.getWidget('vendEvoChart').reload();
        }
        
        if(widget.currentRow.ContRecCheck === "N"){
            templateManager.container.getWidget('CONTAS_A_RECEBER').isVisible = false;
            verificaIsVislible[6] = 0;
            templateManager.container.getWidget('CONTAS_A_RECEBER').reload();
        } else if(widget.currentRow.ContRecCheck === "S"){
            templateManager.container.getWidget('CONTAS_A_RECEBER').isVisible = true;
            verificaIsVislible[6] = 1;
            templateManager.container.getWidget('CONTAS_A_RECEBER').reload();
        }
        
        if(widget.currentRow.ConVenCheck === "N"){
            templateManager.container.getWidget('ConcluVen').isVisible = false;
            verificaIsVislible[8] = 0;
            templateManager.container.getWidget('ConcluVen').reload();
        } else if(widget.currentRow.ConVenCheck === "S"){
            templateManager.container.getWidget('ConcluVen').isVisible = true;
            verificaIsVislible[8] = 1;
            templateManager.container.getWidget('ConcluVen').reload();
        }
        
        templateManager.container.getWidget('SettingsPopUp').isVisible = false;
        
        setTimeout(function(){
            angular.element('.ng-scope').scope().templateManager.container.getWidget('widgetPrincipal').widgets.forEach(function(element){
                element.isVisible = false;
            });
            if($('body > span > section > section > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section').scope().grid){
                $('body > span > section > section > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section').scope().grid.render();
            }
        },750);
        
        var i = 0;
        
        setTimeout(function(){
            verificaIsVislible.forEach(function(element){
                if(element === 1){
                    templateManager.container.getWidget('widgetPrincipal').widgets[i].isVisible = true;
                    i++;
                } else if(element === 0) {
                    templateManager.container.getWidget('widgetPrincipal').widgets[i].isVisible = false;
                    i++;
                }
            });
            if($('body > span > section > section > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section').scope().grid){
                $('body > span > section > section > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section').scope().grid.render();
            }
        },1500);
        
        setTimeout(function() {
            this.initiateButtons();
        }.bind(this),2000);
        
    };
    
    this.verifyChartsOperator = function(){
        
        Ped00000_dashboardPedidos_Service.getData("ped#/info_tela").then(function(callback){
            if(callback){
                for(var i = 0; i<callback.length; i++){
                    if(callback[i].CDVENDEDOR === cdVendedor){
                        this.verifyWidgets(callback[i]);
                        this.changeCharts(callback[i]);
                    }
                }    
            }
        }.bind(this));
        this.setVendedor();
    };
    
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00000_dasboardPedidos_Controller', Ped00000_dasboardPedidos_Controller);
});

// FILE: ./assets/js/controllers/Ped02700_FatorAjustePreco_Controller.js
function Ped02700_FatorAjustePreco_Controller(templateManager, ScreenService, General) {
    this.geraCodigo = function(){
        var dataSource = templateManager.container.getWidget('fatorAjustePreco').dataSource.data;
        var codigo = 0;
        dataSource.forEach(function(aux){
            if(aux.CDFATPRECO > codigo){
                codigo = aux.CDFATPRECO;
            }        
        });
        codigo ++;
        
        templateManager.container.getWidget('fatorAjustePreco').getField('CDFATPRECO').setValue(codigo);
        templateManager.container.getWidget('fatorAjustePreco').getField('CDFATPRECO').reload();
    };
    
    this.salvar = function(){
        var widget = templateManager.container.getWidget('fatorAjustePreco');
        var data = widget.dataSource.data;
        var siglaIgual = 0;
        var nomeIgual  = 0;
        //data.pop();
        data.forEach(function(aux){
            if(widget.currentRow.SGFATPRECO ==  aux.SGFATPRECO){
                siglaIgual ++;
            }if(widget.currentRow.NMFATPRECO ==  aux.NMFATPRECO){
                nomeIgual  ++;
            }    
        });
        
        if(siglaIgual == 1 && nomeIgual == 1){
            General.saveCrud(widget);
        }else if(siglaIgual == 2){
            ScreenService.showMessage('Sigla já cadastrada.');
        }else if(nomeIgual == 2){
            ScreenService.showMessage('Nome já cadastrado.');
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02700_FatorAjustePreco_Controller', Ped02700_FatorAjustePreco_Controller);
});

// FILE: ./assets/js/controllers/Ped02900_FatorAjusteProduto_Controller.js
function Ped02900_FatorAjusteProduto_Controller(templateManager, ScreenService, General) {
    
    this.changeFilter = function(widget){
        templateManager.container.getWidget('fatorAjusteProduto').dataSourceFilter.push(
        	{
        		"name": "P_CDPRODINIC",
        		"operator": "=",
        		"value": widget.currentRow.P_CDPRODINIC
        	},
            {
        		"name": "P_CDPRODFINA",
        		"operator": "=",
        		"value": widget.currentRow.P_CDPRODFINA
        	}	
        );
        
    };
    
    this.validaFiltro = function(widget, name){
        if(name == 'fatorAjusteProduto'){
            var cdprodinic = widget.currentRow.P_CDPRODINIC;
            var cdprodfina = widget.currentRow.P_CDPRODFINA;
            
            if(cdprodinic > cdprodfina){
                ScreenService.showMessage('Produto inicial deve ser menor ou igual ao produto final.');
                widget.getField('P_CDPRODINIC').setValue('');
                widget.getField('P_CDPRODFINA').setValue('');
                widget.getField('P_CDPRODFINA').readOnly = true;
            }
        }else if(name == 'CadastAutom'){
            var cdarvprodini = widget.currentRow.CDARVPRODINI;
            var cdarvprodfin = widget.currentRow.CDARVPRODFIN;
            
            if(cdarvprodini > cdarvprodfin){
                ScreenService.showMessage('Produto inicial deve ser menor ou igual ao produto final.');
                widget.getField('NMPRODINI').setValue('');
                widget.getField('CDARVPRODINI').setValue('');
                widget.getField('CDARVPRODFIN').setValue('');
                widget.getField('NMPRODFIN').setValue('');
                widget.getField('NMPRODFIN').readOnly = true;
            }
        }    
    };
    
    this.fieldProdFinal = function(widget, name){
        if(name == 'fatorAjusteProduto'){
            widget.getField('P_CDPRODFINA').readOnly = false;    
        }else if(name == 'CadastAutom'){
            widget.getField('NMPRODFIN').readOnly = false; 
        }   
    };
    
    this.cadastramentoAutomatico = function(widget){
        for(var i = 0; i < widget.widgets[0].fields.length; i++){
            widget.widgets[0].fields[i].setValue('');
        }
        ScreenService.openPopup(widget.widgets[0]);
    };
    
    this.salvarCadastramento = function(widget){
        var row = widget.widget.currentRow; 
        
        General.callRestEngine('ped#/realiza_cadastramento', 'Row', row).then(function(callback){
            ScreenService.closePopup();
            templateManager.container.getWidget('fatorAjusteProduto').reload();
            //ScreenService.showMessage("Cadastramento automático realizado com sucesso.");
        }).catch(function(error){
            ScreenService.showMessage(error);
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02900_FatorAjusteProduto_Controller', Ped02900_FatorAjusteProduto_Controller);
});

// FILE: ./assets/js/controllers/Ped07000_agendaVendedorRegiao_Controller.js
function Ped07000_agendaVendedorRegiao_Controller(templateManager, ScreenService, General, Ped07000_agendaVendedorRegiao_Service, MessageService) {
    
    var mensagens = {
        regiaoNull:'É necessário preencher o campo "Região"',
        clienteNull:'É necessário preencher o campo "Clientes"',
        mobileWarning: 'Atenção: Esta tela utiliza do seu pacote de dados.'
    };
    
    //variável que guarda o cdVendedor do vendedor selecionado
    var cdVendedor;
    //variável que guarda a data selecionada no calendário
    var currentDate;
    //variável que guarda uma outra formatação da data selecionada no calendário
    var nCurrentDate;
    //boolean que checa se o calendário previsto está aberto ou não
    var CalendarPrevViewOpen;
    
    this.mobileMessage = function() {
      ScreenService.showMessage("Atenção: Esta tela utiliza do seu pacote de dados.");  
    };
    
    //função que pega a data atual e a retorna formatada
    this.getCurrentDate = function() {
      var Today = new Date(); 
      var TodayFormated = Today.getFullYear() + "-" + this.zeroFill(Today.getMonth()+1) + "-" + Today.getDate();
      return TodayFormated;
    };
    
    //função que colore o calendário de acordo com os registros no banco de dados
    this.colorizeCalendar = function() {
        
        //criando um array e armazenando cdVendedor
        var row = [];
        row.push(cdVendedor);
        
        //requisição que retorna CDVENDEDOR e NRCORREGIAOPED de todos os registros de AgendaVendedor que sejam do cdVendedor selecionado
        Ped07000_agendaVendedorRegiao_Service.buscaCalendarColor(row).then(function(success){
            
            //variável que recebe o widget do calendário
            var calendarWidget = templateManager.container.getWidget("calendar");
            //variável que recebe a primeira 'linha' do calendário por uma seleção de html
            var l = document.querySelector('body > span > section > section.zh-application-content > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > section > div > div > div:nth-child(1) > div:nth-child(4)');
            //verifica se a linha do grid "existe", isto é, se ela está presente na tela.
            if (l) {
                //selecionando todos os dias do mês selecionado em um array
                var all = l.parentElement.parentElement.querySelectorAll('div.day.ng-scope:not(.next-month):not(.previous-month)');
                
                //colore o calendário de branco
                for(var i = 0; i < all.length; i++) {
                    all[i].style.backgroundColor = 'white';
                }
                
                var coloredDates = [];
                
                if(success.dataset.calendar_color.length >= 1) {
                    //variáveis onde serão guardados o texto dos dias e o index do array de dias do calendário 
                    var span;
                    var index;
                    
                    //percorre todos os registros de AgendaVendedor
                    for(i = 0; i < success.dataset.calendar_color.length; i++) {
                        if(!this.checkArray(coloredDates, success.dataset.calendar_color[i].DTAGEVENDREGIAO)) {
                            index = 0;
                            //guarda o registro atualmente selecionado
                            var IRow = success.dataset.calendar_color[i];
                            
                            //pega a data do registro e separa o seu mês
                            var currentDate = success.dataset.calendar_color[i].DTAGEVENDREGIAO;
                            var currentMonth = currentDate.substring(3, 5);
                            
                            //formata o mês caso comece com "0" 
                            if(currentMonth.substring(0,1) == "0") {
                                currentMonth = currentMonth.substring(1,2);
                            }
                            
                            //checa se o mês do registro é igual ao mês selecionado
                            if(currentMonth == (calendarWidget.getMonth()+1)) {
                                //pega o dia do registro
                                var currentDay = currentDate.substring(0,2);
                                
                                //formata o dia caso comece com "0"
                                if(currentDay.substring(0,1) == "0") {
                                    currentDay = currentDay.substring(1,2);
                                }
                                
                                //pega o campo do dia correspondente ao registro no calendário
                                index = parseInt(currentDay)-1;
                                span = all[index].childNodes[1];
                                
                                //array onde são guardadas todas as cores de um dia
                                var colorArray = [];
                                colorArray.push(IRow.NRCORREGIAOPED);
                                
                                //percorre todos os registros novamente em busca de registros com o mesmo dia que o selecionado anteriormente
                                for (var j = 0; j < success.dataset.calendar_color.length; j++) {
            	                    //pega outro registro selecionado
                                	var JRow = success.dataset.calendar_color[j];
                                	//checa se os registros "I" e "J" não são os mesmos
                                	if (i != j) {
                                	    //checa se os registros são do mesmo dia, mas com cores diferentes (de diferentes regiões)
                                		if (JRow.DTAGEVENDREGIAO == IRow.DTAGEVENDREGIAO && this.checkArray(colorArray, JRow.NRCORREGIAOPED) == false) {
                                        	//insere a outra cor no array de cores
                                        	colorArray.push(JRow.NRCORREGIAOPED);
                                		}
                                    }
                                }
                                
                                coloredDates.push(success.dataset.calendar_color[i].DTAGEVENDREGIAO);
                                
                                //colore o campo do dia com as cores da região
                                //caso o dia tenha apenas uma cor
                                if (colorArray.length == 1)  {
                                    all[index].style.backgroundColor = success.dataset.calendar_color[i].NRCORREGIAOPED; 
                                    
                                    //checa se o texto do dia deve ser preto ou branco a partir do brilho da cor
                                    if (this.darkOrLight(colorArray[0]) == "light-text") {
                                        span.style.color = 'white';
                                    } else {
                                        span.style.color = 'black';
                                    }
                                    //caso o dia tenha duas cores   
                                } else if (colorArray.length == 2) {
                                    all[index].style.background = '-webkit-linear-gradient(-45deg, ' + colorArray[0] + ' 50%, ' + colorArray[1] + ' 51%)';
                                
                                    if (this.darkOrLight(colorArray[1]) == "light-text") {
                                        span.style.color = 'white';
                                    } else {
                                        span.style.color = 'black';
                                    }
                                    //caso o dia tenha apenas uma cor
                                } else if (colorArray.length == 3) {
                                    all[index].style.background = '-webkit-linear-gradient(-45deg, ' + colorArray[0] + ' 33%, ' + colorArray[1] + ' 34%, ' + colorArray[1] + ' 66%, ' + colorArray[2] + ' 64%)';
                                    
                                    if (this.darkOrLight(colorArray[1]) == "light-text") {
                                        span.style.color = 'white';
                                    } else {
                                        span.style.color = 'black';
                                    }
                                    //caso o dia tenha quatro ou mais cores, ele não é colorido e é colocado um simbolo nele.
                                } else if (colorArray.length >= 4) {
                                        all[index].style.background = 'white';
                                        span.style.color = 'black';

                                        var plus;
                                        if(colorArray.length >= 10) {
                                            plus = '<div style="transform: scale(0.8) translate(10px, -25px); position: absolute;"><span contenteditable="false" class="pb-icon-plus" style="background: #558854;width: 21px;height: 21px;display: block;position: absolute;top: 15px;left: 9px; border-radius: 50%;"></span>' +
                                            '<span style="position:relative; display: inline-block;color:white;transform: translate(10px, 0px) scale(0.8);">' + 
                                            colorArray.length + '</span></div>';
                                        } else {
                                            plus = '<div style="transform: scale(0.8) translate(10px, -25px); position: absolute;"><span contenteditable="false" class="pb-icon-plus" style="background: #558854;width: 21px;height: 21px;display: block;position: absolute;top: 15px;left: 9px; border-radius: 50%;"></span>' +
                                            '<span style="position:relative; display: inline-block;color:white;transform: translate(14px, 0px);">' + 
                                            colorArray.length + '</span></div>';
                                        }
    
                                        all[index].innerHTML = '<div class="content ng-binding" ng-bind="day.day">'+ (index+1) +'</div>' + plus;
                                }
                                //aplica uma borda branca em todos os dias para que as cores não se "juntem" e polua o calendário
                                all[index].style.border = '6px solid white';
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    //função responsável por colorir o widget de regiões a partir da cor da região
    this.colorize = function(mobile) {
        
        //requisição que retorna todos os registros de RegiaoPed
        Ped07000_agendaVendedorRegiao_Service.searchRegiao().then(function(success){
            //checa se existem registros
            if(success.dataset.regiaoped.length >= 1) {
                
                var l, all;
                if(mobile) {
                    l = document.querySelector('body > span > section > section.zh-application-content > div.default-window.ng-scope > section.everything.ng-scope > div > section > section > section > section > div > section > div > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul > li:nth-child(2)');
                    if(l) all = l.parentElement.querySelectorAll('li.zh-text-default-sans');
                } else {
                //variável que recebe uma linha do grid de regiões
                    l = document.querySelector('#grid-50427524868494582335 > div.body > div > div:nth-child(1) > div:nth-child(1)');
                    if(l) all = l.parentElement.parentElement.querySelectorAll('div.td.zh-standard-column.grid-align-left:not(.ng-hide)');
                }
                //verifica se a linha do grid "existe", isto é, se ela está presente na tela.
                if (l) {
                    //seleciona todos os campos da grid em array excluindo os campos invisíveis
                    if (document.querySelector('#grid-50427524868494582335 > div.header > div > div > div:nth-child(3)')) {
                        document.querySelector('#grid-50427524868494582335 > div.header > div > div > div:nth-child(1)').style.pointerEvents = 'none';
                        document.querySelector('#grid-50427524868494582335 > div.header > div > div > div:nth-child(2)').style.pointerEvents = 'none';
                        document.querySelector('#grid-50427524868494582335 > div.header > div > div > div:nth-child(3)').style.pointerEvents = 'none';
                    }
                    
                    //variáveis onde serão guardados o texto dos campos, o index do array de campos no grid e uma boolean caso seja encontado um campo igual ao pesquisado
                    var span;
                    var index;
                    var found;
                    
                    //percorre todos os registros de RegiaoPed
                    for(var i = 0; i < success.dataset.regiaoped.length; i++) {
                        
                        index = 0;
                        found = true;
                        
                        if(mobile) {
                            span = all[index].childNodes[17].childNodes[1].childNodes[5];
                        } else {
                            //pega o texto do campo selecionado
                            span = all[index].querySelector('span');   
                        }
                        //enquanto o texto do campo não for igual a NRCORREGIAOPED do registro, percorre toda a grid
                        while (span.innerHTML !== success.dataset.regiaoped[i].NRCORREGIAOPED) {
                            
                            //caso chegue ao final do array de campos
                            if(index == (all.length)-1) {
                                found = false;
                                break;
                            }
                            
                            index++;
                            if(mobile) {
                                span = all[index].childNodes[17].childNodes[1].childNodes[5];
                            } else {
                                //pega o texto do campo selecionado
                                span = all[index].querySelector('span');   
                            }
                        }
                        //caso tenha encontrado um campo com a cor do registro
                        if(found) {
                            if(mobile){
                                all[index].childNodes[17].childNodes[1].childNodes[5].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                all[index].childNodes[17].childNodes[1].childNodes[5].style.borderRadius = '5px';
                                span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED;
                            } else {
                                //colore o campo com esta cor
                                all[index].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED;
                          
                            }
                        }
                    }
                }
            }
        }.bind(this));
        
    };
    
    this.colorizeRegiao = function(mobile) {
         //requisição que retorna todos os registros de RegiaoPed
        Ped07000_agendaVendedorRegiao_Service.searchRegiao().then(function(success){
            //checa se existem registros
            if(success.dataset.regiaoped.length >= 1) {
                var l, all;
                if (mobile) {
                    l = document.querySelector('body > span > section > section.zh-application-content > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul > li:nth-child(2)');
                    if(l) all = l.parentElement.querySelectorAll('li.zh-text-default-sans');
                } else {
                    l = document.querySelector('#grid-504275243658601829986 > div.body > div > div:nth-child(1) > div:nth-child(1)');
                    if(l) all = l.parentElement.parentElement.querySelectorAll('div.td.zh-standard-column.grid-align-left:not(.ng-hide)');
                }
                //verifica se a linha do grid "existe", isto é, se ela está presente na tela.
                if (l) {
                    if (all.length>0) {
                        if (document.querySelector('#grid-504275243658601829986 > div.header > div > div > div:nth-child(1)')) {
                            document.querySelector('#grid-504275243658601829986 > div.header > div > div > div:nth-child(1)').style.pointerEvents = 'none';
                            document.querySelector('#grid-504275243658601829986 > div.header > div > div > div:nth-child(2)').style.pointerEvents = 'none';
                            document.querySelector('#grid-504275243658601829986 > div.header > div > div > div:nth-child(3)').style.pointerEvents = 'none';
                        }
                        
                        //variáveis onde serão guardados o texto dos campos, o index do array de campos no grid e uma boolean caso seja encontado um campo igual ao pesquisado
                        var span;
                        var index;
                        var found;
                        
                        //percorre todos os registros de RegiaoPed
                        for(var i = 0; i < success.dataset.regiaoped.length; i++) {
                            
                            index = 0;
                            found = true;
                            
                            if(mobile) {
                                span = all[index].childNodes[17].childNodes[1].childNodes[5];
                            } else {
                                //pega o texto do campo selecionado
                                span = all[index].querySelector('span');   
                            }
                            //enquanto o texto do campo não for igual a NRCORREGIAOPED do registro, percorre toda a grid
                            while (span.innerHTML !== success.dataset.regiaoped[i].NRCORREGIAOPED) {
                                
                                //caso chegue ao final do array de campos
                                if(index == (all.length)-1) {
                                    found = false;
                                    break;
                                }
                                
                                index++;
                                if(mobile) {
                                    span = all[index].childNodes[17].childNodes[1].childNodes[5];
                                } else {
                                    //pega o texto do campo selecionado
                                    span = all[index].querySelector('span');   
                                }
                            }
                            //caso tenha encontrado um campo com a cor do registro
                            if(found) {
                                if(mobile){
                                    all[index].childNodes[17].childNodes[1].childNodes[5].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                    all[index].childNodes[17].childNodes[1].childNodes[5].style.borderRadius = '5px';
                                    span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED;
                                } else {//colore o campo com esta cor
                                    all[index].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                    span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED;
                                }
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    //função responsável por colorir os registros no calendário previsto
    this.colorizeRegister = function(mobile) {
        //mesma coisa das funções anteriores, tendo uma mudança nas variáveis que pegam os campos no HTML
        Ped07000_agendaVendedorRegiao_Service.searchRegiao().then(function(success){
            
            if(success.dataset.regiaoped.length >= 1) {
                var l, all;
                if(mobile) {
                    l = document.querySelector('body > span > section > section.zh-application-content > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open.multiple-swipes > div:nth-child(2) > div:nth-child(3) > section > section > div > section > div > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul > li:nth-child(2)');
                    if(l) all = l.parentElement.querySelectorAll('li.zh-text-default-sans');
                } else {
                    l = document.querySelector('body > span > section > section.zh-application-content > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open.multiple-swipes > div:nth-child(2)'); 
                    if(l) all = l.querySelectorAll('div.td.zh-standard-column.grid-align-left:not(.grid-group-footer)');                
                }  
                //verifica se a linha do grid "existe", isto é, se ela está presente na tela.
                if (l) {
                    
                    var index;
                    
                    if (success.dataset.regiaoped.length >= 1) {
                        for(var i = 0; i < success.dataset.regiaoped.length; i++) {
                            for (var j = 0; j <= all.length-1; j++) {
                                index = j;
                                if (mobile) {
                                    if (all[index].childNodes[11].childNodes[1].childNodes[5].innerHTML == success.dataset.regiaoped[i].NMREGIAOPED) {
                                        all[index].childNodes[11].childNodes[1].childNodes[5].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED;
                                        if (this.darkOrLight(success.dataset.regiaoped[i].NRCORREGIAOPED) == "light-text") {
                                            all[index].childNodes[11].childNodes[1].childNodes[5].style.color = 'white';
                                        } else {
                                            all[index].childNodes[11].childNodes[1].childNodes[5].style.color = 'black';
                                        }
                                    }
                                } else {
                                    if (all[index].querySelector('span').innerHTML == success.dataset.regiaoped[i].NMREGIAOPED) {
                                        all[index].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED;
                                        if (this.darkOrLight(success.dataset.regiaoped[i].NRCORREGIAOPED) == "light-text") {
                                            all[index].querySelector('span').style.color = 'white';
                                        } else {
                                            all[index].querySelector('span').style.color = 'black';
                                        }
                                    }   
                                }
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    //função responsável por colorir o popUp de regiões no cadastro de visitas do vendedor
    this.colorizePopup = function(mobile) {
        //mesma coisa das funções anteriores, tendo uma mudança nas variáveis que pegam os campos no HTML
        Ped07000_agendaVendedorRegiao_Service.searchRegiao().then(function(success){
            
            if(success.dataset.regiaoped.length >= 1) {
                var l, all;
                if(mobile) {
                    l = document.querySelector('#popup > span > section > section > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul > li:nth-child(2)');
                    if(l) all = l.parentElement.querySelectorAll('li.zh-text-default-sans');
                } else {
                    l = document.querySelector('#grid-0 > div.body > div > div:nth-child(1)');
                    if(l) all = l.parentElement.parentElement.querySelectorAll('div.td.zh-standard-column.grid-align-left:not(.ng-hide)');                    
                }

                var span;
                var index;
                var found = true;
                
                if (l) {
                    if(!mobile) {
                        document.querySelector('#grid-0 > div.header > div > div > div:nth-child(1)').style.pointerEvents = 'none';
                        document.querySelector('#grid-0 > div.header > div > div > div:nth-child(2)').style.pointerEvents = 'none';
                        document.querySelector('#grid-0 > div.header > div > div > div:nth-child(3)').style.pointerEvents = 'none';   
                    }
                    
                    if (all.length>0) {
                        for(var i = 0; i < success.dataset.regiaoped.length; i++) {
                            
                            index = 0;
                            found = true;
                            
                            if(mobile) {
                                span = all[index].childNodes[17].childNodes[1].childNodes[5];
                            } else {
                                //pega o texto do campo selecionado
                                span = all[index].querySelector('span');   
                            }
                            while (span.innerHTML !== success.dataset.regiaoped[i].NRCORREGIAOPED) {
                                
                                if(index == all.length-1) {
                                    found = false;
                                    break;
                                }
                                
                                index++;
                                if(mobile) {
                                    span = all[index].childNodes[17].childNodes[1].childNodes[5];
                                } else {
                                    //pega o texto do campo selecionado
                                    span = all[index].querySelector('span');   
                                }
                            }
                            
                            if(found) {
                                if(mobile){
                                    all[index].childNodes[17].childNodes[1].childNodes[5].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                    all[index].childNodes[17].childNodes[1].childNodes[5].style.borderRadius = '5px';
                                    span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED;
                                } else {
                                    all[index].style.backgroundColor = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                    span.style.color = success.dataset.regiaoped[i].NRCORREGIAOPED; 
                                }
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    this.checkOpenSwipe = function(args) {
        if (ScreenService.isSwipeOpen()) {
            args.e.preventDefault();
        }
    };
     
    //função que abre o widget de calendário
    this.openCalendar = function(widget) {
            var TabbedCalendarWidget = templateManager.container.getWidget("tabbedCalendario");
            var calendarWidget = templateManager.container.getWidget("calendar");
            calendarWidget.currentDate = this.getCurrentDate();
            //armazena o vendedor selecionado
            cdVendedor = widget.currentRow.CDVENDEDOR;
            
            calendarWidget.actions[0].isVisible = true;
            ScreenService.openSwipe(TabbedCalendarWidget);
    };
    
    //função que fecha o widget de calendário
    this.closeCalendar = function() {
        var TabbedCalendarWidget = templateManager.container.getWidget("tabbedCalendario");
        var calendarWidget = templateManager.container.getWidget("calendar");
        
        calendarWidget.actions[0].isVisible = false;
        ScreenService.closeSwipe(0);
    };
    
    //função que abre o widget do calendário previsto
    this.openCalendarPrevView = function(widget) {
        //armazena a data selecionada
        currentDate = widget.currentRow;
        currentDate = currentDate.split("-");
        //formata uma nova data a partir da primeira
        nCurrentDate = currentDate[2] + "/" + currentDate[1] + "/" + currentDate[0];
        nCurrentDate = nCurrentDate + " 00:00:00";
        
        //cria um filtro para a grid do dia selecionado
        var filter = [{
            "name": "DTAGEVENDREGIAO",
			"operator": "=",
			"value": nCurrentDate
        }, {
            "name": "CDVENDEDOR",
			"operator": "=",
			"value": cdVendedor
        }];
        
        var TabDiaWidget = templateManager.container.getWidget("tabbedCalendario2");
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        
        //escreve na label do widget o dia e o mês selecionado e aplica o filtro criado
        diaWidget.label = "Dia " + currentDate[2] + " de " + this.getMonth(currentDate[1]) + " de " + currentDate[0];
        diaWidget.actions[1].isVisible = true;
        diaWidget.dataSourceFilter = filter;
        
        ScreenService.openSwipe(TabDiaWidget);
        CalendarPrevViewOpen = true;
        
        //busca nos registros de AgendaVendedor se já existe algo agendado para este dia
        Ped07000_agendaVendedorRegiao_Service.searchPrevData().then(function(success){
            
            var found = false;
            
            if(success.dataset.agendavendedor_regiaoped_cliente.length != 0) {
                for(var i = 0; i < success.dataset.agendavendedor_regiaoped_cliente.length; i++) {
                    if (success.dataset.agendavendedor_regiaoped_cliente[i].CDVENDEDOR == cdVendedor && success.dataset.agendavendedor_regiaoped_cliente[i].DTAGEVENDREGIAO == nCurrentDate) {
                        found = true;
                        break;
                    }
                }
            }
            
            //se não existir, abre o cadastro de agendamento para este dia
            if(!found) {
                this.openCalendarAdd();
            }
            
        }.bind(this));
    };
    
    //função responsável por atualizar os filtros dos campos de região e cliente na tela de cadastro e edição de agendamento
    this.interactCalendarPrevView = function() {
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        var regiaoField = diaWidget.getField("NMREGIAOPED");
        var clienteField = diaWidget.getField("NMRAZSOCCLIE");
        var row = diaWidget.currentRow;
        var filter = [{
             "name": "CDVENDEDOR",
             "operator": "=",
             "value": cdVendedor
        }];
        regiaoField.dataSourceFilter = filter;
        
        filter = [{
             "name": "CDREGIAOPED",
             "operator": "=",
             "value": row.CDREGIAOPED
        }];
        
        clienteField.dataSourceFilter = filter;
        diaWidget.reload();
    };
    
    //função responsável por fechar a widget de calendário previsto
    this.closeCalendarPrevView = function() {
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        var calendarWidget = templateManager.container.getWidget("calendar");
        
        calendarWidget.actions[0].isVisible = true;
        diaWidget.actions[1].isVisible = false;
        ScreenService.closeSwipe();
        
        //checa se o calendário previsto estava aberto anteriormente
        if(CalendarPrevViewOpen) {
            //colore o calendário novamente para atualizá-lo
            this.colorizeCalendar();
        }
        CalendarPrevViewOpen = false;
    };
    
    this.InteractPedidos = function() {
        var pedidos = templateManager.container.getWidget("pedidosWidget");
        var calendarprev = templateManager.container.getWidget("calendarPrevView");
        
        pedidos.dataSourceFilter[0].value = cdVendedor;
        pedidos.dataSourceFilter[1].value = calendarprev.currentRow.CDCLIENTE;
        pedidos.dataSourceFilter[2].value = nCurrentDate.substr(0,10);
        pedidos.reload();
    };
    
    //função responsável por abrir o widget de cadastro de agendamento do calendário previsto
    this.openCalendarAdd = function() {
        var calendarAddWidget = templateManager.container.getWidget("calendarPrevAdd");
        var regiaoField = calendarAddWidget.getField("NMREGIAOPED");
        var clienteField = calendarAddWidget.getField("NMCLIENTES");
        
        var filter = [{
             "name": "CDVENDEDOR",
             "operator": "=",
             "value": cdVendedor
         }];
        
        //abre o widget pronto para o cadastro e iguala seus campos de data e cdVendedor aos valores que foram selecionados anteriormente
        ScreenService.openSwipe(calendarAddWidget);
        calendarAddWidget.newRow();
        calendarAddWidget.currentRow.DTAGEVENDREGIAO = nCurrentDate;
        calendarAddWidget.currentRow.CDVENDEDOR = cdVendedor;
         
        calendarAddWidget.actions[0].isVisible = true;
        calendarAddWidget.actions[1].isVisible = true;
        
        regiaoField.dataSourceFilter = filter;
        clienteField.readOnly = true;
    };
    
    //função responsável por salvar o registro no banco de dados
    this.ConfirmCalendarAdd = function() {
        var calendarAddWidget = templateManager.container.getWidget("calendarPrevAdd");
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        var checkedClientes = calendarAddWidget.currentRow.CDCLIENTES;
        calendarAddWidget.currentRow.CDVENDEDOR = cdVendedor;
        calendarAddWidget.currentRow.DTAGEVENDREGIAO = nCurrentDate.substring(0, 10);
        
        //variáveis para caso já existam registros iguais
        var found = false;
        var existingClientes = [];
        var clientesString = "";
        
        if (!calendarAddWidget.currentRow.NMREGIAOPED) {
            ScreenService.showMessage("É necessário preencher o campo \"Região\"");
        } else  if (calendarAddWidget.currentRow.CDCLIENTES) {
            //requisição que retorna todos os registros de AgendaVendedor
            Ped07000_agendaVendedorRegiao_Service.searchPrevData().then(function(success){
                //guarda a currentRow do widget
                var WcurrentRow = calendarAddWidget.currentRow;    
                
                //percorre todos os registros de AgendaVendedor
                for(var i = 0; i < success.dataset.agendavendedor_regiaoped_cliente.length; i++) {
                    //guarda a currentRow do registro
                    var RcurrentRow = success.dataset.agendavendedor_regiaoped_cliente[i];
                    
                    //checa se o registro é igual à currentRow do widget
                    for(var j = 0; j < WcurrentRow.CDCLIENTES.length; j++) {
                        if(RcurrentRow.CDVENDEDOR == WcurrentRow.CDVENDEDOR && 
                           RcurrentRow.DTAGEVENDREGIAO.substring(0,10) == WcurrentRow.DTAGEVENDREGIAO && 
                           RcurrentRow.CDCLIENTE == WcurrentRow.CDCLIENTES[j]) {
                            found = true;
                            existingClientes.push(WcurrentRow.NMCLIENTES[j]);
                        }
                    }
                }
                //caso o registro já exista
                if (found) {
                    //é feita uma strng que exibe quais os registros já existem e são iguais ao que está tentando inserir
                    clientesString = "'" + existingClientes[0] + "'";
                    for (i = 1; i < checkedClientes.length; i++) {
                        
                        if(i == checkedClientes.length-1) {
                            clientesString += " e '" + existingClientes[i] + "'";
                        } else {
                            clientesString += ", '" + existingClientes[i] + "'";
                        }
                    }
                    
                    //organiza e exibe a string
                    if (existingClientes.length > 1) {
                        //ScreenService.showMessage("Os clientes " + clientesString + " já foram visitados por este vendedor nesta data.");
                        
                        var var_clientes_visitados = "CLIENTES_VISITADOS";
                        MessageService.showMessageByCode(var_clientes_visitados,{"CLIENTES": clientesString});
                        return 0;
                    } else {
                        //ScreenService.showMessage("O cliente " + clientesString + " já foi visitado por este vendedor nesta data.");
                        
                        var var_cliente_visitado = "CLIENTE_VISITADO";
                        MessageService.showMessageByCode(var_cliente_visitado,{"CLIENTE": clientesString});
                        return 0;
                    }
                } else {
                    //organizando os dados para serem inseridos
                    calendarAddWidget.currentRow.__table_pk = 'NRSEQAGEVEND';
                    calendarAddWidget.currentRow.__is_new_code = true;
                    calendarAddWidget.currentRow.__new_code_length = 4;
                    calendarAddWidget.currentRow.__columns_to_return = new Array("NRSEQAGEVEND");
                    calendarAddWidget.currentRow.__new_code_pk = 'AGENDAVENDEDOR'+General.getFieldValue('CDVENDEDOR', 'widgetVendedores')+General.getFieldValue('DTAGEVENDREGIAO', 'calendarPrevAdd')+General.getFieldValue('CDREGIAOPED', 'calendarPrevAdd');
                    
                    //requisição que insere os dados em AgendaVendedor
                    Ped07000_agendaVendedorRegiao_Service.saveCliente(calendarAddWidget.currentRow).then(function() {
    
                        calendarAddWidget.actions[0].isVisible = false;
                        calendarAddWidget.actions[1].isVisible = false;
                        ScreenService.closeSwipe();
                        templateManager.container.getWidget("calendarPrevView").activate();
                        templateManager.container.getWidget("calendarPrevView").reload();
                    });
                }
            });
        } else {
            ScreenService.showMessage("É necessário preencher o campo \"Clientes\"");
        }
        
        regiaoFieldPrev = "";
    };
    
    //função responsável por cancelar e fechar o cadastro de agendamentos no calendário previsto
    this.closeCalendarAdd = function() {
        var calendarAddWidget = templateManager.container.getWidget("calendarPrevAdd");
        
        calendarAddWidget.actions[0].isVisible = false;
        calendarAddWidget.actions[1].isVisible = false;
        ScreenService.closeSwipe();
        templateManager.container.getWidget("calendarPrevView").activate();
        templateManager.container.getWidget("calendarPrevView").reload();
        regiaoFieldPrev = "";
   
    };
    

    var regiaoFieldPrev = "";
    //função responsável por "destravar" o campo de seleção de clientes nas telas de cadastro e edição de agendamento
    this.unlockCliente = function() {
        var calendarAddWidget = templateManager.container.getWidget("calendarPrevAdd");
        var regiaoField = calendarAddWidget.getField("NMREGIAOPED");
        var clienteField = calendarAddWidget.getField("NMCLIENTES");
        var cdClienteField = calendarAddWidget.getField("CDCLIENTES");
        
        if(regiaoFieldPrev !== regiaoField.value()){
            clienteField.value("");
            cdClienteField.value("");
        }
         
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        var clienteViewField = diaWidget.getField("NMRAZSOCCLIE");
        var cdClienteViewField = diaWidget.getField("CDCLIENTE");
        
        var row = calendarAddWidget.currentRow;
        clienteField.readOnly = !row.CDREGIAOPED;
        if (!row.CDREGIAOPED) {
            clienteField.clearValue();
            clienteViewField.clearValue();
        }
        var filter = [{
             "name": "CDREGIAOPED",
             "operator": "=",
             "value": row.CDREGIAOPED
        }];
        
        clienteField.dataSourceFilter = filter;
        row = diaWidget.currentRow;
        clienteViewField.readOnly = !row.CDREGIAOPED;
        if (!row.CDREGIAOPED) {
            clienteViewField.clearValue();
            cdClienteViewField.clearValue();
        }
        filter = [{
             "name": "CDREGIAOPED",
             "operator": "=",
             "value": row.CDREGIAOPED
        }];
        clienteViewField.dataSourceFilter = filter;
        
        regiaoFieldPrev = regiaoField.value();
        
    };
    
    
    this.FilterRegiao = function(widget) {
        widget.currentRow.CDVENDEDOR = cdVendedor;
        widget.dataSourceFilter = [
            {
                name: "CDVENDEDOR",
                operator: "=",
                value: cdVendedor
            }
        ];
        widget.reload();
    };
    
    //função responsável por retornar o nome de um mês a partir de um número
    this.getMonth = function(number) {
        switch(number) {
            case "01":
                return "Janeiro";
            case "02":
                return "Fevereiro";
            case "03":
                return "Março";
            case "04":
                return "Abril";
            case "05":
                return "Maio";
            case "06":
                return "Junho";
            case "07":
                return "Julho";
            case "08":
                return "Agosto";
            case "09":
                return "Setembro";
            case "10":
                return "Outubro";
            case "11":
                return "Novembro";
            case "12":
                return "Dezembro";
        }
    };
    
    //função responsável por colocar um "0" atrás do número
    this.zeroFill = function(number) {
    	if (number<10) {
    		return "0" + number;
        } else return number;
    };
    
    //funções responsáveis por traduzir Hexadecimal para RGB
    this.cutHex = function(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h;};
    this.hexToR = function(h) {return parseInt((this.cutHex(h)).substring(0,2),16);};
    this.hexToG = function(h) {return parseInt((this.cutHex(h)).substring(2,4),16);};
    this.hexToB = function(h) {return parseInt((this.cutHex(h)).substring(4,6),16);};
	
	//função responsável por checar o brilho da cor e retornar se o texto por cima dela deve ser preto ou branco
	this.darkOrLight = function(hex) {
        var red = this.hexToR(hex);
        var green = this.hexToG(hex);
        var blue = this.hexToB(hex);
        
        var brightness;
        brightness = (red * 299) + (green * 587) + (blue * 114);
        brightness = brightness / 255000;
        
        // values range from 0 to 1
        // anything greater than 0.5 should be bright enough for dark text
        if (brightness >= 0.5) {
        return "dark-text";
        } else {
        return "light-text";
        }
    };
    
    //função responsável por traduzir RGB para Hexadecimal
	this.rgbToHex = function (field) {
		var r = field.value()._r;
		var g = field.value()._g;
		var b = field.value()._b;
	    var Hex =  "#" + ((1 << 24) + (Math.floor(r) << 16) + (Math.floor(g) << 8) + Math.floor(b)).toString(16).slice(1);
		field.value(Hex);
	};	
    
    //função responsável por colorir o campo do color picker
    this.setCicloColor = function(element, row,fieldName){
	    if (row) {
            if(element.hasClass('zh-span-field ng-scope')){
            	element.find('p').css('background-clip','content-box');
            	element.find('p').css('background-color', row[fieldName]);
            	element.find('p').css('color', row[fieldName]);
            }
            else if(element.hasClass('td zh-standard-column  grid-align-left')) {
            	element.find('p').css('background-clip','content-box');
            	element.find('span').css('background-color', row[fieldName]);
            	element.find('span').css('color', row[fieldName]);
            }
		    
	    }        
    };    
    
    //função que re-carrega um field a partir de seu nome
    this.reloadWidget = function(args, fieldName) {
        var field = args.owner.field.widget.getField(fieldName);
        field.reload();
    };
    
    //função que recarrega um widget
    this.directReload = function(widget) {
        widget.reload();
    };
    
    //função geral para editar
    this.edit = function(widget) {
        widget.edit();
    };
    
    //função geral para cancelar uma edição
    this.cancelEdit = function(widget, reload) {
       if(this.formChangeTemplate(widget) && widget.parent) {
            var widgets = widget.parent.widgets;

            this.changeWidgetAcessibility(widgets.concat(widget.parent), true);
        } else this.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            if(reload) widget.reload();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
            if(reload) widget.reload();
        }
        
        regiaoFieldPrev = "";
    };
    
    //função para cancelar uma edição que involva cores
    this.cancelColorEdit = function(widget) {
        if(this.formChangeTemplate(widget) && widget.parent) {
            var widgets = widget.parent.widgets;

            this.changeWidgetAcessibility(widgets.concat(widget.parent), true);
        } else this.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            this.colorize(widget);
            widget.reload();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            this.colorize(widget);
            widget.reload();
            widget.view();
        }
    };
    
    //função geral para salvar
    this.saveRow = function(widget) {
        General.saveCrud(widget);
        regiaoFieldPrev = "";
        widget.reload();
        widget.view();
    };
    
    //função geral para criar uma adição de row
    this.newRow = function(widget) {
        widget.newRow();
    };
    
    //Correção de erro no mobile
    this.newRowVendedor = function(widget) {
        widget.newRow();
        widget.currentRow.CDVENDEDOR = widget.dataSourceFilter.find(function findVendedor(data){
	        return data.name == 'CDVENDENDOR';
	    }).value;
    };
    
    //função geral para voltar um swipe
    this.back = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };
    
    //função geral para voltar um swipe e recarregar a tela
    this.backReload = function(widget) {
        ScreenService.closeSwipe();
        widget.reload();
    };
    
    //função geral para deletar um registro e recarregar a tela
    this.deleteReload = function(args) {
        var diaWidget = templateManager.container.getWidget("calendarPrevView");
        General.deleteCrud(args.owner.widget);
        diaWidget.view();
        diaWidget.reload();
    };
    
    //função que checa se um valor está num Array
    this.checkArray = function(array,value){

        var isInArray = false;
        array.forEach(function(c){
            if(c === value){
                isInArray = true;
            }
        });
        return isInArray;
    };

    //função geral para mudar a template
    this.formChangeTemplate = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };
    
    //função geral para mudar a acessibilidade de um widget
    this.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped07000_agendaVendedorRegiao_Controller', Ped07000_agendaVendedorRegiao_Controller);
});

// FILE: ./assets/js/controllers/Ped07700_ParametrizacaoClientesPedidos_Controller.js
function Ped07700_ParametrizacaoClientesPedidos_Controller(templateManager, ZHPromise, ScreenService, General, Ped07700_ParametrizacaoClientesPedidos_Service, ZhFilterPreferences, PedGeral_Utility, MessageService) {

    var cdCliente;
    var checkedFields = [];
    
    this.getCliente = function(widget) {
        cdCliente = widget.getField('CDCLIENTE').value();
    };
    
    this.startFiltering = function(widgetPedidos){
        ZhFilterPreferences.setOriginalFilter(widgetPedidos.id);
        ZhFilterPreferences.openFilterWidget(widgetPedidos);
    };

    this.openExport = function(args) {
        var ProdutoWidget = templateManager.container.getWidget('precosCliente');
        
        var ProdutoNull = false;
        var ProdutoCount = 0;
        var ProdutosNameArray = [];
        var ProdutosNameString = "";
        
        checkedFields[0] = ProdutoWidget.getCheckedRows();
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for (var i = 0; i < checkedFields[0].length; i++) {
                if(checkedFields[0][i].CDCLIENTE == null) {
                    ProdutoNull = true;
                    ProdutoCount++;
                    ProdutosNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ProdutoNull) {
                
                ProdutosNameString = "'" + ProdutosNameArray[0] + "'";
                
                for (i = 1; i < ProdutosNameArray.length; i++) {
                    
                    if(i == ProdutosNameArray.length-1) {
                        ProdutosNameString += " e '" + ProdutosNameArray[i] + "'";
                    } else {
                        ProdutosNameString += ", '" + ProdutosNameArray[i] + "'";
                    }
                }
                
                if (ProdutoCount > 1) {
                    //ScreenService.showMessage("Os produtos " + ProdutosNameString + " não possuem preço.");
                  
                    var var_produtos_sem_preco = "PRODUTOS_SEM_PRECO";
                    MessageService.showMessageByCode(var_produtos_sem_preco,{"NMPRODUTOS": ProdutosNameString });
                    return 0;
                } else {
                    //ScreenService.showMessage("O produto " + ProdutosNameString + " não possui preço.");
                   
                    var var_produto_sem_preco = "PRODUTO_SEM_PRECO";
                    MessageService.showMessageByCode(var_produto_sem_preco,{"NMPRODUTO": ProdutosNameString});
                    return 0;
                }
            } else {
                var newWidget = templateManager.container.getWidget("exportCliente_popup");
                ScreenService.openPopup(newWidget);
                newWidget.isVisible = true;
            }
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();  
    };
    
    this.exportPrecos = function(args) {
        //chamando o backend a partir do service e do repository
        
        var ClienteWidget = templateManager.container.getWidget('exportCliente_popup');
        
        checkedFields[1] = ClienteWidget.getCheckedRows();
        
        Ped07700_ParametrizacaoClientesPedidos_Service.exportPrecosCliente(checkedFields).then(function() {
            ScreenService.showMessage("Preços importados com sucesso.");
            ScreenService.closePopup();  
        });
    };
    
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        this.prodFin(widget);
    };
    
    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('precosCliente');
        
        if(row.NMPRODFIN){
            if(row.P_CDPRODINI > row.P_CDPRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_CDPRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_CDPRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.FilterProdFin = function(args) {
        var row = args.owner.field.widget.currentRow;
        var prod_ini =  parseInt(args.owner.field.widget.getField('P_CDPRODINI').value());
        var prod_fin =  parseInt(args.owner.field.widget.getField('P_CDPRODFIN').value());
        
        args.owner.field.widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        args.owner.field.widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        
        if(row.NMPRODINI == false) {
            args.owner.field.widget.getField('NMPRODFIN').clearValue();
            args.owner.field.widget.getField('P_CDPRODFIN').clearValue();
            templateManager.container.getWidget('precosCliente').dataSourceFilter[1].value = prod_ini;
            templateManager.container.getWidget('precosCliente').dataSourceFilter[2].value = prod_fin;
            templateManager.container.getWidget('precosCliente').reload();
        }
        
        args.owner.field.widget.getField('NMPRODFIN').dataSourceFilter[0].value = prod_ini;
        args.owner.field.widget.getField('NMPRODFIN').reload();
        templateManager.container.getWidget('precosCliente').reload();
    };
    
    this.FilterProd = function(args) {
        var row = args.owner.field.widget.currentRow;
        var prod_ini =  parseInt(args.owner.field.widget.getField('P_CDPRODINI').value());
        var prod_fin =  parseInt(args.owner.field.widget.getField('P_CDPRODFIN').value());
        
        templateManager.container.getWidget('precosCliente').dataSourceFilter[1].value = prod_ini;
        templateManager.container.getWidget('precosCliente').dataSourceFilter[2].value = prod_fin;
        templateManager.container.getWidget('precosCliente').reload();
    };
    
    this.reloadWidget = function(args, fieldName) {
        var field = args.owner.field.widget.getField(fieldName);
        field.reload();
    };
    
    this.precoFilter = function(widget) {
        var gridPrecoCli = templateManager.container.getWidget("precosCliente");
        var gridPreco = templateManager.container.getWidget("precos");
        
        gridPreco.dataSourceFilter[0].value = cdCliente;
        gridPrecoCli.dataSourceFilter[0].value = cdCliente;
        gridPreco.reload();
        gridPrecoCli.reload();
    };
    
    this.createMinDate = function(args) {
        var row = args.owner.field.widget.currentRow;
        var Data = args.owner.field.widget.getField('DTVALINI').value();
        
        args.owner.field.widget.getField('DTVALFIN').minDate = Data;
        args.owner.field.widget.getField('DTVALFIN').readOnly = !row.DTVALINI;
        args.owner.field.widget.getField('DTVALFIN').readOnlyOnEdit = !row.DTVALINI;
        
        if(!row.DTVALINI) {
            args.owner.field.widget.getField('DTVALFIN').setValue('');
        }
    };
    
    this.unlockDia = function(args) {
        var row = args.owner.field.widget.currentRow;
        
        if (args.owner.field.widget.getField('IDPFINAPRPED').value()== 1) {
            args.owner.field.widget.getField('NRDIAPFINAPR').readOnly = true;
            args.owner.field.widget.getField('NRDIAPFINAPR').readOnlyOnEdit = true;
            args.owner.field.widget.getField('NRDIAPFINAPR').clearValue();
        } else {
            args.owner.field.widget.getField('NRDIAPFINAPR').readOnly = !row.IDPFINAPRPED;
            args.owner.field.widget.getField('NRDIAPFINAPR').readOnlyOnEdit = !row.IDPFINAPRPED;
        }
    };
    
    this.diaLockCheck = function(widget) {
        if(widget.getField('IDPFINAPRPED').value() == 2 || widget.getField('IDPFINAPRPED').value() == 3) {
            widget.getField('NRDIAPFINAPR').readOnly = false;
            widget.getField('NRDIAPFINAPR').readOnlyOnEdit = false;
        } else {
            widget.getField('NRDIAPFINAPR').readOnly = true;
            widget.getField('NRDIAPFINAPR').readOnlyOnEdit = true;
        }
    };
    
    this.removePrecoMask = function(widget) {
        var gridPrecoCli = templateManager.container.getWidget("precosCliente");
        var Preco = gridPrecoCli.getField('VRPRECOPROD').value();
        
        if(typeof Preco === 'number') Preco = Preco.toString();
        Preco = Preco.split('.').join('');
        Preco = Preco.replace(',', '.');
        
        gridPrecoCli.currentRow.CDCLIENTE = cdCliente;
        
        gridPrecoCli.currentRow.VRPRECOPROD = Preco;
        
        General.saveCrud(widget).then(function() {
            widget.activate();
            widget.reload();
            ScreenService.closeSwipe();
            // widget.list();
            templateManager.updateTemplate();
        });
    };
    
    this.editPreco  = function(widget) {
        
        var gridPreco = templateManager.container.getWidget("precosCliente");
        var cdProd = widget.getField('CDPRODUTO').value();
        var cdArvProd = widget.getField('CDARVPROD').value();
        var nomeProd = widget.getField('NMPRODUTO').value();
        
        if(!gridPreco.currentRow.CDCLIENTE) {
            widget.newRow();
            widget.currentRow.CDCLIENTE = cdCliente;
            widget.currentRow.CDPRODUTO = cdProd;
            widget.currentRow.CDARVPROD = cdArvProd;
            widget.currentRow.NMPRODUTO = nomeProd;
            widget.reload();
        } else {
            General.edit(widget);  
        }
        
    };
    
    this.saveTabela = function(widget) {
        
        var gridTabela = templateManager.container.getWidget("precos");
        gridTabela.currentRow.CDCLIENTE = cdCliente;
        
        if(gridTabela.currentRow.IDPRBASEPRIN == "S") {
            
            var filter = [
                {
                    "name": "CDCLIENTE",
                    "operator": "=",
                    "value": cdCliente
                }
            ];
            
            Ped07700_ParametrizacaoClientesPedidos_Service.searchTabela(filter).then(function(success){
            
                for(var i = 0; i < success.dataset.precobasecli_precobase.length; i++) {
                    if(success.dataset.precobasecli_precobase[i].IDPRBASEPRIN == "S") {
                        widget.currentRow.IDPRBASEPRIN = "N";
                        ScreenService.showMessage("Não é permitido o cadastro de duas Tabelas Principais.");
                        return 0;
                    }
                }
                
                General.saveCrud(widget).then(function (){
                    widget.reload();
                    //widget.view();
                    gridTabela.reload();
                });
            
            }.bind(this));} else {
                
                General.saveCrud(widget).then(function (){
                    widget.reload();
                    //widget.view();
                    gridTabela.reload();
                });
        }
    };
    
    this.edit = function(widget) {
        General.edit(widget);
    };
    
    this.cancelEdit = function(widget) {
       if(this.formChangeTemplate(widget) && widget.parent) {
            var widgets = widget.parent.widgets;

            this.changeWidgetAcessibility(widgets.concat(widget.parent), true);
        } else this.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.reload();    
            widget.list();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.reload();
            widget.view();
        }
    };
    
    this.saveRow = function(widget) {
        
        General.saveCrud(widget).then(function(){
            widget.reload();
        });
        
    };
    
    this.newRow = function(widget) {
        widget.newRow();
    };
    
    this.back = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };

    this.fechaCadastramento = function(widget) {

        widget.fields.forEach(function(field){

            field.setValue('');

            if(field.name != "IDTPCADASTRAMENTO") {
                
                field.readOnly = true;
            
            }

        }.bind(this));

        this.back(widget);

    };

    this.formChangeTemplate = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };
     
    this.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    this.openCadastramento = function(){

        var widgetCadastramento = templateManager.container.getWidget('widgetCadastramento');

        widgetCadastramento.mode = "edit";

        widgetCadastramento.currentRow.__is_new = true;
        
        widgetCadastramento.currentRow.CDVENDEDOR = "";
        widgetCadastramento.currentRow.CDMODPGTO = "";
        widgetCadastramento.currentRow.CDGRUPCLIE = "";
        widgetCadastramento.currentRow.CDREGIAOPED = "";
        widgetCadastramento.currentRow.NRINSJURTRAN = "";
        widgetCadastramento.currentRow.IDTPIJURTRAN = "";
        widgetCadastramento.currentRow.CDTIPTRANS = "";
        widgetCadastramento.currentRow.VRPEMAXDESCL = "";
        widgetCadastramento.currentRow.IDPGFRETTRANCLI = "";
        
        ScreenService.openSwipe(widgetCadastramento);

        templateManager.updateTemplate();

    };

    this.statusCadastra = function(row) {
        var widgetCadastramento = templateManager.container.getWidget('widgetCadastramento');
       
        var fields = ['DSMODPGTO', 'NMGRUPCLIE','NMFANVEN', 'NMREGIAOPED', 'VRPEMAXDESCL', 'NMRAZSOCTRAN', 'NMTIPTRANS', 'IDPGFRETTRANCLI'];
        var newField = "";
        var idtpCadastramento= row.IDTPCADASTRAMENTO;

        switch(idtpCadastramento){

        	case 'V':
        
        		newField = fields.splice(fields.indexOf('NMFANVEN'),1);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).reload();

        	break;
        	
            case 'M':
        
        		newField = fields.splice(fields.indexOf('DSMODPGTO'),1);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).reload();

        	break;
        	
        	case 'G':
        
        		newField = fields.splice(fields.indexOf('NMGRUPCLIE'),1);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).reload();

        	break;
        	
        	case 'R':
        
        		newField = fields.splice(fields.indexOf('NMREGIAOPED'),1);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).reload();

        	break;
        	
        	case 'D':
        
        		newField = fields.splice(fields.indexOf('VRPEMAXDESCL'),1);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[0]).reload();

        	break;
        	
        	case 'T':
        
        		newField = fields.splice(fields.indexOf('NMRAZSOCTRAN', 'NMTIPTRANS', 'IDPGFRETTRANCLI'),3);
        		fields.forEach(function(field){
        			widgetCadastramento.getField(field).readOnly = true;
        			widgetCadastramento.getField(field).validations = {};
        		});
        	 
        		widgetCadastramento.getField(newField[0]).readOnly = false;
        		widgetCadastramento.getField(newField[1]).readOnly = false;
        		widgetCadastramento.getField(newField[2]).readOnly = false;
        		
        		widgetCadastramento.getField(newField[0]).validations = {required: true};
        		widgetCadastramento.getField(newField[1]).validations = {required: true};
        		widgetCadastramento.getField(newField[2]).validations = {required: true};
        		
        		widgetCadastramento.getField(newField[0]).reload();
        		widgetCadastramento.getField(newField[1]).reload();
        		widgetCadastramento.getField(newField[2]).reload();

        	break;
        	
                
            default:
                ScreenService.showMessage('Selecione um Tipo de cadastramento');
        }
  
        templateManager.updateTemplate();

    };

    this.cadastrarAutomaticamente = function(args) {

        // Valor atual que vem para o args
        var widgetCadastramento = args;
        
        if(widgetCadastramento.isValid()){
            
            var widgetCliente = templateManager.container.getWidget('widgetCliente');
    
            var rows = widgetCliente.getCheckedRows();
    
            var paramRow = widgetCadastramento.currentRow;
            
            if(paramRow.IDTPCADASTRAMENTO){
                var dataSet = [paramRow, rows];
                
                Ped07700_ParametrizacaoClientesPedidos_Service.cadastramentoAutomaticoCliente(dataSet).then(function(sucess){
                    
                    ScreenService.showMessage('Campo salvo com sucesso');
                    
                    // ScreenService.showMessage(sucess.message[0].message, sucess.message[0].type);
        
                    this.fechaCadastramento(widgetCadastramento);
                
                    widgetCliente.reload();
                        
                }.bind(this)).catch(function(fail){
                    
                    ScreenService.showMessage('Erro: Campo não salvo');
        
                    //ScreenService.showMessage(fail.messages[0].message, fail.messages[0].type);
        
                }.bind(this));
            }else{
                ScreenService.showMessage('Nenhum campo informado');
            }
            
        }    

    };
    
    
    this.openPopupDadosPedidosAction = function(){
        var widgetPopup = templateManager.container.getWidget('filtroProduto');
        widgetPopup.getField('P_CDPRODINI').setValue(undefined);
        widgetPopup.getField('P_CDPRODFIN').setValue(undefined);
        widgetPopup.getField('P_CDPRODUTOINI').setValue(undefined);
        widgetPopup.getField('P_CDPRODUTOFIN').setValue(undefined);
        widgetPopup.getField('NMPRODINI').setValue(undefined);
        widgetPopup.getField('NMPRODFIN').setValue(undefined);
        
        this.openPopupDadosPedidos();
    };
    
    this.openPopupDadosPedidos = function(){
        var widgetPopup = templateManager.container.getWidget('filtroProduto');
        var prod_ini = widgetPopup.getField('P_CDPRODINI').value();
        var prod_fin = widgetPopup.getField('P_CDPRODFIN').value();
        
        if(prod_ini == undefined || prod_fin == undefined){
            widgetPopup.isVisible = true;
            // var nivel = General.getLevelByMask('CDPICTPROD', 1);
            // nivel = nivel[nivel.length-1].nivel;
            
            // widgetPopup.getField('NMPRODINI').dataSourceFilter.push(
            //     {
            //         name: "CDNVPRODUTO",
            //         operator: "=",
            //         value: nivel
            //     }     
            // );
            
            // widgetPopup.getField('NMPRODFIN').dataSourceFilter.push(
            //     {
            //         name: "CDNVPRODUTO",
            //         operator: "=",
            //         value: nivel
            //     }     
            // );
            ScreenService.openPopup(widgetPopup);      
        }else{
            return 0;
        }
              
        
    };
    
    this.filtrarDadosProduto = function(widget){
        
        widget.isVisible = false;
        var widgetPai = templateManager.container.getWidget('dadosProduto');
        var widgetCliente = templateManager.container.getWidget('widgetCliente');
        var cdCliente = widgetCliente.getField('CDCLIENTE').value();
        var prod_ini = widget.getField('P_CDPRODINI').value();
        var prod_fin = widget.getField('P_CDPRODFIN').value();
        var cdProdIni =  widget.getField('P_CDPRODUTOINI').value();
        var cdProdFin =  widget.getField('P_CDPRODUTOFIN').value();
        var nivel = General.getLevelByMask('CDPICTPROD', 1);
        nivel = nivel[nivel.length-1].nivel;
        var retornoFiltro = this.validaProdInicialProdFinal(cdProdIni, cdProdFin);
        prod_fin = prod_fin + "zzzzzzzzzzzzzzzzzzzzz";
        prod_fin = prod_fin.substring(0, 20);
            if(retornoFiltro){
                ScreenService.closePopup(widget);
                widget.isVisible = false;
                widgetPai.dataSourceFilter = [];
                widgetPai.dataSourceFilter.push(
                    {
                        name: "P_CDCLIENTE",
                        operator: "=",
                        value: cdCliente
                    }
                );
                
                widgetPai.dataSourceFilter.push(
                    {
                        name: "P_CDPRODINI",
                        operator: "=",
                        value: prod_ini
                    }
                );
                
                widgetPai.dataSourceFilter.push(
                    {
                        name: "P_CDPRODFIN",
                        operator: "=",
                        value: prod_fin
                    }
                );
                
                widgetPai.dataSourceFilter.push(
                    {
                        name: "P_CDNVPRODUTO",
                        operator: "=",
                        value: nivel
                    }
                );
                
                widgetPai.getField('CDPRODUTO').dataSourceFilter.push(
                    {
                        name: "CDNVPRODUTO",
                        operator: "=",
                        value: nivel
                    } 
                );
                widgetPai.reload();    
            }
        
    };
    
    this.ativaFields = function(widget){
        if(widget == undefined){
            widget = templateManager.container.getWidget('dadosProduto');
            widget.getField('CDCLIENTE').isVisible = false;
            widget.getField('CDPRODUTO').isVisible = false;
            widget.getField('CDARVPROD').isVisible = true;
            widget.getField('NMPRODUTO').isVisible = true;
        }else{
            widget.getField('CDCLIENTE').isVisible = false;
            widget.getField('CDPRODUTO').isVisible = false;
            widget.getField('CDARVPROD').isVisible = true;
            widget.getField('NMPRODUTO').isVisible = true;
        }

    };
    
    this.saveDadoProduto = function(widget){
        if(widget.currentRow.__is_new == true){
            if(widget.currentRow.CDPRODUTO != ""){
                this.saveRow(widget);         
            }else{
                ScreenService.showMessage("Selecione um produto válido.");    
            }
        }else{
            Ped07700_ParametrizacaoClientesPedidos_Service.salvaDadosProduto(widget.currentRow).then(function(){
                this.ativaFields(widget);
                ScreenService.closeSwipe();
            }.bind(this));
        }
    };
    
    this.validaProdInicialProdFinal = function(prodIni, prodFin){
        
        if(prodIni != undefined && prodFin != undefined){
            if(prodIni <= prodFin){
                return true;
            }else{
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que o codigo do produto final.").then(function(){
                    return false;
                });
            }
        }else{
            ScreenService.showMessage("O Produto Inicial e o Produto final devem ser informados").then(function(){
                return false;
            });
        }
    };
    
    this.editaDadosProduto = function(widget){
        this.habilitaCliente(widget);
        General.edit(widget);
    };
    
    this.voltarDadosProduto = function(widget){
        this.ativaFields(widget);
        this.back(widget);    
    };
    
    this.cancelEditDadosProduto = function(widget){
        this.ativaFields(widget);
        this.cancelEdit(widget);
    };
    
    this.habilitaCliente = function(widget){
        var widgetCliente = templateManager.container.getWidget('widgetCliente');
        var cdCliente = widgetCliente.getField('CDCLIENTE').value();
        widget.getField('CDCLIENTE').setValue(cdCliente);  
        widget.getField('CDCLIENTE').isVisible = true;
    };
    
    this.deletaDados = function(widget){
        Ped07700_ParametrizacaoClientesPedidos_Service.deletaDadosProduto(widget.currentRow).then(function(){
            this.ativaFields(widget);
            ScreenService.closeSwipe();
            widget.reload();
        }.bind(this));
    };
    
    this.closePopupFiltroProduto = function(){
        var widgetPopup = templateManager.container.getWidget('filtroProduto');
        ScreenService.closePopup(widgetPopup);
    };
    
    this.resetaFiltroDadosProduto = function(){
        var widgetPopup = templateManager.container.getWidget('filtroProduto');
        
        widgetPopup.getField('P_CDPRODINI').setValue(undefined);
        widgetPopup.getField('P_CDPRODFIN').setValue(undefined);
        widgetPopup.getField('P_CDPRODUTOINI').setValue(undefined);
        widgetPopup.getField('P_CDPRODUTOFIN').setValue(undefined);
        widgetPopup.getField('NMPRODINI').setValue(undefined);
        widgetPopup.getField('NMPRODFIN').setValue(undefined);
    };
    
    this.controlaVisibilidadeExcluirDadosProduto = function(){
        var widget = templateManager.container.getWidget('dadosProduto');
        var cdprodclieped = widget.getField('CDPRODCLIEPED').value();
        var dsprodclieped = widget.getField('DSPRODCLIEPED').value();
        var dsprodcliepeditem = widget.getField('DSPRODCLIEPEDITEM').value();
        
        if((cdprodclieped != null) || (dsprodclieped != null) || (dsprodcliepeditem != null)){
            widget.getAction('DELETE_DADOS_PRODUTO').isVisible = true;
        }else{
            widget.getAction('DELETE_DADOS_PRODUTO').isVisible = false;
        }
    };
    
    this.cancelarFiltroProduto = function(){
        this.closePopupFiltroProduto();    
        this.resetaFiltroDadosProduto();
    };
    

    /*
    *   Seta o datasource filter do estado com o codigo do pais
    */
    this.setDataSourceFilterField = function(field) {
        var widget = field.widget;
        if(field.name == 'SGESTADO'){
            
            var cdpais = widget.currentRow.CDPAIS;
            
            widget.getField('SGESTADO').dataSourceFilter[0].value = cdpais;
            widget.getField('SGESTADO').reload();
            
        }else if(field.name == 'CDMUNICIPIO'){
            
            var sgestado = widget.currentRow.SGESTADO;
            
            widget.getField('CDMUNICIPIO').dataSourceFilter[0].value = sgestado;
            widget.getField('CDMUNICIPIO').reload();
        }
    };
    
    
    
    /*
    *   Limpa os fieds abaixo do field modificado. Ex: se eu lipar CDPAIS, apago SGESTADO e CDMUNICIPIO
    */
    this.clearDataField = function(fieldName, widget){
        var filterWidget = templateManager.container.getActiveWidget();
      
            if(fieldName == 'CDPAIS'){
                if(widget.currentRow.CDPAIS && widget.currentRow.CDPAIS.length > 0){
                    widget.getField("SGESTADO").readOnly = false;
                    
                }else{
                    widget.getField("SGESTADO").readOnly = true;
                    widget.getField("CDMUNICIPIO").readOnly = true;
                    filterWidget.currentRow.IDTPENDECLIE = 'P';
                    filterWidget.getField('IDTPENDECLIE').setValue('P');
                    
                    
                }
                widget.getField('SGESTADO').setValue([]);
                widget.getField('SGESTADO').reload();
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
        
            }
            else if(fieldName == 'SGESTADO'){
                if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0) {
                    widget.getField("CDMUNICIPIO").readOnly = false;
                } else {
                    widget.getField("CDMUNICIPIO").readOnly = true;
                }
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();

            }
    };
    // FIM NOVOS METODOS CONTROLE DE PAIS-ESTADO-MUNICIPIO
    
    this.openFilter = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
       
    };
    this.setFilter = function(widgetCliente) {
        var filterWidget = templateManager.container.getActiveWidget();
        
        filterWidget.currentRow.IDTPENDECLIE = 'P';
        filterWidget.getField('IDTPENDECLIE').setValue('P');
        
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped07700_ParametrizacaoClientesPedidos_Controller', Ped07700_ParametrizacaoClientesPedidos_Controller);
});

// FILE: ./assets/js/controllers/ger00700_Cliente_Controller.js
var Ger00700_Cliente_Controller  = function(ScreenService, templateManager, Endereco, Ger00700_Cliente_Service, General, ZHPromise){

    var self = this;

    this.numRowFormPgto=0;

    self.salvarBancoPreferencial = function(widget){
        var existe = false;
        var cliente = widget.getParent().currentRow.CDCLIENTE;
        var organizacao = widget.getParent().currentRow.NRORG;
        if (widget.currentRow.IDPRIORBPREF == "S") {
            Ger00700_Cliente_Service.getBancoPref(cliente, organizacao).then(function (response) {
                var bancoPrioridade = response.dataset.bancopref[0];
                if (bancoPrioridade) {
                    if (widget.__is_new) {
                        ScreenService.showMessage("Apenas um banco preferencial pode ser prioritário.");
                    } else {
                        if (bancoPrioridade.CDREDUCONT == widget.currentRow.CDREDUCONT) {
                            General.saveCrud(widget);
                        }else{
                            ScreenService.showMessage("Apenas um banco preferencial pode ser prioritário.");
                        }
                    }
                } else {
                    General.saveCrud(widget);
                }
            });
        }else{
            General.saveCrud(widget);
        }
    };

    self.checkIDTPENDECLIE = function() {
        var widget = templateManager.container.getWidget("endereco");
        var atual = widget.currentRow.IDTPENDECLIE;
        var data = [];
        var i = 0;

        widget.getField('IDTPENDECLIESELECT').dataSource.rawdata.forEach(function(fieldrow) {
            fieldrow.ENABLE = true;
            widget.dataSource.data.forEach(function(row) {
                if(row.IDTPENDECLIE == fieldrow.IDTPENDECLIE){
                    if (row.IDTPENDECLIE.localeCompare(atual) === 0 && widget.mode == 'edit') {
                        fieldrow.ENABLE = true;
                    }else{
                        fieldrow.ENABLE = false;
                    }
                }
            });
            if(fieldrow.ENABLE) data[i++] = fieldrow;
        });

        widget.getField('IDTPENDECLIESELECT').dataSource.data = (widget.currentRow.__is_new)? data : widget.getField('IDTPENDECLIESELECT').dataSource.rawdata;
        widget.currentRow.IDTPENDECLIE = (widget.currentRow.__is_new)? (data[0]? data[0].IDTPENDECLIE : null) : widget.currentRow.IDTPENDECLIE;
        widget.currentRow.IDTPENDECLIESELECT = widget.currentRow.IDTPENDECLIE;
        widget.getField('IDTPENDECLIESELECT').reload();
    };

    self.endeclieSetIDTPENDECLIE = function() {
        var widget = templateManager.container.getWidget("endereco");

        widget.currentRow.IDTPENDECLIE = widget.currentRow.IDTPENDECLIESELECT;
    };

    self.endeclieCheckActions = function() {
        var widget = templateManager.container.getWidget("endereco");
        if(widget.currentRow.__is_new) return;

        if(widget.currentRow.IDTPENDECLIE == 'P') widget.getAction('DELETE').isVisible = false;
        else widget.getAction('DELETE').isVisible = true;

        if(widget.dataSource.data.length == widget.getField('IDTPENDECLIESELECT').dataSource.rawdata.length) widget.getAction('ADD').isVisible = false;
        else widget.getAction('ADD').isVisible = true;
    };

    self.checkInscricao = function(widget) {
        var inscricao = General.inscricaoFormat(widget.currentRow.NRINSJURCLIE);

        if(inscricao.valid) {
            widget.currentRow.NRINSJURCLIE = inscricao.value;
            widget.currentRow.IDTPIJURCLIE = inscricao.tipo.cod;
            self.checkInscricaoParceiro(widget);
        } else {
            
            var var_invalido =  ScreenService.i18n(" inválido!");
            var var_invalida =  ScreenService.i18n(" inválida!");
            if (inscricao.tipo.cod == 'J') inscricao.tipo.msg = 'CNPJ' + " \"" + inscricao.value + "\"" + var_invalido;
            else if (inscricao.tipo.cod == 'F') inscricao.tipo.msg = 'CPF' + " \"" + inscricao.value + "\"" + var_invalido;
            else if (inscricao.tipo.cod == 'I') inscricao.tipo.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\"" + var_invalida;

            if(inscricao.tipo.msg) ScreenService.showMessage(inscricao.tipo.msg, "warning");
            widget.currentRow.NRINSJURCLIE = null;
        }
    };

    self.addCliente = function(){
        var clienteWidget = templateManager.container.getWidget("cliente");
        var addressWidget = templateManager.container.getWidget("endprinc");
        self.habilitaEnderecoPrincipal();

        clienteWidget.newRow();

        clienteWidget.currentRow.IDTPIJURCLIE = 'J';

        self.checkInscricao(clienteWidget);

        addressWidget.showAsTab = true;
        addressWidget.isVisible = true;

        addressWidget.setCurrentRow({});
        addressWidget.edit();

        addressWidget.currentRow.__is_new = true;
        addressWidget.currentRow.IDTPENDECLIE = "P";
    };

    self.criaCdcliente = function(widget){
        if (widget.currentRow.__is_new) {
            if(widget.currentRow.NRINSJURCLIE){
                var inscricao = widget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
                var tipoInscricao = widget.currentRow.IDTPIJURCLIE;
                widget.getField('CDCLIENTE').setValue(tipoInscricao + inscricao);        
            }else
                widget.getField('CDCLIENTE').setValue('');        
        }
    };

    self.setInscricaoJuridica = function(widget){
        widget.fields.filter(function(field) {
            if (field.id == '115003'){
                field.isVisible = 'true';
                field.showOnForm = 'true';
            }
        });
    };

    self.salvarCliente = function(widget){
        
        var clienteWidget = templateManager.container.getWidget('cliente');
        if(clienteWidget.isValid()){
            var parceiroNegocio = clienteWidget.currentRow.NRPARCNEGOCIO;
            var inscricao = clienteWidget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
            var novaParceria = '';
            clienteWidget.currentRow.NRINSJURCLIE = inscricao;
            if (clienteWidget.currentRow.__is_new) {
                var addressWidget = templateManager.container.getWidget("endprinc");
                addressWidget.dataSourceFilter[0].value = clienteWidget.currentRow.CDCLIENTE;
                if(clienteWidget.isValid() && addressWidget.isValid() && addressWidget.currentRow.CDPAIS) {
                    if (parceiroNegocio) {
                        Ger00700_Cliente_Service.getParceria(parceiroNegocio, 'CLIENTE').then(function (promisse) {
                            var parceria = promisse.dataset.parceria[0];
                            if (!parceria) {
                                clienteWidget.currentRow.NRPARCNEGOCIO = parceiroNegocio;
                                novaParceria = self.geraParceria(clienteWidget);
                                if (novaParceria) {
                                    Ger00700_Cliente_Service.insereParceria(novaParceria).then(function () {
                                        General.saveCrud(clienteWidget).then(function(){
                                            addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                            self.salvarEndereco(addressWidget);
                                        });
                                    });
                                }
                            }else{
                                General.saveCrud(clienteWidget).then(function(){
                                    addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                    self.salvarEndereco(addressWidget);
                                });
                            }
                        });
    
                    } else {
                        var parceiro = self.validaParceiro(clienteWidget);
                        Ger00700_Cliente_Service.insereParceiro(parceiro).then(function (data) {
                            clienteWidget.currentRow.NRPARCNEGOCIO = data.dataset.columnsToReturn[0].NRPARCNEGOCIO;
                            novaParceria = self.geraParceria(clienteWidget);
                            Ger00700_Cliente_Service.insereParceria(novaParceria);
                            General.saveCrud(clienteWidget).then(function(){
                                addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                self.salvarEndereco(addressWidget);
                            });
                        });
                    }
                    self.habilitaEnderecoGeral();
                } else {
                    self.validaCamposRequiredSave(clienteWidget, addressWidget);
                }
            }else{
                self.masterDetailSave(clienteWidget);
            }     
        }
        else{
            clienteWidget.currentWidget = clienteWidget;
            clienteWidget.activate();    
        }
       
    };

    self.habilitaEnderecoGeral = function(){
        templateManager.container.getWidget("endereco").isVisible = true;
        templateManager.container.getWidget("endprinc").isVisible = false;
        templateManager.container.getWidget("endprinc").showAsTab = false;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("banco"),
            templateManager.container.getWidget("observacao"),
            templateManager.container.getWidget("interlocutores")], true);
    };

    self.habilitaEnderecoPrincipal = function(){
        templateManager.container.getWidget("endereco").isVisible = false;
        templateManager.container.getWidget("endprinc").isVisible = true;
        templateManager.container.getWidget("endprinc").showAsTab = true;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("banco"),
            templateManager.container.getWidget("observacao"),
            templateManager.container.getWidget("interlocutores")], false);
    };

    self.clienteCancelForm = function(widget) {
        var clienteWidget = templateManager.container.getWidget("cliente");
        if(clienteWidget.currentRow.__is_new) {
            var addressWidget = templateManager.container.getWidget("endprinc");

            /*clienteWidget.getField("CDINSCESTA").readOnly = true;
            clienteWidget.getField("CDINSCMUNI").readOnly = true;
            clienteWidget.getField("DSSERIE").readOnly = true;

            addressWidget.getField("NMESTADO").readOnly = true;
            addressWidget.getField("NMMUNICIPIO").readOnly = true;*/

            templateManager.container.getWidget("endereco").isVisible = true;
            templateManager.container.getWidget("endprinc").isVisible = false;

            self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
                templateManager.container.getWidget("parametrizacao"),
                templateManager.container.getWidget("pagamento"),
                templateManager.container.getWidget("banco"),
                templateManager.container.getWidget("observacao"),
                templateManager.container.getWidget("interlocutores")], true);

            var indexOfCurrentRow = addressWidget.dataSource.data.indexOf(addressWidget.currentRow);
            if(indexOfCurrentRow !== -1) addressWidget.dataSource.data.pop();
            addressWidget.currentRow = {};

            indexOfCurrentRow = clienteWidget.dataSource.data.indexOf(clienteWidget.currentRow);
            if(indexOfCurrentRow !== -1) clienteWidget.dataSource.data.pop();
            clienteWidget.currentRow = {};

            addressWidget.showAsTab = false;
            addressWidget.isVisible = false;

            clienteWidget.list();

            ScreenService.closeSwipe();

            clienteWidget.activate();
        } else {
            //self.clienteResetFields(widget);
            self.masterDetailCancelForm(widget);
        }
    };

   /* self.clienteResetFields = function(widget) {
        if(widget.getField("CDINSCESTA")) widget.getField("CDINSCESTA").readOnly = true;
        if(widget.getField("CDINSCMUNI")) widget.getField("CDINSCMUNI").readOnly = true;
        if(widget.getField("DSSERIE")) widget.getField("DSSERIE").readOnly = true;

        if(widget.getField("NMESTADO")) widget.getField("NMESTADO").readOnly = true;
        if(widget.getField("NMMUNICIPIO")) widget.getField("NMMUNICIPIO").readOnly = true;

        if(widget.currentRow.CDINSCESTA) widget.currentRow.CDINSCESTA = null;
        if(widget.currentRow.CDINSCMUNI) widget.currentRow.CDINSCMUNI = null;
        if(widget.currentRow.CDSERIE) widget.currentRow.CDSERIE = null;
        if(widget.currentRow.DSSERIE) widget.currentRow.DSSERIE = null;

        if(widget.currentRow.SGESTADO) widget.currentRow.SGESTADO = null;
        if(widget.currentRow.NMESTADO) widget.currentRow.NMESTADO = null;
        if(widget.currentRow.CDMUNICIPIO) widget.currentRow.CDMUNICIPIO = null;
        if(widget.currentRow.NMMUNICIPIO) widget.currentRow.NMMUNICIPIO = null;
    };*/

    self.validaCamposRequiredSave = function (clienteWidget, addressWidget){
        if(!clienteWidget.isValid() && (!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS)) {
            if(addressWidget.isValid() && !addressWidget.currentRow.CDPAIS) {
                addressWidget.activate();

                addressWidget.isValid();

                clienteWidget.currentWidget = clienteWidget;
                clienteWidget.activate();
            } else addressWidget.isValid();
            ScreenService.showMessage("Preencha todos os campos obrigatórios das duas telas!");
        } else {
            if((!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS) && !addressWidget.isActive()) {
                addressWidget.activate();
                addressWidget.isValid();
            } else if(!clienteWidget.isValid() && !clienteWidget.isActive()) {
                clienteWidget.currentWidget = clienteWidget;
                clienteWidget.activate();
            }
            ScreenService.showMessage("Preencha os campos obrigatórios!");
        }
    };

    self.geraParceria = function(widget){
        return [{
            "NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO,
            "CDTIPOPARCEIRO": 'CLIENTE',
            "NRORG": getLocalVar('ERP_NRORGTRAB'),
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "PARCERIA",
            "__table_pk": "NRPARCERIA",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.checkInscricaoParceiro = function(widget){
        var inscricao = widget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
        Ger00700_Cliente_Service.getParcNegocio(inscricao).then(function (promisse) {
            var parcnegocio = promisse.dataset.parcnegocio[0];
            if (parcnegocio) {
                ScreenService.confirmMessage('Ja existe um parceiro para este número de inscrição. Deseja carregar dados do parceiro?', 'question', function(success){
                    widget.currentRow.NMRAZSOCCLIE = parcnegocio.NMPRINCIPALPARC;
                    widget.currentRow.NMFANTCLIE = parcnegocio.NMSECUNDARIPARC;
                    widget.currentRow.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                });
            }else{
                widget.currentRow.NRPARCNEGOCIO = false;
            }
        });
    };

    self.salvarEndereco = function(widget){
        var existeTipoEndereco = false;
        var tipoEnderecoCliente = widget.currentRow.IDTPENDECLIE;
        var tipoEnderecoParceiro = self.getTipoEndereco(tipoEnderecoCliente);
        var parceiro = widget.parent.currentRow.NRPARCNEGOCIO;
        var nomeLogradouro = widget.currentRow.DSENDECLIE;
        if (widget.currentRow.__is_new) {
            widget.dataSource.data.forEach(function (endereco) {
                if (endereco.IDTPENDECLIE == tipoEnderecoCliente) {
                    existeTipoEndereco = true;
                }
            });
            self.concatenaCamposEndereco(widget.currentRow);
            if (widget.isValid()) {
                widget.currentRow.changed = true;
                return widget.saveRow().then(function (response) {
                    widget.currentRow.changed = false;
                 ScreenService.showMessage('Inserido com sucesso.');
                    widget.currentRow.__is_new = false;
                 ScreenService.closeSwipe();
                    widget.list();
                 widget.reload();
                 Ger00700_Cliente_Service.getEnderecoParcNegocio(parceiro, tipoEnderecoParceiro).then(function (promisse) {
                        var endereco = promisse.dataset.enderecoparc[0];
                        if (!endereco) {
                            var enderecoParceiro = self.preparaEnderecoParceiro(widget);
                            Ger00700_Cliente_Service.insereEnderecoParceiro(enderecoParceiro);
                        }
                    });
                });
            }
            if (widget.name == 'endprinc') {
                self.habilitaEnderecoGeral();
            }
        }else{
            self.concatenaCamposEndereco(widget.currentRow);
            self.masterDetailSave(widget);
        }
        widget.currentRow.DSENDECLIE = nomeLogradouro;
    };

    self.validaParceiro = function(widget){
        var tipo = "";
        switch(widget.currentRow.IDTPIJURCLIE){
            case "J": tipo = "CNPJ";
                break;
            case "O": tipo = "CODIGO";
                break;
            case "F": tipo = "CPF";
                break;
            default:
                tipo = "LIVRE";
        }
        if(widget.currentRow.__is_new) {
            return [{
                "CDTIPOINSCRICAO": tipo,
                "NRINSCRICAOPARC": widget.currentRow.NRINSJURCLIE,
                "NMPRINCIPALPARC": widget.currentRow.NMRAZSOCCLIE,
                "NMSECUNDARIPARC": widget.currentRow.NMFANTCLIE,
                "CDTIPOPARCPRINCIPAL": "CLIENTE",
                "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
                "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
                "__is_new_code": true,
                "__new_code_pk": "PARCNEGOCIO",
                "__table_pk": "NRPARCNEGOCIO",
                "__new_code_length": 10,
                "__columns_to_return": [
                    "NRPARCNEGOCIO"
                ],
                "__is_new": true
            }];
        } /*else {
         return [{
         "NMPRINCIPALPARC": widget.currentRow.NMRAZSOCCLIE,
         "NMSECUNDARIPARC": widget.currentRow.NMFANTCLIE,
         "NRORGULTATU": getLocalVar('ERP_NRORGTRAB'),
         "CDOPERULTATU": getLocalVar('ERP_CDOPERADOR'),
         "changed": true,
         "__is_new": false
         }];
         }*/
    };

    self.concatenaCamposEndereco = function (endereco){
        endereco.DSENDECLIE = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO + " " + endereco.DSENDECLIE : endereco.DSENDECLIE;
        endereco.DSENDECLIE = (endereco.NUMERO)? endereco.DSENDECLIE + ", " + endereco.NUMERO : endereco.DSENDECLIE;
    };

    self.getTipoEndereco = function(idtpendeclie){
        var cdtipoendereco = "";
        var tipoEndereco = ['P', 'C', 'E', 'X', 'T', 'I'];
        var descTipoEndereco = ['PRINCIPAL', 'COBRANCA', 'EXTERIOR', 'EXPORTACAO', 'ENTREGA', 'INSCRICAO ESTADUAL'];
        for (i = 0; i < tipoEndereco.length; i++){
            if (idtpendeclie == tipoEndereco[i])
                cdtipoendereco = descTipoEndereco[i];
        }
        return cdtipoendereco;
    };

    self.preparaEnderecoParceiro = function(widget){
        var cdtipoendereco = self.getTipoEndereco(widget.currentRow.IDTPENDECLIE);
        return [{
            "NRPARCNEGOCIO": widget.parent.currentRow.NRPARCNEGOCIO,
            "NRCEPENDERECO": widget.currentRow.NRCEPCLIE.replace(/\.|\/|\-/g, ''),
            "CDTIPOENDERECO": cdtipoendereco,
            "DSENDERECO": widget.currentRow.DSENDECLIE,
            "CDLOGRADOURO": widget.currentRow.CDLOGRADOURO,
            "NRIMOVELENDERECO": widget.currentRow.NUMERO,
            "DSCOMPLEENDERECO": widget.currentRow.DSCOMPENDCLI,
            "CDPAIS": widget.currentRow.CDPAIS,
            "SGESTADO": widget.currentRow.SGESTADO,
            "CDMUNICIPIO": widget.currentRow.CDMUNICIPIO,
            "CDBAIRRO": widget.currentRow.CDBAIRCLIE,
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "ENDERECOPARC",
            "__table_pk": "NRENDERECOPARC",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.validaAction = function(widget){
        var action = widget.getAction('ADD');
        if (widget.dataSource.data.length === 0){
            action.label = 'Adicionar';
            action.icon = 'plus';
        }else{
            action.label = 'Editar';
            action.icon = 'pencil';
        }
    };

    self.setGridModoPagamento = function(widget){
        widget.widgets[0].dataSource.data =  [];
    };

    self.openFormaPgto = function(widgetGrid){
        var pagamento = templateManager.container.getWidget('pagamento');
        if (pagamento.getField('NMFORMPGTO').value()) {
            var widgetForm = widgetGrid.widgets[0];
            var data = widgetGrid.dataSource.data;
            data.forEach(function () {
                self.createAndAppendFields(widgetForm);
            });
            if (widgetForm.fields.length === 0) {
                self.createAndAppendFields(widgetForm);
            }
            widgetForm.currentRow = self.montaRow(data, widgetGrid.parent.currentRow.CDCLIENTE);
            ScreenService.openSwipe(widgetForm);
        }else{
            ScreenService.showMessage('Forma de pagamento deve ser informada.');
        }
    };

    self.closeFormaPgto = function(widget){
        widget.fields = [];
        ScreenService.goBack();
        self.numRowFormPgto=0;
    };

    self.montaRow = function(dataSet,cdcliente){
        var row={};
        for(var i in dataSet){
            row['VRPERCPGTOCL'+i] = dataSet[i].VRPERCPGTOCL;
            row['NRDIASPGTOCL'+i] = dataSet[i].NRDIASPGTOCL;
        }
        row.CDCLIENTE = cdcliente;
        return row;
    };

    self.createAndAppendFields=function(widget){
        var widgetFields = widget.fields;
        widget.fields = widgetFields.concat(self.getFields(self.numRowFormPgto,widget));
        self.numRowFormPgto++;
        self.hideDelete(widget);
    };


    self.getFields=function(index,widget){
        var fields=[];
        fields.push(self.getFieldDias(index));
        fields.push(self.getFieldPercent(index));
        fields.push(self.getFieldDelete(index));
        for(var i in fields){
            fields[i]=metaDataFactory.factoryField(fields[i],widget);
        }
        return fields;
    };

    self.getFieldDias=function(index){
        return {
            name: "NRDIASPGTOCL"+index,
            label: "Número (dias)",
            template: "field/number.html",
            validations:{
                required:true,
                /*maxLength: {
                 length: 3
                 }*/
                range: {
                    min: 0,
                    max: 999
                }
            },
            events:[
                {
                    name:"FieldOnChange",
                    code:"Ger00700_Cliente_Controller.validaDiaOnChange(args.owner.field.widget)"
                }
            ],
            defaultValue:'',
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 4
        };
    };

    self.validaDiaOnChange = function(widget){
        var dataSet = self.montaDataSet(widget.currentRow);
        self.validaDias(dataSet);
    };

    self.getFieldPercent=function(index){
        return {
            name: "VRPERCPGTOCL"+index,
            label: "Percentual",
            template: "field/text-edit.html",
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            validations:{
                required:true,
                range: {
                    min: 0,
                    max: 100
                }
            },
            "mask": {
                "type": "viewFloat",
                "params": {
                    "showSymbol": false,
                    "precision": 2,
                    "thousands": ".",
                    "decimal": ","
                }
            },
            defaultValue:'',
            class: 4
        };
    };

    self.getFieldDelete=function(index){
        return {
            name: "BTNDELETE"+index,
            label: "Excluir",
            template: "field/label-with-icon.html",
            isVisible: true,
            icon: "trash",
            showOnList: true,
            showOnForm: true,
            events:[
                {
                    "name":"FieldOnClick",
                    "code":"Ger00700_Cliente_Controller.deleteFields(args.owner.field)"
                }
            ],
            class: 4
        };
    };

    self.deleteFields=function(fieldRemove){
        var widget = fieldRemove.widget;
        var fields = widget.fields;
        var indexDelete = Number.parseInt(fieldRemove.name.replace('BTNDELETE',''));
        for(var i=0;i<fields.length;i++){
            var index = Number.parseInt(fields[i].name.replace(/(BTNDELETE|VRPERCPGTOCL|NRDIASPGTOCL)/g,''));
            if(index ===indexDelete){
                delete widget.currentRow[fields[i].name];
                delete widget.currentRow.$error[fields[i].name];
                fields.splice(i,1);
                i--;
            }else if(index > indexDelete){
                var nameFieldAntigo = fields[i].name;
                fields[i].name = nameFieldAntigo.replace(index,index-1);
                widget.currentRow[fields[i].name] = widget.currentRow[nameFieldAntigo];
                delete widget.currentRow[nameFieldAntigo];
            }
        }
        self.numRowFormPgto--;
        self.hideDelete(widget);
    };

    self.hideDelete=function(widget) {
        var field = widget.getField('BTNDELETE0');
        if (self.numRowFormPgto <= 1) {
            field.isVisible = false;
        } else {
            field.isVisible = true;
        }
    };

    self.validaDias = function(dataSet){
        var validacao = Ger00700_Cliente_Service.validaDiasPrazo(dataSet);
        if(!validacao){
            ScreenService.showMessage('Não é possivel cadastrar mais de um prazo para o mesmo dia');
        }
        return validacao;
    };

    self.validaPercentual = function(dataSet){
        var validacao = Ger00700_Cliente_Service.validaPercentual(dataSet);
        if(!validacao){
            ScreenService.showMessage('Soma dos totais dos percentuais dos prazos deve totalizar 100%');
        }
        return validacao;
    };

    self.saveFormaPgto = function(widget){
        var dataSet = self.montaDataSet(widget.currentRow);
        if(widget.isValid() && self.validaDias(dataSet) && self.validaPercentual(dataSet)){
            General.callRestEngine('ped#/delete_cliente_formpgto', 'Row', {"CDCLIENTE": widget.currentRow.CDCLIENTE}).then(function() {
                General.saveCrud(widget.parent.parent).then(function() {
                    Ger00700_Cliente_Service.removePrazoPagamento(widget.parent.dataSource.data).then(function () {
                        Ger00700_Cliente_Service.inserePrazoPagamento(dataSet).then(function () {
                            self.closeFormaPgto(widget);
                            widget.parent.reload();
                        });
                    });
                });
            });
        }
    };

    self.montaDataSet = function(currentRow){
        var dataSet = [];
        for(var i = 0; i < self.numRowFormPgto; i++){
            dataSet[i]={};
            dataSet[i].CDCLIENTE = currentRow.CDCLIENTE;
            dataSet[i].__is_new = true;
            dataSet[i].VRPERCPGTOCL=currentRow['VRPERCPGTOCL'+i];
            dataSet[i].NRDIASPGTOCL=currentRow['NRDIASPGTOCL'+i];
        }
        return dataSet;
    };

    self.saveFormaPagamento = function(){
        var formpgto = templateManager.container.getWidget('pagamento');
        var opcaoPagamento = formpgto.getField('IDTPFORPGTCL').value();
        var prazopgtclie = templateManager.container.getWidget('modopagamento');
        var widgetFormPgto = templateManager.container.getWidget('formpagamento');


        if (opcaoPagamento == "V"){
            if (!self.prazoDiaCorreto(widgetFormPgto)) {
                self.setFieldsPgtoFixo(formpgto);
                self.saveFormaPgto(widgetFormPgto);
            }else{
                ScreenService.showMessage("Prazo (dias) para pagamento não podem ser duplicados.");
            }
        }else if (opcaoPagamento == "F"){
            self.setFieldsFormaPgto(formpgto);
            self.masterDetailSave(formpgto);
            Ger00700_Cliente_Service.removePrazoPagamento(prazopgtclie.dataSource.data).then(function (){
                    prazopgtclie.reload();
                }
            );
            formpgto.reload();
        }else {
            self.setFieldsFormaPgto(formpgto);
            self.setFieldsPgtoFixo(formpgto);
            self.masterDetailSave(formpgto);
            Ger00700_Cliente_Service.removePrazoPagamento(prazopgtclie.dataSource.data).then(function (){
                    prazopgtclie.reload();
                }
            );
            formpgto.reload();
        }
    };

    self.prazoDiaCorreto = function(prazo){
        var valoresDiasPagamento = [];
        var data =  Object.keys(prazo.currentRow);
        var registroDuplicado = false;
        for(var i = 0; i < data.length && !registroDuplicado; i++){
            var diasPagamento = data[i].substr(0,12);
            if (diasPagamento.localeCompare('NRDIASPGTOCL') === 0){
                var valordia = prazo.getField(data[i]).value();
                if (parseInt(valoresDiasPagamento.indexOf(valordia)) == -1){
                    valoresDiasPagamento.push(valordia);
                }else{
                    registroDuplicado = true;
                }
            }
        }
        return registroDuplicado;
    };

    self.setFieldsFormaPgto = function(formpgto){
        formpgto.currentRow.CDFORMPGTO = null;
    };

    self.setFieldsPgtoFixo = function(cliente){
        cliente.currentRow.NRDIAPGFIXCL = 1;
        cliente.currentRow.NRPARCPGTOCL = 1;
        cliente.currentRow.IDUTDIAPGTCL = 'E';
    };

    self.justInteger = function (campos){
        campos.forEach(function(campo){
           General.justInteger(campo);
        });
    };

    self.setFiltroSearchInstrucoes = function (widget){
        var banco = widget.currentRow.CDBANCO;
        if (banco) {
            widget.getField("NMINSTCOBR1").readOnly = false;
            widget.getField("NMINSTCOBR2").readOnly = false;
            widget.getField("NMINSTCOBR1").dataSourceFilter[0] = {"name": "CDBANCO", "operator": "=", "value": banco};
            widget.getField("NMINSTCOBR2").dataSourceFilter[0] = {"name": "CDBANCO", "operator": "=", "value": banco};
        }else{
            widget.getField("NMINSTCOBR1").readOnly = true;
            widget.getField("NMINSTCOBR2").readOnly = true;
            widget.getField("NMINSTCOBR1").setValue('');
            widget.getField("NMINSTCOBR2").setValue('');
            widget.getField("NMINSTCOBR1").dataSourceFilter = [];
            widget.getField("NMINSTCOBR2").dataSourceFilter = [];
        }
        widget.getField("NMINSTCOBR1").reload();
        widget.getField("NMINSTCOBR2").reload();
    };

   /* self.setFiltroSearchInstrucoes = function (widget){
        widget.parent.widgets[4].getField('NMINSTCOBR1').dataSourceFilter[0].value = widget.currentRow.CDBANCO;
    };*/

    self.mascaraPercentual = function (field){
        var pos = field.value().indexOf(",");
        var vrpercpgtocl = field.value().replace(",", ".");
        if (vrpercpgtocl > 100){
            ScreenService.showMessage("Valor deve ser inferior a 100.");
            field.widget.currentRow.VRPERCPGTOCL = field.widget.backupRow.VRPERCPGTOCL;
        }else{
            if (pos != -1){
                field.widget.currentRow.VRPERCPGTOCL = vrpercpgtocl;
            }
        }
    };

    self.setCurrentRowForm = function (widget){
        if (widget.dataSource.data.length) {
            widget.currentRow = widget.dataSource.data[0];
        }
    };

    self.reloadEndereco = function(widget){
        widget.reload();
    };

    self.setDataSourceFilho = function(){
        var widgetPai = templateManager.container.getWidget('cliente');
        widgetPai.widgets.forEach(
            function (filha){
                if(filha.name != 'filterPopup') filha.dataSourceFilter[0].value = widgetPai.currentRow.CDCLIENTE;
            }
        );
        templateManager.container.getWidget('modopagamento').dataSourceFilter[0].value = widgetPai.currentRow.CDCLIENTE;
        templateManager.container.getWidget('parametrizacao').reload([],false);
    };

    self.setFieldsOpcaoPagamento = function(widget){
        switch(widget.currentRow.IDTPFORPGTCL){
            case "V": self.habilitaGrid(widget.widgets[0]);
                self.formaPagamento(widget);
                break;
            case "F": self.pagamentoFixo(widget);
                self.desabilitaGrid(widget.widgets[0]);
                break;
            default: self.desabilitaGrid(widget.widgets[0]);
                self.desabilitaFields(widget);
                break;
        }
    };

    self.desabilitaFields = function(widget){
        widget.getField('NRDIAPGFIXCL').isVisible = false;
        widget.getField('NRPARCPGTOCL').isVisible = false;
        widget.getField('IDUTDIAPGTCL').isVisible = false;
        widget.getField('NMFORMPGTO').isVisible = false;
    };

    self.pagamentoFixo = function(widget){
        widget.getField('NRDIAPGFIXCL').isVisible = true;
        widget.getField('NRPARCPGTOCL').isVisible = true;
        widget.getField('IDUTDIAPGTCL').isVisible = true;
        widget.getField('NMFORMPGTO').isVisible = false;
    };

    self.formaPagamento = function(widget){
        widget.getField('NRDIAPGFIXCL').isVisible = false;
        widget.getField('NRPARCPGTOCL').isVisible = false;
        widget.getField('IDUTDIAPGTCL').isVisible = false;
        widget.getField('NMFORMPGTO').isVisible = true;
    };

    self.desabilitaGrid = function(widget){
        widget.isVisible = false;
        widget.getAction('SAVE').isVisible= true;
        widget.getAction('ADD').isVisible= false;
    };

    self.habilitaGrid = function(widget){
        widget.isVisible = true;
        widget.getAction('SAVE').isVisible= false;
        widget.getAction('ADD').isVisible= true;
    };

    self.checkAddress = function(widget) {
        var bairro = null;
        if (widget.name.localeCompare('interlocutores') === 0){
            bairro = 'NMBAIRINCLIE';
        }else{
            bairro = 'NMBAIRCLIE';
        }
        var reload = self.atualizafiltroEndereco(widget, bairro);

        if(reload[0]) {
            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = null;

            if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

            widget.getField("NMESTADO").reload();
        }

        if(reload[1]) {
            widget.currentRow.CDMUNICIPIO = null;
            widget.currentRow.NMMUNICIPIO = null;

            if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

            widget.getField("NMMUNICIPIO").reload();
        }

        if(reload[2]) {
            widget.currentRow.CDBAIRRO = null;
            if (widget.name.localeCompare('interlocutores') === 0){
                widget.currentRow.NMBAIRINCLIE = null;
            }else{
                widget.currentRow.NMBAIRCLIE = null;
            }
            if(!widget.currentRow.CDMUNICIPIO)
                widget.getField(bairro).readOnly = true;

            widget.getField(bairro).reload();
        }
    };

    self.atualizafiltroEndereco = function(widget, bairro) {
        var reload =  [false, false, false];

        if(widget.currentRow.CDPAIS) {
            widget.getField("NMESTADO").readOnly = false;

            if(widget.getField("NMESTADO").dataSourceFilter[0])
                if(widget.getField("NMESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

            widget.getField("NMESTADO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};

            if(widget.currentRow.SGESTADO) {
                widget.getField("NMMUNICIPIO").readOnly = false;

                if(widget.getField("NMMUNICIPIO").dataSourceFilter[0])
                    if(widget.getField("NMMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("NMMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

                widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};
                widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": widget.currentRow.SGESTADO};

                if(widget.currentRow.CDMUNICIPIO) {
                    widget.getField(bairro).readOnly = false;

                    if(widget.getField(bairro).dataSourceFilter[0])
                        if(widget.getField(bairro).dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField(bairro).dataSourceFilter[1].value != widget.currentRow.SGESTADO || widget.getField(bairro).dataSourceFilter[2].value != widget.currentRow.CDMUNICIPIO) reload[2] = true;

                    widget.getField(bairro).dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};
                    widget.getField(bairro).dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": widget.currentRow.SGESTADO};
                    widget.getField(bairro).dataSourceFilter[2] = {"name": "CDMUNICIPIO", "operator": "=", "value": widget.currentRow.CDMUNICIPIO};
                } else reload[2] = true;
            } else reload[1] = reload[2] = true;
        } else reload[0] = reload [1] = reload[2] = true;

        return reload;
    };

    self.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    self.getFieldById = function(widget, id) {
        return widget.fields.filter(function(field) {
            return field.id == id;
        })[0];
    };

    self.validateCPF = function(CPF) {
        if(CPF === '') return false;

        if (CPF.length != 11)
            return false;

        if (CPF == "00000000000" ||
            CPF == "11111111111" ||
            CPF == "22222222222" ||
            CPF == "33333333333" ||
            CPF == "44444444444" ||
            CPF == "55555555555" ||
            CPF == "66666666666" ||
            CPF == "77777777777" ||
            CPF == "88888888888" ||
            CPF == "99999999999") return false;

        var soma;
        var resto;
        soma = 0;

        for (i=1; i<=9; i++) soma = soma + parseInt(CPF.substring(i-1, i)) * (11 - i);
        resto = (soma * 10) % 11;

        if ((resto == 10) || (resto == 11))  resto = 0;
        if (resto != parseInt(CPF.substring(9, 10)) ) return false;

        soma = 0;
        for (i = 1; i <= 10; i++) soma = soma + parseInt(CPF.substring(i-1, i)) * (12 - i);
        resto = (soma * 10) % 11;

        if ((resto == 10) || (resto == 11))  resto = 0;
        if (resto != parseInt(CPF.substring(10, 11) ) ) return false;
        return true;
    };

    self.validateCNPJ = function(CNPJ) {
        if(CNPJ === '') return false;

        if (CNPJ.length != 14)
            return false;

        if (CNPJ == "00000000000000" ||
            CNPJ == "11111111111111" ||
            CNPJ == "22222222222222" ||
            CNPJ == "33333333333333" ||
            CNPJ == "44444444444444" ||
            CNPJ == "55555555555555" ||
            CNPJ == "66666666666666" ||
            CNPJ == "77777777777777" ||
            CNPJ == "88888888888888" ||
            CNPJ == "99999999999999")
            return false;

        tamanho = CNPJ.length - 2;
        numeros = CNPJ.substring(0,tamanho);
        digitos = CNPJ.substring(tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0))
            return false;

        tamanho = tamanho + 1;
        numeros = CNPJ.substring(0,tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1))
            return false;

        return true;
    };

    self.masterDetailCancelForm = function(widget) {

        if(self.formChangeTemplate(widget) && widget.parent) {
            var widgets = widget.parent.widgets;

            self.changeWidgetAcessibility(widgets.concat(widget.parent), true);
        } else self.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    self.masterDetailEdit = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if(!widget.editing) {
            if(self.formChangeTemplate(widget) && widget.parent) {
                var widgets = widget.parent.widgets;

                self.changeWidgetAcessibility(widgets.filter(function(w) {return w.name != widget.name;}).concat(widget.parent), false);
            } else self.changeWidgetAcessibility(widget.widgets, false);

            widget.backupRow = Util.clone(widget.currentRow);
            widget.edit();
        }
    };

    self.masterDetailGoBackToList = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };

    /*self.testezinho = function(){
        var fields = [];
        prazopgtclie.fields.forEach(function(field){
            if (field.name.substr(0, field.name.length - 2) == "NRDIASPGTOCL"){
                fields.push(field.name)
            }
        });
    };*/

    self.masterDetailGoBackToParent = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function(){
            widget.parent.list();
            widget.parent.activate();
        });
    };

    self.masterDetailNewRow = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        self.changeWidgetAcessibility(widget.widgets, false);

        widget.newRow();
    };

    self.setCdcliente = function (widget){
        widget.currentRow.CDCLIENTE = widget.dataSourceFilter[0].value;
    };

    self.validaTipoPrincipal = function(widget){
        var existe = false;
        widget.dataSource.data.forEach(function(data){
            if (widget.currentRow.IDPRBASEPRIN == "S" && data.IDPRBASEPRIN == "S" && data.CDPRECOBASE != widget.currentRow.CDPRECOBASE){
                existe = true;
            }
        });
        return existe;
    };

    self.validaDiaPagamento = function(widget){
        Ger00700_Cliente_Service.validaDiaPagamento(widget);
    };

    self.masterDetailSave = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }

            widget.saveRow().then(function(response){
                widget.currentRow.changed = false;

                if(self.formChangeTemplate(widget) && widget.parent) {
                    widget.view();

                    var widgets = widget.parent.widgets;
                    self.changeWidgetAcessibility(widgets.concat(widget.parent), true);
                } else {

                    if(widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                        widget.list();
                    } else widget.view();

                    self.changeWidgetAcessibility(widget.widgets, true);
                }

                if(widget.currentRow.__is_new) {
                    widget.currentRow.__is_new = false;
                } else{
                    widget.reload([],false);
                }
            }.bind(self), function(error) {
                var errorMessage = 'Timeout';

                if (error.data) errorMessage = error.data.error;

                ScreenService.showMessage(errorMessage);
            });

        } else return false;
    };

    self.formChangeTemplate = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.unMask = function(str) {
        if(typeof str === 'string' && str.indexOf('R$') != -1)
            str = $.currency.unmaskString(str, {"thousands": "."});
        else if(typeof str === 'string' && str.indexOf('%') != -1)
            str = parseFloat(str.replace(',', '.'));
        else str = str.replace(/[\D]+/g,'');
        return str;
    };


    //---------------------------------------


    self.endeClieValidarCep = function(widget, CEP) {
        if(CEP.length == 10) {
            Endereco.buscarCep(CEP).then(function(response) {
                var endereco = response.dataset.ENDERECO;
                var reload = Array();
                self.setDataSourceEndereco(widget, endereco);
                if(endereco) {
                    widget.currentRow.CDPAIS = (endereco.CDPAIS)? endereco.CDPAIS : '';
                    widget.currentRow.NMPAIS = (endereco.NMPAIS)? endereco.NMPAIS : '';
                    widget.currentRow.SGESTADO = (endereco.SGESTADO)? endereco.SGESTADO : '';
                    
                    widget.currentRow.NMESTADO = (endereco.NMESTADO)? endereco.NMESTADO : '';
                    if(endereco.NMESTADO) {
                        reload[0] = true;
                    }
                    
                    widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO)? endereco.CDMUNICIPIO : '';
                    widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO)? endereco.NMMUNICIPIO : '';
                    if(endereco.NMMUNICIPIO) {
                        reload[1] = true;
                    }
                    
                    widget.currentRow.CDBAIRCLIE = (endereco.CDBAIRRO)? endereco.CDBAIRRO : '';
                    widget.currentRow.NMBAIRINCLIE = (endereco.NMBAIRRO)? endereco.NMBAIRRO : '';
                    widget.currentRow.NMBAIRCLIE = widget.currentRow.NMBAIRINCLIE;
                    if(endereco.NMBAIRRO) {
                        reload[2] = true;
                    }
                    
                    if (widget.name == 'interlocutores'){
                        var logradouro = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';
                        var dsendeinclie = (endereco.DSENDERECO)? endereco.DSENDERECO : '';
                        widget.currentRow.DSENDEINCLIE = logradouro + " " + dsendeinclie;
                    }else{
                        widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO)? endereco.CDLOGRADOURO : '';
                        widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';
                        widget.currentRow.DSENDECLIE = (endereco.DSENDERECO)? endereco.DSENDERECO : '';
                    }
                } else if(!endereco || response.dataset.ERRO) {
                    if (widget.name == 'interlocutores'){
                        widget.currentRow.NRCEPINCLIE = '';
                    }else {
                        widget.currentRow.NRCEPCLIE = '';
                    }
                }

                if(response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");

                if(reload[0]) {
                    if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;
                    widget.getField("NMESTADO").reload();
                }

                if(reload[1]) {
                    if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;
                    widget.getField("NMMUNICIPIO").reload();
                }

                if(reload[2]) {
                    var bairro = null;
                    if (widget.name.localeCompare('interlocutores') === 0){
                        bairro = widget.currentRow.NMBAIRINCLIE;
                    }else{
                        bairro = widget.currentRow.NMBAIRCLIE;
                    }
                    if(!widget.currentRow.CDMUNICIPIO) widget.getField(bairro).readOnly = true;

                    var nomeCampoBairro =  (widget.name ==='endprinc' || widget.name === 'endereco') ?'NMBAIRCLIE':'NMBAIRINCLIE';
                    widget.getField(nomeCampoBairro).reload();
                }

            }.bind(self), function(error) {
                var errorMessage = 'Timeout';

                if(error.data) errorMessage = error.data.error;
                else if(error) errorMessage = error;

                ScreenService.showMessage(errorMessage);
            });
        }
    };

    self.setDataSourceEndereco = function(widget, endereco){
        if (widget.name.localeCompare('interlocutores') === 0){
            bairro = "NMBAIRINCLIE";
        }else{
            bairro = "NMBAIRCLIE";
        }
        widget.getField("NMESTADO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": endereco.CDPAIS};
        widget.getField("NMESTADO").readOnly = false;
        widget.getField("NMESTADO").reload();
        widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": endereco.CDPAIS};
        widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": endereco.SGESTADO};
        widget.getField("NMMUNICIPIO").readOnly = false;
        widget.getField("NMMUNICIPIO").reload();
        widget.getField(bairro).dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": endereco.CDPAIS};
        widget.getField(bairro).dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": endereco.SGESTADO};
        widget.getField(bairro).dataSourceFilter[2] = {"name": "CDMUNICIPIO", "operator": "=", "value": endereco.CDMUNICIPIO};
        widget.getField(bairro).readOnly = false;
        widget.getField(bairro).reload();
    };

    self.validatePessoaJurFis = function(widget) {
        var inscricao = widget.currentRow.NRINSJURCLIE;
        var tipoInscricao = widget.currentRow.IDTPIJURCLIE;
        if(!widget) widget = templateManager.container.getWidget('cliente');

        if(tipoInscricao == 'F' && !self.validateCPF(self.unMask(inscricao)) && inscricao) {
            ScreenService.showMessage('CPF Inválido', 'warning');
            widget.currentRow.NRINSJURCLIE = '';
        } else if(tipoInscricao == 'J' && !self.validateCNPJ(self.unMask(inscricao)) && inscricao) {
            ScreenService.showMessage('CNPJ Inválido', 'warning');
            widget.currentRow.NRINSJURCLIE = '';
        }
    };

    this.salvarObservacao  = function(widget){
        if(widget.isValid()){
            /**
             * Alterado para atender o cliente TecGeo
             *
             * Campo DSOBSERVCLIE (Long Raw) estourando quando atinge 4000 caracteres;
             * 
             * Foi necessário tirar a integração Delphi x Mobile para funcionar;
             * 
             * Basicamente o Mobile lê o que existe no Delphi e converte para HTML
             * uma vez salvo, ambos não integram mais;
             */
            //widget.currentRow.DSOBSERVCLIE_CLOB = widget.currentRow.DSOBSERVCLIE;
            
            if(widget.currentRow.__is_new)
                widget.currentRow.CDCLIENTE = widget.parent.currentRow.CDCLIENTE;
            
            General.callRestEngine('ped#/salvarObservacaoCliente','Row', widget.currentRow ).then(
                function (response)  {
                    widget.activate();
        			if (widget.currentRow.__is_new) {
        				widget.list(true);
        				ScreenService.goBack();
        				widget.reload();
        			} else {
        				widget.computeDescriptionOrder();
        				widget.view();
        			}
                },
                function (callback) {
    				if (callback.data) {
    					ScreenService.showMessage(callback.data.error);
    				}
    			}  
            );
        }
    };
    
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('Ger00700_Cliente_Controller', Ger00700_Cliente_Controller);
});

// FILE: ./assets/js/controllers/ped00600_Vendedor_Controller.js
var Ped00600_Vendedor_Controller = function (ScreenService, restEngine, General, Endereco, templateManager, ZHPromise) {

	this.setDataSourceFilter = function (widget) {
		if (!widget.currentRow){
			widget.currentRow = {};
		}
		widget.currentRow.CDVENDEDOR = widget.getParent().currentRow.CDVENDEDOR;
		widget.dataSourceFilter = [
			{
				name: "CDVENDEDOR",
				operator: "=",
				value: widget.getParent().currentRow.CDVENDEDOR
            }
        ];
		widget.reload();
	};

	this.setMaxLangth = function (widget) {
		if (widget.currentRow.IDTPIJURVEN === "F") {
			widget.getField("NRINSJURVEN").maxlength = 11;
		} else {
			widget.getField("NRINSJURVEN").maxlength = 14;
		}
	};

	this.CarregaEndereco = function (args) {
		if (args.owner.dataSource.data[0] === undefined) {
			args.owner.currentRow = {
				CDVENDEDOR: args.owner.getParent().currentRow.CDVENDEDOR
			};
			args.owner.currentRow.__is_new = true;
		} else {
			args.owner.currentRow = args.owner.dataSource.data[0];
		}
	};

	this.validaPorcentagem = function (widget, campo) {
		var currentRow = widget.currentRow;
		switch (campo) {
		case 1:
			if (currentRow.VRPEMAXDESVE >= 100) {
				ScreenService.showMessage('O valor tem que está entre 0,01% e 99,99%');
				currentRow.VRPEMAXDESVE = "";
			}
			break;

		case 2:
			if (currentRow.VRPECOMVEN >= 100) {
				ScreenService.showMessage('O valor tem que está entre 0,01% e 99,99%');
				currentRow.VRPECOMVEN = "";
			}
			break;

		case 3:
			if (currentRow.VRCOMPROVEND >= 100) {
				ScreenService.showMessage('O valor tem que está entre 0,01% e 99,99%');
				currentRow.VRCOMPROVEND = "";
			}
			break;
		}
	};

	this.validaEmail = function (widget) {
		var currentRow = widget.currentRow;
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		if (!re.test(currentRow.DSEMAILVEN)) {
			ScreenService.showMessage('Email Invalido');
			currentRow.DSEMAILVEN = "";
		}
	};

	this.editar = function (widget) {
		widget.edit();
		widget.template = "widget/form.html";
		templateManager.updateTemplate();
		
		var widgetsToDeactivate = widget.parent.widgets;
	
		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		false);
	
		if (!widget.currentRow.__is_new) {
			widget.getField('NMESTADO').readOnly = false;
			widget.getField('NMMUNICIPIO').readOnly = false;
			widget.getField('NMBAIRVEN').readOnly = false;
		} else {
			widget.getField('NMESTADO').readOnly = true;
			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMBAIRVEN').readOnly = true;
		}
	};

	this.cancelar = function (widget) {
		widget.template = widget.templateToView;
		
		var widgetsToDeactivate = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
		
		widget.view();
	};

	this.salvar = function (widget) {
		if (widget.isValid()) {
			widget.currentRow.NRCEPVEN = this.removeInscricaoMask(widget.currentRow.NRCEPVEN);

			if (widget.currentRow.NRCELULARVEN)
				widget.currentRow.NRCELULARVEN = this.removeInscricaoMask(widget.currentRow.NRCELULARVEN);

			if (widget.currentRow.NRTELRESIVEN)
				widget.currentRow.NRTELRESIVEN = this.removeInscricaoMask(widget.currentRow.NRTELRESIVEN);

			if (widget.currentRow.NRFAXVEN)
				widget.currentRow.NRFAXVEN = this.removeInscricaoMask(widget.currentRow.NRFAXVEN);

			if (widget.currentRow.NRTELEVEN)
				widget.currentRow.NRTELEVEN = this.removeInscricaoMask(widget.currentRow.NRTELEVEN);

			General.saveCrud(widget);
			widget.template = widget.templateToView;
			
			var widgetsToDeactivate = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
			
			widget.view();
		}
	};

	this.salvarNovoVendedor = function (widget) {
		widget.currentRow.NRINSJURVEN = this.removeInscricaoMask(widget.currentRow.NRINSJURVEN);
		General.saveCrud(widget);
	};

	this.removeInscricaoMask = function (inscricao) {

		if (!Util.isEmptyOrBlank(inscricao)){
			return inscricao.replace(/[^0-9]/g, "");
		}

	};

	this.setIDTPENDEVEN = function (widget) {
		widget.currentRow.IDTPENDEVEN = "P";
	};

	this.endeVendValidarCep = function (widget, CEP) {
		if (CEP.length == 10) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				this.setDataSourceEndereco(widget, endereco);
				if (endereco) {
					widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
					widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
					widget.currentRow.NMBAIRVEN = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
					// widget.currentRow.NMBAIRCLIE = widget.currentRow.NMBAIRINCLIE;
					var logradouro;
					var dsendeinclie;
					if (widget.name == 'interlocutores') {
						logradouro = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						dsendeinclie = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.DSENDEINCLIE = logradouro + " " + dsendeinclie;
					} else {
						widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
						widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						widget.currentRow.DSENDECLIE = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
					}
					if (widget.name === 'ped00600_vendedor_endereco'){
						logradouro = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						dsendeinclie = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.DSENDEVEN = logradouro + " " + dsendeinclie;
					}
				} else if (!endereco || response.dataset.ERRO) {
					if (widget.name == 'interlocutores') {
						widget.currentRow.NRCEPINCLIE = '';
					} else {
						widget.currentRow.NRCEPCLIE = '';
					}
				}

				if (response.dataset.ERRO){ 
					ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
				}

			}.bind(this)).catch(function(error){
				ScreenService.showMessage('CEP inválido');
				widget.currentRow.NRCEPVEN = "";
				widget.currentRow.DSENDEVEN = "";
				widget.currentRow.CDPAIS = "";
				widget.currentRow.NMPAIS = "";
				widget.currentRow.SGESTADO = "";
				widget.currentRow.NMESTADO = "";
				widget.currentRow.CDMUNICIPIO = "";
				widget.currentRow.NMMUNICIPIO = "";
				widget.currentRow.CDBAIRRO = "";
				widget.currentRow.NMBAIRVEN = "";
				widget.getField('NMESTADO').readOnly = true;
				widget.getField('NMMUNICIPIO').readOnly = true;
				widget.getField('NMBAIRVEN').readOnly = true;
			});
		}
	};

	this.setDataSourceEndereco = function (widget, endereco) {
		if (widget.name.localeCompare('interlocutores') === 0) {
			bairro = "NMBAIRINVEN";
		} else {
			bairro = "NMBAIRVEN";
		}
		widget.getField("NMESTADO").dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField("NMESTADO").readOnly = false;
		widget.getField("NMESTADO").reload();
		widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
			"name": "SGESTADO",
			"operator": "=",
			"value": endereco.SGESTADO
		};
		widget.getField("NMMUNICIPIO").readOnly = false;
		widget.getField("NMMUNICIPIO").reload();
		widget.getField(bairro).dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField(bairro).dataSourceFilter[1] = {
			"name": "SGESTADO",
			"operator": "=",
			"value": endereco.SGESTADO
		};
		widget.getField(bairro).dataSourceFilter[2] = {
			"name": "CDMUNICIPIO",
			"operator": "=",
			"value": endereco.CDMUNICIPIO
		};
		widget.getField(bairro).readOnly = false;
		widget.getField(bairro).reload();
	};

	this.checkAddress = function (widget) {
		var bairro = null;
		if (widget.name.localeCompare('interlocutores') === 0) {
			bairro = 'NMBAIRVEN';
		} else {
			bairro = 'NMBAIRVEN';
		}
		var reload = this.atualizafiltroEndereco(widget, bairro);

		if (reload[0]) {
			widget.currentRow.SGESTADO = null;
			widget.currentRow.NMESTADO = null;

			if (!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

			widget.getField("NMESTADO").reload();
		}

		if (reload[1]) {
			widget.currentRow.CDMUNICIPIO = null;
			widget.currentRow.NMMUNICIPIO = null;

			if (!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

			widget.getField("NMMUNICIPIO").reload();
		}

		if (reload[2]) {
			widget.currentRow.CDBAIRRO = null;
			if (widget.name.localeCompare('interlocutores') === 0) {
				widget.currentRow.NMBAIRVEN = null;
			} else {
				widget.currentRow.NMBAIRVEN = null;
			}
			if (!widget.currentRow.CDMUNICIPIO)
				widget.getField(bairro).readOnly = true;

			widget.getField(bairro).reload();
		}
	};

	this.atualizafiltroEndereco = function (widget, bairro) {
		var reload = [false, false, false];

		if (widget.currentRow.CDPAIS) {
			widget.getField("NMESTADO").readOnly = false;

			if (widget.getField("NMESTADO").dataSourceFilter[0])
				if (widget.getField("NMESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

			widget.getField("NMESTADO").dataSourceFilter[0] = {
				"name": "CDPAIS",
				"operator": "=",
				"value": widget.currentRow.CDPAIS
			};

			if (widget.currentRow.SGESTADO) {
				widget.getField("NMMUNICIPIO").readOnly = false;

				if (widget.getField("NMMUNICIPIO").dataSourceFilter[0])
					if (widget.getField("NMMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("NMMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

				widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
					"name": "CDPAIS",
					"operator": "=",
					"value": widget.currentRow.CDPAIS
				};
				widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
					"name": "SGESTADO",
					"operator": "=",
					"value": widget.currentRow.SGESTADO
				};

				if (widget.currentRow.CDMUNICIPIO) {
					widget.getField(bairro).readOnly = false;

					if (widget.getField(bairro).dataSourceFilter[0])
						if (widget.getField(bairro).dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField(bairro).dataSourceFilter[1].value != widget.currentRow.SGESTADO || widget.getField(bairro).dataSourceFilter[2].value != widget.currentRow.CDMUNICIPIO) reload[2] = true;

					widget.getField(bairro).dataSourceFilter[0] = {
						"name": "CDPAIS",
						"operator": "=",
						"value": widget.currentRow.CDPAIS
					};
					widget.getField(bairro).dataSourceFilter[1] = {
						"name": "SGESTADO",
						"operator": "=",
						"value": widget.currentRow.SGESTADO
					};
					widget.getField(bairro).dataSourceFilter[2] = {
						"name": "CDMUNICIPIO",
						"operator": "=",
						"value": widget.currentRow.CDMUNICIPIO
					};
				} else reload[2] = true;
			} else reload[1] = reload[2] = true;
		} else reload[0] = reload[1] = reload[2] = true;

		return reload;
	};

	this.validateCpfCnpj = function (widget) {

		var currentRow = widget.currentRow;

		var resultValidate = General.inscricaoFormat(currentRow.NRINSJURVEN);

		if (resultValidate.valid && resultValidate.value) {

			currentRow.NRINSJURVEN = resultValidate.value;

		} else {
			if (resultValidate.tipo.cod == 'F') {

				ScreenService.showMessage('CPF Invalido');
				currentRow.NRINSJURVEN = "";

			} else {

				ScreenService.showMessage('CNPJ Invalido');
				currentRow.NRINSJURVEN = "";

			}
		}

	};
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ped00600_Vendedor_Controller', Ped00600_Vendedor_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped00100_lancamentoPedido_Controller.js
var  Ped00100_lancamentoPedido_Controller = function(ScreenService, General, Ped00100_lancamentoPedido_Service, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, ZhFilterPreferences, Exp00200_lancamentoExpedicaoPedido_Service, MessageService){

    this.dataProduto   = [];
    this.prazos        = [];
    this.vendedor      = [];
    this.filialLogada  = [];
    this.parametros    = [];
    this.nmrItemPed    = '0000000001';
    this.backupItem    = [];
    this.checkedRows   = [];
    this.pedidoFilter  = [];
    this.widgetPopup = [];
    this.pedidoFilterRow = []; 

    this.bypassPendencia = false;
    
    this.vendPedAux = false;

    this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
    };

    this.retornaOperadorLogadoDesk = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        var params = {
            "requestType": "FilterData",
            "filter": filter
        };

        return restEngine.request("ped#/crud/operador", params);
    };
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - DESKTOP

     
    this.testFiltro = function (widget) {
        if (widget.dataSourceFilter.length <= 0 ) {
            return false;
        } else {
            return true;
        }
    }; 
    

    /* (function/propriedade PedidoEhNovo)
        Função altamente requisitada para realizar fluxos distintos para cada Status:
        Se o Pedido esta para ser cadastrado(Novo) ou já foi cadastrado(Não é novo)
    */
    this.PedidoEhNovo = function() {
        var pedido = templateManager.container.getWidget('widgetPedido');
        return pedido.currentRow.__is_new;
       
    };
    

    // this.openFilterTitulosAPagar = function(widgetPedidos){
    this.startFiltering = function(widgetPedidos){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widgetPedidos);
        }.bind(this)); 
        this.setFilterDataSourceVazio();
    };
    this.setFilterDataSourceVazio = function(){
        var widget = templateManager.container.getWidget('widgetPedido');
        widget.dataSourceFilter[0] = {
            "name": "CDFILIAL",
			"operator": "=",
			"value": ""
        };
   
    };
    
    this.setFieldStatusPed = function(widget){
        var data = templateManager.container.getActiveWidget().dataSourceFilter;
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        var statusPed = widget.appliedFilter.FILTER_ROW.STATUS_PED;
        var sitPedido = widget.appliedFilter.FILTER_ROW.IDSITPEDIDO;

        if(statusPed == 2 && sitPedido.length == 1){
            widget.currentRow.STATUS_PED = "CONFIRMADO";
            data.push(
                {
            		"name": "STATUS_PED",
            		"operator": "=",
            		"value": widget.currentRow.STATUS_PED,
            		"isCustomFilter": true
            	}
            );
            
            
        }else if(statusPed == 3 && sitPedido.length == 1){
            widget.currentRow.STATUS_PED = "APROVADO";
            data.push(
                {
            		"name": "STATUS_PED",
            		"operator": "=",
            		"value": widget.currentRow.STATUS_PED,
            		"isCustomFilter": true
            	}
            );

        }else if (statusPed == 3 || statusPed == 2 && sitPedido.length >1 ){
            if (statusPed == 3){
               widget.currentRow.STATUS_PED = ["APROVADO", "OUTROS"];
                data.push(
                    {
                		"name": "STATUS_PED",
                		"operator": "IN",
                		"value": widget.currentRow.STATUS_PED,
                		"isCustomFilter": true
                	}
                ); 
            }else if(statusPed == 2){
                widget.currentRow.STATUS_PED = ["CONFIRMADO", "OUTROS"];
                data.push(
                    {
                		"name": "STATUS_PED",
                		"operator": "IN",
                		"value": widget.currentRow.STATUS_PED,
                		"isCustomFilter": true
                	}
                );
            }
            
        }
        
        widgetPedido.reload();

    };
    
    this.enableStatusPed = function(){
        var widget = templateManager.container.getActiveWidget();
        var sitPedido = widget.currentRow.IDSITPEDIDO;
        
        var situacao = sitPedido.filter(element => element == 2);
        
        if (situacao.length > 0){
            widget.getField('STATUS_PED').isVisible = true;
            widget.getField('IDSITPEDIDO').class = '4';
            widget.getField('NRPEDIDO').class = '4';
            widget.getField('STATUS_PED').reload();
            
        }else{
            widget.getField('STATUS_PED').isVisible = false;
            widget.getField('STATUS_PED').clearValue();
            widget.getField('STATUS_PED').reload();
            widget.getField('IDSITPEDIDO').class = '6';
            widget.getField('NRPEDIDO').class = '6';

        }

    };
    
    
    this.setFilter = function(widget) {
        this.verifyParameters(widget);
        var filterRow = {};
        
        var NDate = new Date();
        var today = NDate.getDate() + "/" + parseInt(NDate.getMonth()+1)+ "/" + NDate.getFullYear();
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : today
        };
        
        filterRow.DTPEDIDO = interval;
        
        // filterRow.IDSITPEDIDO   = ['1','2', '3', '4', '5', '6', '7', '8'];
        // filterRow.P_STATUSITEM = ['1','2', '3', '4', '5', '6', '7'];
        var filial;
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            filial = response.dataset.filial[0].CDFILIAL;
            
            templateManager.container.getActiveWidget().currentRow = filterRow;
            
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filial
                }
            ];
            
            General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
                if(!callback.dataset.parampedido[0]) {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                    for(var i = 0; i < widget.actions.length; i++) {
                        widget.actions[i].isVisible = false;
                    }
                }else{
                    
                    var widgetFiltro = templateManager.container.getActiveWidget();
                    
                    if (callback.dataset.parampedido[0].IDOBRTPOPPED == 'N'){
                        widgetFiltro.getField('NMTIPOOPER').requiredParam = false;
                        widgetFiltro.getField('NMTIPOOPER').isVisible = false;
                        if(widget.getField('NMTIPOOPER').validations) {
                            delete widgetFiltro.getField('NMTIPOOPER').validations;
                        }
                    } else {
                        widgetFiltro.getField('NMTIPOOPER').requiredParam = true;
                        widgetFiltro.getField('NMTIPOOPER').isVisible = true;

                        // widgetFiltro.getField('NMTIPOOPER').validations = {
                        //     required: true
                        // };
                    }
                }
                
            }.bind(this));
            
        }.bind(this));
        
    };
    
    this.changeUnidade = function(widget) {
         
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }];

        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
            if(callback.dataset.parampedido[0]) {
               if (callback.dataset.parampedido[0].IDOBRTPOPPED == 'N'){
                    widget.getField('NMTIPOOPER').requiredParam = false;
                    widget.getField('NMTIPOOPER').isVisible = false;
                    if(widget.getField('NMTIPOOPER').validations) {
                        delete widget.getField('NMTIPOOPER').validations;
                    }
                } else {
                    widget.getField('NMTIPOOPER').requiredParam = true;
                    widget.getField('NMTIPOOPER').isVisible = true;
                    // widget.getField('NMTIPOOPER').validations = {
                    //     required: true
                    // };
                }
            }
                
        }.bind(this));
     };
    

    /*this.fixFilterStatus = function() {
        var widget = templateManager.container.getActiveWidget();
        if (widget.currentRow.IDSITPEDIDO.indexOf('7') >= 0 && widget.currentRow.IDSITPEDIDO.indexOf('2') < 0) {
            widget.currentRow.ITENS_CONF = '0';
            widget.currentRow.IDSITPEDIDO = widget.currentRow.IDSITPEDIDO.splice( widget.currentRow.IDSITPEDIDO.indexOf('7') ,1);
        }
        if (widget.currentRow.IDSITPEDIDO.indexOf('8') >=0 && widget.currentRow.IDSITPEDIDO.indexOf('2') < 0) {
            widget.currentRow.ITENS_APROV = '0';
            widget.currentRow.IDSITPEDIDO = widget.currentRow.IDSITPEDIDO.splice( widget.currentRow.IDSITPEDIDO.indexOf('8') ,1);
        }
    };*/
    
    this.verifyParameters = function(widget) {

        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            var filter = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": response.dataset.filial[0].CDFILIAL
            }];

            var wid = widget;
            General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
                var wid = widget;
                if(!callback.dataset.parampedido[0]) {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                    for(var i = 0; i < wid.actions.length; i++) {
                        wid.actions[i].isVisible = false;
                    }
                } else {
                    widget.limitePendencia = parseInt(callback.dataset.parampedido[0].NRDIAPENDFIN);
                    if (callback.dataset.parampedido[0].CDGROPERAPRO != null) {
                        widget.grupOperApro = callback.dataset.parampedido[0].CDGROPERAPRO;
                    }
                    widget.idPend = callback.dataset.parampedido[0].IDPENDFINAN;
                    widget.idSitu = callback.dataset.parampedido[0].IDSITUFINAN;
                    
                    this.verificaParamsPedido(callback.dataset.parampedido[0], wid);
                }
            }.bind(this));
        }.bind(this));
    }; 

    this.verificaParamsPedido = function (parametros, wid) {
        
        // =====
        //Verifica se habilita botão de Adicionar Vendedor
        this.btnVendedoresAdicionais(wid,parametros);
        // =====
        
        if (parametros.IDEXCLPEDIDO == 'N') {
            wid.getAction('excluirPedido').isVisible = false;
        }else{
            wid.getAction('excluirPedido').isVisible = true;
        }
        if ( parametros.IDOBRTPOPPED == 'N'){
            wid.getField('NMTIPOOPER').isVisible = false;
            wid.getField('NMTIPOOPER').validations = {};
        }
        wid.IDEXCLPEDIDO = parametros.IDEXCLPEDIDO;
        wid.IDPENDFINANLANC = parametros.IDPENDFINANLANC;
        wid.IDPENDFINAN = parametros.IDPENDFINAN;
        if (parametros.IDEXIBPEDIDO && parametros.IDEXIBPEDIDO == '2') {
            this.retornaOperadorLogadoDesk().then(function(operador){
                var cdoperador = operador.dataset.operador[0].CDOPERADOR;
                var filterOper = [
                    {
                        name: 'CDOPERADOR',
                        operator: '=',
                        value: cdoperador
                    }
                ];
                var filter_autgrupop = [
                    {
                        name: 'IDAUTGRUPOP',
                        operator: '=',
                        value: 'TPED'
                    },
                    {
                        name: 'CDFILIAL',
                        operator: '=',
                        value: parametros.CDFILIAL
                    }
                ];
                var filter_vendedor = [
                    {
                        name: 'CDOPERADOR',
                        operator: '=',
                        value: cdoperador
                    }
                ];
                var promises = [];
                promises.push(General.callRestEngine('ped#/crud/opergrupop', 'FilterData', filterOper));
                promises.push(General.callRestEngine('ped#/crud/autgrupop', 'FilterData', filter_autgrupop));
                promises.push(General.callRestEngine('ped#/crud/vendedor', 'FilterData', filter_vendedor));
                ZHPromise.all(promises).then(function(callback) {
                    var gruoper = callback[0].dataset.opergrupop.filter(function(value){ return value.CDOPERADOR == cdoperador && callback[1].dataset.autgrupop[0] && value.CDGRUPOPER == callback[1].dataset.autgrupop[0].CDGRUPOPER;});
                    var filterWidget = templateManager.container.getActiveWidget();
                    if (!gruoper || gruoper.length <= 0) {
                        if (wid.appliedFilter && wid.appliedFilter.FILTER_ROW){
                            
                                // wid.appliedFilter.FILTER_ROW.getField('NMFANVEN').NMFANVEN = true;
                                if (callback[2].dataset.vendedor.length == 1) {
                                    if(parametros.IDUTRELACVENDCLI == "S"){
                                        wid.getField('NMRAZSOCCLIE').dataSourceFilter = [
                                            {
                                                name: 'CDVENDEDOR',
                                                operator: '=',
                                                value: callback[2].dataset.vendedor[0].CDVENDEDOR
                                            }
                                        ];
                                    }else{
                                        wid.getField('NMRAZSOCCLIE').dataSourceFilter = [];
                                    }
                                        
                                    wid.appliedFilter.FILTER_ROW.CDVENDEDOR   = callback[2].dataset.vendedor[0].CDVENDEDOR;
                                    wid.appliedFilter.FILTER_ROW.NMFANVEN = callback[2].dataset.vendedor[0].NMFANVEN;
                                    
                                    // wid.getField('CDVENDEDOR').value(callback[2].dataset.vendedor[0].CDVENDEDOR);
                                    // wid.getField('NMFANVEN').value(callback[2].dataset.vendedor[0].NMFANVEN);
                                    wid.getField('NMFANVEN').readOnly = true;
                                } else {
                                    wid.getField('NMFANVEN').validations = {required: true};
                                    ScreenService.showMessage('Operador não relacionado a um vendedor.');
                                }
                                    
                                
                        }else {
                            if (callback[2].dataset.vendedor.length == 1) {
                                if(parametros.IDUTRELACVENDCLI == "S"){
                                   var widget = templateManager.container.getActiveWidget();
                                    widget.getField('NMRAZSOCCLIE').dataSourceFilter = [
                                        {
                                            name: 'CDVENDEDOR',
                                            operator: '=',
                                            value: callback[2].dataset.vendedor[0].CDVENDEDOR
                                        }
                                    ];
                                }else{
                                   wid.getField('NMRAZSOCCLIE').dataSourceFilter = []; 
                                }
                                filterWidget.currentRow.CDVENDEDOR = callback[2].dataset.vendedor[0].CDVENDEDOR;
                                filterWidget.currentRow.NMFANVEN = callback[2].dataset.vendedor[0].NMFANVEN;
                                filterWidget.getField('NMFANVEN').readOnly = true;
                            }
                            
                        }
                    }else{
                        filterWidget.currentRow.CDVENDEDOR = callback[2].dataset.vendedor[0].CDVENDEDOR;
                        filterWidget.currentRow.NMFANVEN = callback[2].dataset.vendedor[0].NMFANVEN;
                        
                        // wid.getField('CDVENDEDOR').value(callback[2].dataset.vendedor[0].CDVENDEDOR);
                        // wid.getField('NMFANVEN').value(callback[2].dataset.vendedor[0].NMFANVEN);
                        // wid.getField('NMFANVEN').readOnly = true;
                    }
                }.bind(this));
            }.bind(this));
        }
        wid.reload();
    };

    this.verifyFilterParameters = function (widget) {
        widget = templateManager.container.getWidget('widgetPedido');
        widget.activate();
        var filial = widget.appliedFilter.FILTER_ROW.CDFILIAL;
        // widget.appliedFilter.FILTER_ROW
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];

        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
            if(!callback.dataset.parampedido[0]) {
                ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                for(var i = 0; i < widget.actions.length; i++) {
                    widget.actions[i].isVisible = false;
                }
            }else{
                
                widget.getAction('novoPedido').isVisible = true;
                widget.getAction('salvarPedido').isVisible = true;
                widget.getAction('cancelarEdicao').isVisible = true;
                
                this.parametros = callback.dataset.parampedido[0];
                if (callback.dataset.parampedido[0].IDOBRTPOPPED == 'N'){
                    widget.getField('NMTIPOOPER').requiredParam = false;
                    widget.getField('NMTIPOOPER').isVisible = false;
                    if(widget.getField('NMTIPOOPER').validations) {
                        delete widget.getField('NMTIPOOPER').validations;
                    }
                } else {
                    widget.getField('NMTIPOOPER').requiredParam = true;
                    widget.getField('NMTIPOOPER').isVisible = true;
                    // widget.getField('NMTIPOOPER').validations = {
                    //     required: true
                    // };
                }
            
                 widget.limitePendencia = callback.dataset.parampedido[0].NRDIAPENDFIN;
                this.verificaParamsPedido(callback.dataset.parampedido[0], widget);
            }
            
        }.bind(this));
    }; 

    this.deadlinesAdjustment = function (widgetPedido) {
        var widgetPrazo = templateManager.container.getWidget('widgetPrazoPed');
        if (widgetPedido.mode == 'view') {
            this.removeInlineEditable(templateManager.container.getWidget('widgetPrazoPed'));
            
            /*widgetModalidade.getField('DSMODPGTO').readOnly = true;     
            widgetModalidade.currentRow.CDMODPGTO = widgetModalidade.getParent().currentRow.CDMODPGTO;
            widgetModalidade.currentRow.DSMODPGTO = widgetModalidade.getParent().currentRow.DSMODPGTO;
            widgetModalidade.currentRow.IDTPFORPGTOMOD = widgetModalidade.getParent().currentRow.IDTPFORPGTPED;
            widgetModalidade.currentRow.CDFORMPGTO = widgetModalidade.getParent().currentRow.CDFORMPGTO;*/
            widgetPrazo.reload();
        
        } else if (widgetPedido.mode == 'edit'){
            this.removeInlineEditable(templateManager.container.getWidget('widgetPrazoPed'));
        }
        if (widgetPedido.currentRow.__is_new) {
            this.buildPrazo(templateManager.container.getWidget('widgetPrazoPed'));
        }
        templateManager.updateTemplate();
        this.setPrevisao(widgetPrazo);
    }; 

    this.changeToInlineMode = function (widget, action) {
        var widgetPrazo      = templateManager.container.getWidget('widgetPrazoPed');
        // var widgetModalidade = templateManager.container.getWidget('widgetModpgtoPed');
        widget.mode = 'edit';
        var i;
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": 'FILIAL_LOGADA'
        }];
        this.saveActionControl(widget);
        Ped00100_lancamentoPedido_Service.findParameters(filter).then(function(callback) {
            if (action.name == 'editarPrazo') {
                widgetPrazo.lastAction = 'editarPrazo';
                widget.getField('NRDIASPGTOPED').readOnly = true;
                // widgetModalidade.backup = widgetModalidade.fields[0].value();
                
                var rows = [];
                widget.backup = [];
                for (i = 0; i < widget.dataSource.data.length; i++) {
                    rows = Util.clone(widget.dataSource.data[i], ['__leftActions', '__rightActions', '__proto__']);
                    widget.backup.push(rows);
                }
                widget.getAction('incluirPrazo').isVisible = true;
                if (callback.dataset.parampedido[0].IDALTFORMAPAG === 'S'){
                    widget.getAction('excluirPrazo').isVisible = true;
                    widget.isVisible = false;
                    widget.reload().then(function(){
                        widget.isVisible = true;
                        widget.reload().then(function(){
                            templateManager.updateTemplate();
                            this.setInlineEditable(widget);
                        }.bind(this));
                    }.bind(this));
                }
                // templateManager.updateTemplate();
                
                templateManager.updateTemplate();
            } else if (action.name == 'novoPrazo') {
                var filial;
                widget.getField('NRDIASPGTOPED').readOnly = false;
                
                // widget.getAction('incluirPrazo').isVisible = true;
                widgetPrazo.lastAction = 'novoPrazo';
                this.setInlineEditable(widgetPrazo);
                widgetPrazo.backup = Util.clone(widgetPrazo.dataSource.data, ['__leftActions', '__rightActions']);
                
                for (i = 0; i < widgetPrazo.getParent().dataSourceFilter.length; i++) {
                    if (widgetPrazo.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widgetPrazo.getParent().dataSourceFilter[i].value;
                    }
                }
                widgetPrazo.dataSource.data.push({
                    "CDFILIAL": filial,
                    "NRPEDIDO": widgetPrazo.getParent().currentRow.NRPEDIDO,
                    "NRDIASPGTOPED": null,
                    "VRPERCPGTOPED": null,
                    "PREVISAO": null,
                    "VRPARCELA": null,
                    "__is_new": true
                });
                templateManager.updateTemplate();
            }
            
            templateManager.updateTemplate();
        }.bind(this));
        templateManager.updateTemplate();
    }; 

    this.statusControl = function (widget) {
        //var e;
        //var aux;
        //var name;
        var i = 0;
        var selectedStatus = [];
        var statusName;
        var conditions = {
            'pendente': [
                'STATUS_CONFIRMAR',
                'STATUS_CANCELAR'
            ],
            'confirmado': [ // exclusiva do Item
                'STATUS_EXC_CONFIRMACAO',
                'STATUS_APROVAR',
                'STATUS_CANCELAR'
            ],
            'aprovado': [ // exclusiva do Item
                'STATUS_EXC_APROVACAO',
                'STATUS_LIQMANUALMNTPED',
                'STATUS_CANCELAR'
            ],
            'liquidado': [],
            'liqManual': [
                'STATUS_EXC_LIQMANUALMNTPED'
            ],
            'parcAtendido': [
                'STATUS_LIQMANUALMNTPED'
            ],
            'cancelado': [
                'STATUS_EXL_CANCELAR'
            ]
        };
        widget.actions.forEach(function(action){
            if(action.name.includes('STATUS_')) action.isVisible = false;
        });
        if (widget.name == 'widgetPedido') {
            statusName = {
                "D": "emDigitacao",
                "E": "enviado",
                "N": "não Enviado",
                "1": "pendente",
                "2": "emAndamento",
                "3": "liquidado",
                "4": "cancelado",
                "5": "liqManual",
                "6": "parcAtendido",
                "7": "confirmado",
                "8": "aprovado",
            };
        } else if (widget.name == 'widgetItens') {
            statusName =  {
                "D": "emDigitacao",
                "1": "pendente",
                "2": "confirmado",
                "3": "aprovado",
                "4": "liquidado",
                "5": "cancelado",
                "6": "liqManual",
                "7": "parcAtendido"
            };
        }
        widget.getCheckedRows().forEach(function(row){
            selectedStatus[i] = (widget.name == 'widgetPedido') ? row.IDSITPEDIDO : row.IDSITITEMPED;
            i++;
        }.bind(this));
        
        this.checkedRows = widget.getCheckedRows();
        
        /*if(widget.getCheckedRows().length == 1) widget.actions[14].isVisible = true;
        else widget.actions[14].isVisible = false;*/
        
        // um Objeto onde cada propriedade representa uma action e recebe um array contendo quando a que da nome a propriedade deve ser mostrada
        var statusCod = selectedStatus;
        selectedStatus = selectedStatus.map(function(status) {
            return statusName[status];
        });
        var status = [];
        selectedStatus.forEach(function(value) {
            if (status.indexOf(value) == -1 ) {
                status.push(value);
            }
        });
        selectedStatus = status;
        // Status das linhas selecionadas, essas em conjunto formam as condições que devem ser respeitadas para mostrar as actions
        if (selectedStatus.indexOf("emAndamento") >= 0 || (selectedStatus.indexOf("confirmado") >= 0 && selectedStatus.indexOf('7') >= 0) || (selectedStatus.indexOf("aprovado") >= 0 && selectedStatus.indexOf('8') >= 0) ) {
            var pedidos = [];
            for (i = 0; i < widget.getCheckedRows().length; i++) {
                pedidos[i] = widget.getCheckedRows()[i].NRPEDIDO;
            }
            var filter = [
                {
                    "name": "NRPEDIDO",
                    "operator": "IN",
                    "value": pedidos
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.getCheckedRows()[0].CDFILIAL
                }
            ];
            General.callRestEngine('ped#/crud/itempedido_completa', "FilterData", filter).then(function(callback){
                var selectedItemStatus = [];

                var statusItemName = {
                    "D": "emDigitacao",
                    "1": "pendente",
                    "2": "confirmado",
                    "3": "aprovado",
                    "4": "liquidado",
                    "5": "cancelado",
                    "6": "liqManual",
                    "7": "parcAtendido"
                };

                i = 0;
                callback.dataset.itempedido_completa.forEach(function(row){
                    selectedItemStatus[i] = row.IDSITITEMPED;
                    i++;
                });
                if (selectedItemStatus.indexOf("1") >= 0) {
                    conditions.emAndamento = [   // exclusivo do pedido
                        'STATUS_CONFIRMAR',
                        'STATUS_CANCELAR'
                    ];
                } else if (selectedItemStatus.indexOf("2") >= 0) {
                    conditions.emAndamento = [   // exclusivo do pedido
                        'STATUS_EXC_CONFIRMACAO',
                        'STATUS_APROVAR',
                        'STATUS_CANCELAR'
                    ];
                } else if (selectedItemStatus.indexOf("3") >= 0) {
                    conditions.aprovado = [   // exclusivo do pedido
                        'STATUS_EXC_APROVACAO',
                        'STATUS_EXPEDIR',
                        'STATUS_LIQMANUALMNTPED',
                        'STATUS_CANCELAR'
                    ];
                }
                var statusNameItem =  {
                    "D": "emDigitacao",
                    "1": "pendente",
                    "2": "confirmado",
                    "3": "aprovado",
                    "4": "liquidado",
                    "5": "cancelado",
                    "6": "liqManual", 
                    "7": "parcAtendido"
                };
                selectedStatus = selectedItemStatus.map(function(status) {
                    return statusNameItem[status];
                });
                
                this.actionsControl(widget, conditions, selectedStatus);
            }.bind(this));
        } else if (selectedStatus.indexOf("emAndamento") >= 0 && widget.name == 'widgetPedido'){
            conditions.emAndamento = [  // exclusivo do pedido
                'STATUS_EXC_APROVACAO',
                'STATUS_EXPEDIR',
                'STATUS_LIQMANUALMNTPED',
                'STATUS_CANCELAR'
            ];
            this.actionsControl(widget, conditions, selectedStatus);
        } else {
            this.actionsControl(widget, conditions, selectedStatus);
        }
    }; 

    this.actionsControl = function (widget, conditions, selectedStatus) {
        var e = 0;
        var i = 0;
        var max = 0;
        var array = [];
        var contador = [];
        var selectedAction;
        var actionsToShow = [];
        var valoresMaximos = [];
        Object.keys(conditions).forEach(function(action) {
        //Pega o objeto como um array e da um foreach
            selectedAction = selectedStatus.map(function(row){
                if(row == action) return conditions[action];
            });
            //   armazena em uma variavel, quando todos os elementos das rows selecionadas forem encontrados no array de condições
            // se tiver encontrado entra no if e habilita as actions uma de cada vez
            for (e = 0; e < selectedAction.length; e++) {
                if(selectedAction[e] && selectedAction[e].length > 0) array = array.concat(selectedAction[e]);
            }
            if (selectedAction && selectedAction.length > 0 && selectedAction[0] && selectedAction[0].length > 0) {
                actionsToShow.push(selectedAction[0]);
            }
        });
        array.forEach(function(obj) {
            if (contador[obj]) {
                contador[obj].aparicoes += 1;
                if (contador[obj].aparicoes > max) {
                    max = contador[obj].aparicoes;
                    var ob = contador[obj].objeto;
                    valoresMaximos = [ob];
                } else if(contador[obj].aparicoes === max){
                    valoresMaximos.push(contador[obj].objeto);
                }
            } else  {
                var aparicoes = 1;
                var a = {objeto: obj, aparicoes: aparicoes};
                contador[obj] = a ;
            }
        });
        if (valoresMaximos.length > 0 && max >= selectedStatus.length){
            for (i = 0; i < valoresMaximos.length; i++) {
                widget.getAction(valoresMaximos[i]).isVisible = true;
            }
        } else if (selectedStatus.length == 1) {
            for (i = 0; i < array.length; i++) {
                widget.getAction(array[i]).isVisible = true;
            }
        }
    }; 

    this.changeStatus = function (widget, status, called_by) {
        var rows = widget.getCheckedRows();
        this.checkedRows = rows;

        this.pedidoFilterRow = templateManager.container.getWidget('widgetPedido').appliedFilter.FILTER_ROW;
        this.pedidoFilter = widget.dataSourceFilter;
        
        var route;
        var mensagem;

        rows.forEach(function(row){
            row.NOVOSTATUS = status;
            row.DTHORA = moment().format('DD/MM/YYYY HH:mm:ss');
            row.CALLED_BY = called_by;
        });
        if (widget.name == 'widgetPedido') {
            route = "ped_pedidos#/changeStatusPed";
            if(rows.length > 1){
                mensagem = {
                    "2":  "Pedidos Confirmados com sucesso.",
                    "8":  "Pedidos Aprovados com sucesso.",
                    "10": "Pedidos Liquidados Manualmente com sucesso.",
                    "9":  "Pedidos Cancelados com sucesso."
                };
            } else {
                mensagem = {
                    "2":  "Pedido Confirmado com sucesso.",
                    "8":  "Pedido Aprovado com sucesso.",
                    "10": "Pedido Liquidado Manualmente com sucesso.",
                    "9":  "Pedido Cancelado com sucesso."
                };
            }

        } else {
            route = "ped_pedidos#/changeStatusItemPed";
            if(rows.length > 1){
                mensagem = {
                    "2": "Itens Confirmados com sucesso.",
                    "3": "Itens Aprovados com sucesso.",
                    "6": "Itens Liquidados Manualmente com sucesso.",
                    "5": "Itens Cancelados com sucesso."
                };
            } else {
                mensagem = {
                    "2": "Item Confirmado com sucesso.",
                    "3": "Item Aprovado com sucesso.",
                    "6": "Item Liquidado Manualmente com sucesso.",
                    "5": "Item Cancelados com sucesso."
                };
            }
        }
        if(status == 8 && this.bypassPendencia == false && this.idPend != "3" || status == 8 && this.bypassPendencia == false && this.idSitu != "3") {
            
            this.aprovarPedido(widget);
                
                
        } else if (status == 11) {
            this.openExpedicaoPopUp();
        } else {
            General.callRestEngine(route, "DataSet", rows).then(function(callback) {
                ScreenService.showMessage(mensagem[status]);
                ScreenService.closePopup();
                
                widget.unSelectAll();
                this.enableDupPed();
                
                if (widget.name == 'widgetItens') {
                    templateManager.container.getWidget('widgetItens').reload();
                }
                this.getPedidos();
            }.bind(this))
            .catch(function(error){
                var erroAtualizar = ScreenService.i18n("Erro ao atualizar.");
                ScreenService.showMessage(erroAtualizar + ' \n ' + error.data.error);
                ScreenService.closePopup();
                widget.unSelectAll();
            });
        } 
    }; 

    this.aprovarPedido = function (widget) {
        
        var rows = widget.getCheckedRows();
        var arrayStatusPedido = [];
        var widgetPopupPed = widget.container.getWidget("widgetPopupPedido");
        
        General.callRestEngine('ped#/aprovarPedido', "DataSet", rows).then(
            function(response){
                widgetPopupPed.dataSource.data = response.dataset.mensagem;
                ScreenService.openPopup(widgetPopupPed);
                widget.reload();
            },
            function(error){
                ScreenService.showMessage(error);
            }
        );
    };
    
    this.verificaPendencias = function(widget) {
        var rows = widget.getCheckedRows();
        var arrayPendencias = [];
        var widgetPopupPend = widget.container.getWidget("widgetPopupPendencia");
        General.callRestEngine('ped_pedidos#/consultaPendencia', 'DataSet', rows).then(
            function(response) {
                arrayPendencias = response.dataset.pendencias;
                arrayPendencias.forEach(function(pendencia, index, array){
                    pendencia = JSON.parse(pendencia);
                    array[index] = pendencia;
                });
                widgetPopupPend.dataSource.data = arrayPendencias;
                ScreenService.openPopup(widgetPopupPend);
            },
            function(error) {
                ScreenService.showMessage(error);
            }
        );
    };
    
    this.exibirPendencias = function(widget) {
        
        var rows = widget.getCheckedRows();
        var widgetPopupPend = widget.container.getWidget("widgetPopupPendencia");
        var paramsCdFilial = ",";
        var paramsCdCliente = ",";
        
        rows.forEach(function(row){
            paramsCdFilial += row.CDFILIAL + ',';
            paramsCdCliente += row.CDCLIENTE + ',';
        }.bind(this));
        
        widgetPopupPend.dataSourceFilter[0].value = paramsCdFilial;
        widgetPopupPend.dataSourceFilter[1].value = paramsCdCliente;
        widgetPopupPend.reload();
        ScreenService.openPopup(widgetPopupPend);
    };
    
    this.enableDupPed = function(){
        var widget = templateManager.container.getWidget('widgetPedido');
        var rows = widget.getCheckedRows();

        widget.actions.forEach(function(act){
            if(act.name == 'duplicaPed'){
                if(rows.length == 1){
                    act.isVisible = true;
                }else{
                    act.isVisible = false;
                }
            }
        });
    };
    
    this.getDtEnt = function(){
        var widgetPopup =  templateManager.container.getWidget('widgetDuplicaPed');
        var widget = templateManager.container.getWidget('widgetPedido');
        var rows = widget.getCheckedRows();
        
        
        widgetPopup.currentRow.CDFILIAL = rows[0].CDFILIAL;

       var row ={
            CDFILIAL: rows[0].CDFILIAL,
            DTPEDIDO: widgetPopup.currentRow.DTPEDIDO
        };

        var promises = [];
        promises.push(General.callRestEngine("ped_pedidos#/getDataEntrega", "Row", row));
        ZHPromise.all(promises).then(function(callback){
            if(callback[0].dataset.data.length ==0){
                widgetPopup.getField('DTENTPED').value(moment().format('L'));
            }else{
                widgetPopup.getField('DTENTPED').value(moment(callback[0].dataset.data[0].DTENTREGA,'DD/MM/YYYY').format('L'));
            }

        });

     };
     
     this.validaDtDuplicaPed = function (){
        var widgetPopup =  templateManager.container.getWidget('widgetDuplicaPed');
        
        var now = (moment().format('L')).split("/").reverse("").join("/");
        var dtPedido = (moment((widgetPopup.currentRow.DTPEDIDO), 'DD/MM/YYYY').format('L')).split("/").reverse("").join("/");
        var dtEntPed = (moment((widgetPopup.currentRow.DTENTPED), 'DD/MM/YYYY').format('L')).split("/").reverse("").join("/");
        
        if(dtPedido > now){
            
            ScreenService.showMessage("A data pedido deve ser menor ou igual à data atual.");
            now = moment().format('L');
            widgetPopup.getField('DTPEDIDO').setValue(null);
            widgetPopup.getField('DTPEDIDO').reload();
            widgetPopup.getField('DTENTPED').setValue(null);
            widgetPopup.reload();
                
        }else if(dtEntPed != undefined && dtEntPed < dtPedido){
            
            widgetPopup.getField('DTENTPED').setValue(null);
            widgetPopup.reload();
            ScreenService.showMessage("A data de entrega deve ser maior ou igual à data atual");
        }
          
    };

    this.openPopupDuplicaPed = function(){
        var widgetPopup =  templateManager.container.getWidget('widgetDuplicaPed');
        var widget = templateManager.container.getWidget('widgetPedido');
        var rows = widget.getCheckedRows();
        var now = moment().format('L');
        var itens = [];
        
        var filterItens = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": rows[0].CDFILIAL
            },
            {
                "name": "NRPEDIDO",
                "operator": "=",
                "value": rows[0].NRPEDIDO
            }
        ];
        
        General.callRestEngine('ped#/crud/itempedido_completa', "FilterData", filterItens).then(function(itensPedido){
            
            itens = itensPedido.dataset.itempedido_completa;
            var cdproduto = [];
            itens.forEach(function(item){
                cdproduto.push(item.CDPRODUTO);

            });
            General.callRestEngine('ped#/crud/produto', "FilterData", [{name: 'CDPRODUTO', operator: 'IN', value: cdproduto}]).then(function(callback){
                var produtos = callback.dataset.produto;
                produtos.forEach(function(prod){
                    itens.forEach(function(item){
                        if(item.CDPRODUTO == prod.CDPRODUTO){
                            item.VRFATOCONV = prod.VRFATOCONV;
                        }
                    });
                });
                var data = [];
                data.push({'CDFILIAL': rows[0].CDFILIAL});
                data.push({'CDTIPOOPER': rows[0].CDTIPOOPER});
                data.push({'itens': itens});
                
                Ped00100_lancamentoPedido_Service.validaQtdeDispEstoque(data).then(function(callback) {
        
                    if(callback.dataset.validaQtdeDispEstoque.erro == 0){
                        widgetPopup.getField('DTPEDIDO').value(now);
                        this.getDtEnt();
                        
                        var filter = [
                            {
                                name: 'CDFILIAL',
                                operator: '=',
                                value: rows[0].CDFILIAL
                                
                            }
                        ];
                        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(response){
                            var utilFilialDest = 'NAO';
                            if(response.dataset.parampedido.length != 0){
                                utilFilialDest = response.dataset.parampedido[0].IDUTFILIALDESTINO;
                            }
                             ScreenService.openPopup(widgetPopup).then(function(){
                                widgetPopup.getField('CDCLIENTE').setValue(rows[0].CDCLIENTE);
                                widgetPopup.getField('NMRAZSOCCLIE').setValue(rows[0].NMRAZSOCCLIE);
                                if(utilFilialDest == 'SIM'){
                                     widgetPopup.getField('FILIDEST').readOnly = false;
                                     if(rows[0].CDFILIALPED){
                                        widgetPopup.getField('FILIDEST').setValue(rows[0].FILIDEST);
                                    }
                                 }else{
                                    widgetPopup.getField('FILIDEST').readOnly = true; 
                                    widgetPopup.getField('FILIDEST').setValue(null);
                                     widgetPopup.getField('FILIDEST').reload();
                                 }
                                
                                widgetPopup.reload();
                            });
        
                        });
                    }else{
                        var widgetRetornoValidEst = templateManager.container.getWidget('popUpRetornoValidacaoEstoque');
                
                        var retorno = callback.dataset.validaQtdeDispEstoque;
                        
                        widgetRetornoValidEst.dataSource.data = retorno[0];
                        ScreenService.openPopup(widgetRetornoValidEst).then(function(){
                            widgetRetornoValidEst.reload();
                        });
                    }
                        
                }.bind(this));
                
            }.bind(this));
            
        }.bind(this));
    };
    
    this.salvarPedDuplicado = function(){
        var widgetPopup =  templateManager.container.getWidget('widgetDuplicaPed');
        var widget = templateManager.container.getWidget('widgetPedido');
        var row = widget.getCheckedRows();
        var pedido=[];
        var data = [];
        
        var filter = [
            {
                name: 'CDFILIAL',
                operator: '=',
                value: row[0].CDFILIAL
                
            },
            {
                name: 'NRPEDIDO',
                operator:'=',
                value: row[0].NRPEDIDO
            }
        ];
        
        var promises = [];
        promises.push(General.callRestEngine('ped#/crud/pedido_completa', "FilterData", filter));
        promises.push(General.callRestEngine("ped#/crud/operador","FilterData", [{name: 'CDOPERADOR', operator: 'IN', value: 'OPERADOR_LOGADO'}]));

        ZHPromise.all(promises).then(function(callback){
            
            pedido = callback[0].dataset.pedido_completa[0];
           
            if(widgetPopup.currentRow.CDFILIAL == widgetPopup.currentRow.CDFILIALPED){
                
                ScreenService.showMessage('A filial de destino deve ser diferente da filial de origem do pedido.');
                widgetPopup.getField('FILIDEST').clearValue();
                widgetPopup.getField('FILIDEST').reload();
                
            }else{
                if(widgetPopup.currentRow.NRORDEMCMPPED && widgetPopup.currentRow.NRORDEMCMPPED != ""){
                    pedido.NRORDEMCMPPED = widgetPopup.currentRow.NRORDEMCMPPED;
                }
                if(widgetPopup.currentRow.FILIDEST && widgetPopup.currentRow.FILIDEST != ""){
                    pedido.FILIDEST = widgetPopup.currentRow.FILIDEST;
                }

                pedido.CDCLIENTE = widgetPopup.currentRow.CDCLIENTE;
                pedido.DTPEDIDO = widgetPopup.currentRow.DTPEDIDO;
                pedido.DTENTPED = widgetPopup.currentRow.DTENTPED;
             
                data.push({'pedido': pedido});
                data.push({'operador': callback[1].dataset.operador[0].CDOPERADOR});
    
                Ped00100_lancamentoPedido_Service.salvarDuplicPed(data).then(function(response){
                    var codigo = response.dataset.codigo.P_CDMENSERRO;

                    if(codigo == null){
                        
                        ScreenService.showMessage('Pedido Duplicado com sucesso!');
                        
                    }else if(codigo == "FILIAL_N_PARAM"){
                        
                        ScreenService.showMessage('Impossível duplicar o pedido. Não há parametrização para a Filial logada.');
                        
                    }else if(codigo == "VENDEDOR_INF"){
                        
                        ScreenService.showMessage('Impossível duplicar o pedido. Cadastre o Vendedor na tela Parâmetros de Pedidos.');
                            
                    } else if(codigo == "TIPOOPER_INF"){
                        
                        ScreenService.showMessage('Impossível duplicar o pedido. Cadastre o Tipo de Operação na tela Parâmetros de Pedidos.');
                        
                    }else if(codigo == "MOD_PAGAMENTO"){
                        ScreenService.showMessage('Impossível duplicar o pedido.Cadastre a Modalidade Padrão na tela Parâmetros de Pedidos.');
                    }else if(codigo == 'VRPREUNITPED;'){
                        ScreenService.showMessage('Impossível duplicar o pedido. Valor Unitrio do item deve ser maior que zero.');
                    }else if(codigo == 'PRECOVENC;'){
                        ScreenService.showMessage('Impossível duplicar o pedido. Preço fora de vigência.');
                    }else if(codigo == 'IDSITITEMPED;'){
                        ScreenService.showMessage('Impossível duplicar o pedido. Item sem situação cadastrada.');
                    }
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    widget.reload();
                
                });
            }

        }.bind(this));
    };

    this.checkPendencias = function (widget, route, rows, mensagem, status) {
        this.checkedRows = widget.getCheckedRows();
        this.widgetPopup = templateManager.container.getWidget("widgetPendencias");

        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": this.checkedRows[0].CDCLIENTE
            }
        ];
        var promisses = [];

        if (widget.idPend != 3) {
            promisses.push(General.callRestEngine('ped_pedidos#/crud/cliente_pendencia', 'FilterData', filter));
        }
        if (widget.idSitu != 3) {
            promisses.push(General.callRestEngine('ped_pedidos#/crud/cliente_pendenciasituacao', 'FilterData', filter));
        }

        this.widgetPopup.dataSource.data = [];
        if (widget.idPend == 2 && widget.idSitu != 1 || widget.idSitu == 2 && widget.idPend != 1) {
            this.widgetPopup.actions[1].isVisible = true;
        } else {
            this.widgetPopup.actions[1].isVisible = false;
        }

        ZHPromise.all(promisses).then(function(callback) {
            var pendencias = [];
            if(callback[0]) pendencias.push(callback[0].dataset);
            if(callback[1]) pendencias.push(callback[1].dataset);

            var nmClientesPend = [];
            var nmClientesSitu = [];
            
            // if(pendencias[0].pendencia_cliente.PENDENCIA) {
            //     ScreenService.showMessage("Este cliente possui pendência");
            // } else {
            //     ScreenService.showMessage("Este cliente não possui pendência");
            // }
            
            
            //Percorre todos os pedidos selecionados
            for(var i=0; i < this.checkedRows.length; i++) {
                //Percorre as duas requisições de Pendência Financeira (Pendência e Situação)
                for(var j=0; j < pendencias.length; j++) {
                    var currentPendencia;
                    var currentCheck;

                    if (pendencias[j].cliente_pendencia) {
                        currentPendencia = pendencias[j].cliente_pendencia;
                        currentCheck = "PEND";
                    } else if (pendencias[j].cliente_pendenciasituacao) {
                        currentPendencia = pendencias[j].cliente_pendenciasituacao;
                        currentCheck = "SITU";
                    }

                    var foundPendencia = false;
                    //Percorre todas as pendências encontradas na requisição atual
                    for(var k = 0; k < currentPendencia.length && !foundPendencia; k++) {
                        if (currentPendencia[k].CDCLIENTE == this.checkedRows[i].CDCLIENTE &&
                            this.checkedRows[i].VRTOTALPED + currentPendencia[k].VRFINALBREC >= this.limitePendencia) {
                            foundPendencia = true;
                            if (currentCheck == "PEND") {
                                nmClientesPend.push(this.checkedRows[i].NMRAZSOCCLIE);
                            }
                            if (currentCheck == "SITU") {
                                nmClientesSitu.push(this.checkedRows[i].NMRAZSOCCLIE);
                            }
                        }
                    }
                }
            }
            //Monta o popup de Pendências
            if (nmClientesPend.length >= 1 || nmClientesSitu.length >= 1) {
                ScreenService.openPopup(this.widgetPopup);
                var row;
                for(i=0; i < nmClientesPend.length; i++) {
                    row = {
                        "NMRAZSOCCLIE": nmClientesPend[i],
                        "TPPENDENCIA": "Pendência Financeira"
                    };
                    this.widgetPopup.dataSource.data.push(row);
                }
                for(i = 0; i < nmClientesSitu.length; i++) {
                    row = {
                        "NMRAZSOCCLIE": nmClientesSitu[i],
                        "TPPENDENCIA": "Data limite de Crédito vencida"
                    };
                    this.widgetPopup.dataSource.data.push(row);
                }
            } else {
                var widgetPedidos = templateManager.container.getWidget("widgetPedido");
                this.bypassPendencia = true;
                // this.changeStatus(widgetPedidos, 8);
                
                General.callRestEngine(route, "DataSet", rows).then(function(callback) {
                    ScreenService.showMessage(mensagem[status]);
                    ScreenService.closePopup();
                    widget.unSelectAll();
                    if (widget.name == 'widgetItens') {
                        templateManager.container.getWidget('widgetItens').reload();
                    }
                    templateManager.container.getWidget('widgetPedido').reload();
                    this.bypassPendencia = false;
                }.bind(this));
             }
        }.bind(this));
    };

    this.openSenha = function() {
        if (this.grupOperApro != "") {
            General.callRestEngine('ped#/crud/grupoper', 'FilterData', [{name: 'CDGRUPOPER', operator: '=', value: this.grupOperApro}]).then(function(callback) {
                var widgetSenha = templateManager.container.getWidget("widgetSenha");
                widgetSenha.currentRow.DSGRUPOPER = callback.dataset.grupoper[0].DSGRUPOPER;
                ScreenService.openPopup(widgetSenha);
            }.bind(this));
        } else {
            var widgetSenha = templateManager.container.getWidget("widgetSenha");
            widgetSenha.fields[0].isVisible = false;
            ScreenService.openPopup(widgetSenha);
        }
    };
    
     this.abrirTransmissaoNFe = function(args) {
      
        var notaFiscalPedido = args.owner.getParent().currentRow;
        
        localStorageEngine.setLocalVar('PED_CDFILIAL', General.getFieldValue('CDFILIAL', 'widgetPedido'));
        
        localStorageEngine.setLocalVar('PED_DTENTRSAID.end', notaFiscalPedido.DTENTRSAID);
        
        localStorageEngine.setLocalVar('PED_DTENTRSAID.start', notaFiscalPedido.DTENTRSAID);
        
        localStorageEngine.setLocalVar('PED_CDEMPRESA', notaFiscalPedido.CDEMPRESA);
         
        localStorageEngine.setLocalVar('PED_NRINSJURNF', notaFiscalPedido.NRINSJURNF);

        localStorageEngine.setLocalVar('PED_IDORIGDESTNF', notaFiscalPedido.IDORIGDESTNF);
        
        localStorageEngine.setLocalVar('PED_IDSTATUSNFE', notaFiscalPedido.IDSTATUSNFE);
        
        localStorageEngine.setLocalVar('PED_VRNOTAFISC', notaFiscalPedido.VRNOTAFISC);
        
        this.openWindow("df_saida#dfs49000_transmissao_nota_fiscal_eletronica");
        
      };

    this.requestModulesMetadata = function () {
        var modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
            return response.data;
        });
    };

    this.openWindow = function(windowName, newWindow) {
        this.requestModulesMetadata().then(function (modules) {
            var subModule = windowName.split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            ScreenService.openLink(url, false);
        });
    };
      
    this.checkLogin = function(widget) {
        var widgetPedidos = templateManager.container.getWidget("widgetPedido");
        if(widget.currentRow.OPRLOGIN != undefined && widget.currentRow.OPRSENHA != undefined &&
           widget.currentRow.OPRLOGIN != "" && widget.currentRow.OPRSENHA != "") {
            var login = [{
                login: widget.currentRow.OPRLOGIN,
                senha: widget.currentRow.OPRSENHA,
            }];
            if(this.grupOperApro != "") login[0].grupo = this.grupOperApro;
            Ped00300_aprovacao_Service.checkLogin(login).then(function(callback){
                var result = callback.dataset.result;
                if(result.matched) {
                    if(result.isOnGroup) {
                        this.bypassPendencia = true;
                        this.changeStatusAprovacao(widgetPedidos, 8);
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                    } else {
                        ScreenService.showMessage("Este operador não tem autorização para aprovar pedidos com pendência.");
                    }
                } else {
                    ScreenService.showMessage("Usuário e senha inválidos.");
                }
            }.bind(this));
        } else {
            ScreenService.showMessage("É necessário preencher todos os campos.");
        }
    };

    this.openWindowAprovacao = function(widget) {
        ScreenService.openWindow('ped_pedidos#ped00300_aprovacao').then(function(){
            templateManager.containers["ped_pedidos#ped00300_aprovacao"].getWidget('widgetPedido').reload().then(function() {
                var widgetAprovacao = templateManager.containers["ped_pedidos#ped00300_aprovacao"].getWidget('widgetPedido');

                var filterPed = templateManager.containers['ped_pedidos#ped00100_lancamento_pedido'].getWidget('widgetPedido').appliedFilter;
                var promisses = [];

                promisses.push(ZhFilterPreferences.applyFilter(widgetAprovacao, filterPed));
                promisses.push(ScreenService.closePopup());
                ZHPromise.all(promisses).then(function() {
                    var widgetAprovacao = templateManager.containers["ped_pedidos#ped00300_aprovacao"].getWidget('widgetPedido');
                    if (this.checkedRows.length == 1) {
                        widgetAprovacao.actions[1].isVisible = true;
                    } else {
                        widgetAprovacao.actions[1].isVisible = false;
                    }
                    widgetAprovacao.appliedFilter = filterPed;
                    Ped00100_lancamentoPedido_Controller.checkedRows = this.checkedRows;
                    widgetAprovacao.actions[2].isVisible = true;
                
                }.bind(this));
            }.bind(this));
        }.bind(this));
    };
    
    this.excluirStatus = function (widget, index, called_by) {
        var rows = widget.getCheckedRows();
        var route;
        var mensagem;
        if (widget.name == 'widgetPedido') {
            route = "ped_pedidos#/removeCurrentStatusPed";
            if (rows.length > 1){
                mensagem = {
                    "1": "Confimação dos Pedidos excluída com sucesso.",
                    "2": "Aprovação dos Pedidos excluída com sucesso.",
                    "3": "Liquidação Manuais dos Pedidos excluída com sucesso.",
                    "4": "Cancelamento dos Pedidos excluído com sucesso."
                };
            } else {
                mensagem = {
                    "1": "Confimação do Pedido excluída com sucesso.",
                    "2": "Aprovação do Pedido excluída com sucesso.",
                    "3": "Liquidação Manual do Pedido excluída com sucesso.",
                    "4": "Cancelamento do Pedido excluído com sucesso."
                };
            }
        } else {
            route = "ped_pedidos#/removeCurrentStatus";
            if(rows.length > 1){
                mensagem = {
                    "1": "Confimação dos Itens excluída com sucesso.",
                    "2": "Aprovação dos Itens excluída com sucesso.",
                    "3": "Liquidação Manuais dos Itens excluída com sucesso.",
                    "4": "Cancelamento dos Itens excluído com sucesso."
                };
            } else {
                mensagem = {
                    "1": "Confimação do Item excluída com sucesso.",
                    "2": "Aprovação do Item excluída com sucesso.",
                    "3": "Liquidação Manual do Item excluída com sucesso.",
                    "4": "Cancelamento do Item excluído com sucesso."
                };
            }
        }
        rows.forEach(function(row){
            row.DTHORA = moment().format('DD/MM/YYYY HH:mm:ss');
            row.CALLED_BY = called_by;
        });
        General.callRestEngine(route, "DataSet", rows).then(function(callback) {
            ScreenService.showMessage(mensagem[index]);
            ScreenService.closePopup();
            widget.unSelectAll();
            this.enableDupPed();
            if (widget.name == 'widgetItens') {
                templateManager.container.getWidget('widgetItens').reload().then(function(){
                    this.verificaStatus(templateManager.container.getWidget('widgetPedido'));
                    this.verificaStatusEncargo(templateManager.container.getWidget('widgetEncargo'));
                }.bind(this));
            }
            this.getPedidos();
        }.bind(this))
        .catch(function(error){
            var erroAtualizar_msg = ScreenService.i18n("Erro ao atualizar.");
            ScreenService.showMessage(erroAtualizar_msg + ' \n ' + error.data.error);
            ScreenService.closePopup();
            widget.unSelectAll();
        });
        
    }; 

    this.getPedidos = function () {
        
        templateManager.container.getWidget('widgetPedido').reload();
        // var filter = Util.clone(templateManager.container.getWidget('widgetPedido').filterApplied, ['__proto__']);
        /*General.callRestEngine('ped_pedidos#/crud/pedido_completa', 'FilterData', filter).then(function(callback) {
            templateManager.container.getWidget('widgetPedido').dataSource.data = callback.dataset.pedido_completa;
        });*/
    };

    this.fixWidget = function (widget) {
        widget.isVisible = false;
        widget.reload().then(function(){
            widget.isVisible = true;
            widget.reload().then(function(){
                this.saveActionControl(widget);
                if (widget.getParent().currentRow.__is_new) {
                    Ped00100_lancamentoPedido_Service.getData("ped#/crud/prazopgtoped").then(function(callback){
                        widget.dataSource.data = callback;
                    }.bind(this));
                }
            }.bind(this));
        }.bind(this));
    }; 

    this.saveActionControl = function (widget) {
        var action = widget.getAction('save');
        if (action) {
            widget.getAction('save').isVisible = false;
        }
    }; 

    /*this.editModalidade = function (widget) {
        widget.getField('DSMODPGTO').readOnly = false;
        General.edit(widget);
    };*/ 

    this.setInlineEditable = function (widget) {
        // passar os fields da widget prazo para inline editable
        var lastAction = widget.lastAction;
        widget.fields.forEach(function(field){
            if (field.name !== 'NRDIASPGTOPED' && field.name !== 'PREVISAO' && lastAction == 'editarPrazo') {
                field.inlineEditable = "number";
            } else if (lastAction == 'novoPrazo' && field.name !== 'PREVISAO'){
                field.inlineEditable = "number";
            }
        });
        widget.inlineEdit();
    }; 

    this.removeInlineEditable = function (widget) {
        widget.fields.forEach(function(field){
            delete field.inlineEditable;
        });
    }; 

    this.fixPrazoInlineEdit = function (widget) {
        // var widget = field.widget;
        if (widget.currentRow.__is_new) {
            var dataPed = widget.getParent().getField("DTPEDIDO").value();
            if (dataPed) {
                dataPed = moment(dataPed, 'DD/MM/YYYY').format();
            } else {
                dataPed = moment().format('DD/MM/YYYY');
            }
            dataPed = moment(dataPed).format('DD/MM/YYYY');
            var diasPg = widget.currentRow.NRDIASPGTOPED_inline;
            widget.getField("PREVISAO").setValue(this.calcPreview(dataPed, diasPg));
            var dtPrevisao = widget.currentRow.PREVISAO;
            widget.getField("NRDIASPGTOPED").setValue((this.calcPrazo(dataPed, dtPrevisao)));
        } else {
            ScreenService.showMessage('Impossível alterar prazo em dias de uma parcela já lançado.');
        }
    }; 

    this.checkImpostoVisibility = function(widget) {
        var pedidosWidget = widget.getParent();
        if (pedidosWidget.currentRow.__is_new) {
            templateManager.container.getWidget('widgetImposto').isVisible = false;
        } else {
            templateManager.container.getWidget('widgetImposto').isVisible = true;
        }
    }; 

    this.salvarInlineEdit = function (widget) { 
        var pedidosWidget = widget.getParent();
        
        var i = 0;
        var percnt = 0;
        var wrongRows = [];
        var invalidPrazo = true;
        var aux;
        var vrPrazos = 0;
        var vrTotal;
        if (pedidosWidget.currentRow.__is_new) {
            vrTotal = pedidosWidget.getField('VRTOTPEDLIQ').value();
        } else {
            vrTotal = pedidosWidget.getField('VRTOTALPED').value();
        }
        widget.dataSource.data.forEach(function(row){
            row.NRPEDIDO = pedidosWidget.currentRow.NRPEDIDO;
            percnt += parseFloat(row.VRPERCPGTOPED);
            percnt = parseFloat(percnt.toFixed(2));
            wrongRows[i] = row.VRPERCPGTOPED > 0 ? true : false;
            aux =  widget.dataSource.data.filter(function(key){return key.NRDIASPGTOPED == row.NRDIASPGTOPED;});
            if (aux.length > 1) {
                invalidPrazo = false;
            }
            widget.dataSource.data[i].VRPARCELA = parseFloat(widget.dataSource.data[i].VRPARCELA.toFixed(2));
            if (i+1 < widget.dataSource.data.length) {
                vrPrazos += widget.dataSource.data[i].VRPARCELA;
            }
            i++;
        });
        var idx = widget.dataSource.data.length - 1;//esse idx represanta a ultima parcela, em que é feito um ajuste para que nao fique maior que o valor do pedido
        widget.dataSource.data[idx].VRPARCELA =  (parseFloat(parseFloat(vrTotal).toFixed(2)) - parseFloat(parseFloat(vrPrazos).toFixed(2)));
        widget.dataSource.data[idx].VRPARCELA = parseFloat(widget.dataSource.data[idx].VRPARCELA.toFixed(2));
        wrongRows = wrongRows.filter(function(key){return key === false;});
        
        if (pedidosWidget.currentRow.__is_new && percnt == 100 && wrongRows[0] !== false && invalidPrazo) {
            this.removeInlineEditable(widget);
            var matches = [];
            for (i = 0; i < widget.dataSource.data.length; i++) {
                for (var key in widget.dataSource.data[i]) {
                    if (key.includes('changed_') || key.includes('_inline')) {
                        matches.push(key);
                    }
                }
                for (var e = 0; e < matches.length; e++) {
                    delete widget.dataSource.data[i][matches[i]];
                }
                matches = [];
            }
            widget.getAction('excluirPrazo').isVisible = false;

            Ped00100_lancamentoPedido_Service.saveData("ped#/crud/prazopgtoped", widget.dataSource.data);//.then(function() {
            widget.list();
            widget.activate();
            templateManager.updateTemplate();
            // widget.reload();
        } else if (!(pedidosWidget.currentRow.__is_new) && percnt == 100 && wrongRows[0] !== false && invalidPrazo) {
            this.removeInlineEditable(widget);
            widget.getAction('excluirPrazo').isVisible = false;
            var data = widget.dataSource.data.map(function(row){ return Util.clone(row, ['__leftActions', '__rightActions']);});
            var prazos = widget.backup;
            
            Ped00100_lancamentoPedido_Service.deletePrazo(prazos).then(function(){
                
                if(!widget.getParent().currentRow.__is_new) {
                    for(i=0; i<data.length; i++) {
                        data[i].__is_new = true;
                    }
                }
                
                var filter = [{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": pedidosWidget.currentRow.CDFILIAL
                }];
                
                General.callRestEngine('ped#/crud/filial', 'FilterData', filter).then(function(callback) {
                    
                    pedidosWidget.currentRow.CDEMPRESA = callback.dataset.filial[0].CDEMPRESA;
                    pedidosWidget.currentRow.CDINSCESTA = callback.dataset.filial[0].CDINSCESTA;
                    var promises = [];
                    promises.push(General.callRestEngine("ped_pedidos#/prazopgtoped/updatePrazo", "DataSet", data));
                    promises.push(this.getItem(templateManager.container.getWidget('widgetItens')));
                    if (this.vendPedAux) {
                        promises.push(this.tiraVendedoresCache());
                    }
                    ZHPromise.all(promises).then(function (callback) {
                        var vendedores = callback[2] ? callback[2] : { CDVENDEDOR: templateManager.container.getWidget('widgetPedido').currentRow.CDVENDEDOR };
                        widget.activate();
                        widget.list();
                        widget.reload();
                        if (!(pedidosWidget.currentRow.__is_new)) {
                            widget.getParent().getField('DSMODPGTO').readOnly = true;
                        }
                        this.fixWidget(widget);
                        var prazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.map(function(row) {
                            return Util.clone(row, ['__leftActions', '__rightActions']);
                        });
                        
                        widget.container.getWidget('widgetPedido').currentRow.CALLED_BY = 'UPDATE_PED';
                        var encargos = widget.container.getWidget('widgetEncargo').dataSource.data.filter( function(value){ return value.VRENCARGOPED != "0"; });
                        var itens = widget.container.getWidget('widgetItens').dataSource.data;
                        // itens = itens.forEach(function(row){row.changePrazo = false;});
                        // for (var i = 0; i < itens.length; i++) {
                            // itens[i].changePrazo = false;
                        // }
                        var savePedido = [itens, prazos, [widget.container.getWidget('widgetPedido').currentRow], encargos, [vendedores]];
                        
                        Ped00100_lancamentoPedido_Service.updateOrder(savePedido).then(function(){
                            widget.currentRow.__is_new = false;
                            widget.container.getWidget('widgetPedido').reload();
                        })
                        .catch(function(error){
                            var msg_erroAtualizar = ScreenService.i18n("Erro ao atualizar.");
                            ScreenService.showMessage(msg_erroAtualizar +' \n ' + error.data.error);
                            widget.unSelectAll();
                        });
                    }.bind(this)).catch(function(error){
                        ScreenService.showMessage('Erro ao atualizar o pedido' + error);
                        widget.getAction('excluirPrazo').isVisible = false;
                        if (!(pedidosWidget.currentRow.__is_new)) {
                            widget.getParent().getField('DSMODPGTO').readOnly = true;
                        }
                        widget.list();
                        this.fixWidget(widget);
                    }.bind(this));
                }.bind(this));
            }.bind(this));
            
        } else if (!invalidPrazo) {
            ScreenService.showMessage('O prazo, em dias, das parcelas não podem ser iguais.');
        } else if (wrongRows[0] !== false || percnt > 100 || percnt < 100 && invalidPrazo){
            ScreenService.showMessage('O valor total dos prazos difere do valor total do pedido.');
        } else {
            ScreenService.showMessage('Existe uma parcela do vencimento do pedido menor ou igual a zero.');
        }
    }; 

    this.cancelarInlineEdit = function (widget) {
        
        templateManager.updateTemplate();
        var widgetPrazo = templateManager.container.getWidget('widgetPrazoPed');
        /*var idx;
        widget.widgets[0].dataSource.data.forEach(function(row){
            if (row.__is_new) {
                idx = widget.widgets[0].dataSource.data.indexOf(row);
            }
        });
        if (widget.widgets[0].lastAction == 'novoPrazo') {
            widget.widgets[0].dataSource.data.splice(idx, 1);
        } else*/ 
        
        widgetPrazo.getAction('excluirPrazo').isVisible = false;
        this.fixWidget(widgetPrazo);
        if (widgetPrazo.lastAction == 'editarModalidade') {
            if (widget.currentRow.__is_new) {
                Ped00100_lancamentoPedido_Service.getData("ped#/crud/prazopgtoped").then(function(callback){
                    widgetPrazo.dataSource.data = callback;
                });
            }
        }
        templateManager.updateTemplate();
        this.removeInlineEditable(widgetPrazo);
        templateManager.updateTemplate();
        /*if (!(widget.getParent().currentRow.__is_new)) {
            widget.getField('DSMODPGTO').readOnly = true;
        }*/
        widgetPrazo.dataSource.data = widgetPrazo.backup;
        // widget.fields[0].setValue(widget.backup);
        widgetPrazo.list();
        widgetPrazo.activate();
        // widgetPrazo.currentRow.CDMODPGTO = widgetPrazo.getParent().currentRow.CDMODPGTO; 
        // widgetPrazo.currentRow.DSMODPGTO = widgetPrazo.getParent().currentRow.DSMODPGTO;
        templateManager.updateTemplate();
    }; 

    this.setPrevisao = function (widget) {
        if (!(widget.getParent().currentRow.__is_new)) {
            for (var i = 0; i < widget.dataSource.data.length; i++) {
                var nrDiasPg = widget.dataSource.data[i].NRDIASPGTOPED;
                var dtPedido =  widget.getParent().currentRow.DTPEDIDO;
                widget.dataSource.data[i].PREVISAO = moment(dtPedido, 'DD/MM/YYYY').add(nrDiasPg, 'days').format('DD/MM/YYYY');
            }
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                var filial = response.dataset.filial[0].CDFILIAL;
                this.filialLogada = filial;
                
                if(widget.name == 'widgetPrazoPed' && filial){
                    var filter = [{
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filial
                    }];
                    Ped00100_lancamentoPedido_Service.findParameters(filter).then(function(callback){
                        
                        if (callback.dataset.parampedido[0].IDALTFORMAPAG === 'S' && widget.getParent().currentRow.IDSITPEDIDO != 3 && widget.getParent().currentRow.IDSITPEDIDO != 4){
                            // widget.getAction('editarModalidade').isVisible = true;
                            widget.getAction('editarPrazo').isVisible = true;
                            widget.getAction('novoPrazo').isVisible = true;
                        } else {
                            widget.getAction('editarPrazo').isVisible = false;
                            widget.getAction('novoPrazo').isVisible = false;
                        }
                    }.bind(this));
                }
            }.bind(this));
        }
    };
    
    this.checaDeleteVendedor = function(widget) {
        var pedido = widget.container.getWidget('widgetPedido');
        return [
            {
                label: ScreenService.i18n("Sim"),
                code: function(){
                    General.callRestEngine("ped_pedidos#/delete_vendpedaux", "DataSet", [pedido.currentRow])
                    .then(function(sucess){
                         if (sucess.dataset.deleteAll_vendpedaux == 'done') {
                            
                            ScreenService.showMessage('Vendedores adicionais removidos');
                            this.deletaCacheVendedores();
                            widget.vendPedAuxRegistrado = false;
                            widget.vendInCache = false;
                        }
                    }.bind(this))
                    .catch(function(fail){
                        ScreenService.showMessage(fail);
                         
                    }.bind(this));
                }.bind(this)
            },{
                label: ScreenService.i18n("Não"),
                code: function(){
                    
                    widget.dataSource.addCheckedRows(widget.dataSource.checkedRows);
                    templateManager.updateTemplate();
                }.bind(this)
            }
        ];
    };
    
    this.checaDeleteVendedores = function(widget) {
        
        if (!this.PedidoEhNovo() && widget.vendPedAuxRegistrado && !widget.fechaPopUp && !widget.sincroniza) {
            var vendedoresDesselecionados_msg = ScreenService.i18n("Foi desselecionado todos os vendedores registrados, Deseja excluir do banco?");
            ScreenService.showCustomDialog(vendedoresDesselecionados_msg, 'question', 'question', this.checaDeleteVendedor(widget));
        }
        if (widget.fechaPopUp) {
            widget.fechaPopUp = false;
        }
        if (widget.sincroniza) {
            widget.sincroniza = false;
        }
    };
    
    this.checaDeleteUltVendedor = function(widget) {
        
        var quant = widget.dataSource.checkedRows.length;
        if (!this.PedidoEhNovo() && quant == 1 && widget.vendPedAuxRegistrado && !widget.fechaPopUp && !widget.sincroniza) {
            var desselecionadoUltimoVendedor_msg = ScreenService.i18n("Foi desselecionado o último vendedor regitrado, Deseja excluir do banco?");
            ScreenService.showCustomDialog(desselecionadoUltimoVendedor_msg, 'question', 'question', this.checaDeleteVendedor(widget));
        }
        if (widget.fechaPopUp) {
            widget.fechaPopUp = false;
        }
        if (widget.sincroniza) {
            widget.sincroniza = false;
        }
        
    };
    
    this.btnVendedoresAdicionais = function(widget, param) {
        
        if (param.IDEXIBVENDCOM == 'S') {
            widget.getField('VENDPEDAUX').readOnly = false;
        } else {
            widget.getField('VENDPEDAUX').readOnly = true;
        }
    };

    this.addPedido = function (widget) {
        var validFiltro = this.testFiltro(widget);
        var filial;
        if (validFiltro) {
            templateManager.updateTemplate();
            widget.newRow();
            // widget.widgets[3].widgets[0].fields[0].readOnly = false;
            // widget.widgets[3].widgets[0].fields[0].clearValue();
            // widget.widgets[3].widgets[0].fields[1].clearValue();
            // widget.widgets[3].widgets[0].dataSource.data = [];
            // widget.widgets[3].widgets[0].reload();
            
            for (var i = 0; i < widget.dataSourceFilter.length; i++) {
                if (widget.dataSourceFilter[i].name == 'CDFILIAL'){
                    filial = widget.dataSourceFilter[i].value;
                }
            }
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filial
                }
            ];
            /* for (var i = 0; i < widget.widgets.length; i++) {
                widget.widgets[i].floatingControl.visibleModes = [];
            }*/
            //widget.container.getWidget('widgetItens').floatingControl.reload =false;
            Ped00100_lancamentoPedido_Service.getNewCode(filial).then(function(callback){
                widget.currentRow.NRPEDIDO = callback.dataset.data[0].NOVOCODIGO;
                widget.currentRow.CDFILIAL = filial;
                
                widget.currentRow.__is_new = true;
                widget.currentRow.DTPEDIDO = moment().format('DD/MM/YYYY');
                widget.getField('DTVALIPED').minDate = widget.getField('DTPEDIDO').value();
                widget.getField('DTENTPED').minDate  = widget.getField('DTPEDIDO').value();
                
                var promises = [];
                promises.push(Ped00100_lancamentoPedido_Service.findParameters(filter));         
                promises.push(General.callRestEngine("ped_pedidos#/getDataEntrega", "Row", widget.currentRow));

                ZHPromise.all(promises).then(function(callback){
    
                    widget.getField('DTENTPED').setValue(callback[1].dataset.data[0].DTENTREGA);
                    
                    this.parametros = callback[0].dataset.parampedido[0];
                    this.setClientePadrao(this.parametros);
                    

                    /*
                        var prazoEntrega = callback[0].dataset.parampedido[0] ? callback[0].dataset.parampedido[0].NRDIASENTPED : null;
                        if (prazoEntrega === null) {
                            prazoEntrega = 5;
                        }
                        var dtEntPed = widget.getField('DTPEDIDO').value();
                        dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(prazoEntrega,'days').format('DD/MM/YYYY');
                        
                        for (var i = 0; i < prazoEntrega; i++) {
                            dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(1,'days');
                            
                            if(dtEntPed.format('dddd') == 'Sábado'){
                                dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(2,'days');
                            } else if(dtEntPed.format('dddd') == 'Domingo'){
                                dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(1,'days');
                            }
                        }
                    */
                    
                    widget.currentRow.CDMODPGTO = this.parametros.CDMODPGTO;
                    widget.currentRow.DSMODPGTO = this.parametros.DSMODPGTO;
                    
                    if(callback[0].dataset.parampedido[0].IDUTVALIPED == 'S'){
                    	widget.getField('DTVALIPED').readOnly = false;
                    	if (callback[0].dataset.parampedido[0].QTDIAVALIPED > 0) {
                    		widget.currentRow.DTVALIPED = moment(widget.getField('DTPEDIDO').value(), 'DD/MM/YYYY').add(callback[0].dataset.parampedido[0].QTDIAVALIPED,'days').format('DD/MM/YYYY');
                    	} 
                    }else{
                    	widget.getField('DTVALIPED').readOnly = true;
                    }  
                    
                    this.setTipoOperClie(this.parametros);
                    /*General.callRestEngine('ped#/crud/cliente_parametrizacoes', 'FilterData', [{name: 'CDCLIENTE', operator: '=', value: this.parametros.CDCLIENTE}]).then(function(tipoopercclie){
                        var tipooper;
                        if(tipoopercclie.dataset.cliente_parametrizacoes[0].CDTIPOOPERPED && tipoopercclie.dataset.cliente_parametrizacoes[0].CDTIPOOPERPED != null ){
                            
                            tipooper = widget.getField('NMTIPOOPER').dataSource.data.filter(function(row){ return row.CDTIPOOPER == tipoopercclie.dataset.cliente_parametrizacoes[0].CDTIPOOPERPED;});
                            widget.getField('NMTIPOOPER').readOnly = true;
                            
                        }else if (callback[0].dataset.parampedido[0].CDTIPOOPER > 0  || callback[0].dataset.parampedido[0].CDTIPOOPER == 0) {
                            
                            tipooper = widget.getField('NMTIPOOPER').dataSource.data.filter(function(row){ return row.CDTIPOOPER == callback[0].dataset.parampedido[0].CDTIPOOPER;});
                            widget.getField('NMTIPOOPER').readOnly = false;

                        }
                        widget.currentRow.CDTIPOOPER = tipooper[0].CDTIPOOPER;
                        widget.currentRow.NMTIPOOPER = tipooper[0].NMTIPOOPER;
                        widget.currentRow.IDORIGDESTOP = tipooper[0].IDORIGDESTOP;
                        widget.currentRow.IDOPERDEVONF = tipooper[0].IDOPERDEVONF;
                        widget.currentRow.IDSERIEAUTO = tipooper[0].IDSERIEAUTO;
                        widget.currentRow.IDUTILVENC = tipooper[0].IDUTILVENC;
                        widget.currentRow.IDENTRSAIDOP = tipooper[0].IDENTRSAIDOP;
                        widget.currentRow.DSOPERNFORIG = tipooper[0].DSOPERNFORIG;
                        widget.currentRow.CDMODDOCFISC = tipooper[0].CDMODDOCFISC;
                        widget.currentRow.DSMODDOCFISC = tipooper[0].DSMODDOCFISC;
                        widget.currentRow.IDATUESTTPOP = tipooper[0].IDATUESTTPOP;
                        
                        var row = {
                        	IDORIGDESTOP: widget.currentRow.IDORIGDESTOP
                        };
                        this.verificaTipoOper(row);
                    }.bind(this));*/
                                        
                    
                    
                    widget.getField('CDVENDEDOR').setValue(widget.appliedFilter.FILTER_ROW.CDVENDEDOR);
                    widget.getField('NMFANVEN').setValue(widget.appliedFilter.FILTER_ROW.NMFANVEN);
                    
                    
                    widget.container.getWidget('widgetDadosAdicionais').getAction('fecharPedidoDadosAdic').isVisible = true;
                    widget.container.getWidget('transportadora').getAction('fecharPedidoTransportadora').isVisible = true;
                    
                    widget.container.getWidget('widgetItens').getAction('fecharPedidoItem').isVisible = true;
                    widget.container.getWidget('widgetPrazoPed').getAction('fecharPedidoPrazo').isVisible = true;
                    //Alteracoes para nao editar o prazo
                    widget.container.getWidget('widgetPrazoPed').getAction('novoPrazo').isVisible = true;
                    widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = true;
                    // widget.container.getWidget('widgetPrazoPed').getAction('excluirPrazo').isVisible = true;
                    
                    if (callback[0].dataset.parampedido[0]) {
                        widget.container.getWidget('widgetPrazoPed').getAction('novoPrazo').isVisible = false;
                        // widget.container.getWidget('widgetPrazoPed').getAction('editarModalidade').isVisible = false;
                        widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = false;
                        if (callback[0].dataset.parampedido[0].IDALTMODPAG === 'S') {
                            widget.container.getWidget('widgetPedido').getField('DSMODPGTO').readOnly = false;
                            // widget.container.getWidget('widgetPrazoPed').getAction('editarModalidade').isVisible = true;
                            // widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = false;
                        } 
                        if (callback[0].dataset.parampedido[0].IDALTFORMAPAG == 'S'){
                            widget.container.getWidget('widgetPrazoPed').getAction('novoPrazo').isVisible = true;
                            widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = true;
                        }
                        
                        // RAISETRANSP tratar entrada da widget aqui
                        // widget.container.getWidget('transportadora').mode = 'edit';
                        // General.edit(widget.container.getWidget('transportadora'));
                        // widget.container.getWidget('transportadora').template = "widget/form.html";
                        widget.container.getWidget('transportadora').getAction('ATUALIZA_ENDERECO').isVisible = false;
                        
                        widget.container.getWidget('transportadora').getField('NMROTATRANS').readOnly = false;
                        widget.container.getWidget('transportadora').getField('NMRAZSOCTRAN').readOnly = false;
                        widget.container.getWidget('transportadora').getField('NMTIPTRANS').readOnly = false;
                        widget.container.getWidget('transportadora').getField('IDPGFRETTRAN').readOnly = false;
                        
                        widget.container.getWidget('transportadora').getField('DSENDECLIE').readOnly = false;
                        
                        widget.container.getWidget('transportadora').reload();
                        
                    }
                    
                    templateManager.updateTemplate();
                }.bind(this));
            }.bind(this));
        } else {
            ScreenService.showMessage('É necessário utilizar o filtro nesta tela.');
        }
    };

    this.setClientePadrao = function (parametros) {
        if (parametros.CDCLIENTE){
            var widget = templateManager.container.getActiveWidget();
            
            var filterPopup = widget.appliedFilter.FILTER_ROW;
            
            var filter = [];
            
            if(parametros.IDEXIBPEDIDO == '2' && parametros.IDUTRELACVENDCLI == 'S'){
                filter = [
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": parametros.CDCLIENTE
                    },
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": filterPopup.CDVENDEDOR
                    }
                ];
            }else{
                filter = [
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": parametros.CDCLIENTE
                    }
                ];
            }
            
            General.callRestEngine("ped#/crud/cliente_vendedor", "FilterData", filter).then(function(sucess){
                if(sucess.dataset.cliente_vendedor.length > 0){
                    widget.currentRow.CDVENDEDOR     = sucess.dataset.cliente_vendedor[0].CDVENDEDOR;
                    widget.currentRow.NMFANVEN       = sucess.dataset.cliente_vendedor[0].NMFANVEN;
                    widget.currentRow.CDCLIENTE      = sucess.dataset.cliente_vendedor[0].CDCLIENTE;
                    widget.currentRow.NRINSJURCLIE   = sucess.dataset.cliente_vendedor[0].NRINSJURCLIE;
                    widget.currentRow.NMRAZSOCCLIE   = sucess.dataset.cliente_vendedor[0].NMRAZSOCCLIE;
                    widget.currentRow.IDTPIJURCLIE   = sucess.dataset.cliente_vendedor[0].IDTPIJURCLIE;
                    widget.currentRow.CDMODPGTO      = sucess.dataset.cliente_vendedor[0].CDMODPGTO;
                    widget.currentRow.DSMODPGTO      = sucess.dataset.cliente_vendedor[0].DSMODPGTO;
                    widget.currentRow.NMFANTCLIE     = sucess.dataset.cliente_vendedor[0].NMFANTCLIE;
                    widget.currentRow.IDDIAVISITA    = sucess.dataset.cliente_vendedor[0].IDDIAVISITA;
                    widget.currentRow.DSEMAILCLIE    = sucess.dataset.cliente_vendedor[0].DSEMAILCLIE;
                    widget.currentRow.SGESTADO       = sucess.dataset.cliente_vendedor[0].SGESTADO;
                    widget.currentRow.CDPAIS         = sucess.dataset.cliente_vendedor[0].CDPAIS;
                    widget.currentRow.PENDENCIA      = sucess.dataset.cliente_vendedor[0].PENDENCIA;
                    widget.currentRow.DTATUAVENREC   = sucess.dataset.cliente_vendedor[0].DTATUAVENREC;
                    widget.currentRow.NRDIAPENDFIN   = sucess.dataset.cliente_vendedor[0].NRDIAPENDFIN;
                    widget.currentRow.IDTPFORPGTOMOD = sucess.dataset.cliente_vendedor[0].IDTPFORPGTOMOD;
                    widget.currentRow.NRDIAPGFIXMOD  = sucess.dataset.cliente_vendedor[0].NRDIAPGFIXMOD;
                    widget.currentRow.NRPARCPGTOMOD  = sucess.dataset.cliente_vendedor[0].NRPARCPGTOMOD;
                    widget.currentRow.IDUTDIAPAGMOD  = sucess.dataset.cliente_vendedor[0].IDUTDIAPAGMOD;
                    widget.currentRow.CDFORMPGTO     = sucess.dataset.cliente_vendedor[0].CDFORMPGTO;
                    widget.currentRow.VRPEMAXDESCL   = sucess.dataset.cliente_vendedor[0].VRPEMAXDESCL;
                    widget.currentRow.VRPEMAXDESVE   = sucess.dataset.cliente_vendedor[0].VRPEMAXDESVE;                
                    this.setParams(widget);
                }
                // else{
                //     ScreenService.showMessage('O cliente padrão não compõe a cartela de clientes do vendedor');
                // }
            }.bind(this));
        }
    };
    
    this.setPrebaseFilter = function (widget) {
        widget.container.getWidget('widgetItens').getField('NMPRODUTO').dataSourceFilter = [
            {
                "name": "CDPRECOBASE",
                "operator": "=",
                "value": widget.currentRow.CDPRECOBASE
            },
            {
                "name": "CDCLIENTE",
                "operator": "=",
                "value": widget.currentRow.CDCLIENTE
            }, {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            }, {
                "name": "DTPEDIDO",
                "operator": "=",
                "value": widget.currentRow.DTPEDIDO
            }
        ];
    }; 

    this.goBack = function (widget, args) {

        General.backOrCancel(args);
    }; 

    this.dataPop = function(widget) {
        widget = widget.container.getWidget('widgetPedido');
        // a ideia e remover o registro nao salvo da tela ao cancelar o lançamento do pedido em uma widget que nao seja a de pedidos.
        if (widget.currentRow.__is_new || widget.currentRow.__is_new !== false  && widget.currentRow.__is_new !== true) {
            widget.dataSource.data.pop();
        }
        widget.container.getWidget('widgetPedido').reload();
    }; 

    this.verifyModPgto = function (widget) {
        var widgetPedido = widget.container.getWidget('widgetPedido');
        // var wdgtParentModpgtoPed = wdgtModpgtoPed.getParent();
        var filter = [];
        if (widget.name == 'widgetPedido' && widget.currentRow.__is_new) {
            
            if (this.parametros.CDMODPGTO) {
                
                widget.currentRow.CDMODPGTO = this.parametros.CDMODPGTO;
                // wdgtModpgtoPed.currentRow.CDMODPGTO = widget.currentRow.CDMODPGTO;
                filter = [
                    {
                        "name": "CDMODPGTO",
                        "operator": "=",
                        "value": this.parametros.CDMODPGTO
                    }
                ];
                General.callRestEngine('ped#/crud/modpgto', 'FilterData', filter).then(function(callback) {
                    
                    widgetPedido.currentRow.CDMODPGTO      = callback.dataset.modpgto[0].CDMODPGTO;
                    widgetPedido.currentRow.DSMODPGTO      = callback.dataset.modpgto[0].DSMODPGTO;
                    widgetPedido.currentRow.CDFORMPGTO     = callback.dataset.modpgto[0].CDFORMPGTO;
                    widgetPedido.currentRow.IDTPFORPGTPED = callback.dataset.modpgto[0].IDTPFORPGTOMOD;
                   
                    widgetPedido.currentRow.IDUTDIAPAGMOD = callback.dataset.modpgto[0].IDUTDIAPAGMOD;
                    widgetPedido.currentRow.NRDIAPGFIXMOD = callback.dataset.modpgto[0].NRDIAPGFIXMOD;
                    widgetPedido.currentRow.NRPARCPGTOMOD = callback.dataset.modpgto[0].NRPARCPGTOPED;
                });
            }
        }
        if (widgetPedido.currentRow.CDMODPGTO) {
            this.buildPrazo(widget.container.getWidget('widgetPrazoPed'));
            var cdmodpgto = widgetPedido.currentRow.CDMODPGTO ? widgetPedido.currentRow.CDMODPGTO : this.parametros.CDMODPGTO;
            filter = [
                {
                    "name": "CDMODPGTO",
                    "operator": "=",
                    "value": cdmodpgto
                }
            ];
            General.callRestEngine('ped#/crud/modpgto', 'FilterData', filter).then(function(callback) {
                if(widgetPedido.currentRow.__is_new){
                    widgetPedido.currentRow.CDMODPGTO     = callback.dataset.modpgto[0].CDMODPGTO;
                    widgetPedido.currentRow.DSMODPGTO     = callback.dataset.modpgto[0].DSMODPGTO;
                    widgetPedido.currentRow.CDFORMPGTO    = callback.dataset.modpgto[0].CDFORMPGTO;
                    widgetPedido.currentRow.IDTPFORPGTPED = callback.dataset.modpgto[0].IDTPFORPGTOMOD;
                   
                    widgetPedido.currentRow.IDUTDIAPAGMOD = callback.dataset.modpgto[0].IDUTDIAPAGMOD;
                    widgetPedido.currentRow.NRDIAPGFIXMOD = callback.dataset.modpgto[0].NRDIAPGFIXMOD;
                    widgetPedido.currentRow.NRPARCPGTOMOD = callback.dataset.modpgto[0].NRPARCPGTOPED;
                }
            });
            
        }

        
        if (this.parametros.CDFILIAL) {
            
            var filtro = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": this.parametros.CDFILIAL
            }];
            
            Ped00100_lancamentoPedido_Service.findParameters(filtro).then(function(callback){
                this.parametros = callback.dataset.parampedido[0];
                if (callback.dataset.parampedido[0].IDALTMODPAG === 'S'  && widget.container.getWidget('widgetPedido').currentRow.__is_new) {
                    widgetPedido.getField('DSMODPGTO').readOnly = false;
                } else if (widget.container.getWidget('widgetPedido').currentRow.__is_new) {
                    widgetPedido.getField('DSMODPGTO').readOnly = true;
                }
            }.bind(this));
        }
        // widget.getParent().childTemplate = "widget/form.html";
        templateManager.updateTemplate();
    }; 

    this.atualizaParampreco = function (){
        var widgetPed = templateManager.container.getWidget('widgetPedido');
        var widgetItens = templateManager.container.getWidget('widgetItens');
        // var widgetModpgto = templateManager.container.getWidget('widgetModpgtoPed');
        var widgetPrazo = templateManager.container.getWidget('widgetPrazoPed');
        var data = widgetPed.getField('NMFILIAL').dataSource.data.filter(function(data){ return data.CDFILIAL == widgetPed.appliedFilter.FILTER_ROW.CDFILIAL;});
        var filter = [
            {
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value":  data[0].CDEMPRESA
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widgetPed.currentRow.CDFILIAL
            }
        ];
        if (widgetPed.currentRow.CDPRECOBASE && widgetPed.currentRow.CDMODPGTO) {
            ScreenService.showMessage('Ao alterar esta informação o valor dos itens pode mudar devido a parametrização de preços.');
            General.callRestEngine('ped#/crud/precouti_filial', "FilterData", filter).then(function(success) {
                var vrTotal = 0;
                var vrTotalLq = 0;
                var itens = widgetItens.dataSource.data;
                var paramPreco = success.dataset.precouti_filial.filter(function(row){ 
                    return  row.CDEMPRESA == data[0].CDEMPRESA &&
                            row.CDFILIAL  == widgetPed.currentRow.CDFILIAL  &&
                            row.CDPRECOBASE == widgetPed.currentRow.CDPRECOBASE &&
                            row.CDMODPGTO   == widgetPed.currentRow.CDMODPGTO;
                });
                for (var i = 0; i < itens.length; i++) {
                    if (widgetPed.currentRow.NRPEDIDO == itens[i].NRPEDIDO) {
                        
                        itens[i].VRPREUNITPED = (itens[i].VRITEPREBASE) ? itens[i].VRITEPREBASE : itens[i].VRPREUNITPED;
                        if (paramPreco.length > 0) {
                            itens[i].VRPREUNITPED = itens[i].VRPREUNITPED + ((itens[i].VRPREUNITPED * paramPreco[0].VRPEADPBASE)/100);
                            itens[i].VRPREUNITPED = parseFloat(itens[i].VRPREUNITPED.toFixed(2));
                            itens[i].IDITPEDDIFER = 'R';
                        }
                        itens[i].PERDESC = 0;
                        itens[i].VRDESITPED = 0;
                        itens[i].VRTOTALITEMSEMIMP = itens[i].QTITEMPED * itens[i].VRPREUNITPED;
                        itens[i].VRTOTALITEMSEMIMP = parseFloat(itens[i].VRTOTALITEMSEMIMP.toFixed(2));
                        itens[i].VRTOTALITEM = itens[i].VRTOTALITEMSEMIMP;
                        itens[i].VRTOTALITEM = parseFloat(itens[i].VRTOTALITEMSEMIMP.toFixed(2));
                        
                        vrTotalLq += itens[i].VRTOTALITEMSEMIMP;
                        vrTotalLq = parseFloat(vrTotalLq.toFixed(2));
                        
                        vrTotal += itens[i].VRTOTALITEM;
                        vrTotal = parseFloat(vrTotal.toFixed(2));
                    }
                }
                var widgetEncargo = templateManager.container.getWidget('widgetEncargo');
                var encargos = widgetEncargo.dataSource.data.filter(function(row){ 
                    return row.CDFILIAL == widgetPed.currentRow.CDFILIAL &&
                    row.NRPEDIDO == widgetPed.currentRow.NRPEDIDO;
                });
                if (encargos.length > 0) {
                    for (i = 0; i < encargos.length; i++) {
                        if (encargos[i].NRPEDIDO == widgetPed.currentRow.NRPEDIDO) {
                            
                            encargos[i].VRPERCENTENC = ((encargos[i].VRENCARGOPED * 100) / vrTotalLq);
                            encargos[i].VRPERCENTENC = parseFloat(encargos[i].VRPERCENTENC.toFixed(2)); 
                            
                            if ( encargos[i].IDENCARGO == 'A') {
                                vrTotal = vrTotal + encargos[i].VRENCARGOPED;
                                vrTotal = parseFloat(vrTotal.toFixed(2));
                            } else if ( encargos[i].IDENCARGO == 'D'){
                                vrTotal = vrTotal - encargos[i].VRENCARGOPED;
                                vrTotal = parseFloat(vrTotal.toFixed(2));
                            }
                        }
                    }
                }
                widgetPed.currentRow.VRTOTPEDLIQ = parseFloat(vrTotalLq.toFixed(2)) > 0 ? parseFloat(vrTotalLq.toFixed(2)) : widgetPed.currentRow.VRTOTPEDLIQ;
                widgetPed.currentRow.VRTOTALPED = parseFloat(vrTotal.toFixed(2)) > 0 ? parseFloat(vrTotal.toFixed(2)) : widgetPed.currentRow.VRTOTALPED;
                
                this.buildPrazo(widgetPrazo);
                // Ped00100_lancamentoPedido_Service.setData("ped#/encargoped_completa", encargos);
                // Ped00100_lancamentoPedido_Service.setData("ped#/itempedido_completa", itens).then(function() {
                // }.bind(this));
            }.bind(this));
        }
    };

    /* (funcition verificaHabilitaEncargo)
        Função utilizada para verificar parametro específico para
        habilitar ou não a visualização de Encargo no Lançamento de Pedido,
        esta função é executada no evento WidgetOnEnter de widgetPedido    
    */

    this.verificaHabilitaEncargo = function() {

        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            }
        ];
        Ped00100_lancamentoPedido_Service.findParamPedido(filter).then(function(parametros){
            
            if (parametros) {
                if (parametros.dataset.ped_parampedido[0].IDLANENCARGOPED == 'S') {
                    var widget = templateManager.container.getWidget('widgetEncargo');
                    widget.isVisible = true;
                }
            }
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error);
        }.bind(this));
    };

    this.verificaOrcamento = function() {
        var widget = templateManager.container.getActiveWidget();
        var filial;
        for (var i = 0; i < widget.dataSourceFilter.length; i++) {
            if (widget.dataSourceFilter[i].name == 'CDFILIAL'){
                filial = widget.dataSourceFilter[i].value;
            }
        }
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            }
        ];
        if (widget.currentRow.IDTIPOPEDIDO == '2' && widget.currentRow.__is_new) {
            General.callRestEngine('ped#/crud/ped_parampedido', 'FilterData', filter).then(function(parametros) {
                widget.currentRow.CDCLIENTE = parametros.dataset.ped_parampedido[0].CDCLIEORC; 
                widget.currentRow.NMRAZSOCCLIE = parametros.dataset.ped_parampedido[0].NMRAZSOCCLIEORC; 
                
                this.setParams(widget); 
            }.bind(this));
        } else if (widget.currentRow.IDTIPOPEDIDO == '1' && widget.currentRow.__is_new) {
            General.callRestEngine('ped#/crud/ped_parampedido', 'FilterData', filter).then(function(parametros) {
                widget.currentRow.CDCLIENTE =  parametros.dataset.ped_parampedido[0].CDCLIEORC ==  widget.currentRow.CDCLIENTE ? null  : widget.currentRow.CDCLIENTE; 
                widget.currentRow.NMRAZSOCCLIE =  parametros.dataset.ped_parampedido[0].NMRAZSOCCLIEORC ==  widget.currentRow.NMRAZSOCCLIE ? null  : widget.currentRow.NMRAZSOCCLIE; 
                
                this.setParams(widget);
            }.bind(this));
        }// else if (widget.currentRow.orcamento && !widget.currentRow.__is_new){
        //}
        
    }; 

    this.editPedido = function(widget){
        this.verificaTipoOper();
        this.setTipoOperClie();
        var filial = widget.currentRow.CDFILIAL;
        General.callRestEngine('ped#/crud/parampedido', 'FilterData', [{ "name": "CDFILIAL", "operator": "=", "value": filial }]).then(function(callback) {
 
            if(callback.dataset.parampedido[0].IDUTVALIPED == 'S'){
                widget.getField('DTVALIPED').readOnly = false;
                if (callback.dataset.parampedido[0].QTDIAVALIPED > 0) {
                    widget.currentRow.DTVALIPED = moment(widget.getField('DTPEDIDO').value(), 'DD/MM/YYYY').add(callback.dataset.parampedido[0].QTDIAVALIPED,'days').format('DD/MM/YYYY');
                } 
            }else{
                widget.getField('DTVALIPED').readOnly = true;
            }
        });
        if(widget.currentRow.IDTIPOPEDIDO == 2) {
            widget.currentRow.orcamento = true;
            widget.getField('NMRAZSOCCLIE').readOnlyOnEdit = false;
        } else {
            widget.currentRow.orcamento = false;
        }
        General.edit(widget);
    };

    this.setParams = function(widget) {
        if (widget.currentRow.__is_new) {
            this.setVendedor(widget);
            this.verifyModPgto(widget);
            this.filterPrecobase(widget);
            this.verificaPendencia(widget);
            this.setDadosTransportadora();
        }
    }; 
    
    this.setTipoOperClie = function(parametro){
        var widget = templateManager.container.getActiveWidget();
        var tipoOperacao = this.parametros.CDTIPOOPER;
        var filtro = [];
        
        if(widget.currentRow.CDCLIENTE != "" && widget.currentRow.CDCLIENTE != undefined){
            filtro.push(
               {
                    name: 'CDCLIENTE',
                    operator: '=',
                    value: widget.currentRow.CDCLIENTE
                    
                } 
            );
        }else{
           filtro.push(
               {
                    name: 'CDCLIENTE',
                    operator: '=',
                    value: parametro.CDCLIENTE
                    
                } 
            ); 
        }
        
        General.callRestEngine('ped#/crud/cliente_parametrizacoes', 'FilterData', filtro).then(function(callback){
            
            if(this.parametros.IDOBRTPOPPED =='S'){
                var tipooper;
                if(callback.dataset.cliente_parametrizacoes[0] && callback.dataset.cliente_parametrizacoes[0].CDTIPOOPERPED != null ){
                    
                        tipooper = widget.getField('NMTIPOOPER').dataSource.data.filter(function(row){ return row.CDTIPOOPER == callback.dataset.cliente_parametrizacoes[0].CDTIPOOPERPED;});
                        widget.getField('NMTIPOOPER').readOnly = true;
    
                }else if (tipoOperacao > 0  || tipoOperacao == 0) {
                    
                    tipooper = widget.getField('NMTIPOOPER').dataSource.data.filter(function(row){ return row.CDTIPOOPER == tipoOperacao;});
                    widget.getField('NMTIPOOPER').readOnly = false;
                }
                if(tipooper.length != 0){
                    widget.currentRow.CDTIPOOPER = tipooper[0].CDTIPOOPER;
                    widget.currentRow.NMTIPOOPER = tipooper[0].NMTIPOOPER;
                    widget.currentRow.IDORIGDESTOP = tipooper[0].IDORIGDESTOP;
                    widget.currentRow.IDOPERDEVONF = tipooper[0].IDOPERDEVONF;
                    widget.currentRow.IDSERIEAUTO = tipooper[0].IDSERIEAUTO;
                    widget.currentRow.IDUTILVENC = tipooper[0].IDUTILVENC;
                    widget.currentRow.IDENTRSAIDOP = tipooper[0].IDENTRSAIDOP;
                    widget.currentRow.DSOPERNFORIG = tipooper[0].DSOPERNFORIG;
                    widget.currentRow.CDMODDOCFISC = tipooper[0].CDMODDOCFISC;
                    widget.currentRow.DSMODDOCFISC = tipooper[0].DSMODDOCFISC;
                    widget.currentRow.IDATUESTTPOP = tipooper[0].IDATUESTTPOP;
                    var row = {
                    	IDORIGDESTOP: widget.currentRow.IDORIGDESTOP
                    };
                    this.verificaTipoOper(row);
                }
            }
        }.bind(this));
        
    };

    this.verificaPendencia = function(widget){
        var filter = [
            {
                name: "CDCLIENTE",
                operator: "=",
                value: widget.currentRow.CDCLIENTE
            }
        ];
        if(widget.IDPENDFINANLANC == 'S'){
            General.callRestEngine('ped_pedidos#/crud/cliente_pendenciafinanceira', 'FilterData', filter).then(function(success) {
                var rowCliente  = success.dataset.cliente_pendenciafinanceira.filter(function(data){ return data.CDCLIENTE == widget.currentRow.CDCLIENTE;});
                if (rowCliente && rowCliente.length > 0) {
                    var limite = parseInt(widget.limitePendencia);
                    if (widget.IDPENDFINAN == '2') {
                        if (rowCliente[0].DATA > 0 && rowCliente[0].DATA > limite) {
                            ScreenService.showMessage('Cliente possui pendência financeira');
                            widget.currentRow.CDCLIENTE = '';
                            widget.currentRow.NMRAZSOCCLIE = '';
                            widget.currentRow.CDVENDEDOR = '';
                            widget.currentRow.NMFANVEN = '';
                            widget.currentRow.CDPRECOBASE = '';
                            widget.currentRow.DSPRECOBASE = '';
                            widget.currentRow.CDFORMPGTO = '';
                            widget.currentRow.CDMODPGTO = '';
                            widget.currentRow.DSMODPGTO = '';
                        }
                    } else if (widget.IDPENDFINAN == '3') {
                        this.openPendenciaPopUp(widget);
                    }
                }
            }.bind(this));
        }
    }; 

    this.openPendenciaPopUp = function (widget) {
        var pendenciaFinanceira_msg = ScreenService.i18n("Cliente possui pendência financeira, para continuar será necessário validar o operador.");
        ScreenService.showCustomDialog(pendenciaFinanceira_msg, 'exclamation', 'exclamation', [
            {
                label: ScreenService.i18n("Ok"),
                code: function(){
                    ScreenService.openPopup(widget.container.getWidget('widgetSenha'));
                }
            }
        ]);
    }; 

    this.checkLogin = function(widget) {
        var widgetPedidos = templateManager.container.getWidget("widgetPedido");
        if (widget.currentRow.OPRLOGIN != undefined && widget.currentRow.OPRSENHA != undefined &&
           widget.currentRow.OPRLOGIN != "" && widget.currentRow.OPRSENHA != "") {
            var filial = '';
            for (i = 0; i < widgetPedidos.dataSourceFilter.length; i++) {
                if (widgetPedidos.dataSourceFilter[i].name == 'CDFILIAL'){
                    filial = widgetPedidos.dataSourceFilter[i].value;
                }
            }
            var login = [
                {
                    login: widget.currentRow.OPRLOGIN,
                    senha: widget.currentRow.OPRSENHA,
                    cdfilial: filial
                }
            ];
            /*if (this.grupOperApro != ""){
                login[0].grupo = this.grupOperApro;
            }*/
            General.callRestEngine('ped_pedidos#/pendencia/checkLogin', 'DataSet', login).then(function(callback) {
                var result = callback.dataset.result;
                if (result.matched) {
                    if (result.isOnGroup) {
                        templateManager.container.getWidget('widgetSenha').currentRow = {};
                        ScreenService.closePopup(templateManager.container.getWidget('widgetSenha'));
                        templateManager.container.getWidget('widgetPedido').mode = 'edit';
                        templateManager.updateTemplate();
                        templateManager.container.getWidget('widgetPedido').activate().then(function(){
                            templateManager.container.getWidget('widgetPedido').activate();
                        });
                    } else {
                        ScreenService.showMessage("Este operador não possui autorização para realizar esta operação.");
                    }
                } else {
                    ScreenService.showMessage("Usuário e senha inválidos.");
                }
            }.bind(this));
        } else {
            ScreenService.showMessage("É necessário preencher todos os campos.");
        }
    }; 

    this.cancelarLoginPopUp = function (widget) {
        templateManager.container.getWidget('widgetPedido').currentRow.CDCLIENTE = '';
        templateManager.container.getWidget('widgetPedido').currentRow.NMRAZSOCCLIE = '';
        templateManager.container.getWidget('widgetPedido').currentRow.CDVENDEDOR = '';
        templateManager.container.getWidget('widgetPedido').currentRow.NMFANVEN = '';
        templateManager.container.getWidget('widgetPedido').currentRow.CDPRECOBASE = '';
        templateManager.container.getWidget('widgetPedido').currentRow.DSPRECOBASE = '';
        templateManager.container.getWidget('widgetPedido').currentRow.CDFORMPGTO = '';
        templateManager.container.getWidget('widgetPedido').currentRow.CDMODPGTO = '';
        templateManager.container.getWidget('widgetPedido').currentRow.DSMODPGTO = '';
        ScreenService.closePopup();
    }; 
    this.setDescontoOP = function(){
        this.retornaOperadorLogadoDesk().then(function(operador){
			var cdoperador = operador.dataset.operador[0].CDOPERADOR;
			var filter_vendedor = [
				{
					name: 'CDOPERADOR',
					operator: '=',
					value: cdoperador
				}
			];

			var promises =[];
			promises.push(General.callRestEngine('ped#/crud/vendedor', 'FilterData', filter_vendedor));
			ZHPromise.all(promises).then(function(callback) {
				
				if(callback[0].dataset.vendedor[0].length != 0){
					var widget = templateManager.container.getActiveWidget();
					var vendedor = [
						{
							name:'CDVENDEDOR',
							operator:'=',
							value: callback[0].dataset.vendedor[0].CDVENDEDOR
						}
					];
					General.callRestEngine("ped#/crud/cliente_vendedor", "FilterData", vendedor).then(function(sucess){
						widget.currentRow.VRPEMAXDESVE = sucess.dataset.cliente_vendedor[0].VRPEMAXDESVE;
					});
				}
			});
		});
    };

    this.setVendedor = function (widget) {
        if(this.parametros) {
            if ((!widget.currentRow.CDVENDEDOR) && this.parametros.CDVENDEDOR) {
                widget.currentRow.CDVENDEDOR = this.parametros.CDVENDEDOR;
                
                if (this.parametros.IDUTRELACVENDCLI == 'N'){
                    widget.currentRow.CDVENDEDOR = widget.appliedFilter.FILTER_ROW.CDVENDEDOR;
                    widget.currentRow.NMFANVEN = widget.appliedFilter.FILTER_ROW.NMFANVEN;
                }
                if(this.parametros.CDVENDEDOR){
                    
                    var filter = [{
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": this.parametros.CDVENDEDOR
                    }];
    
                    General.callRestEngine('ped#/crud/vendedor', 'FilterData', filter).then(function(callback) {
                        widget.currentRow.NMFANVEN = callback.dataset.vendedor[0].NMFANVEN;
                        widget.currentRow.CDVENDEDOR = callback.dataset.vendedor[0].CDVENDEDOR;
                        widget.currentRow.VRPEMAXDESVE= callback.dataset.vendedor[0].VRPEMAXDESVE;
                    });
                } 
            }else {
                
                var filterClieVen = [
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": widget.currentRow.CDCLIENTE 
                    }
                ];
                General.callRestEngine('ped#/crud/cliente_vendedor', 'FilterData', filterClieVen).then(function(callback){
                    var cdvendedor = callback.dataset.cliente_vendedor[0].CDVENDEDOR;
                    if(cdvendedor){
                        widget.currentRow.NMFANVEN = callback.dataset.cliente_vendedor[0].NMFANVEN;
                        widget.currentRow.CDVENDEDOR = callback.dataset.cliente_vendedor[0].CDVENDEDOR;
                    }else{
                        
                        var filter_vendedor = [
                            {
                                "name": "CDOPERADOR",
                                "operator": "=",
                                "value": "OPERADOR_LOGADO"
                            }
                        ];
                        
                        General.callRestEngine('ped#/crud/vendedor', 'FilterData', filter_vendedor).then(function(callback){
                            var vendedor = callback.dataset.vendedor;
                            
                            widget.currentRow.NMFANVEN = vendedor[0].NMFANVEN;
                            widget.currentRow.CDVENDEDOR = vendedor[0].CDVENDEDOR;

                        }.bind(this));
                    }
                
                }.bind(this));

            }
        }
        this.setDescontoOP();
    }; 

    this.filterPrecobase = function (widget) {

        if(widget.name != "widgetPedido") {
            widget = templateManager.container.getWidget('widgetPedido');
        }
        if (widget.currentRow.CDCLIENTE) {
            widget.getField('DSPRECOBASE').readOnly = false;
            widget.getField('DSPRECOBASE').reload();
            
            var filter = [
                {
                    "name": "CDCLIENTE",
                    "operator": "=",
                    "value": widget.currentRow.CDCLIENTE
                },
                {
                    "name": "IDPRBASEPRIN",
                    "operator": "=",
                    "value": "S"
                }
            ];
            General.callRestEngine('ped#/crud/precobasecli_parametrizacao', 'FilterData', filter).then(function(callback) {
                if (callback.dataset.precobasecli_parametrizacao.length > 0){
                    var dsprecobasePrincipal = callback.dataset.precobasecli_parametrizacao[0].DSPRECOBASE;
                    var cdprecobasePrincipal = callback.dataset.precobasecli_parametrizacao[0].CDPRECOBASE;
                    var nmIndicePrincipal = callback.dataset.precobasecli_parametrizacao[0].NMINDICE;
                        
                    if (widget.currentRow.__is_new){
                        templateManager.container.getWidget('widgetPedido').getField('DSPRECOBASE').setValue(dsprecobasePrincipal);
                        templateManager.container.getWidget('widgetPedido').getField('CDPRECOBASE').setValue(cdprecobasePrincipal);
                        templateManager.container.getWidget('widgetPedido').getField('NMINDICE').setValue(nmIndicePrincipal);
                        // ADICIONADO PARA CORRIGIR ERRO DE PRECOBASSE ERRADO NA ESCOLHA DO PRODUTO
                        this.setPrebaseFilter(widget);
                    }
                } else if (widget.currentRow.__is_new) {
                    templateManager.container.getWidget('widgetPedido').getField('DSPRECOBASE').setValue("");
                }
            }.bind(this));
        } else {
            widget.getField('DSPRECOBASE').clearValue();
            widget.getField('DSPRECOBASE').readOnly = true;
        }
    }; 

    this.changeFilterPrecobase = function (widget) {
        widget.container.getWidget('widgetItens').getField('NMPRODUTO').dataSourceFilter[0] =
            {
                "name": "CDPRECOBASE",
                "operator": "=",
                "value": widget.currentRow.CDPRECOBASE
            };
    };
    
    this.changeMoeda = function(widget) {
        var nomeMoeda = widget.currentRow.NMINDICE;
        widget.getField('NMINDICE').setValue(nomeMoeda); 
    };

    this.addZero = function(number) {
        if (parseInt(number) < 10) {
            return "0"+number;
        } else {
            return number;
        }
    }; 

    this.addItens = function (widget) {
        ScreenService.openSwipe(templateManager.container.getWidget('widgetConsultaProduto'));
        templateManager.container.getWidget('widgetConsultaProduto').reload();
    };
    
    this.addItem = function (widget) {
        this.backupItem = {};
        this.backupData = Util.clone(widget.dataSource.data);
        widget.newRow();
        
        if (!(widget)) {
            widget = templateManager.container.getWidget('widgetItens');
        }
        if (this.parametros.IDPERALTPRECO == 'N') {
            widget.getField('VRPREUNITPED').readOnly = true;
        } else {
            widget.getField('VRPREUNITPED').readOnly = false;
        }
        widget.currentRow.DTENTITPED = widget.getParent().getField('DTENTPED').value().substr(0,10) + " " + new Date().getHours() + ":" + this.addZero(new Date().getMinutes());
        widget.currentRow.NRPEDIDO = widget.getParent().getField('NRPEDIDO').value();
        widget.currentRow.CDFILIAL = widget.getParent().getField('CDFILIAL').value(); //this.parametros.CDFILIAL;
        for (var i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
            if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                filial = widget.getParent().dataSourceFilter[i].value;
            }
        }
        var filial = '0000';
        for (i = 0; i < widget.container.getWidget('widgetPedido').dataSourceFilter.length; i++) {
            if (widget.container.getWidget('widgetPedido').dataSourceFilter[i].name == 'CDFILIAL') {
                filial = widget.container.getWidget('widgetPedido').dataSourceFilter[i].value;
            }
        }
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        Ped00100_lancamentoPedido_Service.findParameters(filter).then(function(callback){
            widget.paramsPreco = callback.dataset.parampedido[0]; 
            
        });
        
        templateManager.container.getWidget('widgetImposto').isVisible = false;
        templateManager.container.getWidget('widgetReserva').isVisible = false;
    }; 

    this.validaPrecoUnit = function (widget) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            }
        ];
        Ped00100_lancamentoPedido_Service.findParameters(filter).then(function(callback){
             widget.paramsPreco = callback.dataset.parampedido[0]; 

        if (widget.paramsPreco) {
            var parametros = widget.paramsPreco;
            var VRPREUNITPED = widget.currentRow.VRPREUNITPED;
            if (typeof(VRPREUNITPED) == 'string') {
                VRPREUNITPED+=" ";
                VRPREUNITPED = VRPREUNITPED.replace(',', '.');
                VRPREUNITPED = parseFloat(VRPREUNITPED);
            }
            widget.getField('VRPREUNITPED').value(VRPREUNITPED);
            var VRPRTABITPED = widget.currentRow.VRITEPREBASE;

            if (parametros.IDPERALTPRECO === 'S') {
                var validaMax = false;
                var validaMin = false;
                if ((parametros.DSPERALTMAIOR)) {
                    var vrMaior = VRPRTABITPED + ((VRPRTABITPED * parametros.DSPERALTMAIOR)/100);
                    if (VRPREUNITPED > vrMaior) {
                        if (!parametros.CDGRUALTPRECO) {
                            ScreenService.showMessage('Operação não permitida.');
                            widget.getField('VRPREUNITPED').value(VRPRTABITPED);
                        } else {
                            this.retornaOperadorLogadoDesk().then(function(calloper) {
        
                                var cdoperador = calloper.dataset.operador[0].CDOPERADOR;
                                this.verificaGrupOper(parametros.CDGRUALTPRECO, cdoperador).then(function(callgrup) {
                                    if (!callgrup.dataset.opergrupop[0]) {
                                        ScreenService.showMessage('Operador não tem permissão.');
                                        widget.getField('VRPREUNITPED').value(VRPRTABITPED);
                                    }
                                    this.calcValorDesc(widget);
                                    this.calcValorTotal(widget);
                                }.bind(this));
                            }.bind(this));
                        }
                    } else {
                        this.calcValorDesc(widget);
                        this.calcValorTotal(widget);
                    }
                } else if ((parametros.DSPERALTMAIOR == '') || (parametros.DSPERALTMAIOR === null)) {
                    validaMax = true;
                }
                if ((parametros.DSPERALTMENOR)) {
                    var vrMenor = VRPRTABITPED - ((VRPRTABITPED * parametros.DSPERALTMENOR)/100);
                    if (VRPREUNITPED < vrMenor) {
                        if (!parametros.CDGRUALTPRECO) {
                            ScreenService.showMessage('Operação não permitida.');
                            widget.getField('VRPREUNITPED').value(VRPRTABITPED);
                        } else {
                            this.retornaOperadorLogadoDesk().then(function(calloper) {

                                var cdoperador = calloper.dataset.operador[0].CDOPERADOR;
                                this.verificaGrupOper(parametros.CDGRUALTPRECO, cdoperador).then(function(callgrup){
                                    if (!callgrup.dataset.opergrupop[0]){
                                        ScreenService.showMessage('Operador não tem permissão.');
                                        widget.getField('VRPREUNITPED').value(VRPRTABITPED);

                                        //ScreenService.showMessage('S - Vou deixar alterar.');
                                    }
                                    this.calcValorDesc(widget);
                                    this.calcValorTotal(widget);
                                }.bind(this));
                            }.bind(this));
                        }
                    } else {
                        this.calcValorDesc(widget);
                        this.calcValorTotal(widget);
                    }
                } else if ((parametros.DSPERALTMENOR == '') || (parametros.DSPERALTMENOR === null)) {
                    validaMin = true;
                }
                if (validaMin && validaMax) {
                    this.calcValorDesc(widget);
                    this.calcValorTotal(widget);
                }
            } else {
                this.retornaOperadorLogadoDesk().then(function(calloper){
        
                    var cdoperador = calloper.dataset.operador[0];
                    this.verificaGrupOper(parametros.CDGRUALTPRECO, cdoperador).then(function(callgrup){
                        if (!callgrup.dataset.opergrupop[0]){
                            ScreenService.showMessage('Operador não tem permissão.');
                            widget.getField('VRPREUNITPED').value(VRPRTABITPED);
                        } else {
                            this.calcValorDesc(widget);
                            this.calcValorTotal(widget);
                        }
                    }.bind(this));
                }.bind(this));
            }
        }
     }.bind(this));
    }; 

    this.verificaGrupOper = function(cdgrupoper, cdoperador){
        var filter = [
            {
                "name": "CDGRUPOPER",
                "operator": "=",
                "value": cdgrupoper
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": cdoperador
            }
        ];

        var params = {
            "requestType": "FilterData",
            "filter": filter
        };

        return restEngine.request("ped#/crud/opergrupop", params);
    }; 

    this.calculaValor = function (field) {
        
        var percnt = field;
        // var percnt = field.value();
        
        var vrTotal;
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        if (widgetPedido.currentRow.__is_new) {
            vrTotal = widgetPedido.getField('VRTOTPEDLIQ').value();
        } else {
            vrTotal = widgetPedido.getField('VRTOTALPED').value();
        }
        percnt = percnt/100;
        vrTotal = vrTotal * percnt;
        vrTotal = parseFloat(vrTotal.toFixed(2));
        
        var widgetPrazoPed = templateManager.container.getWidget('widgetPrazoPed');
        widgetPrazoPed.getField('VRPARCELA').setValue(vrTotal);
        // field.widget.getField('VRPARCELA').setValue(vrTotal);
    }; 

    this.calcPercentual = function (field) {
        var percnt = field.value();
        var vrTotal = field.widget.getParent().getField('VRTOTALPED').value();
        percnt = percnt/100;
        vrTotal = vrTotal * percnt;
        field.widget.getField('VRPERCPGTOPED').setValue(percnt);
    }; 

    this.checkProperties = function (widget) {
        widget = widget.container.getWidget('widgetPedido');
        if (widget.currentRow.CDFILIAL) {
            if (widget.currentRow.CDFILIAL != "") {
                var filter = [{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                }];

                General.callRestEngine('ped#/crud/filial', 'FilterData', filter).then(function(callback) {

                    widget.currentRow.CDEMPRESA = callback.dataset.filial[0].CDEMPRESA;
                    widget.currentRow.CDINSCESTA = callback.dataset.filial[0].CDINSCESTA;
                });
            }
        }
        if (!(widget.currentRow.__is_new)) {
            widget.container.getWidget('widgetItens').getAction('fecharPedidoItem').isVisible = false;
            widget.container.getWidget('widgetPrazoPed').getAction('fecharPedidoPrazo').isVisible = false;
            widget.container.getWidget('widgetDadosAdicionais').getAction('fecharPedidoDadosAdic').isVisible = false;
            widget.container.getWidget('transportadora').getAction('fecharPedidoTransportadora').isVisible = false;
            
            widget.container.getWidget('widgetItens').reload();
            widget.container.getWidget('widgetPrazoPed').reload();
            widget.container.getWidget('widgetDadosAdicionais').reload();
            widget.container.getWidget('transportadora').reload();
        } 

    }; 

    this.verificaStatusNotaFiscal = function (widget) {
        
        var pedido = widget.currentRow;
        var notaFiscal = widget.container.getWidget('widgetNotaFiscal');
        
        if (pedido.IDSITPEDIDO == 3 || pedido.IDSITPEDIDO == 6) {
            notaFiscal.isVisible = true;
        } else {
            notaFiscal.isVisible = false;
        }
    };

    
    this.verificaStatus = function (widget) {
        
        //widget e ações de pedido
        widget = widget.container.getWidget('widgetPedido');
        var editarPedido = widget.getAction('editarPedido');
        var excluirPedido = widget.getAction('excluirPedido');
        
        //widget e ações de itens
        var itensPedido = widget.container.getWidget('widgetItens');
        var novoItem = itensPedido.getAction('novoItem');
        var fecharPedidoItem = itensPedido.getAction('fecharPedidoItem');
        var excluirItem = itensPedido.getAction('excluirItem');
        
        //widget e ações de prazoped
        var prazoPed = widget.container.getWidget('widgetPrazoPed');
        // var editarModalidade = prazoPed.getAction('editarModalidade');
        var editarPrazo = prazoPed.getAction('editarPrazo');
        var incluirPrazo = prazoPed.getAction('incluirPrazo');
        
        //widget e ações de dados adicionais
        var dadosAdicionais = widget.container.getWidget('widgetDadosAdicionais');
        var actNovoDadosAdicionais = dadosAdicionais.getAction('actNovoDadosAdicionais');
        var excluirDadosAdicionais = dadosAdicionais.getAction('excluirDadosAdicionais');
        var editarDadosAdicionais = dadosAdicionais.getAction('editarDadosAdicionais');
        
        if (widget.currentRow.IDSITPEDIDO == '2' || widget.currentRow.IDSITPEDIDO == '7' || widget.currentRow.IDSITPEDIDO == '8') {
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                },
                {
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": widget.currentRow.NRPEDIDO
                }
            ];
            General.callRestEngine('ped#/crud/itempedido', 'FilterData', filter).then(function(callback) {
                var status = [];
                callback.dataset.itempedido.forEach(function(value) {
                    if (status.indexOf(value.IDSITITEMPED) == -1 ) {
                        status.push(value.IDSITITEMPED);
                    }
                });
                if (status.indexOf("1") >= 0 || status.indexOf("2") >= 0 || status.indexOf("7") >= 0 || status.indexOf("8") >= 0) {
                    // posso editar e talvez excluir
                    editarPedido.isVisible = true;
                    novoItem.isVisible = true;
                    if (widget.IDEXCLPEDIDO == 'S') {
                        excluirPedido.isVisible = true;
                    }
                } else if (status.indexOf("3") >= 0 || status.indexOf("4") >= 0) {
                    editarPedido.isVisible = false;
                    excluirPedido.isVisible = false;
                    novoItem.isVisible = false;
                    fecharPedidoItem.isVisible = false;
                }
                
                if (this.parametros.IDALTMODPAG == 'S'){
                    // editarModalidade.isVisible = true;
                    widget.getField('DSMODPGTO').readOnly = false;
                } else if (this.parametros.IDALTMODPAG == 'N'){
                    widget.getField('DSMODPGTO').readOnly = false;
                }
                if (this.parametros.IDALTFORMAPAG == 'S'){
                    editarPrazo.isVisible = true;
                } else if (this.parametros.IDALTFORMAPAG == 'N'){
                    editarPrazo.isVisible = false;
                }
                
            }.bind(this));
        } else if (widget.currentRow.IDSITPEDIDO == '3' || widget.currentRow.IDSITPEDIDO == '4'){
            //Nao edita item nem pedido, não adiciona item, nao exclui item nem pedido
            editarPedido.isVisible = false;
            excluirPedido.isVisible = false;
            novoItem.isVisible = false;
            excluirItem.isVisible = false;
            // editarModalidade.isVisible = false;
            editarPrazo.isVisible = false;
            incluirPrazo.isVisible = false;
        } else {
            editarPedido.isVisible = true;
            novoItem.isVisible = true;
            if (widget.IDEXCLPEDIDO == 'S') {
                excluirPedido.isVisible = true;
            }
        }
        if (widget.currentRow.IDSITPEDIDO == '3' || widget.currentRow.IDSITPEDIDO == '4') {
            actNovoDadosAdicionais.isVisible = false;
            excluirDadosAdicionais.isVisible = false;
            editarDadosAdicionais.isVisible = false;
        } else {
            actNovoDadosAdicionais.isVisible = true;
            excluirDadosAdicionais.isVisible = true;
            editarDadosAdicionais.isVisible = true;
        }
        
        this.verificaStatusNotaFiscal(widget);
       //templateManager.container.getActiveWidget().reload();
        templateManager.updateTemplate();
    }; 

    this.verificaStatusItem = function (widget) {
        //widget.reload().then(function(callback){
            var status = [];
            var row = widget.currentRow;
            
            status.push(row.IDSITITEMPED);
            /*widget.dataSource.data.forEach(function(value) {
                if (status.indexOf(value.IDSITITEMPED) == -1 ) {
                    status.push(value.IDSITITEMPED);
                }
            });*/
            
            var widgetPedido = templateManager.container.getWidget('widgetPedido');
            
            if (status.indexOf("1") >= 0) {
                // posso editar e talvez excluir o
                widget.getAction('editarItem').isVisible = true;
                widget.getAction('excluirItem').isVisible = true;
                if (this.parametros.IDEXCLPEDIDO == 'S') {
                    widgetPedido.getAction('excluirPedido').isVisible = true;
                }
            } else if (status.indexOf("2") >= 0) {
                // posso editar e talvez excluir
                widget.getAction('editarItem').isVisible = true;
                if (this.parametros.IDEXCLPEDIDO == 'S') {
                    widgetPedido.getAction('excluirPedido').isVisible = true;
                }
            } else if (status.indexOf("3") >= 0 || status.indexOf("4") >= 0 || status.indexOf("5") >= 0) {
                // nao posso fazer nada
                widget.getAction('editarItem').isVisible = false;
                widget.getAction('excluirItem').isVisible = false;
                widgetPedido.getAction('excluirPedido').isVisible = false;
            }
            
            if (!widget.currentRow.__is_new){
                if (this.parametros.IDEXIBIMPITPED == 'N'){
                    templateManager.container.getWidget('widgetImposto').isVisible = false;
                } else if (this.parametros.IDEXIBIMPITPED == 'S'){
                    templateManager.container.getWidget('widgetImposto').isVisible = true;
                } else { 
                    templateManager.container.getWidget('widgetImposto').isVisible = false;
                }
                
                //ainda nao e usada a parte de reserva
                if (this.parametros.IDUTRESELOTE == 'N'){
                    templateManager.container.getWidget('widgetReserva').isVisible = false;
                } else if (this.parametros.IDUTRESELOTE == 'S'){
                    templateManager.container.getWidget('widgetReserva').isVisible = true;
                } else {
                    templateManager.container.getWidget('widgetReserva').isVisible = false;
                }
                if(templateManager.container.getWidget('widgetPedido').currentRow.IDTIPOPEDIDO !== '1') {
                    templateManager.container.getWidget('widgetReserva').isVisible = false;
                }
                if(templateManager.container.getWidget('widgetPedido').currentRow.IDATUESTTPOP !== 'S') {
                    templateManager.container.getWidget('widgetReserva').isVisible = false;
                } else if (templateManager.container.getWidget('widgetPedido').currentRow.IDATUESTTPOP == 'S') {
                    templateManager.container.getWidget('widgetReserva').isVisible = true;
                }
            }
            
            // var widItensSwipe = templateManager.container.getWidget('widgetItensTabb');	
            // ScreenService.openSwipe(templateManager.container.getWidget('widgetItensTabb'));	
            	
            // widItensSwipe.activate();	
            // widItensSwipe.view();	
            // widItensSwipe.currentRow = templateManager.container.getWidget('widgetItensTabb').currentRow;	
            // widItensSwipe.isVisible = false;	
            	
            // widItensSwipe.reload().then(function(){	
            //     widItensSwipe.isVisible = true;	
            // });	
            
        // });
    }; 

    this.verificaStatusEncargo = function (widget) {
        var pedido = widget.getParent();
        var editarEncargo = widget.getAction('editarEncargo');
        var excluirEncargo = widget.getAction('excluirEncargo');
        var fecharPedido = widget.getAction('fecharPedidoEncargo');
        if (pedido.currentRow.__is_new || pedido.currentRow.IDSITPEDIDO == 1 || pedido.currentRow.IDSITPEDIDO == 2 || pedido.currentRow.IDSITPEDIDO == 7) {
            editarEncargo.isVisible = true;
            excluirEncargo.isVisible = true;
        } else {
            editarEncargo.isVisible = false;
            excluirEncargo.isVisible = false;
        }
        if (pedido.currentRow.__is_new){
            fecharPedido.isVisible = true;
        } else {
            fecharPedido.isVisible = false;
        }
    }; 
    
    

    this.editItem = function (widget) {
        //widget.currentRow.__is_new = widget.getParent().currentRow.__is_new;
        // widget.getParent().currentRow.__is_new = false;
        General.edit(widget);
        this.backupItem = Util.clone(widget.currentRow);
        this.backupData = Util.clone(widget.dataSource.data);      
        this.getParamPreco(templateManager.container.getWidget('widgetPedido'));
        if (this.parametros.IDPERALTPRECO == 'N') {
            widget.getField('VRPREUNITPED').readOnly = true;
        } else {
            widget.getField('VRPREUNITPED').readOnly = false;
        }
        this.verificaPrecoOpcio();

    }; 
    
    this.editEncargo = function (widget) {
        
        widget.currentRow.__is_new = widget.getParent().currentRow.__is_new;
        General.edit(widget);
    }; 

    this.cancelEditItem = function(args) {
        var widget = args.owner.widget;
        
        if (widget.getParent().currentRow.__is_new){
            var rowEdited = widget.dataSource.data.filter(function(row){
                return row.NRITEMPED == this.backupItem.NRITEMPED && row.NRPEDIDO == this.backupItem.NRPEDIDO;
            }.bind(this));
            
            if (rowEdited.length > 0 ) {
                for (var i = 0; i < widget.dataSource.data.length; i++) {
                    if (widget.dataSource.data[i].NRITEMPED == this.backupItem.NRITEMPED && widget.dataSource.data[i].NRPEDIDO == this.backupItem.NRPEDIDO) {
                        widget.dataSource.data[i] = this.backupItem;
                    }
                }
            } else {
                widget.dataSource.data = this.backupData;
            }
            widget.view();
    		ScreenService.goBack();
        } else {
            General.backOrCancel(args).then(function(){
                this.getItem(widget);
            }.bind(this));
        }
    };
    
    this.removeEncargoCache = function(widget) {
        Ped00100_lancamentoPedido_Service.getData("ped_pedidos#/encargo_lancamento").then(function(dadosEncargos) {
        //  dadosEncargos = dadosEncargos.filter(function(value){ return value.CDENCARGO !== widget.currentRow.CDENCARGO; });
          
            widget.currentRow.VRENCARGOPED = "0";
            widget.currentRow.VRPERCENTENC = "0";
            dadosEncargos.forEach(function(encargo){
                if (encargo.CDENCARGO == widget.currentRow.CDENCARGO) {
                    
                    encargo.VRENCARGOPED = "0";
                    encargo.VRPERCENTENC = "0";
                }
            }.bind(this));
            widget.dataSource.data.forEach(function(encargoDataSource, index){
                if (encargoDataSource.CDENCARGO == widget.currentRow.CDENCARGO) {
                    widget.dataSource.data[index].VRENCARGOPED = "0";
                    widget.dataSource.data[index].VRPERCENTENC = "0";
                }
            }.bind(this));
           
           this.salvarEncargosCache(dadosEncargos, widget);
          
        }.bind(this));
    };
    
    /*  (function defineEncargo)
        Função para atribuir aos encargos padrões valores de um pedido específico
    */
    this.defineEncargo = function(encargo, pedido) {
        if ( !encargo.NRPEDIDO && pedido.CDFILIAL != "") {
            encargo.NRPEDIDO = pedido.NRPEDIDO;
            encargo.CDFILIAL = pedido.CDFILIAL;
            encargo.__is_new = true;
        }
    };
    
    /* (function excluirEncargo)
        Função que exclui Encargo em dois estados:
        Ou se Pedido é novo ou se o Pedido já foi cadastrado antes
    */
    this.excluirEncargo = function(widget) {
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        if (this.PedidoEhNovo()) {
            this.removeEncargoCache(widget);
        } else {
            General.deleteCrud(widget).then(function(){
                widgetPedido.getField('VRTOTALPED').reload();
                widgetPedido.reload();
                
            });
        }
        
    };
  
    this.montaConfig = function(args){
        
        var pedido = args.owner.getParent().currentRow;
    
        Ped00100_lancamentoPedido_Service.montaConfigTransmissao(pedido).then(function(resp){
        }, requestError);
    };
    
     var requestError = function(error){
        var errorMessage = ScreenService.i18n("Ocorreu um erro ao tentar realizar a operação.");
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    this.verificarStatusServico = function(args){
        var rows = args.owner.widget.getCheckedRows();
        
        var notasMarcadas = rows.filter(function(nota) {
            return nota.IDSTATUSNFE == 'P' || nota.IDSTATUSNFE == 'R';
        });
        if (notasMarcadas.length > 0) {
            Ped00100_lancamentoPedido_Service.statusServico(notasMarcadas).then(function(status){
                if(Object.keys(status[0])[0] === "STATUS"){
                    var popupTransmissao = args.owner.widget.container.getWidget('popupTransmissao');
                    popupTransmissao.getField("MENSAGEM").setValue(status[0].STATUS);
                    ScreenService.openPopup(popupTransmissao);
                }
                if(Object.keys(status[0])[0] === "SUCCESS"){
                    ScreenService.showMessage('Nota(s) transmitida(s) com sucesso!');
                    atualizaStatusNota(notasMarcadas, status[0].SUCCESS);
                    args.owner.widget.reload();
                    args.owner.widget.unSelectAll();
                }
                else if(Object.keys(status[0])[0] === "ERRORS"){
                    if(typeof status[0].ERRORS === 'string')
                        ScreenService.showMessage(status[0].ERRORS, "ERROR");
                    else{
                        var popupErros = args.owner.widget.container.getWidget('popupErros');
                        popupErros.currentRow.MENSAGEM = status[0].ERRORS;
                        popupErros.getField('MENSAGEM').textRows = status[0].ERRORS.length;
                        ScreenService.openPopup(popupErros);
                    }
                }
                else{
                    ScreenService.showMessage(status[0]);
                }
            });
        }
        else {
            ScreenService.showMessage("Todas as notas selecionadas já foram transmitidas.");
        }
        
    };

    this.excluirItem = function (widget) {
        var itens = widget.dataSource.data.filter(function(value){return value.NRPEDIDO == widget.getParent().currentRow.NRPEDIDO;});
        if (itens && itens.length > 1) {
            if (widget.getParent().currentRow.__is_new) {
                var excluir_Item_msg = ScreenService.i18n("Deseja Excluir o item?");
                ScreenService.showCustomDialog(excluir_Item_msg, 'question', 'question', [{
                    label: ScreenService.i18n("Sim"),
                    code: function(){
                        for(var i=0; i<widget.dataSource.data.length; i++) {
                            if(widget.dataSource.data[i] == widget.currentRow) {
                                widget.dataSource.data.splice(i,1);
                            }
                        }
                        widget.getParent().currentRow.VRTOTALPED = 0;
                        widget.getParent().currentRow.VRTOTPEDLIQ = 0;
                        widget.currentRow.IDSITITEMPED = '1';
                        widget.dataSource.data.forEach(function(item){
                            widget.getParent().currentRow.VRTOTALPED += parseFloat(item.VRTOTALITEM);
                            widget.getParent().currentRow.VRTOTPEDLIQ += parseFloat(item.VRTOTALITEMSEMIMP);
                        });

                        Ped00100_lancamentoPedido_Service.setData("ped#/crud/itempedido_completa", widget.dataSource.data).then(function(){
                            Ped00100_lancamentoPedido_Service.getData("ped#/crud/itempedido_completa").then(function(callback){
                                widget.dataSource.data = callback;
                                if (widget.container.getWidget('widgetPrazoPed').dataSource.data && widget.container.getWidget('widgetPrazoPed').dataSource.data.length > 0 ) {
                                    // var percnt;
                                    // var vrTotalPrazo;
                                    // var vrTotal = widget.getParent().getField('VRTOTALPED').value();
                                    this.buildPrazo(widget.container.getWidget('widgetPrazoPed')); //.dataSource.data.forEach(function(prazo){
                                        /*percnt = prazo.VRPERCPGTOPED/100;
                                        vrTotalPrazo = vrTotal * percnt;
                                        prazo.VRPARCELA = vrTotalPrazo;
                                    });*/
                                }
                            }.bind(this));
                        }.bind(this));

                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                }.bind(this)},{
                    label: ScreenService.i18n("Não"),
                    code: function(){}.bind(this)
                }]);
            } else {
                var excluirItem_msg = ScreenService.i18n("Deseja Excluir o item?");
                ScreenService.showCustomDialog(excluirItem_msg, 'question', 'question', [{
                    label: ScreenService.i18n("Sim"),
                    code: function(){
                        var promises = [];
                        promises.push(widget.removeRow());
                        if (this.vendPedAux) {
                            promises.push(this.tiraVendedoresCache());
                        }
                        ZHPromise.all(promises).then(function (callback) {
                            var vendedores = callback[1] ? callback[1] : { CDVENDEDOR: templateManager.container.getWidget('widgetPedido').currentRow.CDVENDEDOR };
                            widget.getParent().currentRow.VRTOTALPED = 0;
                            widget.getParent().currentRow.VRTOTPEDLIQ = 0;
                            widget.currentRow.IDSITITEMPED = '1';
                            widget.dataSource.data.forEach(function(item){
                                widget.getParent().currentRow.VRTOTALPED += parseFloat(item.VRTOTALITEM);
                                widget.getParent().currentRow.VRTOTPEDLIQ += parseFloat(item.VRTOTALITEM);
                            });

                            /*.dataSource.data.forEach(function(prazo){
                            if (widget.container.getWidget('widgetPrazoPed').dataSource.data && widget.container.getWidget('widgetPrazoPed').dataSource.data.length > 0 ) {
                                // var percnt;
                                // var vrTotalPrazo;
                                // var vrTotal = widget.getParent().getField('VRTOTALPED').value();
                                    percnt = prazo.VRPERCPGTOPED/100;
                                    vrTotalPrazo = vrTotal * percnt;
                                    prazo.VRPARCELA = vrTotalPrazo;
                            }
                                });*/
                            ZHPromise.all(this.buildPrazo(widget.container.getWidget('widgetPrazoPed'))).then(function(){
                                widget.container.getWidget('widgetPedido').currentRow.CALLED_BY = 'UPDATE_PED';
                                
                                var encargos = widget.container.getWidget('widgetEncargo').dataSource.data.filter( function(value){ return value.VRENCARGOPED != "0"; });
                                
                                if (widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '7' || widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '8'){
                                    widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO = '2';
                                } 
                                var prazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.map(function(row) {
                                    return Util.clone(row, ['__leftActions', '__rightActions']);
                                });
                                
                                var savePedido = [widget.container.getWidget('widgetItens').dataSource.data, prazos, [widget.container.getWidget('widgetPedido').currentRow], encargos, [vendedores]];
    
                                Ped00100_lancamentoPedido_Service.updateOrder(savePedido).then(function(){
                                    ScreenService.showMessage('Item excluido com sucesso');
                                    widget.currentRow.__is_new = false;
                                    widget.container.getWidget('widgetPedido').reload();
                                })
                                .catch(function(error){
                                    var erroExcluir_msg = ScreenService.i18n("Erro ao excluir o item.");
                                    ScreenService.showMessage(erroExcluir_msg +' \n ' + error.data.error);
                                });
    
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                    widget.reload();
                                });
                            }.bind(this));
                        }.bind(this));
                }.bind(this)},{
                    label: ScreenService.i18n("Não"),
                    code: function(){}.bind(this)
                }]);
            }
        }  else {
            ScreenService.showMessage('Exclusão Bloqueada. Pedido deve ter um item cadastrado.');
        }
    }; 

    this.fecharItem = function (widget) {
        // var itens = [widget.currentRow];
        
        // var data = [];
        // data.push({'CDFILIAL': widget.currentRow.CDFILIAL});
        // data.push({'CDTIPOOPER': widget.currentRow.CDTIPOOPER});
        // data.push({'itens': itens});

        // // função para validar quantidade disponível em estoque
        // // se retornar '0' é porque não houve inconsistencias ou a parametrização não controla estoque
        // // se retornar '1' é porque houve inconsistencias de estoque e uma mensagem é exibida impedindo o salvamento do pedido
        // Ped00100_lancamentoPedido_Service.validaQtdeDispEstoque(data).then(function(callback) {
            
        //     if(callback.dataset.validaQtdeDispEstoque.erro == 0){
                if (widget.isValid()) {
                    this.salvarItem(widget);
                }
        //     }else{
        //         var widgetRetornoValidEst = templateManager.container.getWidget('popUpRetornoValidacaoEstoque');
                
        //         var retorno = callback.dataset.validaQtdeDispEstoque;
                
        //         widgetRetornoValidEst.dataSource.data = retorno[0];
        //         ScreenService.openPopup(widgetRetornoValidEst).then(function(){
        //             widgetRetornoValidEst.reload();
        //         });
        //     }
            
        // }.bind(this));
    };
    
    /* (function widgetEncargoOnEnter)
        Função para o evento que sempre ativa ao visitar a widget de Encargo
    */
    this.widgetEncargoOnEnter = function(widget) {
        if (widget.getParent().currentRow.__is_new) {
            this.atualizaDadosEncargoNovoPedido(widget);
        } else {
            widget.reload();
        }
    };
    
    /* (function salvarEncargo)
        Função principal para salvar registro de Encargo
        to do: Avaliar se necessita de melhoria
    */
    this.salvarEncargo = function(widget) {
        
        //  Ped00100_lancamentoPedido_Service.salvarEncargo(widget.currentRow);
        var pedido = widget.getParent().currentRow;
        if (this.PedidoEhNovo()) {
            this.defineEncargo(widget.currentRow, pedido);
            this.adicionaEncargoPedidoNovo(widget);
        } else {
            // Filtra todos os encargos já existentes ao pedido, pois são > 0 e se não for, é encargo padrão    
            var encargos = widget.dataSource.data.filter(function(encargo){ return encargo.VRENCARGOPED > 0; } );
             
            encargos.forEach(function(encargo){
                this.defineEncargo(encargo, pedido);
                if (encargo.CDENCARGO == widget.currentRow.CDENCARGO) {
                    encargo.VRENCARGOPED = widget.currentRow.VRENCARGOPED;
                    encargo.VRPERCENTENC = widget.currentRow.VRPERCENTENC;
                }
            }.bind(this));
            widget.view();
            this.fecharPedido(widget.getParent());
        }
    };
    
    /* (function adicionaEncargoPedidoNovo)
        Função especifica para rotina de inserção de Encargo caso o Pedido for Novo
    */
    this.adicionaEncargoPedidoNovo = function(widget) {
        Ped00100_lancamentoPedido_Service.getData("ped_pedidos#/encargo_lancamento").then(function(dadosEncargos) {
            dadosEncargos = dadosEncargos.filter(function(value){ return value.VRENCARGOPED != "0"; });
            if (!Array.isArray(dadosEncargos)) {
                var list = [];
                list.push(dadosEncargos);
                list.push(widget.currentRow);
                this.salvarEncargosCache(list, widget);
            } else {
                dadosEncargos.push(widget.currentRow);
                this.salvarEncargosCache(dadosEncargos, widget);
            }
        }.bind(this));  
    };
    
    /* function (resetarEncargosCache)
        Função que substitui valores de Encargos em 0 para os dados da widget
        e também substitui a Cache de Encargos por um Array vazio
    */
    this.resetarEncargosCache = function(widget) {
        widget = widget.container.getWidget('widgetEncargo');
        
        widget.dataSource.data.forEach(function(encargoDataSource){
            encargoDataSource.VRENCARGOPED = "0";
            encargoDataSource.VRPERCENTENC = "0";
        }.bind(this));
        Ped00100_lancamentoPedido_Service.setData("ped_pedidos#/encargo_lancamento",[]).then(function(){
            this.atualizaDadosEncargoNovoPedido(widget);
        }.bind(this))
        .catch(function(){
        }.bind(this));
    };
    
    
    /* (function salvarEncargosCache)
        Função de adicionar Encargos no Cache do Navegador
    */
    this.salvarEncargosCache = function(dados, widget){
        Ped00100_lancamentoPedido_Service.saveData("ped_pedidos#/encargo_lancamento",dados).then(function(){
            widget.activate();
            widget.view();
            ScreenService.goBack();
            ScreenService.showMessage('Salvo com sucesso.');
            
            this.atualizaDadosEncargoNovoPedido(widget);
            /* 
            * Método criado para desabilitar o grid de pedidos no backgroud do swipe
            */
            this.desabilitaBackgroundPedido('widgetDadosAdicionais');
        }.bind(this))
        .catch(function(error){
            var erroAoSalvar_msg = ScreenService.i18n("Erro ao salvar.");
            ScreenService.showMessage(erroAoSalvar_msg +' '+error);
            /* 
            * Método criado para desabilitar o grid de pedidos no backgroud do swipe
            */
            this.desabilitaBackgroundPedido('widgetDadosAdicionais');
        }.bind(this));
    };
    
    
    /*  (function atualizaDadosEncargoNovoPedido)
        Função para atualizar a lista de Encargos caso existir registro novo no cache do Navegador, 
        que geralmente é realizado quando usuário edita Encaro de um NOVO PEDIDO
    */
    this.atualizaDadosEncargoNovoPedido = function(widget) {
        
        if (this.PedidoEhNovo()) {
            Ped00100_lancamentoPedido_Service.getData("ped_pedidos#/encargo_lancamento").then(function(dadosEncargos) {
                dadosEncargos = dadosEncargos.filter(function(value){ return value.VRENCARGOPED != "0"; });
                dadosEncargos.forEach(function(dado) {
                    widget.dataSource.data.forEach(function(dadoDatasource, index) {
                        if (dadoDatasource.CDENCARGO == dado.CDENCARGO) {
                            widget.dataSource.data[index] = dado;
                        }
                    }.bind(this)); 
                });
            
            }.bind(this));
        }
    };
     
    /* (function calculaValorEncargoPercentPedido)
        Função que ao digitar valor no field/campo VRENCARGOPED da widgetEncargo
        será calculado um valor percentual para atribuir no campo/field VRPERCENTENC
    
    */
    this.calculaValorEncargoPercentPedido = function(args) {
        var widget = args.owner.owner.widget;
        var valorEncargo = widget.currentRow.VRENCARGOPED;
        var valorPedido = widget.getParent().currentRow.VRTOTPEDLIQ;
        var result = 0;
        try {
        
            valorEncargo = valorEncargo.replace('.','').replace(',','.'); // Ao receber valores como 1,25 transforma pra 1.25
            valorEncargo = parseFloat(valorEncargo); // para em seguida a conversão para número ser autêntica e sem erros
            
            result = parseFloat((valorEncargo/valorPedido) * 100); // cálculo único desta função
            
            // result = (result).toLocaleString('pt-BR'); // conversão de número de ponto flutuante para notação numérica brasileira
            // result = result.replace('.',''); // o template específico do campo VRPERCENTENC em 'text-edit' interpreta PONTO como VIRGULA
            
            widget.currentRow.VRPERCENTENC = result;
        } catch(e) {
            var naoPossivelCalcularPorcentagem = ScreenService.i18n("Não foi possível calcular a porcentagem:");
            ScreenService.showMessage(naoPossivelCalcularPorcentagem+" " + e);
        }
    };
      
    /* (function calculaPercentEncargoPedido)
        Função que ao digitar valor no field/campo VRPERCENTENC da widgetEncargo
        será calculado um valor para atribuir no campo/field VRENCARGOPED
    */

    this.calculaPercentEncargoPedido = function(args) {
        
        var widget = args.owner.owner.widget;
        var percent = widget.currentRow.VRPERCENTENC;
        var valorPedido = widget.getParent().currentRow.VRTOTPEDLIQ;
        var result = 0;
        try {
            
            percent = percent.replace('.','').replace(',','.'); // Ao receber valores como 1,25 transforma pra 1.25
            percent = parseFloat(percent); // para em seguida a conversão para número ser autêntica e sem erros
            result = parseFloat((percent/100) * valorPedido); // cálculo único desta função
            
         //   result = (result).toLocaleString('pt-BR'); // conversão de número de ponto flutuante para notação numérica 
         //   result = result.replace('.',''); // o template específico do campo VRENCARGOPED em 'text-edit' interpreta PONTO como VIRGULA
            
            widget.currentRow.VRENCARGOPED = result;
        } catch(e) {
            var naoFoiPossivelCalcular = ScreenService.i18n("Não foi possível calcular o valor da porcentagem:");
            ScreenService.showMessage(naoFoiPossivelCalcular+ " " + e);
        }
        
    };
    
    this.salvarVendedoresCache = function (widget) {
        
        Ped00100_lancamentoPedido_Service.setData("ped#/crud/vendedor", widget.getCheckedRows()).then(function(sucess){
            ScreenService.showMessage('Vendedores Adicionados!');
            ScreenService.closePopup();
        }.bind(this));
    };
    this.setDataSourceFilterImp = function(){
        var widgetItens = templateManager.container.getWidget('widgetItens');
        var widgetImposto = templateManager.container.getWidget('widgetImposto');
        var nrpedido = widgetItens.currentRow.NRPEDIDO;
        var cdfilial = widgetItens.currentRow.CDFILIAL;
        var nritemped = widgetItens.currentRow.NRITEMPED;
        
         var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            },
            {
                "name": "NRPEDIDO",
                "operator": "=",
                "value": nrpedido
            },
            {
                "name": "NRITEMPED",
                "operator": "=",
                "value": nritemped
            }
                            
        ];
        widgetImposto.dataSourceFilter = filter;
        widgetImposto.reload();
        
    };
    
    this.calcImpostoItem = function(){
        var widgetItens = templateManager.container. getActiveWidget();
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        widgetItens.currentRow._isActiveRow = true;
        
        var qtItem = widgetItens.currentRow.QTITEMPED;
        var vrUnit = widgetItens.currentRow.VRPREUNITPED;
        if (typeof(qtItem) == 'string' || typeof(vrUnit) == 'string') {
            qtItem +=" ";
            qtItem = qtItem.replace(',', '.');
            qtItem = parseFloat(qtItem);
            vrUnit+=" ";
            vrUnit = vrUnit.replace(',', '.');
            vrUnit = parseFloat(vrUnit);
        }
        widgetItens.currentRow.QTITEMPED = qtItem;
        widgetItens.currentRow.VRPREUNITPED = vrUnit;
        var itens = Util.clone(templateManager.container.getWidget('widgetItens').currentRow, ['__leftActions', '__rightActions', '__proto__', '$error']);
        itens.VRTOTALITEM = "0";
        this.calcValorTotal(widgetItens);
        itens.VRTOTALITEMSEMIMP = widgetItens.currentRow.VRTOTALITEMSEMIMP;

        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            widgetPedido.currentRow.CDEMPRESA = response.dataset.filial[0].CDEMPRESA;
            widgetPedido.currentRow.CDINSCESTA = response.dataset.filial[0].CDINSCESTA;
        
            var params = {
                'CDFILIAL'    : widgetPedido.currentRow.CDFILIAL,
                'CDEMPRESA'   : widgetPedido.currentRow.CDEMPRESA,
                'NRPEDIDO'    : widgetPedido.currentRow.NRPEDIDO,
                'CDVENDEDOR'  : widgetPedido.currentRow.CDVENDEDOR,
                'CDOPERADOR'  : widgetPedido.currentRow.CDOPERADOR,
                'IDSITITEMPED': "1",
                'OLDCDVENDE'  : widgetPedido.currentRow.CDVENDEDOR,
                'CDINSCESTA'  : widgetPedido.currentRow.CDINSCESTA,
                'CDCLIENTE'   : widgetPedido.currentRow.CDCLIENTE,
                'DTENTITPED'  : widgetPedido.currentRow.DTENTPED,
                'CDTIPOOPER'  : widgetPedido.currentRow.CDTIPOOPER,
                'IDORIGDESTOP'  : widgetPedido.currentRow.IDORIGDESTOP,
                'NRORG' : widgetPedido.currentRow.NRORG       
            };
            
            var encargos =[];
            var promises = [];
            promises.push(Ped00100_lancamentoPedido_Service.calcImpostoItem([[itens],[encargos],params]));
            ZHPromise.all(promises).then(function(callback) {
                var impItens = callback[0].dataset.itens[0][0].VRTOTALITEM;
                
                widgetItens.currentRow.VRTOTALITEM = parseFloat(parseFloat(impItens).toFixed(2));
            }.bind(this));
        }.bind(this));
    };
  

    this.salvarItem = function (widget) {
        
        var vendedores = [];
        
        var encargos = widget.container.getWidget('widgetEncargo').dataSource.data.filter(function(value){ return value.VRENCARGOPED != "0"; });
        widget.currentRow.QTEXPITEMPED    = '0';
        widget.currentRow.IDITPEDSEMQTDIS = 'N';
        var i;
        var filter = [{
            "name": "CDPRODUTO",
            "operator": "=",
            "value": widget.currentRow.CDPRODUTO
        }];
        
        this.calcValorTotal(widget);
        
        General.callRestEngine('ped#/crud/produto', 'FilterData', filter).then(function(callback) {
            
            widget.currentRow.VRFATOCONV = callback.dataset.produto[0].VRFATOCONV;
            if (!widget.currentRow.VRFATOCONV) {
                widget.currentRow.VRFATOCONV = 1;
            }
            widget.currentRow.QTITEMPED2 = parseFloat(widget.currentRow.VRFATOCONV) * parseFloat(widget.currentRow.QTITEMPED);
            var vrUnitario = widget.currentRow.VRPREUNITPED;
            
            if (vrUnitario) {
                if (typeof(vrUnitario) == 'string') {
                    vrUnitario = vrUnitario.replace(/\./g, '');
                    vrUnitario = parseFloat(vrUnitario.replace(',', '.'));
                }
            }

            if (widget.isValid() && widget.getParent().currentRow.__is_new && widget.getParent().currentRow.IDSITPEDIDO == 'D' && parseFloat(widget.currentRow.QTITEMPED) > 0 && vrUnitario > 0) {
                var filial;
                widget.currentRow.NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
                for (i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
                    if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widget.getParent().dataSourceFilter[i].value;
                    }
                }
                widget.currentRow.CDFILIAL = filial;
                var dataItens = widget.dataSource.data;
                var vrTotalPedido = 0;
                var vrTotalPedidoLiquido = 0;
                dataItens.forEach(function(itens){
                    if(itens.NRITEMPED != widget.currentRow.NRITEMPED){
                        vrTotalPedido += itens.VRTOTALITEM;
                        vrTotalPedidoLiquido += itens.VRTOTALITEMSEMIMP;
                    }
                });
                // widget.getParent().currentRow.VRTOTALPED = parseFloat(widget.getParent().currentRow.VRTOTALPED) + parseFloat(widget.currentRow.VRTOTALITEM);
                // widget.getParent().currentRow.VRTOTPEDLIQ = parseFloat(widget.getParent().currentRow.VRTOTPEDLIQ) + parseFloat(widget.currentRow.VRTOTALITEMSEMIMP);
                widget.getParent().currentRow.VRTOTALPED = vrTotalPedido + parseFloat(widget.currentRow.VRTOTALITEM);
                widget.getParent().currentRow.VRTOTPEDLIQ = vrTotalPedidoLiquido + parseFloat(widget.currentRow.VRTOTALITEMSEMIMP);
                
                ScreenService.closeSwipe();
                
                /* 
                * Metodo criado para desabilitar o grid de pedidos no backgroud do swipe
                */
                this.desabilitaBackgroundPedido('widgetItens');
                
                //widget.currentRow.__is_new = false;
                
                Ped00100_lancamentoPedido_Service.saveData("ped#/crud/itempedido_completa", widget.currentRow).then(function(){
                    Ped00100_lancamentoPedido_Service.getData("ped#/crud/itempedido_completa").then(function(callback){

                        callback = callback.filter(function(value){return value.NRPEDIDO == widget.currentRow.NRPEDIDO;});
                        widget.dataSource.data = callback;

                        if (widget.container.getWidget('widgetPrazoPed').dataSource.data && widget.container.getWidget('widgetPrazoPed').dataSource.data.length > 0 ) {
                            var percnt;
                            var vrTotal;
                            var vrTotalPrazo;
                            if (widget.container.getWidget('widgetPedido').currentRow.__is_new) {
                                vrTotal = widget.getParent().getField('VRTOTPEDLIQ').value();
                            } else {
                                vrTotal = widget.getParent().getField('VRTOTALPED').value();
                            }
                            widget.container.getWidget('widgetPrazoPed').dataSource.data.forEach(function(prazo){
                                percnt = prazo.VRPERCPGTOPED/100;
                                vrTotalPrazo = vrTotal * percnt;
                                prazo.VRPARCELA = vrTotalPrazo;
                            });
                        }
                    }.bind(this));
                }.bind(this));
            } else if (widget.isValid() && parseFloat(widget.currentRow.QTITEMPED) > 0 && vrUnitario > 0){
                widget.currentRow.NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
                widget.currentRow.QTEXPITEMPED    = '0';
                widget.currentRow.IDITPEDSEMQTDIS = 'N';

                // widget.currentRow.IDSITITEMPED = 1;
                this.calcValorTotal(widget);
                // widget.getParent().currentRow.VRTOTALPED = parseFloat(widget.getParent().currentRow.VRTOTALPED) + parseFloat(widget.currentRow.VRTOTALITEM);
                // widget.dataSource.data.forEach(function(item){
                //     widget.getParent().currentRow.VRTOTALPED += parseFloat(item.VRTOTALITEM);
                //     widget.getParent().currentRow.VRTOTPEDLIQ += parseFloat(item.VRTOTALITEMSEMIMP);
                // });
                widget.getParent().currentRow.VRTOTALPED = 0;
                widget.getParent().currentRow.VRTOTPEDLIQ = 0;
                var itens = widget.dataSource.data.filter(function(value){return value.NRPEDIDO == widget.getParent().currentRow.NRPEDIDO;});
                var totalItens = 0;
                var totalItensSemImp = 0;

                for (i = 0; i < itens.length; i++) {
                    // totalItens = parseInt(itens[i].VRTOTALITEM) + totalItens;
                    totalItensSemImp = parseFloat(itens[i].VRTOTALITEM) + totalItensSemImp;
                    itens[i].QTITEMPED2 = parseFloat(itens[i].VRFATOCONV) * parseFloat(itens[i].QTITEMPED);
                }
                totalItensSemImp += widget.container.getWidget('widgetItens').currentRow.VRTOTALITEMSEMIMP;
                widget.getParent().currentRow.VRTOTALPED = totalItensSemImp;
                widget.getParent().currentRow.VRTOTPEDLIQ = totalItensSemImp;
                // widget.getParent().currentRow.VRTOTALPED = widget.getParent().currentRow.VRTOTALPED.toFixed(3);
                widget.currentRow.NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;

                widget = widget.container.getWidget('widgetPedido');
                var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": widget.currentRow.CDFILIAL
                    }
                ];
                General.callRestEngine('ped#/crud/filial', 'FilterData', filter).then(function(callback) {
                    widget.currentRow.CDEMPRESA = callback.dataset.filial[0].CDEMPRESA;
                    widget.currentRow.CDINSCESTA = callback.dataset.filial[0].CDINSCESTA;
                    filter = [
                        {
                            "name": "CDTIPOOPER",
                            "operator": "=",
                            "value": widget.currentRow.CDTIPOOPER
                        },
                        {
                            "name": "IDENTRSAIDOP",
                            "operator": "=",
                            "value": 'S'
                        }
                    ];
                    
                    var promises = [];
                    promises.push(General.callRestEngine('ped#/crud/tipooperac', 'FilterData', filter));
                    promises.push(General.callRestEngine("ped_pedidos#/select_vendpedaux", "DataSet", [widget.currentRow]));
                    promises.push(this.buildPrazo(widget.container.getWidget('widgetPrazoPed')));
                    
                    
                    ZHPromise.all(promises).then(function(callback) {
                        if(callback[0].dataset.tipooperac.length > 0){
                            widget.currentRow.IDORIGDESTOP = callback[0].dataset.tipooperac[0].IDORIGDESTOP;
                        }
                        
                        vendedores = callback[1].dataset.vendedores;
                        
                        /*for (i = 0; i < widget.container.getWidget('widgetItens').dataSource.data.length; i++) {
                            widget.container.getWidget('widgetItens').dataSource.data[i].IDSITITEMPED = '1';
                        }*/
                        
                        /*var percnt;
                        var vrTotalPrazo;
                        var vrTotal = widget.getField('VRTOTALPED').value();
                        widget.container.getWidget('widgetPrazoPed').dataSource.data.forEach(function(prazo){
                            percnt = prazo.VRPERCPGTOPED/100;
                            vrTotalPrazo = vrTotal * percnt;
                            prazo.VRPARCELA = vrTotalPrazo;
                        });*/
                        
                        
                        var itens = widget.container.getWidget('widgetItens').dataSource.data.filter(function(row){
                            return row.changed == true;
                        });
                        /*if (itens.length == 0) {
                            itens = [widget.container.getWidget('widgetItens').currentRow];
                            itens[0].IDSITITEMPED = 1;
                        } else {
                            itens[0].IDSITITEMPED = 1;
                        }*/
                        widget.container.getWidget('widgetPedido').currentRow.CALLED_BY = 'UPDATE_PED';
                        if (widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '7' || widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '8'){
                            widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO = '2';
                        }
                        var prazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.map(function(row) {
                            return Util.clone(row, ['__leftActions', '__rightActions']);
                        });
                        
                        var savePedido = [itens, 
                                        prazos, 
                                        [widget.container.getWidget('widgetPedido').currentRow], 
                                        encargos, 
                                        vendedores];
                        //Alteracoes para nao editar o prazo
                        // widget.container.getWidget('widgetPrazoPed').getAction('novoPrazo').isVisible = true;
                        // widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = false;
                        // widget.container.getWidget('widgetPrazoPed').getAction('excluirPrazo').isVisible = true;
                        
                        Ped00100_lancamentoPedido_Service.updateOrder(savePedido).then(function(){
                            ScreenService.closeSwipe();
                            
                            /* 
                            * Método criado para desabilitar o grid de pedidos no backgroud do swipe
                            */
                            this.desabilitaBackgroundPedido('widgetItens');
                            
                            ScreenService.showMessage('Item atualizado com sucesso');
                            // for (e = 0; e < widget.widgets.length; e++) {
                                // widget.widgets[e].floatingControl.visibleModes = ["list"];
                            // }
                            widget.container.getWidget('widgetItens').getAction('fecharPedidoItem').isVisible = false;
                            widget.container.getWidget('widgetPrazoPed').getAction('fecharPedidoPrazo').isVisible = false;
                            widget.container.getWidget('widgetDadosAdicionais').getAction('fecharPedidoDadosAdic').isVisible = false;
                            widget.container.getWidget('transportadora').getAction('fecharPedidoTransportadora').isVisible = false;
                            
                            widget.currentRow.__is_new = false;
                            widget.container.getWidget('widgetPedido').reload();
                            widget.container.getWidget('widgetItens').reload();
                        }.bind(this)).catch(function(error){
                            var erroAtualizarItem_msg = ScreenService.i18n("Erro ao atualizar o item.");
                            ScreenService.showMessage(erroAtualizarItem_msg + ' \n ' + error.data.error);
                        }.bind(this));
                    }.bind(this));
                }.bind(this));
            } else if(widget.isValid() && parseFloat(widget.currentRow.QTITEMPED) <= 0 ){
                ScreenService.showMessage("Quantidade do Item deve ser maior que zero '0'.");
            } else if (widget.isValid() && vrUnitario <= 0 ){
                ScreenService.showMessage("Valor Unitário do Item deve ser maior que zero '0'.");
            }
        }.bind(this));

    }; 

    this.openPosicaoFinanceira = function(widget) {
        ScreenService.openWindow('ped_pedidos#ped00301_posicao_financeira_cliente').then(function(){
            var widgetAprovacao = templateManager.containers["ped_pedidos#ped00301_posicao_financeira_cliente"].getWidget('widgetPosicao');
            widgetAprovacao.currentRow.TELAORIGINAL = 'LANCAMENTO';
            widgetAprovacao.currentRow.CDCLIENTE = this.checkedRows[0].CDCLIENTE;
            widgetAprovacao.currentRow.NMRAZSOCCLIE = this.checkedRows[0].NMRAZSOCCLIE;
        }.bind(this));
    }; 

    this.buildPrazo = function (widget) {
        var filter = [];
        var prazos = [];
        var prazo  = {};
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        if ((widget.getParent().mode == 'edit' || widget.mode == 'edit')  && (widget.getParent().currentRow.CDMODPGTO || widget.getParent().currentRow.CDMODPGTO) ) {
            var cdmodpgto = widget.getParent().currentRow.CDMODPGTO;
            
            filter = [
                {
                    "name": "CDMODPGTO",
                    "operator": "=",
                    "value": cdmodpgto
                }
            ];
            
            Ped00100_lancamentoPedido_Service.findModpgtoPrazo(filter).then(function(callback){
                var i;
                var filial;
                for (i = 0; i < widgetPedido.dataSourceFilter.length; i++) {
                    if (widgetPedido.dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widgetPedido.dataSourceFilter[i].value;
                    }
                }
                var vrParcial = 0;
                var vrTotal;
                if (widgetPedido.currentRow.__is_new) {
                    vrTotal = widgetPedido.getField('VRTOTPEDLIQ').value();
                } else {
                    vrTotal = widgetPedido.getField('VRTOTALPED').value();
                }
                if (callback.dataset.modpgto_prazomodpgto.length > 0) {
                    // widget.dataSource.data = [];
                    for (i = 0; i < callback.dataset.modpgto_prazomodpgto.length; i++) {
                        if ((i+1) != (callback.dataset.modpgto_prazomodpgto.length)) {
                            this.calculaValor(callback.dataset.modpgto_prazomodpgto[i].VRPERCMODPGTO);
                            // this.calculaValor(widget.getField('VRPERCPGTOPED'));
                            prazo = {
                                "NRPEDIDO": widgetPedido.currentRow.NRPEDIDO,
                                "NRDIASPGTOPED": callback.dataset.modpgto_prazomodpgto[i].NRDIASMODPGTO,
                                "VRPERCPGTOPED": callback.dataset.modpgto_prazomodpgto[i].VRPERCMODPGTO,
                                "CDFILIAL": filial,
                                "__is_new": true
                            };
                            prazo.PREVISAO = this.calcPreview(widgetPedido.currentRow.DTPEDIDO, callback.dataset.modpgto_prazomodpgto[i].NRDIASMODPGTO);
                            widget.getField('VRPERCPGTOPED').setValue(callback.dataset.modpgto_prazomodpgto[i].VRPERCMODPGTO);
                            prazo.VRPARCELA = parseFloat(widget.getField('VRPARCELA').value().toFixed(2));
                            prazos.push(prazo);
                            
                            vrParcial += parseFloat(prazo.VRPARCELA.toFixed(2));
                            // console.log('OW!!', widget.dataSource.data);
                        } else if ((i + 1) == (callback.dataset.modpgto_prazomodpgto.length) ) {
                            this.calculaValor(widget.getField('VRPERCPGTOPED'));
                            prazo = {
                                "NRPEDIDO": widgetPedido.currentRow.NRPEDIDO,
                                "NRDIASPGTOPED": callback.dataset.modpgto_prazomodpgto[i].NRDIASMODPGTO,
                                "VRPERCPGTOPED": callback.dataset.modpgto_prazomodpgto[i].VRPERCMODPGTO,
                                "CDFILIAL": filial,
                                "__is_new": true
                            };
                            prazo.PREVISAO = this.calcPreview(widgetPedido.currentRow.DTPEDIDO, callback.dataset.modpgto_prazomodpgto[i].NRDIASMODPGTO);
                            widget.getField('VRPERCPGTOPED').setValue(callback.dataset.modpgto_prazomodpgto[i].VRPERCMODPGTO);
                            prazo.VRPARCELA = (parseFloat(parseFloat(vrTotal).toFixed(2)) - parseFloat(parseFloat(vrParcial).toFixed(2)));
                            prazo.VRPARCELA = parseFloat(prazo.VRPARCELA.toFixed(2));
                            prazos.push(prazo);
                            
                            vrParcial += parseFloat(prazo.VRPARCELA);
                        }
                    }
                } else {
                    // widget.dataSource.data = [];
                    prazo = {
                        "NRPEDIDO": widgetPedido.currentRow.NRPEDIDO,
                        "NRDIASPGTOPED": 0,
                        "VRPERCPGTOPED": 100,
                        "CDFILIAL": filial,
                        "__is_new": true
                    };
                    prazo.PREVISAO = this.calcPreview(widgetPedido.currentRow.DTPEDIDO, '0');
                    widget.getField('VRPERCPGTOPED').setValue('100');
                    this.calculaValor(widget.getField('VRPERCPGTOPED'));
                    prazo.VRPARCELA = parseFloat(widget.getField('VRPARCELA').value().toFixed(2));
                    prazos.push(prazo);
                }
                if (widget.dataSource.data !== prazos && prazos.length > 0) {
                    widget.dataSource.data = prazos;
                }
                Ped00100_lancamentoPedido_Service.setData("ped#/crud/prazopgtoped", widget.dataSource.data);
            }.bind(this));
        } else if (widgetPedido.currentRow.CDCLIENTE.length > 0 && widgetPedido.mode == 'edit') {
            filter = [
                {
                    "name": "CDMODPGTO",
                    "operator": "=",
                    "value": widgetPedido.currentRow.CDMODPGTO
                }
            ];
            Ped00100_lancamentoPedido_Service.findModpgtoPrazo(filter).then(function(callback){
                var diasEntrg = 0;
                if (this.parametros.NRDIASENTPED) {
                    diasEntrg = this.parametros.NRDIASENTPED;
                }
                var filial;
                for (var i = 0; i < widgetPedido.dataSourceFilter.length; i++) {
                    if (widgetPedido.dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widgetPedido.dataSourceFilter[i].value;
                    }
                }
                prazo = [{
                    "NRPEDIDO": widgetPedido.currentRow.NRPEDIDO,
                    "NRDIASPGTOPED": diasEntrg,
                    "VRPERCPGTOPED": 100,
                    "CDFILIAL": filial,
                    "__is_new": true
                }];
                prazo[0].PREVISAO = this.calcPreview(widgetPedido.currentRow.DTPEDIDO, prazo[0].NRDIASPGTOPED);
                widget.getField('VRPERCPGTOPED').setValue(100);
                this.calculaValor(widget.getField('VRPERCPGTOPED'));
                prazo[0].VRPARCELA = parseFloat(widget.getField('VRPARCELA').value().toFixed(2));
                widget.dataSource.data = prazo;
                // Ped00100_lancamentoPedido_Service.setData("ped#/crud/prazopgtoped", widget.dataSource.data);
            }.bind(this));
        }
    }; 

    this.getPrazo = function (){
        var widgetPed = templateManager.container.getWidget('widgetPedido');
        var widgetPrazo = templateManager.container.getWidget('widgetPrazoPed');
        if(widgetPed.mode == 'form'){
            Ped00100_lancamentoPedido_Service.getData("ped#/crud/prazopgtoped").then(function(callback){
                var prazos = callback.filter(function(row){ return row.CDFILIAL == widgetPed.currentRow.CDFILIAL && row.NRPEDIDO == widgetPed.currentRow.NRPEDIDO; });    
                widgetPrazo.dataSource.data = prazos;
            });
            
        }    
    };

    this.verificaRequiredPedido = function (widget) {
        var message;
        if (!(widget.container.getWidget('widgetPedido').currentRow.CDCLIENTE)){
            message = ScreenService.i18n("O Cliente deve ser escolhido.");
            ScreenService.showMessage(message, 'error');
        } else {
            if (!(widget.getParent().currentRow.CDPRECOBASE)) {
                message = ScreenService.i18n("A Tabela de Preço deve ser escolhida.");
                ScreenService.showMessage(message, 'error');
            } 
        }
            this.getItem(widget);
    }; 

    this.getItem = function (widget) {
        // widget.dataSource.data = [];
        //Ped00100_lancamentoPedido_Service.getData("ped#/crud/itempedido_completa").then(function(callback){
            var item = null;
            item = /*callback*/widget.dataSource.data.filter(function(value){return value.NRPEDIDO == widget.getParent().currentRow.NRPEDIDO;});
            widget.dataSourceFilter = [
                {
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": widget.getParent().currentRow.NRPEDIDO
                }
            ];
            if (item.length > 0 && widget.getParent().currentRow.__is_new) {
                widget.dataSource.data = item;
            } else if (!(widget.getParent().currentRow.__is_new)) {
                var filial;
                for (var i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
                    if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widget.getParent().dataSourceFilter[i].value;
                    }
                }
                var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filial
                    },
                    {
                        "name": "NRPEDIDO",
                        "operator": "=",
                        "value": widget.getParent().currentRow.NRPEDIDO
                    }
                ];
                widget.dataSourceFilter = filter;
                General.callRestEngine('ped#/crud/itempedido_completa', "FilterData", filter).then(function(callback){
                    widget.dataSource.data = callback.dataset.itempedido_completa;
                });
            } else if (widget.getParent().currentRow.__is_new){
                widget.dataSource.data = item;
            }
       // }.bind(this));
    }; 

    // Widget recebida deve ser a widget de Pedido
    this.fecharPedido = function (widget) {
        var itens = [];
        
        if(widget.currentRow.__is_new){
            itens = widget.container.getWidget('widgetItens').dataSource.data;
        }else{
            itens = this.getItensSalvos(widget);
        }
        
        var data = [];
        data.push({'CDFILIAL': widget.currentRow.CDFILIAL});
        data.push({'CDTIPOOPER': widget.currentRow.CDTIPOOPER});
        data.push({'itens': itens});

        // função para validar quantidade disponível em estoque
        // se retornar '0' é porque não houve inconsistencias ou a parametrização não controla estoque
        // se retornar '1' é porque houve inconsistencias de estoque e uma mensagem é exibida impedindo o salvamento do pedido
        Ped00100_lancamentoPedido_Service.validaQtdeDispEstoque(data).then(function(callback) {
            
            if(callback.dataset.validaQtdeDispEstoque.erro == 0){
                
                var widgetEncargo = widget.container.getWidget('widgetEncargo');
                
                // Instrução para adquirir Encargos do usuário
                var encargos = widgetEncargo.dataSource.data.filter( function(value){ return value.VRENCARGOPED != "0"; });
                
                widget = widget.container.getWidget('widgetPedido');
                
                widget.getField('NMRAZSOCCLIE').readOnlyOnEdit = false;
                
                var vendedores = [];
                
                var percent = 0;
                widget.container.getWidget('widgetPrazoPed').dataSource.data.forEach(function(prazo){
                    percent += parseFloat(prazo.VRPERCPGTOPED);
                    percent = parseFloat(percent.toFixed(2));
                });
                
                // widget.currentRow.CDMODPGTO = widget.container.getWidget('widgetModpgtoPed').currentRow.CDMODPGTO;
                
                var qtItens = widget.container.getWidget('widgetItens').dataSource.data.filter(function(row){  
                    return row.NRPEDIDO == widget.currentRow.NRPEDIDO && row.CDFILIAL == widget.currentRow.CDFILIAL; 
                    
                });   
                qtItens = qtItens.length;
                var cdmodptgo; 
                if(widget.currentRow.CDMODPGTO) {
                    cdmodptgo = true;
                } else {
                    cdmodptgo = false;
                }
                var promises = [];
                var numPrazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.length;
                var validaWidgetTrans = templateManager.container.getWidget('transportadora').isValid();

                if (widget.isValid() && cdmodptgo && percent == 100 && qtItens > 0 && numPrazos > 0 && widget.currentRow.__is_new && validaWidgetTrans) {
                    
                    widget.currentRow.IDSITPEDIDO  = '1';
                    widget.currentRow.IDPRIOPED    = '3';
                    widget.currentRow.IDPEDIDOIMPR = 'N';
                    widget.currentRow.IDORIGPED    = '3';
                    widget.currentRow.DTHRLANPED   = moment().format('DD/MM/YYYY');
                    // Verificar se posso ou nao salvar
                    // console.log('Verificar se posso ou nao salvar e passar os Rests para true');
                    
                    // promises.push(Ped00100_lancamentoPedido_Service.getData("ped#/crud/itempedido_completa"));
                    // promises.push(Ped00100_lancamentoPedido_Service.getData("ped#/crud/prazopgtoped"));
                    
                    promises.push(this.retornaOperadorLogado());
                    promises.push(Ped00100_lancamentoPedido_Service.getData("ped_pedidos#/crud/dadosadicped"));
                    
                    if (this.vendPedAux) {
                        promises.push(this.tiraVendedoresCache());
                    }
                    
                    var e;
                    ZHPromise.all(promises).then(function(callback){
                        if (widget.container.getWidget('widgetItens').dataSource.data.length > 0 && widget.container.getWidget('widgetPrazoPed').dataSource.data.length > 0 ) {
                            var i;
                            var filial;
                            for (i = 0; i < widget.dataSourceFilter.length; i++) {
                                if (widget.dataSourceFilter[i].name == 'CDFILIAL'){
                                    filial = widget.dataSourceFilter[i].value;
                                }
                            }
                            
                            if(this.vendPedAux) {
                                vendedores = callback[2];
                                this.vendPedAux = false;
                            } else {
                                 vendedores = [{CDVENDEDOR: widget.currentRow.CDVENDEDOR, NMFANVEN: widget.currentRow.NMFANVEN }];
                            }
                            widget.currentRow.CDFILIAL = filial;
                            widget.currentRow.CDFILIALPED = widget.currentRow.CDFILIALPED;
                            widget.currentRow.CDOPELANPED = callback[0][0].CDOPERADOR;
                            var dadosadic = callback[1].filter(function(row){return row.NRPEDIDO == widget.currentRow.NRPEDIDO; });
                            
                            var itemWidget = widget.container.getWidget('widgetItens');
                            for (i = 0; i < itemWidget.dataSource.data.length; i++) {
                                
                                itemWidget.dataSource.data[i].CDOPERADOR = callback[0][0].CDOPERADOR;
                                //itemWidget.dataSource.data[i].NRITORDEMCMPPED = itemWidget.currentRow.NRITEMPED.substr(5,10);
                                if(itemWidget.dataSource.data[i].NRITORDEMCMPPED == "" || !itemWidget.dataSource.data[i].NRITORDEMCMPPED)
                                    itemWidget.dataSource.data[i].NRITORDEMCMPPED = itemWidget.dataSource.data[i].NRITEMPED.substr(5,10);
                            
                            }
                            
                            var filter = [{
                                "name": "CDFILIAL",
                                "operator": "=",
                                "value": widget.currentRow.CDFILIAL
                            }];
                            
                            General.callRestEngine('ped#/crud/filial', 'FilterData', filter).then(function(callback) {
                                
                                widget.currentRow.CDEMPRESA = callback.dataset.filial[0].CDEMPRESA;
                                widget.currentRow.CDINSCESTA = callback.dataset.filial[0].CDINSCESTA;
                                
                                filter = [
                                    {
                                        "name": "CDTIPOOPER",
                                        "operator": "=",
                                        "value": widget.currentRow.CDTIPOOPER
                                    },
                                    {
                                        "name": "IDENTRSAIDOP",
                                        "operator": "=",
                                        "value": 'S'
                                    }
                                ];
                                General.callRestEngine('ped#/crud/tipooperac', 'FilterData', filter).then(function(callback) {
                                    if (callback.dataset.tipooperac.length > 0) {
                                        widget.currentRow.IDORIGDESTOP = callback.dataset.tipooperac[0].IDORIGDESTOP;
                                    }
                                    
                                    filter = [{
                                        "name": "CDMODPGTO",
                                        "operator": "=",
                                        "value": widget.currentRow.CDMODPGTO
                                    }];
                                    
                                    General.callRestEngine('ped#/crud/modpgto', 'FilterData', filter).then(function(callback) {
                                        
                                        for (i = 0; i < widget.container.getWidget('widgetItens').dataSource.data.length; i++) {
                                            widget.container.getWidget('widgetItens').dataSource.data[i].IDSITITEMPED = '1';
                                        }
                                        
                                        for (var i = 0; i < itemWidget.dataSource.data.length; i++) {
                                            if (callback.dataset.modpgto[0].IDLANCPEDMOD && callback.dataset.modpgto[0].CDMODPGTO == widget.currentRow.CDMODPGTO) {
                                                if (callback.dataset.modpgto[0].IDLANCPEDMOD == '1') {
                                                    widget.currentRow.IDSITPEDIDO = '1';
                                                    itemWidget.dataSource.data[i].IDSITITEMPED = '1';
                                                } else if (callback.dataset.modpgto[0].IDLANCPEDMOD == '2') {
                                                    widget.currentRow.IDSITPEDIDO = '2';
                                                    itemWidget.dataSource.data[i].IDSITITEMPED = '2';
                                                } else if (callback.dataset.modpgto[0].IDLANCPEDMOD == '3') {
                                                    widget.currentRow.IDSITPEDIDO = '2';
                                                    itemWidget.dataSource.data[i].IDSITITEMPED = '3';
                                                } else {
                                                    widget.currentRow.IDSITPEDIDO = '1';
                                                    itemWidget.dataSource.data[i].IDSITITEMPED = '1';
                                                }
                                            }
                                        }
                                        
                                        filter = [{
                                            "name": "CDFILIAL",
                                            "operator": "=",
                                            "value": widget.currentRow.CDFILIAL
                                        }];
                                        
                                        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(parametros) {
                                            for (var i = 0; i < itemWidget.dataSource.data.length; i++) {
                                                if (!callback.dataset.modpgto[0].IDLANCPEDMOD && parametros.dataset.parampedido[0].IDLANCPED && callback.dataset.modpgto[0].CDMODPGTO == widget.currentRow.CDMODPGTO) {
                                                    if (parametros.dataset.parampedido[0].IDLANCPED == '1'){
                                                        widget.currentRow.IDSITPEDIDO = '1';
                                                        itemWidget.dataSource.data[i].IDSITITEMPED = '1';
                                                    } else if (parametros.dataset.parampedido[0].IDLANCPED == '2'){
                                                        widget.currentRow.IDSITPEDIDO = '2';
                                                        itemWidget.dataSource.data[i].IDSITITEMPED = '2';
                                                    } else if (parametros.dataset.parampedido[0].IDLANCPED == '3'){
                                                        widget.currentRow.IDSITPEDIDO = '2';
                                                        itemWidget.dataSource.data[i].IDSITITEMPED = '3';
                                                    } else {
                                                        widget.currentRow.IDSITPEDIDO = '1';
                                                        itemWidget.dataSource.data[i].IDSITITEMPED = '1';
                                                    }
                                                }
                                            }
                                            
                                            var prazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.map(function(row) {
                                                return Util.clone(row, ['__leftActions', '__rightActions']);
                                            });
                                                
                                            /* RAISETRANSP SALVA DADOS DO ENDEREÇO DO PEDIDO*/
                                            var endereco = widget.container.getWidget('transportadora').currentRow.DADOSENDPED;
                                            /*SALVA DADOS DO ENDEREÇO DO PEDIDO*/
                                            
                                            var savePedido = [widget.container.getWidget('widgetItens').dataSource.data, 
                                                            prazos, 
                                                            [widget.container.getWidget('widgetPedido').currentRow], 
                                                            dadosadic, 
                                                            encargos, 
                                                            vendedores,
                                                            [endereco]];
                                                            
                                            //Alteracoes para nao editar o prazo
                                            widget.container.getWidget('widgetPrazoPed').getAction('novoPrazo').isVisible = true;
                                            widget.container.getWidget('widgetPrazoPed').getAction('editarPrazo').isVisible = true;
                                            // widget.container.getWidget('widgetPrazoPed').getAction('excluirPrazo').isVisible = true;
                                            
                                            Ped00100_lancamentoPedido_Service.savePedido(savePedido).then(function(){
                                                
                                                ScreenService.closeSwipe();
                                                ScreenService.showMessage('Pedido lançado com sucesso');
                                                for (e = 0; e < widget.widgets.length; e++) {
                                                    widget.widgets[e].floatingControl.visibleModes = ["list"];
                                                }
                                                widget.container.getWidget('widgetItens').getAction('fecharPedidoItem').isVisible = false;
                                                widget.container.getWidget('widgetPrazoPed').getAction('fecharPedidoPrazo').isVisible = false;
                                                widget.container.getWidget('widgetDadosAdicionais').getAction('fecharPedidoDadosAdic').isVisible = false;
                                                widget.container.getWidget('transportadora').getAction('fecharPedidoTransportadora').isVisible = false;
                                                widget.currentRow.__is_new = false;
                                                
                                                this.apagaCacheGeral(widget);
                                                
                                                // RAISETRANSP atualizando template da transportadora
                                                widget.container.getWidget('transportadora').getField('NMROTATRANS').readOnly = true;
                                                widget.container.getWidget('transportadora').getField('NMRAZSOCTRAN').readOnly = true;
                                                widget.container.getWidget('transportadora').getField('NMTIPTRANS').readOnly = true;
                                                widget.container.getWidget('transportadora').getField('IDPGFRETTRAN').readOnly = true;
                                                widget.container.getWidget('transportadora').getField('DSENDECLIE').readOnly = true;
                                                widget.container.getWidget('transportadora').reload();
                                                
                                                widget.reload();
                                                
                                            }.bind(this))
                                            .catch(function(error){
                                                var erroLancarPedido_msg = ScreenService.i18n("Erro ao lançar o pedido");
                                                ScreenService.showMessage(erroLancarPedido_msg +' \n ' + error.data.error);
                                            }.bind(this));
                                        }.bind(this));
                                    }.bind(this));
                                }.bind(this));
                            }.bind(this));
                        }
                    }.bind(this));
                } else if (percent !== 100 && widget.isValid() && qtItens > 0 && widget.container.getWidget('widgetPrazoPed').dataSource.data.length > 0 && widget.currentRow.__is_new) {
                    ScreenService.showMessage('O valor total do pedido difere do valor total dos prazos.');
                } else if (widget.isValid() && widget.currentRow.__is_new && validaWidgetTrans) {
                    ScreenService.showMessage('É necessário primeiro inserir itens e modalidades de pagamento para o pedido e preencher todos os seus campos obrigatórios.');
                    if (widget.currentRow.VRTOTALPED) {
                        widget.widgets[3].activate();
                    } else {
                        widget.widgets[0].activate();
                    }
                    //widget.widgets[0].activate();
                } else if (!validaWidgetTrans){
                    	ScreenService.showMessage('É necessário preencher todos os campos obrigatórios da Transportadora.');
                }else if (widget.isValid() && !(widget.currentRow.__is_new)) {
                   
                    promises.push(this.getItensSalvos(widget));
                   
                    if(this.vendPedAux) {
                        promises.push(this.tiraVendedoresCache());
                    }
                    // widget.container.dataSourceFilter = filter;
                    ZHPromise.all(promises).then(function(callback){
                        var itens = widget.container.getWidget('widgetItens').dataSource.data;
                        
                        if (this.vendPedAux) {
                            vendedores = callback[1];
                             this.vendPedAux = false;
                        }
                        
                        if (itens && itens.length === 0) {
                            itens = callback[0].dataset.itempedido_completa;
                        }
                        widget.container.getWidget('widgetPedido').currentRow.CALLED_BY = 'UPDATE_PED';
                        if (widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '7' || widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO == '8'){
                            widget.container.getWidget('widgetPedido').currentRow.IDSITPEDIDO = '2';
                        }
                        var prazos = widget.container.getWidget('widgetPrazoPed').dataSource.data.map(function(row) {
                            return Util.clone(row, ['__leftActions', '__rightActions']);
                        });
                        var savePedido = [itens, prazos, [widget.container.getWidget('widgetPedido').currentRow], encargos, vendedores];
                        
                        Ped00100_lancamentoPedido_Service.updateOrder(savePedido).then(function(callback){
                            ScreenService.showMessage('Salvo com sucesso.');
                            widget.view();
                            // widget.container.getWidget('widgetPedido').dataSourceFilter = filter;
                            
                            this.apagaCacheGeral(widget);
                            
                            widget.container.getWidget('widgetPedido').reload();
                        }.bind(this)).catch(function(error){
                            var erroEditar_msg = ScreenService.i18n("Erro ao editar o pedido");
                            ScreenService.showMessage(erroEditar_msg + ' \n ' + error.data.error);
                        }.bind(this));
                    }.bind(this));
                } else if (!widget.isValid()) {     
                      
                    ScreenService.showMessage('É necessário preencher todos os campos obrigatórios.');
                }
            }else{
                var widgetRetornoValidEst = templateManager.container.getWidget('popUpRetornoValidacaoEstoque');
                
                var retorno = callback.dataset.validaQtdeDispEstoque;
                
                widgetRetornoValidEst.dataSource.data = retorno[0];
                ScreenService.openPopup(widgetRetornoValidEst).then(function(){
                    widgetRetornoValidEst.reload();
                });
            }
        }.bind(this));
    }; 

    this.getItensSalvos = function(widget) {
        
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            },
            {
                "name": "NRPEDIDO",
                "operator": "=",
                "value": widget.currentRow.NRPEDIDO
            }
        ];
        // widget.container.dataSourceFilter = filter;
        
        return General.callRestEngine('ped#/crud/itempedido_completa', "FilterData", filter);
    };

    this.apagaCacheGeral = function(widget) {
        
        this.deletaCacheVendedores();
        this.deletaCacheItemCompleta();
        this.deletaCachePrazoPgtoPed();
        
        // Instrução para apagar dados de Cache sobre Encargos
        this.resetarEncargosCache(widget);
    };

    this.generateNumberItemPed = function (widget) {
        if(!(widget)){
            widget = templateManager.container.getWidget('widgetItens');
        }
        var keyItem = 0;
        var i;
        for (i = 0; i < widget.dataSource.data.length; i++) {
            if (keyItem < parseInt(widget.dataSource.data[i].NRITEMPED)) {
                keyItem = parseInt(widget.dataSource.data[i].NRITEMPED);
            }
        }

        this.nmrItemPed = keyItem + 1;
        var loop = this.nmrItemPed.toString();
        loop = loop.length;
        for (i = 0; i < 10-loop; i++) {
            widget.currentRow.NRITEMPED += '0';
        }
        widget.currentRow.NRITEMPED += this.nmrItemPed;
        // widget.getField('NRITEMPED').reload();
    }; 

    this.fixPrazo = function (field) {
        var widget = field.widget;
        var dataPed = widget.getParent().getField("DTPEDIDO").value();
        if (dataPed) {
            dataPed = moment(dataPed, 'DD/MM/YYYY').format();
        } else {
            dataPed = moment().format('DD/MM/YYYY');
        }
        dataPed = moment(dataPed).format('DD/MM/YYYY');
        if (field.name == "NRDIASPGTOPED" && field.value()) {
            var diasPg = widget.currentRow.NRDIASPGTOPED;
            widget.getField("PREVISAO").setValue(this.calcPreview(dataPed, diasPg));
        } else if (widget.getField("PREVISAO").value()) {
            var dtPrevisao = widget.currentRow.PREVISAO;
            widget.getField("NRDIASPGTOPED").setValue((this.calcPrazo(dataPed, dtPrevisao)));
        }
    }; 

    this.calcPreview = function (dtPedido, nrDiasPg) {
        nrDiasPg = parseInt(nrDiasPg);
        var dtPrevisao = moment(dtPedido, 'DD/MM/YYYY').add(nrDiasPg,'days').format('DD/MM/YYYY');
        return dtPrevisao;
    }; 

    this.fixMinDate = function (field) {

        field.minDate = field.widget.getField('DTPEDIDO').value();
    }; 

    this.fixDate = function (field) {
        this.fixMinDate(field);
        var dtEntPed = field.widget.getField('DTPEDIDO').value();
        dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(5,'days').format('DD/MM/YYYY');
        field.widget.getField('DTENTPED').setValue(dtEntPed);
    }; 

	this.checkData = function(widget) {
	    
		var dataInput = (widget.getField('DTENTPED').value());
	
		if (moment(moment().format('L'), "DD/MM/YYYY") > moment(dataInput, "DD/MM/YYYY")){
			widget.currentRow.DTENTPED = moment().format("DD/MM/YYYY");
			ScreenService.showMessage("Data de Entrega inferior a data atual.");
		}
	};

    this.changeProduto = function () {
        var widget = templateManager.container.getActiveWidget();
        this.verificaPrecoOpcio();
        this.verifyParamPreco();
        this.calcValorTotal(widget);
        this.calcImpostoItem(widget);
        
    };
    
    this.getParamPreco = function (widgetPed){
        var data = widgetPed.getField('NMFILIAL').dataSource.data.filter(function(data){ return data.CDFILIAL == widgetPed.appliedFilter.FILTER_ROW.CDFILIAL;});
        var filter = [
            {
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value":  data[0].CDEMPRESA
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widgetPed.currentRow.CDFILIAL
            }
        ];
        General.callRestEngine('ped#/crud/precouti_filial', "FilterData", filter).then(function(success){
            if(success.length > 0){
                var modPgto = widgetPed.currentRow.CDMODPGTO > 0 ? widgetPed.currentRow.CDMODPGTO : widgetPed.currentRow.CDMODPGTO;
                var paramPreco = success.filter(function(row){ 
                    return  row.CDEMPRESA == widgetPed.currentRow.CDEMPRESA &&
                            row.CDFILIAL == widgetPed.currentRow.CDFILIAL  &&
                            row.CDPRECOBASE == widgetPed.currentRow.CDPRECOBASE &&
                            row.CDMODPGTO == modPgto;
                });   
                widgetPed.currentRow.paramPreco = paramPreco[0].VRPEADPBASE;
            }    
        });    
    };
    
    this.verifyParamPreco = function (){
        var widgetPed   = templateManager.container.getWidget('widgetPedido');
        var widgetItens = templateManager.container.getWidget('widgetItens');
        // var widgetModpgto = templateManager.container.getWidget('widgetModpgtoPed');
        var data = widgetPed.getField('NMFILIAL').dataSource.data.filter(function(data){ return data.CDFILIAL == widgetPed.appliedFilter.FILTER_ROW.CDFILIAL;});
        var filter = [
            {
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value":  data[0].CDEMPRESA
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widgetPed.currentRow.CDFILIAL
            }
        ];
        General.callRestEngine('ped#/crud/precouti_filial', "FilterData", filter).then(function(success){
            var modPgto = widgetPed.currentRow.CDMODPGTO;
            var paramPreco = success.dataset.precouti_filial.filter(function(row){ 
                return  row.CDEMPRESA == data[0].CDEMPRESA &&
                        row.CDFILIAL == widgetPed.currentRow.CDFILIAL  &&
                        row.CDPRECOBASE == widgetPed.currentRow.CDPRECOBASE &&
                        row.CDMODPGTO == modPgto;
            });   
            if (paramPreco.length > 0){
                widgetPed.currentRow.paramPreco   = paramPreco[0].VRPEADPBASE;
                widgetItens.currentRow.VRPREUNITPED = parseFloat(widgetItens.currentRow.VRPREUNITPED) + parseFloat((widgetItens.currentRow.VRPREUNITPED * paramPreco[0].VRPEADPBASE)/100);
                widgetItens.currentRow.VRPREUNITPED = parseFloat(widgetItens.currentRow.VRPREUNITPED.toFixed(2));
            } else {
                widgetPed.currentRow.paramPreco = 0;
            }
            return true;
        });
    }; 

    this.calcValorTotal = function (widget) {
        var qtItem = widget.currentRow.QTITEMPED;
        if (typeof(qtItem) == 'string') {
            // qtItem = qtItem.replace(/\./g, "");
            qtItem = qtItem.replace(',', '.');
            qtItem = parseFloat(qtItem);
            // qtItem = parseFloat(qtItem.replace(',', '.'));
        }
        // widget.currentRow.QTITEMPED = qtItem;
        var vrUnit = parseFloat(widget.currentRow.VRPREUNITPED);
        if (vrUnit) {
            if (typeof(vrUnit) == 'string') {
                
                // vrUnit = vrUnit.replace(/\./g, '');
                vrUnit+=" ";
                vrUnit = vrUnit.replace(',', '.');
                vrUnit = parseFloat(vrUnit);
                // vrUnit = parseFloat(vrUnit.replace(',', '.'));
            }
        }

        var vrTotal   = (parseFloat(widget.currentRow.VRTOTALITEMSEMIMP) > 0) ? parseFloat(widget.currentRow.VRTOTALITEMSEMIMP) : 0;
        var desconto = widget.currentRow.PERDESC;
        // desconto = desconto.replace(/\./g, '');
        desconto+=" ";
        desconto = desconto.replace(',', '.');
        desconto = parseFloat(desconto);
        
        if (qtItem && vrUnit) {
            vrTotal = vrUnit * qtItem;
            desconto = desconto/100;
            desconto = desconto * vrTotal;
            if (desconto){
                vrTotal = vrTotal - desconto;
                widget.currentRow.VRDESITPED = desconto;

            }
            vrTotal = vrTotal.toFixed(2);
            vrTotal = parseFloat(vrTotal);

            widget.currentRow.VRTOTALITEMSEMIMP = vrTotal;
        }
    }; 

    this.calcValorDesc = function(widget) {
        if (widget.currentRow.PERDESC >= 100) {
            ScreenService.showMessage('O Preço do produto não pode ser menor ou igual a 0.');
            widget.currentRow.PERDESC = 99;
        }
        // var qtItem = parseFloat(widget.currentRow.QTITEMPED);
        // var vrUnit = parseFloat(widget.currentRow.VRPREUNITPED);
        
        var qtItem = widget.currentRow.QTITEMPED;
        var vrUnit = widget.currentRow.VRPREUNITPED;
        
        // qtItem = qtItem.replace(/\./g, "");
        qtItem +=" ";
        qtItem = qtItem.replace(',', '.');
        qtItem = parseFloat(qtItem);
            
        // vrUnit = vrUnit.replace(/\./g, '');
        vrUnit+=" ";
        vrUnit = vrUnit.replace(',', '.');
        vrUnit = parseFloat(vrUnit);
        
        var vrPed = vrUnit * qtItem;

        var desconto = widget.currentRow.PERDESC;
        if (desconto) {
            if (typeof(desconto) == 'string') {
                // desconto = desconto.replace(/\./g, "");
                desconto = parseFloat(desconto.replace(',', '.'));
            }
        } else {
            desconto = 0;
            widget.currentRow.PERDESC = desconto;
        }

        var vrdesconto = (desconto*vrPed)/100;
        vrdesconto = vrdesconto.toFixed(2);

        vrdesconto = parseFloat(vrdesconto);
        widget.currentRow.VRDESITPED = vrdesconto;

        if (widget.currentRow.PERDESC === 0) {
            widget.currentRow.VRTOTALITEMSEMIMP = widget.currentRow.VRITEPREBASE * widget.currentRow.QTITEMPED;
        }

        this.validaDesconto(widget);

        if (widget.isValid() && parseFloat(widget.currentRow.VRTOTALITEMSEMIMP) !==0 ) {
            this.calcValorTotal(widget);
        }
    }; 
    
    

    this.calcPercDesc = function(widget) {

        // var qtItem = parseFloat(widget.currentRow.QTITEMPED);
        // var vrUnit = parseFloat(widget.currentRow.VRPREUNITPED);
        
        var qtItem = widget.currentRow.QTITEMPED;
        var vrUnit = widget.currentRow.VRPREUNITPED;
        
        // qtItem = qtItem.replace(/\./g, "");
        qtItem +=" ";
        qtItem = qtItem.replace(',', '.');
        qtItem = parseFloat(qtItem);
            
        // vrUnit = vrUnit.replace(/\./g, '');
        vrUnit+=" ";
        vrUnit = vrUnit.replace(',', '.');
        vrUnit = parseFloat(vrUnit);
        
        var vrPed = vrUnit * qtItem;
        if (typeof(widget.currentRow.VRDESITPED) == 'string') {
            parseFloat(widget.currentRow.VRDESITPED.replace(',','.'));
        }
        if (widget.currentRow.VRDESITPED >= widget.currentRow.VRTOTALITEMSEMIMP) {
            ScreenService.showMessage('O Preço do produto não pode ser menor ou igual a 0.');
            widget.currentRow.VRDESITPED = (vrPed-(vrPed*0.01));
        }
        
        var vrDesc = widget.currentRow.VRDESITPED;
        if (vrDesc) {
            if (typeof(vrDesc) == 'string') {
                // vrDesc = vrDesc.replace(/\./g, '');
                vrDesc = vrDesc.replace(',', '.');
                vrDesc = parseFloat(vrDesc);

            }
        } else {
            vrDesc = 0;
            widget.currentRow.VRDESITPED =  vrDesc;
        }

        var percDesc = (vrDesc*100)/vrPed;
        // var percDesc = (parseFloat(vrDesc)*100)/vrPed;
        percDesc = percDesc.toFixed(4);
        percDesc = parseFloat(percDesc);

        widget.currentRow.PERDESC = percDesc;

        if (widget.currentRow.VRDESITPED === 0) {
            widget.currentRow.VRTOTALITEMSEMIMP = widget.currentRow.VRITEPREBASE * widget.currentRow.QTITEMPED;
        }

        this.validaDesconto(widget);
        if (widget.isValid() && parseFloat(widget.currentRow.VRTOTALITEMSEMIMP) !==0 && widget.currentRow.PERDESC < 100) {
            this.calcValorTotal(widget);
        }
    }; 

    this.validaDesconto = function(widget) {
        /*  '1' 'Não verifica o desconto máximo'
            '2' 'Verifica o desconto máximo e emite mensagem de aviso'
            '3' 'Bloqueia a inclusão de desconto acima do desconto máximo'*/
        var verifica = this.parametros.IDUTDESCMAXI ? this.parametros.IDUTDESCMAXI : null;
        var filter = [{
                "name": "CDPRECOBASE",
                "operator": "=",
                "value": widget.getParent().currentRow.CDPRECOBASE
            },
            {
                "name": "CDPAIS",
                "operator": "=",
                "value": widget.getParent().currentRow.CDPAIS
            },
            {
                "name": "SGESTADO",
                "operator": "=",
                "value": widget.getParent().currentRow.SGESTADO
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": widget.currentRow.CDPRODUTO
            }
        ];
        General.callRestEngine('ped#/crud/itdesprebase', "FilterData", filter).then(function(callback) {
            var descTab = callback.dataset.itdesprebase;
            var isValid = true;
            if (this.parametros.IDUTDESCMAXI !== "1" && this.parametros.IDUTDESCMAXI) {
                // callback.dataset.itdesprebase[0].VRPEMAXDESVE = !(callback.dataset.itdesprebase[0].VRPEMAXDESVE) ? null : callback.dataset.itdesprebase[0].VRPEMAXDESVE;

                // var cliente = widget.getParent().getField('NMRAZSOCCLIE').dataSource.data.find(function(value) {
                //     return value.CDCLIENTE == widget.getParent().currentRow.CDCLIENTE;
                // });

                var filterCliente = [{
                    "name": "CDCLIENTE",
                    "operator": "=",
                    "value": widget.getParent().currentRow.CDCLIENTE
                }];

                General.callRestEngine('ped#/crud/cliente_vendedor', "FilterData", filterCliente).then(function(cliente) {


                    var descontoClie = cliente.dataset.cliente_vendedor[0].VRPEMAXDESCL ? cliente.dataset.cliente_vendedor[0].VRPEMAXDESCL : null;
                    var descontoVendedor = widget.getParent().currentRow.VRPEMAXDESVE ? widget.getParent().currentRow.VRPEMAXDESVE : null;
                    var descontoProd = descTab[0] ? descTab[0].VRPEMAXDESPR : null;
                    var descontoMaximo = null;

                    if (descontoClie > descontoVendedor && descontoClie > descontoProd) {
                        descontoMaximo = descontoClie;
                    } else {
                        descontoMaximo = descontoProd > descontoVendedor ? descontoProd : descontoVendedor;
                    }
                    

                    // var descontoMaximo = 0;
                    // if (cliente.dataset.cliente_vendedor[0].VRPEMAXDESCL!= null){
                    // descontoMaximo = cliente.dataset.cliente_vendedor[0].VRPEMAXDESCL;
                    // }
                    // if (widget.getParent().currentRow.VRPEMAXDESVE != null) {
                    //     var desconto = parseFloat(cliente.dataset.cliente_vendedor[0].VRPEMAXDESCL) > parseFloat(widget.getParent().currentRow.VRPEMAXDESVE) ? cliente.VRPEMAXDESCL : widget.getParent().currentRow.VRPEMAXDESVE;
                    //     if (descTab[0] && descTab.length) {
                    //         desconto = parseFloat(descontoMaximo) > parseFloat(descTab[0].VRPEMAXDESPR) ? descontoMaximo : descTab[0].VRPEMAXDESPR;
                    //     }
                    // }
                    if (parseFloat(widget.currentRow.PERDESC) > parseFloat(descontoMaximo)) {
                        //Validação confirma
                        if (verifica == 2) {
                            ScreenService.confirmMessage(ScreenService.i18n('Deseja gravar o desconto acima do recomendado para o item?'), 'question', function(success) {
                                    widget.isValidDesc = isValid;
                                }.bind(this),
                                function(error) {
                                    widget.currentRow.PERDESC = 0;
                                    widget.currentRow.VRDESITPED = 0;
                                    isValid = false;
                                }.bind(this));
                        } else if (verifica == 3){
                            widget.currentRow.PERDESC = 0;
                            widget.currentRow.VRDESITPED = 0;
                            this.calcValorTotal(widget);
                            this.calcImpostoItem();
                            ScreenService.showMessage('Desconto maior que o permitido.');
                            isValid = false;

                            widget.currentRow.VRTOTALITEM = 0;

                        }
                    }
                }.bind(this));


                /*if ( cliente && cliente.VRPEMAXDESCL && cliente.VRPEMAXDESCL > 0 && widget.currentRow.PERDESC > cliente.VRPEMAXDESCL ) {
                    ScreenService.showMessage('Desconto maior que o permitido para este Cliente');
                    if (this.parametros.IDUTDESCMAXI == 3) {
                        widget.currentRow.PERDESC = cliente.VRPEMAXDESCL;
                        widget.currentRow.VRDESITPED = (widget.currentRow.VRITEPREBASE-(widget.currentRow.VRITEPREBASE*(cliente.VRPEMAXDESCL/100)));
                    }
                } else if (widget.currentRow.PERDESC > this.vendedor.VRPEMAXDESVE && this.vendedor.VRPEMAXDESVE && cliente.VRPEMAXDESCL > 0){
                    ScreenService.showMessage('Desconto maior que o permitido para este Vendedor');
                }*/
            }
            widget.isValidDesc = isValid;
        }.bind(this));
    };


    this.setPrevisaoMobile = function (widget) {
        if (widget.dataSource.data.length !== 0) {
            for (var i = 0; i < widget.dataSource.data.length; i++) {
                var dataPed = widget.getParent().getField("DTPEDIDO").value();
                var diasPg = widget.dataSource.data[i].NRDIASPGTOPED;
                var dtPrevisao = this.calcPreview(dataPed, diasPg);
                widget.dataSource.data[i].PREVISAO = dtPrevisao;
            }
        }
    }; 

    this.minDate = function (widget) {
        widget.getField('PREVISAO').minDate = widget.getParent().getField('DTPEDIDO').value();
    }; 
    
    this.filterPromocao = function (widget) {
        if (widget.currentRow.CDARVPROD) {
            var produto = this.dataProduto.find(function(value){return value.CDARVPROD == widget.getField('CDARVPROD').value();});
            var tpPreco = 'O';
            if (widget.currentRow.VRPREUNITPED == produto.VRITEPREBASE) {
                tpPreco = 'N';
            }
            if (widget.currentRow.IDITPEDDIFER == 'P' && !produto.VRTOTALPROMO) {
                ScreenService.showMessage('Não há Promoção Cadastrada para este Produto');
                widget.currentRow.IDITPEDDIFER = tpPreco;
            } else if (widget.currentRow.IDITPEDDIFER == 'G' && !produto.VRTOTALPROMO) {
                ScreenService.showMessage('Não há Promoção Cadastrada para este Produto');
                widget.currentRow.IDITPEDDIFER = tpPreco;
            } else if (widget.currentRow.IDITPEDDIFER == 'G' || widget.currentRow.IDITPEDDIFER == 'P' && produto.VRTOTALPROMO) {
                widget.currentRow.VRPREUNITPED = produto.VRTOTALPROMO;
            }
            if (widget.currentRow.IDITPEDDIFER == 'N'){
                widget.currentRow.VRPREUNITPED = produto.VRITEPREBASE;
            }
        }
    }; 
    /* global moment*/

    this.calcPrazo = function (dtPedido, dtPrevisao) {
        dtPedido = moment(dtPedido, 'DD/MM/YYYY');
        dtPrevisao = moment(dtPrevisao, 'DD/MM/YYYY');
        var diasPg = dtPrevisao.diff(dtPedido, 'days');
        diasPg = parseInt(diasPg);
        return diasPg;
    }; 

    this.deletePrazo = function (widget) {
        var msg_excluir = ScreenService.i18n("Deseja excluir o prazo?");
        ScreenService.showCustomDialog(msg_excluir, 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
            code: function(){
                if (Util.isMobile()) {
                    this.excluiPrazo(widget);
                } else  {
                    widget.dataSource.data.splice(widget.dataSource.data.indexOf(widget.currentRow), 1);
                }
            }.bind(this)
        },{
            label: ScreenService.i18n("Não"),
            code: function(){}.bind(this)
        }]);
    }; 

    this.excluiPrazo = function (widget) {
        if (this.prazos.length) {
            for (var i = this.prazos.length-1; i >= 0; i--) {
                if (this.prazos[i].NRPEDIDO == widget.currentRow.NRPEDIDO && this.prazos[i].NRDIASPGTOPED == widget.currentRow.NRDIASPGTOPED) {
                    this.prazos.splice(i,1);
                }
            }
            Ped00100_lancamentoPedido_Service.setData("ped#/prazopgtoped", this.prazos).then(function(){
                ScreenService.closeSwipe();
                widget.reload();
            });
        }
    }; 
    
    this.editMensage = function (widget) {

        widget.currentRow.CDMENSAGEM = '';
    }; 

    this.fechaPopupResAprovacao = function (widget) {
        
        ScreenService.closePopup(widget);
        
        ScreenService.closePopup();
        
        widget.container.getWidget('widgetPedido').unSelectAll();
        this.enableDupPed();
    };
    
    this.setDadosTransportadora = function(){
        var widget = templateManager.container.getWidget('transportadora');
        
        var widgetPedido = widget.getParent();
        
        if(widgetPedido.currentRow.__is_new){
            var paramped = this.parametros;
            if(paramped.IDOBRINFTRAN == '2'){
                // tornar campos obrigatórios
                widget.getField('NRINSJURTRAN').validations = {required: true};
                widget.getField('NMRAZSOCTRAN').validations = {required: true};
                widget.getField('CDTIPTRANS').validations = {required: true};
                widget.getField('NMTIPTRANS').validations = {required: true};
                widget.getField('IDPGFRETTRAN').validations = {required: true};
                widget.reload();
            }
            
            restEngine.post('ped#/crud/cliente_parametrizacoes', {
                "requestType": "FilterData",
                "filter": [{
                    "name": "CDCLIENTE",
                    "operator": "=",
                    "value": widget.getParent().currentRow.CDCLIENTE
                }]
            }).then(function(callback){
                if(callback.dataset.cliente_parametrizacoes.length > 0){
                    var rowCli = callback.dataset.cliente_parametrizacoes[0];
                    
                    widget.getField('NRINSJURTRAN').setValue(rowCli.NRINSJURTRAN ? rowCli.NRINSJURTRAN : '');
                    widget.getField('NMRAZSOCTRAN').setValue(rowCli.NMRAZSOCTRAN ? rowCli.NMRAZSOCTRAN : '');
                    widget.getField('CDTIPTRANS').setValue(rowCli.CDTIPTRANS ? rowCli.CDTIPTRANS : '');
                    widget.getField('NMTIPTRANS').setValue(rowCli.NMTIPTRANS ? rowCli.NMTIPTRANS : '');
                    widget.getField('IDPGFRETTRAN').setValue(rowCli.IDPGFRETTRANCLI ? rowCli.IDPGFRETTRANCLI : '');
                    
                    templateManager.container.getWidget('widgetPedido').currentRow.NRINSJURTRAN = rowCli.NRINSJURTRAN;
                    templateManager.container.getWidget('widgetPedido').currentRow.IDTPIJURTRAN = rowCli.IDTPIJURTRAN;
                    templateManager.container.getWidget('widgetPedido').currentRow.CDTIPTRANS   = rowCli.CDTIPTRANS;
                    templateManager.container.getWidget('widgetPedido').currentRow.IDPGFRETTRAN = rowCli.IDPGFRETTRANCLI;
                }
            });
            
            restEngine.post('ped_pedidos#/crud/endeclie_transportadora', {
                "requestType": "FilterData",
                "filter": [{
                    "name": "CDCLIENTE",
                    "operator": "=",
                    "value": widget.getParent().currentRow.CDCLIENTE
                }]
            }).then(function(callback){
                if(callback.dataset.endeclie_transportadora.length > 0){
                    
                    var rowEnd;
                    var endEntrega = callback.dataset.endeclie_transportadora.filter((row) => {
                        return row.IDTPENDECLIE === 'T';
                    });
                    
                    if(endEntrega.length > 0)
                        rowEnd = endEntrega;
                    else
                        rowEnd = callback.dataset.endeclie_transportadora.filter((row) => {
                            return row.IDTPENDECLIE === 'P';
                        });
                    
                    rowEnd = rowEnd[0];
                    widget.getField('DSENDECLIE').setValue(rowEnd.DSENDECLIE);
                    widget.getField('NMBAIRRO').setValue(rowEnd.NMBAIRCLIE);
                    widget.getField('NMPAIS').setValue(rowEnd.NMPAIS);
                    widget.getField('NMESTADO').setValue(rowEnd.NMESTADO);
                    widget.getField('NMMUNICIPIO').setValue(rowEnd.NMMUNICIPIO);
                    widget.getField('NRCEPCLIE').setValue(rowEnd.NRCEPCLIE);
                    
                    var rowToSave = {};
                    rowToSave.CDFILIAL       = widget.getParent().currentRow.CDFILIAL;
                    rowToSave.NRPEDIDO       = widget.getParent().currentRow.NRPEDIDO;
                    rowToSave.NMRAZSOCPED    = widget.getParent().currentRow.NMRAZSOCCLIE;
                    rowToSave.CDCLIENTE      = widget.getParent().currentRow.CDCLIENTE;
                    rowToSave.NRINSJURPED    = widget.getParent().currentRow.NRINSJURCLIE;
                    rowToSave.IDTPENDECLIE   = rowEnd.IDTPENDECLIE;
                    
                    rowToSave.DSENDEPED      = rowEnd.DSENDECLIE;
                    rowToSave.NRCEPPED       = rowEnd.NRCEPCLIE;
                    
                    rowToSave.NMPAISPED      = rowEnd.NMPAIS;
                    rowToSave.NMMUNIPED      = rowEnd.NMMUNICIPIO;
                    rowToSave.NMBAIRROPED    = rowEnd.NMBAIRCLIE;
                    rowToSave.NMESTADOPED    = rowEnd.NMESTADO;
                    
                    rowToSave.SGESTADOPED    = rowEnd.SGESTADO;
                    rowToSave.CDPAISPED      = rowEnd.CDPAIS;
                    rowToSave.CDMUNICIPIOPED = rowEnd.CDMUNICIPIO;
                    
                    rowToSave.NRSEQEND       = '1';
                    rowToSave.NRORG          = '';
                    rowToSave.__is_new       = true;
                    
                    widget.currentRow.DADOSENDPED = rowToSave;
                    
                }
            });
            
        }
    };
    
    this.getDadosTransportadora = function (widget) {
        
        var widgetPedido = widget.getParent();
        
        if(!widgetPedido.currentRow.__is_new){
            var filial = General.getFieldValue('CDFILIAL','widgetPedido');
    
            // busca dados de transportadora do pedido e seta nos fields
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filial
                },
                {
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": widget.getParent().currentRow.NRPEDIDO
                }
            ];
            General.callRestEngine('ped_pedidos#/pedido_completa_transp', "FilterData", filter).then(function(callback){
                // widget.dataSource.data = callback.dataset.pedido_completa;
                
                var row = callback.dataset.pedido_completa_transp[0];
                
                widget.getField('CDROTATRANSPED').setValue(row.CDROTATRANSPED);
                widget.getField('NMROTATRANS').setValue(row.NMROTATRANS);
                
                widget.getField('NRINSJURTRAN').setValue(row.NRINSJURTRAN);
                widget.getField('NMRAZSOCTRAN').setValue(row.NMRAZSOCTRAN);
                // widget.getField('IDTPIJURTRAN').setValue(row.IDTPIJURTRAN);
                
                widget.getField('CDTIPTRANS').setValue(row.CDTIPTRANS);
                widget.getField('NMTIPTRANS').setValue(row.NMTIPTRANS);
                
                widget.getField('IDPGFRETTRAN').setValue(row.IDPGFRETTRAN);
                
                widget.reload();
            });
            
            // busca dados de endereço e seta nos fields
            restEngine.post('ped#/crud/dadosendped', {
                "requestType": "FilterData",
                "filter": [{
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": widget.getParent().currentRow.NRPEDIDO
                }]
            }).then(function(callback){
                if(callback.dataset.dadosendped.length > 0){
                    var rowEnd = callback.dataset.dadosendped[0];
                    widget.getField('DSENDECLIE').setValue(rowEnd.DSENDEPED);
                    widget.getField('NMBAIRRO').setValue(rowEnd.NMBAIRROPED);
                    widget.getField('NMPAIS').setValue(rowEnd.NMPAISPED);
                    widget.getField('NMESTADO').setValue(rowEnd.NMESTADOPED);
                    widget.getField('NMMUNICIPIO').setValue(rowEnd.NMMUNIPED);
                    widget.getField('NRCEPCLIE').setValue(rowEnd.NRCEPPED);
                }
            });
            
            /* habilita campos de transportadora */
            
            var result = widget.container.getWidget('widgetPedido').mode == 'edit';
            widget.getAction('ATUALIZA_ENDERECO').isVisible = !result;
            widget.getField('NMROTATRANS').readOnly = !result;
            widget.getField('NMRAZSOCTRAN').readOnly = !result;
            widget.getField('NMTIPTRANS').readOnly = !result;
            widget.getField('IDPGFRETTRAN').readOnly = !result;
            
            widget.getField('DSENDECLIE').readOnly = !result;
            
            /* fim controel campos de transportadora*/
            
        }
    };
    
    this.validaDadosEndEntrega = function(widget){
		widget.currentRow.DADOSENDPED = null;
    };
    
    this.setFieldChangePedido = function(nameFields){
        
        nameFields.forEach(function(nameField) {
            var valueField = templateManager.container.getWidget('transportadora').getField(nameField).value();
            templateManager.container.getWidget('widgetPedido').currentRow[nameField] = valueField;
        });
        
    };
    
    this.atualizaEndeTransportadora = function(widget){
        restEngine.post('ped_pedidos#/crud/endeclie_transportadora', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDCLIENTE",
                "operator": "=",
                "value": widget.getParent().currentRow.CDCLIENTE
            }]
        }).then(function(callback){
            if(callback.dataset.endeclie_transportadora.length > 0){
                
                var rowEnd;
                var endEntrega = callback.dataset.endeclie_transportadora.filter((row) => {
                    return row.IDTPENDECLIE === 'T';
                });
                
                if(endEntrega.length > 0)
                    rowEnd = endEntrega;
                else
                    rowEnd = callback.dataset.endeclie_transportadora.filter((row) => {
                        return row.IDTPENDECLIE === 'P';
                    });
                
                rowEnd = rowEnd[0];
                widget.getField('DSENDECLIE').setValue(rowEnd.DSENDECLIE);
                widget.getField('NMBAIRRO').setValue(rowEnd.NMBAIRCLIE);
                widget.getField('NMPAIS').setValue(rowEnd.NMPAIS);
                widget.getField('NMESTADO').setValue(rowEnd.NMESTADO);
                widget.getField('NMMUNICIPIO').setValue(rowEnd.NMMUNICIPIO);
                widget.getField('NRCEPCLIE').setValue(rowEnd.NRCEPCLIE);
                
                var rowToSave = {};
                rowToSave.CDFILIAL       = widget.getParent().currentRow.CDFILIAL;
                rowToSave.NRPEDIDO       = widget.getParent().currentRow.NRPEDIDO;
                // rowToSave.NMRAZSOCPED    = widget.getParent().currentRow.NMRAZSOCPED;
                // rowToSave.CDCLIENTE      = widget.getParent().currentRow.CDCLIENTE;
                // rowToSave.NRINSJURPED    = widget.getParent().currentRow.NRINSJURCLIE;
                rowToSave.IDTPENDECLIE   = rowEnd.IDTPENDECLIE;
                
                rowToSave.DSENDEPED      = rowEnd.DSENDECLIE;
                rowToSave.NRCEPPED       = rowEnd.NRCEPCLIE;
                
                rowToSave.NMPAISPED      = rowEnd.NMPAIS;
                rowToSave.NMMUNIPED      = rowEnd.NMMUNICIPIO;
                rowToSave.NMBAIRROPED    = rowEnd.NMBAIRCLIE;
                rowToSave.NMESTADOPED    = rowEnd.NMESTADO;
                
                rowToSave.SGESTADOPED    = rowEnd.SGESTADO;
                rowToSave.CDPAISPED      = rowEnd.CDPAIS;
                rowToSave.CDMUNICIPIOPED = rowEnd.CDMUNICIPIO;
                
                // rowToSave.NRSEQEND       = '1';
                rowToSave.__is_new       = false;
                rowToSave.changed        = true;
                
                // widget.currentRow.DADOSENDPED = rowToSave;
                restEngine.post('ped#/crud/dadosendped/save', {
                    "requestType": "Row",
                    "row": rowToSave
                });
            }
        });
    };

    this.getDadosAdic = function (widget) {
        Ped00100_lancamentoPedido_Service.getData("ped_pedidos#/crud/dadosadicped").then(function(callback){
            var dadosAdic = null;
            dadosAdic = callback.filter(function(value){return value.NRPEDIDO == widget.getParent().currentRow.NRPEDIDO;});

            if (dadosAdic.length > 0 && widget.getParent().currentRow.__is_new) {
                widget.dataSource.data = dadosAdic;
            } else if (!(widget.getParent().currentRow.__is_new)) {
                var filial;
                for (var i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
                    if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                        filial = widget.getParent().dataSourceFilter[i].value;
                    }
                }
                var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filial
                    },
                    {
                        "name": "NRPEDIDO",
                        "operator": "=",
                        "value": widget.getParent().currentRow.NRPEDIDO
                    }
                ];
                // widget.dataSourceFilter = filter;
                General.callRestEngine('ped_pedidos#/crud/dadosadicped', "FilterData", filter).then(function(callback){
                    widget.dataSource.data = callback.dataset.dadosadicped;
                });
            } else if (widget.getParent().currentRow.__is_new){
                widget.dataSource.data = dadosAdic;
            }
        }.bind(this));
    };

    this.prepareToSaveDadosAdic = function (widget) { 
        if (widget.isValid()) {
            if (widget.getParent().currentRow.__is_new) {
                this.armazenaDadosAdic(widget);
            } else {
                this.saveDadosAdic(widget);
                widget.reload();
            }
        }
    };

    this.armazenaDadosAdic = function (widget) {
        var filial;
        for (var i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
            if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                filial = widget.getParent().dataSourceFilter[i].value;
            }
        }
        widget.currentRow.CDFILIAL = filial;
        widget.currentRow.NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        Ped00100_lancamentoPedido_Service.saveData('ped_pedidos#/crud/dadosadicped', widget.dataSource.data).then(function(){
            widget.activate();
            widget.view();
            ScreenService.goBack();
            ScreenService.showMessage('Salvo com sucesso.');
            
            /* 
            * Método criado para desabilitar o grid de pedidos no backgroud do swipe
            */
            this.desabilitaBackgroundPedido('widgetDadosAdicionais');
            
        }.bind(this)).catch(function(error){
            var erroAosalvar = ScreenService.i18n("Erro ao salvar.");
            ScreenService.showMessage(erroAosalvar+' '+error);
            
            /* 
            * Método criado para desabilitar o grid de pedidos no backgroud do swipe
            */
            this.desabilitaBackgroundPedido('widgetDadosAdicionais');
            
        }.bind(this));

    };

    this.saveDadosAdic = function (widget) {
        if (widget.currentRow.__is_new) {
            var filial;
            for (var i = 0; i < widget.getParent().dataSourceFilter.length; i++) {
                if (widget.getParent().dataSourceFilter[i].name == 'CDFILIAL'){
                    filial = widget.getParent().dataSourceFilter[i].value;
                }
            }
            widget.currentRow.CDFILIAL = filial;
            widget.currentRow.NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
            widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
            General.callRestEngine('ped_pedidos#/dadosadicped/save', "Row", widget.currentRow).then(function(callback){
                widget.activate();
                widget.view();
                ScreenService.goBack();
                ScreenService.showMessage('Salvo com sucesso.');
            }).catch(function(error){
                var erroSalvar_msg = ScreenService.i18n("Erro ao salvar.");
                ScreenService.showMessage( erroSalvar_msg + ' '+error);
            });
        } else {
            General.saveCrud(widget);
        }
        // widget.currentRow.NRDADOADICPED = widget.parent.currentRow.NRDADOADICPED; // preciso pegar o maior
        // widget.currentRow.DSDADOADICPED = widget.parent.currentRow.DSDADOADICPED;
    };

    this.removeDadosAdic = function (widget) {
        if (widget.getParent().currentRow.__is_new) {
            var excluirRegistro_msg = ScreenService.i18n("Deseja Excluir o Registro?");
            ScreenService.showCustomDialog(excluirRegistro_msg, 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
                code: function(){
                    for(var i=0; i < widget.dataSource.data.length; i++) {
                        if(widget.dataSource.data[i] == widget.currentRow) {
                            widget.dataSource.data.splice(i,1);
                        }
                    }
                    Ped00100_lancamentoPedido_Service.setData('ped_pedidos#/crud/dadosadicped', widget.dataSource.data).then(function(){
                        widget.activate();
                        widget.view();
                        ScreenService.goBack();
                        ScreenService.showMessage('Deletado com sucesso.');
                    }).catch(function(error){
                        var erroExcluir = ScreenService.i18n("Erro ao excluir.");
                        ScreenService.showMessage(erroExcluir+' '+error);
                    });
                }.bind(this)
            },{
                label: ScreenService.i18n("Não"),
                code: function(){}.bind(this)
            }]);
        } else {
            General.deleteCrud(widget);
        }
    };
    
    this.reloadPedido = function(){
        var widget = templateManager.container.getWidget('widgetPedido');
        widget.reload();
    };
    
    this.abrirPopUpVendedores = function(widget) {
      
      var popUpWidget = widget.container.getWidget('popUpVendedores');
      
      popUpWidget.reload();
          
      ScreenService.openPopup(popUpWidget);
        
    };
    
    this.tiraVendedoresCache = function() {
     
     return Ped00100_lancamentoPedido_Service.getData('ped#/crud/vendedor').then(function(sucess){
          var vendedores = sucess;
          
          this.deletaCacheVendedores();
          
          return vendedores;
      }.bind(this));
      
    
    };
    
    
    this.deletaCacheItemCompleta = function() {
        
        localStorage.removeItem("ped#/crud/itempedido_completa");
        
        Ped00100_lancamentoPedido_Service.setData("ped#/crud/itempedido_completa",[]);
        
    };
    
    this.deletaCachePrazoPgtoPed = function() {
        
        localStorage.removeItem("ped#/crud/prazopgtoped");
        
        Ped00100_lancamentoPedido_Service.setData("ped#/crud/prazopgtoped",[]);
        
    };
    
    this.cancelarLancamentoDePedidos = function(args) {
        
        General.backOrCancel(args); 
        
        this.deletaCacheVendedores();
        
        this.deletaCacheItemCompleta();
        
        this.deletaCachePrazoPgtoPed();

        args.owner.widget.reload();
        
    };
    
    this.consultaVendedoresCache = function(widget) {
        
        Ped00100_lancamentoPedido_Service.getData('ped#/crud/vendedor').then(function(sucess){
          var vendedores = sucess;
          
          var sincVend = [];
          
          if(vendedores.length > 0) {
                    
                    vendedores.forEach(function(vend) {
                        
                        sincVend.push(widget.dataSource.data.filter(function(vendF){ 
                            
                            return vendF.CDVENDEDOR == vend.CDVENDEDOR;
                            
                        }.bind(this))[0] );
                        
                    }.bind(this));
                    
                    widget.dataSource.addCheckedRows(sincVend);
                
                    widget.vendInCache = true;
                
                }
          
          templateManager.updateTemplate();
          
      }.bind(this));
        
    };
    
    this.deletaCacheVendedores = function() {
        
        localStorage.removeItem("ped#/crud/vendedor");
        
        Ped00100_lancamentoPedido_Service.setData("ped#/crud/vendedor",[]);
        
    };
    
    this.filtraPopUpVendedores = function(widget) {
        
        var popUpWidget = widget;
        
        var widgetPedido = widget.container.getWidget('widgetPedido');
        
        if(widgetPedido.currentRow.CDVENDEDOR) {
         
        var cdVendedor = widgetPedido.currentRow.CDVENDEDOR;
          
        popUpWidget.dataSource.data = popUpWidget.dataSource.data.filter(function(vendedor){
            return vendedor.CDVENDEDOR != cdVendedor;
        }.bind(this)); 
        
        this.sincronizaVendPedAux(widget);
        
        }
    };
    
    
    this.fechaPopVendedores = function(widget) {
      
      widget.fechaPopUp = true;
      
      widget.unSelectAll();
     
      ScreenService.closePopup();
        
    };
    
    this.sincronizaVendPedAux = function(widget) {
        
        widget.sincroniza = true;
            
        widget.unSelectAll();
        
        if(!this.PedidoEhNovo()) {
            
            var sincVend = [];
            
            var pedidoWidget = widget.container.getWidget('widgetPedido');
            
            General.callRestEngine("ped_pedidos#/select_vendpedaux", "DataSet", [pedidoWidget.currentRow])
            .then(function(sucess){
                
                var vendedores = sucess.dataset.vendedores;
                
                if(vendedores.length > 0) {
                    
                    vendedores.forEach(function(vend) {
                        
                        sincVend.push(widget.dataSource.data.filter(function(vendF){ 
                            
                            return vendF.CDVENDEDOR == vend.CDVENDEDOR;
                            
                        }.bind(this))[0] );
                        
                    }.bind(this));
                    
                    widget.dataSource.addCheckedRows(sincVend);
                
                    widget.vendPedAuxRegistrado = true;
                
                }
                
            }.bind(this))
            .catch(function(fail){
                
                ScreenService.showMessage(fail);
                
            }.bind(this));
            
            this.consultaVendedoresCache(widget);
        
            
        } else {
            
            this.consultaVendedoresCache(widget);
            
        }
        
        
    };
    
    this.adicionarVendedores = function(widget) {
      
      this.vendPedAux = true;
      
      this.salvarVendedoresCache(widget);
      
    //   let todos = widget.dataSouce.data;
    //   let selecionados = widget.getCheckedRows();
      
    //   let paraDeletar = todos.filter(row => {
    //       return selecionados.some(selecionado =>{
    //           return selecionado != row;
    //       });
    //   });
        
    };
    
    this.desabilitaBackgroundPedido = function(widgetAtiva){
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        if(widgetPedido.currentRow.__is_new){
            templateManager.container.getWidget(widgetAtiva).editing = true;
            templateManager.updateTemplate();
        }else{
            templateManager.container.getWidget(widgetAtiva).editing = false;
            templateManager.updateTemplate();
        }
    };

    this.openExpedicaoPopUp = function() {
        var widgetPed = templateManager.container.getWidget('widgetPedido');
        var widget = templateManager.container.getWidget('expedirPedido');
        var cdfilial = widgetPed.appliedFilter.FILTER_ROW.CDFILIAL;
        
        widget.currentRow.CDTIPOOPER = '';
        widget.currentRow.NMTIPOOPER = '';
        widget.currentRow.CDSERIE = '';
        widget.currentRow.DSSERIE = '';
        
        widget.currentRow.CDSERIEENTR = '';
        widget.currentRow.DSSERIEENTR = '';
        widget.currentRow.CDTIPOOPERENTR = '';
        widget.currentRow.NMTIPOOPERENTR = '';
        
        if (widget.getField('DSSERIEENTR').dataSourceFilter) {
            widget.getField('DSSERIEENTR').dataSourceFilter =  [];
        }
        
        General.callRestEngine('ped#/crud/parexpedicao', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: cdfilial}]).then(function(callback) {
            
            if (widgetPed.getField('NMTIPOOPER').requiredParam){
                widget.getField('DSSERIE').class = 12;
                widget.getField('NMTIPOOPER').isVisible = false;
                if(widget.getField('NMTIPOOPER').validations) {
                    delete widget.getField('NMTIPOOPER').validations;
                }
            } else {
                widget.getField('DSSERIE').class = 6;
                widget.getField('NMTIPOOPER').isVisible = true;
                // widget.getField('NMTIPOOPER').validations = {
                //     required: true
                // };
            }
            if (callback.dataset.parexpedicao.length > 0 && callback.dataset.parexpedicao[0].IDGERAREPLIC == '2') {
                widget.getField('DSSERIEENTR').isVisible = true;
                widget.getField('NMTIPOOPERENTR').isVisible = true;
            } else {
                widget.getField('DSSERIEENTR').isVisible = false;
                widget.getField('NMTIPOOPERENTR').isVisible = false;
            }
            var data = widgetPed.getField('NMFILIAL').dataSource.data.filter(function(data){ return data.CDFILIAL == cdfilial;});
            widget.getField('DSSERIE').dataSource.data = [];
            widget.getField('DSSERIE').dataSourceFilter =  [
            {
                name: "CDEMPRESA",
                operator: "=",
                value: data[0].CDEMPRESA
            },
            {
                name: "CDINSCESTA",
                operator: "=",
                value: data[0].CDINSCESTA
            },
            {
                name: "CDINSCMUNI",
                operator: "=",
                value: data[0].CDINSCMUNI
            }
        ];
            widget.getField('DSSERIE').reload();
            
            ScreenService.openPopup(templateManager.container.getWidget('expedirPedido'));
        });    
    }; 
    
    this.expedirPedido = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetPed = templateManager.container.getWidget('widgetPedido');
        var rows = widgetPed.getCheckedRows();
        for (var i = 0; i < rows.length; i++ ) {
            rows[i].CDSERIE = widget.currentRow.CDSERIE;
            
            if (!(widgetPed.getField('NMTIPOOPER').requiredParam)) {
                rows[i].CDTIPOOPER = widget.currentRow.CDTIPOOPER;
            }
            
            if (widget.getField('DSSERIEENTR').isVisible) {
                rows[i].CDSERIEENTR = widget.currentRow.CDSERIEENTR;
                rows[i].DSSERIEENTR = widget.currentRow.DSSERIEENTR;
                rows[i].CDTIPOOPERENTR = widget.currentRow.CDTIPOOPERENTR;
                rows[i].NMTIPOOPERENTR = widget.currentRow.NMTIPOOPERENTR;
            }
        }
        if (widget.isValid()) {
            Exp00200_lancamentoExpedicaoPedido_Service.expedirPedido([rows,[]]).then(function(callback){
                // ScreenService.showMessage('Pedido(s) expedido(s) com sucesso.');
                ScreenService.closePopup();
                ScreenService.closePopup(widget);
                widget.currentRow.CDSERIE = '';
                widget.currentRow.DSSERIE = ''; 
                widget.currentRow.CDTIPOOPER = '';
                widget.currentRow.NMTIPOOPER = '';
                widgetPed.unSelectAll();
                widgetPed.reload();
                var widgetRetornoExp = templateManager.container.getWidget('popUpRetornoExpedicao');
                
                callback.dataset.data.forEach(function(item){
                    item.DSERRO = ScreenService.i18n(item.DSERRO);
                    if(item.PRODUTO){
                        item.DSERRO = item.PRODUTO + item.DSERRO;    
                    }
                });
                
                setTimeout(function(){
                    ZHPromise.all(ScreenService.openPopup(widgetRetornoExp)).then(function(){
                        var data = callback.dataset.data;
                        for (var i = 0; i < data.length; i++ ) {
                            if (data[i].DSERRO == "PEDNFILDEST"){
                              data[i].DSERRO = 'Tipo de Operação necessita de Filial de Destino e o pedido não possui filial de destino informada.'; 
                            }else if (data[i].DSERRO == "TIPOOPERENTR"){
                              data[i].DSERRO= 'Tipo de Operacao de entrada não foi informada.'; 
                                
                            }else if (data[i].DSERRO== "SERIEENTR"){
                              data[i].DSERRO= 'Série da nota de entrada não foi informada.'; 
                                
                            }else if (data[i].DSERRO == "TPNREPLIC"){
                              data[i].DSERRO= 'Tipo de Operacao não tem Filial de Destino.'; 
                            }
                        }
                        widgetRetornoExp.dataSource.data = data;
                        widgetPed.reload();

                    });
                }, 1000);
            }.bind(this)).catch(function(callback){
                //ScreenService.showMessage(callback.data.error);
                if(callback.data.error.indexOf("erro_lote") > -1){
                    var itemSemLote = "ITEM_NAO_POSSUI_LOTE";
                    var parametros = callback.data.error.split("/");
                    MessageService.showMessageByCode(itemSemLote,{"NMPRODUTO":parametros[1], "NRPEDIDO":parametros[2], "NMRAZSOCCLIE":parametros[3]});                    
                }else{
                    ScreenService.showMessage(callback.data.error);
                }
                ScreenService.closePopup(widget).then(function(){
                    ScreenService.closePopup();
                });
            }.bind(this));
        }
        
    };

    this.visibilidadeComissaoAction = function(widget){
        var actionComissao = widget.getAction('COMISSAO');
        var rows = widget.getCheckedRows();
        if(rows.length != 1){
            actionComissao.isVisible = false;
        }else{
            actionComissao.isVisible = true;
        }
    };
    
    this.visibilidadeComissao = function(){
        var widget = templateManager.container.getWidget("widgetItens");
        var widgetComissao = templateManager.container.getWidget("widgetComissao");
        
        if(widget.getAction('novoItem').isVisible){
            widgetComissao.isVisible = false;    
        }else{
            widgetComissao.isVisible = true;
        }
    };
    
    this.abreComissao = function(){
        var widget = templateManager.container.getWidget("widgetPedido");
        var checkedRow = widget.getCheckedRows();
        ScreenService.openWindow('ped_pedidos#ped00102_comissao_vendedor').then(function(){
            var widgetItens =  templateManager.containers["ped_pedidos#ped00102_comissao_vendedor"].getWidget('widgetItensExterna');  
            widgetItens.dataSourceFilter = [];
            widgetItens.dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": checkedRow[0].CDFILIAL
                },
                {
                    "name": "NRPEDIDO",
                    "operator": "=",
                    "value": checkedRow[0].NRPEDIDO
                }
            ];
            widgetItens.activate();
            widgetItens.reload();
        }.bind(this));
        // ScreenService.closePopup();
        // widget.unSelectAll();
        
    };
    
    this.fechaComissao = function(){
        ScreenService.openWindow('ped_pedidos#ped00100_lancamento_pedido').then(function(){
            var widget = templateManager.container.getWidget("widgetPedido");
            widget.unSelectAll();
            widget.reload();   
        });
    };
    
    this.visibilidadeItensExterna = function(){
        var widgetComissaoExterna = templateManager.container.getWidget('widgetComissaoExterna');
        widgetComissaoExterna.activate();
        widgetComissaoExterna.reload();
    };
    
    
    this.enviarEmail = function(){
        var widgetPedido = templateManager.container.getWidget('widgetPedido');
        var rows = widgetPedido.getCheckedRows();
        
        if(rows[0].DSEMAILCLIENFE){
            Ped00100_lancamentoPedido_Service.enviarEmail(rows).then(function(retornoEmai){
                ScreenService.showMessage('Email enviado com sucesso');
            }).catch(function(error){
                ScreenService.showMessage(error.data.error);
            });

        }else{
            ScreenService.showMessage('Cadastre o Email na tela de Cliente');
        }

        
    };
    
    this.deletePedido = function(widget){
        ScreenService.showCustomDialog('Deseja excluir o pedido?', 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
            code: function(){
                var row = [];
                row.push(widget.currentRow);
                
                Ped00100_lancamentoPedido_Service.deletePedido(row).then(function(callback){
                    ScreenService.showMessage('Pedido excluído com sucesso!');
                    ScreenService.closeSwipe().then(function () {
                        widget.reload();
                    });
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
            }.bind(this)
        },{
            label: ScreenService.i18n("Não"),
            code: function(){}.bind(this)
        }]);
    };
    
    this.changeTipoOperac = function(){
         var widget = templateManager.container.getWidget('widgetPedido');
         var row = {
            IDORIGDESTOP: widget.currentRow.IDORIGDESTOP
        };
        this.verificaTipoOper(row);
    };
    
    this.verificaTipoOper = function(row){
        var widget = templateManager.container.getWidget('widgetPedido');
        var idorigdestop;
         if (widget.currentRow.__is_new == true){
             idorigdestop = row.IDORIGDESTOP;
         }else{
            idorigdestop = widget.currentRow.IDORIGDESTOP;
         }
         var filtro = [
            {
                name: 'CDFILIAL', 
                operator: '=', 
                value: widget.currentRow.CDFILIAL
                
            }
        ];
        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filtro).then(function(callback){
           var utFilial = callback.dataset.parampedido[0].IDUTFILIALDESTINO; 
           if(idorigdestop == 'L'){
                widget.getField('FILIDEST').validations = {required:true};
                
                if(utFilial == 'NAO'){
                   widget.getField('FILIDEST').readOnly = true;  
                   widget.getField('FILIDEST').reload();
                   ScreenService.showMessage('O tipo de operação parametrizado exige informação de Filial de destino. Verifique a parametrização na tela Parâmetros de Pedidos');
                }
            }else if(idorigdestop != 'L' && utFilial == 'SIM'){
                widget.getField('FILIDEST').validations = {};
                widget.getField('FILIDEST').readOnly = false;
                widget.getField('FILIDEST').reload();
            }else if(idorigdestop != 'L' && utFilial == 'NAO'){
                widget.getField('FILIDEST').validations = {};
                widget.getField('FILIDEST').readOnly = true;
                widget.getField('FILIDEST').reload();
            }
            widget.reload();
        });
    };
     
    this.verificaRota = function(){
        var widget = templateManager.container.getWidget('widgetPedido');
        var widgetTransp = templateManager.container.getWidget('transportadora');
        var row = [];
        if(widget.currentRow.CDFILIALPED == undefined){
            row.push({
                IDORIGDESTOP: widget.currentRow.IDORIGDESTOP,
                CDFILIROTA:   null,
                CDCLIENTE:    widget.currentRow.CDCLIENTE
            });
        }else{
            row.push({
                IDORIGDESTOP: widget.currentRow.IDORIGDESTOP,
                CDFILIROTA:   widget.currentRow.CDFILIALPED,
                CDCLIENTE:    widget.currentRow.CDCLIENTE
            }); 
        }
        
        var promises = [];
        promises.push(General.callRestEngine("ped_pedidos#/getRotaEnt", "Row", row));
        ZHPromise.all(promises).then(function(callback){
            if(callback[0].dataset.data.length > 0){
                widgetTransp.currentRow.CDROTATRANS = callback[0].dataset.data[0].CDROTATRANS;
                widgetTransp.currentRow.NMROTATRANS = callback[0].dataset.data[0].NMROTATRANS;
                templateManager.container.getWidget('widgetPedido').currentRow.CDROTATRANSPED= widgetTransp.currentRow.CDROTATRANS;
            }
        }.bind(this));
 
    };
    
    this.verificaPrecoOpcio = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetPedido = templateManager.container.getWidget('widgetPedido');

        var filtroPreOpc = [
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.currentRow.CDPRODUTO
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetPedido.currentRow.CDPRECOBASE
            }
        ];
       
       
        var promises = [];
        promises.push(General.callRestEngine('ped_pedidos#/preco_opcional', 'FilterData', filtroPreOpc));
        promises.push(General.callRestEngine('ped_pedidos#/crud/preco_base', 'FilterData', [{ name: 'CDPRECOBASE', operator: '=', value: widgetPedido.currentRow.CDPRECOBASE}]));
        promises.push(General.callRestEngine('ped#/crud/parampedido', 'FilterData', [{ name: 'CDFILIAL', operator: '=', value: widgetPedido.currentRow.CDFILIAL}]));
        ZHPromise.all(promises).then(function(callback){
            var preOpcional = callback[0].dataset.preco_opcional;
            var tabPrecoBase = callback[1].dataset.preco_base[0].IDULTPRECPROMO;
            var alteraPreco = callback[2].dataset.parampedido[0].IDPERALTPRECO;
            
            if(preOpcional.length > 0 && tabPrecoBase == 'N' && alteraPreco == 'S'){
                widget.getField('QTITEMPED').class = 4;
                widget.getField('VRPREUNITPED').class = 4;
                widget.getField('VROPCIOPRBASE').showOnForm = true;
                widget.getField('VROPCIOPRBASE').reload();
                // widget.reload();
            }else{
                widget.getField('QTITEMPED').class = 6;
                widget.getField('VRPREUNITPED').class = 6;
                widget.getField('VROPCIOPRBASE').showOnForm = false;
                // widget.reload();
            }
        
        });
        
    };
    this.setValorUnit = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.getField('VRPREUNITPED').setValue(widget.currentRow.VROPCIOPRBASE);
        //widget.currentRow.VRPREUNITPED = widget.currentRow.VROPCIOPRBASE;
            this.calcValorTotal(widget);
            this.calcImpostoItem(widget);
    };
    
    this.clearPrecoOpcio = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.getField('VROPCIOPRBASE').setValue('');
    };
    
}; 

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00100_lancamentoPedido_Controller', Ped00100_lancamentoPedido_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped00301_posicaoFinanceiraCliente_Controller.js
var  Ped00301_posicaoFinanceiraCliente_Controller = function(ScreenService, General, templateManager, Ped00301_posicaoFinanceiraCliente_Service, ZHPromise, restEngine){
    
    this.filialLogada = '';
    this.initialized = false;
    
    this.initializePosicaoFinanceira = function(widget) {
        // var now = moment(new Date()).format("DD/MM/YYYY");
        // var later = moment(new Date()).add(7,'days').format("DD/MM/YYYY");
        // var dateInterval = {
        //   "end": later,
        //   "period": undefined,
        //   "start": now
        // };
        // widget.widgets[0].currentRow.DTPREVIVENDA = dateInterval;
        
        if(widget.currentRow.TELAORIGINAL == undefined) widget.currentRow.TELAORIGINAL = "LANCAMENTO";

        var posicaoWidgets = [];
        posicaoWidgets[0] = templateManager.container.getWidget('PosicaoFinanceira');
        posicaoWidgets[1] = templateManager.container.getWidget('ContasAbertas');
        posicaoWidgets[2] = templateManager.container.getWidget('ContasFechadas');
        posicaoWidgets[3] = templateManager.container.getWidget('Endereco');
        posicaoWidgets[4] = templateManager.container.getWidget('Historico');
        posicaoWidgets.forEach(function(posWidget) {
            var originalName;
            if(widget.currentRow.TELAORIGINAL == 'LANCAMENTO') originalName = "Lançamento de Pedidos";
            else originalName = "Aprovação Financeira";
            posWidget.actions[0].label = originalName;
        });
        if(widget.currentRow.CDCLIENTE == undefined || widget.currentRow.CDCLIENTE == null) {
            General.callRestEngine('ped#/crud/cliente_vendedor', 'FilterData', []).then(function(response) {
                widget.currentRow.CDCLIENTE = response.dataset.cliente_vendedor[0].CDCLIENTE;
                widget.currentRow.NMRAZSOCCLIE = response.dataset.cliente_vendedor[0].NMRAZSOCCLIE;
                this.searchData(widget);
                this.initialized = true;
            }.bind(this));
        } else {
            this.searchData(widget);
            this.initialized = true;
        }
    };
    
    this.returnOriginal = function(widget) {
        if(widget.currentRow.TELAORIGINAL == 'LANCAMENTO')
        ScreenService.openWindow('ped_pedidos#ped00100_lancamento_pedido');
        else ScreenService.openWindow('ped_pedidos#ped00300_aprovacao');
    };
    
    this.toggleCloseSwipe = function(widget) {
        widget.actions[0].isVisible = false;
        widget.actions[1].isVisible = true;
    };
    
    this.closeSwipe = function(widget) {
        ScreenService.closeSwipe();
        widget.actions[0].isVisible = true;
        widget.actions[1].isVisible = false;
    };
    
    this.searchData = function(widget) {
        ZHPromise.all().then(function(){
            var filtro;
            var i;
            var promisses = [];
            var activeWidget = templateManager.container.getActiveWidget();
            if (activeWidget.name == 'posicaoFinanceira' && this.initialized|| activeWidget.name == 'PosicaoFinanceira'  && 
                this.initialized|| activeWidget.name == 'widgetPosicao' && this.initialized) {
                if (widget.name == undefined && widget.widgets == undefined) {
                    widget = widget.owner.field.widget;
                } else if (widget.name == "PosicaoFinanceira") { 
                    widget = widget.getParent().getParent();
                }
                if(widget.widgets[0].currentRow.DTPREVIVENDA == undefined || widget.widgets[0].currentRow.DTPREVIVENDA.start == null) {
                    widget.widgets[0].currentRow.DTINI = null;
                    widget.widgets[0].currentRow.DTFIM = null;
                    widget.widgets[0].currentRow.TDATA = 'T';
                } else {
                    widget.widgets[0].currentRow.DTINI =  widget.widgets[0].currentRow.DTPREVIVENDA.start;
                    widget.widgets[0].currentRow.DTFIM =  widget.widgets[0].currentRow.DTPREVIVENDA.end;
                    widget.widgets[0].currentRow.TDATA = null;
                }
                
                for(i=0; i<widget.widgets[0].widgets[0].fields.length; i++) {
                    widget.widgets[0].widgets[0].fields[i].clearValue();
                }
                filtro = [];
                filtro[0] = widget.currentRow;
                filtro[1] = widget.widgets[0].currentRow;
                
                Ped00301_posicaoFinanceiraCliente_Service.getPosicaoFinanceira(filtro).then(function(response) {
                    var posFis = response.dataset.posicaoFinanceira;
                    var row = widget.widgets[0].widgets[0].currentRow;
                    
                    if (posFis.PRIMDATA) row.PRIMDATA = posFis.PRIMDATA.substr(0,10);
                    if (posFis.PRIMCOMPRA) row.PRIMCOMPRA = posFis.PRIMCOMPRA;
                    if (posFis.ULTDATA) row.ULTDATA = posFis.ULTDATA.substr(0,10);
                    if (posFis.ULTCOMPRA) row.ULTCOMPRA = posFis.ULTCOMPRA;
                    if (posFis.TOTALCOMPRA) row.TOTALCOMPRA = posFis.TOTALCOMPRA; else row.TOTALCOMPRA = "0";
                   
                    if (posFis.TOTCOMPAG) row.TOTCOMPAG = posFis.TOTCOMPAG; else row.TOTCOMPAG = "0";
                    if (posFis.TOTATR) row.TOTATR = posFis.TOTATR; else row.TOTATR = "0";
                    if (posFis.TOTVENC) row.TOTVENC = posFis.TOTVENC; else row.TOTVENC = "0";
                    if (posFis.TOTAVENC) row.TOTAVENC = posFis.TOTAVENC; else row.TOTAVENC = "0";
                    
                    if (posFis.MAIORDATA) row.MAIORDATA = posFis.MAIORDATA.substr(0,10);
                    if (posFis.MAIORVALOR) row.MAIORVALOR = posFis.MAIORVALOR; else row.MAIORVALOR = "0";
                    
                    if (posFis.NRDIASATRASO) row.NRDIASATRASO = posFis.NRDIASATRASO; else row.NRDIASATRASO = "0";
                    if (posFis.VRMATR) row.VRMATR = posFis.VRMATR; else row.VRMATR = "0";
                    
                    if (posFis.DTATRAB) row.DTATRAB = posFis.DTATRAB; else row.DTATRAB = "0";
                    if (posFis.VRATRAB)  row.VRATRAB = posFis.VRATRAB; else row.VRATRAB = "0";
                }.bind(this));   
            }
            if(activeWidget.name == 'ContasAbertas') {
                if(widget.name != 'widgetPosicao') {
                    if(widget.name == 'ContasAbertas') widget = widget.getParent().getParent();
                    else if (widget.name == 'ContasHolder') widget = widget.getParent();
                    else if (widget.owner.field.name == 'NMRAZSOCCLIE') widget = widget.owner.field.widget;
                }
                // if(this.filialLogada == '') {
                // }
                promisses.push(Ped00301_posicaoFinanceiraCliente_Service.getFilialLogada());
                if(widget.widgets[1].currentRow.DTPREVIVENDA == undefined || widget.widgets[1].currentRow.DTPREVIVENDA.start == null) {
                    widget.widgets[1].currentRow.DTINI = null;
                    widget.widgets[1].currentRow.DTFIM = null;
                    widget.widgets[1].currentRow.TDATA = 'T';
                } else {
                    widget.widgets[1].currentRow.DTINI =  widget.widgets[1].currentRow.DTPREVIVENDA.start;
                    widget.widgets[1].currentRow.DTFIM =  widget.widgets[1].currentRow.DTPREVIVENDA.end;
                    widget.widgets[1].currentRow.TDATA = null;
                }
                filtro = [];
                filtro[0] = widget.currentRow;
                
                ZHPromise.all(promisses).then(function(callback) {
                    if(callback[0]) {
                        this.filialLogada = callback[0][0];
                    }
                    if(widget.widgets[1].currentRow.NMFILIAL == undefined) {
                        widget.widgets[1].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[1].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    } else {
                        this.filialLogada = {
                            "CDFILIAL": widget.widgets[1].currentRow.CDFILIAL ? widget.widgets[1].currentRow.CDFILIAL : this.filialLogada.CDFILIAL, 
                            "NMFILIAL": widget.widgets[1].currentRow.NMFILIAL ? widget.widgets[1].currentRow.NMFILIAL : this.filialLogada.NMFILIAL 
                        };
                        widget.widgets[3].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[3].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    }
                    filtro[1] = widget.widgets[1].currentRow;
                    filtro[1].CDFILIAL = this.filialLogada.CDFILIAL;
                    filtro[1].NMFILIAL = this.filialLogada.NMFILIAL;
                    Ped00301_posicaoFinanceiraCliente_Service.getContasAbertas(filtro).then(function(response) {
                        if(response.dataset.contasAbertas) {
                            widget.widgets[1].widgets[0].dataSource.data = [];
                            for(var i=0; i<response.dataset.contasAbertas.length; i++) {
                                var result = response.dataset.contasAbertas[i];
                                var row = {
                                    "NRNOTAFISC": result.NRNOTAFISC,
                                    "DTEMISSAO": result.DTEMISSAO.substr(0,10),
                                    "DTATUAVENREC": result.DTATUAVENREC.substr(0,10),
                                    "VRORIGREC": result.VRORIGREC,
                                    "CDCARTCOBBOL": result.CDCARTCOBBOL,
                                    "NRDIASATRASO": result.NRDIASATRASO,
                                    "NMFANVEN": result.NMFANVEN,
                                    "NRLANBOLREC": result.NRLANBOLREC,
                                    "VRATUAREC": result.VRATUAREC
                                };
                                widget.widgets[1].widgets[0].dataSource.data.push(row);
                            }
                        }
                    }.bind(this));
                }.bind(this));
            }
            if(activeWidget.name == 'TipoDeRecAberto') {
                if(widget.name == 'TipoDeRecAberto') widget = widget.getParent();
                widget.widgets[0].dataSource.data = [];
                filtro = [];
                filtro[0] = widget.currentRow;
                filtro[1] = widget.getParent().currentRow;
                Ped00301_posicaoFinanceiraCliente_Service.getTipoRecAbertas(filtro).then(function(response) {
                    if(response.dataset.tipoRecAbertas) {
                        for(var i=0; i<response.dataset.tipoRecAbertas.length; i++) {
                            var result = response.dataset.tipoRecAbertas[i];
                            var row = {
                                "NMTIPORECE": result.NMTIPORECE,
                                "VRTPRECBOLR": result.VRTPRECBOLR,
                                "CDCONTCORR": result.CDCONTCORR,
                                "NMTPBAIXAREC": result.NMTPBAIXAREC,
                                "NRCHEQBOLREC": result.NRCHEQBOLREC,
                                "DTCHEQBOLREC": result.DTCHEQBOLREC,
                                "NRCARCREBOLR": result.NRCARCREBOLR,
                                "NMCARTAO": result.NMCARTAO
                            };
                            widget.widgets[0].dataSource.data.push(row);
                        }
                    }
                }.bind(this));
            }
            if(activeWidget.name == 'ContasFechadas') {
                if(widget.name != 'widgetPosicao') {
                    if(widget.name == 'ContasFechadas') widget = widget.getParent().getParent();
                    else if (widget.name == 'ContasHolder') widget = widget.getParent();
                    else if (widget.owner.field.name == 'NMRAZSOCCLIE') widget = widget.owner.field.widget;
                }
                if(this.filialLogada == '') {
                    promisses.push(Ped00301_posicaoFinanceiraCliente_Service.getFilialLogada());
                }
                if(widget.widgets[1].currentRow.DTPREVIVENDA == undefined || widget.widgets[1].currentRow.DTPREVIVENDA.start == null) {
                    widget.widgets[1].currentRow.DTINI = null;
                    widget.widgets[1].currentRow.DTFIM = null;
                    widget.widgets[1].currentRow.TDATA = 'T';
                } else {
                    widget.widgets[1].currentRow.DTINI =  widget.widgets[1].currentRow.DTPREVIVENDA.start;
                    widget.widgets[1].currentRow.DTFIM =  widget.widgets[1].currentRow.DTPREVIVENDA.end;
                    widget.widgets[1].currentRow.TDATA = null;
                }
                filtro = [];
                filtro[0] = widget.currentRow;
                ZHPromise.all(promisses).then(function(callback) {
                    if(callback[0]) {
                        this.filialLogada = callback[0][0];
                    }
                    if(widget.widgets[1].currentRow.NMFILIAL == undefined) {
                        widget.widgets[1].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[1].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    } else {
                        this.filialLogada = {
                            "CDFILIAL": widget.widgets[1].currentRow.CDFILIAL,
                            "NMFILIAL": widget.widgets[1].currentRow.NMFILIAL
                        };
                        widget.widgets[3].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[3].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    }
                    filtro[1] = widget.widgets[1].currentRow;
                    Ped00301_posicaoFinanceiraCliente_Service.getContasFechadas(filtro).then(function(response) {
                        if(response.dataset.contasFechadas) {
                            widget.widgets[1].widgets[1].dataSource.data = [];
                            for(var i=0; i<response.dataset.contasFechadas.length; i++) {
                                var result = response.dataset.contasFechadas[i];
                                var row = {
                                    "NRNOTAFISC": result.NRNOTAFISC,
                                    "DTEMISSAO": result.DTEMISSAO.substr(0,10),
                                    "DTATUAVENREC": result.DTATUAVENREC.substr(0,10),
                                    "VRORIGREC": result.VRORIGREC,
                                    "CDCARTCOBBOL": result.CDCARTCOBBOL,
                                    "NRDIASATRASO": result.NRDIASATRASO,
                                    "NMFANVEN": result.NMFANVEN,
                                    "NRLANBOLREC": result.NRLANBOLREC,
                                    "VRATUAREC": result.VRATUAREC
                                };
                                widget.widgets[1].widgets[1].dataSource.data.push(row);
                            }
                        }
                    }.bind(this));
                }.bind(this));
            }
            if(activeWidget.name == 'TipoDeRecFechado') {
                if(widget.name == 'TipoDeRecFechado') widget = widget.getParent();
                widget.widgets[0].dataSource.data = [];
                filtro = [];
                filtro[0] = widget.currentRow;
                filtro[1] = widget.getParent().currentRow;
                Ped00301_posicaoFinanceiraCliente_Service.getTipoRecFechadas(filtro).then(function(response) {
                    if(response.dataset.tipoRecAbertas) {
                        for(var i=0; i<response.dataset.tipoRecAbertas.length; i++) {
                            var result = response.dataset.tipoRecAbertas[i];
                            var row = {
                                "NMTIPORECE": result.NMTIPORECE,
                                "VRTPRECBAIXA": result.VRTPRECBAIXA,
                                "CDCONTCORR": result.CDCONTCORR,
                                "NMTPBAIXAREC": result.NMTPBAIXAREC,
                                "NRCHEQBAIREC": result.NRCHEQBAIREC,
                                "DTCHEQBAIREC": result.DTCHEQBAIREC,
                                "NRCARCREBREC": result.NRCARCREBREC,
                                "NMCARTAO": result.NMCARTAO
                            };
                            widget.widgets[0].dataSource.data.push(row);
                        }
                    }
                }.bind(this));
            }
            if(activeWidget.name == 'Endereco') {
                if(widget.name != 'widgetPosicao') {
                    if(widget.name == 'Endereco') widget = widget.getParent().getParent();
                    else if(widget.owner.field.name == 'NMRAZSOCCLIE') widget = widget.owner.field.widget;
                    else if(widget.owner.field.name == 'TPENDERECO') widget = widget.owner.field.widget.getParent();
                }
                if(widget.widgets[2].currentRow.TPENDERECO == undefined) {
                    widget.widgets[2].currentRow = {
                        "CDENDERECO": "P",
                        "TPENDERECO": "P"
                    };
                }
                filtro = [];
                filtro[0] = widget.currentRow;
                filtro[1] = widget.widgets[2].currentRow;
                
                for(i=0; i<widget.widgets[2].widgets[0].fields.length; i++) {
                    widget.widgets[2].widgets[0].fields[i].clearValue();
                }
                
                Ped00301_posicaoFinanceiraCliente_Service.getEndereco(filtro).then(function(response) {
                    var endereco = response.dataset.endereco[0];
                    if(endereco) {
                        widget.widgets[2].widgets[0].currentRow.DSENDECLIE = endereco.DSENDECLIE;
                        widget.widgets[2].widgets[0].currentRow.NMBAIRCLIE = endereco.NMBAIRCLIE;
                        widget.widgets[2].widgets[0].currentRow.NRCEPCLIE = endereco.NRCEPCLIE;
                        widget.widgets[2].widgets[0].currentRow.NMPAIS = endereco.NMPAIS;
                        widget.widgets[2].widgets[0].currentRow.SGESTADO = endereco.SGESTADO;
                        widget.widgets[2].widgets[0].currentRow.NMMUNICIPIO = endereco.NMMUNICIPIO;
                        
                        widget.widgets[2].widgets[0].currentRow.NRTELECLIE = endereco.NRTELECLIE;
                        widget.widgets[2].widgets[0].currentRow.NRRAMALCLIE = endereco.NRRAMALCLIE;
                        widget.widgets[2].widgets[0].currentRow.NMCONTCLIE = endereco.NMCONTCLIE;
                        widget.widgets[2].widgets[0].currentRow.NRTELECLIE1 = endereco.NRTELECLIE1;
                        widget.widgets[2].widgets[0].currentRow.NRRAMALCLIE1 = endereco.NRRAMALCLIE1;
                        widget.widgets[2].widgets[0].currentRow.DSEMAILCLIE = endereco.DSEMAILCLIE;
                        widget.widgets[2].widgets[0].currentRow.NRCELULARCLI = endereco.NRCELULARCLI;
                        widget.widgets[2].widgets[0].currentRow.NRTELRESICLI = endereco.NRTELRESICLI;
                        widget.widgets[2].widgets[0].currentRow.NRFAXCLIE = endereco.NRFAXCLIE;   
                    }
                }.bind(this));
            }
            if(activeWidget.name == 'Historico') {
                if(widget.name != 'widgetPosicao') {
                    if(widget.name == 'Historico') widget = widget.getParent().getParent();
                    else if (widget.name == 'HistoricoHolder') widget = widget.getParent();    
                    else if (widget.owner.field.name == 'NMRAZSOCCLIE') widget = widget.owner.field.widget;
                }
                if(this.filialLogada == '') {
                    promisses.push(Ped00301_posicaoFinanceiraCliente_Service.getFilialLogada());
                }
                if(widget.widgets[3].currentRow.DTPREVIVENDA == undefined || widget.widgets[3].currentRow.DTPREVIVENDA.start == null) {
                    widget.widgets[3].currentRow.DTINI = null;
                    widget.widgets[3].currentRow.DTFIM = null;
                    widget.widgets[3].currentRow.TDATA = 'T';
                } else {
                    widget.widgets[3].currentRow.DTINI =  widget.widgets[3].currentRow.DTPREVIVENDA.start;
                    widget.widgets[3].currentRow.DTFIM =  widget.widgets[3].currentRow.DTPREVIVENDA.end;
                    widget.widgets[3].currentRow.TDATA = null;
                }
                ZHPromise.all(promisses).then(function(callback) {
                    if(callback[0]) {
                        this.filialLogada = callback[0][0];
                    }
                    if(widget.widgets[3].currentRow.NMFILIAL == undefined) {
                        widget.widgets[3].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[3].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    } else {
                        this.filialLogada = {
                            "CDFILIAL": widget.widgets[3].currentRow.CDFILIAL,
                            "NMFILIAL": widget.widgets[3].currentRow.NMFILIAL
                        };
                        widget.widgets[1].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[1].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    }
                    var filtro = [];
                    filtro[0] = widget.currentRow;
                    filtro[1] = widget.widgets[3].currentRow;
                    Ped00301_posicaoFinanceiraCliente_Service.getHistorico(filtro).then(function(response) {
                        if(response.dataset.historico) {
                            widget.widgets[3].widgets[0].dataSource.data = [];
                            var vrTotal = 0;
                            var vrTotalLiq = 0;
                            for(var i=0; i<response.dataset.historico.length; i++) {
                                var result = response.dataset.historico[i];
                                vrTotal += result.VRTOTALPED;
                                vrTotalLiq += result.VRTOTPEDLIQ;
                                var row = {
                                    "NRPEDIDO": result.NRPEDIDO,
                                    "DTENTREGA": result.DTENTPED.substr(0,10),
                                    "NMFANVEN": result.NMFANVEN,
                                    "NMTIPOOPER": result.NMTIPOOPER,
                                    "DSMODPGTO": result.DSMODPGTO,
                                    "VRTOTPEDLIQ": result.VRTOTPEDLIQ,
                                    "VRTOTALPED": result.VRTOTALPED
                                };
                                widget.widgets[3].widgets[0].dataSource.data.push(row);
                            }
                            widget.widgets[3].currentRow.TOTALVRBRUTO = vrTotal;
                            widget.widgets[3].currentRow.TOTALVRLIQUIDO = vrTotalLiq;
                        }
                    }.bind(this));
                }.bind(this));
            }
            if(activeWidget.name == 'HistContas') {
                if(widget.name != 'widgetPosicao') {
                    if(widget.name == 'HistContas') widget = widget.getParent().getParent();
                    else if (widget.name == 'HistoricoHolder') widget = widget.getParent();    
                    else if (widget.owner.field.name == 'NMRAZSOCCLIE') widget = widget.owner.field.widget;
                }
                if(this.filialLogada == '') {
                    promisses.push(Ped00301_posicaoFinanceiraCliente_Service.getFilialLogada());
                }
                if(widget.widgets[3].currentRow.DTPREVIVENDA == undefined || widget.widgets[3].currentRow.DTPREVIVENDA.start == null) {
                    widget.widgets[3].currentRow.DTINI = null;
                    widget.widgets[3].currentRow.DTFIM = null;
                    widget.widgets[3].currentRow.TDATA = 'T';
                } else {
                    widget.widgets[3].currentRow.DTINI =  widget.widgets[3].currentRow.DTPREVIVENDA.start;
                    widget.widgets[3].currentRow.DTFIM =  widget.widgets[3].currentRow.DTPREVIVENDA.end;
                    widget.widgets[3].currentRow.TDATA = null;
                }
                ZHPromise.all(promisses).then(function(callback) {
                    if(callback[0]) {
                        this.filialLogada = callback[0][0];
                    }
                    if(widget.widgets[3].currentRow.NMFILIAL == undefined) {
                        widget.widgets[3].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[3].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    } else {
                        this.filialLogada = {
                            "CDFILIAL": widget.widgets[3].currentRow.CDFILIAL,
                            "NMFILIAL": widget.widgets[3].currentRow.NMFILIAL
                        };
                        widget.widgets[1].currentRow.CDFILIAL = this.filialLogada.CDFILIAL;
                        widget.widgets[1].currentRow.NMFILIAL = this.filialLogada.NMFILIAL;
                    }
                    var filtro = [];
                    filtro[0] = widget.currentRow;
                    filtro[1] = widget.widgets[3].currentRow;
                    Ped00301_posicaoFinanceiraCliente_Service.getHistContas(filtro).then(function(response) {
                        if(response.dataset.historicoContas) {
                            widget.widgets[3].widgets[1].dataSource.data = [];
                            for(var i=0; i<response.dataset.historicoContas.length; i++) {
                                var result = response.dataset.historicoContas[i];
                                var row = {
                                    "DSCDFISOPENF": result.DSCDFISOPENF,
                                    "NRNOTAFISC": result.NRNOTAFISC,
                                    "DTEMISSAO": result.DTEMISSAO.substr(0,10),
                                    "NMRAZSOCTRAN": result.NMRAZSOCTRAN,
                                    "DTENTRSAID": result.DTENTRSAID.substr(0,10),
                                    "DTATUAVENREC": result.DTATUAVENREC.substr(0,10),
                                    "VRORIGREC": result.VRORIGREC,
                                    "VRATUAREC": result.VRATUAREC,
                                    "DTATRASO": result.DTATRASO,
                                    "IDSTATREC": result.IDSTATREC
                                };
                                widget.widgets[3].widgets[1].dataSource.data.push(row);
                            }
                        }
                    }.bind(this));
                }.bind(this));
            }
        }.bind(this));
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00301_posicaoFinanceiraCliente_Controller', Ped00301_posicaoFinanceiraCliente_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped01900_peso_do_produto_Controller.js
function Ped01900_peso_do_produto_Controller(templateManager, ScreenService, General, Ped02300PrecoBaseServices, restEngine, ZhFilterPreferences, ZHPromise) {
    
    this.startFiltering = function(widgetPedidos){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };

    this.carregaFornecedWidget = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('forncedorWidget');
        
        if(row.NMFANTFORN){

            widget.dataSourceFilter.push(
                {
                    name: "P_CDFORNECED",
                    operator: "=",
                    value: row.CDFORNECED
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_TODOS",
                    operator: "=",
                    value: "T"
                }
            );
            
            widget.actions[0].isVisible = true;
            
        } else if(row.NMFANTFORN == ""){
            widget.dataSourceFilter = [];
            widget.actions[0].isVisible = false;
        }
        
        widget.reload();
    };
    
    this.validaProdIni = function(){
        var widget = templateManager.container.getActiveWidget('preodutoWidget');
        if(widget.currentRow.CDARVPRODFIN && widget.currentRow.CDARVPRODINI >= widget.currentRow.CDARVPRODFIN){
            ScreenService.showMessage("O codigo do produto final deve ser maior que o inicial");
                widget.currentRow.CDARVPRODFIN = "";
                widget.currentRow.CDPRODUTOFIN = "";
                widget.currentRow.NMPRODUTOFIN = "";
        }
    };
    
    
    
    this.validaProdFin = function(){
        var widget = templateManager.container.getActiveWidget('preodutoWidget');
        if(widget.currentRow.CDARVPRODINI && widget.currentRow.CDARVPRODFIN){
            if(widget.currentRow.CDARVPRODINI >= widget.currentRow.CDARVPRODFIN){
                ScreenService.showMessage("O codigo do produto final deve ser maior que o inicial");
                widget.currentRow.CDARVPRODFIN = "";
                widget.currentRow.CDPRODUTOFIN = "";
                widget.currentRow.NMPRODUTOFIN = "";
            } 
        }else if(widget.currentRow.CDARVPRODFIN){
                ScreenService.showMessage("Selecione o produto inicial antes do final!");
                widget.currentRow.CDARVPRODFIN = "";
                widget.currentRow.CDPRODUTOFIN = "";
                widget.currentRow.NMPRODUTOFIN = "";
        }
    };
   
    this.filterPrevisao = function(){
        var widget = templateManager.container.getWidget('preodutoWidget');
        
        if(widget.appliedFilter.FILTER_ROW.CDARVPRODINI && widget.appliedFilter.FILTER_ROW.CDARVPRODFIN){
            widget.dataSourceFilter[0].name = "P_PRODINI";
            widget.dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDARVPRODINI;
            widget.dataSourceFilter[1].name = "P_PRODFIN";
            widget.dataSourceFilter[1].value = widget.appliedFilter.FILTER_ROW.CDARVPRODFIN;
            if (widget.dataSourceFilter[2].value == "T"){
                 widget.dataSourceFilter[2].value = "";
            }
             widget.reload();
        } else if(!(widget.appliedFilter.FILTER_ROW.CDARVPRODFIN) && !(widget.appliedFilter.FILTER_ROW.CDARVPRODINI)){
            widget.dataSourceFilter[2].name = "P_TODOS";
            widget.dataSourceFilter[2].value = "T";
            widget.reload();
        } else {
            ScreenService.showMessage("Preencha os 2 campos corretamente ou deixe os dois vazios para filtrar todos os produtos!");
            widget.dataSourceFilter[1].value = "";
            widget.dataSourceFilter[0].value = "";
            widget.dataSourceFilter[2].value = "";
            widget.reload();
        }
    };
    
    this.saveForProdPesagem = function(widget){
        widget.currentRow.CDFORNECED = widget.parent.currentRow.CDFORNECED;
        General.saveCrud(widget);
    };
    
    this.deletePesoProduto = function(widget){
        widget.currentRow.QTPROPVOLUME = null;
        widget.currentRow.VRTARA = null;
        widget.currentRow.QTVOLUMES = null;
        widget.currentRow.VRPESOBRUTPR = null;
        widget.currentRow.VRPESOLIQUPR = null;
        General.saveCrud(widget).then(function (sucess) {
            ScreenService.showMessage("Informações do peso deletadas com sucesso");
        });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped01900_peso_do_produto_Controller', Ped01900_peso_do_produto_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped02100_modalidadePagamento_Controller.js
var Ped02100_modalidadePagamento_Controller = function(General, templateManager, ScreenService) {
    
    this.validaCamposAtivos = function(){
        
        var widget = templateManager.container.getWidget('widgetModalidadePagamentoForm');

        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
            
        var idtpforpgtomod = widget.currentRow.IDTPFORPGTOMOD;
            
            switch (idtpforpgtomod) {
                case 'X':
                    widget.getField('NRDIAPGFIXMOD').readOnly = true;
                    widget.getField('NRPARCPGTOMOD').readOnly = true;
                    widget.getField('IDUTDIAPAGMOD').readOnly = true;
                    widget.getField('NMFORMPGTO').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 0;
                    widget.currentRow.NRPARCPGTOMOD = 0;
                    widget.currentRow.IDUTDIAPAGMOD = "I";
                    widget.currentRow.NMFORMPGTO = "";
                    widgetPrazo.isVisible = false;
                    widget.getAction('novoPrazo').isVisible = false;
                    if(widget.getField('NMFORMPGTO').validations){
                        delete(widget.getField('NMFORMPGTO').validations);
                    }
                    break;
                case 'F':
                    widget.getField('NRDIAPGFIXMOD').readOnly = false;
                    widget.getField('NRPARCPGTOMOD').readOnly = false;
                    widget.getField('IDUTDIAPAGMOD').readOnly = false;
                    widget.getField('NMFORMPGTO').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 1;
                    widget.currentRow.NRPARCPGTOMOD = 1;
                    widget.currentRow.NMFORMPGTO = "";
                    widgetPrazo.isVisible = false;
                    widget.getAction('novoPrazo').isVisible = false;
                    if(widget.getField('NMFORMPGTO').validations){
                        delete(widget.getField('NMFORMPGTO').validations);
                    }
                    break;
                case 'V':
                    widget.getField('NRDIAPGFIXMOD').readOnly = true;
                    widget.getField('NRPARCPGTOMOD').readOnly = true;
                    widget.getField('IDUTDIAPAGMOD').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 0;
                    widget.currentRow.NRPARCPGTOMOD = 0;
                    widget.currentRow.IDUTDIAPAGMOD = "I";
                    widget.getAction('novoPrazo').isVisible = true;
                    widget.getField('NMFORMPGTO').readOnly = false;
                    widget.getField('NMFORMPGTO').validations = {required: true};
                    widgetPrazo.isVisible = true;
                    this.consultaPrazo(widgetModPrincipal,widget,widgetPrazo);
                    this.editPrazo();
                    widget.activate();
                    break;
                default:
            }
            
            templateManager.updateTemplate();
        

    };
    
    this.editPrazo = function() {

        var widgetModForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');

        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');

        var idtpforpgtomod = widgetModForm.currentRow.IDTPFORPGTOMOD;

        if(widgetModForm.mode == "edit" && idtpforpgtomod == 'V') {

            widgetPrazo.fields[1].inlineEditable = true;
            
            widgetPrazo.fields[2].inlineEditable = true;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = true;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
                
        } else if(idtpforpgtomod != 'V') {

            widgetPrazo.fields[1].inlineEditable = false;
            
            widgetPrazo.fields[2].inlineEditable = false;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
        
        }

    };
    
    this.validaValorMax = function(args){
        if(args.row.VRPEDESMODPG >= 100){
            ScreenService.showMessage("Percentual de Desconto deve estar entre 0,01 e 99,99%.");
            args.row.VRPEDESMODPG = "";
        }
    };
    
    this.validaDataMax = function(args){
        if((args.row.NRDIAPGFIXMOD > 31) || (args.row.NRDIAPGFIXMOD < 1)){
            ScreenService.showMessage("Dia deve estrar entre 1 e 31.");
            args.row.NRDIAPGFIXMOD = "";
        }
    };
    
    this.validaParcelaMax = function(args){
        if((args.row.NRPARCPGTOMOD > 99) || (args.row.NRPARCPGTOMOD < 1)){
            ScreenService.showMessage("Quantidade de parcelas deve estar entre 1 e 99.");
            args.row.NRPARCPGTOMOD = "";
        }
    };
    
    this.saveModalidade = function(){
        
        var sucesso = false;
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
        var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
        var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
        var id = widgetModForm.currentRow.IDTPFORPGTOMOD;
        var porcentagem = 0;
        
        if(id == 'X'){
            widgetModForm.currentRow.IDTPFORPGTOMOD = "";
        }
        
        if(id == 'V') {
        
            var dados = widgetPrazo.dataSource.data;
            
            dados.map(function(prazo){
               
               porcentagem += parseFloat(prazo.VRPERCMODPGTO);
                
            }.bind(this));
            
        }
        
        if(porcentagem == 100 && id == 'V') {
        
            sucesso = true;
        
            var dataSet = [];
        
            dataSet[0] = [widgetModForm.currentRow];
            
            dataSet[1] = [];
            
            widgetPrazo.dataSource.data.forEach(function(e){
                
                e.CDMODPGTO = dataSet[0][0].CDMODPGTO;
                
                dataSet[1].push(Util.clone(e, ['__leftActions', '__rightActions']));
                
            }.bind(this));
        
            General.callRestEngine('ped_pedidos#/saveModalidade', 'DataSet', dataSet).then(function(sucess){
                
                ScreenService.showMessage('Modalidade Salva').then(function(){
                   this.sucessoFunction(); 
                }.bind(this));
                
            }.bind(this),function(fail){
                
                ScreenService.showMessage(fail.error);
                
            }.bind(this));
            
        } else if(id == 'V' && porcentagem !== 100) {
            
            sucesso = false;
            
            ScreenService.showMessage('Percentual dos Prazos esta diferente de 100%');
            
        } else if(id !== 'V') {
           
            sucesso = true;
            
            General.saveCrud(widgetModForm).then(function(){
               
                if((id !== 'F') && (id !== 'V')){
                    widgetModForm.currentRow.IDTPFORPGTOMOD = 'X';
                }
                
                ScreenService.showMessage("Modalidade salva").then(function(){
                   this.sucessoFunction(); 
                }.bind(this));
            
            }.bind(this), function (error) {
               
                ScreenService.showMessage(error);
            
            }.bind(this));
        
        }
        
        /*if(sucesso) {
            
            General.widgetCancelForm(widgetModForm);
            
            widgetModForm.activate();
            
            templateManager.updateTemplate();
            
            widgetPrazo.fields[1].inlineEditable = false;
            
            widgetPrazo.fields[2].inlineEditable = false;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            
            this.resetWidget(widgetPrazo);
            
            widgetModPrincipal.activate();
            
            templateManager.updateTemplate();
            
            ScreenService.goBack();
            
            widgetModPrincipal.reload();
            
            sucesso = false;
            
        }*/

    };
    
    this.sucessoFunction = function(){
            var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
            var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
            var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
           
            General.widgetCancelForm(widgetModForm);
            widgetModForm.activate();
            templateManager.updateTemplate();
            widgetPrazo.fields[1].inlineEditable = false;
            widgetPrazo.fields[2].inlineEditable = false;
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            this.resetWidget(widgetPrazo);
            widgetModPrincipal.activate();
            templateManager.updateTemplate();
            ScreenService.goBack();
            widgetModPrincipal.reload();
            
    };
    
    this.removerModalidade = function() {
      
      var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
      var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
      var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
      
       var dataSet = [];
        
            dataSet[0] = [widgetModForm.currentRow];
            
            dataSet[1] = [];
            
            widgetPrazo.dataSource.data.forEach(function(e){
                
                e.CDMODPGTO = dataSet[0][0].CDMODPGTO;
                
                dataSet[1].push(Util.clone(e, ['__leftActions', '__rightActions']));
                
            }.bind(this));
        
            General.callRestEngine('ped_pedidos#/deletaModalidade', 'DataSet', dataSet).then(function(sucess){
                
                ScreenService.showMessage('Modalidade Removida').then(function(){
                    widgetModPrincipal.reload();
                });
                
            }.bind(this),function(fail){
                
                ScreenService.showMessage(fail.error);
                
            }.bind(this));
            
       ScreenService.goBack();
        
    };
    
    this.editForm = function() {
        
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
        
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
        
        General.widgetEdit(widgetModadalidadeForm);
        
        var idtpforpgtomod = widgetModadalidadeForm.currentRow.IDTPFORPGTOMOD;
        
        if(widgetPrazo.isVisible && idtpforpgtomod == 'V') {
            
            widgetPrazo.fields[1].inlineEditable = true;
            
            widgetPrazo.fields[2].inlineEditable = true;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = true;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
            
        }
        
        widgetModalidadeDash.activate();
        
        templateManager.updateTemplate();
        
        widgetModadalidadeForm.activate();
        
        templateManager.updateTemplate();
    
    };
    
    this.resetWidget = function(widget) {
        
        widget.isVisible = false;
            
        widget.reload().then(function(){
            
            widget.isVisible = true;
    
            templateManager.updateTemplate();
        }.bind(this));
        
    };
    
    this.adicionaPrazo = function() {
      
       var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
       
       widgetPrazo.newRow();
        
    };
    
    
    this.deletaPrazo = function(row){
        
        var widget = templateManager.container.getWidget('widgetModPrazoPed');
        
        ScreenService.showCustomDialog('Deseja excluir o prazo?', 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
            code: function(){
               
               if(row.__is_new){
                   
                   widget.dataSource.data.splice(widget.dataSource.data.indexOf(row), 1);
                   
               } else {
                   
                   var dataRow = Util.clone(row, ['__leftActions', '__rightActions']);
                   
                   General.callRestEngine('ped_pedidos#/deletaPrazoModalidade', 'Row', dataRow).then(function(sucess){
                       
                        ScreenService.showMessage('Prazo Deletado');
                        
                        widget.dataSource.data.splice(widget.dataSource.data.indexOf(row), 1);
                       
                   }.bind(this), function(fail){
                       
                       ScreenService.showMessage(fail);
                       
                   }.bind(this));
                   
               }
                    
                
            }.bind(this)
        },{
            label: ScreenService.i18n("Não"),
            code: function(){}.bind(this)
        }]);
        
    };
    
    this.cancelEditForm = function() {
      
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
        
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
         
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
        
        General.widgetCancelForm(widgetModadalidadeForm);
            
        widgetPrazo.fields[1].inlineEditable = false;
        
        widgetPrazo.fields[2].inlineEditable = false;
        
        widgetPrazo.getAction('excluirPrazo').isVisible = false;
        
        this.resetWidget(widgetPrazo);
        
        widgetModalidadeDash.activate();
        
        templateManager.updateTemplate();
        
        widgetModadalidadeForm.activate();
        
        templateManager.updateTemplate();
        
        if(widgetModadalidadeForm.currentRow.__is_new) {
            
            ScreenService.goBack();
            
            widgetModPrincipal.activate();
        
            templateManager.updateTemplate();
            
        }
        
    };
    
    this.focaModForm = function() {
        
         var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
         
         widgetModadalidadeForm.activate();
        
    };
    
    this.abrirModalidadeForm = function() {
     
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
     
        var widgetTabbedModPag = templateManager.container.getWidget("tabbedModPag");
      
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
            ScreenService.openSwipe(widgetTabbedModPag).then(function() {
          
                widgetModadalidadeForm.currentRow = widgetModPrincipal.currentRow;
                
                this.validaCamposAtivos();
                  
                widgetModadalidadeForm.view();
                  
                widgetModalidadeDash.activate();
                   
                widgetModadalidadeForm.activate();
                
                widgetPrazo.activate();
                
                widgetModadalidadeForm.activate();
                   
                templateManager.updateTemplate();
           
      }.bind(this));
        
    };
    
    this.consultaPrazo = function(widgetPrincipal, widgetForm ,widgetPrazo) {
        
        widgetPrazo.dataSourceFilter[0].name = 'CDMODPGTO';
        widgetPrazo.dataSourceFilter[0].operator = '=';
        widgetPrazo.dataSourceFilter[0].value = widgetPrincipal.currentRow.CDMODPGTO;
        
        widgetPrazo.activate();
        
        this.resetWidget(widgetPrazo);
        
        widgetForm.activate();
        
    };
    
    this.adicionarModalidade = function(){
      
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
      
        var widgetTabbedModPag = templateManager.container.getWidget("tabbedModPag");
        
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');

        widgetModPrincipal.currentRow = {};
        
        widgetPrazo.dataSource.data = [];
        
        widgetPrazo.isVisible = false;
            
        widgetPrazo.fields[1].inlineEditable = true;
            
        widgetPrazo.fields[2].inlineEditable = true;
            
        widgetPrazo.getAction('excluirPrazo').isVisible = true;
      
        ScreenService.openSwipe(widgetTabbedModPag).then(function(){
            
            General.widgetEdit(widgetModadalidadeForm);
            
            widgetModadalidadeForm.newRow();
        
            widgetModalidadeDash.activate();
            
            templateManager.updateTemplate();
            
            widgetModadalidadeForm.activate();
            
            templateManager.updateTemplate();
             
         }.bind(this));
    
            
    };
    
    this.fecharModalidadeForm = function(){
      
      var widgetModalidade = templateManager.container.getWidget('modalidadePagamento');
      
      var widgetForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
      widgetModalidade.activate = true;
      
      widgetForm.activate = false;
      
      widgetForm.habilitado = false;
      
      ScreenService.closeSwipe();
      
        
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02100_modalidadePagamento_Controller', Ped02100_modalidadePagamento_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped02200_parametroPreco_Controller.js
function Ped02200_parametroPreco_Controller(General, templateManager, ScreenService) {
    
    this.reload = function(){
        var widget = templateManager.container.getWidget('widgetParametrosPreco');
        widget.reload();
    };
    
    this.adicionar = function(){
        var widget = templateManager.container.getWidget('widgetParametrosPreco');
        var dados  = widget.dataSource.data;
        
        var nrseqpreuti = "0000000001";
        
        for(var i = 0; i < dados.length; i++){
            if(dados[i].NRSEQPREUTI > nrseqpreuti){
                nrseqpreuti = dados[i].NRSEQPREUTI;
            }
        }
        nrseqpreuti++;
        
        General.widgetNewRow(widget);
        widget.getField('NRSEQPREUTI').setValue(nrseqpreuti);
        widget.getField('CDEMPRESA').setValue('01');
        widget.reload();
    };
    
    this.salvar = function(){
        var widget = templateManager.container.getWidget('widgetParametrosPreco');
        var vrpeadpbase = parseFloat(widget.getField('VRPEADPBASE').value());
        
        if((vrpeadpbase > -100) && vrpeadpbase < 1000){
            var data   = widget.dataSource.data;
            var result = 0;
            
            for(var i = 0; i < data.length; i++){
                if((widget.currentRow.CDMODPGTO == data[i].CDMODPGTO) && (widget.currentRow.CDFILIAL == data[i].CDFILIAL)){
                    result++;
                }
            }
            
            if(widget.currentRow.__is_new == false){
                if(result == 1){
                        General.saveCrud(widget);
                }else if((result == 0) || (result > 1)){    
                    ScreenService.showMessage('Parâmetro de preço já cadastrado.');
                }    
            }else{
                if(result == 0){
                        General.saveCrud(widget);
                }else{
                    ScreenService.showMessage('Parâmetro de preço já cadastrado.');
                }
            }
        }else{
            ScreenService.showMessage('Acréscimo/Desconto(%) deve estar entre -99,99 e 999,99%');
        }
        
    };
    
    this.editar = function(){
        var widget = templateManager.container.getWidget('widgetParametrosPreco');
        widget.getField('CDMODPGTO').readOnly = true;
        widget.getField('CDFILIAL').readOnly = true;
        General.edit(widget);        
    };
    
    this.salvarCancelarEdit = function(){
        var widget = templateManager.container.getWidget('widgetParametrosPreco');
        widget.getField('CDMODPGTO').readOnly = false;
        widget.getField('CDFILIAL').readOnly = false;
        widget.reload();
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02200_parametroPreco_Controller', Ped02200_parametroPreco_Controller);
});



// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped02300_preco_base_Controller.js
function Ped02300_preco_base_Controller(templateManager, ScreenService, General, Ped02300PrecoBaseServices, restEngine, MessageService) {
    var checkedFields = [];
    var checkedFieldsReajuste = [];
    
    this.savePrecoBase = function(args){
        
        General.saveCrud(args.owner.widget).then(function(success){
            General.changeWidgetAcessibility(args.owner.widget.widgets,true);
        });
        
    };
    
    this.saveListaItemPreBase = function(widget){

        if(widget.currentRow.VRITEPREBASE == '0.00' || widget.currentRow.VRITEPREBASE == '0'){
            ScreenService.showMessage("O preço do produto deve ser diferente de 0.00"); 
        }else{
            Ped02300PrecoBaseServices.retornaOperadorLogado().then(function(operadorLogado){
                widget.currentRow.CDOPERATZIPB =  operadorLogado[0].CDOPERADOR;
                General.saveCrud(widget);
            });   
        }
        
        
    };
    
    this.setDataSourceFilterPromocao = function(widget){
        widget.dataSourceFilter = [
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().getParent().currentRow.CDPRECOBASE
            },
            {
                name: "P_DTINIVALIPB",
                operator: "=",
                value: widget.getParent().currentRow.DTINIVALIPB
            },
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.getParent().currentRow.CDPRODUTO
            }
        ];
        widget.reload();
    };
    
    this.getNrorg = function(){
        return templateManager.container.getWidget('promocao').currentRow.NRORG;
    };
    
    this.salvarPromoPrBase = function(widget){
        if(widget.isValid()){
            this.setPreco(widget);
            var dadosPromoPrBase;
            var row = widget.currentRow;
                if(widget.currentRow.__is_new){
                    Ped02300PrecoBaseServices.newCode(row).then(function(success){
                        dadosPromoPrBase = {
                            "__createdLocal": true,
                            "__index": 4,
                            "__isSelected": false,
                            "__is_new": true,
                            "__notSelectable": false,
                            "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                            "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                            "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                            "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                            "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                            "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                            "DTINIPROMO": widget.currentRow.DTINIPROMO,
                            "DTFINPROMO": widget.currentRow.DTFINPROMO,
                            "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                            "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                            "NRORG": this.getNrorg(),
                            "CDPROMOCAO": success.dataset.data[0]
                        };
                        Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                            ScreenService.closeSwipe();
                            widget.getField('VRPERBASEPROMO').readOnly = true;
                            widget.getField('VRTOTALPROMO').readOnly = false;
                            widget.reload();
                        }.bind(this), function (error) {
                            ScreenService.showMessage(error.error);
                        });  
                    }.bind(this), function(error){
                        ScreenService.showMessage(error);    
                    });
                } else {
                    dadosPromoPrBase = {
                        "__index": 2,
                        "__isSelected": false,
                        "__is_new": false,
                        "__notSelectable": false,
                        "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                        "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                        "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                        "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                        "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                        "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                        "DTINIPROMO": widget.currentRow.DTINIPROMO,
                        "DTFINPROMO": widget.currentRow.DTFINPROMO,
                        "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                        "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                        "NRORG": this.getNrorg(),
                        "CDPROMOCAO": widget.currentRow.CDPROMOCAO
                    };
                    Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                        ScreenService.closeSwipe();
                        widget.getField('VRPERBASEPROMO').readOnly = true;
                        widget.getField('VRTOTALPROMO').readOnly = false;
                        widget.reload();
                    }.bind(this), function (error) {
                        ScreenService.showMessage(error.error);
                    });    
                }
        }
    };
    
    this.editar = function(widget){
        
        if(widget.currentRow.VRITEPREBASE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDOPERATZIPB = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
            widget.currentRow.CDPRECOBASE = General.getFieldValue('CDPRECOBASE', 'precoBase');
        }
        General.edit(widget);
        
    };
    

    this.prodIni = function(widget){
        
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
    };
    
    this.prodFin = function(){
        var widget = templateManager.container.getWidget('itemPreBase');
        var row = widget.currentRow;
        var widgetLista = widget.container.getWidget('listaItemPreBase');
 
        widgetLista.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetLista.getParent().getParent().currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetLista.getParent().getParent().currentRow.CDPRECOBASE
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_CDPRODUTOINI > row.P_CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        if(row.IDPRODATIVPR== 'S' ||row.IDPRODATIVPR== 'N'){
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_IDPRODATIVPR",
                    operator: "=",
                    value: row.IDPRODATIVPR
                }
            );
        }else{
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_TIDPRODATIVPR",
                    operator: "=",
                    value: row.IDPRODATIVPR
                }
            );
        }
        if(row.DATAVIGENTE == 'P'){
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_DATAVIGENTE",
                    operator: "=",
                    value: moment().format('L')
                }
            );
        }else{
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_TDATAVIGENTE",
                    operator: "=",
                    value: "T"
                }
            );
        }
        widgetLista.reload();
    };
    
    this.setFieldValor = function(args){
        var row = args.owner.field.widget.currentRow;
        if(row.IDTIPOPROMO != "V"){
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = false;
        } else {
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = true;
        }
    };
    
    this.setSelects = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.IDPRODATIVPR = 'S';
        widget.getField('IDPRODATIVPR').setValue('S');
        widget.currentRow.DATAVIGENTE = 'P';
        widget.getField('DATAVIGENTE').setValue('P');
        widget.reload();
    };
    
    this.setPreco = function(widget){
        var porcentagem;
        var row = widget.currentRow;
        row.VRITEPREBASE = General.getFieldValue('VRITEPREBASE','listaItemPreBase');
        if(row.IDTIPOPROMO == "A"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE + porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        } 
        if(row.IDTIPOPROMO == "D"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE - porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        }
    };
    
    this.setView = function(widget){
        if(widget.container.getWidget('listaItemPreBase').getField('VRITEPREBASE').value() == undefined){
            General.changeWidgetAcessibility(widget.widgets,false);
        } else {
            General.changeWidgetAcessibility(widget.widgets,true);
        }
        switch (widget.getParent().getParent().currentRow.IDULTPRECPROMO) {
            case 'S':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            case 'N':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = true;
                break;
        }
        widget.reload();
    };
    
    this.prodIniFator = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFINFATOR').readOnly = !row.NMPRODINIFATOR;
        widget.getField('NMPRODFINFATOR').readOnlyOnEdit = !row.NMPRODINIFATOR;
        this.prodFinFator(widget);
    };
    
    this.prodFinFator = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('produtosFatorAjuste');
        widget.dataSourceFilter = [
            {
                name: "P_CDFATPRECO",
                operator: "=",
                value: General.getFieldValue('CDFATPRECO', 'fator')
            }
        ];
        if(row.NMPRODFINFATOR){
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.editarFator = function(widget){
        if(widget.currentRow.VRFATPRECO == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFATPRECO = General.getFieldValue('CDFATPRECO', 'fator');
        }
        General.edit(widget);
    };
    
    this.validaIntervalo = function(widget) {
        restEngine.post("/validaIntervalo",{'requestType': 'DataSet', 'dataset': [widget.currentRow]})
        .then(function (data) {
            widget.reload();
        }).
        catch(function(e){
            ScreenService.showMessage(e.data.error);
            widget.currentRow.QTCONVINIPRB = "";
            widget.currentRow.QTCONVFINPRB = "";
        });
    };
    
    this.validaValor = function(widget){
        if(widget.currentRow.VRPREBASECONV <= 0 || widget.currentRow.VRPREBASECONV == null){
            ScreenService.showMessage("O valor não pode ser menor ou igual a zero.");
        } else { 
            General.saveCrud(widget);
            widget.reload();
        }    
    };
    
    this.preparaExportacao = function(widget){
        checkedFields[0] = widget.getCheckedRows();
        
        var ItemNull = false;
        var ItemCount = 0;
        var ItemNameArray = [];
        var ItemNameString = "";
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFields[0].length; i++){
                if(checkedFields[0][i].CDPRECOBASE == null){
                    ItemNull = true;
                    ItemCount++;
                    ItemNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ItemNull) {
                
                ItemNameString = "'" + ItemNameArray[0] + "'";
                
                for (i = 1; i < ItemNameArray.length; i++) {
                    
                    if(i == ItemNameArray.length-1) {
                        ItemNameString += " e '" + ItemNameArray[i] + "'";
                    } else {
                        ItemNameString += ", '" + ItemNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemNameString + " não possui(em) preço(s).");
                var var_produtoNaoPossuiPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtoNaoPossuiPreco_msg,{"PRODUTO": ItemNameString});
                
                return 0;
                
            } else {
                var newWidget = templateManager.container.getWidget("exportItem_popup");
                newWidget.dataSourceFilter = [
                    {
                        "name": "CDPRECOBASE",
                        "operator": "<>",
                        "value": widget.getParent().getParent().currentRow.CDPRECOBASE
                    }
                ];
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                newWidget.reload();
                ScreenService.openPopup(newWidget);
            }
            
            
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();
      widget.isVisible = false;
    };
    
    this.exportPrecos = function(widget){
        checkedFields[1] = widget.getCheckedRows();
        
        restEngine.post("ped_pedidos#/exportarItem",{
            'requestType': 'DataSet', 
            'dataset': [checkedFields]
            
        }).then(function(success) {
            ScreenService.showMessage("Itens importados com sucesso.");
            ScreenService.closePopup();  
        }, function(callback){
            ScreenService.showMessage("Não foi possível exporta os itens selecionados.");
            ScreenService.closePopup();  
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.reajuste = function(widget){
        checkedFieldsReajuste[0] = widget.getCheckedRows();
        
        var ItemReajusteNull = false;
        var ItemReajusteCount = 0;
        var ItemReajusteNameArray = [];
        var ItemReajusteNameString = "";
        
        if(!checkedFieldsReajuste[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFieldsReajuste[0].length; i++){
                if(checkedFieldsReajuste[0][i].CDPRECOBASE == null){
                    ItemReajusteNull = true;
                    ItemReajusteCount++;
                    ItemReajusteNameArray.push(checkedFieldsReajuste[0][i].NMPRODUTO);
                }
            }
            
            if (ItemReajusteNull) {
                
                ItemReajusteNameString = "'" + ItemReajusteNameArray[0] + "'";
                
                for (i = 1; i < ItemReajusteNameArray.length; i++) {
                    
                    if(i == ItemReajusteNameArray.length-1) {
                        ItemReajusteNameString += " e '" + ItemReajusteNameArray[i] + "'";
                    } else {
                        ItemReajusteNameString += ", '" + ItemReajusteNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemReajusteNameString + " não possui(em) preço(s).");
                var var_naoPossuiPreco_msg = "NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_naoPossuiPreco_msg,{"ITEM": ItemReajusteNameString});
                return 0;
                
            } else {
                ScreenService.showMessage("As promoções desse item vão ser apagados após o reajuste");
                var newWidget = templateManager.container.getWidget("reajuste_popup");
                newWidget.isVisible = true;
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                ScreenService.openPopup(newWidget);
            }
            
        }
    };
    
    this.reajustePrecos = function(widget){
        
        if(widget.currentRow.IDTIPOREAJUSTE == null){
            ScreenService.showMessage("Selecione um tipo de reajuste.");
            return 0;
        }
        if(widget.currentRow.VRPERBASEPROMO <= 0){
            ScreenService.showMessage("O valor da porcentagem não pode ser menor ou igual a 0;");
            return 0;
        }
        
        checkedFieldsReajuste[1] = widget.currentRow.VRPERBASEPROMO;
        checkedFieldsReajuste[2] = widget.currentRow.DTFIMVALIPB;
        checkedFieldsReajuste[3] = widget.currentRow.IDTIPOREAJUSTE;
        
        
        
        restEngine.post("/reajusteItem",{'requestType': 'DataSet', 'dataset': [checkedFieldsReajuste]}).then(function() {
            ScreenService.showMessage("Itens reajustado com sucesso.");
            ScreenService.closePopup();
            widget.getParent().reload();
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.saveFatorPreco = function(widget){
        if(widget.currentRow.__is_new == true){    
            Ped02300PrecoBaseServices.saveFatorPreco(widget.currentRow).then(function(sucess){
                ScreenService.goBack();
                widget.reload();
            }, function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            General.saveCrud(widget);
        }
    };
    
    this.newRowDesc = function(widget){
        widget.newRow();
        widget.currentRow.CDPRECOBASE = widget.getParent().getParent().currentRow.CDPRECOBASE;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };
    
    this.fieldOnChangePais = function(){
        var widget = templateManager.container.getWidget('desconto_maximo');
        var dadosWidget = templateManager.container.getWidget('desconto_maximo_grid');
        
        if(!widget.getField('NMPAIS').value()) {
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            //ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            var var_porcentagem_msg = "PORCENTAGEM_MSG";
            MessageService.showMessageByCode(var_porcentagem_msg,{"FIELD": field.label});
            
            field.clearValue();
        }
    };
    
    this.getLevelByMaskNomeProduto = function(widget){
        var filtro = General.getLevelByMask('CDPICTPROD',1).length;
        
        widget.getField('NMPRODUTO').dataSourceFilter[0] = {
            "name": "CDNVPRODUTO",
            "operator": "=",
            "value": filtro
        };
        
        widget.getField('NMPRODUTO').reload();
    };
    /*global moment*/
    this.verificaValidade = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.__is_new == true){
            var maiorDataFinal;
            var menorDataInicial;
            var preco = widget.currentRow.VRITEPREBASE;
            var filter = [
                {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": widget.currentRow.CDPRODUTO
                },
                {
                  "name": "CDPRECOBASE",
                    "operator": "=",
                    "value": widget.currentRow.CDPRECOBASE  
                }
            ];
    
            General.callRestEngine('ped#/crud/itemprebase', 'FilterData', filter).then(function(callback){
                var validades = callback.dataset.itemprebase;
                validades.forEach(comparaValidade);
                
                function comparaValidade(validade, index){
                    if(index >= 0){
                        maiorDataFinal = moment(validade.DTFIMVALIPB,'DD/MM/YYYY').format('L');
                        menorDataInicial = moment(validade.DTINIVALIPB,'DD/MM/YYYY').format('L') ;
                        
                        menorDataInicial = menorDataInicial.split("/").reverse("").join("/");
                        maiorDataFinal = maiorDataFinal.split("/").reverse("").join("/");
                        
                        //this.validaDatasValidade(maiorDataFinal, menorDataInicial);
                        
                        /* inicio bloco validaDatasValidade */
                        var widget = templateManager.container.getWidget('listaItemPreBase');
            
                        var inicial = moment(widget.getField('DTINIVALIPB').value(),'DD/MM/YYYY').format('L');
                        var final = moment(widget.getField('DTFIMVALIPB').value(), 'DD/MM/YYYY').format('L');
                        
                        inicial = inicial.split("/").reverse("").join("/");
                        final = final.split("/").reverse("").join("/");
                        
                        if (final != "Invalid date"){
                            if(final <= inicial){
                                ScreenService.showMessage("A data final deve ser maior do que a data Inicial.");
                                widget.getField('DTFIMVALIPB').setValue(null);
                                
                            }else if (final >= maiorDataFinal && inicial <= menorDataInicial){
                                ScreenService.showMessage("Não pode haver outras validades contidas dentro das datas selecionadas.");
                                widget.getField('DTFIMVALIPB').setValue(null);
                                
                                    
                            }else if(final >= menorDataInicial  && final <= maiorDataFinal){
                                    ScreenService.showMessage("A data final não pode estar contida outras validades.");
                                    widget.getField('DTFIMVALIPB').setValue(null);
                                
                            }
                        }else if(inicial >= menorDataInicial && inicial <= maiorDataFinal){
                                ScreenService.showMessage("A data inicial não pode estar contida nas outras validades.");
                                widget.getField('DTINIVALIPB').setValue(null);
                            
                        }else if (preco != "" && final == "Invalid date"){
                            if (inicial <= menorDataInicial){
                                ScreenService.showMessage("Existem outras validades já cadastradas no período selecionado.");
                                    widget.getField('DTINIVALIPB').setValue(null);
                                    widget.getField('DTFIMVALIPB').setValue(null);
                                    widget.getField('VRITEPREBASE').setValue("");
                                    
                                }
                        }
                        
                        /* fim bloco validaDatasValidade */
                    }
                }
            }.bind(this));
        }
    };
    
    // início metodos aba de Preço por Cliente
    
    this.novaValidade = function(widget){
        
        var codigo = widget.currentRow.CDARVPROD;
        var nome = widget.currentRow.NMPRODUTO;
        var unidade = widget.currentRow.SGUNIDADE;
        var CDOPERATZIPB =  widget.currentRow.CDOPERATZIPB;
        var CDPRECOBASE =  widget.getParent().getParent().currentRow.CDPRECOBASE;
        var NRORG =  widget.currentRow.NRORG;
        var CDPRODUTO = widget.currentRow.CDPRODUTO;

        widget.newRow();
        widget.currentRow.CDARVPROD = codigo;
        widget.currentRow.NMPRODUTO = nome;
        widget.currentRow.SGUNIDADE = unidade;
        widget.currentRow.CDOPERATZIPB = CDOPERATZIPB;
        widget.currentRow.CDPRECOBASE = CDPRECOBASE;
        widget.currentRow.NRORG = NRORG;
        widget.currentRow.CDPRODUTO = CDPRODUTO;
        widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
        widget.reload();
    };
    
    this.editarTabpreclie = function(widget){
        
        if(widget.currentRow.CDCLIENTE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDCLIENTE = templateManager.container.getWidget('popupFiltroTabpreclie').currentRow.CDCLIENTE;
            // widget.currentRow.CDOPERINCLUSAO = getLocalVar("ERP_CDOPERADOR");
            // widget.currentRow.CDOPERULTATU = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');
            widget.currentRow.DTULTATU = moment().format('DD/MM/YYYY');
        }
        General.edit(widget);
        
    };
    
    this.salvaProduto = function(widget){
        this.validaDataPrecoCliente(widget);
    };
    
    this.validaDataPrecoCliente = function(widget){
        if(widget.currentRow.VRPRECOPROD == '0.00' || widget.currentRow.VRPRECOPROD == '0'){
            ScreenService.showMessage("O preço do produto deve ser diferente de 0.00");
        }else{
            var inicial = moment(widget.getField('DTVALINI').value(),'DD/MM/YYYY').format('L');
            var final = moment(widget.getField('DTVALFIN').value(), 'DD/MM/YYYY').format('L');
                        
            inicial = inicial.split("/").reverse("").join("/");
            final = final.split("/").reverse("").join("/");
            
            if(inicial != "Invalid date" && final != "Invalid date"){
                if(final <= inicial){
                    ScreenService.showMessage("A validade final deve ser maior do que a validade inicial.");
                    widget.currentRow.DTVALINI = '';
                    widget.currentRow.DTVALFIN = '';
                    widget.getField('DTVALFIN').value('');
                    widget.getField('DTVALINI').value('');
                    widget.getField('DTVALFIN').reload();
                    widget.getField('DTVALINI').reload();
                }
                General.saveCrud(widget);
            } else if(inicial == "Invalid date" && final != "Invalid date"){
                    ScreenService.showMessage("A validade inicial deve ser preenchida.");
            } else if(final == "Invalid date" && inicial != "Invalid date"){
                ScreenService.showMessage("A validade final deve ser preenchida.");
            } else {
                General.saveCrud(widget);
            }
        }
    };
    
    this.openPopupTabpreclie = function(){
        var wdgPopup = templateManager.container.getWidget('popupFiltroTabpreclie');
        var cliente = wdgPopup.getField('NMRAZSOCCLIE').value();
        if(cliente == undefined || cliente == ""){
            ScreenService.openPopup(wdgPopup);
        }else{
            return 0;
        }
    };
    
    this.openPopupTabpreclieAction = function(){
        var wdgPopup = templateManager.container.getWidget('popupFiltroTabpreclie');
        ScreenService.openPopup(wdgPopup);
    };

    this.setDataSourceFilterTabpreclie = function(widget){
        if(widget.isValid()){
            widget.isVisible = false;
            var wdgPrecoPorCliente =  templateManager.container.getWidget('wdgPrecoPorCliente');
            ScreenService.closePopup(widget);
            wdgPrecoPorCliente.dataSourceFilter.push({
                name: "CDCLIENTE",
                operator: "=",
                value: widget.currentRow.CDCLIENTE
            });
            wdgPrecoPorCliente.reload();
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02300_preco_base_Controller', Ped02300_preco_base_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped02400_justificativaExclusaoHistorico_Controller.js
function Ped02400_justificativaExclusaoHistorico_Controller(templateManager, ScreenService, General) {
    
    var originalRow;
    
    this.createJust = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };

    this.edit = function(widget) {
        widget.edit();
        originalRow = Util.clone(widget.currentRow);
    };
  
    this.cancelEdit = function(widget) {
        if (widget.currentRow.__is_new) {
          widget.dataSource.data.pop();
          widget.reload();
          ScreenService.closeSwipe();
        } else { 
          Util.extend(widget.currentRow, originalRow);
          widget.view();
        }
    };

    
    this.deleteJust = function(widget) {
        General.deleteCrud(widget).then(function(){
            widget.reload();
        });
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02400_justificativaExclusaoHistorico_Controller', Ped02400_justificativaExclusaoHistorico_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped02600_parametrosPedidos_Controller.js
var  Ped02600_parametrosPedidos_Controller = function(ScreenService, General, templateManager, ZHPromise, localStorageEngine, Ped02600_parametrosPedidos_Service){

    // Variaveis para recarregar widgets
    this.recarregaWidgetLancamentoPedido = true;
    this.recarregaWidgetItemLancamento = true;
    this.recarregaWidgetEstoqueItem = true;
    this.recarregaWidgetPrecoProduto = true;
    this.recarregaWidgetInformacoesFinanceras = true;
    this.recarregaWidgetDadosComissao = true;
    this.recarregaWidgetOperacoesImposto = true;
    this.recarregaWidgetAcesso = true;

   
    this.cancelEdit = function(args){
        var widget = args.owner.widget;
        widget.parent.widgets.forEach(function(element){
            if(element !== widget){
                element.enabled = true;
            }
        });
        widget.parent.getField('NMFILIAL').readOnly = false;
        General.formWidgetSwitchTemplate(widget);
        General.backOrCancel(args);
        // Voltar template do widget para list, conseguindo assim atualizar os dados da row
        args.owner.widget.list();
    };

    this.changeDataValidade = function(widget){
        if(widget.currentRow.IDUTVALIPED === 'S'){
            widget.getField('QTDIAVALIPED').readOnly = false;
        } else if(widget.currentRow.IDUTVALIPED === 'N'){
            widget.getField('QTDIAVALIPED').readOnly = true;
            // widget.getField('QTDIAVALIPED').value('');
        }
        templateManager.updateTemplate();
    };

    this.changeFields = function(widget){
        if(widget.currentRow){
            if(widget.name === 'lancamentoPedido'){
                this.changeDataValidade(widget);
                this.changeTipoOperacao(widget);
                widget.reload();
            } else if(widget.name === 'lancamentoItem'){
                this.changeGrupoper(widget);
                widget.reload();
            } else if(widget.name === 'precoProduto'){
                this.changeIdAtuTabPrecIni(widget);
                this.changePerAltPreco(widget);
                this.changeIdExibRentPed(widget);
                widget.reload();
            } else if(widget.name === 'informacoesFinanceiras'){
                this.changeIdPendFinan(widget);
                this.changeIdsitufinan(widget);
                widget.reload();
            } else if(widget.name === 'acesso'){
                //this.metodo(widget);
                //widget.reload();
            }
        }
    };

    this.changeGrupoper = function(widget){
        if((widget.currentRow.IDCONFISPRODCLIE === 'S') || (widget.currentRow.IDCONFISPRODFIL === 'S') || (widget.currentRow.IDCONFISPRODTRA === 'S')){
            widget.getField('DSGRUPOPER').readOnly = false;
        } else if((widget.currentRow.IDCONFISPRODCLIE === 'N') && (widget.currentRow.IDCONFISPRODFIL === 'N') && (widget.currentRow.IDCONFISPRODTRA === 'N')){
            widget.getField('DSGRUPOPER').readOnly = true;
        }
        templateManager.updateTemplate();
    };

    this.changeIdAtuTabPrecIni = function(widget){
        if(widget.currentRow.IDATUTABPRECINI === 'S'){
            widget.getField('VRPERDIFCUSPREC').readOnly = false;
            widget.getField('DSGRUPOPATPR').readOnly = false;
        } else if(widget.currentRow.IDATUTABPRECINI === 'N'){
            widget.getField('VRPERDIFCUSPREC').readOnly = true;
            widget.getField('DSGRUPOPATPR').readOnly = true;
        }
    };

    this.changeIdExibRentPed = function(widget){
        if(widget.currentRow.IDEXIBRENTPED === 'F'){
            widget.getField('NRTPCUSTORENT').readOnly = false;
            widget.getField('DSGRUNRENTAVEL').readOnly = false;
            widget.getField('NMITFORPRECO').readOnly = true;
        } else if(widget.currentRow.IDEXIBRENTPED === 'S'){
            widget.getField('NRTPCUSTORENT').readOnly = true;
            widget.getField('DSGRUNRENTAVEL').readOnly = true;
            widget.getField('NMITFORPRECO').readOnly = false;
        } else if(widget.currentRow.IDEXIBRENTPED === 'N'){
            widget.getField('NRTPCUSTORENT').readOnly = true;
            widget.getField('DSGRUNRENTAVEL').readOnly = true;
            widget.getField('NMITFORPRECO').readOnly = true;
        }
    };

    this.changeIdPendFinan = function(widget){
        if(widget.currentRow.IDPENDFINAN === '1'){
            widget.getField('NRDIAPENDFIN').readOnly = true;
            widget.getField('IDPENDFINANLANC').readOnly = true;
        } else if(widget.currentRow.IDPENDFINAN === '2'){
            widget.getField('NRDIAPENDFIN').readOnly = false;
            widget.getField('IDPENDFINANLANC').readOnly = false;
        } else if(widget.currentRow.IDPENDFINAN === '3'){
            widget.getField('NRDIAPENDFIN').readOnly = false;
            widget.getField('IDPENDFINANLANC').readOnly = false;
        }
    };
    
    this.changeIdsitufinan = function(widget){
        if(widget.currentRow.IDSITUFINAN === '1'){
            widget.getField('VRLIMAPROVA').readOnly = true;
        } else if(widget.currentRow.IDSITUFINAN === '2'){
            widget.getField('VRLIMAPROVA').readOnly = false;
        } else if(widget.currentRow.IDSITUFINAN === '3'){
            widget.getField('VRLIMAPROVA').readOnly = false;
        }
    };

    this.changePerAltPreco = function(widget){
        if(widget.currentRow.IDPERALTPRECO === 'S'){
            widget.getField('DSGRUALTPRECO').readOnly = false;
            widget.getField('DSPERALTMENOR').readOnly = false;
            widget.getField('DSPERALTMAIOR').readOnly = false;
        } else if(widget.currentRow.IDPERALTPRECO === 'N'){
            widget.getField('DSGRUALTPRECO').readOnly = true;
            widget.getField('DSPERALTMENOR').readOnly = true;
            widget.getField('DSPERALTMAIOR').readOnly = true;
        }
    };
    
    this.changeIdexibpedido = function(widget){
        if(widget.currentRow.IDEXIBPEDIDO === '1'){
            widget.currentRow.IDUTRELACVENDCLI = 'N';
            widget.getField('DSGRUPOPTPED').readOnly = true;
            widget.getField('IDUTRELACVENDCLI').readOnly = true;
        } else if(widget.currentRow.IDEXIBPEDIDO === '2'){
            widget.getField('DSGRUPOPTPED').readOnly = false;
            widget.getField('IDUTRELACVENDCLI').readOnly = false;
        }
    };

    this.changeTipoOperacao = function(widget){
        if(widget.currentRow.IDOBRTPOPPED === 'S'){
            widget.getField('NMTIPOOPER').readOnly = false;
        } else if(widget.currentRow.IDOBRTPOPPED === 'N'){
            widget.getField('NMTIPOOPER').readOnly = true;
            // widget.getField('NMTIPOOPER').value('');
        }
        templateManager.updateTemplate();
    };
    
    
    this.validateFieldsPrecoProduto = function(widget){
        this.changePerAltPreco(widget);
        this.changeIdtabprecoOnEnter(widget);
    };
    
    this.changeIdtabpreco = function(field){
        if(field.value() === '1'){
            field.getParent().getField('IDPERALTPRECO').readOnly = false;
            if(field.getParent().getField('IDPERALTPRECO').value() === 'S'){
                field.getParent().getField('DSGRUALTPRECO').readOnly = false;
                field.getParent().getField('DSPERALTMENOR').readOnly = false;
                field.getParent().getField('DSPERALTMAIOR').readOnly = false;
            }else{
                field.getParent().getField('DSGRUALTPRECO').readOnly = true;
                field.getParent().getField('DSPERALTMENOR').readOnly = true;
                field.getParent().getField('DSPERALTMAIOR').readOnly = true;
            }
        } else if(field.value() === '2'){
            field.getParent().getField('IDPERALTPRECO').readOnly = true;
            field.getParent().getField('DSGRUALTPRECO').readOnly = true;
            field.getParent().getField('DSPERALTMENOR').readOnly = true;
            field.getParent().getField('DSPERALTMAIOR').readOnly = true;
        }
    };

    this.changeIdtabprecoOnEnter = function(widget){
        if(widget.getField('IDTABPRECO').value() === '1'){
            widget.getField('IDPERALTPRECO').readOnly = false;
            if(widget.getField('IDPERALTPRECO').value() === 'S'){
                widget.getField('DSGRUALTPRECO').readOnly = false;
                widget.getField('DSPERALTMENOR').readOnly = false;
                widget.getField('DSPERALTMAIOR').readOnly = false;
            }else{
                widget.getField('DSGRUALTPRECO').readOnly = true;
                widget.getField('DSPERALTMENOR').readOnly = true;
                widget.getField('DSPERALTMAIOR').readOnly = true;
            }
        } else if(widget.getField('IDTABPRECO').value() === '2'){
            widget.getField('IDPERALTPRECO').readOnly = true;
            widget.getField('DSGRUALTPRECO').readOnly = true;
            widget.getField('DSPERALTMENOR').readOnly = true;
            widget.getField('DSPERALTMAIOR').readOnly = true;
        }
    };

    this.edit = function() {
        var widgetPrincipal = templateManager.container.getWidget('tabbedParametrosPedidos');
        var widget = templateManager.container.getActiveWidget();
        widgetPrincipal.getField('NMFILIAL').readOnly = true;
        widgetPrincipal.widgets.forEach(function(element){
            if(element !== widget){
                element.enabled = false;
            }
            this.changeFields(element);
        }.bind(this));

        if(widget.currentRow.__is_new === false){
            General.widgetEdit(widget);
        } else {
            widget.template = widget.templateToForm;
            widget.currentRow = {};
            widget.newRow();
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFILIAL = widgetPrincipal.currentRow.CDFILIAL;

        }
    };
    this.habilitaCamposOpImp = function(){
        var widget = templateManager.container.getActiveWidget();
        if (widget.name == 'operacoesImpostos'){
            widget.getField('IDEXIBIMPITPED').readOnly = false;
            widget.getField('IDLANENCARGOPED').readOnly = false;
        }
    };
    this.desabilitacampo = function(){
        var widget = templateManager.container.getActiveWidget();
        if (widget.name == 'operacoesImpostos'){
            widget.getField('IDEXIBIMPITPED').readOnly = true;
            widget.getField('IDLANENCARGOPED').readOnly = true;
        }else if (widget.name == 'dadosComissao'){
            widget.getField('IDENCARPRIPARC').readOnly = true;
            widget.getField('IDEXIBVENDCOM').readOnly = true;
        }else if (widget.name == 'lancamentoItem'){
            widget.getField('IDCONFISPRODTRA').readOnly = true;
            widget.getField('IDCONFISPRODFIL').readOnly = true;
            widget.getField('IDCONFISPRODCLIE').readOnly = true;
            widget.getField('IDTPCOMPPROD').readOnly = true;
            widget.getField('IDUTDESCMAXI').readOnly = true;
            widget.getField('NRMAXITNFPED').readOnly = true;
            widget.getField('IDEXIBPRINATIV').readOnly = true;
        }else if (widget.name == 'estoqueItem'){
            widget.getField('IDTESTAEST').readOnly = true;
            widget.getField('IDUTRESELOTE').readOnly = true;
            widget.getField('IDEVOLESTLIQMAN').readOnly = true;
            widget.getField('IDCONSESTGEROP').readOnly = true;
            
        }else if (widget.name == 'precoProduto'){
            widget.getField('IDTABPRECO').readOnly = true;
            widget.getField('IDPERALTPRECO').readOnly = true;
            widget.getField('DSPERALTMENOR').readOnly = true;
            widget.getField('DSPERALTMAIOR').readOnly = true;
            
        }else if (widget.name == 'informacoesFinanceiras'){
            widget.getField('IDPENDFINAN').readOnly = true;
            widget.getField('NRDIAPENDFIN').readOnly = true;
            widget.getField('IDPENDFINANLANC').readOnly = true;
            widget.getField('IDSITUFINAN').readOnly = true;
            widget.getField('VRLIMAPROVA').readOnly = true;
            widget.getField('IDBLOQAPROVACAO').readOnly = true;
            widget.getField('DSGROPERAPRO').readOnly = true;
        }else if (widget.name == 'acesso'){
            widget.getField('IDEXIBPEDIDO').readOnly = true;
            widget.getField('DSGRUPOPTPED').readOnly = true;
            widget.getField('IDUTRELACVENDCLI').readOnly = true;
            widget.getField('IDMENSVEND').readOnly = true;
            widget.getField('IDESTTODFIL').readOnly = true;
            widget.getField('VRMINPEDIDO').readOnly = true;
            
        }
        
    };

    this.saveWidget = function(widget){

        var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": widget.currentRow.CDFILIAL
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": getLocalVar('NRORG')
                    }
                ];
                
        General.callRestEngine('ped#/crud/ped_parampedido', 'FilterData', filter).then(function(callback){
            if(!callback.dataset.ped_parampedido[0]){
                widget.currentRow.__is_new = true;
            }else {
                widget.currentRow.__is_new = false;
            }   
        
            var tabbedPedidos = widget.container.getWidget('tabbedParametrosPedidos');
            
            
            if(!widget.currentRow.IDUTCTREMPEN){
                widget.currentRow.IDUTCTREMPEN = "";
            }

            General.formWidgetSwitchTemplate(widget);
            widget.parent.widgets.forEach(function(element){
                if(element !== widget){
                    element.enabled = true;
                }
            });
            
            
            var widgetLancPed = templateManager.container.getWidget('lancamentoPedido');

            if(widget.currentRow.IDOBRTPOPPED == 'N' && widget.currentRow.IDEXIBIMPITPED == 'S') {
                
                ScreenService.showMessage("Não será possivel Exibir Impostos sem informar o Tipo de Operação no Lançamento de Pedido");

            } else if (widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDEXIBPRINATIV){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if(widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDTESTAEST){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if (widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDTABPRECO){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if(widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDPENDFINAN){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if(widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDENCARPRIPARC){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if(widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDEXIBIMPITPED){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else if(widgetLancPed.currentRow.IDLANCPED == undefined && widget.currentRow.IDMENSVEND){
                ScreenService.showMessage("Preencha os parâmetros da aba Lançamento do Pedidos.");
                widget.parent.getField('NMFILIAL').readOnly = true;
            }else {
                var widgetOpImposto = templateManager.container.getWidget('operacoesImpostos');
                 General.saveCrud(widget).then(
                    function (success) {
        				Ped02600_parametrosPedidos_Service.saveRowParamPed(widget.currentRow).then(function(sucess){
        				    ScreenService.showMessage("Parametros salvos com sucesso.");
        				    
        				  //  widget.list();
        				    widget.parent.getField('NMFILIAL').readOnly = false;
        				    widgetOpImposto.getField('IDEXIBIMPITPED').readOnly = true;
                            widgetOpImposto.getField('IDLANENCARGOPED').readOnly = true;
        				  
        				    widget.reload();
        				    
        				    tabbedPedidos.reload();
        				    
        				    templateManager.updateTemplate();
        				    
        				    widget.list();
        				    
        				}.bind(this), 
        				
        				function(error){
        				    if((error.data.error[0] === "Não existe registro na tabela de Parametros de Expedição para a Filial selecionada.")){
        				        ScreenService.showMessage(error.data.error);
        				    } else if((error.data.error[0] === "Não existe registro na tabela de Parametros Gerais.") && (widget.parent.widgets[0].getField('IDUTCTREMPEN').isVisible === true)){
        				        ScreenService.showMessage(error.data.error);
        				        widget.currentRow.IDUTCTREMPEN = "";
        				    } else if((error.data.error.length > 1) && (widget.parent.widgets[0].getField('IDUTCTREMPEN').isVisible === true)){
        				        ScreenService.showMessage(error.data.error);
        				        widget.currentRow.IDUTCTREMPEN = "";
        				    }
        				    widget.reload();
        				    
        				    templateManager.updateTemplate();
        				}.bind(this));
                    }.bind(this)
        		);
                
            }
        });
    };

    this.updateDataSourceFilters = function(widget) {
        
        widget.dataSourceFilter[0].name = 'CDFILIAL';
        widget.dataSourceFilter[0].operator = '=';
        widget.dataSourceFilter[0].value = General.getFieldValue('CDFILIAL','tabbedParametrosPedidos');
        
        widget.dataSourceFilter[1].name = 'NRORG';
        widget.dataSourceFilter[1].operator = '=';
        widget.dataSourceFilter[1].value = getLocalVar('NRORG');
        
        return widget;
        
    };
    
    this.recarregaWidget = function(nomeVariavel, nomeWidget){
        if(this[nomeVariavel]){
            var widget = templateManager.container.getWidget(nomeWidget);
            widget = this.updateDataSourceFilters(widget);
            widget.reload();
            this[nomeVariavel] = false;
        }
        
    };

    this.showActionEdit = function(field){

        var widget = templateManager.container.getWidget('tabbedParametrosPedidos');
        if(field.value().length){
            var widgetAtiva = templateManager.container.getActiveWidget();
            widget.widgets.forEach(function(element){
                
                element.getAction('editar').isVisible = true;
                element.getAction('atualizar').isVisible = true;
                element = this.updateDataSourceFilters(element);
               
                this.recarregaWidgetLancamentoPedido = true;
                this.recarregaWidgetItemLancamento = true;
                this.recarregaWidgetEstoqueItem = true;
                this.recarregaWidgetPrecoProduto = true;
                this.recarregaWidgetInformacoesFinanceras = true;
                this.recarregaWidgetDadosComissao = true;
                this.recarregaWidgetOperacoesImposto = true;
                this.recarregaWidgetAcesso = true;
                widgetAtiva.currentRow = {};
            }.bind(this));
            setTimeout(function(){ widgetAtiva.reload(); }, 2000);
        } else {
            widget.widgets.forEach(function(element){
                element.getAction('editar').isVisible = false;
                element.getAction('atualizar').isVisible = false;
                element.currentRow = {};
                element.reload();
               
            });
        }

    };
    
    this.reloadWidgets = function(){
        var widget = templateManager.container.getWidget('tabbedParametrosPedidos');
        widget.widgets.forEach(function(element){
            element.reload();
        }.bind(this));
        templateManager.updateTemplate();
    };

   this.showDataSourceValue = function(widget){
    
        if(widget.dataSource.data[0]) {
            
            widget.currentRow = widget.dataSource.data[0];
            
        }
    
    };

    this.verifyNumber = function(field){
        if(field.value() > 100){
            ScreenService.showMessage('O número do percentual deve ser entre 0 e 100');
            field.value("");
        }
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02600_parametrosPedidos_Controller', Ped02600_parametrosPedidos_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped03500_tabelaMetaComissao_Controller.js
function Ped03500_tabelaMetaComissao_Controller(Ped03500_tabelaMetaComissao_Service, General, templateManager, ScreenService, ZhFilterPreferences) {

    var  mensagens = {
        valorInicial : 'Valor Inicial inválido!',
        valorFinal: 'Valor Final inválido!',
        produtoFinal: 'Produto Final não pode ser menor que o produto inicial!',
        valorComissao: 'Comissão(%) deve estar entre 0 e 100!',
        preencherCampos: 'Preencha os filtros antes de realizar o cadastro Automatico!',
        sucessoCadastro: 'Cadastro automático realizado com sucesso!',
        checkedRows: 'Selecione produtos antes de realizar o cadastro automático!'
    };

    var i = 0;

    this.openFilter = function(widget){
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    this.fieldOnChangeProduto = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        if (!(widget.getField('CDPRODUTOINI').value())) {
            widget.currentRow.CDPRODUTOFIN =  '';
            widget.currentRow.CDARVPRODFIN =  '';
            widget.currentRow.NMPRODUTOFIN = '';
            widget.getField('NMPRODUTOFIN').readOnly = true;
        } else {
            widget.getField('NMPRODUTOFIN').readOnly = false;
        }
        if (widget.getField('CDARVPRODINI').value() > widget.getField('CDARVPRODFIN').value() && widget.getField('CDARVPRODFIN').value()) {
            //ScreenService.showMessage(mensagens.produtoFinal);
            ScreenService.showMessage("Produto Final não pode ser menor que o produto inicial!");
            widget.currentRow.CDPRODUTOFIN = '';
            widget.currentRow.NMPRODUTOFIN = '';
        }
    };

    this.filterTipoOperacao = function() {
        var metavenda = templateManager.container.getWidget('METAVENDA');
        var tipooper = templateManager.container.getWidget('TIPOOPER');
        tipooper.dataSourceFilter[0].value = metavenda.currentRow.CDMETAVENDA;
        tipooper.reload();
    };

    this.saveTipoOperacao = function(widget) {
        var metavenda = templateManager.container.getWidget('METAVENDA');
        var nrseq = [];
        nrseq.push('METAVENDOPERAC');
        Ped03500_tabelaMetaComissao_Service.getNrSeq(nrseq).then(function(success) {
            widget.currentRow.CDMETAVENDA = metavenda.currentRow.CDMETAVENDA;
            widget.currentRow.NRSEQMETAVENDOP = success.dataset.data[0];
            widget.currentRow.NRORG = success.dataset.data[1];
            General.saveCrud(widget);
        });
    };

    this.getNrorg = function(){
        return templateManager.container.getWidget('TABELACOMISSAO').currentRow.NRORG;
    };

    this.filiProd = function(widget){
        var row = widget.currentRow;
        if (row.NMFILIAL == ""){
            widget.getField('NMPRODUTOINI').readOnly = true;
            widget.getField('NMPRODUTOINI').readOnlyOnEdit = true;
            widget.getField('NMPRODUTOFIN').readOnly = true;
            widget.getField('NMPRODUTOFIN').readOnlyOnEdit = true;
            widget.currentRow.NMPRODUTOINI = "";
            widget.currentRow.NMPRODUTOFIN = "";
            widget.reload();
            widget = widget.container.getWidget('ITENS');
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
            widget.reload();
        } else {
            widget.getField('NMPRODUTOINI').readOnly = !row.NMFILIAL;
            widget.getField('NMPRODUTOINI').readOnlyOnEdit = !row.NMFILIAL;
            this.prodIni(widget);
        }
    };

    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODUTOFIN').readOnly = !row.NMPRODUTOINI;
        widget.getField('NMPRODUTOFIN').readOnlyOnEdit = !row.NMPRODUTOINI;
        this.prodFin(widget);
    };

    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('ITENS');
        widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: this.getNrorg()
            }
        ];
        if(row.NMPRODUTOFIN){

            if (row.CDPRODUTOINI > row.CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }

            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.CDPRODUTOINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.CDPRODUTOFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };

    this.fieldOnChangeComissao = function() {
        var widget = templateManager.container.getWidget('ITEMPRODUTO');
        if (widget.getField('VRPECOMIVEND').value() <= 0 || widget.getField('VRPECOMIVEND').value() >= 100) {
            widget.getField('VRPECOMIVEND').clearValue();
            //ScreenService.showMessage(mensagens.valorComissao);
            ScreenService.showMessage("Comissão(%) deve estar entre 0 e 100!");
            widget.reload();
        }
    };

    this.openPopupCadastroItens = function() {
        var widget = templateManager.container.getWidget('TABBEDITENS');
        if(widget._hasChildWithCheckedRows()) {
            if (widget.getField('CDFILIAL').value() && widget.getField('CDPRODUTOINI').value() && widget.getField('CDPRODUTOFIN').value()) {
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOITEM');
                widgetPopup.isVisible = true;
                ScreenService.openPopup(widgetPopup);
            } else {
                //ScreenService.showMessage(mensagens.preencherCampos);
                ScreenService.showMessage("Preencha os filtros antes de realizar o cadastro Automatico!");
            }
        } else {
            //ScreenService.showMessage(mensagens.checkedRows);
            ScreenService.showMessage("Selecione produtos antes de realizar o cadastro automático!");   
        }
    };

    this.openPopupCadastroProdutos = function() {

        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widgetPopup.currentRow.CDMETAVENDA = widgetPopup.parent.parent.currentRow.CDMETAVENDA;
        widgetPopup.currentRow.NMMETAVENDA = widgetPopup.parent.parent.currentRow.NMMETAVENDA;
        widgetPopup.isVisible = true;
        ScreenService.openPopup(widgetPopup);
    };

    this.fieldOnChangeVRCadastro = function(field) {

        var widget = templateManager.container.getWidget('CADASTROAUTOITEM');
        var CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        var CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        var CDCOMISSAO  = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;
        var VRINICVENDA = widget.currentRow.VRINICVENDA;
        var VRFINAVENDA = widget.currentRow.VRFINAVENDA;

        if (!(widget.getField('VRINICVENDA').value())){
            widget.currentRow.VRFINAVENDA = '';
            widget.getField('VRFINAVENDA').readOnly = true;
        } else {
            if (field.name === 'VRINICVENDA'){
                if (field.value() < 0) {
                    //ScreenService.showMessage(mensagens.valorInicial);
                    ScreenService.showMessage("Valor Inicial inválido!");
                    widget.currentRow.VRINICVENDA = '';
                    widget.currentRow.VRFINAVENDA = '';
                    widget.getField('VRFINAVENDA').readOnly = true;
                } else {
                    widget.getField('VRFINAVENDA').readOnly = false;
                }
            }
            if (field.name === 'VRFINAVENDA') {
                if (field.value()) {
                    var valorInicial = parseFloat(widget.getField('VRINICVENDA').value());
                    var valorFinal = parseFloat(widget.getField('VRFINAVENDA').value());
                     if(valorInicial > valorFinal){
                        //ScreenService.showMessage(mensagens.valorFinal);
                        ScreenService.showMessage("Valor Final inválido!");
                        widget.currentRow.VRFINAVENDA = '';
                    }
                }
            }
        }

    };

    this.editComissao = function(widget){
        General.edit(widget);
        widget.currentRow.VRFINAVENDAANTIGO = widget.currentRow.VRFINAVENDA;
        i = widget.currentRow.__index;
        widget.getField('VRFINAVENDA').readOnly = false;
    };

    this.fieldOnChangeVR = function(field) {
        var widget = templateManager.container.getWidget('ITEMPRODUTO');
        var CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        var CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        var CDCOMISSAO  = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;
        var VRINICVENDA = widget.currentRow.VRINICVENDA;
        var VRFINAVENDA = widget.currentRow.VRFINAVENDA;

        if (!widget.getField('VRINICVENDA').value()){
            widget.currentRow.VRFINAVENDA = '';
            widget.getField('VRFINAVENDA').readOnly = true;
        } else {
            if (field.name === 'VRINICVENDA') {
                Ped03500_tabelaMetaComissao_Service.verificaValorInicial(VRINICVENDA, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                    if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                        //ScreenService.showMessage(mensagens.valorInicial);
                        ScreenService.showMessage("Valor Inicial inválido!");
                        widget.currentRow.VRINICVENDA = '';
                        widget.currentRow.VRFINAVENDA = '';
                        widget.getField('VRFINAVENDA').readOnly = true;
                    } else {
                        widget.getField('VRFINAVENDA').readOnly = false;
                    }
                });
            }
        }

        if (widget.getField('VRFINAVENDA').value()){
            var valorFinal = parseFloat(widget.getField('VRFINAVENDA').value());
            var erro = false;
            if (field.name === 'VRFINAVENDA') {
                var valores = [
                    VRINICVENDA,
                    VRFINAVENDA
                ];
                Ped03500_tabelaMetaComissao_Service.verificaValorFinal(valores, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                   if ((response.dataset.itcomissao.length !== 0 || field.value() < 0) && widget.mode != "edit") {
                        if (erro === false) {
                            //ScreenService.showMessage(mensagens.valorFinal);
                            ScreenService.showMessage("Valor Final inválido!");
                            erro = true;
                        }
                        widget.currentRow.VRFINAVENDA = '';
                    } else if ((widget.mode == "edit") && (widget.currentRow.__is_new == false)){
                        if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                            if (field.value() != widget.currentRow.VRFINAVENDAANTIGO){
                                if (widget.currentRow.__index != (widget.dataSource.data.length - 1)){
                                    if (field.value() >= widget.dataSource.data[i+1].VRINICVENDA){
                                        if (erro === false) {
                                            //ScreenService.showMessage(mensagens.valorFinal);
                                            ScreenService.showMessage("Valor Final inválido!");
                                            erro = true;
                                        }
                                        widget.currentRow.VRFINAVENDA = '';
                                    }
                                }
                            }
                        }
                    } else {
                         Ped03500_tabelaMetaComissao_Service.verificaValores(valores, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                           if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                                if (erro === false) {
                                    //ScreenService.showMessage(mensagens.valorFinal);
                                    ScreenService.showMessage("Valor Final inválido!");
                                    erro = true;
                                }
                                widget.currentRow.VRFINAVENDA = '';
                            }
                        });
                    }
                });
            }
            var valorInicial = parseFloat(widget.getField('VRINICVENDA').value());
            if (valorInicial > valorFinal){
                if (erro === false) {
                    //ScreenService.showMessage(mensagens.valorFinal);
                    ScreenService.showMessage("Valor Final inválido!");
                    erro = true;
                }
                widget.currentRow.VRFINAVENDA = '';
            }
        }
    };

    this.saveProduto = function(widget) {
        widget.currentRow.CDMETAVENDA = widget.getParent().currentRow.CDMETAVENDA;
        General.saveCrud(widget);
    };

    this.saveComissao = function(widget) {
        widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        widget.currentRow.CDCOMISSAO = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;

        General.saveCrud(widget);
    };

    this.cadastroAutomaticoItem = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
            widget.currentRow.CDCOMISSAO = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;

            var widgetActivate = templateManager.container.getWidget('ITENS');
            var rows = {
                PRODUTOS: widget.getParent().getCheckedRows(),
                ROW: widget.currentRow
            };

            Ped03500_tabelaMetaComissao_Service.cadastroAutomaticoItem(rows).then(function(response){
                //ScreenService.showMessage(mensagens.sucessoCadastro);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widget.getParent().unSelectAll();
                widget.currentRow = '';
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOITEM');
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                widgetActivate.activate();
            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.cadastroAutomaticoProduto = function(widget) {
        var row = widget.currentRow;
        if (widget.isValid()) {
            Ped03500_tabelaMetaComissao_Service.cadastroAutomaticoProduto(row).then(function(response){
                var widgetActivate = templateManager.container.getWidget('PRODUTOS');
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                //ScreenService.showMessage(mensagens.sucessoCadastro);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetActivate.activate();
                widgetActivate.reload();
            }, function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.cancelarCadastroAutomaticoItem = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOITEM');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('TABBEDITENS');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };

    this.cancelarCadastroAutomaticoProduto = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('PRODUTOS');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
    };

    this.delete = function(widget) {
        var dataSource;
        if (widget.name === 'TABELACOMISSAO') {
            dataSource = 'ped_pedidos#/comissao';
        } else if(widget.name === 'METAVENDA') {
           dataSource = 'ped_pedidos#/metavenda';
        }
        var row = widget.currentRow;
        ScreenService .confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            Ped03500_tabelaMetaComissao_Service.delete(dataSource, row).then(function(response){
                widget.activate();
                ScreenService.closeSwipe();
                widget.reload();
            }, function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        });
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('Ped03500_tabelaMetaComissao_Controller', Ped03500_tabelaMetaComissao_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped03600_comissaoVendedor_Controller.js
function Ped03600_comissaoVendedor_Controller(General, templateManager, ScreenService, ZhFilterPreferences, ZHPromise) {
    
    this.startFiltering = function(widget){
        var promises = [];
        /*widget = templateManager.container.getActiveWidget();
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){*/
             this.setValues();
        // }.bind(this)); 
    };
    
    this.setActions = function(name){
        if (name == 'editar') {
            templateManager.container.getWidget('widgetVendedor').getAction('salvarEdit').isVisible = true;
            templateManager.container.getWidget('widgetVendedor').getAction('salvar').isVisible = false;
        } else {
            templateManager.container.getWidget('widgetVendedor').getAction('salvar').isVisible = true;
            templateManager.container.getWidget('widgetVendedor').getAction('salvarEdit').isVisible = false;
        }    
    };
    
    this.setValues = function() {
        
        var widget = templateManager.container.getWidget('widgetPedidos');
        var cdfilial = templateManager.container.getWidget('tabbedComisVend').getField('CDFILIAL').value();
        widget.applyDefaultValue();
        
        widget.container.getActiveWidget().getField('IDPRIOPED').setValue(["3", "2", "1"]);
        widget.container.getActiveWidget().getField('IDSITPEDIDO').setValue(["6", "5", "4", "3", "2", "1"]);
        widget.container.getActiveWidget().getField('IDSITITEMPED').setValue(["7", "6", "5", "4", "3", "2", "1"]);
        
        widget.dataSourceFilter[0].value = cdfilial;
        
        this.filtroNmPedido();
        this.filtroCliente();
        this.filtroProdutos();
        this.filtroMunicipioCliente();
        
        widget.reload();
    };
    
    this.filtroNmPedido = function(){
        var widget = templateManager.container.getWidget('widgetPedidos');
        
        if (widget.container.getActiveWidget().getField('P_TPEDIDO').value() == 'L') {
           
           widget.container.getActiveWidget().getField('NRPEDIDO').readOnly = false;
           widget.container.getActiveWidget().getField('NRPEDIDO').reload();
           widget.container.getActiveWidget().getField('P_INTERVALODE').readOnly = true;
           widget.container.getActiveWidget().getField('P_INTERVALOATE').readOnly = true;
           widget.container.getActiveWidget().getField('NRPEDIDO').validations = {required: true};
           
           delete (widget.container.getActiveWidget().getField('P_INTERVALODE').validations);
           delete (widget.container.getActiveWidget().getField('P_INTERVALOATE').validations);
           
           widget.container.getActiveWidget().getField('P_INTERVALODE').setValue('');
           widget.container.getActiveWidget().getField('P_INTERVALOATE').setValue('');
            
        } else if (widget.container.getActiveWidget().getField('P_TPEDIDO').value() == 'I') {
           
           widget.container.getActiveWidget().getField('NRPEDIDO').readOnly = true;
           widget.container.getActiveWidget().getField('P_INTERVALODE').readOnly = false;
           widget.container.getActiveWidget().getField('P_INTERVALOATE').readOnly = false;
           widget.container.getActiveWidget().getField('P_INTERVALODE').validations = {required: true};
           widget.container.getActiveWidget().getField('P_INTERVALOATE').validations = {required: true};
           
           delete (widget.container.getActiveWidget().getField('NRPEDIDO').validations);
           
           widget.container.getActiveWidget().getField('NRPEDIDO').setValue('');
           
        } else if (widget.container.getActiveWidget().getField('P_TPEDIDO').value() == 'T') {
           
           widget.container.getActiveWidget().getField('NRPEDIDO').readOnly = true;
           widget.container.getActiveWidget().getField('P_INTERVALODE').readOnly = true;
           widget.container.getActiveWidget().getField('P_INTERVALOATE').readOnly = true;
           
           delete (widget.container.getActiveWidget().getField('P_INTERVALODE').validations);
           delete (widget.container.getActiveWidget().getField('P_INTERVALOATE').validations);
           delete (widget.container.getActiveWidget().getField('NRPEDIDO').validations);
           
           widget.container.getActiveWidget().getField('NRPEDIDO').setValue('');
           widget.container.getActiveWidget().getField('P_INTERVALOATE').setValue('');
           widget.container.getActiveWidget().getField('P_INTERVALODE').setValue('');
        }
    };
    
    this.filtroCliente = function(){
        
        var widget = templateManager.container.getWidget('widgetPedidos');
        
        if (widget.container.getActiveWidget().getField('P_TCLIENTE').value() == 'L') {
           
            widget.container.getActiveWidget().getField('CDCLIENTE').readOnly = false;
            widget.container.getActiveWidget().getField('CDCLIENTE').reload();
            widget.container.getActiveWidget().getField('CDCLIENTE').validations = {required: true};
        } else {
            
            widget.container.getActiveWidget().getField('CDCLIENTE').readOnly = true;
            delete (widget.container.getActiveWidget().getField('CDCLIENTE').validations);
            widget.container.getActiveWidget().getField('CDCLIENTE').setValue('');
        }
    };
     
    this.filtroMunicipioCliente = function(){
        var widget = templateManager.container.getWidget('widgetPedidos');
        
        if (widget.container.getActiveWidget().getField('P_TCDMUNICIPIO').value() == 'L') {
            widget.container.getActiveWidget().getField('CDMUNICIPIO').readOnly = false;
            widget.container.getActiveWidget().getField('CDMUNICIPIO').reload();
            widget.container.getActiveWidget().getField('CDMUNICIPIO').validations = {required: true};
           
        } else {
            widget.container.getActiveWidget().getField('CDMUNICIPIO').readOnly = true;
            delete(widget.container.getActiveWidget().getField('CDMUNICIPIO').validations);
            widget.container.getActiveWidget().getField('CDMUNICIPIO').setValue('');
        }
    };
    
    this.filtroProdutos = function(){
        var widget = templateManager.container.getWidget('widgetPedidos');
        if (widget.container.getActiveWidget().getField('P_TPRODUTO').value() == 'L') {
            
           widget.container.getActiveWidget().getField('CDPRODUTO').readOnly = false;
           widget.container.getActiveWidget().getField('CDPRODUTO').reload();
           widget.container.getActiveWidget().getField('CDPRODUTO').validations = {required: true};
            
        } else {
            
            widget.container.getActiveWidget().getField('CDPRODUTO').readOnly = true;
            delete (widget.container.getActiveWidget().getField('CDPRODUTO').validations);
            widget.container.getActiveWidget().getField('CDPRODUTO').setValue('');
        }
    };
    
    this.salvarEdit = function(){
        var widget = templateManager.container.getWidget('widgetVendedor');
        var data = widget.dataSource.data;
        var result = 0;
        for(var i = 0; i < data.length; i++){
            if(data[i].CDVENDEDOR == widget.currentRow.CDVENDEDOR){
                result++;
            }
        }
        if(result > 1){
            ScreenService.showMessage('Impossível adicionar. Registro já existe.');
        }else{
            var soma = 0;
            var aux;
            var comis = parseFloat(templateManager.container.getActiveWidget().fields[5].value());
            data.forEach(function(x){
                aux = parseFloat(x.VRPECOMITPED);
                soma = soma + aux;
            });
            if(comis > 0){
                if((soma > 0) && (soma <=100)){
                    General.saveCrud(widget);
                }else if(soma > 100){
                    ScreenService.showMessage('Valor total das comissões de um item deve estar entre 0 e 100%.');
                    templateManager.container.getActiveWidget().fields[5].setValue('');
                }
            }else{
                ScreenService.showMessage('Percentual de comissão deve ser maior que zero.');
                templateManager.container.getActiveWidget().fields[5].setValue('');
            }
        }

    };
    
    this.salvar = function(){
        var widget = templateManager.container.getWidget('widgetVendedor');
        if(widget.isValid()){
            var data = templateManager.container.getActiveWidget().dataSource.data;
            var soma = 0;
            var aux;
            data.forEach(function(x){
                aux = parseFloat(x.VRPECOMITPED);
                soma = soma + aux;
            });
            var comis = parseFloat(templateManager.container.getActiveWidget().fields[5].value());
            if(comis > 0){
                if((soma > 0) && (soma <=100)){
                    ScreenService.confirmMessage(ScreenService.i18n('Deseja gravar o percentual de comissão do vendedor para todos os itens do pedido?'), 'question', function (success) {
                       var dataItens = templateManager.container.getWidget('widgetItens').dataSource.data;
                       var dados = [];
                       for(var i = 0; i < dataItens.length; i++){
                           
                            dados[i] = {
                                'CDFILIAL':widget.currentRow.CDFILIAL,
                                'CDVENDEDOR': widget.currentRow.CDVENDEDOR,
                                'NMFANVEN': widget.currentRow.NMFANVEN,
                                'NRITEMPED': dataItens[i].NRITEMPED,
                                'NRPEDIDO': widget.currentRow.NRPEDIDO,
                                'VRPECOMITPED': widget.currentRow.VRPECOMITPED,
                                'IDGERACOMISVEND': 'S',
                                '__is_new': widget.currentRow.__is_new,
                                'changed': widget.currentRow.changed
                           };
                           
                        }
                        General.callRestEngine("ped_pedidos#/vendedor_venditemped_pedido/salvar", "DataSet", dados).then(function(response){
                            dados = [];
                            widget.view();
                            widget.reload();
                            ScreenService.goBack();
                            widget.currentRow = [];
                        }).catch(function(error){
                            ScreenService.showMessage(error.data.error);
                            widget.view();
                            widget.reload();
                            ScreenService.goBack();
                            widget.currentRow = [];
                        });
                	}.bind(this), 
                	function(error) {
                	    var dataSourceWid = widget.dataSource.data;
                	    for(var j = 0; j < dataSourceWid.length; j++){
                	        if(j != (dataSourceWid.length - 1)){
                	            if(widget.dataSource.data[j].__is_new == true){
                	                widget.dataSource.data[j].__is_new = false;
                	            }
                	        }
                	    }
                        General.saveCrud(templateManager.container.getActiveWidget());
                	}.bind(this));
                }else if(soma > 100){
                    ScreenService.showMessage('Valor total das comissões de um item deve estar entre 0 e 100%.');
                    templateManager.container.getActiveWidget().fields[5].setValue('');
                }
            }else{
                ScreenService.showMessage('Percentual de comissão deve ser maior que zero.');
                templateManager.container.getActiveWidget().fields[5].setValue('');
            }
            
        }
    };
 
}
    


Configuration(function(ContextRegister){
    ContextRegister.register('Ped03600_comissaoVendedor_Controller', Ped03600_comissaoVendedor_Controller);
});



// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped04400_previsao_de_vendas_Controller.js
function Ped04400_previsao_de_vendas_Controller(templateManager, ScreenService, General, Ped04400_previsao_de_vendas_Service, restEngine, ZhFilterPreferences, ZHPromise, Exp00200_lancamentoExpedicaoPedido_Service, MessageService) {
    
     this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };
    
    this.filterPrevisao = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetPrev = templateManager.container.getWidget('widgetPrevisao');
        
        if(widget.currentRow.DTPREVIVENDA){
            widgetPrev.dataSourceFilter[0].name = "P_DATA";
            widgetPrev.dataSourceFilter[0].value = widget.currentRow.DTPREVIVENDA.start;
            widgetPrev.dataSourceFilter[1].name = "P_DATAFIN";
            widgetPrev.dataSourceFilter[1].value = widget.currentRow.DTPREVIVENDA.end;
        }
    };
    
    this.filterFix = function(widget){
        widget.dataSourceFilter.forEach(function(element, index){
            if(element.name === "DTPREVIVENDA"){
                widget.dataSourceFilter.splice(index,1);
            }
        });
        widget.reload();
    };
    
    this.getCDFILIALfilter = function(){
    
        Ped04400_previsao_de_vendas_Service.getFilialLogada().then(function(filialLogada) {
            var widget = templateManager.container.getWidget('widgetPrevisao');
            widget.currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
            widget.getField('CDFILIAL').reload();
            widget.currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
            widget.getField('NMFILIAL').reload();
            
        });
    };
    
    this.novaPrevisao = function(widget){
        
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;    
        widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
        widget.currentRow.DTPREVIVENDA = moment().format("DD/MM/YYYY");
    };
    
    this.savePrevisao = function(widget){
        var DTPREVIVENDA = widget.currentRow.DTPREVIVENDA.substring(6,10)+'-'+widget.currentRow.DTPREVIVENDA.substring(3,5)+'-'+widget.currentRow.DTPREVIVENDA.substring(0,2);
        if(DTPREVIVENDA > moment().format("YYYY-MM-DD")){
            General.saveCrud(widget);
        } else if(DTPREVIVENDA === moment().format("YYYY-MM-DD")){
/*            ScreenService.showCustomDialog('Deseja salvar uma previsão de venda para a data de hoje, '+widget.currentRow.DTPREVIVENDA+'?', 'question', 'question', [
                {
                    label: ScreenService.i18n("Sim"),
                    code: function(){
                        General.saveCrud(widget);
                    }
                },
                {
                    label: ScreenService.i18n("Não"),
                    code: function(){}
                }]);
*/
            var messageCode = "PREVISAO_VENDA_MSG";
           
            var messageParameters = {
                "DATA" : widget.currentRow.DTPREVIVENDA
            };
           
            var dialogConfig ={
                type: 'question',
                icon: 'question',
                actions: [
                    {
                    label: ScreenService.i18n("Sim"),
                    code: function(){
        	                General.saveCrud(widget);
            	        }  
                    },  
                    {
                        label: ScreenService.i18n("Não"),
                            code: function(){}
                    }
                ]
            };
            MessageService.showCustomDialogByCode(messageCode, messageParameters, dialogConfig);
            
        } else if(DTPREVIVENDA < moment().format("YYYY-MM-DD")){
            //ScreenService.showMessage('Não é possivel salvar uma previsão de venda para uma data anterior a data de hoje, dia '+moment().format("DD/MM/YYYY"));
            
            var data_previsao = moment().format("DD/MM/YYYY");
            var var_erro_previsao = "ERRO_PREVISAO_MSG";
            MessageService.showMessageByCode(var_erro_previsao,{"DATA":data_previsao});
            widget.currentRow.DTPREVIVENDA = "";
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped04400_previsao_de_vendas_Controller', Ped04400_previsao_de_vendas_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped04900_recalculo_comissao_vendedor_Controller.js
var  Ped04900_recalculo_comissao_vendedor_Controller = function(ScreenService, Ped04900_recalculo_comissao_vendedor_Service, General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
    
    this.recalculoComissaoVendedor = function(widget) {
        
        var cdFilial = widget.currentRow.CDFILIAL;
        var cdProdIni = widget.currentRow.CDPRODINI;
        var cdProdFin = widget.currentRow.CDPRODFIN;
        
        var cdProdFinConcat = cdProdFin.concat('zzzzzzzzzzzzzzzzzzzz');
        var newCdProdFinConcat = cdProdFinConcat.substring(0, 20);
        
        cdProdFin = newCdProdFinConcat;
        
        var row = {
                    "CDFILIAL" : cdFilial,
                    "CDPRODINI": cdProdIni,
                    "CDPRODFIN": cdProdFin
                  };
        
        Ped04900_recalculo_comissao_vendedor_Service.recalculoComissaoVendedor(row).then(function(response){
            ScreenService.showMessage("Recálculo realizado com sucesso.");
        });
    };
    
};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped04900_recalculo_comissao_vendedor_Controller', Ped04900_recalculo_comissao_vendedor_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped05000_metaVendaComissao_Controller.js
function Ped05000_metaVendaComissao_Controller(General, templateManager, ScreenService, Ped05000_metaVendaComissao_Service, ZhFilterPreferences) {

    var  mensagens = {
        valorInicial : 'Valor Inicial inválido!',
        valorFinal: 'Valor Final inválido!',
        produtoFinal: 'Produto Final não pode ser menor que o produto inicial!',
        valorComissao: 'Comissão(%) deve estar entre 0 e 100!',
        preencherCampos: 'Preencha os filtros antes de realizar o cadastro Automatico!',
        sucessoCadastro: 'Cadastro automático realizado com sucesso!',
        checkedRows: 'Selecione produtos antes de realizar o cadastro automático!'
    };
    
    this.saveProduto = function(widget) {
       var widgetMetaVenda = templateManager.container.getWidget('METAVENDA').currentRow;
       widget.currentRow.CDMETAVENDA = widgetMetaVenda.CDMETAVENDA;
       General.saveCrud(widget);
    };
    
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODUTOFIN').readOnly = !row.NMPRODUTOINI;
        widget.getField('NMPRODUTOFIN').readOnlyOnEdit = !row.NMPRODUTOINI;
        this.prodFin(widget);
    };
   
    this.getNrorg = function(){
        return templateManager.container.getWidget('METAVENDA').currentRow.NRORG;
    };
    
    this.prodFin = function(widget){
       
        var row = widget.currentRow;
    
        if (row.CDPRODUTOINI > row.CDPRODUTOFIN){
            ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
            return 0;
        }

        widget.reload();
    };
    
    this.editMetaVenda = function(widget) {
        widget.edit();
    };
   
    this.cancelarCadastroAutomaticoProduto = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('PRODUTOS');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
    };
    
    this.newMeta = function(widget) {
        widget.newRow();
        widget.widgets[0].enabled = false;
        widget.widgets[1].enabled = false;
        
        var nrseq;
        nrseq.push('METAVENDCOM');
        Ped05000_metaVendaComissao_Service.getNrSeq(nrseq).then(function(success){
          widget.currentRow.NRMETAVENDCOM = success.dataset.data[0];
        });
    };
    
    this.unlockFaixaFinal = function(args) {
        var row = args.owner.field.widget.currentRow;
        
        args.owner.field.widget.getField('FXFINAL').readOnly = !row.FXINICIAL;
        args.owner.field.widget.getField('FXFINAL').readOnlyOnEdit = !row.FXINICIAL;
        args.owner.field.widget.getField('FXFINAL').clearValue();
    };
    
    this.filterTabbed = function(widget) {
        if(widget.mode == 'list') {
            widget.dataSourceFilter[0].value = templateManager.container.getWidget('METAVENCOMISSAO').currentRow.NRMETAVENDCOM;
            widget.reload();   
        }
    };
   
    this.openFilter = function(widget){
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    
    
    this.openPopupCadastroProdutos = function() {
        var widgetMetaVenda = templateManager.container.getWidget('METAVENDA').currentRow;
        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widgetPopup.currentRow.CDMETAVENDA = widgetMetaVenda.CDMETAVENDA;
        widgetPopup.currentRow.NMMETAVENDA = widgetMetaVenda.NMMETAVENDA;
        widgetPopup.isVisible = true;
        ScreenService.openPopup(widgetPopup);
    };
    
    this.openPopupCadastroVendedor = function() {
        var widgetMetaVenda = templateManager.container.getWidget('METAVENDA').currentRow;
        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOVENDEDOR');
        widgetPopup.currentRow.CDMETAVENDA = widgetMetaVenda.CDMETAVENDA;
        widgetPopup.currentRow.NMMETAVENDA = widgetMetaVenda.NMMETAVENDA;
        widgetPopup.isVisible = true;
        ScreenService.openPopup(widgetPopup);
    };

    this.cancelEdit = function(widget) {
       if(this.formChangeTemplate(widget) && widget.parent) {
            var widgets = widget.parent.widgets;

            this.changeWidgetAcessibility(widgets.concat(widget.parent), true);
        } else this.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        widget.widgets[0].enabled = true;
        widget.widgets[1].enabled = true;
    };
    
    this.formChangeTemplate = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };
    
    this.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };
    
    this.cancelarCadastroAutomaticoVendedor = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOVENDEDOR');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('VENDEDOR');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
    };

    this.cadastroAutomaticoVendedor = function(widget) {
        var row = widget.currentRow;
        if (widget.isValid()) {
            Ped05000_metaVendaComissao_Service.cadastroAutomaticoVendedor(row).then(function(response){
                var widgetActivate = templateManager.container.getWidget('VENDEDOR');
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOVENDEDOR');
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetActivate.activate();
                widgetActivate.reload();
            }, function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        } 
    };
    
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05000_metaVendaComissao_Controller', Ped05000_metaVendaComissao_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped05001_equipeVendedorMeta_Controller.js
function Ped05001_equipeVendedorMeta_Controller(templateManager, General, ScreenService, Ped05001_equipeVendedorMeta_Service) {
    var mensagens = {
        equipeNada: "É necessário preencher todos os campos.",
        membroExistente: "Este vendedor já está nesta equipe.",
        equipeExistente: "Já existe uma equipe com este código.",
        portNada: "É necessário selecionar uma equipe."
    };
    var previousRow;
    
    this.filterMembro = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        membrosWidget.dataSourceFilter[0].value = equipeWidget.currentRow.CDEQUIPE;
        membrosWidget.reload();
    };
    
    this.newEquipe = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        this.changeMemberVisibility(false);
        equipeWidget.newRow();
    };
    
    this.returnEquipe = function() {
        ScreenService.goBack();
        this.reloadEquipes();
    };
    
    this.edit = function(widget) {
        this.previousRow = Util.clone(widget.currentRow);
        widget.edit();
    }.bind(this);
    
    this.cancelEdit = function(widget) {
        this.changeMemberVisibility(true);
        this.reloadEquipes();
        if (templateManager.container.getActiveWidget().currentRow.__is_new) {
            ScreenService.closeSwipe();
        } else {
            widget.currentRow = this.previousRow;
            widget.view();
        } 
    }.bind(this);
    
    this.saveEquipe = function(widget) {
        var row = templateManager.container.getActiveWidget();
        
        if (row.isValid()) {
            if (templateManager.container.getActiveWidget().currentRow.__is_new) {
                Ped05001_equipeVendedorMeta_Service.searchEquipe().then(function(membros){
                    var row = widget.currentRow;
                    var found = false;
                    for (var i=0; i<membros.dataset.equipe.length && found == false; i++) {
                        var equipe = membros.dataset.equipe[i];
                        if (row.CDEQUIPE == equipe.CDEQUIPE) {
                            found = true;
                        }
                    }
                    if (found) {
                        //ScreenService.showMessage(mensagens.equipeExistente);
                        ScreenService.showMessage("Já existe uma equipe com este código.");
                    } else {
                        this.changeMemberVisibility(true);
                        widget.saveRow();
                        widget.currentRow.QNTMEMBROS = 0;
                        ScreenService.closeSwipe();
                        widget.reload(); 
                    }
                }.bind(this));
            } else {
                widget.saveRow();
                this.reloadEquipes();
                widget.view();
                widget.reload();
            } 
        } else {
            //ScreenService.showMessage(mensagens.equipeNada);
            ScreenService.showMessage("É necessário preencher todos os campos.");
        }
    };
    
    this.delete = function(widget) {
        General.deleteCrud(widget);
    };
    
    this.newMembro = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        membrosWidget.newRow();
        membrosWidget.currentRow.CDEQUIPE = equipeWidget.currentRow.CDEQUIPE;
        membrosWidget.currentRow.NMEQUIPE = equipeWidget.currentRow.NMEQUIPE;
    };
    
    this.saveMembro = function(widget) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var nrseq = [];
        nrseq.push('EQUIPEVENDEDOR');
        Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
            var row = widget.currentRow;
            var found = false;
            for (var i=0; i<membros.dataset.equipevendedor.length && found == false; i++) {
                var membro = membros.dataset.equipevendedor[i];
                if (row.CDEQUIPE == membro.CDEQUIPE && row.CDVENDEDOR == membro.CDVENDEDOR) {
                    found = true;
                }
            }
            if (found) {
                //ScreenService.showMessage(mensagens.membroExistente);
                ScreenService.showMessage("Este vendedor já está nesta equipe.");
            } else {
                Ped05001_equipeVendedorMeta_Service.getNrSeq(nrseq).then(function(success){
                    widget.currentRow.NRSEQEQUIPEVEND = success.dataset.data[0];
                    widget.currentRow.NRORG = success.dataset.data[1];
                    General.saveCrud(widget);
                    equipeWidget.QNTMEMBROS++; 
                });   
            }
        }.bind(this));
    };
    
    this.changeMemberVisibility = function(isVisible) {
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        if (isVisible) {
            membrosWidget.enabled = true;
        } else {
            membrosWidget.enabled = false;
        }
    };
    
    this.reloadEquipes = function() {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        Ped05001_equipeVendedorMeta_Service.searchEquipe().then(function(equipe){
            equipeWidget.dataSource.data = equipe.dataset.equipe;
        }.bind(this));
        equipeWidget.reload();
    };
    
    this.openExport = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var exportWidget = templateManager.container.getWidget("exportMembros");
        equipeWidget.reload();
        var data = Util.clone(equipeWidget.dataSource.data);
        
        for (var i=0; i<data.length; i++) {
            if(data[i].CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                data.splice(i, 1);
                i--;
            }
        }
        
        exportWidget.dataSource.data = data;
        
        exportWidget.isVisible = true;
        ScreenService.openPopup(exportWidget);
        if (type == 'sub') {
            exportWidget.actions[1].isVisible = true;
            exportWidget.actions[2].isVisible = false;
        } else if (type == 'add') {
            exportWidget.actions[1].isVisible = false;
            exportWidget.actions[2].isVisible = true;
        }
    };
    
    this.exportMembros = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        var checkedRows = widget.getCheckedRows();
        var cancelExport = false;
        
        if (!checkedRows[0]) {
            //ScreenService.showMessage(mensagens.portNada);
            ScreenService.showMessage("É necessário selecionar uma equipe.");
            cancelExport = true;
        }
        
        if (!cancelExport) {
            Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
                var currentMembros = [];
                for (var i=0; i<membros.dataset.equipevendedor.length; i++) {
                    var membro = membros.dataset.equipevendedor[i];
                    if (membro.CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                        currentMembros.push(membro);
                    }
                }
                var rows = [];
                rows[0] = type;
                rows[1] = checkedRows;
                rows[2] = currentMembros;
                Ped05001_equipeVendedorMeta_Service.exportarMembros(rows).then(function(success){
                    ScreenService.showMessage('Membros exportados com sucesso.');
                    ScreenService.closePopup();
                    membrosWidget.reload();
                    this.reloadEquipes();
                    this.closeExport();
                }.bind(this));
            }.bind(this));
        }
    };
    
    this.closeExport = function() {
        var exportWidget = templateManager.container.getWidget("exportMembros");
        exportWidget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.openImport = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var importWidget = templateManager.container.getWidget("importMembros");
        equipeWidget.reload();
        importWidget.isVisible = true;
        
        var data = Util.clone(equipeWidget.dataSource.data);
        
        for (var i=0; i<data.length; i++) {
            if(data[i].CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                data.splice(i, 1);
                i--;
            }
        }
        
        importWidget.dataSource.data = data;
        
        ScreenService.openPopup(importWidget);
        if (type == 'sub') {
            importWidget.actions[1].isVisible = true;
            importWidget.actions[2].isVisible = false;
        } else if (type == 'add') {
            importWidget.actions[1].isVisible = false;
            importWidget.actions[2].isVisible = true;
        }
    };
    
    this.importMembros = function(widget, type) {
        var equipeWidget = templateManager.container.getWidget("equipeWidget");
        var membrosWidget = templateManager.container.getWidget("membrosWidget");
        var checkedRows = widget.getCheckedRows();
        var cancelImport = false;
        
        if (!checkedRows[0]) {
            //ScreenService.showMessage(mensagens.portNada);
            ScreenService.showMessage("É necessário selecionar uma equipe.");
            cancelImport = true;
        }
        
        if (!cancelImport) {
            Ped05001_equipeVendedorMeta_Service.searchMembros().then(function(membros){
                var currentMembros = [];
                for (var i=0; i<membros.dataset.equipevendedor.length; i++) {
                    var membro = membros.dataset.equipevendedor[i];
                    if (membro.CDEQUIPE == equipeWidget.currentRow.CDEQUIPE) {
                        currentMembros.push(membro);
                    }
                }
                var rows = [];
                rows[0] = type;
                rows[1] = checkedRows;
                rows[2] = currentMembros;
                rows[3] = equipeWidget.currentRow;
                Ped05001_equipeVendedorMeta_Service.importarMembros(rows).then(function(success){
                    ScreenService.showMessage('Membros importados com sucesso.');
                    ScreenService.closePopup();
                    this.closeImport();
                    this.reloadEquipes();
                    membrosWidget.reload();
                    widget.reload();
                }.bind(this));
            }.bind(this));
        }
    };
    
    this.closeImport = function() {
        var importWidget = templateManager.container.getWidget("importMembros");
        importWidget.isVisible = false;
        ScreenService.closePopup();
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped05001_equipeVendedorMeta_Controller', Ped05001_equipeVendedorMeta_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped05300_recalculo_preco_pedido_Controller.js
var  Ped05300_recalculo_preco_pedido_Controller = function(ScreenService, Ped05300_recalculo_preco_pedido_Service,General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
                                                            
    this.enableTabPreco = function(){// Habilita  campo preço origem e preço destino de acordo  com o tipo de alteração
       var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
       var tipoRecalc = widgetFormRecalc.currentRow.IDOPCAO;
       
       if(tipoRecalc == '1'){
           
           widgetFormRecalc.getField('DSPRECOBASEINI').validations = {required:true};
           widgetFormRecalc.getField('DSPRECOBASEFIN').reload();
           widgetFormRecalc.getField('DSPRECOBASEINI').reload();
           widgetFormRecalc.getField('DSPRECOBASEFIN').readOnly = false;
           widgetFormRecalc.getField('DSPRECOBASEINI').readOnly = false;
           widgetFormRecalc.getField('DSPRECOBASEFIN').validations = {required:true};
           widgetFormRecalc.actions[0].isVisible = false;
           widgetFormRecalc.actions[1].isVisible = true;
           widgetFormRecalc.reload();

           
       }else{
           widgetFormRecalc.getField('DSPRECOBASEFIN').clearValue();
           widgetFormRecalc.getField('DSPRECOBASEINI').clearValue();
           widgetFormRecalc.getField('DSPRECOBASEFIN').readOnly = true;
           widgetFormRecalc.getField('DSPRECOBASEINI').readOnly = true;
           widgetFormRecalc.getField('DSPRECOBASEFIN').validations = {};
           widgetFormRecalc.getField('DSPRECOBASEINI').validations = {};
           widgetFormRecalc.getField('DSPRECOBASEFIN').reload();
           widgetFormRecalc.getField('DSPRECOBASEINI').reload();
           widgetFormRecalc.actions[0].isVisible = true;
           widgetFormRecalc.actions[1].isVisible = false;
           widgetFormRecalc.reload();
       }
    };  
    
    this.setFilial = function(widget){//seta valor default dos campos Filial, data atual, e tipo alteração
        widget.getField('BODTATUAL').setValue('N');
        widget.getField('IDOPCAO').setValue('0');
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(callback) {
        widget.currentRow.NMFILIAL = callback.dataset.filial[0].NMFILIAL;
        widget.currentRow.CDFILIAL = callback.dataset.filial[0].CDFILIAL;
            
        });
    };
    
    this.checkValidteWidget = function(){// verifica se a widget formulário está válida
        var widgetFormRecalc = templateManager.containers['ped_pedidos#ped05300_recalculo_preco_pedido'].getWidget('widgetRecalPrecoPed');
        
        if(widgetFormRecalc.isValid()){
            this.buscaPedRecalc();
        }else{
            ScreenService.showMessage('Preencha os campos Pedido Inicial e Pedido Final.');
        }
        
    };
    
    
    this.buscaPedRecalc =function(){// busca  os pedidos passíveis de alteração e exibe no grid
        var widgetFormRecalc = templateManager.containers['ped_pedidos#ped05300_recalculo_preco_pedido'].getWidget('widgetRecalPrecoPed');

        var tipoAlterac = widgetFormRecalc.currentRow.IDOPCAO;
        var idAtual = widgetFormRecalc.currentRow.BODTATUAL;
        
        
        
        var row = [];
        
        if(tipoAlterac == "0"){
            row = {
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                BODTATUAL:idAtual,
                IDOPCAO: tipoAlterac
                
            };
            
        }else if(tipoAlterac == "1"){
            row = {
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                CDPRECOBASEINI:widgetFormRecalc.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetFormRecalc.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO: tipoAlterac
                
            };
        }
        widgetFormRecalc.deactivate();
        widgetFormRecalc.isVisible = false;


        ScreenService.openWindow('ped_pedidos#ped05300_recalculo_preco_pedido_grid').then(function(){
            var widgetGrid =  templateManager.containers["ped_pedidos#ped05300_recalculo_preco_pedido_grid"].getWidget('widgetPedRecalc');
            var widgetItensAtual = templateManager.containers["ped_pedidos#ped05300_recalculo_preco_pedido_grid"].getWidget('widgetItemPrecoAtual');
            var widgetItensNovo = templateManager.containers["ped_pedidos#ped05300_recalculo_preco_pedido_grid"].getWidget('widgetItemPrecoAlterado');
            widgetGrid.activate();
            widgetGrid.isVisible = true;
            
            Ped05300_recalculo_preco_pedido_Service.buscaPedRecalc(row).then(function(response){
                widgetGrid.dataSource.data = response.dataset.dataSetRecalc.cdsPedido;
                widgetItensAtual.dataSource.data = response.dataset.dataSetRecalc.cdsItemPedAtual;
                widgetItensNovo.dataSource.data = response.dataset.dataSetRecalc.cdsItemPedNovo;
                
                widgetGrid.reload();
                
            });

        }.bind(this));
    };
    
    this.fechaGridRecalculo = function(){
        var widgetGrid =  templateManager.containers["ped_pedidos#ped05300_recalculo_preco_pedido_grid"].getWidget('widgetPedRecalc');  
        widgetGrid.isVisible = false;
        widgetGrid.deactivate();
        ScreenService.openWindow('ped_pedidos#ped05300_recalculo_preco_pedido').then(function(){
            
            var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
            widgetFormRecalc.isVisible = true;
            widgetFormRecalc.activate();
            widgetFormRecalc.reload();
            
        });
    };
    
    this.recalcVrPedido = function(){ // recalcula o o valor dos pedidos
        var widgetFormRecalc = templateManager.containers['ped_pedidos#ped05300_recalculo_preco_pedido'].getWidget('widgetRecalPrecoPed');
        var widgetPedRecal = templateManager.container.getWidget('widgetPedRecalc');
        var widgetAtiva = templateManager.container.getActiveWidget();
        var tipoAlterac =widgetFormRecalc.currentRow.IDOPCAO;
        var idAtual = widgetFormRecalc.currentRow.BODTATUAL;
        var row = [];
        
        
        if(widgetAtiva.name =="widgetRecalculo"){// valores da row quando recalculo é chamado na widget preço atual /alterado
             row.push({
                CDFILIAL:       widgetPedRecal.currentRow.CDFILIAL,
                NRPEDIDOINI:    widgetPedRecal.currentRow.NRPEDIDO,
                NRPEDIDOFIM:    widgetPedRecal.currentRow.NRPEDIDO,
                CDPRECOBASEINI: widgetPedRecal.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetPedRecal.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO:tipoAlterac
    
            }); 
        }else if(widgetAtiva.name =="widgetPedRecalc" && widgetFormRecalc.isVisible == true){// valores da row quando recalculo é chamado na widget formulário
            row.push({
                CDFILIAL : widgetFormRecalc.currentRow.CDFILIAL,
                NRPEDIDOINI:widgetFormRecalc.currentRow.NRPEDIDOINI,
                NRPEDIDOFIM: widgetFormRecalc.currentRow.NRPEDIDOFIM,
                CDPRECOBASEINI:widgetFormRecalc.currentRow.CDPRECOBASEINI,
                CDPRECOBASEFIN: widgetFormRecalc.currentRow.CDPRECOBASEFIN,
                BODTATUAL:idAtual,
                IDOPCAO:tipoAlterac
                
    
       });
        }else{//verifica os valores marcados no grid e faz um foreach para row
            var checkeds = widgetPedRecal.getCheckedRows();
            var data = widgetPedRecal.dataSource.data;
            
            if(checkeds.length >= 1 && data.length !=  checkeds.length){
                checkeds.forEach(function(check){
                    row.push({
                        CDFILIAL : check.CDFILIAL,
                        NRPEDIDOINI:check.NRPEDIDO,
                        NRPEDIDOFIM: check.NRPEDIDO,
                        CDPRECOBASEINI:check.CDPRECOBASEINI,
                        CDPRECOBASEFIN: check.CDPRECOBASEFIN,
                        BODTATUAL:idAtual,
                        IDOPCAO:tipoAlterac
                    });
                });
            }else if(data.length ==  checkeds.length){
    
                row.push({
                    CDFILIAL : checkeds[0].CDFILIAL,
                    NRPEDIDOINI:checkeds[0].NRPEDIDO,
                    NRPEDIDOFIM: checkeds[checkeds.length-1].NRPEDIDO,
                    CDPRECOBASEINI:checkeds[0].CDPRECOBASEINI,
                    CDPRECOBASEFIN: checkeds[0].CDPRECOBASEFIN,
                    BODTATUAL:idAtual,
                    IDOPCAO:tipoAlterac
    
                });
            }
            
        }
    
        Ped05300_recalculo_preco_pedido_Service.recalcVrPedido(row).then(function(response){
            
            if(widgetAtiva.name == "widgetRecalculo"){
                
                ScreenService.goBack();
                this.buscaPedRecalc();
                
            }else if(widgetAtiva.name == "widgetPedRecalc" && widgetFormRecalc.isVisible == false){
                
                this.buscaPedRecalc();
                
            }else{
                
                widgetFormRecalc.getField('IDOPCAO').setValue('0');
                this.enableTabPreco();
            }
                
           var retorno = response.dataset.codigo;
           var codigos = [];
           var itensNaoAlterados = "1";
           var pedidosNaoAlterados = "2";
           var itensAprov = "3";
           retorno.forEach(function(cod){
               codigos.push(cod.P_NRERRO);
               if(codigos.indexOf(itensAprov) > -1){
                   ScreenService.showMessage('Pedido com itens aprovados. O preço base de alguns pedidos não foi alterado.');
               }else if(codigos.indexOf(pedidosNaoAlterados) > -1){
                   ScreenService.showMessage('Produto sem preço. O preço base de alguns pedidos não foi alterado.');
               }else if(codigos.indexOf(itensNaoAlterados) > -1){
                   ScreenService.showMessage('Produto sem preço. O preço de alguns itens não foi alterado.');
               } else{
                   ScreenService.showMessage('Recálculo realizado com sucesso.');
               } 
           });
           
            /*if(codigo == "0"){
                
                ScreenService.showMessage('Recálculo realizado com sucesso.');
                
            }else if(codigo == "1"){
                
                ScreenService.showMessage('Produto sem preço. O preço de alguns itens não foi alterado.');
                
            }
            else if(codigo == "2"){
                
                ScreenService.showMessage('Produto sem preço. O preço base de alguns pedidos não foi alterado.');
                
            }else if(codigo == "3"){
                
                ScreenService.showMessage('Pedido com itens aprovados. O preço base de alguns pedidos não foi alterado.');
            }*/
            
        }.bind(this));
   
    };
    
    
    
    this.cancelaRecalc = function(widget){
        var widgetFormRecalc = templateManager.container.getWidget('widgetRecalPrecoPed');
        var widgetRecalc = templateManager.container.getWidget('widgetPedRecalc');
        widgetFormRecalc.isVisible = true;
        widgetRecalc.isVisible = false;
        widgetRecalc.actions[0].isVisible = true;
        widgetRecalc.actions[1].isVisible = false;
        widgetRecalc.actions[2].isVisible = false;
        widgetRecalc.actions[3].isVisible = false;

    };
    
    this.setDataSourceFilterGrid = function(widget){//seta o dataSourceFilter da tela de item 
        var widgetItensAtual = templateManager.container.getWidget('widgetItemPrecoAtual');
        var widgetItensNovos = templateManager.container.getWidget('widgetItemPrecoAlterado');

        widgetItensAtual.dataSourceFilter = [];
        widgetItensNovos.dataSourceFilter= [];
        widgetItensAtual.dataSourceFilter.push({"name": "NRPEDIDO", "operator": "=","value": widget.currentRow.NRPEDIDO});
        widgetItensNovos.dataSourceFilter.push({"name": "NRPEDIDO", "operator": "=","value": widget.currentRow.NRPEDIDO});
        
        if(widgetItensAtual.redraw && widgetItensNovos.redraw){
            widgetItensAtual.redraw();
            widgetItensNovos.redraw();
        }

    };
    

    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('widgetRecalculo');
        widget.activate();
        widget.reload();
    };
    
    this.fechaGridItens = function(){
        var widgetGrid = templateManager.container.getWidget('widgetPedRecalc');
        var widgetDashItens = templateManager.container.getWidget('widgetRecalculo');
        ScreenService.goBack();
        widgetDashItens.deactivate();
        widgetGrid.reload();

    };
    

    
};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped05300_recalculo_preco_pedido_Controller', Ped05300_recalculo_preco_pedido_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped05700_importacao_Solicitacao_Compras_Controller.js
var Ped05700_importacao_Solicitacao_Compras_Controller = function (ScreenService, General, templateManager, restEngine, localStorageEngine, Ped05700_importacao_Solicitacao_Compras_Service, Endereco, ZhFilterPreferences, ZHPromise, Ger01100_Transportadora_Service) {
    
    this.checkedRows   = [];
    
    this.openFilter = function(widget){
            var promises = [];
            promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
            promises.push(ZhFilterPreferences.openFilterWidget(widget));
            ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.controlaVisibilidadeImportar = function (widget){
    	var checkedRows = widget.getCheckedRows();
        
    	if(checkedRows.length > 0){
    		widget.getAction('importarSolicitacoes').isVisible = true;
    	}else{
    		widget.getAction('importarSolicitacoes').isVisible = false;
    	}
    };
    
    this.controlaImportacaoSelectAll = function (widget){
        widget.getCheckedRows().forEach(function(row){
            if(row.IDMARCADO == 'S'){
                widget.unSelectAll();
                ScreenService.showMessage('Existem solicitações já importadas dentre as selecionadas!');
                widget.getAction('importarSolicitacoes').isVisible = false;
            }
        }.bind(this));
    };
    
    this.controlaImportacao = function (widget){
        var row = widget.selectedRow;
        if(row.IDMARCADO == 'S'){
            ScreenService.showMessage('Solicitação já importada!');
            row.__isSelected = false;
            widget.getAction('importarSolicitacoes').isVisible = false;
        }
    };
    
    this.controlaDataSource = function (widget){
        
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": 'FILIAL_LOGADA'
                }
            ];
            
        General.callRestEngine('ped#/crud/paramimppedido', 'FilterData', filter).then(function(callback){
            var row = callback.dataset.paramimppedido[0];
            if(row){
                if(row.IDIMPSCDTENTR == 'S'){
                    widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos_data";
                    widget.getField('DTPROGENTR').isVisible = true;
                    widget.reload();
                }else{
                    widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos";
                    widget.getField('DTPROGENTR').isVisible = false;
                    widget.reload();
                }
            }
            
        });
        
    };
 
    this.setFilter = function(widget){
    	// fazer os campos do filtro iniciarem como falado
    	// todos começam com T
        templateManager.container.getActiveWidget().getField('IDCDFILIAL').value('T');
        templateManager.container.getActiveWidget().getField('IDNRSOLICMP').value('T');
        templateManager.container.getActiveWidget().getField('SUBGRUPFIL').value('T');
        templateManager.container.getActiveWidget().getField('IDPRODUTO').value('T');
    	
    	// data começa com data atual
    };

    this.importaSolicitacao = function (widget){
    	var checkedRows = widget.getCheckedRows();

    // 	widget.getCheckedRows().forEach(function(row){
    //         Ped05700_importacao_Solicitacao_Compras_Service.importarSolicitacoes(row).then(function(response){
    //                 ScreenService.showMessage(response.dataset.importacaoSolicitacoes);
    //         });
    //     }.bind(this));
        var CDFILIAL;
        var TCDFILIAL;
        var CDGRUPPROD;
        var TCDGRUPPROD;
        var CDFATORPRECO;
         
        if(widget.appliedFilter.FILTER_ROW.IDCDFILIAL == 'T'){
            CDFILIAL = '';
            TCDFILIAL = 'T';
        }else{
            CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            TCDFILIAL = '';
        }
    
        if(widget.appliedFilter.FILTER_ROW.SUBGRUPFIL == 'T'){
            CDGRUPPROD = '';
            TCDGRUPPROD = 'T';
        }else{
            CDGRUPPROD = widget.appliedFilter.FILTER_ROW.CDGRUPPROD;
            TCDGRUPPROD = 'T';
        }
        
        if(widget.appliedFilter.FILTER_ROW.NMFATORPRECO != ''){
            CDFATORPRECO = widget.appliedFilter.FILTER_ROW.CDFATORPRECO;
        }else{
            CDFATORPRECO = '';
        }
        
        function setValue(row){
            row.CDGRUPPROD = CDGRUPPROD;
            row.CDFILIAL = CDFILIAL;
            row.TCDGRUPPROD = TCDGRUPPROD;
            row.TCDFILIAL = TCDFILIAL;
            row.CDFATORPRECO = CDFATORPRECO;
        }

        checkedRows.forEach(setValue);
        
        Ped05700_importacao_Solicitacao_Compras_Service.importarSolicitacoes(checkedRows).then(function(callback){
            var widgetRetornoImportacao = templateManager.container.getWidget('popUpRetornoImportacaoSolicitacoes');
            var widget = templateManager.container.getWidget('gridSolicitaCompra');
            var retorno;
            if(callback.dataset){
                 retorno = callback.dataset.retorno;
            }else{
                 retorno = 'importado';
                
            }
            
            if(retorno != 'importado'){
                widgetRetornoImportacao.dataSource.data = retorno;
                ScreenService.openPopup(widgetRetornoImportacao).then(function(){
                    widget.getAction('importarSolicitacoes').isVisible = false;
                    widgetRetornoImportacao.reload();
                });
            }else{
                widget.unSelectAll();
                widget.getAction('importarSolicitacoes').isVisible = false;
                widget.reload();
            }
            
        });
    };
   
    this.newImportacao = function(widget){
		General.newRow(widget);
	};
    
    this.filtroFilial = function(args) {
        var filialOrigem = args.owner.field.widget.currentRow.IDCDFILIAL;
        var CDFILSOLI = args.owner.field.widget.getField('NMFILIAL');

        if (filialOrigem == 'T') {
            
            CDFILSOLI.readOnly = true;
        } else if (filialOrigem == 'L') {
            
            CDFILSOLI.readOnly = false;
        }
        CDFILSOLI.value('');  
        
    };

    this.filtroNrSolicitacao = function(args) {
        var NrSolicitacao = args.owner.field.widget.currentRow.IDNRSOLICMP;
        var NRSOLICMP = args.owner.field.widget.getField('NRSOLICMP');

        if (NrSolicitacao == 'T') {
            
            NRSOLICMP.readOnly = true;
        } else if (NrSolicitacao == 'L') {
            
            NRSOLICMP.readOnly = false;
        }
        NRSOLICMP.value('');
    };
    
    this.filtroProdutoLista = function() {
        var widget = templateManager.container.getActiveWidget();
        var produtos = widget.currentRow.IDPRODUTO;
        var NMPRODUTOINI = widget.getField('NMPRODUTOINI');
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');

        if (produtos == 'T') {
            NMPRODUTOINI.readOnly = true;
            NMPRODUTOFIN.readOnly = true;
            NMPRODUTOFIN.validations = {};
            NMPRODUTOINI.validations = {};
        } else if (produtos == 'L') {
            NMPRODUTOINI.readOnly = false;
            NMPRODUTOFIN.validations.required = true;
            NMPRODUTOINI.validations.required = true;
        }
        NMPRODUTOINI.value('');
        NMPRODUTOFIN.value('');
        widget.currentRow.NMPRODUTOFIN = "";
        widget.currentRow.NMPRODUTOINI = "";
        widget.reload();

    };
    
    this.filtroProdutoInicial = function() {
        var widget = templateManager.container.getActiveWidget();
        var row = widget.currentRow;
        var produtoInicial = row.CDPRODUTOINI;
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');

        if(produtoInicial == undefined || produtoInicial == ''){
            NMPRODUTOFIN.readOnly = true;
            widget.currentRow.NMPRODUTOFIN = "";
            NMPRODUTOFIN.value('');
            widget.reload();
        }else{
            NMPRODUTOFIN.readOnly = false;
        }
        
    };
    
    this.filtroProdutoFinal = function() {
        var widget = templateManager.container.getActiveWidget();
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');
        var produtoInicial = widget.currentRow.CDPRODUTOINI;
        var produtoFinal = widget.currentRow.CDPRODUTOFIN;

        if(produtoInicial > produtoFinal){
            ScreenService.showMessage('Produto Final deve ser maior que o produto inicial!');
            NMPRODUTOFIN.setValue('');
        }
                    
        
    };
    
    this.filtroSubGrup = function(args) {
        var SubGrup = args.owner.field.widget.currentRow.SUBGRUPFIL;
        var CDGRUPPROD = args.owner.field.widget.getField('CDGRUPPROD');

        if (SubGrup == 'T') {
            
            CDGRUPPROD.readOnly = true;
        } else if (SubGrup == 'L') {
            
            CDGRUPPROD.readOnly = false;
        }
        CDGRUPPROD.value('');
    };
    
    this.filtroData = function(args) {
        var setData = templateManager.container.getActiveWidget().currentRow;
        var dataSourceFilter = [
            {
                "name": "DTSOLCMP",
                "operator": "=",
                "value": setData.DTSOLCMP.start
            },
            {
                "name": "DTSOLCMP",
                "operator": "=",
                "value": setData.DTSOLCMP.end
            },
            {
                "name": "DTPROGENTR",
                "operator": "=",
                "value": setData.DTPROGENTR.start
            },
            {
                "name": "DTPROGENTR",
                "operator": "=",
                "value": setData.DTPROGENTR.end
            }
        ];
    };

    this.setDataSourceFilter = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [];
            
            /* CAMPO DE FILIAL NO DATASOURCEFILTER */
            var filiais = '';
            var nrSol = '';
            var subGrupo = '';
            
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                var filial = response.dataset.filial[0].CDFILIAL;

                /* CAMPO DE FILIAL DE PRODUCAO */
                dataSourceFilter.push(
                    {
                        name: "P_FILIPROC",
                        operator: "=",
                        value: filial
                    }
                );
                
                if(rowPopup.IDCDFILIAL == 'T'){
                    dataSourceFilter.push({
                            "name": 'P_TCDFILIAL',
                            "operator": "=",
                            "value": 'T'
                    });
                }else{
                    rowPopup.CDFILIAL.forEach(function(filial){
                        filiais += "_" + filial;
                    });
                    filiais = filiais + "_";
                    
                    dataSourceFilter.push({
                        "name": 'P_CDFILIAL',
                        "operator": "=",
                        "value": filiais
                    });
                }
               
                /* CAMPO DE NRSOLICITAÇÃO NO DATASOURCEFILTER */
                if(rowPopup.IDNRSOLICMP == 'T'){
                    dataSourceFilter.push({
                            "name": 'P_TNRSOLI',
                            "operator": "=",
                            "value": 'T'
                    });
                }else{
                    rowPopup.NRSOLICMP.forEach(function(nrSoli){
                        nrSol += "_" + nrSoli + rowPopup.CDFILISOLICMP;
                    });
                    nrSol = nrSol + "_";
                    
                    dataSourceFilter.push({
                        "name": 'P_NRSOLICMP',
                        "operator": "=",
                        "value": nrSol
                    });
                }
                 
                
                /* CAMPO DE DATA DE SOLICITAÇÃO NO DATASOURCEFILTER */
                dataSourceFilter.push(
                    {
                        "name": 'P_DTDESOLI',
                        "operator": "=",
                        "value": rowPopup.DTSOLCMP.start
                    },
                    {
                        "name": 'P_DTATESOLI',
                        "operator": "=",
                        "value": rowPopup.DTSOLCMP.end
                    },
                    {
                        "name": 'P_DTINIENT',
                        "operator": "=",
                        "value": rowPopup.DTPROGENTR.start
                    },
                    {
                        "name": 'P_DTFINENT',
                        "operator": "=",
                        "value": rowPopup.DTPROGENTR.end
                    }
                );
                
                
                if(rowPopup.CDPRODUTOINI == null || rowPopup.CDPRODUTOFIN == null){
                    dataSourceFilter.push({
                        "name": 'P_TPRODUTO',
                        "operator": "=",
                        "value": 'T'
                    });
                }else{
                    dataSourceFilter.push(
                        {
                            "name": 'PRODINI',
                            "operator": "=",
                            "value": rowPopup.CDPRODUTOINI
                        },
                        {
                            "name": 'PRODFIM',
                            "operator": "=",
                            "value": rowPopup.CDPRODUTOFIN
                        }
                    );   
                }
                
                args.owner.dataSourceFilter = dataSourceFilter;
                args.owner.container.getWidget('gridSolicitaCompra').reload();
            }.bind(this));    
            
            
        }
    };
    
    this.closeRetorno = function(){
        var widget = templateManager.container.getWidget('gridSolicitaCompra');
        ScreenService.closePopup();
        widget.unSelectAll();
        widget.getAction('importarSolicitacoes').isVisible = false;
        widget.reload();
    };
    
};
    
    Configuration(function (ContextRegister) {
	ContextRegister.register('Ped05700_importacao_Solicitacao_Compras_Controller', Ped05700_importacao_Solicitacao_Compras_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped07001_ControleVisitasVendedor_Controller.js
function Ped07001_ControleVisitasVendedor_Controller(Ped07001_ControleVisitasVendedor_Service, ZHPromise, localStorageEngine, Ped00100_lancamentoPedido_Controller, Ped00100_lancamentoPedido_Service, templateManager, ScreenService, General, ZhFilterPreferences) {

    this.operador               = [];
    this.vendedor               = [];
    this.filialLogada           = [];
    this.email                  = [];
    this.dadosFilial            = [];
    this.nrorg                  = [];
    this.parametros             = [];
    this.dataAgevenrealizado    = [];
    this.dataPedidos            = [];
    this.valida                 = true;

    this.openFilter = function(widget){
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    var mensagens =  {
        operadorNaoVinculado: 'Operador não Vinculado a um Vendedor.',
        operadorVinculadoVen: 'Operador Vinculado a mais de um Vendedor.',
        errorEnviarDados: 'Erro ao enviar dados. Tente novamente mais tarde!',
        dadosEnviados: 'Dados enviados com sucesso!'
    };

   this.save = function(widget) {
       if (widget.currentRow.DSJUSTIFICA !== 0) {
            if (widget.currentRow.DSREALIZADO){
                widget.currentRow.DSJUSTIFICA = 2;
            } else {
                widget.currentRow.DSJUSTIFICA = 1;
            }
        }
        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        widget.currentRow.CDREGIAOPED = CDPRIMARY[0];
        widget.currentRow.CDVENDEDOR = CDPRIMARY[1].split("/")[0].replace(" ","");
        widget.currentRow.CDCLIENTE = CDPRIMARY[1].split("/")[1];
        widget.currentRow.DTREALIZADO = widget.currentRow.DTAGEVENDREGIAO;
        widget.paramsNewCode.__new_code_pk = 'AGEVENREALIZADO'+General.getFieldValue('CDVENDEDOR', 'DIARIO')+General.getFieldValue('DTAGEVENDREGIAO', 'DIARIO');
        if (widget.currentRow.NRSEQREALIZADO) {
            widget.currentRow.__is_new = false;
        } else {
            widget.currentRow.__is_new = true;
        }
        General.saveCrud(widget).then(function(){
            templateManager.container.getWidget("DIARIOTABBED").activate();
            if (widget.currentRow.__is_new === true) {
                widget.currentRow.__is_new = false;
            }
            templateManager.container.refresh();
            templateManager.container.getWidget('DIARIO').redraw();
        });
    };

    this.getCodigoVendedor = function() {
        return this.vendedor.CDVENDEDOR;
    };

    this.getCDCLIENTE = function() {
        var widget = templateManager.container.getWidget('DIARIO');
        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        var CDCLIENTE = CDPRIMARY[1].split("/")[1];
        return CDCLIENTE;
    };

    this.getDTHRLANPED = function() {
        var widget = templateManager.container.getWidget('DIARIO');
        var DTAGEVENDREGIAO = widget.currentRow.DTAGEVENDREGIAO.split(" ");
        return DTAGEVENDREGIAO[0]+'%';
    };

    this.abreSwipe = function(args) {
        if(args.row.CDPARENT) {
            var tabbedWidget = templateManager.container.getWidget('DIARIOTABBED');
            tabbedWidget.widgets[0].currentRow = templateManager.container.getWidget('DIARIO').currentRow;
            ScreenService.openSwipe(templateManager.container.getWidget('DIARIOTABBED'));
            templateManager.container.getWidget('DIARIOFORM').view();
        }
    };

    this.closeSwipe = function() {
        templateManager.container.getWidget('DIARIO').activate();
        ScreenService.closeSwipe(templateManager.container.getWidget('DIARIO'));
    };

    this.enablePedidos = function(boolean) {
        templateManager.container.getWidget('PEDIDO').enabled = boolean;
        // if (templateManager.container.getWidget('DIARIOFORM').currentRow.DSREALIZADO ){

        // }
    };

    // --------------------------------DEKTOP e MOBILE-------------------------------------------//

    // --------------------------------------DEKTOP----------------------------------------------//

    this.setFilters = function () {
        var widgetData = templateManager.container.getWidget('PEDIDO');
        widgetData.dataSourceFilter[1].value = '@Ped07001_ControleVisitasVendedor_Controller.getCDCLIENTE()@';
        widgetData.dataSourceFilter[2].value = '@Ped07001_ControleVisitasVendedor_Controller.getDTHRLANPED()@';
    };

    this.setFiltersMobile = function () {
        Ped07001_ControleVisitasVendedor_Service.getData('ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree');
    };

    // --------------------------------------DEKTOP------------------------------------------------//


    // ---------------------------------------MOBILE------------------------------------------------//

	this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
	};

    this.verifyOperator = function (container, args) {
        if (this.valida) {
            args.e.preventDefault();
            this.retornaOperadorLogado().then(function (callback) {
                this.operador = callback[0].CDOPERADOR;
                this.email = callback[0].DSEMAILOPER;
                var filter = [
                    {
                        "name": "CDOPERADOR",
                        "operator": "=",
                        "value": this.operador
                    }
                ];
                return Ped00100_lancamentoPedido_Service.filtraVendedor(filter);
            }.bind(this))
            .then(function(callback){
                if(callback.dataset.vendedor.length && callback.dataset.vendedor.length <= 1){
                    this.vendedor = callback.dataset.vendedor[0];
                    return Ped00100_lancamentoPedido_Service.getLocalVar('CDFILIAL');
                } else if(!callback.dataset.vendedor.length){
                    //ScreenService.showCustomDialog(mensagens.operadorNaoVinculado, 'exclamation', 'exclamation', [{
                    ScreenService.showCustomDialog("Operador não Vinculado a um Vendedor.", 'exclamation', 'exclamation', [{    
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                    return ZHPromise.defer().reject(1);
                } else {
                    //ScreenService.showCustomDialog(mensagens.operadorVinculadoVen, 'exclamation', 'exclamation', [{
                    ScreenService.showCustomDialog("Operador Vinculado a mais de um Vendedor.", 'exclamation', "exclamation", [{
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                    return ZHPromise.defer().reject(2);
                }
            }.bind(this))
            .then(function(callback){
                this.filialLogada = callback;
                var filter = [
                    {
                        "name": "CDOPERADOR",
                        "operator": "=",
                        "value": this.operador
                    }
                ];
                return Ped00100_lancamentoPedido_Service.filtraFilioper(filter);
            }.bind(this))
            .then(function(callback){
                this.dadosFilial = callback.dataset.filioper;
                var filial = [];
                if (this.dadosFilial.length > 1) {
                    for (var i = 0; i < this.dadosFilial.length; i++) {
                        filial.push(this.dadosFilial[i].CDFILIAL);
                    }
                } else {
                    filial = this.dadosFilial[0].CDFILIAL;
                }
                var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "IN",
                        "value": filial
                    }
                ];
                var filterP = [
                    {
                        "name": "CDFILIAL",
                        "operator": "IN",
                        "value": filial
                    }
                ];
                var promises = [];
                promises.push(Ped00100_lancamentoPedido_Service.retornaDadosUnidade(filter));
                promises.push(Ped00100_lancamentoPedido_Service.findParameters(filterP));
                return ZHPromise.all(promises);
            }.bind(this))
            .then(function(callback){
                if(this.dadosFilial.length > 0){
                    openWindow('ped_pedidos#ped07001_controle_visitas_vendedor');
                    this.dadosFilial = callback[0].dataset.filial_empresa_endefili;
                    this.parametros = callback[1].dataset.parampedido;
                    this.valida = false;
                } else {
                    ScreenService.showCustomDialog('Operador não Vinculado a uma Filial', 'exclamation', 'exclamation', [{
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                }
            }.bind(this));
        } else {
            this.valida = true;
        }
    };

    this.sincroniza = function() {
        var filter = [
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": this.vendedor.CDVENDEDOR
            },
            {
                "name": "DTAGEVENDREGIAO",
                "operator": ">=",
                "value": this.getDataSincroniza()
            }
        ];

        Ped07001_ControleVisitasVendedor_Service.getAgeVenRealizado(filter).then(function(success) {
            var filter = [
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": this.vendedor.CDVENDEDOR
                },
                {
                    "name": "DTHRLANPED",
                    "operator": ">=",
                    "value": this.getDataSincroniza()
                }
            ];
            this.dataAgevenrealizado = success.dataset.agevenrealizado_agendavendedor_regiaoped;
            Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree", this.dataAgevenrealizado);
            Ped07001_ControleVisitasVendedor_Service.findPedidos(filter).then(function(success){
                this.dataPedidos = success.dataset.pedido_filial_modpgto;
                Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/pedido_filial_modpgto",   this.dataPedidos);
                ScreenService.showMessage("Sincronização Completa com Sucesso.");
                this.getDataSource();
                var widgetFiltro = templateManager.container.getWidget('DIARIO');
                this.filtroRegiao(widgetFiltro);
                ScreenService.closePopup();
            }.bind(this));
        }.bind(this))
        .catch(function(){
            ScreenService.showMessage("Verifique sua Conexão.");
        }.bind(this));
    };

    this.getDataSource = function() {
       Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree").then(function (success) {
            this.dataAgevenrealizado = success;
            if (this.dataAgevenrealizado.length > 0) {
                Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto").then(function (success) {
                    this.pedidos  = success;
                }.bind(this), function (error) {
                    ScreenService.showMessage(error);
             });
            }
        }.bind(this));
    };

    this.filtroRegiao = function(widget) {
        var compromissos = [];
        compromissos = this.dataAgevenrealizado.filter(function(value){return value.DTAGEVENDREGIAO == moment().format('DD/MM/YYYY') + ' 00:00:00';}.bind(this));
        widget.dataSource.data = compromissos;
        if (templateManager.container) {
            var widgetForm = templateManager.container.getWidget('DIARIOFORM');
            widgetForm.dataSource.data = compromissos;
        }
    };

    this.getDataSincroniza = function() {
        return moment().subtract(30, 'days').calendar();
    };

    this.openFilterPopupDiario = function() {
        var widget = templateManager.container.getWidget('FILTRO');
        ScreenService.openPopup(widget);
        widget.isVisible = true;
        widget.activate();
    };

    this.closeFilterPopupDiario = function() {
        var widget = templateManager.container.getWidget('FILTRO');
        ScreenService.closePopup(widget);
        widget.isVisible = false;
        templateManager.container.getWidget('DIARIO').activate();
    };

    this.filtrarMobileDiario = function() {
        var promises = [];
        promises.push(Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree"));
        promises.push(Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto"));
        ZHPromise.all(promises).then(function(success){
            if (success[0].length > 0 && success[1].length > 0) {
                this.dataAgevenrealizado  = success[0];
                this.pedidos  = success[1];
                var data = moment().format('DD/MM/YYYY');
                var compromissos = [];
                if (templateManager.container.getWidget('FILTRO').currentRow.DTAGEVENDREGIAO) {
                    data = templateManager.container.getWidget('FILTRO').currentRow.DTAGEVENDREGIAO;
                }
                compromissos = this.dataAgevenrealizado.filter(function(value){return value.CDVENDEDOR == this.vendedor.CDVENDEDOR && value.DTAGEVENDREGIAO == data + ' 00:00:00';}.bind(this));
                var widgetData = templateManager.container.getWidget('DIARIO');
                widgetData.dataSource.data = compromissos;
                this.closeFilterPopupDiario();
            }
        }.bind(this), function (error) {
            ScreenService.showMessage(error);
        }.bind(this));
    };

    this.enviarDadosControleVisita = function(widget) {
        Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree").then(function (success) {
            this.dataAgevenrealizado = success;
            Ped07001_ControleVisitasVendedor_Service.enviarDadosControleVisita(success).then(function (callback) {

                widget.dataSource.data = this.dataAgevenrealizado;
                var dataAgevenrea;
                var findAgevenrealizadoFunc = function(value){ return value.CDVENDEDOR == callback.dataset.agevenrealizado[i].CDVENDEDOR && value.CDPARENT == callback.dataset.agevenrealizado[i].CDPARENT && value.DTAGEVENDREGIAO == callback.dataset.agevenrealizado[i].DTAGEVENDREGIAO && value.CDCLIENTE == callback.dataset.agevenrealizado[i].CDCLIENTE;};
                callback.dataset.agevenrealizado.forEach(function(value) { value.__is_new = false;});
                for (var i = 0; i < callback.dataset.agevenrealizado.length; i++) {
                    dataAgevenrea = this.dataAgevenrealizado.find(findAgevenrealizadoFunc);
                    if (callback.dataset.agevenrealizado[i].NRSEQREALIZADO) {
                        dataAgevenrea.NRSEQREALIZADO = callback.dataset.agevenrealizado[i].NRSEQREALIZADO;
                        dataAgevenrea.__is_new = callback.dataset.agevenrealizado[i].__is_new;
                    }
                }
                //ScreenService.showMessage(mensagens.dadosEnviados);
                ScreenService.showMessage("Dados enviados com sucesso!");
                ScreenService.closePopup();
                Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree", this.dataAgevenrealizado).then(function(){
                    this.filtrarMobileDiario();
                }.bind(this),
                function() {
                    //ScreenService.showMessage(mensagens.errorEnviarDados);
                    ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
                }.bind(this));
            }.bind(this), function() {
                //ScreenService.showMessage(mensagens.errorEnviarDados);
                ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
            });
        }.bind(this),
        function() {
            //ScreenService.showMessage(mensagens.errorEnviarDados);
            ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
        });
    };

    this.cancel = function(args) {
        var deferred = ZHPromise.defer();
        if (args.row.__is_new) {
            args.owner.widget.list(true);
            args.owner.widget.dataSource.data.pop();
            args.owner.widget.currentRow = {};
            deferred.resolve();
        } else if (args.owner.widget.mode === 'edit') {
            args.owner.widget.view();
            args.owner.widget.template = "widget/form-view.html";
            deferred.resolve();
            return deferred.promise;
        }
        ScreenService.goBack();
        return deferred.promise;
    };

    this.saveMobile = function(widget) {
        if (widget.currentRow.DSJUSTIFICA !== 0) {
            if (widget.currentRow.DSREALIZADO) {
                widget.currentRow.DSJUSTIFICA = 2;
            } else {
                widget.currentRow.DSJUSTIFICA = 1;
            }
        }

        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        widget.currentRow.CDREGIAOPED = CDPRIMARY[0];
        widget.currentRow.CDVENDEDOR = CDPRIMARY[1].split("/")[0].replace(" ","");
        widget.currentRow.CDCLIENTE = CDPRIMARY[1].split("/")[1];
        widget.currentRow.DTREALIZADO = widget.currentRow.DTAGEVENDREGIAO;
        // widget.paramsNewCode.__new_code_pk = 'AGEVENREALIZADO'+General.getFieldValue('CDVENDEDOR', 'DIARIO')+General.getFieldValue('DTAGEVENDREGIAO', 'DIARIO');
        var teste = this.dataAgevenrealizado.find(function(value){return value.CDVENDEDOR == widget.currentRow.CDVENDEDOR && value.CDPARENT == widget.currentRow.CDPARENT && value.DTAGEVENDREGIAO == widget.currentRow.DTAGEVENDREGIAO && value.CDCLIENTE == widget.currentRow.CDCLIENTE;});
        teste.DSREALIZADO = widget.currentRow.DSREALIZADO;
        teste.DTREALIZADO = widget.currentRow.DTREALIZADO;
        if (teste.NRSEQREALIZADO) {
            teste.__is_new = false;
        } else {
            teste.__is_new = true;
        }
        teste.changed = true;
        Ped07001_ControleVisitasVendedor_Service.setData('ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree', this.dataAgevenrealizado).then(function(){
            templateManager.container.getWidget("DIARIOTABBED").activate();
            templateManager.container.refresh();
            templateManager.container.getWidget('DIARIO').redraw();
            widget.template = "widget/form-view.html";
            widget.view();
        });
    };

    this.lancarPedido = function(widget) {
        openWindow('ped_pedidos#ped00100_lancamento_pedido').then(function(){
            var cliente = {
                "CDCLIENTE": widget.container.getWidget('DIARIO').currentRow.CDCLIENTE,
                "NMRAZSOCCLIE": widget.container.getWidget('DIARIO').currentRow.NMEXPAND,
            };
            Ped00100_lancamentoPedido_Controller.openWidgetFromDiario(true, cliente);
        });
    };

    this.setDataPedido = function() {
        Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto").then(function(success){
            if (templateManager.container) {
                this.dataPedidos = success;
                var widgetPedido = templateManager.container.getWidget("PEDIDO");
                var widgetDiario = templateManager.container.getWidget("DIARIOFORM");
                var data = widgetDiario.currentRow.DTAGEVENDREGIAO.split(' ')[0];
                var pedido = success.filter(function(value){ return value.CDCLIENTE == widgetDiario.currentRow.CDCLIENTE && value.DTHRLANPED == data;});
                widgetPedido.dataSource.data = pedido;
            }
        }.bind(this));
    };
}


Configuration(function(ContextRegister){
    ContextRegister.register('Ped07001_ControleVisitasVendedor_Controller', Ped07001_ControleVisitasVendedor_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped08000_tabela_desconto_Controller.js
function Ped08000_tabela_desconto_Controller(templateManager, ScreenService, General, Ped08000_tabela_desconto_Services, restEngine) {
    var checkedFields = [];
    var checkedFieldsReajuste = [];

    this.novoDesconto = function(args){
        Ped08000_tabela_desconto_Services.getNewNRTABDESC().then(function(success){
            args.owner.widget.newRow();
            args.owner.widget.getField('NRTABDESC').setValue(success.dataset.data[0].NRTABDESC);
            args.owner.widget.currentRow.NRTABDESC = success.dataset.data[0].NRTABDESC;
            args.owner.widget.getField('VRPERDESC').readOnly = false;
            // this.changePercDesconto();
        });
        
    };
    
    this.novoItemDescQtde = function(args){
        var nrtabdesc = templateManager.container.getWidget('tabelaDesconto').currentRow.NRTABDESC;
        var cdproduto = templateManager.container.getWidget('descontoProporcional').currentRow.CDPRODUTO;
        var filter = [
            {
                'NRTABDESC': nrtabdesc,
                'CDPRODUTO': cdproduto
            }
        ];
        General.callRestEngine("ped_pedidos#/getNewNRITTABDESC", "DataSet", filter).then(function(success){
            args.owner.widget.newRow();
            args.owner.widget.getField('NRTABDESC').setValue(nrtabdesc);
            args.owner.widget.currentRow.NRTABDESC = nrtabdesc;
            args.owner.widget.getField('CDPRODUTO').setValue(cdproduto);
            args.owner.widget.currentRow.CDPRODUTO = cdproduto;
            args.owner.widget.getField('NRITTABDESC').setValue(success.dataset.data[0].NRITTABDESC);
            args.owner.widget.currentRow.NRITTABDESC = success.dataset.data[0].NRITTABDESC;
        }).catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
    };

    this.saveTabelaDesconto = function(args){
        General.saveCrud(args.owner.widget);//.then(function(success){
            // General.changeWidgetAcessibility(args.owner.widget.widgets,true);
        // });
    };
    this.changePercDesconto = function(){
        var widget = templateManager.container.getWidget('tabelaDesconto');
        var idtipodesc = widget.getField('IDTIPODESC');
        var vrperdesc = widget.getField('VRPERDESC');
        
        if(idtipodesc.value() == '1'){
            vrperdesc.readOnly = false;
        }else{
            vrperdesc.readOnly = true;
            vrperdesc.setValue(0);
        }
    };
    
    this.changeWidgetAcessibility = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.name == 'tabelaDesconto'){
            if (widget.currentRow.IDTIPODESC == 1){
                // General.changeWidgetAcessibility(widget.widgets, false);
                General.changeWidgetAcessibility([widget.widgets[0]], false);
                General.changeWidgetAcessibility([widget.widgets[1]], false);
            } else if (widget.currentRow.IDTIPODESC == 2){
                General.changeWidgetAcessibility([widget.widgets[0]], true);
                General.changeWidgetAcessibility([widget.widgets[1]], false);
            } else if (widget.currentRow.IDTIPODESC == 3){
                General.changeWidgetAcessibility([widget.widgets[0]], false);
                General.changeWidgetAcessibility([widget.widgets[1]], true);
            }
        }
    };
    
    this.prodDescQtde = function(field){
        var widget = field.widget.container.getWidget('listaItemDescQtde');
        widget.dataSourceFilter = [
            {
                name: "P_NRTABDESC",
                operator: "=",
                value: widget.parent.parent.parent.currentRow.NRTABDESC
            },
            {
                name: "P_CDARVPROD",
                operator: "=",
                value: widget.parent.getField('CDARVPROD').value()
            },
            {
                name: "P_TCDARVPROD",
                operator: "=",
                value: ""
            }
        ];
        
        this.showActionNew(field);
    };
    
    this.savelistaItemDescQuantidade = function(widget){
        if (widget.isValid()) {
            if (parseFloat(widget.currentRow.QTFINDESC) > parseFloat(widget.currentRow.QTINIDESC)) {
                this.validaIntervalo(widget);
            } else {
                ScreenService.showMessage('Quantidade final deve er maior que a quntidade inicial.');
            }
        }
    };
    
    this.validaIntervalo = function(widget) {
        var qtini = widget.currentRow.QTINIDESC;
        var qtfin = widget.currentRow.QTFINDESC;
        
        var filtroIni = [
            {
                "name": "P_NRTABDESC",
                "operator": "=",
                "value": widget.currentRow.NRTABDESC
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": widget.currentRow.CDPRODUTO
            },
            {
                "name": "P_CDARVPROD",
                "operator": "=",
                "value": widget.getParent().currentRow.CDARVPROD
            },
            {
                "name": "QTINIDESC",
                "operator": "BETWEEN",
                "value": [qtini, qtfin]
            }
        ];
        General.callRestEngine('ped_pedidos#/crud/itemtabdesc_quantidade', 'FilterData', filtroIni).then(function(success){
            if (success.dataset.itemtabdesc_quantidade.length <= 0) {
                var filtroFin = [
                    {
                        "name": "P_NRTABDESC",
                        "operator": "=",
                        "value": widget.currentRow.NRTABDESC
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": widget.currentRow.CDPRODUTO
                    },
                    {
                        "name": "P_CDARVPROD",
                        "operator": "=",
                        "value": widget.getParent().currentRow.CDARVPROD
                    },
                    {
                        "name": "QTFINDESC",
                        "operator": "BETWEEN",
                        "value": [qtini, qtfin]
                    }
                ]; 
                General.callRestEngine('ped_pedidos#/crud/itemtabdesc_quantidade', 'FilterData', filtroFin).then(function(success){
                    if (success.dataset.itemtabdesc_quantidade.length <= 0) {
                        General.saveCrud(widget);
                    } else {
                        ScreenService.showMessage('Intervalos de quantidade não podem ser sobrepostos.');
                    }
                });
            } else {
                ScreenService.showMessage('Intervalos de quantidade não podem ser sobrepostos.');
            }
        });
    };
    
    this.showActionNew = function(field){
        var widgetLista = templateManager.container.getWidget('listaItemDescQtde');
        if(field.value().length){
            widgetLista.getAction('add').isVisible = true;
            widgetLista.reload();
        } else {
            widgetLista.getAction('add').isVisible = false;
            widgetLista.reload();
        }
    };
    
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        // widget.reload();
        this.prodFin(widget);
    };
    
    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('listaItemDescProd');
        widget.dataSourceFilter = [
            {
                name: "P_NRTABDESC",
                operator: "=",
                value: widget.getParent().getParent().currentRow.NRTABDESC
            },
            {
                name: "P_CDNIVELPROD",
                operator: "=",
                value: '5'
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            } else { 
                widget.dataSourceFilter.push(
                    {
                        name: "P_PRODINI",
                        operator: "=",
                        value: row.P_PRODINI
                    }
                );
                widget.dataSourceFilter.push(
                    {
                        name: "P_PRODFIN",
                        operator: "=",
                        value: row.P_PRODFIN
                    }
                );
                widget.reload();
            }
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
    };
    
    this.setView = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.VRPERDESC == '0'){
            widget.getAction('deleteListaProd').isVisible = false;
        } else {
            widget.getAction('deleteListaProd').isVisible = true;
        }
    };
    
    this.editListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        General.edit(widget);
        if (widget.currentRow.VRPERDESC == '0'){
            widget.currentRow.is_new = true;
        } else {
            widget.currentRow.is_new = false;
        }
    };
    
    this.deleteListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        General.deleteCrud(widget);/*.then(function(){
            // widget.reload();
        });*/
    };
    
    this.saveListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) { 
            widget.currentRow.NRTABDESC = widget.getParent().getParent().currentRow.NRTABDESC;
            if (widget.currentRow.is_new == true){
                widget.currentRow.__is_new = true;
            } 
            if (widget.currentRow.VRPERDESC > 0) {
                General.saveCrud(widget).then(function(success){
                    ScreenService.showMessage('Salvo com sucesso.');
                }).catch(function(e){
                    ScreenService.showMessage(e.data.error);
                });
            } else if (!widget.currentRow.is_new && widget.currentRow.VRPERDESC == '0') {
                widget.removeRow().then(function () {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                });
            } else {
                widget.view();
            }
        }
    };
    
    /*
    this.savelistaItemDescProd = function(widget){
        
        Ped02300PrecoBaseServices.retornaOperadorLogado().then(function(operadorLogado){
            widget.currentRow.CDOPERATZIPB =  operadorLogado[0].CDOPERADOR;
            General.saveCrud(widget);
        });
        
    };
    
    this.setDataSourceFilterPromocao = function(widget){
        widget.dataSourceFilter = [
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().getParent().currentRow.CDPRECOBASE
            },
            {
                name: "P_DTINIVALIPB",
                operator: "=",
                value: widget.getParent().currentRow.DTINIVALIPB
            },
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.getParent().currentRow.CDPRODUTO
            }
        ];
        widget.reload();
    };
    
    this.getNrorg = function(){
        return templateManager.container.getWidget('promocao').currentRow.NRORG;
    };
    
    this.salvarPromoPrBase = function(widget){
        if(widget.isValid()){
            this.setPreco(widget);
            var dadosPromoPrBase;
            if(widget.currentRow.__is_new){
                dadosPromoPrBase = {
                    "__createdLocal": true,
                    "__index": 4,
                    "__isSelected": false,
                    "__is_new": true,
                    "__notSelectable": false,
                    "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                    "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                    "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                    "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                    "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                    "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                    "DTINIPROMO": widget.currentRow.DTINIPROMO,
                    "DTFINPROMO": widget.currentRow.DTFINPROMO,
                    "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                    "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                    "NRORG": this.getNrorg()
                };
            } else {
                dadosPromoPrBase = {
                    "__index": 2,
                    "__isSelected": false,
                    "__is_new": false,
                    "__notSelectable": false,
                    "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                    "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                    "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                    "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                    "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                    "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                    "DTINIPROMO": widget.currentRow.DTINIPROMO,
                    "DTFINPROMO": widget.currentRow.DTFINPROMO,
                    "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                    "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                    "NRORG": this.getNrorg()
                };
            }
            Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                ScreenService.closeSwipe();
                widget.getField('VRPERBASEPROMO').readOnly = true;
                widget.getField('VRTOTALPROMO').readOnly = false;
                widget.reload();
            }.bind(this), function (error) {
                ScreenService.showMessage(error.dadosPrecoBase.error);
            });
        }
    };
    
    this.editar = function(widget){
        if(widget.currentRow.VRITEPREBASE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDOPERATZIPB = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
            widget.currentRow.CDPRECOBASE = General.getFieldValue('CDPRECOBASE', 'precoBase');
        }
        General.edit(widget);
    };
    
    this.setFieldValor = function(args){
        var row = args.owner.field.widget.currentRow;
        if(row.IDTIPOPROMO != "V"){
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = false;
        } else {
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = true;
        }
    };
    
    this.setPreco = function(widget){
        var porcentagem;
        var row = widget.currentRow;
        row.VRITEPREBASE = General.getFieldValue('VRITEPREBASE','listaItemDescProd');
        if(row.IDTIPOPROMO == "A"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE + porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        } 
        if(row.IDTIPOPROMO == "D"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE - porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        }
    };
    
    this.setView = function(widget){
        if(widget.container.getWidget('listaItemDescProd').getField('VRITEPREBASE').value() == undefined){
            General.changeWidgetAcessibility(widget.widgets,false);
        } else {
            General.changeWidgetAcessibility(widget.widgets,true);
        }
        switch (widget.getParent().getParent().currentRow.IDULTPRECPROMO) {
            case 'S':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            case 'N':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = true;
                break;
        }
        widget.reload();
    };
    
    this.prodIniFator = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFINFATOR').readOnly = !row.NMPRODINIFATOR;
        widget.getField('NMPRODFINFATOR').readOnlyOnEdit = !row.NMPRODINIFATOR;
        this.prodFinFator(widget);
    };
    
    this.prodFinFator = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('produtosFatorAjuste');
        widget.dataSourceFilter = [
            {
                name: "P_CDFATPRECO",
                operator: "=",
                value: General.getFieldValue('CDFATPRECO', 'fator')
            }
        ];
        if(row.NMPRODFINFATOR){
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.editarFator = function(widget){
        if(widget.currentRow.VRFATPRECO == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFATPRECO = General.getFieldValue('CDFATPRECO', 'fator');
        }
        General.edit(widget);
    };
    
    this.validaValor = function(widget){
        if(widget.currentRow.VRPREBASECONV <= 0 || widget.currentRow.VRPREBASECONV == null){
            ScreenService.showMessage("O valor não pode ser menor ou igual a zero.");
        } else { 
            General.saveCrud(widget);
            widget.reload();
        }    
    };
    
    this.preparaExportacao = function(widget){
        checkedFields[0] = widget.getCheckedRows();
        
        var ItemNull = false;
        var ItemCount = 0;
        var ItemNameArray = [];
        var ItemNameString = "";
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFields[0].length; i++){
                if(checkedFields[0][i].CDPRECOBASE == null){
                    ItemNull = true;
                    ItemCount++;
                    ItemNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ItemNull) {
                
                ItemNameString = "'" + ItemNameArray[0] + "'";
                
                for (i = 1; i < ItemNameArray.length; i++) {
                    
                    if(i == ItemNameArray.length-1) {
                        ItemNameString += " e '" + ItemNameArray[i] + "'";
                    } else {
                        ItemNameString += ", '" + ItemNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemNameString + " não possui(em) preço(s).");
                
                var var_produtosSemPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtosSemPreco_msg,{"PRODUTO":ItemNameString});
                return 0;
                
            } else {
                var newWidget = templateManager.container.getWidget("exportItem_popup");
                newWidget.dataSourceFilter = [
                    {
                        "name": "CDPRECOBASE",
                        "operator": "<>",
                        "value": widget.getParent().getParent().currentRow.CDPRECOBASE
                    }
                ];
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                newWidget.reload();
                ScreenService.openPopup(newWidget);
            }
            
            
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();
      widget.isVisible = false;
    };
    
    this.exportPrecos = function(widget){
        checkedFields[1] = widget.getCheckedRows();
        
        restEngine.post("ped_pedidos#/exportarItem",{
            'requestType': 'DataSet', 
            'dataset': [checkedFields]
            
        }).then(function(success) {
            ScreenService.showMessage("Itens importados com sucesso.");
            ScreenService.closePopup();  
        }, function(callback){
            ScreenService.showMessage("Não foi possível exporta os itens selecionados.");
            ScreenService.closePopup();  
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.reajuste = function(widget){
        checkedFieldsReajuste[0] = widget.getCheckedRows();
        
        var ItemReajusteNull = false;
        var ItemReajusteCount = 0;
        var ItemReajusteNameArray = [];
        var ItemReajusteNameString = "";
        
        if(!checkedFieldsReajuste[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFieldsReajuste[0].length; i++){
                if(checkedFieldsReajuste[0][i].CDPRECOBASE == null){
                    ItemReajusteNull = true;
                    ItemReajusteCount++;
                    ItemReajusteNameArray.push(checkedFieldsReajuste[0][i].NMPRODUTO);
                }
            }
            
            if (ItemReajusteNull) {
                
                ItemReajusteNameString = "'" + ItemReajusteNameArray[0] + "'";
                
                for (i = 1; i < ItemReajusteNameArray.length; i++) {
                    
                    if(i == ItemReajusteNameArray.length-1) {
                        ItemReajusteNameString += " e '" + ItemReajusteNameArray[i] + "'";
                    } else {
                        ItemReajusteNameString += ", '" + ItemReajusteNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemReajusteNameString + " não possui(em) preço(s).");
                
                var var_produtosSemPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtosSemPreco_msg,{"PRODUTO":ItemReajusteNameString});
                return 0;
                
            } else {
                ScreenService.showMessage("As promoções desse item vão ser apagados após o reajuste");
                var newWidget = templateManager.container.getWidget("reajuste_popup");
                newWidget.isVisible = true;
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                ScreenService.openPopup(newWidget);
            }
            
        }
    };
    
    this.reajustePrecos = function(widget){
        
        if(widget.currentRow.VRPERBASEPROMO <= 0){
            ScreenService.showMessage("O valor da porcentagem não pode ser menor ou igual a 0;");
            return 0;
        }
        
        checkedFieldsReajuste[1] = widget.currentRow.VRPERBASEPROMO;
        checkedFieldsReajuste[2] = widget.currentRow.DTFIMVALIPB;
        checkedFieldsReajuste[3] = widget.currentRow.IDTIPOREAJUSTE;
        
        
        
        restEngine.post("/reajusteItem",{'requestType': 'DataSet', 'dataset': [checkedFieldsReajuste]}).then(function() {
            ScreenService.showMessage("Itens reajustado com sucesso.");
            ScreenService.closePopup();
            widget.getParent().reload();
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.saveFatorPreco = function(widget){
        if(widget.currentRow.__is_new == true){    
            Ped02300PrecoBaseServices.saveFatorPreco(widget.currentRow).then(function(sucess){
                ScreenService.goBack();
                widget.reload();
            }, function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            General.saveCrud(widget);
        }
    };
    
    this.newRowDesc = function(widget){
        widget.newRow();
        widget.currentRow.CDPRECOBASE = widget.getParent().getParent().currentRow.CDPRECOBASE;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };
    
    this.fieldOnChangePais = function(){
        var widget = templateManager.container.getWidget('desconto_maximo');
        var dadosWidget = templateManager.container.getWidget('desconto_maximo_grid');
        
        if(!widget.getField('NMPAIS').value()) {
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            //ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            
            var var_valorPorcentagem_msg = "PORCENTAGEM_MSG";
            MessageService.showMessageByCode(var_valorPorcentagem_msg,{"FIELD":field.label});
            
            field.clearValue();
        }
    };*/
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped08000_tabela_desconto_Controller', Ped08000_tabela_desconto_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped14000_parametrosWebservice_Controller.js
var Ped14000_parametrosWebservice_Controller = function(Ped14000_parametrosWebservice_Service, ScreenService, templateManager, Endereco, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService){
    
    this.openFilter = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
    };
    this.setFilter = function(widget){
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');
        if (widget===widgetcadAutoCliente){
            widgetcadAutoCliente.currentRow.IDTPCADAUTOCLIE = 'T';
            //widgetcadAutoCliente.getField('IDTPCADAUTOCLIE').setValue ='T';
        }else if ( widget===widgetcadAutoProduto){
            widgetcadAutoProduto.currentRow.IDTPCADAUTOPROD = 'T';
            //widgetcadAutoProduto.getField('IDTPCADAUTPROD').setValue = 'T';
        }else if ( widget===widgetcadAutoModalidade){
            widgetcadAutoModalidade.currentRow.IDTPCADAUTOMOD = 'T';
            //widgetcadAutoModalidade.getField('IDTPCADAUTOMOD').setValue='T';
        }
        
    };
   this.openItens = function(widget){
        var widgetPedidos = templateManager.container.getWidget('widgetPedidos');
        var widgetItens = templateManager.container.getWidget('widgetItens');
        var widgetTabbed = templateManager.container.getWidget('widgetTabbed');
        var filter = [
            {
                "name": "P_NRPEDIDO",
                "operator": "=",
                "value": widgetPedidos.currentRow.NRPEDIDO
            },
            {
                "name": "P_NRITEMPED",
                "operator": "=",
                "value": "T"
            },
            {
                "name": "P_NRSEQWEBSERVICE",
                "operator": "=",
                "value": widgetPedidos.currentRow.NRSEQWEBSERVICE
            }
           
        ];
        widgetItens.activate();
        widgetTabbed.activate();
        widgetItens.dataSourceFilter = filter;
        ScreenService.openSwipe(widgetTabbed);
        widgetItens.reload();

        
        
    };

    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice');
        var widgetModalidade = templateManager.container.getWidget('widgetModPgto');
        var widgetProduto = templateManager.container.getWidget('widgetProdutos');
    
        
        if (widget === widgetWebservice){
            if (widget.currentRow.NRSEQWEBSERVICE != ""){
                widget.getField('NRSEQWEBSERVICE').readOnly = true;
            }else{
                widget.getField('NRSEQWEBSERVICE').readOnly = false;
            }
        }else if (widget === widgetModalidade){
            if (widget.currentRow.DSMODPGTO != ""){
                widget.getField('DSMODPGTO').readOnly = true;
            }else{
                widget.getField('DSMODPGTO').readOnly = false;
            }
        }else if (widget === widgetProduto){
            if (widget.currentRow.NMPRODUTO!= ""){
                widget.getField('NMPRODUTO').readOnly = true;
                widget.getField('NMPRODUTO').reload();
            }else{
                widget.getField('NMPRODUTO').readOnly = false;
                widget.getField('NMPRODUTO').reload();
            }
        }
    };
    
    this.salvaTabelasCliente = function(widget){
        var widgetCliente = templateManager.container.getWidget('widgetClientes');
        var data = {};
        
        var row = {};
        
        if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row).then(function(success){
                
                    ScreenService.showMessage('Cliente salvo com sucesso.');
                    ScreenService.closeSwipe();
                    widgetCliente.reload().then(function(){
                        widgetCliente.activate();
                    });
                
                });
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Cliente já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
            
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row).then(function(success){
                
               
                    ScreenService.showMessage('Cliente editado com sucesso.');
                    ScreenService.closeSwipe();
                    widgetCliente.reload().then(function(){
                        widgetCliente.activate();
                    });
                    
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Cliente já cadastrado neste Webserice.');
                widget.reload();
                
            }.bind(this));
        }
    };
    this.validaCodigoSiteClie = function(widget){
        if(widget.isValid()){
            var codCliente = widget.currentRow.CDCLIENTE;
            var filterClie = [
                {
                    "name":"CDCLIENTE",
                    "operator":"=",
                    "value":widget.currentRow.CDCLIENTE
                }
            ];
            General.callRestEngine('ped#/crud/cliepedweb', 'FilterData', filterClie).then(function(callback){
                var codigos= callback.dataset.cliepedweb;
                var foundCliente = codigos.find(element=>element.CDCLIENTE === codCliente);
                
                if(foundCliente == undefined){
                    var codClieSite =widget.currentRow.CDCLIEEXTERNO;
                    var filterSite = [
                        {
                            "name": "CDCLIEEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDCLIEEXTERNO
                        }
                        
                    ];
                    General.callRestEngine('ped#/crud/cliepedweb', 'FilterData', filterSite).then(function(callback){
                        var codigos= callback.dataset.cliepedweb;
                        var foundSite = codigos.find(element=>element.CDCLIEEXTERNO == codClieSite);
            
                            if(foundSite != undefined){
                                var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outro cliente. Deseja continuar?");
                                ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                                label: ScreenService.i18n("Sim"),
                                code: function(){
                                    this.salvaTabelasCliente(widget);
                                }.bind(this)
                                },{
                                    label: ScreenService.i18n("Não"),
                                    code: function(){}.bind(this)
                                }]);
                                    
                            }else{
                                this.salvaTabelasCliente(widget);
                            }
                    }.bind(this));
                }else{
                    this.salvaTabelasCliente(widget);
                }
            }.bind(this));
        }
    };
    
    this.validaCodigoSiteProd = function(widget){
        if(widget.isValid()){
            var codProdSite =widget.currentRow.CDPRODEXTERNO;
            var codProduto =widget.currentRow.CDPRODUTO;
        
            var filterCdProd =[
                {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": widget.currentRow.CDPRODUTO
                }
                
            ];
            General.callRestEngine('ped#/crud/prodpedweb', 'FilterData', filterCdProd).then(function(callback){
                var codigos= callback.dataset.prodpedweb;
                var foundProduto = codigos.find(element=>element.CDPRODUTO === codProduto);
                
                if(foundProduto == undefined){
                     var filterCdSite = [
                        {
                            "name": "CDPRODEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDPRODEXTERNO
                        }
                    ];
                    General.callRestEngine('ped#/crud/prodpedweb', 'FilterData', filterCdSite).then(function(callback){
                        var codigos= callback.dataset.prodpedweb;
                        var foundCodSite = codigos.find(element=>element.CDPRODEXTERNO === codProdSite);
                        if(foundCodSite != undefined){
                            var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outro produto. Deseja continuar?");
                            ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                            label: ScreenService.i18n("Sim"),
                            code: function(){
                                this.salvaTabelasProduto(widget);
                            }.bind(this)
                            },{
                                label: ScreenService.i18n("Não"),
                                code: function(){}.bind(this)
                            }]);
                                
                        }else{
                            this.salvaTabelasProduto(widget);
                        }
                    }.bind(this));  
                }else{
                    this.salvaTabelasProduto(widget);
                }
            }.bind(this));
        }
    };
    
    this.salvaTabelasProduto = function(widget){
        var widgetProduto = templateManager.container.getWidget('widgetProdutos');
        var data = {};
         if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                
                var row = {};
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row).then(function(success){
                
                    ScreenService.closeSwipe();
                    ScreenService.showMessage('Produto Salvo com sucesso.');
                    widgetProduto.reload().then(function(){
                        
                        widgetProduto.activate();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Produto já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                var row = {};
                
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row).then(function(success){
                
                    ScreenService.closeSwipe();
                    ScreenService.showMessage('Produto editado com sucesso.');
                    widgetProduto.reload().then(function(){
                        
                        widgetProduto.activate();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Produto já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }
    };
    this.openPopupCadastroCliente = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetcadAutoCliente = templateManager.container.getWidget('cadAutoCliente');
        widgetcadAutoCliente.currentRow.NRSEQWEBSERVICE = widgetWebservice.NRSEQWEBSERVICE;
        widgetcadAutoCliente.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetcadAutoCliente.currentRow.DSPRECOBASE = widgetWebservice.DSPRECOBASE;
        widgetcadAutoCliente.currentRow.CDPRECOBASE = widgetWebservice.CDPRECOBASE;
        widgetcadAutoCliente.isVisible = true;
        ScreenService.openPopup(widgetcadAutoCliente );
    };
    
    this.cancelarCadastroAutomatico = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');


        if(widget === widgetcadAutoCliente){
            widgetcadAutoCliente.currentRow.IDTPCADAUTOCLIE = 'T';
            //widgetcadAutoCliente.getField('IDTPCADAUTOCLIE').setValue ='T';
            widgetcadAutoCliente.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoCliente);
        }else if(widget === widgetcadAutoProduto){
            widgetcadAutoProduto.currentRow.IDTPCADAUTOPROD = 'T';
            //widgetcadAutoProduto.getField('IDTPCADAUTPROD').setValue = 'T';
            widgetcadAutoProduto.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoProduto);
        }else if(widget === widgetcadAutoModalidade){ 
            widgetcadAutoModalidade.currentRow.IDTPCADAUTOMOD = 'T';
           // widgetcadAutoModalidade.getField('IDTPCADAUTOMOD').setValue='T';
            widgetcadAutoModalidade.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoModalidade);
        }
    };
    this.disableFieldCadAuto = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');
        if(widget === widgetcadAutoCliente){
            if (widget.currentRow.IDTPCADAUTOCLIE == 'T'){
                widget.getField('CDCLIENTE').readOnly = true;
                widget.getField('CDCLIENTE').clearValue();
                widget.getField('CDCLIENTE').reload();
            }else{
                widget.getField('CDCLIENTE').readOnly = false;
                widget.getField('CDCLIENTE').reload();
                
            }
        }else if (widget === widgetcadAutoProduto){
            if (widget.currentRow.IDTPCADAUTOPROD == 'T'){
                widgetcadAutoProduto.getField('NMPRODFIN').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').clearValue();
                widgetcadAutoProduto.getField('CDPRODUTO').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {};
                widgetcadAutoProduto.getField('NMPRODINI').validations = {};
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {};
                widgetcadAutoProduto.reload();
            }else if(widget.currentRow.IDTPCADAUTOPROD == 'I') {
                widgetcadAutoProduto.getField('CDPRODUTO').clearValue();
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {};
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {required: true};
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = false;
                widgetcadAutoProduto.getField('NMPRODINI').validations = {required: true};
                widgetcadAutoProduto.reload();
            }else if(widget.currentRow.IDTPCADAUTOPROD == 'L'){
                widgetcadAutoProduto.getField('NMPRODFIN').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = false;
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {};
                widgetcadAutoProduto.getField('NMPRODINI').validations = {};
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {required:true};

            }
        }else if ( widget === widgetcadAutoModalidade){
            if (widget.currentRow.IDTPCADAUTOMOD == 'T'){
                widgetcadAutoModalidade.getField('CDMODPGTO').clearValue();
                widgetcadAutoModalidade.getField('CDMODPGTO').readOnly = true;
                widgetcadAutoModalidade.getField('CDMODPGTO').validations = {};
                widgetcadAutoModalidade.reload();
                
            }else{
                widgetcadAutoModalidade.getField('CDMODPGTO').readOnly = false;
                widgetcadAutoModalidade.getField('CDMODPGTO').validations = {required:true};
                widgetcadAutoModalidade.reload();
            }
        }
    };

    this.salvarCadastroAutomaticoCliente = function(widget) {
        var widgetCadAutoClie = templateManager.container.getWidget('cadAutoCliente');
        var IDTPCADAUTOCLIE =widgetCadAutoClie.currentRow.IDTPCADAUTOCLIE;
        var clientesLista = widgetCadAutoClie.currentRow.CDCLIENTE;
        var clientes = "";
        if (IDTPCADAUTOCLIE == 'L'){
            
            clientesLista.forEach(function(cliente){
                clientes += "_" +cliente;
            });
            clientes = clientes + "_";
        }
         
        var row = {};
        if(IDTPCADAUTOCLIE == 'T'){
            row[0]= {
                CDCLIENTE: IDTPCADAUTOCLIE,
                NRSEQWEBSERVICE: widgetCadAutoClie.currentRow.NRSEQWEBSERVICE
            };
        }else{
            
            row[0] = {
                CDCLIENTE: clientes,
                NRSEQWEBSERVICE: widgetCadAutoClie.currentRow.NRSEQWEBSERVICE
            };
        }
        if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoCliente(row).then(function(response){
                var widgetCliente = templateManager.container.getWidget('widgetClientes');
                widgetCadAutoClie.isVisible = false;
                widgetCadAutoClie.currentRow = {};
                ScreenService.closePopup(widgetCadAutoClie);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetCliente.activate();
                widgetCliente.reload();
                widgetCadAutoClie.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
        

    };
    
    this.openCadastroAutomaticoProdutos = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoProduto');
        widgetCadAutoProd.currentRow.NRSEQWEBSERVICE= widgetWebservice .NRSEQWEBSERVICE;
        widgetCadAutoProd.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetCadAutoProd.currentRow.DSPRECOBASE = widgetWebservice.DSPRECOBASE;
        widgetCadAutoProd.currentRow.CDPRECOBASE = widgetWebservice.CDPRECOBASE;
        widgetCadAutoProd.isVisible = true;
        ScreenService.openPopup(widgetCadAutoProd);
    };
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
        
    };
    this.prodFin = function(widget){
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice');

        var row = widget.currentRow;
        widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetWebservice.currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetWebservice.currentRow.CDPRECOBASE
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    this.salvarCadastroAutomaticoProduto = function(widget) {
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoProduto');
        var IDTPCADAUTOPROD = widgetCadAutoProd.currentRow.IDTPCADAUTOPROD;
        var produtoLista = widgetCadAutoProd.currentRow.CDPRODUTO;
        var produtos = "";
        if (IDTPCADAUTOPROD == 'L'){
            
            produtoLista.forEach(function(produto){
                produtos += "_" +produto;
            });
            produtos = produtos+ "_";
        }
        
        var row = {};
        if(IDTPCADAUTOPROD == 'I'){
            row[0]= {
                CDPRODUTO: null,
                P_PRODINI :widgetCadAutoProd.currentRow.P_PRODINI,
                P_PRODFIN :widgetCadAutoProd.currentRow.P_PRODFIN,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE

            };
        }else if (IDTPCADAUTOPROD == 'L'){
            
            row[0] = {
                CDPRODUTO : produtos,
                P_PRODINI :null,
                P_PRODFIN :null,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE
            };
        }else if (IDTPCADAUTOPROD == 'T'){
            row[0] = {
                CDPRODUTO : IDTPCADAUTOPROD,
                P_PRODINI :null,
                P_PRODFIN :null,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE
            };
        }
        
       if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoProduto(row).then(function(response){
                var widgetProduto = templateManager.container.getWidget('widgetProdutos');
                widgetCadAutoProd.isVisible = false;
                widgetCadAutoProd.currentRow = {};
                widgetCadAutoProd.getField('NMPRODINI').readOnly = true;
                widgetCadAutoProd.getField('NMPRODFIN').readOnly = true;
                widgetCadAutoProd.getField('CDPRODUTO').readOnly = true;
                ScreenService.closePopup(widgetCadAutoProd);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetProduto.reload();
                widgetCadAutoProd.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
        
        
    };
    
    this.validaCodigoSiteMod = function(widget){
        if(widget.isValid()){
            var codMod = widget.currentRow.CDMODPGTO;
            var filterMod = [
                {
                    "name": "CDMODPGTO",
                    "operator": "=",
                    "value": widget.currentRow.CDMODPGTO
                }
            ];
            General.callRestEngine('ped#/crud/modpedweb', 'FilterData', filterMod).then(function(callback){
                var codigos= callback.dataset.modpedweb;
                var foundMod = codigos.find(element=>element.CDMODPGTO == codMod);
                
                if(foundMod == undefined){
                    var codModSite =widget.currentRow.CDMODEXTERNO;
                    var filterSite = [
                        {
                            "name": "CDMODEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDMODEXTERNO
                        }
                    ];
                    
                    General.callRestEngine('ped#/crud/modpedweb', 'FilterData', filterSite).then(function(callback){
                        var codigos= callback.dataset.modpedweb;
                        var foundSite = codigos.find(element=>element.CDMODEXTERNO == codModSite);
            
                            if(foundSite != undefined){
                                var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outra modalidade. Deseja continuar?");
                                ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                                label: ScreenService.i18n("Sim"),
                                code: function(){
                                    this.salvaTabelasModalidade(widget);
                                }.bind(this)
                                },{
                                    label: ScreenService.i18n("Não"),
                                    code: function(){}.bind(this)
                                }]);
                                    
                            }else{
                                this.salvaTabelasModalidade(widget);
                            }
                    }.bind(this));  
                }else{
                    this.salvaTabelasModalidade(widget);
                }
            }.bind(this));   
        }
    };
    
    this.salvaTabelasModalidade = function(widget){
        var widgetModPgto = templateManager.container.getWidget('widgetModPgto');
        var data = {};
        if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosModPedWeb(data).then(function(success){
                ScreenService.showMessage('Modalidade salva com sucesso.');
                ScreenService.closeSwipe();
                widgetModPgto.activate();
                widgetModPgto.reload();
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível cadastrar. Modalidade já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]={
                CDMODPGTO:widget.currentRow.CDMODPGTO,
                CDMODEXTERNO:widget.currentRow.CDMODEXTERNO,
                NRSEQWEBSERVICE:widget.currentRow.NRSEQWEBSERVICE,
                __is_new:false,
                changed:true
               
            };
            Ped14000_parametrosWebservice_Service.salvaDadosModPedWeb(data).then(function(success){
                ScreenService.showMessage('Modalidade salva com sucesso.');
                ScreenService.closeSwipe();
                widgetModPgto.activate();
                widgetModPgto.reload();
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Modalidade já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this)); 
        }
        
    };
    this.openCadastroAutomaticoModalidade = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoModalidade');
        widgetCadAutoProd.currentRow.NRSEQWEBSERVICE= widgetWebservice .NRSEQWEBSERVICE;
        widgetCadAutoProd.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetCadAutoProd.isVisible = true;
        ScreenService.openPopup(widgetCadAutoProd);
    };
    
    this.salvacadastroAutomaticoModalidade = function(widget){
        var widgetCadAutoMod = templateManager.container.getWidget('cadAutoModalidade');
        var IDTPCADAUTOMOD= widgetCadAutoMod.currentRow.IDTPCADAUTOMOD;
        var modalidadeLista = widgetCadAutoMod.currentRow.CDMODPGTO;
        var modalidades = "";
        if (IDTPCADAUTOMOD == 'L'){
            
           modalidadeLista.forEach(function(modalidade){
                modalidades += "_" +modalidade;
            });
            modalidades = modalidades+ "_";
        }
        
        var row = {};
        if(IDTPCADAUTOMOD == 'L'){
            row[0]= {
                CDMODPGTO: modalidades,
                NRSEQWEBSERVICE: widgetCadAutoMod.currentRow.NRSEQWEBSERVICE

            };
        }else if (IDTPCADAUTOMOD == 'T'){
            
            row[0] = {
                CDMODPGTO : IDTPCADAUTOMOD,
                NRSEQWEBSERVICE: widgetCadAutoMod.currentRow.NRSEQWEBSERVICE
            };
        }
        if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoModalidade(row).then(function(response){
                var widgetModalidade = templateManager.container.getWidget('widgetModPgto');

                widgetCadAutoMod.isVisible = false;
                widgetCadAutoMod.currentRow = {};
                widgetCadAutoMod.getField('CDMODPGTO').readOnly = true;
                ScreenService.closePopup(widgetCadAutoMod);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetModalidade.reload();
                widgetCadAutoMod.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
};  
    Configuration(function(ContextRegister){
    ContextRegister.register('Ped14000_parametrosWebservice_Controller', Ped14000_parametrosWebservice_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped21000_relatorios_customizaveis_pedidos_Controller.js
function Ped21000_relatorios_customizaveis_pedidos_Controller (General, templateManager, ScreenService, ZHPromise, restEngine, localStorageEngine, ZhFilterPreferences) {
    this.parametros    = [];
    
    this.setNameLayout = function(args){
        
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    this.retornaOperadorLogadoDesk = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        var params = {
            "requestType": "FilterData",
            "filter": filter
        };

        return restEngine.request("ped#/crud/operador", params);
    };
    
    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilial(widget);
            this.setTipoEnd(widget);
        }.bind(this)); 
    };
    this.setTipoEnd = function(widget) {
        var filterWidget = templateManager.container.getActiveWidget();

        filterWidget.currentRow.IDTPENDECLIE = 'P';
        filterWidget.getField('IDTPENDECLIE').setValue('P');

    };
    
    this.setFilial = function(widget){
       // var filterRow = {};
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
           var widget = templateManager.container.getActiveWidget();
            widget.currentRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            widget.currentRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
        });
        
    };
    
    this.openFilter = function(widget) {
        
        var rowsToSet = {};
        var CDVENDEDOR_AUX ;
        this.getOperadorLogado().then(function(success) {
            
            var CDOPERADOR_AUX = success.dataset.operador[0].CDOPERADOR;
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                if(success.dataset.vendedor.length != 0){
                    rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                    rowsToSet.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                    
                    rowsToSet.DTPEDIDO = this.getIntervaloDataFiltro();
                  
                  
                    var filter = [
                        {
                            "name": "IDEXIBPEDIDO",
                            "operator": "=",
                            "value": "2"
                        },
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": "FILIAL_LOGADA"
                        }
                    ];
                    General.callRestEngine("ped#/crud/parampedido", 'FilterData', filter).then(function (success){
                        
                        if(success.dataset.parampedido.length != 0){
                            
                            var widget_aux = templateManager.container.getWidget('widgetRelatorioCustomizavelPedido');
                            widget_aux.getField('NMFANVEN').IDUTRELACVENDCLI_AUX = rowsToSet.IDUTRELACVENDCLI = success.dataset.parampedido[0].IDUTRELACVENDCLI;
                            
                            var filterFilial = [
                                {
                                    "name": "CDFILIAL",
                                    "operator": "=",
                                    "value": "FILIAL_LOGADA"
                                },
                                {
                                    "name": "IDAUTGRUPOP",
                                    "operator": "=",
                                    "value": "TPED"
                                }
                                
                            ];
                            
                            General.callRestEngine("ped#/crud/autgrupop", 'FilterData', filterFilial).then(function (success){
                                
                                if(success.dataset.autgrupop.length != 0){
                                    
                                    var filterOperador = [
                                        {
                                            "name": "CDGRUPOPER",
                                            "operator": "=",
                                            "value": success.dataset.autgrupop[0].CDGRUPOPER
                                        },
                                        {
                                            "name": "CDOPERADOR",
                                            "operator": "=",
                                            "value": CDOPERADOR_AUX
                                        }
                                    ];
                                    
                                    General.callRestEngine("ped#/crud/opergrupop", 'FilterData', filterOperador).then(function (success){
                                    
                                        if(success.dataset.opergrupop.length != 0){
                                           
                                           
                                            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                               
                                                widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                                                widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                                                // widget.container.getActiveWidget().currentRow.NMFANVEN = '';
                                                // widget.container.getActiveWidget().currentRow.CDVENDEDOR = '';
                                           
                                           }.bind(this));
                                           
    
                                        }else{
                                            
                                            this.VerificaParamPedido(widget);
                                            
                                        }
                                        
                                    }.bind(this));
                                    
                                }else{
                                    
                                    this.VerificaParamPedido(widget);
    
                                }
                            
                                
                            }.bind(this));
                        
                        }else{
                            
                            this.VerificaParamPedido(widget);
                            
                        }
                         
                    }.bind(this));
                
                    
                }else{
                    ScreenService.showMessage("Não há operador parametrizado para o vendedor logado.");
                }
                
            }.bind(this));

        }.bind(this));
        
    };
    
    this.setNumPedido = function(){
        var widget = templateManager.container.getActiveWidget();
        var pedidoIni = widget.currentRow.NRPEDIDOINI;
        widget.getField("NRPEDIDOFIM").setValue(pedidoIni);
    };
    /*global moment*/
    this.getIntervaloDataFiltro = function(){
        
        const startOfMonth = moment().startOf('month').format('DD/MM/YYYY');
        var today = moment().format('DD/MM/YYYY');
        
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : startOfMonth
        };
        
        return interval;
    };
    
    this.getOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
	
    this.reloadDataSoure = function(args){
        args.owner.reload();
    };

    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
   
    this.setCliente_Vendedor = function(widget,rowsToSet){
    
        var filterVendedor = [
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": templateManager.container.getActiveWidget().currentRow.CDVENDEDOR
            }
        ];
        

        General.callRestEngine("ped#/crud/cliente_vendedor", 'FilterData', filterVendedor).then(function (success){
            
            if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function () {
                    
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                    widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                    
                }.bind(this));

            }else{
                
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                
            }
        
        }.bind(this));
            
    };
    this.VerificaParamPedido = function (widget){
        var filterFilial = [
            {
                name: 'CDFILIAL',
                operator: '=', 
                value: 'FILIAL_LOGADA'
                
            }
        ];
        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filterFilial).then(function(callback) {
            var filial = callback.dataset.parampedido[0].CDFILIAL;
            if (callback.dataset.parampedido[0].IDEXIBPEDIDO == '2') {
                this.retornaOperadorLogadoDesk().then(function(operador){
                    var cdoperador = operador.dataset.operador[0].CDOPERADOR;
                    var filterOper = [
                        {
                            name: 'CDOPERADOR',
                            operator: '=',
                            value: cdoperador
                        }
                    ];
                    var filter_autgrupop = [
                        {
                            name: 'IDAUTGRUPOP',
                            operator: '=',
                            value: 'TPED'
                        },
                        {
                            name: 'CDFILIAL',
                            operator: '=',
                            value: filial
                        }
                    ];
                    var filter_vendedor = [
                        {
                            name: 'CDOPERADOR',
                            operator: '=',
                            value: cdoperador
                        }
                    ];
                    
                    var promises = [];
                    promises.push(General.callRestEngine('ped#/crud/opergrupop', 'FilterData', filterOper));
                    promises.push(General.callRestEngine('ped#/crud/autgrupop', 'FilterData', filter_autgrupop));
                    promises.push(General.callRestEngine('ped#/crud/vendedor', 'FilterData', filter_vendedor));
                    ZHPromise.all(promises).then(function(callback) {
                        var gruoper = callback[0].dataset.opergrupop.filter(function(value){ return value.CDOPERADOR == cdoperador && callback[1].dataset.autgrupop[0] && value.CDGRUPOPER == callback[1].dataset.autgrupop[0].CDGRUPOPER;});
                        var filterWidget = templateManager.container.getActiveWidget();
                        if (!gruoper || gruoper.length <= 0) {
                            if (callback[2].dataset.vendedor.length == 1) {
                                if (callback[2].dataset.vendedor.length == 1) {
                                
                                    filterWidget.currentRow.CDVENDEDOR = callback[2].dataset.vendedor[0].CDVENDEDOR;
                                    filterWidget.currentRow.NMFANVEN = callback[2].dataset.vendedor[0].NMFANVEN;
                                    filterWidget.getField('NMFANVEN').readOnly = true;
                                }
                            } else {
                                ScreenService.showMessage('Operador não relacionado a um vendedor.');
                            }
                        }else{
                            filterWidget.currentRow.CDVENDEDOR = callback[2].dataset.vendedor[0].CDVENDEDOR;
                            filterWidget.currentRow.NMFANVEN = callback[2].dataset.vendedor[0].NMFANVEN;
                        }
                        
                    }.bind(this));
                });
            }
        }.bind(this));
        
    };
    
    this.disableSitPedido = function(){
        var filterWidget = templateManager.container.getActiveWidget();
        
        if(filterWidget.currentRow.NOTAFISCAL){
            filterWidget.getField('IDSITPEDIDO').clearValue();
            filterWidget.getField('IDSITPEDIDO').setValue(["3", "6"]);
            filterWidget.getField('IDSITPEDIDO').readOnly = true;
            
        }else{
            filterWidget.getField('IDSITPEDIDO').readOnly = false;
            filterWidget.getField('IDSITPEDIDO').clearValue();
        }
    };
     
   
    this.setDataSourceFilterApply = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
    
            var dataSourceFilter= [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                },
                {
                    "name": "DTPEDIDO",
                    "operator": "BETWEEN",
                    "value": [rowPopup.DTPEDIDO.start, rowPopup.DTPEDIDO.end]
                }
            ];
            
            if(rowPopup.DTENTPED.start != ''){
                dataSourceFilter.push(
                    {
                        "name": "DTENTPED",
                        "operator": "BETWEEN",
                        "value": [rowPopup.DTENTPED.start, rowPopup.DTENTPED.end]
                    }
                );
            }
            
            if(rowPopup.IDSITPEDIDO !== undefined){
                if(rowPopup.IDSITPEDIDO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "IDSITPEDIDO",
                            "operator": "IN",
                            "value": rowPopup.IDSITPEDIDO
                        }
                    );
                }
            }
            
            if(rowPopup.IDPRIOPED != undefined){
                if(rowPopup.IDPRIOPED != null){ 
                    dataSourceFilter.push(
                        {
                            "name": "IDPRIOPED",
                            "operator": "=",
                            "value": rowPopup.IDPRIOPED
                        }
                    );
                }
            }
            
            if (rowPopup.CDVENDEDOR != undefined){
                dataSourceFilter.push(
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": rowPopup.CDVENDEDOR
                    }
                );
                
            }
            
            if(rowPopup.CDFILIALPED != undefined){
                if(rowPopup.CDFILIALPED != '' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDFILIALPED",
                            "operator": "=",
                            "value": rowPopup.CDFILIALPED
                        }
                    );
                }
            }
            
            if(rowPopup.CDPRECOBASE != undefined){
                if(rowPopup.CDPRECOBASE != '' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDPRECOBASE",
                            "operator": "=",
                            "value": rowPopup.CDPRECOBASE
                        }
                    );
                }
            }
            
            if (rowPopup.CDTIPOOPER != undefined){
                if(rowPopup.CDTIPOOPER != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPOOPER",
                            "operator": "=",
                            "value": rowPopup.CDTIPOOPER
                        }
                    );
                }
            }
            
            if(rowPopup.IDTIPOPEDIDO != undefined){
                dataSourceFilter.push(
                    {
                        "name": "IDTIPOPEDIDO",
                        "operator": "IN",
                        "value": rowPopup.IDTIPOPEDIDO
                    }
                );
            }
            
            if(rowPopup.IDORIGPED != undefined){
                if(rowPopup.IDORIGPED != null){
                    dataSourceFilter.push(
                        {
                            "name": "IDORIGPED",
                            "operator": "=",
                            "value": rowPopup.IDORIGPED
                        }
                    );
                }
            }
            
            if (rowPopup.NRORDEMCMPPED != undefined){
                if(rowPopup.NRORDEMCMPPED!= ''){
                    dataSourceFilter.push(
                        {
                            "name": "NRORDEMCMPPED",
                            "operator": "=",
                            "value": rowPopup.NRORDEMCMPPED
                        }
                    );
                }
                
            }
            
            if(rowPopup.NOTAFISCAL == undefined ||rowPopup.NOTAFISCAL == ''){
                dataSourceFilter.push(
                    {
                        "name": "P_TNOTA",
                        "operator": "=",
                        "value": "T"
                    }
                );
                
            }else if(rowPopup.NOTAFISCAL != undefined){
                if(rowPopup.NOTAFISCAL != ''){
                    dataSourceFilter.push(
                        {
                            "name": "NRNOTAFISC",
                            "operator": "=",
                            "value": rowPopup.NOTAFISCAL
                        }
                    );
                }
            }

            if(rowPopup.NRPEDIDOINI != rowPopup.NRPEDIDOFIM){
                dataSourceFilter.push(
                    {
                        "name": "NRPEDIDO",
                        "operator": "BETWEEN",
                        "value": [rowPopup.NRPEDIDOINI, rowPopup.NRPEDIDOFIM]
                    }
                );

            }else if(rowPopup.NRPEDIDOINI == rowPopup.NRPEDIDOFIM &&  rowPopup.NRPEDIDOINI != undefined){
                if(rowPopup.NRPEDIDOINI != ''){
                    dataSourceFilter.push(
                    {
                        "name": "NRPEDIDO",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOINI
                    } 
                );
                }
            }
            
            if(rowPopup.CDCLIENTE != undefined){
                if(rowPopup.CDCLIENTE != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDCLIENTE",
                            "operator": "=",
                            "value": rowPopup.CDCLIENTE
                        }
                    );
                }
            }
            if(rowPopup.IDTPENDECLIE){
                dataSourceFilter.push(
                    {
                        "name": "IDTPENDECLIE",
                        "operator": "=",
                        "value": rowPopup.IDTPENDECLIE
                    }
                );
            }
            
            if (rowPopup.CDPAIS !== undefined){
                if(rowPopup.CDPAIS.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "CDPAIS",
                            "operator": "IN",
                            "value": rowPopup.CDPAIS
                        }
                    );
                }
                
            }
            
            if(rowPopup.SGESTADO !== undefined){
                if(rowPopup.SGESTADO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "SGESTADO",
                            "operator": "IN",
                            "value": rowPopup.SGESTADO
                        }
                    );
                }
            }
            
            if(rowPopup.CDMUNICIPIO !== undefined){
                if(rowPopup.CDMUNICIPIO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "CDMUNICIPIO",
                            "operator": "IN",
                            "value": rowPopup.CDMUNICIPIO
                        }
                    );
                }
            }
            
            if (rowPopup.CDATIVCLI != undefined){
                if(rowPopup.CDATIVCLI != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDATIVCLI",
                            "operator": "=",
                            "value": rowPopup.CDATIVCLI
                        }
                    );
                }
            }
            if (rowPopup.CDSEGMER != undefined){
                if (rowPopup.CDSEGMER != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDSEGMER",
                            "operator": "=",
                            "value": rowPopup.CDSEGMER
                        }
                    );
                    
                }
            }
            
            if(rowPopup.CDROTATRANSPED != undefined){
                if( rowPopup.CDROTATRANSPED !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDROTATRANSPED",
                            "operator": "=",
                            "value": rowPopup.CDROTATRANSPED
                        }
                    );
                }
            }
            
            if(rowPopup.NRINSJURTRAN != undefined){
                if(rowPopup.NRINSJURTRAN !=''){
                    dataSourceFilter.push(
                        {
                            "name": "NRINSJURTRAN",
                            "operator": "=",
                            "value": rowPopup.NRINSJURTRAN
                        }
                    );
                }
            }
            
            if (rowPopup.CDTIPTRANS != undefined){
                if( rowPopup.CDTIPTRANS !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPTRANS",
                            "operator": "=",
                            "value": rowPopup.CDTIPTRANS
                        }
                    );
                }
            }
            
            if (rowPopup.IDPGFRETTRAN != undefined){
                dataSourceFilter.push(
                    {
                        "name": "IDPGFRETTRAN",
                        "operator": "=",
                        "value": rowPopup.IDPGFRETTRAN
                    }
                );
                
            }
            
            if (rowPopup.CDTIPORECE != undefined){
                if(rowPopup.CDTIPORECE !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPORECE",
                            "operator": "=",
                            "value": rowPopup.CDTIPORECE
                        }
                    );
                }
            }
            
            if (rowPopup.CDMODPGTO != undefined){
                if(rowPopup.CDMODPGTO !='' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDMODPGTO",
                            "operator": "=",
                            "value": rowPopup.CDMODPGTO
                        }
                    );
                }
            }
            
            
            args.owner.dataSourceFilter = dataSourceFilter;
  
            args.owner.container.getWidget('widgetRelatorioCustomizavelPedido').reload();
        }

    };
    
    this.setDataSourceFilterField = function(field) {
        var widget = field.widget;
        if(field.name == 'SGESTADO'){
            
            var cdpais = widget.currentRow.CDPAIS;
            
            widget.getField('SGESTADO').dataSourceFilter[0].value = cdpais;
            widget.getField('SGESTADO').reload();
            
        }else if(field.name == 'CDMUNICIPIO'){
            
            var sgestado = widget.currentRow.SGESTADO;
            
            widget.getField('CDMUNICIPIO').dataSourceFilter[0].value = sgestado;
            widget.getField('CDMUNICIPIO').reload();
        }
    };
    
    this.clearDataField = function(fieldName, widget){
        var filterWidget = templateManager.container.getActiveWidget();
      
            if(fieldName == 'CDPAIS'){
                if(widget.currentRow.CDPAIS && widget.currentRow.CDPAIS.length > 0){
                    widget.getField("SGESTADO").readOnly = false;
                    
                }else{
                    widget.getField("SGESTADO").readOnly = true;
                    widget.getField("CDMUNICIPIO").readOnly = true;
                    filterWidget.currentRow.IDTPENDECLIE = 'P';
                    filterWidget.getField('IDTPENDECLIE').setValue('P');
                    
                    
                }
                widget.getField('SGESTADO').setValue([]);
                widget.getField('SGESTADO').reload();
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
        
            }
            else if(fieldName == 'SGESTADO'){
                if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0) {
                    widget.getField("CDMUNICIPIO").readOnly = false;
                } else {
                    widget.getField("CDMUNICIPIO").readOnly = true;
                }
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();

            }
    };
    /*this.setVendedor = function(widget, rowsToSet = {}){
       
        // var rowsToSet = {};
        this.getOperadorLogado().then(function(success) {
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){

                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                    templateManager.container.getActiveWidget().currentRow.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                
                }
                
                rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                
                //verifica se o parametro de relação entre cliente_vendedor está ativo
                if(templateManager.container.getWidget('widgetRelatorioCustomizavelPedido').getField('NMFANVEN').IDUTRELACVENDCLI_AUX == 'S'){

                    this.setCliente_Vendedor(widget,rowsToSet);

                }else{
                    
                    var clienteAtivo = [{
                        
                        "name": "IDCLIEATIV",
                        "operator": "=",
                        "value": "S"
                        
                    }];
                    

                    widget.getField('NMRAZSOCCLIE').dataSource.name = 'ped#/crud/cliente';
                    widget.getField('NMRAZSOCCLIE').dataSourceFilter = clienteAtivo;
                    widget.getField('NMRAZSOCCLIE').reload();
                    
                
                    if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        
                    }
                    
                }
            
            }.bind(this));
            
        }.bind(this));
   };*/
    
}


Configuration(function(ContextRegister) {
	ContextRegister.register('Ped21000_relatorios_customizaveis_pedidos_Controller', Ped21000_relatorios_customizaveis_pedidos_Controller);
});


// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped22000_relacionamento_produtos_importacao_Controller.js
var Ped22000_relacionamento_produtos_importacao_Controller = function(Ped22000_relacionamento_produtos_importacao_Service, ScreenService, templateManager, Endereco, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService){

    this.openFilter = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
    };
    this.visibilidadewidgetProdImportado = function(){
        var widgetProdImportado = templateManager.container.getWidget('widgetProdImportado');
        widgetProdImportado.activate();
        widgetProdImportado.reload();
        
    };
    
    this.salvaProdImp = function(widget){

        var data = {};
 
        if(widget.currentRow.__is_new){
            data[0]={
                CDPRODIMPO: widget.currentRow.CDPRODUTO,
                CDPRODORIG: widget.getParent().currentRow.CDPRODUTO,
                __is_new:true
            };
            Ped22000_relacionamento_produtos_importacao_Service.salvaDadosRelProdImp(data).then(function(success){
                
                ScreenService.showMessage('Produto Importado salvo com sucesso.');
                ScreenService.closeSwipe();
                widget.reload().then(function(){
                    widget.activate();
                });
  
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Produto já cadastrado.');
                widget.reload().then(function(){
                    widget.activate();
                });
                
            }.bind(this));
            
        }
    };
    
    this.validaProdImp = function(widget){
        if(widget.isValid()){
            var prodOrigem = widget.getParent().currentRow.CDPRODUTO;
            
            var filter = [
                {
                    "name":"CDPRODORIG",
                    "operator":"=",
                    "value": prodOrigem
                }
            ];
            General.callRestEngine('ped#/crud/relacprodimpsc', 'FilterData', filter).then(function(callback){
                var codigos= callback.dataset.relacprodimpsc;
                var foundCodigo= codigos.find(element=>element.CDPRODORIG === prodOrigem);
                
                if (foundCodigo != undefined){
                    ScreenService.showMessage('Não é possível relacionar um produto a dois ou mais produtos de integração.');
                    ScreenService.closeSwipe();
                    widget.reload().then(function(){
                        widget.activate();
                    });
                        
                }else{
                    this.salvaProdImp(widget);
                }
               
            }.bind(this));
        }
        
    };



};
Configuration(function(ContextRegister){
    ContextRegister.register('Ped22000_relacionamento_produtos_importacao_Controller', Ped22000_relacionamento_produtos_importacao_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped22000_relatorios_customizaveis_pedidos_itens_Controller.js
function Ped22000_relatorios_customizaveis_pedidos_itens_Controller (ScreenService, General, templateManager, ZhFilterPreferences) {
    
    this.setNameLayout = function(args){
        
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget) {
        
        var rowsToSet = {};
        var CDVENDEDOR_AUX ;
        
        rowsToSet.IDTPENDECLIE = 'P';

        this.getOperadorLogado().then(function(success) {
            
            var CDOPERADOR_AUX = success.dataset.operador[0].CDOPERADOR;
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                rowsToSet.NMFILIAL = response.dataset.filial[0].NMFILIAL;

                rowsToSet.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            });
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                rowsToSet.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                
                rowsToSet.DTPEDIDO = this.getIntervaloDataFiltro();
              
              
                var filter = [
                    {
                        "name": "IDEXIBPEDIDO",
                        "operator": "=",
                        "value": "2"
                    },
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": "FILIAL_LOGADA"
                    }
                ];
        
                General.callRestEngine("ped#/crud/parampedido", 'FilterData', filter).then(function (success){
                    
                    if(success.dataset.parampedido.length != 0){
                        
                        var widget_aux = templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem');
                        widget_aux.getField('CDVENDEDOR').IDUTRELACVENDCLI_AUX = rowsToSet.IDUTRELACVENDCLI = success.dataset.parampedido[0].IDUTRELACVENDCLI;

                        var filterFilial = [
                            {
                                "name": "CDFILIAL",
                                "operator": "=",
                                "value": "FILIAL_LOGADA"
                            },
                            {
                                "name": "IDAUTGRUPOP",
                                "operator": "=",
                                "value": "TPED"
                            }
                            
                        ];
                        
                        General.callRestEngine("ped#/crud/autgrupop", 'FilterData', filterFilial).then(function (success){
                            
                            if(success.dataset.autgrupop.length != 0){
                                
                                var filterOperador = [
                                    {
                                        "name": "CDGRUPOPER",
                                        "operator": "=",
                                        "value": success.dataset.autgrupop[0].CDGRUPOPER
                                    },
                                    {
                                        "name": "CDOPERADOR",
                                        "operator": "=",
                                        "value": CDOPERADOR_AUX
                                    }
                                ];
                                
                                General.callRestEngine("ped#/crud/opergrupop", 'FilterData', filterOperador).then(function (success){
                                
                                    if(success.dataset.opergrupop.length != 0){
                                       
                                       
                                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                           
                                            widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                                            widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                                            widget.container.getActiveWidget().currentRow.NMFANVEN = '';
                                            widget.container.getActiveWidget().currentRow.CDVENDEDOR = '';
                                       
                                       }.bind(this));
                                       

                                    }else{
                                        
                                        this.setVendedor(widget,rowsToSet);
                                        
                                    }
                                    
                                }.bind(this));
                                
                            }else{
                                
                                this.setVendedor(widget,rowsToSet);

                            }
                        
                            
                        }.bind(this));
                    
                        
                    }else{
                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                           
                            widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                            widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                            widget.container.getActiveWidget().currentRow.NMFANVEN = '';
                            widget.container.getActiveWidget().currentRow.CDVENDEDOR = '';
                       
                       }.bind(this));
                        
                        this.setVendedor(widget,rowsToSet);
                        
                    }
                     
                }.bind(this));
                
                
            }.bind(this));

        }.bind(this));
        
    };
    this.setNumPedido = function(){
        var widget = templateManager.container.getActiveWidget();
        var pedidoIni = widget.currentRow.NRPEDIDOINI;
        if(pedidoIni!= undefined && pedidoIni!= ""){
            widget.getField("NRPEDIDOFIM").readOnly = false;
            widget.getField("NRPEDIDOFIM").setValue(pedidoIni);
            widget.getField("NRPEDIDOFIM").reload();  
        }else{
            widget.getField("NRPEDIDOFIM").clearValue();
            widget.getField("NRPEDIDOFIM").readOnly = true;
            widget.getField("NRPEDIDOFIM").reload();
        }
    };
    /*global moment*/
    this.getIntervaloDataFiltro = function(){
        
        const startOfMonth = moment().startOf('month').format('DD/MM/YYYY');
        var today = moment().format('DD/MM/YYYY');
        
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : startOfMonth
        };
        
        return interval;
    };

    this.getOperadorLogado = function(){
        
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
	
    this.setCliente_Vendedor = function(widget,rowsToSet, CDVENDEDOR){
    
        var filterVendedor = [
            {
                "name": "CDVENDEDOR",
                "operator": "IN",
                "value": templateManager.container.getActiveWidget().currentRow.CDVENDEDOR
            }
        ];
        
        General.callRestEngine("ped#/crud/cliente_vendedor", 'FilterData', filterVendedor).then(function (success){
            
            if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function () {
                    
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                    widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                    
                }.bind(this));

            }else{
                
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                widget.container.getActiveWidget().currentRow.NRINSJURCLIE= '';

            }
        
        }.bind(this));
        
    };
    this.disableSitPedido = function(){
        var filterWidget = templateManager.container.getActiveWidget();
        
        if(filterWidget.currentRow.NRNOTAFISC){
            filterWidget.getField('IDSITPEDIDO').clearValue();
            filterWidget.getField('IDSITPEDIDO').setValue(["3", "6"]);
            filterWidget.getField('IDSITPEDIDO').readOnly = true;
            
        }else{
            filterWidget.getField('IDSITPEDIDO').readOnly = false;
            filterWidget.getField('IDSITPEDIDO').clearValue();
        }
    };
     
    
    this.setDataSourceFilterApply = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [];
    
            dataSourceFilter.push(
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                },
                {
                    "name": "DTPEDIDO",
                    "operator": "BETWEEN",
                    "value": [rowPopup.DTPEDIDO.start, rowPopup.DTPEDIDO.end]
                }
                
            );
            
            if(rowPopup.DTEMISSAO != '' && rowPopup.DTEMISSAO != undefined){
                dataSourceFilter.push(
                    {
                        "name": "DTEMISSAO",
                        "operator": "=",
                        "value": rowPopup.DTEMISSAO
                    }
                );
            }
            if(rowPopup.DTENTITPED!= '' && rowPopup.DTENTITPED!= undefined){
                dataSourceFilter.push(
                    {
                        "name": "DTENTITPED",
                        "operator": "=",
                        "value": rowPopup.DTENTITPED
                    }
                );

            }else{
               dataSourceFilter.push(
                    {
                        "name": "P_TDTENTIT",
                        "operator": "=",
                        "value": "T"
                    }
                ); 
            }
            
            if(rowPopup.CDREGIAOPED!= '' && rowPopup.CDREGIAOPED!= undefined){
                dataSourceFilter.push(
                    {
                        "name": "CDREGIAOPED",
                        "operator": "=",
                        "value": rowPopup.CDREGIAOPED
                    }
                );

            }
            if(rowPopup.NRLANCTONF!= '' && rowPopup.NRLANCTONF!= undefined){
                dataSourceFilter.push(
                    {
                        "name": "NRLANCTONF",
                        "operator": "=",
                        "value": rowPopup.NRLANCTONF
                    }
                );

            }
            
            if(rowPopup.NMPRODINI != '' && rowPopup.NMPRODINI != undefined){
                
                dataSourceFilter.push(
                    {
                        "name": "CDARVPROD",
                        "operator": "BETWEEN",
                        "value": [rowPopup.P_PRODINI, rowPopup.P_PRODFIN]
                    }
                );
            }
            
            if(rowPopup.DTENTPED.start != ''){
                dataSourceFilter.push(
                    {
                        "name": "DTENTPED",
                        "operator": "BETWEEN",
                        "value": [rowPopup.DTENTPED.start, rowPopup.DTENTPED.end]
                    }
                );
            }
            
            if(rowPopup.IDSITPEDIDO !== undefined){
                if(rowPopup.IDSITPEDIDO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "IDSITPEDIDO",
                            "operator": "IN",
                            "value": rowPopup.IDSITPEDIDO
                        }
                    );
                }
            }
            if(rowPopup.IDSITITEMPED !== undefined){
                if(rowPopup.IDSITITEMPED.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "IDSITITEMPED",
                            "operator": "IN",
                            "value": rowPopup.IDSITITEMPED
                        }
                    );
                }
            }
            
            if(rowPopup.IDPRIOPED != undefined){
                if(rowPopup.IDPRIOPED != null){ 
                    dataSourceFilter.push(
                        {
                            "name": "IDPRIOPED",
                            "operator": "=",
                            "value": rowPopup.IDPRIOPED
                        }
                    );
                }
            }
            
            if (rowPopup.CDVENDEDOR != undefined && rowPopup.CDVENDEDOR != ""){
                dataSourceFilter.push(
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": rowPopup.CDVENDEDOR
                    }
                );
                
            }
            
            if(rowPopup.CDFILIALPED != undefined){
                if(rowPopup.CDFILIALPED != '' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDFILIALPED",
                            "operator": "=",
                            "value": rowPopup.CDFILIALPED
                        }
                    );
                }
            }
            
            if(rowPopup.CDPRECOBASE != undefined){
                if(rowPopup.CDPRECOBASE != '' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDPRECOBASE",
                            "operator": "=",
                            "value": rowPopup.CDPRECOBASE
                        }
                    );
                }
            }
            
            if (rowPopup.CDTIPOOPER != undefined){
                if(rowPopup.CDTIPOOPER != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPOOPER",
                            "operator": "=",
                            "value": rowPopup.CDTIPOOPER
                        }
                    );
                }
            }
            
            if(rowPopup.IDTIPOPEDIDO != undefined && rowPopup.IDTIPOPEDIDO != ""){
                dataSourceFilter.push(
                    {
                        "name": "IDTIPOPEDIDO",
                        "operator": "IN",
                        "value": rowPopup.IDTIPOPEDIDO
                    }
                );
            }
            
            if(rowPopup.IDORIGPED != undefined){
                if(rowPopup.IDORIGPED != null){
                    dataSourceFilter.push(
                        {
                            "name": "IDORIGPED",
                            "operator": "=",
                            "value": rowPopup.IDORIGPED
                        }
                    );
                }
            }
            
            if (rowPopup.NRORDEMCMPPED != undefined){
                if(rowPopup.NRORDEMCMPPED!= ''){
                    dataSourceFilter.push(
                        {
                            "name": "NRORDEMCMPPED",
                            "operator": "=",
                            "value": rowPopup.NRORDEMCMPPED
                        }
                    );
                }
                
            }
            if(rowPopup.NRLANCTONF == undefined && rowPopup.NRLANCTONF == ''){
                dataSourceFilter.push(
                    {
                        "name": "NRLANCTONF",
                        "operator": "=",
                        "value": rowPopup.NRLANCTONF
                    }
                );
                
            }
            
            if(rowPopup.NRNOTAFISC == undefined || rowPopup.NRNOTAFISC == ''){
                dataSourceFilter.push(
                    {
                        "name": "P_TNOTA",
                        "operator": "=",
                        "value": "T"
                    }
                );
                
            }else if(rowPopup.NRNOTAFISC != undefined){
                if(rowPopup.NRNOTAFISC != ''){
                    dataSourceFilter.push(
                        {
                            "name": "NRNOTAFISC",
                            "operator": "=",
                            "value": rowPopup.NRNOTAFISC
                        }
                    );
                }
            }

            if(rowPopup.NRPEDIDOINI != rowPopup.NRPEDIDOFIM){
                dataSourceFilter.push(
                    {
                        "name": "NRPEDIDO",
                        "operator": "BETWEEN",
                        "value": [rowPopup.NRPEDIDOINI, rowPopup.NRPEDIDOFIM]
                    }
                );

            }else if(rowPopup.NRPEDIDOINI == rowPopup.NRPEDIDOFIM &&  rowPopup.NRPEDIDOINI != undefined){
                if(rowPopup.NRPEDIDOINI != ''){
                    dataSourceFilter.push(
                    {
                        "name": "NRPEDIDO",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOINI
                    } 
                );
                }
            }
            
            if(rowPopup.CDCLIENTE != undefined){
                if(rowPopup.CDCLIENTE != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDCLIENTE",
                            "operator": "=",
                            "value": rowPopup.CDCLIENTE
                        }
                    );
                }
            }
            if(rowPopup.IDTPENDECLIE){
                dataSourceFilter.push(
                    {
                        "name": "IDTPENDECLIE",
                        "operator": "=",
                        "value": rowPopup.IDTPENDECLIE
                    }
                );
            }
            
            if (rowPopup.CDPAIS !== undefined){
                if(rowPopup.CDPAIS.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "CDPAIS",
                            "operator": "IN",
                            "value": rowPopup.CDPAIS
                        }
                    );
                }
                
            }
            
            if(rowPopup.SGESTADO !== undefined){
                if(rowPopup.SGESTADO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "SGESTADO",
                            "operator": "IN",
                            "value": rowPopup.SGESTADO
                        }
                    );
                }
            }
            
            if(rowPopup.CDMUNICIPIO !== undefined){
                if(rowPopup.CDMUNICIPIO.length != 0){
                    dataSourceFilter.push(
                        {
                            "name": "CDMUNICIPIO",
                            "operator": "IN",
                            "value": rowPopup.CDMUNICIPIO
                        }
                    );
                }
            }
            
            if (rowPopup.CDATIVCLI != undefined){
                if(rowPopup.CDATIVCLI != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDATIVCLI",
                            "operator": "=",
                            "value": rowPopup.CDATIVCLI
                        }
                    );
                }
            }
            if (rowPopup.CDSEGMER != undefined){
                if (rowPopup.CDSEGMER != ''){
                    dataSourceFilter.push(
                        {
                            "name": "CDSEGMER",
                            "operator": "=",
                            "value": rowPopup.CDSEGMER
                        }
                    );
                    
                }
            }
            
            if(rowPopup.CDROTATRANSPED != undefined){
                if( rowPopup.CDROTATRANSPED !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDROTATRANSPED",
                            "operator": "=",
                            "value": rowPopup.CDROTATRANSPED
                        }
                    );
                }
            }
            
            if(rowPopup.NRINSJURTRAN != undefined){
                if(rowPopup.NRINSJURTRAN !=''){
                    dataSourceFilter.push(
                        {
                            "name": "NRINSJURTRAN",
                            "operator": "=",
                            "value": rowPopup.NRINSJURTRAN
                        }
                    );
                }
            }
            
            if (rowPopup.CDTIPTRANS != undefined){
                if( rowPopup.CDTIPTRANS !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPTRANS",
                            "operator": "=",
                            "value": rowPopup.CDTIPTRANS
                        }
                    );
                }
            }
            
            if (rowPopup.IDPGFRETTRAN != undefined){
                dataSourceFilter.push(
                    {
                        "name": "IDPGFRETTRAN",
                        "operator": "=",
                        "value": rowPopup.IDPGFRETTRAN
                    }
                );
                
            }
            
            if (rowPopup.CDTIPORECE != undefined){
                if(rowPopup.CDTIPORECE !=''){
                    dataSourceFilter.push(
                        {
                            "name": "CDTIPORECE",
                            "operator": "=",
                            "value": rowPopup.CDTIPORECE
                        }
                    );
                }
            }
            
            if (rowPopup.CDMODPGTO != undefined){
                if(rowPopup.CDMODPGTO !='' ){
                    dataSourceFilter.push(
                        {
                            "name": "CDMODPGTO",
                            "operator": "=",
                            "value": rowPopup.CDMODPGTO
                        }
                    );
                }
            }
            
            
            args.owner.dataSourceFilter = dataSourceFilter;
  
            args.owner.container.getWidget('widgetRelatorioCustomizavelPedidoItem').reload();
        }

    };

    
    this.setVendedor = function(widget, rowsToSet = {}){
       
        // var rowsToSet = {};
        this.getOperadorLogado().then(function(success) {
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){

                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                    templateManager.container.getActiveWidget().currentRow.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                
                }
                
                rowsToSet.NMFANVEN = [success.dataset.vendedor[0].NMFANVEN];
                
                //verifica se o parametro de relação entre cliente_vendedor está ativo
                if(templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('CDVENDEDOR').IDUTRELACVENDCLI_AUX == 'S'){
                    
                    this.setCliente_Vendedor(widget,rowsToSet);

                }else{
                    
                    var clienteAtivo = [{
                        
                        "name": "IDCLIEATIV",
                        "operator": "=",
                        "value": "S"
                        
                    }];
                    

                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').dataSource.name = 'ped#/crud/cliente';
                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').dataSourceFilter = clienteAtivo;
                    templateManager.container.getWidget('widgetRelatorioCustomizavelPedidoItem').getField('NMRAZSOCCLIE').reload();
                    
                
                    if(templateManager.container.getActiveWidget().getField('CDVENDEDOR').readOnly){
                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        
                    }
                    
                }
            
            }.bind(this));
            
        }.bind(this));
    };
    
    this.setDataSourceFilterField = function(field) {
        var widget = field.widget;
        if(field.name == 'SGESTADO'){
            
            var cdpais = widget.currentRow.CDPAIS;
            
            widget.getField('SGESTADO').dataSourceFilter[0].value = cdpais;
            widget.getField('SGESTADO').reload();
            
        }else if(field.name == 'CDMUNICIPIO'){
            
            var sgestado = widget.currentRow.SGESTADO;
            
            widget.getField('CDMUNICIPIO').dataSourceFilter[0].value = sgestado;
            widget.getField('CDMUNICIPIO').reload();
        }
    };
    
    this.clearDataField = function(fieldName, widget){
        var filterWidget = templateManager.container.getActiveWidget();
      
            if(fieldName == 'CDPAIS'){
                if(widget.currentRow.CDPAIS && widget.currentRow.CDPAIS.length > 0){
                    widget.getField("SGESTADO").readOnly = false;
                    
                }else{
                    widget.getField("SGESTADO").readOnly = true;
                    widget.getField("CDMUNICIPIO").readOnly = true;
                    filterWidget.currentRow.IDTPENDECLIE = 'P';
                    filterWidget.getField('IDTPENDECLIE').setValue('P');
                    
                    
                }
                widget.getField('SGESTADO').setValue([]);
                widget.getField('SGESTADO').reload();
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
        
            }
            else if(fieldName == 'SGESTADO'){
                if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0) {
                    widget.getField("CDMUNICIPIO").readOnly = false;
                } else {
                    widget.getField("CDMUNICIPIO").readOnly = true;
                }
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();

            }
    };
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
        
    };
    this.prodFin = function(widget){

        var row = widget.currentRow;
        /*widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetWebservice.currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetWebservice.currentRow.CDPRECOBASE
            }
        ];*/
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };

    this.reloadDataSoure = function(args){
        args.owner.reload();
    };

    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
   
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ped22000_relatorios_customizaveis_pedidos_itens_Controller', Ped22000_relatorios_customizaveis_pedidos_itens_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped29000_manutencaoReserva_Controller.js
var Ped29000_manutencaoReserva_Controller = function(General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, Ped29000_manutencaoReserva_Service){
    
    /*this.fixDate = function (field) {
        this.fixMinDate(field);
        var dtEntPed = field.widget.getField('DTPEDIDO').value();
        dtEntPed = moment(dtEntPed, 'DD/MM/YYYY').add(5,'days').format('DD/MM/YYYY');
        field.widget.getField('DTENTPED').setValue(dtEntPed);
    };*/
    
    /*this.checkData = function(widget) {
	    
		var dataInput = (widget.getField('DTENTPED').value());
	
		if (moment(moment().format('L'), "DD/MM/YYYY") > moment(dataInput, "DD/MM/YYYY")){
			widget.currentRow.DTENTPED = moment().format("DD/MM/YYYY");
			ScreenService.showMessage("Data de Entrega inferior a data atual.");
		}
	};*/

    /*this.setCurrentRowItem = function(widget){
        var row = widget.currentRow;
        if(!row.IDMARCADA){
            row.IDMARCADA = 'S';
            widget.setCurrentRow(row);
        }
    };*/

    this.verifyParameters = function(widget) {

        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            var filter = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": response.dataset.filial[0].CDFILIAL
            }];

            General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
                if(!callback.dataset.parampedido[0]) {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                }
            }.bind(this));
        }.bind(this));
    };

    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
        // this.setFilterDataSourceVazio();
    };
    
    this.setFilter = function(widget) {
        this.verifyParameters(widget);
        var filterRow = {};
        
        var NDate = new Date();
        var today = NDate.getDate() + "/" + parseInt(NDate.getMonth()+1)+ "/" + NDate.getFullYear();
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : '01/12/2021'//today
        };
        
        filterRow.DTPEDIDO = interval;
        
        // var filial;
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            // filial = response.dataset.filial[0].CDFILIAL;
            
            templateManager.container.getActiveWidget().currentRow = filterRow;

        }.bind(this));
        
    };
    
    this.setActiveTab = function(nameWidget){
        const widget = templateManager.container.getWidget(nameWidget);
        widget.activate();
    };
    
    this.backItemReserva = function(args) {
        var widgetItem = templateManager.container.getWidget('itens');
        widgetItem.rollbackInlineEdit();
        
        var widgetReserva = templateManager.container.getWidget('reserva');
        widgetReserva.rollbackInlineEdit();
    };
    
    this.actvateView = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        widgetPrincipal.activate();
        widgetPrincipal.view();
        this.actvateList();
    };
    
    this.actvateList = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        widgetPrincipal.list();
    };
    
    this.setDataSourceFilterItem = function(widget) {
        var widItens = templateManager.container.getWidget('itens');
        widItens.dataSourceFilter = [];
        widItens.dataSourceFilter.push(
            {
                name: "CDFILIAL",
                operator: "=",
                value: General.getFieldValue('CDFILIAL','widgetPrincipal')
            }
        );
        widItens.dataSourceFilter.push(
            {
                name: "NRPEDIDO",
                operator: "=",
                value: General.getFieldValue('NRPEDIDO','widgetPrincipal')
            }
        );
        widItens.dataSourceFilter.push(
            {
                name: "NRITEMPED",
                operator: "=",
                value: General.getFieldValue('NRITEMPED','widgetPrincipal')
            }
        );
        widItens.reload();
    };
    
    this.setDataSourceFilterReserva = function(widget) {
        var widReserva = templateManager.container.getWidget('reserva');
        widReserva.dataSourceFilter = [];
        widReserva.dataSourceFilter.push(
            {
                name: "P_CDFILIAL",
                operator: "=",
                value: General.getFieldValue('CDFILIAL','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_NRPEDIDO",
                operator: "=",
                value: General.getFieldValue('NRPEDIDO','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_NRITEMPED",
                operator: "=",
                value: General.getFieldValue('NRITEMPED','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: General.getFieldValue('CDPRODUTO','widgetPrincipal')
            }
        );
        widReserva.reload();
    };
    
    this.qtdeTotalReserva = function(widgetReserva){
        // var qtdade = 0;
        var total = 0;
        widgetReserva.dataSource.data.forEach(function(row){
            if(typeof row.QTRESPRODPED === 'string')
                row.QTRESPRODPED = parseFloat(row.QTRESPRODPED.replace(',','.'));
            else
                row.QTRESPRODPED = parseFloat(row.QTRESPRODPED);
            total = total + row.QTRESPRODPED;
        });
        return parseFloat(total);
    };

    this.onSaveItem = function() {
        var widgetItem = templateManager.container.getWidget('itens');
        var widgetReserva = templateManager.container.getWidget('reserva');
        
        // Quantidade total dos itens da reserva 
        var QTRESPRODPED = this.qtdeTotalReserva(widgetReserva);
        
        // Quantidade total do item
        var QTITEMPED = 0;
        if(typeof widgetItem.dataSource.data[0].QTITEMPED === 'string')
             QTITEMPED = parseFloat(widgetItem.dataSource.data[0].QTITEMPED.replace(',','.'));
        else
             QTITEMPED = parseFloat(widgetItem.dataSource.data[0].QTITEMPED);
        
        // Se a quantidade reservada for igual a quantidade do item
        if(QTITEMPED == QTRESPRODPED){
            
            var itens = [{
                        "CDFILIAL": General.getFieldValue('CDFILIAL','widgetPrincipal'),
                        "NRPEDIDO": General.getFieldValue('NRPEDIDO','widgetPrincipal'),
                        "NRITEMPED": General.getFieldValue('NRITEMPED','itens'),
                        "QTITEMPED": QTITEMPED,
                        "changed": true,
                        "__is_new": false
                    }];
                    
            var reservas = [];
            widgetReserva.dataSource.data.forEach(function(row){
                reservas.push(
                    {
                        "CDFILIAL": General.getFieldValue('CDFILIAL','widgetPrincipal'),
                        "NRPEDIDO": General.getFieldValue('NRPEDIDO','widgetPrincipal'),
                        "NRITEMPED": General.getFieldValue('NRITEMPED','itens'),
                        "QTRESPRODPED": row.QTRESPRODPED,
                        "QTRESPRODARR": row.QTRESPRODPED,
                        "NRRESPRODPED": row.NRRESPRODPED,
                        "CDPRODUTO": row.CDPRODUTO,
                        "NRLOTEESTQ": row.NRLOTEESTQ,
                        "changed": true,
                        "__is_new": false
                    }
                );
            });
            
            var dataReserva = [itens, reservas];

            Ped29000_manutencaoReserva_Service.salvarManutencaoReserva(dataReserva).then((item)=>{

                widgetItem.commitInlineEdit();
                widgetItem.list();

                widgetItem.currentRow.changed = false;
                widgetItem.reload();
                
                widgetReserva.commitInlineEdit();
                widgetReserva.list();
                
                widgetReserva.currentRow.changed = false;
                widgetReserva.reload();

            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        }else{
            ScreenService.showMessage('Quantidade reservada deve ser igual a quantidade do item do pedido');
        }
    };
    
}; 

Configuration(function(ContextRegister){
    ContextRegister.register('Ped29000_manutencaoReserva_Controller', Ped29000_manutencaoReserva_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/ped05800_itens_composicao_preco_Controller.js
var  ped05800_itens_composicao_preco_Controller = function(ScreenService, ped05800_itens_composicao_preco_Service, General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
    
    this.geraCodigo = function(){
        this.enableField();
        var dataSource = templateManager.container.getWidget('widgetItensCompPreco').dataSource.data;
        var codigo = 0;
        dataSource.forEach(function(aux){
            if(aux.CDITFORPRECO > codigo){
                codigo = aux.CDITFORPRECO;
            }        
        });
        codigo ++;
        
        templateManager.container.getWidget('widgetItensCompPreco').getField('CDITFORPRECO').setValue(codigo);
        templateManager.container.getWidget('widgetItensCompPreco').getField('CDITFORPRECO').reload();
    };

    this.validaSigla = function(){
        var widget = templateManager.container.getActiveWidget();
        var sigla = widget.currentRow.SGITFORPRECO.toUpperCase();
        
        if (sigla == "PC"){
            ScreenService.showMessage('Sigla já reservada para Preço de Custo.');
            widget.getField('SGITFORPRECO').setValue("");
            
        }else{
            widget.currentRow.SGITFORPRECO = sigla;
            widget.getField('SGITFORPRECO').setValue(sigla);
            widget.getField('SGITFORPRECO').reload();

        }
    };
    
    this.salvar = function(){
        var widget = templateManager.container.getWidget('widgetItensCompPreco');
        var data = widget.dataSource.data;
        var codigo = 0;
        
        var regexp = /\d/;

        if(widget.currentRow.SGITFORPRECO.match(regexp)){
            ScreenService.showMessage('O campo sigla deve conter apenas letras.');
        }else{
           var cod = parseInt(widget.currentRow.CDITFORPRECO,10);
            data.forEach(function(aux){
                if(cod ==  aux.CDITFORPRECO){
                    codigo ++;
                }    
            });
            
            if(codigo == 1){
                General.saveCrud(widget);
            }else if(codigo == 2){
                ScreenService.showMessage('Código já cadastrada.');
            } 
        }
    };
    
    this.enableField = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.__is_new){
           widget.getField('CDITFORPRECO').readOnly = false;
        }else{
           widget.getField('CDITFORPRECO').readOnly = true;
        }
        
        
    };

};
Configuration(function(ContextRegister){
    ContextRegister.register('ped05800_itens_composicao_preco_Controller', ped05800_itens_composicao_preco_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/ped05900_composicao_preco_produto_Controller.js
var  ped05900_composicao_preco_produto_Controller = function(ScreenService, General,templateManager, ZHPromise, restEngine, ZhFilterPreferences, MessageService){
                                                            
    
    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.setFilter = function(widget) {
        var filterRow = {};
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            templateManager.container.getActiveWidget().currentRow = filterRow;
        }.bind(this));
    };

    
    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('widgetComposicao');
        widget.activate();
        widget.reload();
    };
    
    this.setDefaultValue = function(widget){
        widget.getField('NMITFORPRECO').readOnly = false;
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('VRPEFORMPREC'). setValue('0');
        widget.getField('VRFATFORMPREC'). setValue('0');
       /* widget.currentRow.VRPEFORMPREC = 0;
        widget.currentRow.VRFATFORMPREC = 0;*/
    };
    this.editCompPreco = function(widget){
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('NMITFORPRECO').readOnly = true;
        General.edit(widget);
    };
    
    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.VRPEFORMPREC != 0 && widget.currentRow.VRFATFORMPREC == 0 ){
            if(widget.currentRow.VRPEFORMPREC > 100){
                ScreenService.showMessage('O Percentual de Composição do Preço do Produto não pode ser maior que 100.');
                widget.getField('VRPEFORMPREC'). setValue('0');
            }else{
                widget.getField('VRFATFORMPREC').readOnly = true;
            }
        }else if (widget.currentRow.VRFATFORMPREC != 0 && widget.currentRow.VRPEFORMPREC == 0){
            widget.getField('VRPEFORMPREC').readOnly = true;
        }
    };
    
    this.openPopupformulaCalcPreco = function(){
        var widgetFormCalcPreco = templateManager.container.getWidget('widgetFormCalcPreco');
        widgetFormCalcPreco.isVisible = true;
        ScreenService.openPopup(widgetFormCalcPreco);
    };
    
    this.setDataSourceFilterApply = function(args){
         if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter= [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                }
            ];
            
            args.owner.dataSourceFilter = dataSourceFilter;
            args.owner.currentRow.CDTIPOCUSTO = rowPopup.CDTIPOCUSTO;
            args.owner.container.getWidget('widgetProduto').reload();
         }
    };

}; 

Configuration(function(ContextRegister){
    ContextRegister.register('ped05900_composicao_preco_produto_Controller', ped05900_composicao_preco_produto_Controller);
});                                                          

// FILE: ./assets/modules/pedidos/assets/js/controllers/ped16000_ParametrosdeImportacaodePedidos_Controller.js
function ped16000_ParametrosdeImportacaodePedidos_Controller (ScreenService,ZHPromise, templateManager, General){

     this.adicionar = function(widget){
        var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        widget.newRow();
        widget.currentRow.__is_new = true;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        this.controlaStatusWidgets(tabbedParametrosImpPedidos, widget.name, false);
        
    };
	
	this.editar = function(widget){
	    var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelar = function(widget){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        if(widget.currentRow.__is_new === true){    
            widget.parent.widgets.forEach(function(element){
                element.currentRow = {};
            });
        }
	    widget.template = widget.templateToView;
        widget.view();
        widget.reload();
        widget.activate();
        
        var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = false;
	    
    };
    
    this.salvarImpPeddistri = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosImpPedidos'), 'autorizacaofornecimento', true);
                var tabbedParametrosImpPedidos =  templateManager.container.getWidget('tabbedParametrosImpPedidos');
                tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosImportacaoPed(tabbedParametrosImpPedidos);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarImpPedsolicita = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosImpPedidos'),'solicitacaodecompras',true);
                var tabbedParametrosImpPedidos =  templateManager.container.getWidget('tabbedParametrosImpPedidos');
                tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosImportacaoPed(tabbedParametrosImpPedidos);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };

    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });
    };
    
    this.reloadWidgets = function(){
        var widget = templateManager.container.getWidget('tabbedParametrosImpPedidos');
        widget.widgets.forEach(function(element){
            element.reload();
        }.bind(this));
        templateManager.updateTemplate();
    };
    
    this.filtroParametrosImportacaoPed = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        
        General.callRestEngine("ped_pedidos#/crud/paramimppedido_vendedor","FilterData", filtro).then(function(sucesso){
            var resultado = sucesso.dataset.paramimppedido_vendedor[0];
            widget.widgets.forEach(function(value){
                if(resultado && filial) {
                    value.currentRow = resultado;
                    value.getAction('editar').isVisible = true;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }else if(!resultado && filial){
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = true;
                    value.reload();
                }
                else {
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }
            });
            
        }.bind(this), function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('ped16000_ParametrosdeImportacaodePedidos_Controller', ped16000_ParametrosdeImportacaodePedidos_Controller);
});

// FILE: ./assets/modules/pedidos/assets/js/controllers/Ger96700_tipoFiscalizacaoProduto.js
function Ger96700_tipoFiscalizacaoProduto(General, templateManager, ScreenService) {

    this.ativaAction = function(name) {
        if(name == 'WidgetOnOpenDetail'){
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
        }
        if(name == 'adicionarClassFiscal' || name == 'editClassFiscal'){  
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = false;
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('cancelarClasFiscal').isVisible = true;
        }    
        if(name == 'cancelarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
        }
        if(name == 'adicionarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = true;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
        }   
        if(name == 'cancelarClasFiscal'){
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').widgets[0].enabled = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').getField('SGUNIDPADR').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').getField('SGUNIDADE').isVisible = false;
        }
        if(name == 'voltar'){
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
            templateManager.container.getActiveWidget().reload();
        }
        if(name == 'salvarProdSemAlvara' || name == 'cancelarProdSemAlvara'){
            templateManager.container.getWidget('widgetGridProdSemALvara').getAction('voltarProdSemAlvara').isVisible = true;
            templateManager.container.getWidget('widgetGridProdSemALvara').getAction('cancelarProdSemAlvara').isVisible = false;
            templateManager.container.getWidget('widgetGridProdSemALvara').label = '';
        }
        if(name == 'cancelarTpAlvara' || name == 'salvarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getField('NMALVARA').readOnly = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = true;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = false;
        }
        if(name == 'editTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = true;
        }
        if(name == 'salvarClasFiscal'){
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = true;
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').widgets[0].enabled = true;
            
        }
        
    };
    
    this.create = function(widget, nameAction){
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
        
        if(nameAction == 'adicionarTpFiscalizacao')
            this.addTpFiscalizacao();
        else if(nameAction == 'adicionarClassFiscal')
            this.addClassFiscal(widget);
        if(nameAction == 'adicionarTpAlvara')
            this.adicionarTpAlvara(widget);
    };  
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        widget.reload();
    };
	

    this.addTpFiscalizacao = function(){
        var widget = templateManager.container.getWidget('widgetTipoFiscalizacao');
        var dados = widget.dataSource.data;
        
        if(dados.length == 0){
            widget.getField('NRTPFISCALPROD').setValue('01');
        }else{
            var aux = 0;
            for(var i = 0; i < dados.length; i++){
                if(dados[i].NRTPFISCALPROD > aux){
                    aux = dados[i].NRTPFISCALPROD;
                }
            }
            aux++;
            widget.getField('NRTPFISCALPROD').setValue(aux);
            widget.getField('NMTPFISCALPROD').readOnly = false;
        }
        
        this.ativaWidget(widget, 'adicionaTpFiscalizacao');
    };
    
    this.ativaWidget = function(widget, name){
        if (name == 'salvarTpFiscalizacao' || name == 'cancelarTpFiscalizacao'){
            
            if(name == 'salvarTpFiscalizacao'){
                widget.getAction('voltarTpFiscalizacao').isVisible = true;
                widget.getAction('cancelarTpFiscalizacao').isVisible = false;
            }else if(name == 'cancelarTpFiscalizacao'){
                widget.getAction('voltarTpFiscalizacao').isVisible = true;
                widget.getAction('cancelarTpFiscalizacao').isVisible = false;
            }
            
            widget.widgets[0].isVisible = true;
            widget.widgets[1].isVisible = true;
            
            widget.widgets[0].enabled = true;
            widget.widgets[1].enabled = true;
            
        }else if(name == 'adicionaTpFiscalizacao'){
            
            widget.getAction('voltarTpFiscalizacao').isVisible = false;
            widget.getAction('cancelarTpFiscalizacao').isVisible = true;
            
            widget.widgets[0].isVisible = false;
            widget.widgets[1].isVisible = false;
        }
        
    };
    
    this.editTpFiscalizacao = function(widget){
        General.edit(widget);
        
        widget.getField('NMTPFISCALPROD').readOnly = false;
        widget.getAction('voltarTpFiscalizacao').isVisible = false;
        widget.getAction('cancelarTpFiscalizacao').isVisible = true;
        
        widget.widgets[0].enabled = false;
        widget.widgets[1].enabled = false;
    };
    
    this.excluirTpFiscalizacao = function(widget){
        General.callRestEngine('ped_pedidos#/ncmcontrolados_clasfiscal', 'Row', widget.currentRow).then(function(){
            var widget = templateManager.container.getWidget('widgetTipoFiscalizacao');
            General.deleteCrud(widget);
        }.bind(this));
        
        
    };
    
    this.cadastroAutomatico = function(){
        templateManager.container.getWidget('widgetCadastroAutomatico').isVisible = false;
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        widget.getField('FILTRAR').setValue("T");
        widget.getField('NMTPFISCALPROD').reload();
        this.cancelaCadastramento(widget);
        ScreenService.openPopup(widget);    
    };
    
    this.changeFiltro = function(){
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        var field = widget.getField('FILTRAR').value();
        if(field == 'L'){
            widget.getField('DSCLASFISC').readOnly = false;
        }
    };
    
    this.salvarCadastramento = function(){
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        var dataSet = [];
        var row = {};
        var cdclasfisc = widget.getField('CDCLASFISC').value();
        var filtro = widget.getField('FILTRAR').value();
        
        var un = widget.getField('SGUNIDADE').value();
        widget.getField('SGUNIDPADR').setValue(un);
        
        var qtmensal = widget.getField('QTMENSAL').value();
        var qtmensalCorreto;
        if(qtmensal > "0"){
            if((widget.fields[0].value() != " ") && (widget.fields[1].value() != " ") && (widget.fields[3].value() != " ") && (widget.fields[4].value() != " ") && (widget.fields[5].value() != " ")){
                if(isNaN(qtmensal)){
                    if(qtmensal.indexOf(",") >= 0){
                        qtmensalCorreto = qtmensal.replace(',','.');
                        widget.getField('QTMENSAL').setValue(qtmensalCorreto);
                        this.salvarCadastramento();
                    }else{
                        ScreenService.showMessage("O campo 'Qt. Mensal' deve conter apenas números.");
                        widget.getField('QTMENSAL').setValue("0");
                    }
                }else{
                    var aux2;
                    
                    if(qtmensal.indexOf(",") >= 0){
                        qtmensalCorreto = qtmensal.replace(',','.');
                        aux2 = Number.parseFloat(qtmensalCorreto).toFixed(3);
                    }else{
                        aux2 = Number.parseFloat(qtmensal).toFixed(3);
                    }
                    
                    var tamanho = aux2.length;
                    var numArrendodado;
                    
                    if(aux2[tamanho - 1] > 5){
                        numArrendodado = Number.parseFloat(aux2).toFixed(2);
                        widget.getField('QTMENSAL').setValue(numArrendodado);
                    }else{
                        widget.getField('QTMENSAL').setValue(aux2);
                    }
                    
                    widget.reload();
                    var nrorg = widget.dataSource.data[0].NRORG;
                    if(filtro == "L"){
                        if(widget.fields[7].value() != " "){
                            for(var i = 0; i < cdclasfisc.length; i++){
                            
                                row = {
                                    "NRTPFISCALPROD": widget.getField('NRTPFISCALPROD').value(),
                                    "CDCLASFISC": cdclasfisc[i],
                                    "SGUNIDPADR": widget.getField('SGUNIDADE').value(),
                                    "QTMENSAL": widget.getField('QTMENSAL').value(),
                                    "NRORG": nrorg
                                };
                                dataSet.push(row);
                                //this.salvar(row);
                            }
                            this.salvar(dataSet);
                        }else{
                            ScreenService.showMessage("Preencha todos os campos para realizar o cadastramento automático.");
                        }  
                    }else if(filtro == "T"){
                        row = {
                                "NRTPFISCALPROD": widget.getField('NRTPFISCALPROD').value(),
                                "SGUNIDPADR": widget.getField('SGUNIDADE').value(),
                                "QTMENSAL": widget.getField('QTMENSAL').value(),
                                "NRORG": nrorg
                        };
                            
                        General.callRestEngine('ped_pedidos#/select_clasfiscal', 'Row', row).then(function(callback){
                            ScreenService.closePopup();
                            ScreenService.showMessage("Cadastramento automático realizado com sucesso.");
                        }).catch(function(error){
                            ScreenService.showMessage("Impossível adicionar, registro já existe.");
                        });
                        
                    }
                }
            }else{
                ScreenService.showMessage("Preencha todos os campos para realizar o cadastramento automático.");
            }
        }else if(qtmensal <= "0"){
            widget.getField('QTMENSAL').setValue("");
        }
    };
    
    this.salvar = function(dataSet){
        General.callRestEngine('ped_pedidos#/cadastro_automatico', 'DataSet', dataSet).then(function(){
            ScreenService.closePopup();
            ScreenService.showMessage("Cadastramento automático realizado com sucesso.");
        }).catch(function(error){
            ScreenService.showMessage("Impossível adicionar, registro já existe.");
        });
    };
    
    this.cancelaCadastramento = function(widget){
      for(var j = 0; j < widget.fields.length; j++ ){
            if(j == 5){
                widget.fields[j].setValue("T");
            }else{
                widget.fields[j].setValue(" ");
            }
        }
        widget.fields[7].readOnly = true;  
    };
    
   
    this.addClassFiscal = function(widget){
        var aux = templateManager.container.getWidget('widgetTipoFiscalizacao').getField('NRTPFISCALPROD').value();
        widget.getField('NRTPFISCALPROD').setValue(aux);
        widget.getField('DSCLASFISC').readOnly = false;
        widget.getField('SGUNIDPADR').isVisible = false;
        widget.getField('SGUNIDADE').isVisible = true;
    };
    
    this.editClassFiscal = function(widget){
      General.edit(widget);  
      
      widget.getField('DSCLASFISC').readOnly = true;
      widget.getField('SGUNIDPADR').readOnly = true;
      widget.widgets[0].enabled = false;
    };
    
    this.saveClasFiscal = function(widget){
        if(widget.currentRow.__is_new == true){
            var un = widget.getField('SGUNIDADE').value();
            var aux = un.toUpperCase();
            widget.getField('SGUNIDPADR').setValue(aux);
        }
        
        widget.getField('SGUNIDADE').isVisible = false;
        widget.getField('SGUNIDPADR').isVisible = true;
        
        var qtmensal = widget.getField('QTMENSAL').value();
        if(qtmensal > "0"){
            
            var qtmensalCorreto;
            if(isNaN(qtmensal)){
                if(qtmensal.indexOf(",") >= 0){
                    qtmensalCorreto = qtmensal.replace(',','.');
                    widget.getField('QTMENSAL').setValue(qtmensalCorreto);
                    this.saveClasFiscal(widget);
                }else{
                    ScreenService.showMessage("O campo 'Qt. Mensal' deve conter apenas números.");
                    widget.getField('QTMENSAL').setValue("0");
                }
            }else{
                var aux2;
                
                if(qtmensal.indexOf(",") >= 0){
                    qtmensalCorreto = qtmensal.replace(',','.');
                    aux2 = Number.parseFloat(qtmensalCorreto).toFixed(3);
                }else{
                    aux2 = Number.parseFloat(qtmensal).toFixed(3);
                }
                
                var tamanho = aux2.length;
                var numArrendodado;
                
                if(aux2[tamanho - 1] > 5){
                    numArrendodado = Number.parseFloat(aux2).toFixed(2);
                    widget.getField('QTMENSAL').setValue(numArrendodado);
                }else{
                    widget.getField('QTMENSAL').setValue(aux2);
                }
                
                widget.reload();
                
                General.saveCrud(widget);
            }
        }else if(qtmensal <= "0"){
            widget.getField('QTMENSAL').setValue("");
        }
    };
    
    
    this.editTpAlvaraLicenca = function(widget){
        General.edit(widget);
        widget.getField('NMALVARA').readOnly = true;
    };
    
    this.verificaTpAlvara = function(widget){
        var fields = widget.fields;
        var aux = false;
        
        for(var i = 3; i < fields.length; i++){
            if(fields[i].value() == 'S'){
                aux = true;
            }    
        }
        
        if(aux == true){
            General.saveCrud(widget);
        }else{
            ScreenService.showMessage("Pelo menos um dos campos: 'Cliente', 'Filial', 'Fornecedor' e 'Transportadora' deve estar com a opção 'Exige' selecionada.");
        }
    };
    
    this.adicionarTpAlvara = function(widget){
        var nrtpfiscalprod = widget.getParent().getField('NRTPFISCALPROD').value();
        widget.getField('NRTPFISCALPROD').setValue(nrtpfiscalprod);
        
    };
    
    
    this.changeLabel = function(widget, name){
        if(name == 'WidgetOnOpenDetail'){
            templateManager.container.getWidget('widgetGridProdSemALvara').label = 'Produtos sem Alvará';    
        }else if(name == 'voltarProdSemAlvara'){
            widget.label = ' ';    
            if(templateManager.container.getActiveWidget().name == 'widgetTipoFiscalizacao'){
                templateManager.container.getWidget('widgetProdSemAlvara').fields[0].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[1].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[2].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[3].setValue(' ');
            }
        }
        
        templateManager.container.getWidget('widgetGridProdSemALvara').reload();
    };
    
    this.editProdSemAlvara = function(widget){
        General.edit(widget);
        widget.getAction('cancelarProdSemAlvara').isVisible = true;
        widget.getAction('voltarProdSemAlvara').isVisible = false;
    };
    
    this.setCampos = function(){
        var widget = templateManager.container.getWidget('widgetClasFiscalControlados');
        var dsclasfisc = widget.getField('DSCLASFISC').value();
        var sgunidpadr = widget.getField('SGUNIDPADR').value();
        var cdclasfisc = widget.getField('CDCLASFISC').value();
        var qtmensal = widget.getField('QTMENSAL').value();
        
        var prodsemalvara = templateManager.container.getWidget('widgetProdSemAlvara');
        prodsemalvara.getField('CDCLASFISC').setValue(cdclasfisc);
        prodsemalvara.getField('DSCLASFISC').setValue(dsclasfisc);
        prodsemalvara.getField('QTMENSAL').setValue(qtmensal);
        prodsemalvara.getField('SGUNIDPADR').setValue(sgunidpadr);
        
        templateManager.container.getWidget('widgetGridProdSemALvara').reload();
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ger96700_tipoFiscalizacaoProduto', Ger96700_tipoFiscalizacaoProduto);
});



// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped00400_tipoTransporte.js
function Ped00400_tipoTransporte(General, templateManager, ScreenService) {
    
    this.addTpTransp = function(widget){
        widget.newRow();
    };
    
    this.saveTpTransp = function(widget){
        var code = widget.getField('CDTIPTRANS').value();
        if(isNaN(code)){
            ScreenService.showMessage("O campo Código deve conter apenas números");
            widget.getField('CDTIPTRANS').setValue('');
        }else{    
            if(code.indexOf(".") >= 0){
                ScreenService.showMessage("O campo Código deve conter apenas números");
                widget.getField('CDTIPTRANS').setValue('');
            }else{
                General.saveCrud(widget);
            }
        }
    };
    
    this.reload = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.reload();    
    };
    
    this.changeFields = function(nameAction){
        var widget = templateManager.container.getActiveWidget();
        if(nameAction == "edit"){
            widget.getField('CDTIPTRANS').readOnly = true;
        }else{
            widget.getField('CDTIPTRANS').readOnly = false;
        }
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped00400_tipoTransporte', Ped00400_tipoTransporte);
});



// FILE: ./assets/modules/pedidos/assets/js/controllers/Ped01100_dadosPedido.js
function Ped01100_dadosPedido(General, templateManager, ScreenService, MessageService, Ped01100_dadosPedido_Service, PedGeral_Utility) {
    
    this.quantItemLista = 0;

    this.setValues = function(){
        var widget = templateManager.container.getWidget('widgetDados');
        widget.applyDefaultValue();
        widget.getField('PRIORIDADE').setValue(["3", "2", "1"]);
        widget.getField('SITUACAOPEDIDO').setValue(["6", "5", "4", "3", "2", "1"]);
        widget.getField('SITUACAOITEM').setValue(["7", "6", "5", "4", "3", "2", "1"]);
        
        this.startFilterFilial();

         // this.filtroFilial();
        this.filtroNmPedido();
        this.filtroTpOper();
        this.filtroCliente();
        this.filtroProdutos();
        this.filtroVendedor();
        this.filtroVendedorComis();
        
        widget.reload();
    };

    this.startFilterFilial = function() {

        var widgetDados = this.getWidgetDados();

        widgetDados.getField('FILTRARFILIAL').setValue('L');

        this.filtroFilial();

        var fieldFilial = widgetDados.getField('NMFILIAL');
        var fieldCdFilial = widgetDados.getField('CDFILIAL');

        PedGeral_Utility.getFilialLogada().then(function(success) {
            
            var filial = [success.dataset.filial[0].NMFILIAL];
            var cdfilial = [success.dataset.filial[0].CDFILIAL];

            fieldFilial.setValue(filial);
            fieldCdFilial.setValue(cdfilial);
        
            templateManager.updateTemplate();

        }.bind(this));

    }; 
    
    this.filtroNmPedido = function(){
        var widget = templateManager.container.getWidget('widgetDados');
        if(widget.getField('FILTRAR').value() == 'L'){
           widget.getField('NMFANTCLIE').readOnly = false;
           widget.getField('INICIO').readOnly = true;
           widget.getField('FIM').readOnly = true;
           widget.getField('NMFANTCLIE').validations = {required: true};
           delete(widget.getField('INICIO').validations);
           delete(widget.getField('FIM').validations);
           widget.getField('INICIO').setValue('');
           widget.getField('FIM').setValue('');
        }else if(widget.getField('FILTRAR').value() == 'I'){
           widget.getField('NMFANTCLIE').readOnly = true;
           widget.getField('INICIO').readOnly = false;
           widget.getField('FIM').readOnly = false;
           widget.getField('INICIO').validations = {required: true};
           widget.getField('FIM').validations = {required: true};
           delete(widget.getField('NMFANTCLIE').validations);
           widget.getField('NMFANTCLIE').setValue('');
        }else if(widget.getField('FILTRAR').value() == 'T'){
           widget.getField('NMFANTCLIE').readOnly = true;
           widget.getField('INICIO').readOnly = true;
           widget.getField('FIM').readOnly = true;
           delete(widget.getField('INICIO').validations);
           delete(widget.getField('FIM').validations);
           delete(widget.getField('NMFANTCLIE').validations);
           widget.getField('NMFANTCLIE').setValue('');
           widget.getField('FIM').setValue('');
           widget.getField('INICIO').setValue('');
        }
        templateManager.updateTemplate();
    };

    this.checkQuantItemList = function() {

        var wid = templateManager.container.getActiveWidget();

        this.quantItemLista = wid.dataSource.data.length;

    };

    this.getTabbedWidgetDados = function() {

        return templateManager.container.getWidget('tabbedDadosPedido');

    };

    this.getWidgetDados = function() {

        return templateManager.container.getWidget('widgetDados');

    };
    
    this.filtraParametro = function(nomeFiltro, nomeLista) {
        var widget = this.getWidgetDados();

        var filtro = widget.getField(nomeFiltro);

        var fieldList = widget.getField(nomeLista);

        if(filtro.value() == 'L') {

            fieldList.readOnly = false;
            fieldList.validations = {required: true};

        } else {

            fieldList.readOnly = true;
            delete (fieldList.validations);
            fieldList.setValue('');

        }

        templateManager.updateTemplate();

    };

    this.filtroFilial = function(){
        
        this.filtraParametro('FILTRARFILIAL', 'NMFILIAL');

    };
    
    this.filtroTpOper = function(){
        
        this.filtraParametro('FILTRARTIPOOPERACAO', 'NMTIPOOPER');
    
    };
    
    this.filtroCliente = function(){
        
        this.filtraParametro('FILTRARCLIENTE', 'NMFANTCLIE2');

    };
    
    this.filtroProdutos = function(){
        
        this.filtraParametro('FILTRARPRODUTOS', 'NMPRODUTO');
        
    };
    
    this.filtroVendedor = function(){
        
        this.filtraParametro('FILTRARVENDEDOR', 'NMFANVEN');

    };
    
    this.filtroVendedorComis = function(){
        
        this.filtraParametro('FILTRARVENDEDORCOMIS', 'NMFANVEN2');

    };
    
    this.mudaLabel = function(){
        var tabbedWidget = templateManager.container.getWidget('tabbedDadosPedido');
        var widget = tabbedWidget.widgets[0];
        if(tabbedWidget.getField('RELATORIO').value() == 'PED01100'){
          widget.label = "Espelho do Pedido";
          delete(templateManager.container.getWidget('widgetDados').getField('DTPEDIDO').validations);
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01101'){
          widget.label = "Dados do Pedido";
          delete(templateManager.container.getWidget('widgetDados').getField('DTPEDIDO').validations);
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01103'){
          widget.label = "Pedido por Vendedor";
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01104'){
          widget.label = "Preço de Venda x Preço de Custo (Analítico)";
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01105'){
          widget.label = "Preço de Venda x Preço de Custo (Sintético)";
        }
    };
    
    this.concatParametro = function(fieldFiltro, fieldTodos, fieldLista, fieldValue) {

        var currentRowToSend = this.getTabbedWidgetDados().currentRow;

        var currentRowToRead = this.getWidgetDados().currentRow;

        if(currentRowToRead[fieldFiltro] == 'T'){
            
            currentRowToSend[fieldTodos] =  'T';
            currentRowToSend[fieldLista] =  '';

        }else if(currentRowToRead[fieldFiltro] == 'L'){
            
            currentRowToSend[fieldTodos] =  '';
            var array = currentRowToRead[fieldValue];
            var aux = '';
            
            for(var i=0; i < array.length; i++){
                aux += array[i] + '_';
            }
            
            currentRowToSend = this.validaConcat(currentRowToSend, fieldLista, fieldValue, aux);
        }

        return currentRowToSend;

    };

    this.validaConcat = function(currentRow, fieldLista, fieldValue, aux) {

        if(aux.length < 4000) {

            currentRow[fieldLista] = aux;

            return currentRow;

        } else {

            var widgetDados = this.getWidgetDados();

            var field = widgetDados.getField(fieldValue);

            var nomFieldGroup = null;

            var fieldGroups = widgetDados.fieldGroups;

            for(i = 0; i < fieldGroups.length; i++) {

                if(fieldGroups[i].name == field.fieldGroup) {

                    nomFieldGroup = fieldGroups[i].label;

                    break;

                }

            }

            param = { parametro: nomFieldGroup};
            
            MessageService.showMessageByCode('NUM_I_LIMIT',param);

            throw new Error('NUM_I_LIMIT');

        }

    };

    this.analizaQuantSeleciona = function(field, nomeFieldTodos) {

        if(field.value().length == this.quantItemLista) {

            var fieldTodos = field.widget.getField(nomeFieldTodos);

            fieldTodos.setValue('T');

            field.clearValue();

            field.readOnly = true;

            delete (field.validations);

            templateManager.updateTemplate();

        }

    };

    this.sitConcat = function(situacao,status,statusTodos) {

        var currentRowToRead = this.getWidgetDados().currentRow;
        var currentRowToSend = this.getTabbedWidgetDados().currentRow;

        var array = currentRowToRead[situacao];
        var aux = '';
        
        for(var i=0; i < array.length; i++){
            aux += array[i] + '_';
        }

        currentRowToSend[status] =  aux;
        currentRowToSend[statusTodos] = '';

        return currentRowToSend;

    };

    this.setCurrentRow = function(){
        var widget = templateManager.container.getWidget('tabbedDadosPedido');
        var currentWidget = templateManager.container.getWidget('tabbedDadosPedido').widgets[0].currentRow;    
        
        widget.currentRow.__report_name = widget.currentRow.RELATORIO;
        
        if(currentWidget.FILTRAR == 'T'){
            widget.currentRow.NRPEDIDOTODOS =  'T';
            widget.currentRow.NRPEDIDOLISTA =  '';
            widget.currentRow.NRPEDIDODE =  '';
            widget.currentRow.NRPEDIDOATE =  '';
        }else if(currentWidget.FILTRAR == 'L'){
            widget.currentRow.NRPEDIDOTODOS =  '';
            var listaNrpedido = currentWidget.NRPEDIDO;
            var lista = '';
            for(var i=0; i < listaNrpedido.length; i++){
                lista = lista + listaNrpedido[i] + '_';
            }

            this.validaConcat(widget.currentRow, 'NRPEDIDOLISTA','NRPEDIDO',lista);
            
            widget.currentRow.NRPEDIDODE =  '';
            widget.currentRow.NRPEDIDOATE =  '';
        }else if(currentWidget.FILTRAR == 'I'){
            widget.currentRow.NRPEDIDOTODOS =  '';
            widget.currentRow.NRPEDIDOLISTA = '';
            widget.currentRow.NRPEDIDODE =  currentWidget.INICIO;
            widget.currentRow.NRPEDIDOATE =  currentWidget.FIM;
        }
        
        widget.currentRow = this.concatParametro('FILTRARFILIAL','TCDFILIAL','LCDFILIAL','CDFILIAL');
        
        // if(currentWidget.FILTRARFILIAL == 'T'){
        //     widget.currentRow.TCDFILIAL =  'T';
        //     widget.currentRow.LCDFILIAL =  '';
        // }else if(currentWidget.FILTRARFILIAL == 'L'){
        //     widget.currentRow.TCDFILIAL =  '';
        //     var array = currentWidget.CDFILIAL;
        //     var aux = '';
        //     for(var j=0; j < array.length; j++){
        //         aux = aux + array[j] + '_';
        //     }
        //     widget.currentRow.LCDFILIAL = aux;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARTIPOOPERACAO','TCDTIPOOPER','CDTIPOOPER','CDTIPOOPER');

        // if(currentWidget.FILTRARTIPOOPERACAO == 'T'){
        //     widget.currentRow.TCDTIPOOPER =  'T';
        //     widget.currentRow.CDTIPOOPER =  '';
        // }else if(currentWidget.FILTRARTIPOOPERACAO == 'L'){
        //     widget.currentRow.TCDTIPOOPER =  '';
        //     var array2 = currentWidget.CDTIPOOPER;
        //     var aux2 = '';
        //     for(var k=0; k < array2.length; k++){
        //         aux2 = aux2 + array2[k] + '_';
        //     }
            
        //     widget.currentRow.CDTIPOOPER = aux2;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARCLIENTE','CLIENTETODOS','CLIENTELISTA','CDCLIENTE2');

        // if(currentWidget.FILTRARCLIENTE == 'T'){
        //     widget.currentRow.CLIENTETODOS =  'T';
        //     widget.currentRow.CLIENTELISTA =  '';
        // }else if(currentWidget.FILTRARCLIENTE == 'L'){
        //     widget.currentRow.CLIENTETODOS =  '';
        //     var array3 = currentWidget.NRINSJURCLIE2;
        //     var aux3 = '';
        //     for(var l=0; l < array3.length; l++){
        //         aux3 = aux3 + array3[l] + '_';
        //     }
        //     widget.currentRow.CLIENTELISTA = aux3;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARPRODUTOS','PRODUTOTODOS','PRODUTOLISTA','CDARVPROD');
        
        // if(currentWidget.FILTRARPRODUTOS == 'T'){
        //     widget.currentRow.PRODUTOTODOS =  'T';
        //     widget.currentRow.PRODUTOLISTA =  '';
        // }else if(currentWidget.FILTRARPRODUTOS == 'L'){
        //     widget.currentRow.PRODUTOTODOS =  '';
        //     var array4 = currentWidget.CDARVPROD;
        //     var aux4 = '';
        //     for(var m=0; m < array4.length; m++){
        //         aux4 = aux4 + array4[m] + '_';
        //     }
        //     widget.currentRow.PRODUTOLISTA = aux4;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARVENDEDOR','VENDEDORTODOS','VENDEDORLISTA','CDVENDEDOR');

        // if(currentWidget.FILTRARVENDEDOR == 'T'){
        //     widget.currentRow.VENDEDORTODOS =  'T';
        //     widget.currentRow.VENDEDORLISTA =  '';
        // }else if(currentWidget.FILTRARVENDEDOR == 'L'){
        //     widget.currentRow.VENDEDORTODOS =  '';
        //     var array5 = currentWidget.CDVENDEDOR;
        //     var aux5 = '';
        //     for(var n=0; n < array5.length; n++){
        //         aux5 = aux5 + array5[n] + '_';
        //     }
        //     widget.currentRow.VENDEDORLISTA = aux5;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARVENDEDORCOMIS','VENDCOMISTODOS','VENDCOMISLISTA','CDVENDEDOR2');
        
        // if(currentWidget.FILTRARVENDEDORCOMIS == 'T'){
        //     widget.currentRow.VENDCOMISTODOS =  'T';
        //     widget.currentRow.VENDCOMISLISTA =  '';
        // }else if(currentWidget.FILTRARVENDEDORCOMIS == 'L'){
        //     widget.currentRow.VENDCOMISTODOS =  '';
        //     var array6 = currentWidget.CDVENDEDOR2;
        //     var aux6 = '';
        //     for(var o=0; o < array6.length; o++){
        //         aux6 = aux6 + array6[o] + '_';
        //     }
        //     widget.currentRow.VENDCOMISLISTA = aux6;
        // }
        
        widget.currentRow = this.sitConcat('SITUACAOPEDIDO','STATUS','STATUSTODOS');

        // var array7 = currentWidget.SITUACAOPEDIDO;
        // var aux7 = '';
        // for(var p=0; p < array7.length; p++){
        //     aux7 = aux7 + array7[p] + '_';
        // }
        // widget.currentRow.STATUS =  aux7;
        // widget.currentRow.STATUSTODOS = '';
        
        widget.currentRow = this.sitConcat('SITUACAOITEM','STATUSITEM','STATUSITEMTODOS');
        
        // var array8 = currentWidget.SITUACAOITEM;
        // var aux8 = '';
        // for(var q=0; q < array8.length; q++){
        //     aux8 = aux8 + array8[q] + '_';
        // }
        // widget.currentRow.STATUSITEM = aux8;
        // widget.currentRow.STATUSITEMTODOS = ''; 
        
        widget.currentRow = this.sitConcat('SITUACAOITEM','TIPOPEDIDO','TODOSPEDIDOS');

        // var array9 = currentWidget.SITUACAOITEM;
        // var aux9 = '';
        // for(var r=0; r < array9.length; r++){
        //     aux9 = aux9 + array9[r] + '_';
        // }
        // widget.currentRow.TIPOPEDIDO = aux9;
        // widget.currentRow.TODOSPEDIDOS = ''; 
        
        if(currentWidget.NRORDEMCMPPED != ''){
            widget.currentRow.NRORDEMCMPPED = currentWidget.NRORDEMCMPPED;
        }else{
            widget.currentRow.NRORDEMCMPPED = '';
        }
        
        if((currentWidget.DTPEDIDO.start != '') && (currentWidget.DTPEDIDO.end != '')){
            widget.currentRow.EMISSAODE = currentWidget.DTPEDIDO.start;
            widget.currentRow.EMISSAOATE = currentWidget.DTPEDIDO.end;
            widget.currentRow.EMISSAOTODOS = '';
        }else{
            widget.currentRow.EMISSAODE = '';
            widget.currentRow.EMISSAOATE = '';
            widget.currentRow.EMISSAOTODOS = 'T';
        }
        
        if((currentWidget.DTENTPED.start != '') && (currentWidget.DTENTPED.end != '')){
            widget.currentRow.ENTREGADE = currentWidget.DTENTPED.start;
            widget.currentRow.ENTREGAATE = currentWidget.DTENTPED.end;
            widget.currentRow.ENTREGATODOS = '';
        }else{
            widget.currentRow.ENTREGADE = '';
            widget.currentRow.ENTREGAATE = '';
            widget.currentRow.ENTREGATODOS = 'T';
        }
        
        widget.currentRow = this.sitConcat('PRIORIDADE','PRIORIDADE','PRIORIDADETODOS');

        // var array10 = currentWidget.PRIORIDADE;
        // var aux10 = '';
        // for(var s=0; s < array10.length; s++){
        //     aux10 = aux10 + array10[s] + '_';
        // }
        
        // widget.currentRow.PRIORIDADE = aux10;
        // widget.currentRow.PRIORIDADETODOS = '';
        
        widget.currentRow.NRORG = getLocalVar("NRORG").toString();
        
        this.criaRelatorio(widget);
    };
    
    this.visualizarRelatorio = function(){
        var widget = templateManager.container.getWidget('tabbedDadosPedido');
        if(widget.isValid()){
            if(widget.widgets[0].isValid()){
                this.setCurrentRow();    
            }
        }
    };
    
    this.criaRelatorio = function(widget) {
        Ped01100_dadosPedido_Service.geraRelatorio(widget.currentRow).then(function(birtURL) {
            // window.open(birtURL.messages[0].mess cage);
            var reportOpened = window.open(birtURL.messages[0].message);
			if(!reportOpened){
			    ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
			}
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
       
       
       
       
        // var reportName = widget.container.getWidget('tabbedDadosPedido').currentRow.RELATORIO;
        // if (widget.isValid()) {
        //     General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);
        // }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('/ped01100_relatorio', reportName, row);
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped01100_dadosPedido', Ped01100_dadosPedido);
});


// FILE: ./assets/modules/expedicao/assets/js/controllers/Exp00200_lancamentoExpedicaoPedido_Controller.js
var Exp00200_lancamentoExpedicaoPedido_Controller = function(General, templateManager, ScreenService, Exp00200_lancamentoExpedicaoPedido_Service, ZHPromise, ZhFilterPreferences, MessageService) {


    this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilialLogadaFilter(widget);
            this.filterAdjustment();
        }.bind(this)); 
    };

    this.setFilialLogadaFilter = function (widget){
        Exp00200_lancamentoExpedicaoPedido_Service.getFilialLogada().then(function(filialLogada) {
            if (filialLogada[0]) {
                var widget = templateManager.container.getWidget('expedicaoPedido');
                templateManager.container.getActiveWidget().currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
                templateManager.container.getActiveWidget().currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
                
                this.setSerieFilter(widget);
                Exp00200_lancamentoExpedicaoPedido_Service.retornaEmpresa(filialLogada[0].CDEMPRESA).then(function(empresa) {
                    
                    templateManager.container.getActiveWidget().currentRow.CDEMPRESA = empresa[0].CDEMPRESA;
                    templateManager.container.getActiveWidget().currentRow.NMEMPRESA = empresa[0].NMEMPRESA;
                }.bind(this));
            } else {
                ScreenService.showMessage('Erro ao buscar Filial Logada, escolha manualmente.');
            }
        }.bind(this));
    };
    
    this.filterAdjustment = function (){
        Exp00200_lancamentoExpedicaoPedido_Service.getFilialLogada().then(function(filialLogada) {
            var cdfilial = filialLogada[0].CDFILIAL;
            var widget = templateManager.container.getWidget('expedicaoPedido');
            var widgetFiltro = templateManager.container.getActiveWidget();
            if (widgetFiltro && widgetFiltro.currentRow.CDFILIAL && filialLogada[0].CDFILIAL !== widgetFiltro.currentRow.CDFILIAL) {
                cdfilial = widgetFiltro.currentRow.CDFILIAL;
            }
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ];
            widgetFiltro.currentRow.CDSERIE = '';
            widgetFiltro.currentRow.DSSERIE = '';
            this.setSerieFilter2(filter);
            General.callRestEngine('ped#/crud/parampedido', "FilterData", filter).then(function(callback){
                var params = callback.dataset.parampedido;
                // widget.transportadora = params[0].NRINSJURTRAN;
                if (params[0] && params[0].IDOBRTPOPPED == 'N'){
                    widget.getField('NMTIPOOPER').requiredParam = true;
                    widgetFiltro.getField('NMTIPOOPER').validations = {
                        required: true
                    };
                    widgetFiltro.getField('NMTIPOOPER').reload();
                } else if (params[0]){
                    widget.getField('NMTIPOOPER').requiredParam = false;
                    delete widgetFiltro.getField('NMTIPOOPER').validations;
                } else {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial escolhida.');
                }
            }.bind(this)).catch(function(callback){
                ScreenService.showMessage(callback.dataset.error);
            });
        }.bind(this)).catch(function(callback){
            ScreenService.showMessage(callback.dataset.error);
        }.bind(this));
    };
    
    this.setSerieFilter2 = function(filter){
        General.callRestEngine('ped#/crud/filial', "FilterData", filter).then(function(callback){
            if (callback.dataset.filial && callback.dataset.filial.length > 0) {
                var filialLogada = callback.dataset.filial;
                var widgetFiltro = templateManager.container.getActiveWidget();
                var widget = templateManager.container.getWidget('expedicaoPedido');
                
                var filtroFilial = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filialLogada[0].CDFILIAL
                    }
                ];
                
                var filtroSerie = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": filialLogada[0].CDEMPRESA
                    },
                    {
                        "name": "CDINSCESTA",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCESTA
                    },
                    {
                        "name": "CDINSCMUNI",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCMUNI
                    }
                ];

                widget.getField('DSSERIE').dataSourceFilter = filtroSerie;
                widgetFiltro.getField('DSSERIE').dataSourceFilter = filtroSerie;

                widget.getField('NRPEDIDO').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDO').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;

            }
        }.bind(this));
    };
    
    this.getCurrentField = function(widgetName, fieldName) {
        return General.getFieldValue(fieldName,widgetName);
    };

    this.setDataSourceFilterApply = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [
                /*{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                },*/
                {
                    "name": "PRIORIDADE",
                    "operator": "=",
                    "value": "321"
                },
                {
                    "name": "IDORIGDESTOP",
                    "operator": "=",
                    "value": "1"
                }
            ];
            if (rowPopup.TIPOFILTRO == 'L') {
                var listaPED = '_'+rowPopup.NRPEDIDO.join('_')+'_';
               // var lista = listaPED.replace(/\,/g, '_');
                //var newListaPED = '_'+lista+'_';

                dataSourceFilter.push(
                    {
                        "name": "LNRPEDIDO",
                        "operator": "=",
                        "value": listaPED
                    },
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'I') {
                dataSourceFilter.push(
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOINI
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOFIN
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'T' || !rowPopup.TIPOFILTRO) {
                dataSourceFilter.push(
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDCLIENTE && rowPopup.CDCLIENTE.length != 0) {
                var listaCLIENTE = '_'+rowPopup.CDCLIENTE.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": listaCLIENTE
                    },
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDVENDEDOR && rowPopup.CDVENDEDOR.length != 0) {
                var listaVENDEDOR = '_'+rowPopup.CDVENDEDOR.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": listaVENDEDOR
                    },
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTPEDIDO && rowPopup.DTPEDIDO.start && rowPopup.DTPEDIDO.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.start
                    },
                    {
                        "name": "DTPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.end
                    },
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            
            if (rowPopup.CDTIPOOPER){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPOOPER",
                        "operator": "=",
                        "value": rowPopup.CDTIPOOPER
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDTIPOOPER",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTENTPED && rowPopup.DTENTPED.start && rowPopup.DTENTPED.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTENTPEDINI",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.start
                    },
                    {
                        "name": "DTENTPEDFIN",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.end
                    },
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            
            args.owner.dataSourceFilter = args.owner.dataSourceFilter.concat(dataSourceFilter);

            for (var i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDSERIE') {
                    args.owner.CDSERIE = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDEMPRESA') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'TIPOFILTRO') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            args.owner.container.getWidget('expedicaoPedido').reload();
        }
    };


    /*this.getCurrentFieldFilter = function(widgetName, fieldName) {
        var filterPopup = templateManager.container.getWidget(widgetName).__filterPopup;
        return General.getFieldValue(filterPopup.name, fieldName);
    };*/
    
    this.setSerieFilter = function(widget){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            }
        ];
        General.callRestEngine('ped#/crud/filial', "FilterData", filter).then(function(callback){
            if (callback.dataset.filial && callback.dataset.filial.length > 0) {
                var widget = templateManager.container.getWidget('expedicaoPedido');
                var widgetFiltro = templateManager.container.getActiveWidget();
                var filialLogada = callback.dataset.filial;

                var filtroFilial = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filialLogada[0].CDFILIAL
                    }
                ];

                var filtroSerie = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": filialLogada[0].CDEMPRESA
                    },
                    {
                        "name": "CDINSCESTA",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCESTA
                    },
                    {
                        "name": "CDINSCMUNI",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCMUNI
                    }
                ];
                widget.getField('DSSERIE').dataSourceFilter       = filtroSerie;
                widgetFiltro.getField('DSSERIE').dataSourceFilter = filtroSerie;

                widget.getField('NRPEDIDO').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDO').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;

                widget.container.getActiveWidget().reload();
            }
        }.bind(this));
    };

    this.validaIntervaloPedido = function(args) {
        var tipoFiltro = args.owner.field.widget.currentRow.TIPOFILTRO;
        var NRPEDIDOINI = args.owner.field.widget.getField('NRPEDIDOINI');
        var NRPEDIDOFIN = args.owner.field.widget.getField('NRPEDIDOFIN');
        var NRPEDIDO = args.owner.field.widget.getField('NRPEDIDO');

        if (tipoFiltro == 'I') {
            this.setFieldRequired(NRPEDIDOINI);
            this.setFieldRequired(NRPEDIDOFIN);
            this.setFieldNotRequired(NRPEDIDO);
        } else if (tipoFiltro == 'L') {
            this.setFieldNotRequired(NRPEDIDOINI);
            this.setFieldNotRequired(NRPEDIDOFIN);
            this.setFieldRequired(NRPEDIDO);
        } else {
            this.setFieldNotRequired(NRPEDIDOINI);
            this.setFieldNotRequired(NRPEDIDOFIN);
            NRPEDIDO.isVisible = true;
            NRPEDIDO.readOnly = true;
            delete NRPEDIDO.validations;
        }

        NRPEDIDOINI.value('');
        NRPEDIDOFIN.value('');
        NRPEDIDO.value('');
    };

    this.setFieldRequired = function(field){
        field.isVisible = true;
        field.validations = {
            "required": true
        };
        field.readOnly = false;
    };

    this.setFieldNotRequired = function(field){
        field.isVisible = false;
        delete field.validations;
        field.readOnly = true;
    };

    this.expedirPedido = function(args){
        Exp00200_lancamentoExpedicaoPedido_Service.expedir(args);
    };

    this.setValueCurrentCliente = function(field){
        field.widget.currentRow.CDCLIENTE = field.value();
    };

    this.setValueCurrentVendedor = function(field){
        field.widget.currentRow.CDVENDEDOR = field.value();
    };

    this.changeField = function(field, arraySonFields, firstSonField){
		for(var index in arraySonFields){
			var fieldSon = field.widget.getField(arraySonFields[index]);
			fieldSon.clearValue();
			fieldSon.readOnly = true;
		}
		field.widget.getField(firstSonField).readOnly = !field.value();
	};

	this.salvarWidget = function(widget){
	    widget.saveRow(widget);
	};

	this.getEstoqueData = function(widget){
        // $cdfilial, $nrpedido, $nritemped, $cdproduto, $cdalmoxarife, $cdlocalestoq
        Exp00200_lancamentoExpedicaoPedido_Service.getEstoqueData(widget.getParent().currentRow).then(function(callback){
            widget.dataSource.data = callback.dataset.data;
        });
	};

	this.selectRow = function(widget){
        widget.getAction('expedir').isVisible = true;
	};

	this.deselectRow = function(widget){
        if(widget.getCheckedRows().length == 0){
            widget.getAction('expedir').isVisible = false;
        }
	};

	this.verificaPedido = function(widget){
        var checkedRows = widget.getCheckedRows();
        for (var i = 0; i < checkedRows.length; i++ ) {
            if (!(widget.getField('NMTIPOOPER').requiredParam) && !(checkedRows[i].CDTIPOOPER)){
                //ScreenService.showMessage("Pedido "+checkedRows[i].NRPEDIDO+' - '+checkedRows[i].NMFANTCLIE+" não possui tipo de operação cadastrada.");
                
                var var_nao_possui_operacao = "NAO_POSSUI_OPERACAO";
                MessageService.showMessageByCode(var_nao_possui_operacao,{"NRPEDIDO":checkedRows[i].NRPEDIDO, "NMFANTCLIE": checkedRows[i].NMFANTCLIE});
                i = checkedRows.length;
                widget.unSelectAll();
            }
            // if (!(widget.transportadora) && checkedRows[i] && !(checkedRows[i].NRINSJURTRAN)){
            //     this.checkTransportadora(checkedRows[i],widget);

            //     ScreenService.showMessage("Pedido "+checkedRows[i].NRPEDIDO+' - '+checkedRows[i].NMFANTCLIE+" não possui transportadora cadastrada.");
            //     i = checkedRows.length;
            //     widget.unSelectAll();
            // }
        }
    };

    /*this.checkTransportadora = function(row,widget){
        var filterClient = [
            {
                "name": "CDCLIENTE",
                "operator": "=",
                "value": row.CDCLIENTE
            }
        ];
        var filterFilial = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
            }
        ];
        var promise = [];
        promise.push(General.callRestEngine('ped#/crud/parexpedicao', "FilterData", filterFilial));
        ZHPromise.all(promise).then(function(callback){
            if (!callback[0].dataset.parexpedicao[0].NRINSJURTRAN) {
                ScreenService.showMessage("Pedido "+row.NRPEDIDO+' - '+row.NMFANTCLIE+" não possui transportadora cadastrada.");
            }
        });
    };*/

    this.qtdeControl = function(widget){
        var qtItem  = 0;
        var qtTotal = 0;
        for (var i = 0; i < widget.dataSource.data.length; i++) {
            qtItem = widget.dataSource.data[i].QTRESPRODPED_inline;
            if (qtItem) {
                if (typeof(qtItem) == 'string') {
                    qtItem = parseFloat(qtItem.replace(',', '.'));
                }
                qtTotal += qtItem;
            }
        }
        if (widget.currentRow.QTRESPRODPED_inline > widget.getParent().currentRow.QTITEMPED || qtTotal > widget.getParent().currentRow.QTITEMPED){
            ScreenService.showMessage('Quantidade escolhida maior que a quantidade do item no pedido.');
            widget.currentRow.QTRESPRODPED_inline = 0;
            widget.currentRow.QTRESPRODPED = 0;
            return false;
        } else if (widget.currentRow.QTRESPRODPED_inline > widget.currentRow.QTDISPONIVEL){
            ScreenService.showMessage('Quantidade escolhida maior que a disponível para este lote.');
            widget.currentRow.QTRESPRODPED_inline = 0;
            widget.currentRow.QTRESPRODPED = 0;
            return false;
        } else if (qtTotal == widget.getParent().currentRow.QTITEMPED){
            widget.currentRow.QTRESPRODPED = widget.currentRow.QTRESPRODPED_inline;
            return true;
        } else {
            ScreenService.showMessage('Quantidade escolhida diferente a quantidade do item no pedido.');
            return false;
        }
    };

    this.save = function(widget){
        var qtValida = this.qtdeControl(widget);
        if (qtValida) {
            Exp00200_lancamentoExpedicaoPedido_Service.setData('ped_expedicao#/lotes_expedicao', widget.dataSource.data).then(function(success){
                ScreenService.showMessage('Salvo com sucesso.');
                widget.view();
                widget.activate();
            });
        } else {
            for (var i = 0; i > widget.dataSource.data.length; i++) {
                widget.dataSource.data[i].QTRESPRODPED_inline = 0;
                widget.dataSource.data[i].QTRESPRODPED = 0;
            }
        }
    };

    this.getLocalData = function(widget){
        for (var i = 0; i < widget.dataSource.data.length; i++) {
            widget.dataSource.data[i].NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
            widget.dataSource.data[i].NRITEMPED = widget.getParent().currentRow.NRITEMPED;
        }
        var filter = [
            {
                "name": "NRPEDIDO",
                "operator": "=",
                "value": widget.getParent().currentRow.NRPEDIDO
            },
            {
                "name": "NRITEMPED",
                "operator": "=",
                "value": widget.getParent().currentRow.NRITEMPED
            }
        ];
        Exp00200_lancamentoExpedicaoPedido_Service.getData('ped_expedicao#/lotes_expedicao', filter).then(function(callback){
            var i;
            var e;
            if (callback.length > 0 ){
                for (i = 0; i < widget.dataSource.data.length; i++) {
                    for (e = 0; e < callback.length; e++) {
                        if (widget.dataSource.data[i].NRPEDIDO == callback[e].NRPEDIDO && widget.dataSource.data[i].NRITEMPED == callback[e].NRITEMPED &&
                          widget.dataSource.data[i].CDPRODUTO == callback[e].CDPRODUTO && widget.dataSource.data[i].NRLOTEESTQ == callback[e].NRLOTEESTQ &&
                          widget.dataSource.data[i].CDALMOXARIFE == callback[e].CDALMOXARIFE) {
                            widget.dataSource.data[i].QTRESPRODPED = callback[e].QTRESPRODPED;
                        }
                    }
                }
            } else {
                for (i = 0; i < widget.dataSource.data.length; i++) {
                    delete widget.dataSource.data[i].QTRESPRODPED;
                }
            }
        }.bind(this));
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Exp00200_lancamentoExpedicaoPedido_Controller', Exp00200_lancamentoExpedicaoPedido_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/Exp01100_parametrosDeExpedicao_Controller.js
function Exp01100_parametrosDeExpedicao_Controller (ScreenService,ZHPromise, templateManager, General, Exp01100_parametrosDeExpedicao_Service){
    
    this.adicionar = function(widget){
        var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        widget.newRow();
        widget.currentRow.__is_new = true;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        this.controlaStatusWidgets(tabbedParametrosExpedicao, widget.name, false);
        
    };
	
	this.editar = function(widget){
	    var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelar = function(widget){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        if(widget.currentRow.__is_new === true){    
            widget.parent.widgets.forEach(function(element){
                element.currentRow = {};
            });
        }
	    widget.template = widget.templateToView;
        widget.view();
        widget.reload();
        widget.activate();
        
        var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = false;
	    
    };
    
    this.completeFieldVRPERCOMEXP = function(field){
       
       var VRPERCOMEXP = 100 - parseFloat(field.value().replace(/,/gi, "."));
       if(VRPERCOMEXP === 0){
          VRPERCOMEXP = 0; 
       }
         else if(VRPERCOMEXP > 0){
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = VRPERCOMEXP;    
       } else {
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = "";
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = "";
       }
       
    };
   
    this.completeFieldVRPERCOMREC = function(field){
       
       var VRPERCOMREC = 100 - parseFloat(field.value().replace(/,/gi, "."));
       if(VRPERCOMREC >= 0){
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = VRPERCOMREC;
       } else {
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = "";
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = "";
       }
       
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });
    };
    
    this.filtroParametrosExpedicao = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        
        General.callRestEngine("ped_expedicao#/crud/parexpedicao_tipooperac","FilterData", filtro).then(function(sucesso){
            var resultado = sucesso.dataset.parexpedicao_tipooperac[0];
            widget.widgets.forEach(function(value){
                if(resultado && filial) {
                    value.currentRow = resultado;
                    value.getAction('editar').isVisible = true;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }else if(!resultado && filial){
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = true;
                    value.reload();
                }
                else {
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }
            });
            
        }.bind(this), function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.recarregarField = function(nomeWidget,nomeField){
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        field.reload();
    };
   
    this.saveLogExpedicao = function(widget){
        if(widget.isValid()){
            var promiseDel = [];
            var promiseIns = [];
            
            var nmgrupopersep = widget.currentRow.NMGRUPOPERSEP;
            var nmgrupopercon = widget.currentRow.NMGRUPOPERCON;
            
            // widget.currentRow.CDGRUPOPERSEP = (widget.currentRow.NMGRUPOPERSEP) ? widget.currentRow.CDGRUPOPERSEP : null; 
            
            if(nmgrupopersep){
                var objDelSep = {
                    "CDFILIAL": widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP": "LOGS"
                };
                promiseDel.push(Exp01100_parametrosDeExpedicao_Service.deleteLogExpedicao(objDelSep));
                
                var cdgrupopersep = widget.currentRow.CDGRUPOPERSEP;
                var objLog = {
                    "__is_new" : true,
                    "changed": true,
                    "CDFILIAL" : widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP" : 'LOGS',
                    "CDGRUPOPER": widget.currentRow.CDGRUPOPERSEP,
                    "NRAUTGRUPOP" : widget.currentRow.NRAUTGRUPOPSEP,
                    "NRORG" : widget.currentRow.NRORG
                };
                promiseIns.push(Exp01100_parametrosDeExpedicao_Service.insertLogExpedicao(objLog));
                
            }
            
            if(nmgrupopercon){
                var objDelConf = {
                    "CDFILIAL": widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP": "LOGC"
                };
                promiseDel.push(Exp01100_parametrosDeExpedicao_Service.deleteLogExpedicao(objDelConf));
                
                var cdgrupopercon = widget.currentRow.CDGRUPOPERCON;
                var objLogConf = {
                    "__is_new" : true,
                    "changed": true,
                    "CDFILIAL" : widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP" : 'LOGC',
                    "CDGRUPOPER": widget.currentRow.CDGRUPOPERCON,
                    "NRAUTGRUPOP" : widget.currentRow.NRAUTGRUPOPCON,
                    "NRORG" : widget.currentRow.NRORG
                };
                promiseIns.push(Exp01100_parametrosDeExpedicao_Service.insertLogExpedicao(objLogConf));
            }
            
            // if(nmgrupopersep || nmgrupopercon){
                ZHPromise.all(promiseDel).then(function(){
                    ZHPromise.all(promiseIns).then(function(){
                        General.saveCrud(widget).then(function() {
                            General.callRestEngine('ped#/crud/grupoper_autgrupop_logExpedicao/save', 'Row', widget.currentRow);
                        });
                    });
                });
            // }
            
            this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'controleLogExpedicao',true);
            var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
            tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
            var currentRow = widget.currentRow;
            if(currentRow.__is_new == true){
                this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
            }
            currentRow.__is_new = false;
            currentRow.changed = false;
            widget.template = widget.templateToView;
            widget.view();
            widget.list();
        }
    };
    
    this.reloadWidgets = function(){
        var widget = templateManager.container.getWidget('tabbedParametrosExpedicao');
        widget.widgets.forEach(function(element){
            element.reload();
        }.bind(this));
        templateManager.updateTemplate();
    };
    
    this.getMaxNrautgrupop = function(nomeWidget,nomeField){
        
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        var nrorg = field.widget.currentRow.NRORG;
        var cdgrupoper;
        var idautgrupop;
        
        if(field.name == 'NMGRUPOPERCON'){
            cdgrupoper = field.widget.currentRow.CDGRUPOPERCON;
            idautgrupop = 'LOGC';
        }
        else if(field.name == 'NMGRUPOPERSEP'){
            cdgrupoper = field.widget.currentRow.CDGRUPOPERSEP;
            idautgrupop = 'LOGS';
        }
        
        
        
        Exp01100_parametrosDeExpedicao_Service.getMaxNrautgrupop(cdgrupoper, idautgrupop, nrorg).then(function(retorno){
           var max = '0';
           var objeto = retorno.dataset.autgrupop;

            if(objeto[0]){
                objeto.forEach(function(obj){ 
                    if(obj.NRAUTGRUPOP > max){
                       max = obj.NRAUTGRUPOP;
                    }
                });
                max = parseInt(max) + 1;
            }else{
                max = '1';
            }
            
            if(field.name == 'NMGRUPOPERCON'){
                field.widget.currentRow.NRAUTGRUPOPCON = max;
                field.widget.currentRow.NRAUTGRUPOPSEP = (field.widget.currentRow.NRAUTGRUPOPSEP) ? field.widget.currentRow.NRAUTGRUPOPSEP : '1';
            }else if(field.name == 'NMGRUPOPERSEP'){
                field.widget.currentRow.NRAUTGRUPOPSEP = max;
                field.widget.currentRow.NRAUTGRUPOPCON = (field.widget.currentRow.NRAUTGRUPOPCON) ? field.widget.currentRow.NRAUTGRUPOPCON : '1';
            }
            
        });
    };
   
    this.salvarInformacoesFinanceiras = function(widget){
        var widgetInformacoesFinanceiras = templateManager.container.getWidget('informacoesFinanceiras');
        var calcula = widgetInformacoesFinanceiras.getField('IDCOMISPERIODO');
        
        if(calcula.value() == "S"){
            if((parseFloat(widget.getField('VRPERCOMEXP').value()) + parseFloat(widget.getField('VRPERCOMREC').value())) === 100){
            
            General.saveCrud(widget).then(function(sucesso){
                        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'informacoesFinanceiras',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
                    }.bind(this), function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
            }else{ 
               ScreenService.showMessage("A soma dos campos 'Percentual de Comissão na Expedição' e 'Percentual de Comissão na Baixa (Recebimento)' deve ser igual a 100%");
            }
       }else{
            General.saveCrud(widget).then(function(sucesso){
                        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'informacoesFinanceiras',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
       }
   };
   
    this.salvarDistribuicaoTransporte = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'distribuicaoTransporte',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarNotaFiscalEstoque = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'notaFiscalEstoque',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
    };
   
    this.salvarExpedicaoPorPedido = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorPedido',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarExpPorItemPedido = function(widget){
        if(widget.isValid()){
            
            var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
            var campoPermissaoExpedicaoAdicional = expedicaoPorItemPedido.getField('IDPERADIEXP');
            var campoPercentual = expedicaoPorItemPedido.getField('VRPEADIEXP');
            if(campoPermissaoExpedicaoAdicional.value() == 'S'){
                if(campoPercentual.value() >= 0.01 && campoPercentual.value() <= 500){
                   General.saveCrud(widget).then(function(){
                       this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorItemPedido',true);
                            var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                            tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                            var currentRow = widget.currentRow;
                            widget.view();
                            if(currentRow.__is_new == true){
                                this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                            }
                            currentRow.__is_new = false;
                            currentRow.changed = false;
                            widget.template = widget.templateToView;
                            widget.getAction('editar').isVisible = true;
                            widget.getAction('atualizar').isVisible = true;
                            widget.getAction('novo').isVisible = false;
                        }.bind(this), function(callback){
                            if(callback.data){
                                ScreenService.showMessage(callback.data.error);
                            }
                        });
                
                }else{
                    ScreenService.showMessage("O valor do campo 'Percentual Máximo para Expedição Adicional' deve estar entre 0,01 e 500%");
                }
            }else{
                General.saveCrud(widget).then(function(sucesso){
                   this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorItemPedido',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
                    }.bind(this), function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
            }
        }
    };
    
    this.salvarContabilizacaoFrete = function(widget){
        General.saveCrud(widget);
        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'contabilizacaoFretes',true);
        widget.enabled = true;
        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
    };

    this.verificaPermissaoExpedAdicional = function(widget){
        var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
        var campoPermissaoExpedicaoAdicional= expedicaoPorItemPedido.getField('IDPERADIEXP');
        var campoPercentual =expedicaoPorItemPedido.getField('VRPEADIEXP');
        if(campoPermissaoExpedicaoAdicional.value()=="S"){
            campoPercentual.readOnly=false;
            campoPercentual.validations.required = true;
        }else {
            campoPercentual.setValue('0');
            campoPercentual.readOnly=true;
            campoPercentual.validations.required = false;
        }
    };
   
    this.verificaPercentualMaximo = function(widget){
        var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
        var campoPermissaoExpedicaoAdicional= expedicaoPorItemPedido.getField('IDPERADIEXP');
        if(campoPermissaoExpedicaoAdicional.value()=="S"){
           widget.getField('VRPEADIEXP').validations.range.required=true;
        }else{
            widget.getField('VRPEADIEXP').validations.range.required=false;
        }
   };
  
    this.verificaContaReceberFrete = function(){
        var widgetInformacoesFinanceiras =  templateManager.container.getWidget('informacoesFinanceiras');
        var campoGeraContaReceberFrete = widgetInformacoesFinanceiras.getField('IDGERACTFRETE');
        var campoPorcentagem = widgetInformacoesFinanceiras.getField('VRPERCFRETE');
        if(campoGeraContaReceberFrete.value()=="S"){
            campoPorcentagem.readOnly=false;
            campoPorcentagem.validations.required=true;
        }else {
            campoPorcentagem.setValue('0');
            campoPorcentagem.readOnly=true;
            campoPorcentagem.validations.required=false;
        }
    };
   
    this.verificaConferente = function(){
       var widgetControleLogExpedicao =  templateManager.container.getWidget('controleLogExpedicao');        
       var conferente = widgetControleLogExpedicao.getField('IDCONFERENTE');
       var grupoOp = widgetControleLogExpedicao.getField('NMGRUPOPERCON');
       if(conferente.value() == "1"){
           grupoOp.readOnly = true;
           grupoOp.setValue('');
           widgetControleLogExpedicao.currentRow.CDGRUPOPERCON = null;
           delete grupoOp.validations;
       }else{
           grupoOp.readOnly = false;
           grupoOp.validations = {required : true};
           
       }
    };
   
    this.verificaSeparador = function(){
       var widgetControleLogExpedicao =  templateManager.container.getWidget('controleLogExpedicao');        
       var separador = widgetControleLogExpedicao.getField('IDSEPARADOR');
       var grupoOp = widgetControleLogExpedicao.getField('NMGRUPOPERSEP');
       if(separador.value() == "1"){
           grupoOp.readOnly = true;
           grupoOp.setValue('');
           widgetControleLogExpedicao.currentRow.CDGRUPOPERSEP = null;
           delete grupoOp.validations;
       }else{
           grupoOp.readOnly = false;
           grupoOp.validations = {required : true};
       }
    };
   
    this.verificaComissao = function(){
       var widgetInformacoesFinanceiras = templateManager.container.getWidget('informacoesFinanceiras');
       var calcula = widgetInformacoesFinanceiras.getField('IDCOMISPERIODO');
       var expedicao = widgetInformacoesFinanceiras.getField('VRPERCOMEXP');
       var baixa = widgetInformacoesFinanceiras.getField('VRPERCOMREC');
       
       if(calcula.value() == "S"){
           expedicao.readOnly = false;
           expedicao.validations.required = true;
           baixa.readOnly = false;
           baixa.validations.required = true;
       }else{
           expedicao.readOnly = true;
           expedicao.validations.required = false;
           baixa.readOnly = true;
           baixa.validations.required = false;
           expedicao.setValue('0');
           baixa.setValue('0');
       }
    };
    
    this.changeEditLeitor = function(){
        var widget = templateManager.container.getWidget('expedicaoPorPedido');
        var idtpexppedido = widget.getField('IDTPEXPPEDIDO');
        var idexpleitor = widget.getField('IDEXPLEITOR');
        
        if(idtpexppedido.value() == 'COL'){
            idexpleitor.readOnly = false;
            idexpleitor.validations = {
                                        "required": true
                                    };
        }else{
            idexpleitor.readOnly = true;
            delete idexpleitor.validations;
            idexpleitor.setValue(null);
        }
    };
    
    this.changeEditRetiradaExpedicao = function(){
        var widget = templateManager.container.getWidget('notaFiscalEstoque');
        var idgerprodest = widget.getField('IDGERPRODEST');
        var idretproexp = widget.getField('IDRETPROEXP');
        
        if(idgerprodest.value() == '3'){
            idretproexp.readOnly = false;
        }else{
            idretproexp.readOnly = true;
        }
    };
    
    this.changeEditTrocaProduto = function(){
        var widget = templateManager.container.getWidget('notaFiscalEstoque');
        var idevolesttro = widget.getField('IDEVOLESTTRO');
        var nmgropertroc = widget.getField('NMGROPERTROC');
        
        if(idevolesttro.value() == 'N'){
            nmgropertroc.readOnly = false;
        }else{
            nmgropertroc.readOnly = true;
        }
    };
    
    this.changeEditGeraComissao = function(){
        var widget = templateManager.container.getWidget('informacoesFinanceiras');
        var idcomisperiodo = widget.getField('IDCOMISPERIODO');
        var vrpecogerexp = widget.getField('VRPECOGEREXP');
        
        if(idcomisperiodo.value() == 'S'){
            vrpecogerexp.readOnly = true;
            vrpecogerexp.setValue(null);
            delete vrpecogerexp.validations;
        }else{
            vrpecogerexp.readOnly = false;
            vrpecogerexp.validations = {
                                        "required": true
                                    };
        }
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp01100_parametrosDeExpedicao_Controller', Exp01100_parametrosDeExpedicao_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/Exp01800_cancelamento_Controller.js
var Exp01800_cancelamento_Controller = function(General, templateManager, ScreenService, ZHPromise, ZhFilterPreferences) {

    this.reloadFieldFilter = function(nameField) {

        var widgetFilter = templateManager.container.getActiveWidget();

        widgetFilter.getField(nameField).reload();

    };

    this.checkCdFilialLength = function() {

        var widgetFilter = templateManager.container.getActiveWidget();

        var cdfilial =  widgetFilter.getField('CDFILIAL');

        if(cdfilial.value().length == 4) {

            this.reloadFieldFilter('NREXPEDICAO');

            this.reloadFieldFilter('CDROTATRANS');

            this.reloadFieldFilter('NRPEDIDO');

        }

    };
    
    this.recarregaWidget = function(){
        var widget = templateManager.container.getWidget('widgetCancelamento');
        widget.reload();
    };

    this.habilitaCancelarExped = function(){

        var widget = templateManager.container.getActiveWidget();
        if( widget.getAction('cancelarExpedicao')){
            
            if(widget.getCheckedRows().length) {

                widget.getAction('cancelarExpedicao').isVisible = true;

            } else {

                widget.getAction('cancelarExpedicao').isVisible = false;
        
            }
        }


    };


    this.cancelarExpedicao = function() {

        var rows = templateManager.container.getWidget('widgetCancelamento').getCheckedRows();
        var widget = templateManager.container.getActiveWidget();

        General.callRestEngine('ped_expedicao#/cancelarExpedicao','DataSet', rows)
        .then(function(callback){
            
            callback.dataset.data.forEach(function(item){
                item.IDERRO = ScreenService.i18n(item.IDERRO);  
            });

            widget.unSelectAll();
            widget.reload();
            var widgetRetornoCancelamento = templateManager.container.getWidget('popUpRetornoCancelamento');
            
            setTimeout(function(){
                    ZHPromise.all(ScreenService.openPopup(widgetRetornoCancelamento)).then(function(){
                        widgetRetornoCancelamento.dataSource.data = callback.dataset.data;
                    });
                }, 1000);
        }.bind(this))
        .catch(function(callback){
            ScreenService.showMessage(callback.data.error);
            ScreenService.closePopup(widget).then(function(){
                ScreenService.closePopup();
            });
        }.bind(this));
        

    };
};


Configuration(function(ContextRegister){
    ContextRegister.register('Exp01800_cancelamento_Controller', Exp01800_cancelamento_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/Exp0800_comissaoVendedorPeriodo_Controller.js
function Exp0800_comissaoVendedorPeriodo_Controller(templateManager, General, ScreenService, Exp0800_comissaoVendedorPeriodo_Service, ZhFilterPreferences, ZHPromise) {
    
    var mensagens = {
        errorBloqueado: 'O mapa já esta bloqueado.',
        mapaBloqueado: 'Mapa bloqueado com sucesso!',
        errorDesbloqueado: 'O mapa já esta desbloqueado.',
        mapaDesbloqueado: 'Mapa desbloqueado com sucesso.',
        errorApurar: 'Desbloqueie o mapa antes de apurar.',
        apuradoSucesso: 'Mapa apurado com sucesso!',
        apuradoError: 'Erro ao apurar o mapa!',
        alertaMapas: 'Existem notas/contas com alerta. Deseja continuar?',
        notaOutroPeriodo: 'Esta nota já foi apurada em outro periodo.',
        contaOutroPeriodo: 'Esta conta já foi apurada em outro periodo.',
        errorContaPagar: 'Ocorreu um erro ao gerar a conta!',
        contaPagarExistente: 'Esse mapa já possui contas a pagar.',
        bloquearMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        desbloquarMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        salvoSucesso: 'Salvo com sucesso!',
        errorSalvar:  'Ocorreu um erro a salvar',
        errorSaveComissao: 'Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.',
        bloqOperacao: 'Este mapa possui contas a pagar. Não foi possivel ',
        apurarComissao: 'Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar? '
    };  
    
    this.startFiltering = function(widgetPedidos){
        
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };
    
    this.adicionar = function(widget) {
        var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('adicionar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel adicionar.");
            }
            else {
                General.widgetNewRow(widget);
            }
        });
    };
    
    this.setDATAATUAL = function(widget){
        if(templateManager.container.getWidget('contas_a_pagar').dataSource.data.length > 0){
            templateManager.container.getWidget('contas_a_pagar').dataSource.data[0].DATAATUAL = moment().format('DD/MM/YYYY hh:mm:ss');
        }
    };
    
    this.apurarComissao = function(widget) {
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
            var row = { INICIAL: widget.currentRow.DTINIPERIODO,
                                        FINAL: widget.currentRow.DTFIMPERIODO,
                                        VENDEDOR: widget.currentRow.CDVENDEDOR,
                                        NRORG: widget.currentRow.NRORG,
                                        CDFILIAL: widget.currentRow.CDFILICOMIS,
                                        NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
                            };  
            
           Exp0800_comissaoVendedorPeriodo_Service.verificaMapasAnteriores(row).then(function(success){
                if(success.dataset.mapacomperiodo[0]) {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.apurarComissao), 'question', function (success) {
                    ScreenService.confirmMessage("Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar?", 'question', function(success){    
                        row.MAPAOUTROPERIODO = 'S';
                        ScreenService.confirmMessage(ScreenService.i18n('Deletar notas/contas fora do período?'), 'question', function (success) {
                            row.excluiForaPeriodo = 'S';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                            }.bind(this),
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this), 
                        function(error) {
                           row.excluiForaPeriodo = 'N';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                                
                            },
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this));
                    }.bind(this),
                    function(error) {
                            ScreenService.closePopup();
                    });
                } else {
                    row.MAPAOUTROPERIODO = 'N';
                    ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir o detalhamento do mapa?'), 'question', function (success) {
                        row.excluiForaPeriodo = 'S';
                        Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                            //ScreenService.showMessage(mensagens.apuradoSucesso);
                            ScreenService.showMessage("Mapa apurado com sucesso!");
                            ScreenService.closePopup();
                            widget.reload();
                        }.bind(this),
                        function(error) {
                            //ScreenService.showMessage(mensagens.apuradoError);
                            ScreenService.showMessage("Erro ao apurar o mapa!");
                        });
                    }.bind(this), 
                    function(error) {
                           row.excluiForaPeriodo = 'N';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                                
                            }.bind(this),
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                	}.bind(this));

                   
                }
    	   
           }.bind(this));
        }
        //else ScreenService.showMessage(mensagens.errorApurar);
        else ScreenService.showMessage("Desbloqueie o mapa antes de apurar.");
    };
    
    this.saveNota = function(widget) {
        
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);

        Exp0800_comissaoVendedorPeriodo_Service.saveNota(row).then(function(success){
            if(success.dataset) {
                //ScreenService.showMessage(mensagens.notaOutroPeriodo);
                ScreenService.showMessage("Esta nota já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
            ScreenService.showMessage("Salvo com sucesso!").then(function(){    
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
        
       
    };
    
    this.saveConta = function(widget) {
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        row.NEWROW = true;
        Exp0800_comissaoVendedorPeriodo_Service.saveConta(row).then(function(success){
             if(success.dataset) {
                //ScreenService.showMessage(mensagens.contaOutroPeriodo);
                ScreenService.showMessage("Esta conta já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
              ScreenService.showMessage("Salvo com sucesso!").then(function(){
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
    };
    
    this.situacaoMapa = function(widget, boolean) {
        // Quando boolean é true o mapa é bloqueado
        // Quando boolean é false o mapa é desbloqueado
        if(boolean) {
            //Verifica se o mapa já esta bloqueado 
            if(widget.currentRow.IDBLOQMAPACOMIS === 'S') {
                //ScreenService.showMessage(mensagens.errorBloqueado);
                ScreenService.showMessage("O mapa já esta bloqueado.");
                return 0;
            }
            else {
                
                var row = { 
                    VENDEDOR: widget.currentRow.CDVENDEDOR,
                    NRORG: widget.currentRow.NRORG,
                    CDFILIAL: widget.currentRow.CDFILICOMIS,
                    NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
                };  
                ZHPromise.all(Exp0800_comissaoVendedorPeriodo_Service.verificaAlertaMapas(row)).then(function(success){
                    if(success.dataset.mapacomexp.ERRO === true)  {
                    	//ScreenService.confirmMessage(ScreenService.i18n(mensagens.alertaMapas), 'question', function (success) {
                    	ScreenService.confirmMessage("Existem notas/contas com alerta. Deseja continuar?", 'question', function (success) {
                    	    widget.currentRow.IDBLOQMAPACOMIS = 'S';
                	        General.saveCrud(widget).then(function(success){
                                widget.reload();
                                ScreenService.closePopup();
                                //ScreenService.showMessage(mensagens.mapaBloqueado);
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                             });
                    	},
                    	function(error) {
                    	    ScreenService.closePopup();
                    	});
                    }
                    else {
                        widget.currentRow.IDBLOQMAPACOMIS = 'S';
                        General.saveCrud(widget).then(function(success){
                            widget.reload();
                            ScreenService.closePopup();
                            //ScreenService.showMessage(mensagens.mapaBloqueado);
                            ScreenService.showMessage("Mapa bloqueado com sucesso!");
                        });
                    }
                },
                function(error){
                    ScreenService.showMessage('Erro ao bloquear mapa');
                });
            }
            
        }
        else {
            //Verifica se o mapa já esta desbloqueado
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
                //ScreenService.showMessage(mensagens.errorDesbloqueado);
                ScreenService.showMessage("O mapa já esta desbloqueado.");
                return 0;
            } 
            else widget.currentRow.IDBLOQMAPACOMIS = 'N';
            General.saveCrud(widget).then(function(success){
                widget.reload();
                ScreenService.closePopup();
                if(boolean) {
                    //ScreenService.showMessage(mensagens.mapaBloqueado);
                    ScreenService.showMessage("Mapa bloqueado com sucesso!");
                }
                //else ScreenService.showMessage(mensagens.mapaDesbloqueado);
                else ScreenService.showMessage("Mapa desbloqueado com sucesso.");
            
             });
        }
      
        
        
    };
    
    this.gerarContaPagar = function(widget) {
         var row = { 
            VENDEDOR    : widget.getParent().currentRow.CDVENDEDOR,
            NRORG       : widget.getParent().currentRow.NRORG,
            CDFILIAL    : widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS : widget.getParent().currentRow.NRMAPACOMIS,
            VRCONTAPAG  : widget.getParent().currentRow.VRCOMISTOTAL
        };  
        if(widget.getParent().currentRow.IDBLOQMAPACOMIS === 'N') {
            //ScreenService.confirmMessage(ScreenService.i18n(mensagens.bloquearMapa), 'question', function (success) {
            ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function(success) {
                this.situacaoMapa(widget.getParent(), true);
                if(widget.dataSource.data[0]) {
                    //ScreenService.showMessage(mensagens.contaPagarExistente);
                    ScreenService.showMessage("Esse mapa já possui contas a pagar.");
                }
                else {
                    Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                        widget.reload();
                        
                    },
                    function(error) {
                        //ScreenService.showMessage(mensagens.errorContaPagar);
                        ScreenService.showMessage("Ocorreu um erro ao gerar a conta!");
                    }
                    );  
                }  
            }.bind(this));    
        }
        else {
            if(widget.dataSource.data[0]) {
                //ScreenService.showMessage(mensagens.contaPagarExistente);
                ScreenService.showMessage("Esse mapa já possui contas a pagar.");
            }
            else {
                Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                    widget.reload();
                },
                function(error) {
                    if(error.data.error !== "Fornecedor não possui tipo de conta cadastrada."){
                        //ScreenService.showMessage(mensagens.errorContaPagar);
                        ScreenService.showMessage("Ocorreu um erro ao gerar a conta!");
                        
                    }else{
                        ScreenService.showMessage("Fornecedor não possui tipo de conta cadastrada.");
                    }
                });  
            }
        }
    };
    
    this.saveComissaoProduto = function(widget) {
        widget.currentRow.EDITCOMISSAO = true;
        widget.currentRow.NRORG        = widget.getParent().currentRow.NRORG;
        widget.currentRow.NRMAPACOMIS  = widget.getParent().currentRow.NRMAPACOMIS;
        widget.currentRow.VENDEDOR     = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDVENDEDOR   = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDFILIAL     = widget.getParent().currentRow.CDFILICOMIS;
        widget.currentRow.__is_new     = false;
        Exp0800_comissaoVendedorPeriodo_Service.saveComissaoProduto(widget.currentRow).then(function(success) {
            ScreenService.goBack();
            widget.reload();
            templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            //ScreenService.showMessage(mensagens.salvoSucesso);
            ScreenService.showMessage("Salvo com sucesso!");
        }.bind(this), function(error) {
            //ScreenService.showMessage(mensagens.errorSaveComissao);
            ScreenService.showMessage("Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.");
        });
    };
    
    this.editComissao = function(widget) {
         var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('editar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel editar.");
            }
            else {
                if(templateManager.container.getWidget('comissao_do_vendedor_por_periodo').currentRow.IDBLOQMAPACOMIS === 'S') {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.desbloquarMapa), 'question', function (success) {
                    ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function (success) {
                        General.widgetEdit(widget);
                    });
                }
                else {
                    General.widgetEdit(widget);
                }
            }
        }.bind(this));
    };
    
    this.excluirMapa = function(widget) {
        var row = {
            CDVENDEDOR: widget.currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.currentRow.NRMAPACOMIS,
            NRORG: widget.currentRow.NRORG
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }
            else {
                 var row = { 
                    CDVENDEDOR    : widget.currentRow.CDVENDEDOR,
                    NRORG       : widget.currentRow.NRORG,
                    CDFILIAL    : widget.currentRow.CDFILIAL,
                    NRMAPACOMIS : widget.currentRow.NRMAPACOMIS,
                    CDFILICOMIS: widget.currentRow.CDFILICOMIS,
                    dataSourceName: 'mapacomperiodo'
                }; 
                Exp0800_comissaoVendedorPeriodo_Service.excluirMapa(row).then(function(success){
                    ScreenService.showMessage('Deletado com sucesso!');
                    ScreenService.goBack();
                    widget.reload();
                }.bind(this),
                function(error){
                    ScreenService.showMessage('Ocorreu um erro ao deletar');
                });
            }
        }.bind(this));
    };
    
    this.excluir = function(widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){

            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }    
            else {
                General.deleteCrud(widget).then(function(success){
                    templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                }.bind(this));
            }
        }.bind(this));
    };
    
    this.controlaVisibilidade = function(widget){
        if(widget.getCheckedRows().length == 0){
            widget.getAction('RECALCULO_COMISSAO').isVisible = false;
        }else{
            widget.getAction('RECALCULO_COMISSAO').isVisible = true;
        }
	};
	
	this.recalculoComissao = function(){
	    var widget = templateManager.container.getWidget('comissao_do_vendedor_por_periodo');
	    var rows = widget.getCheckedRows();
	    var dataset = [];
	    var i = 0;
	    rows.forEach(function(row){
	        var dadosRow = {
	            CDFILIAL: row.CDFILICOMIS,
	            CDVENDEDOR: row.CDVENDEDOR,
	            DATAINICIAL: row.DTINIPERIODO,
	            DATAFINAL: row.DTFIMPERIODO
	        };
	        dataset[i] = dadosRow;
	        i++;
	    });
	    
	    Exp0800_comissaoVendedorPeriodo_Service.recalculoComissao(dataset).then(function(){
            widget.reload();
            widget.unSelectAll();
            ScreenService.showMessage("Comissão recalculada com sucesso.");
	    }.bind(this))
	    .catch(function(){
	        ScreenService.showMessage("Ocorreu um erro ao recalcular a comissao do vendedor.");
	    }.bind(this));
	};

    
    this.adicionarComissao = function(widget){
        var rows = widget.groupedData;
        var cdfilial = widget.appliedFilter.FILTER_ROW.CDFILICOMIS;
        var cdvendedor =  widget.appliedFilter.FILTER_ROW.CDVENDEDOR;
        var nmfilial = widget.appliedFilter.FILTER_ROW.NMFILIAL;
        var nmrazsocven = widget.appliedFilter.FILTER_ROW.NMRAZSOCVEN;
        var maiorDataFinal;
        
        
        function maiorData(row){
            if(maiorDataFinal){
                if(moment(maiorDataFinal, "DD/MM/YYYY") < moment(row.DTFIMPERIODO, "DD/MM/YYYY")){
                    maiorDataFinal = moment(row.DTFIMPERIODO, 'DD/MM/YYYY');
                }
            }else{
                maiorDataFinal = row.DTFIMPERIODO;
            }
        }
        
        if(rows){
            widget.newRow();
            rows.forEach(maiorData);
        
            widget.currentRow.CDFILICOMIS = cdfilial;
            widget.getField('CDFILICOMIS').setValue(cdfilial);
            widget.currentRow.NMFILIAL = nmfilial;
            widget.getField('NMFILIAL').setValue(nmfilial);

            widget.currentRow.CDVENDEDOR = cdvendedor;
            widget.getField('CDVENDEDOR').setValue(cdvendedor);
            widget.currentRow.NMRAZSOCVEN = nmrazsocven;
            widget.getField('NMRAZSOCVEN').setValue(nmrazsocven);
            
            widget.getField('NMRAZSOCVEN').readOnly = true;
            widget.getField('NMFILIAL').readOnly = true;
            
            if(maiorDataFinal){
                widget.currentRow.DTINIPERIODO = moment(maiorDataFinal, 'DD/MM/YYYY').add(1,'days').format('DD/MM/YYYY');    
            }
            
            widget.reload();
        }else{
            widget.newRow();
        }
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp0800_comissaoVendedorPeriodo_Controller', Exp0800_comissaoVendedorPeriodo_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/Ger01100_Transportadora_Controller.js
var Ger01100_Transportadora_Controller = function (ScreenService, General, templateManager, restEngine, localStorageEngine, Endereco, Ger01100_Transportadora_Service) {

	this.newTransportadora = function(widget){
		General.newRow(widget);
		this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro(widget.name);
	};
	
	this.setFieldsAddress = function (widgetName, fieldName) {
		//field = General.getFieldValue(fieldName,widgetName);
		//field = field.toString();
		//return field;
		return General.getFieldValue(fieldName, widgetName);
		//return templateManager.container.getWidget(widgetName).currentRow[fieldName] || '';
	};

	this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRTRAN');
		if (widget.currentRow.NMPAIS) {
			estado.readOnly = false;
			municipio.readOnly = true;
			bairro.readOnly = true;
			if (widget.currentRow.NMESTADO) {
				municipio.readOnly = false;
				bairro.readOnly = true;
				if (widget.currentRow.NMMUNICIPIO) {
					bairro.readOnly = false;
				} else {
					bairro.readOnly = true;
				}
			} else {
				municipio.readOnly = true;
				bairro.readOnly = true;
			}
		} else {
			estado.readOnly = true;
			municipio.readOnly = true;
			bairro.readOnly = true;
		}
	};

	this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRTRAN');
		switch (nomeCampoAtual) {
		case 'Pais':
			estado.value('');
			municipio.value('');
			bairro.value('');
			break;
		case 'Estado':
			municipio.value('');
			bairro.value('');
			break;
		case 'Municipio':
			bairro.value('');
			break;
		default:
			break;
		}
	};

	this.recarregarCampo = function (nomeWidget, nomeCampo) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.getField(nomeCampo).reload();
	};

	this.recarregarWidget = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.reload();
	};

	this.validarCepEnd = function (args) {

		var widget = args.owner.owner.widget;
		var CEP = widget.currentRow.NRCEPTRAN;
		if (CEP) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				if (endereco) {
					widget.currentRow.NRCEPTRAN = CEP;
					widget.currentRow.ENDERECOPARCEIRO = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
					widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
					widget.currentRow.NMBAIRTRAN = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
					widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
					widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
					widget.currentRow.DSENDETRAN = ((endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '') + " " + widget.currentRow.ENDERECOPARCEIRO;
					//widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';
					this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridTransportadora');
				}
				if (response.dataset.ERRO){ 
					ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
				}
			}.bind(this), function(error){
				ScreenService.showMessage("Ouve um erro ao tentar localizar este CEP. Insira um CEP Valido.", "warning");	
			});
		}
	};

	/* **************************************************
	 * Procedimento que checa o input de inscrição,
	 * validando-o e colocando o tipo de inscrição na
	 * currentRow de acordo.
	 *
	 * Nota: Esse método pressupõe que o input de
	 * inscrição possui as propriedades valueField e
	 * descriptionField, apesar de ser do template
	 * text-edit. Ele também supõe que o valueField
	 * e o descriptionField estarão na currentRow.
	 *
	 * @param Field field
	 */
	this.checkNumeroDeInscricao = function (field) {
		var validatedInscricao = Ger01100_Transportadora_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
		var widget = field.widget;

		if (validatedInscricao.valid) {
			//if input is valid, builds unformatted data to save
			switch (validatedInscricao.tipo.cod) {
			case 'O': //Código genérico
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
				break;
			case 'I': //Inscrição genérica
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
				break;
			default: //CPF && CNPJ
				validatedInscricao.rawValue = validatedInscricao.parameter;
			}

			//sets data in the currentRow
			widget.currentRow.IDTPIJURTRAN = validatedInscricao.tipo.cod;
			widget.currentRow[field.valueField] = validatedInscricao.rawValue;
			widget.currentRow[field.descriptionField] = validatedInscricao.value;
		} else {
			//if message exists, throws warning popup
			if (validatedInscricao.error.msg)
				ScreenService.showMessage(validatedInscricao.error.msg, "warning");

			//cleans data
			widget.currentRow[field.valueField] = null;
			widget.currentRow[field.descriptionField] = null;
		}
	};

	this.verificaVeiculo = function (args) {
		var widget = templateManager.container.getWidget('gridTransportadora');
		var veiculo = widget.getField('DSTIPOVEIC');
		var inscricao = widget.getField('NRINSJURTRAN').value();
		veiculo.dataSourceFilter[0].value = inscricao.replace(/[^0-9]/g, '');
		widget.getField('DSTIPOVEIC').reload().then(function (Success) {
			if (veiculo.dataSource.data.length === 0) {
				ScreenService.showMessage('Veículo não cadastrado para a transportadora.');
				//ScreenService.closePopup();
			}
		}, function (callback) {});
	};

	this.salvarTransportadora = function (args) {
		var widget = templateManager.container.getWidget('gridTransportadora');
		if (widget.isValid()) {

			widget.currentRow.CDTIPTRANS = widget.currentRow.CDTIPTRANS ? widget.currentRow.CDTIPTRANS : null;
			widget.currentRow.CDVEICPADRAO = widget.currentRow.CDVEICPADRAO ? widget.currentRow.CDVEICPADRAO : null;
			if (!widget.currentRow.CDLOGRADOURO) {
				widget.currentRow.CDLOGRADOURO = null;
			}
			Ger01100_Transportadora_Service.removerMacaras(widget.currentRow);
			Ger01100_Transportadora_Service.salvarTransportadora(widget.currentRow).then(function (Success) {
				widget.dataSource.name = 'ped_expedicao#/crud/transport_completa';
				if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
				}
			}, function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
				widget.dataSource.name = 'ped_expedicao#/crud/transport_completa';

			});
		}
	};
	
	this.verficaParceiro = function (args) {
		var widget = args.owner.owner.widget;
		if (widget.currentRow.NRINSJURTRAN) {
			widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURTRAN.replace(/[^0-9]/g, '');
			Ger01100_Transportadora_Service.buscarParceiro(widget.currentRow).then(function (response) {
					var parceiro = response.dataset.parcnegocio;
					if (parceiro.length !== 0) {
						ScreenService.confirmMessage('Já existe um parceiro para este número de inscrição. Deseja carregar dados do parceiro?', 'question', function (success) {
							widget.currentRow.NMRAZSOCTRAN = parceiro[0].NMPRINCIPALPARC;
							widget.currentRow.NMFANTTRAN = parceiro[0].NMSECUNDARIPARC;
							widget.currentRow.NRPARCNEGOCIO = parceiro[0].NRPARCNEGOCIO;
						});
					}
				},
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
	};

	this.addMask = function (widget) {
		var data = widget.dataSource.data;
		data.forEach(function (element, index, data) {
			if (element.NRINSJURTRAN.length == 14)
				element.NRINSJURTRAN = element.NRINSJURTRAN.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
			if (element.NRINSJURTRAN.length == 11)
				element.NRINSJURTRAN = element.NRINSJURTRAN.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
		});
		widget.redraw();
	};

};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01100_Transportadora_Controller', Ger01100_Transportadora_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/exp00600_relatorio_consumo_na_expedicao_Controller.js
function exp00600_relatorio_consumo_na_expedicao_Controller(templateManager, restEngine, General, ScreenService, ZhFilterPreferences, ZHPromise,MessageService){
	var somadorFields = 3;//4->NOTAFIS, 5->NRPEDIDO
	
	var verificadorFields = {
		"CDFILIAL": false,
		"DATAINICIAL": false,
		"CDCLIENTE": true,
		"TIPOOPER": true,
		"NOTAFIS": true
	};
	
	this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
        	
        }.bind(this)); 
    };
	
    this.filterBuilder = function () {
        var activeWidget = templateManager.container.getActiveWidget();
        var nome;
        var exp = /\b(NM|DT|NRL)[A-Z]*/;//nao precisam ser montados no filtro
        var exp1 = /\b(CDCLIENTE|TIPOOPER|NOTAFIS|NRPEDIDO|CDVENDEDOR)/;//montados no filtro com operador IN
        var exp2 = /\b(TODOS|TODAS)/;//Campos que precisam passar o filtro "T" mesmo quando não preenchidos
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter = [];
        
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
        	{
        		"name": "P_PRODFIM",
        		"operator": "=",
        		"value": activeWidget.currentRow.CDPRODUTO
        	}
        );
        
        activeWidget.fields.forEach(function (field) {
        	
            if(field.value() != "" && field.value() != null && !field.name.match(exp) && field.name != 'SEARCHLIST__ALL') {
                nome = nomes[field.name];
	               
	            if(field.name.match(exp1)){
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name": nome,
	                        "operator": "IN",
	                        "value": field.value().join(',')
	                    }
	                );
	            } else{
	                templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name":  nome,
	                        "operator": "=",
	                        "value": field.value()
	                    }
	                );
	            }
            } else if(field.value() === undefined && field.name.match(exp2)){
            	nome = nomes[field.name];
            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                {
	                    "name":  nome,
	                    "operator": "=",
	                    "value": "T"
	                }
	            );
            }
        });
    };
    
    this.filterCDARVPRODFIN = function() {
    	var prodIni = templateManager.container.getActiveWidget().getField('CDARVPRODINI');
    	var prodFin = templateManager.container.getActiveWidget().getField('CDARVPRODFIN');
    	prodFin.dataSourceFilter = [];
    	
    	var filtro = [
            {
                "name": "CDARVPROD",
                "operator": ">=",
                "value": prodIni.value()
            }
        ];
        
        prodFin.dataSourceFilter = filtro;
    };
    
    this.changeTemplate = function (field, fieldToChange) {
        var missingFields = [];
        var prop;
        
        if(field.value() == "T") {
            fieldToChange.readOnly = true;
            delete(fieldToChange.filterProperties.validations.required);
            fieldToChange.setValue("");
            
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && !verificadorFields[fieldToChange.name] ) {
            	verificadorFields[fieldToChange.name] = true;
            	somadorFields++;
            }
            
            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = false;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = false;
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = false;
	            	}
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = false;
	            	}
	            	
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = false;
	            		if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').value() == 'L') {
		            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = false;
		            	}
	            	}
	            }
            
            templateManager.updateTemplate();
        } else {
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && verificadorFields[fieldToChange.name]) {
            	verificadorFields[fieldToChange.name] = false;
        		somadorFields--;
            }
            
        	if(fieldToChange.name == 'NOTAFIS' && somadorFields < 4) {
    			verificadorFields[fieldToChange.name] = true;
    			somadorFields++;
        		
        		for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){
        
        		var missing_fields = missingFields.join(', ');
				var var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(var_precisa_ser_preenchido,{"MISSING": missing_fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
        		
        		
        	} else if (fieldToChange.name == 'NRPEDIDO' && somadorFields < 5) {
    			
    			for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){

        		var missing_Fields = missingFields.join(', ');
				var Var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(Var_precisa_ser_preenchido,{"MISSING": missing_Fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
    			
        	} else{
	            fieldToChange.readOnly = false;
	            fieldToChange.filterProperties.validations.required = true;
	            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = true;
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = true;
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = true;
	            	}
	            }
	            templateManager.updateTemplate();
        	}
        }
    };
    
    this.validaProdutoAte = function () {
    	var activeWidget = templateManager.container.getActiveWidget();
        var produtoFinal = activeWidget.getField('CDARVPRODFIN');
		var produtoInicial_isSelected = !!activeWidget.currentRow.CDARVPRODINI;
		
		if(produtoInicial_isSelected){
			produtoFinal.validations.required = true;
		}else{
			delete(produtoFinal.validations.required);
			activeWidget.getField('NMPRODFIN').setValue(null);
		}
		
		produtoFinal.readOnly = !produtoInicial_isSelected;
		produtoFinal.setValue(null);
		produtoFinal.needReload = true;
    };
    
    this.prodFinal = function(widget){
		var limite = widget.currentRow.INICIAL;
		var arrayProdFinal = widget.getField('CDARVPRODFIN').dataSource.data;

		arrayProdFinal.splice(0, limite-1);
	};
	
	this.validaDatas = function (args) {
	    var expedicao = args.owner.field;
	    
	    if(expedicao.value().start != "" && expedicao.value().start != null) {
            args.row.DATAINICIAL = expedicao.value().start;
            args.row.DATAFINAL = expedicao.value().end;
	    } else {
	        args.row.DATAINICIAL = null;
	        args.row.DATAFINAL = null;
	    }
	    this.validaFields(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DATAINICIAL'));
	};
	
	
	//verificadorFields serve para a verificacao de fields necessarios aos campos NOTAFIS e NRPEDIDO
	this.validaFields = function(field) {
		if(field.value() != "" && field.value() != null && !verificadorFields[field.name]) {
			verificadorFields[field.name] = true;
			somadorFields++;
		} else if ((field.value() == "" || field.value() == null) && verificadorFields[field.name]) {
			verificadorFields[field.name] = false;
			somadorFields--;
		}
	};
	//modificar conteudo do field se dataSource nao entregar o esperado ao datasource da tela
	this.valueBuilder = function(field){
	    var filterRow = templateManager.container.getWidget('relatorio_consumo_expedicao').currentRow;
	    var valor = [];	
	    	
	    	for(var i = 0; i < filterRow.IDENTRSAIDOP.length ; i++) {
	    		valor.push(filterRow.IDENTRSAIDOP[i] + filterRow.CDTIPOOPER[i]);
	    	}
	    	
	        field.setValue(valor);
	};
	
	this.eventTest = function() {
		console.log('teste');
	};
	
	var nomes = {
	    "CDFILIAL": "P_CDFILIAL",
	    "DATAINICIAL": "P_DATAINI",
	    "DATAFINAL": "P_DATAFINAL",
	    "TODOSCLIENTE": "P_TODOS",
	    "CDCLIENTE": "P_CLIENTE",
	    "TODOSTIPOOP": "P_TTIPO",
	    "TIPOOPER": "P_TIPO",
	    "TODASNOTAFIS": "P_TNOTFIS",
	    "NOTAFIS": "P_NOTFIS",
	    "TODOSNRPEDIDO": "P_NRPEDTODOS2",
	    "NRPEDIDO": "P_NRPEDLISTA",
	    "TODOSCDVENDEDOR": "P_TVENDEDOR",
	    "CDVENDEDOR": "P_CDVENDEDOR",
	    "CDARVPRODINI": "P_PRODINIC",
	    "CDARVPRODFIN": "P_PRODFINAL",
	    "NVPROD": "P_NVPROD"
	};
	
}


Configuration(function(ContextRegister) {
    ContextRegister.register('exp00600_relatorio_consumo_na_expedicao_Controller', exp00600_relatorio_consumo_na_expedicao_Controller);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/exp01300_veiculosController.js
function exp01300_veiculosController (ScreenService, General, templateManager){
    
    this.new = function(widget){
        widget.newRow();
    };
    
    this.calcularValorKmRodado = function (widget){
        
        var VRMANUMENSAL = widget.currentRow.VRMANUMENSAL;
        var VRKMMEDIAANO = widget.currentRow.VRKMMEDIAANO;
        var VRKMMEDLITRO = widget.currentRow.VRKMMEDLITRO;
        var VRMEDLTCOMB = widget.currentRow.VRMEDLTCOMB;
        
        if(((VRMANUMENSAL || VRMEDLTCOMB) > 0) && ((VRKMMEDIAANO && VRKMMEDLITRO) > 0)){
            
            var VRKMRODAVIAT = (((VRMANUMENSAL * 12) + ((VRKMMEDIAANO / VRKMMEDLITRO) * (VRMEDLTCOMB))) / VRKMMEDIAANO);
        
            widget.currentRow.VRKMRODAVIAT = VRKMRODAVIAT;
            
        }else {
            ScreenService.showMessage('Para fazer a operação, preencha os seguintes campos com valores positivos: Quilometragem Média Anual, Vr Médio Litro Combustível, Quilômetros por Litro (Média), Valor Manutenção Mensal');
            widget.currentRow.VRKMRODAVIAT = null;
        }
            
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('exp01300_veiculosController', exp01300_veiculosController);
});

// FILE: ./assets/modules/expedicao/assets/js/controllers/exp02100_rota_entregaController.js
function exp02100_rota_entregaController (ScreenService, General, templateManager, exp02100_rota_entregaService, ZhFilterPreferences, ZHPromise){
    
    this.startFiltering = function(widgetPedidos){
        
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };

    this.newRota = function(widget){
        widget.newRow();
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',false);
        this.controlaStatusWidgets(widget,'CLIENROTA',false);
        this.controlaStatusWidgets(widget,'FILIALROTA',false);
        widget.getField('CDROTATRANS').readOnly= false;
        
        exp02100_rota_entregaService.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        
        exp02100_rota_entregaService.retornaOperadorLogado().then(function(operadorLogado){
            widget.currentRow.CDOPERADOR =  operadorLogado[0].CDOPERADOR;
        });
    };
    
    this.saveRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',true);
        this.controlaStatusWidgets(widget,'CLIENROTA',true);
        this.controlaStatusWidgets(widget,'FILIALROTA',true);
        
        General.saveCrud(widget);
    };
    
    this.editRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',false);
        this.controlaStatusWidgets(widget,'CLIENROTA',false);
        this.controlaStatusWidgets(widget,'FILIALROTA',false);
        widget.getField('CDROTATRANS').readOnly= true;
        General.edit(widget);
    };
    
    this.deletarRota = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            exp02100_rota_entregaService.deletarRota(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.cancelarRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',true);
        this.controlaStatusWidgets(widget,'CLIENROTA',true);
        this.controlaStatusWidgets(widget,'FILIALROTA',true);
    };
    
    this.newMunicipioRota = function(widget){
        widget.newRow();
        widget.getField('NMPAIS').readOnly= false;
        widget.getField('NMESTADO').readOnly= true;
        widget.getField('NMMUNICIPIO').readOnly= true;
        widget.getField('NMBAIRRO').readOnly= true;
    };
    
    this.editMunicipioRota = function(widget){
        widget.getField('NMESTADO').readOnly= true;
        widget.getField('NMMUNICIPIO').readOnly= true;
        widget.getField('NMBAIRRO').readOnly= true;
        widget.getField('NMPAIS').readOnly= true;
    };

    this.cancelMunicipiRota = function(widget){
        widget.getField('NMPAIS').readOnly= false;
        widget.getField('NMESTADO').readOnly= false;
        widget.getField('NMMUNICIPIO').readOnly= false;
        widget.getField('NMBAIRRO').readOnly= false;
    };
    
    this.newClienteRota = function(widget){
        widget.newRow();
        widget.getField('NRORDCLIROTA').readOnly= false;
        widget.getField('NMRAZSOCCLIE').readOnly= false;
    };
    
    this.editClienteRota = function(widget){
        widget.getField('NRORDCLIROTA').readOnly= true;
        widget.getField('NMRAZSOCCLIE').readOnly= true;
    };
    
    this.newFilialRota = function(widget){
        widget.newRow();
        widget.getField('NMFILIAL').readOnly= false;
    };
    
    this.editFilialRota = function(widget){
        widget.getField('NMFILIAL').readOnly= true;
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        widget.currentRow.CDROTATRANS = widget.getParent().currentRow.CDROTATRANS;
        General.saveCrud(widget);
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.preLoadAutocomplete = function(widget){
      if(widget.dataSource.data.length === 0)
        widget.reload();
    };

    this.limparValorPais = function(){
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        if(pais.value()){
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= false;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }else{
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= true;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }
    };

    this.limparValorEstado= function(){
        var widget = templateManager.container.getActiveWidget();
        var estado = widget.getField('NMESTADO');
        if(estado.value()){
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= false;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }else{
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }
    };

    this.limparValorMunicipio = function(){
        var widget = templateManager.container.getActiveWidget();
        var municipio = widget.getField('NMMUNICIPIO');
        if(municipio.value()){
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= false;
            widget.getField('NMBAIRRO').reload();
        }else{
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMBAIRRO').reload();
        }
    };

    this.verificaFieldOnChangePais = function(endereco){
        var widget =templateManager.container.getWidget('exp02100_rota_entrega');
        if(!endereco){
            widget.getField('NMPAIS').value('');
            widget.getField('CDPAIS').value('');


            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMESTADO').value('');
            widget.getField('SGESTADO').value('');


            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').value('');
            widget.getField('CDMUNICIPIO').value('');

            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').value('');
            widget.getField('CDBAIRRO').value('');
        }
        else{
            var pais = endereco.NMPAIS;
            var estado = endereco.NMESTADO;
            var municipio = endereco.NMMUNICIPIO;
            if(!pais){
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            }
            else{
                if(!estado){
                    widget.getField('NMESTADO').readOnly = false;
                    widget.getField('NMMUNICIPIO').readOnly = true;
                    widget.getField('NMBAIRRO').readOnly = true;
                }
                else{
                    widget.getField('NMESTADO').readOnly = false;
                    if(!municipio){
                        widget.getField('NMMUNICIPIO').readOnly = false;
                        widget.getField('NMBAIRRO').readOnly = true;

                    }
                    else{
                    widget.getField('NMMUNICIPIO').readOnly = false;
                    widget.getField('NMBAIRRO').readOnly = false;
                    }
                }
            }
        }
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('exp02100_rota_entregaController', exp02100_rota_entregaController);
});
